!================================================
!  Software name : STM
!  Subroutine(s) : InputData_Analysis
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine InputData_Analysis
! $Id: InputData_Analysis.F90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  use m_Files, only                : nfinp,nfcntn_bin
  use m_Control_Parameters, only   : m_CtrlP_rd_nc_z_axis
  use m_Charge_File,          only : m_CF_rd_Header_For_Cube
  use m_ArraySize_Parameters, only : m_ArraySize_Parameters_rd
  use m_Electronic_Structure, only : m_ES_rd_EigenValues_etc
  use m_PlaneWaveBasisSet, only    : m_pwBS_rd_data
  use m_FFT, only                  : m_FFT_rd_fft_box_size 

  implicit none

  call m_CtrlP_rd_nc_z_axis(nfinp)
  call m_ArraySize_Parameters_rd(nfcntn_bin)
  call m_ES_rd_EigenValues_etc(nfcntn_bin)
  call m_pwBS_rd_data(nfcntn_bin)
  call m_FFT_rd_fft_box_size(nfcntn_bin)
  call m_CF_rd_Header_For_Cube(nfcntn_bin)

end subroutine InputData_Analysis

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.01)
!
!  SUBROUINE: Renewal_of_Hubbard_Potential
!
!  AUTHOR(S): T. Yamamoto   May/08/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==========================
!     patch 0.1 by K. Tagami @adv    2009/04/21
!
!     patch 0.1 : commented out an if sentence for band calculation with DFT+U
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Renewal_of_Hubbard_Potential()
! $Id: Renewal_of_Hubbard_Potential.f90 376 2014-06-17 07:48:31Z jkoga $
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_add_dhub_to_vlhxcQ
  use m_Files,               only : nfout
  use m_Hubbard,             only : m_Hubbard_Potential
  use m_Control_Parameters,  only : icond
  use m_Const_Parameters,    only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION

! ================================== K. Tagami ================== 5.0
  use m_Hubbard,             only : m_Hubbard_Potential2
! =============================================================== 5.0


! ============================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,   only : noncol
  use m_Electronic_Structure,  only : vlhxcQ
! ===================================================================== 11.0

  implicit none
 
! =========================== Modified by K. Tagami ============= 0.1
!!!  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return
! ==============================================================

! =================================== modifed by K. Tagami ============- 5.0
!  call m_Hubbard_Potential(nfout)       ! -> dhub
  call m_Hubbard_Potential2(nfout)       ! -> dhub
! ====================================================================== 5.0
  

  call m_ESiVQ_add_dhub_to_vlhxcQ(nfout)! vlhxcQ = vlhxcQ + dhub
  

end subroutine Renewal_of_Hubbard_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: rdecomp, rsolve, cdecomp, csolve, csolve2,  rg_eispack, 
!           balanc, balbak, cdiv, elmhes, eltran, hqr, hqr2, cg_eispack,
!           cbabk2, cbal, comqr, comqr2, corth, csroot, mltpha4, 
!          decide_alpha, rmm3_uda, rmm2_uda,  crmm2_uda, crmm3_uda,
!
!  AUTHOR(S): T. Uda, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: rmmsubs.F 409 2014-10-27 09:24:52Z jkoga $
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rdecomp(n,a,w,ip,ier)
c     $Id: rmmsubs.F 409 2014-10-27 09:24:52Z jkoga $
c                       rmmsubs.f 1.2 99/06/04 21:17:36
c                       rmmsubs.f 1.3 03/02/20 18:35:31
c     rmm routine is available for systems
c                        with inversion symmetry or
c                        GAMMA point sampling  
c
c***********************************************
c*    LU decomposition of real matrix a(n,n)
c***********************************************
      real*8 a(n,n),w(n)
      real*8 al
      real*8 eps
      integer ip(n)
      integer ier
c     parameter(eps=1.0d-75)
      parameter(eps=1.0d-30)
#ifdef __TIMER_SUB__
      call timer_sta(1135)
#endif

      do k=1,n
         ip(k)=k
      end do

      do k=1,n
         l=k
         al=abs(a(ip(l),k))
#ifdef __TIMER_DO__
      call timer_sta(1182)
#endif
	      do i=k+1,n
		 if(abs(a(ip(i),k)).gt.al) then
		    l=i
		    al=abs(a(ip(l),k))
		 end if
	      end do
#ifdef __TIMER_DO__
      call timer_end(1182)
#endif

      if(l.ne.k) then
         lv=ip(k)
         ip(k)=ip(l)
         ip(l)=lv
      end if

      if(dabs(a(ip(k),k)).lt.eps) then ! This matrix is singular.
c        write(6,*) 'dabs(a(ip(k),k))',dabs(a(ip(k),k))
         ier = 1 
         return
      end if

c** Gaussian elimination **
      a(ip(k),k)=1.0d0/a(ip(k),k)

#ifdef __TIMER_DO__
      call timer_sta(1183)
#endif
	      do i=k+1,n

		 a(ip(i),k)=a(ip(i),k)*a(ip(k),k)

		      do j=k+1,n
			 w(j)=a(ip(i),j)-a(ip(i),k)*a(ip(k),j)
		      end do

		      do j=k+1,n
			 a(ip(i),j)=w(j)
		      end do
	      end do
#ifdef __TIMER_DO__
      call timer_end(1183)
#endif
      end do
#ifdef __TIMER_SUB__
      call timer_end(1135)
#endif
         ier = 0 ! normal return
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rsolve(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c***************************************
c*    Solve the linear equation.
c*    matrix a(n,n) must be LU-decomposed
c*    before the calling of this routine.
c***************************************

      real*8 a(n,n),b(n,m),x(n,m)
      integer ip(n)

      real*8 t
#ifdef __TIMER_SUB__
      call timer_sta(1136)
#endif

#ifdef __TIMER_DO__
      call timer_sta(1184)
#endif
      do k=1,m
         do i=1,n
            t=b(ip(i),k)
            do j=1,i-1
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t
         end do
      end do
#ifdef __TIMER_DO__
      call timer_end(1184)
#endif

#ifdef __TIMER_DO__
      call timer_sta(1185)
#endif
      do k=1,m
         do i=n,1,-1
            t=x(i,k)
            do j=i+1,n
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t*a(ip(i),i)
         end do
      end do
#ifdef __TIMER_DO__
      call timer_end(1185)
#endif

#ifdef __TIMER_SUB__
      call timer_end(1136)
#endif
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine cdecomp(n,a,w,ip,ier)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c***********************************************
c*    LU decomposition of complex matrix a(n,n)
c***********************************************
      complex*16 a(n,n),w(n)
      real*8 al
      real*8 eps
      integer ip(n)
      integer ier 
      parameter(eps=1.0d-10)

      do k=1,n
         ip(k)=k
      end do

      do k=1,n
         l=k
         al=cdabs(a(ip(l),k))
	      do i=k+1,n
		 if(cdabs(a(ip(i),k)).gt.al) then
		    l=i
		    al=cdabs(a(ip(l),k))
		 end if
	      end do

      if(l.ne.k) then
         lv=ip(k)
         ip(k)=ip(l)
         ip(l)=lv
      end if

      if(cdabs(a(ip(k),k)).lt.eps) then ! This matrix is singular.
         ier = 1 
         return
      end if

c** Gaussian elimination **
      a(ip(k),k)=1.0d0/a(ip(k),k)

	      do i=k+1,n

		 a(ip(i),k)=a(ip(i),k)*a(ip(k),k)

		      do j=k+1,n
			 w(j)=a(ip(i),j)-a(ip(i),k)*a(ip(k),j)
		      end do

		      do j=k+1,n
			 a(ip(i),j)=w(j)
		      end do
	      end do
      end do
         ier = 0 ! normal return
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine csolve(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c******************************************************
c*    Solve the linear equation.
c*    The complex matrix a(n,n) must be LU-decomposed
c*    before calling this routine.
c******************************************************
      complex*16 a(n,n),b(n,m),x(n,m)
      integer ip(n)

      complex*16 t

      do k=1,m
         do i=1,n
            t=b(ip(i),k)
            do j=1,i-1
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t
         end do
      end do

      do k=1,m
         do i=n,1,-1
            t=x(i,k)
            do j=i+1,n
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t*a(ip(i),i)
         end do
      end do

      return
      end

c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine csolve2(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c******************************************************
c*    Solve the linear equation.
c*    The complex matrix a(n,n) must be LU-decomposed
c*    before calling this routine.
c******************************************************
      real*8 a(n,n,2),b(n,m,2),x(n,m,2)
      integer ip(n)

      complex*16 t, q

      do k=1,m
         do i=1,n
            t=dcmplx(b(ip(i),k,1),b(ip(i),k,2))
            do j=1,i-1
               t=t-dcmplx(a(ip(i),j,1),a(ip(i),j,2)) 
     &             *  dcmplx(x(j,k,1),x(j,k,2))
            end do
            x(i,k,1) = dreal(t)
            x(i,k,2) = dimag(t)
         end do
      end do

      do k=1,m
         do i=n,1,-1
            t=dcmplx(x(i,k,1),x(i,k,2))
            do j=i+1,n
               t=t - dcmplx(a(ip(i),j,1),a(ip(i),j,2))
     &              *dcmplx(x(j,k,1),    x(j,k,2))
            end do
            q = t*dcmplx(a(ip(i),i,1),a(ip(i),i,2))
            x(i,k,1) = dreal(q)
            x(i,k,2) = dimag(q)
         end do
      end do

      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rg_eispack(nm,n,a,wr,wi,matz,z,iv1,fv1,ierr)
      integer n,nm,is1,is2,ierr,matz
      double precision a(nm,n),wr(n),wi(n),z(nm,n),fv1(n)
      integer iv1(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real general matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.  complex conjugate
c        pairs of eigenvalues appear consecutively with the
c        eigenvalue having the positive imaginary part first.
c
c        z  contains the real and imaginary parts of the eigenvectors
c        if matz is not zero.  if the j-th eigenvalue is real, the
c        j-th column of  z  contains its eigenvector.  if the j-th
c        eigenvalue is complex with positive imaginary part, the
c        j-th and (j+1)-th columns of  z  contain the real and
c        imaginary parts of its eigenvector.  the conjugate of this
c        vector is the eigenvector for the conjugate eigenvalue.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for hqr
c           and hqr2.  the normal completion code is zero.
c
c        iv1  and  fv1  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  balanc(nm,n,a,is1,is2,fv1)
      call  elmhes(nm,n,is1,is2,a,iv1)
      if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  hqr(nm,n,is1,is2,a,wr,wi,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  eltran(nm,n,is1,is2,a,iv1,z)
      call  hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)
      if (ierr .ne. 0) go to 50
      call  balbak(nm,n,is1,is2,fv1,n,z)
   50 return
      end
      subroutine balanc(nm,n,a,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision a(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a real matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the input matrix to be balanced.
c
c     on output
c
c        a contains the balanced matrix.
c
c        low and igh are two integers such that a(i,j)
c          is equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j),      j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in balance appears in
c     balanc  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = a(i,j)
         a(i,j) = a(i,m)
         a(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = a(j,i)
         a(j,i) = a(m,i)
         a(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
         j = l + 1 - jj
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (a(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (a(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + dabs(a(j,i))
            r = r + dabs(a(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
  250    a(i,j) = a(i,j) * g
c
         do 260 j = 1, l
  260    a(j,i) = a(j,i) * f
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end
      subroutine balbak(nm,n,low,igh,scale,m,z)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),z(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a real general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  balanc.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  balanc.
c
c        scale contains information determining the permutations
c          and scaling factors used by  balanc.
c
c        m is the number of columns of z to be back transformed.
c
c        z contains the real and imaginary parts of the eigen-
c          vectors to be back transformed in its first m columns.
c
c     on output
c
c        z contains the real and imaginary parts of the
c          transformed eigenvectors in its first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
  100    z(i,j) = z(i,j) * s
c
  110 continue
c     ......... for i=low-1 step -1 until 1,
c               igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = scale(i)
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = z(i,j)
            z(i,j) = z(k,j)
            z(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end
      subroutine cdiv(ar,ai,br,bi,cr,ci)
      double precision ar,ai,br,bi,cr,ci
c
c     complex division, (cr,ci) = (ar,ai)/(br,bi)
c
      double precision s,ars,ais,brs,bis
      s = dabs(br) + dabs(bi)
      ars = ar/s
      ais = ai/s
      brs = br/s
      bis = bi/s
      s = brs**2 + bis**2
      cr = (ars*brs + ais*bis)/s
      ci = (ais*brs - ars*bis)/s
      return
      end
      subroutine elmhes(nm,n,low,igh,a,int)
c
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      double precision a(nm,n)
      double precision x,y
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmhes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     stabilized elementary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the input matrix.
c
c     on output
c
c        a contains the hessenberg matrix.  the multipliers
c          which were used in the reduction are stored in the
c          remaining triangle under the hessenberg matrix.
c
c        int contains information on the rows and columns
c          interchanged in the reduction.
c          only elements low through igh are used.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         mm1 = m - 1
         x = 0.0d0
         i = m
c
         do 100 j = m, igh
            if (dabs(a(j,mm1)) .le. dabs(x)) go to 100
            x = a(j,mm1)
            i = j
  100    continue
c
         int(m) = i
         if (i .eq. m) go to 130
c     .......... interchange rows and columns of a ..........
         do 110 j = mm1, n
            y = a(i,j)
            a(i,j) = a(m,j)
            a(m,j) = y
  110    continue
c
         do 120 j = 1, igh
            y = a(j,i)
            a(j,i) = a(j,m)
            a(j,m) = y
  120    continue
c     .......... end interchange ..........
  130    if (x .eq. 0.0d0) go to 180
         mp1 = m + 1
c
         do 160 i = mp1, igh
            y = a(i,mm1)
            if (y .eq. 0.0d0) go to 160
            y = y / x
            a(i,mm1) = y
c
            do 140 j = m, n
  140       a(i,j) = a(i,j) - y * a(m,j)
c
            do 150 j = 1, igh
  150       a(j,m) = a(j,m) + y * a(j,i)
c
  160    continue
c
  180 continue
c
  200 return
      end
      subroutine eltran(nm,n,low,igh,a,int,z)
c
      integer i,j,n,kl,mm,mp,nm,igh,low,mp1
      double precision a(nm,igh),z(nm,n)
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmtrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the stabilized elementary
c     similarity transformations used in the reduction of a
c     real general matrix to upper hessenberg form by  elmhes.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the multipliers which were used in the
c          reduction by  elmhes  in its lower triangle
c          below the subdiagonal.
c
c        int contains information on the rows and columns
c          interchanged in the reduction by  elmhes.
c          only elements low through igh are used.
c
c     on output
c
c        z contains the transformation matrix produced in the
c          reduction by  elmhes.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
c     .......... initialize z to identity matrix ..........
      do 80 j = 1, n
c
         do 60 i = 1, n
   60    z(i,j) = 0.0d0
c
         z(j,j) = 1.0d0
   80 continue
c
      kl = igh - low - 1
      if (kl .lt. 1) go to 200
c     .......... for mp=igh-1 step -1 until low+1 do -- ..........
      do 140 mm = 1, kl
         mp = igh - mm
         mp1 = mp + 1
c
         do 100 i = mp1, igh
  100    z(i,mp) = a(i,mp-1)
c
         i = int(mp)
         if (i .eq. mp) go to 140
c
         do 130 j = mp, igh
            z(mp,j) = z(i,j)
            z(i,j) = 0.0d0
  130    continue
c
         z(i,mp) = 1.0d0
  140 continue
c
  200 return
      end
      double precision function epslon (x)
      double precision x
c
c     estimate unit roundoff in quantities of size x.
c
      double precision a,b,c,eps
c
c     this program should function properly on all systems
c     satisfying the following two assumptions,
c        1.  the base used in representing floating point
c            numbers is not a power of three.
c        2.  the quantity  a  in statement 10 is represented to 
c            the accuracy used in floating point variables
c            that are stored in memory.
c     the statement number 10 and the go to 10 are intended to
c     force optimizing compilers to generate code satisfying 
c     assumption 2.
c     under these assumptions, it should be true that,
c            a  is not exactly equal to four-thirds,
c            b  has a zero for its last bit or digit,
c            c  is not exactly equal to one,
c            eps  measures the separation of 1.0 from
c                 the next larger floating point number.
c     the developers of eispack would appreciate being informed
c     about any systems where these assumptions do not hold.
c
c     this version dated 4/6/83.
c
      a = 4.0d0/3.0d0
   10 b = a - 1.0d0
      c = b + b + b
      eps = dabs(c-1.0d0)
      if (eps .eq. 0.0d0) go to 10
      epslon = eps*dabs(x)
      return
      end
      subroutine hqr(nm,n,low,igh,h,wr,wi,ierr)
C  RESTORED CORRECT INDICES OF LOOPS (200,210,230,240). (9/29/89 BSG)
c
      integer i,j,k,l,m,n,en,ll,mm,na,nm,igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n)
      double precision p,q,r,s,t,w,x,y,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr,
c     num. math. 14, 219-231(1970) by martin, peters, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 359-371(1971).
c
c     this subroutine finds the eigenvalues of a real
c     upper hessenberg matrix by the qr method.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.  information about
c          the transformations used in the reduction to hessenberg
c          form by  elmhes  or  orthes, if performed, is stored
c          in the remaining triangle under the hessenberg matrix.
c
c     on output
c
c        h has been destroyed.  therefore, it must be saved
c          before calling  hqr  if subsequent calculation and
c          back transformation of eigenvectors is to be performed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated september 1989.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 1001
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + dabs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
         tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, EN
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 210 i = L, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, EN
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 240 i = L, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 wr(en) = x + t
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      x = x + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine hqr2(nm,n,low,igh,h,wr,wi,z,ierr)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,mm,na,nm,nn,
     x        igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n),z(nm,n)
      double precision p,q,r,s,t,w,x,y,ra,sa,vi,vr,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr2,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a real upper hessenberg matrix by the qr method.  the
c     eigenvectors of a real general matrix can also be found
c     if  elmhes  and  eltran  or  orthes  and  ortran  have
c     been used to reduce this general matrix to hessenberg form
c     and to accumulate the similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.
c
c        z contains the transformation matrix produced by  eltran
c          after the reduction by  elmhes, or by  ortran  after the
c          reduction by  orthes, if performed.  if the eigenvectors
c          of the hessenberg matrix are desired, z must contain the
c          identity matrix.
c
c     on output
c
c        h has been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        z contains the real and imaginary parts of the eigenvectors.
c          if the i-th eigenvalue is real, the i-th column of z
c          contains its eigenvector.  if the i-th eigenvalue is complex
c          with positive imaginary part, the i-th and (i+1)-th
c          columns of z contain the real and imaginary parts of its
c          eigenvector.  the eigenvectors are unnormalized.  if an
c          error exit is made, none of the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 340
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + dabs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
         tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, n
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 210 i = 1, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
c     .......... accumulate transformations ..........
         do 220 i = low, igh
            p = x * z(i,k) + y * z(i,k+1)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
  220    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, n
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 240 i = 1, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
c     .......... accumulate transformations ..........
         do 250 i = low, igh
            p = x * z(i,k) + y * z(i,k+1) + zz * z(i,k+2)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
            z(i,k+2) = z(i,k+2) - p * r
  250    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 h(en,en) = x + t
      wr(en) = h(en,en)
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      h(en,en) = x + t
      x = h(en,en)
      h(na,na) = y + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      x = h(en,na)
      s = dabs(x) + dabs(zz)
      p = x / s
      q = zz / s
      r = dsqrt(p*p+q*q)
      p = p / r
      q = q / r
c     .......... row modification ..........
      do 290 j = na, n
         zz = h(na,j)
         h(na,j) = q * zz + p * h(en,j)
         h(en,j) = q * h(en,j) - p * zz
  290 continue
c     .......... column modification ..........
      do 300 i = 1, en
         zz = h(i,na)
         h(i,na) = q * zz + p * h(i,en)
         h(i,en) = q * h(i,en) - p * zz
  300 continue
c     .......... accumulate transformations ..........
      do 310 i = low, igh
         zz = z(i,na)
         z(i,na) = q * zz + p * z(i,en)
         z(i,en) = q * z(i,en) - p * zz
  310 continue
c
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  340 if (norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 1 do -- ..........
      do 800 nn = 1, n
         en = n + 1 - nn
         p = wr(en)
         q = wi(en)
         na = en - 1
         if (q) 710, 600, 800
c     .......... real vector ..........
  600    m = en
         h(en,en) = 1.0d0
         if (na .eq. 0) go to 800
c     .......... for i=en-1 step -1 until 1 do -- ..........
         do 700 ii = 1, na
            i = en - ii
            w = h(i,i) - p
            r = 0.0d0
c
            do 610 j = m, en
  610       r = r + h(i,j) * h(j,en)
c
            if (wi(i) .ge. 0.0d0) go to 630
            zz = w
            s = r
            go to 700
  630       m = i
            if (wi(i) .ne. 0.0d0) go to 640
            t = w
            if (t .ne. 0.0d0) go to 635
               tst1 = norm
               t = tst1
  632          t = 0.01d0 * t
               tst2 = norm + t
               if (tst2 .gt. tst1) go to 632
  635       h(i,en) = -r / t
            go to 680
c     .......... solve real equations ..........
  640       x = h(i,i+1)
            y = h(i+1,i)
            q = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i)
            t = (x * s - zz * r) / q
            h(i,en) = t
            if (dabs(x) .le. dabs(zz)) go to 650
            h(i+1,en) = (-r - w * t) / x
            go to 680
  650       h(i+1,en) = (-s - y * t) / zz
c
c     .......... overflow control ..........
  680       t = dabs(h(i,en))
            if (t .eq. 0.0d0) go to 700
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 700
            do 690 j = i, en
               h(j,en) = h(j,en)/t
  690       continue
c
  700    continue
c     .......... end real vector ..........
         go to 800
c     .......... complex vector ..........
  710    m = na
c     .......... last vector component chosen imaginary so that
c                eigenvector matrix is triangular ..........
         if (dabs(h(en,na)) .le. dabs(h(na,en))) go to 720
         h(na,na) = q / h(en,na)
         h(na,en) = -(h(en,en) - p) / h(en,na)
         go to 730
  720    call cdiv(0.0d0,-h(na,en),h(na,na)-p,q,h(na,na),h(na,en))
  730    h(en,na) = 0.0d0
         h(en,en) = 1.0d0
         enm2 = na - 1
         if (enm2 .eq. 0) go to 800
c     .......... for i=en-2 step -1 until 1 do -- ..........
         do 795 ii = 1, enm2
            i = na - ii
            w = h(i,i) - p
            ra = 0.0d0
            sa = 0.0d0
c
            do 760 j = m, en
               ra = ra + h(i,j) * h(j,na)
               sa = sa + h(i,j) * h(j,en)
  760       continue
c
            if (wi(i) .ge. 0.0d0) go to 770
            zz = w
            r = ra
            s = sa
            go to 795
  770       m = i
            if (wi(i) .ne. 0.0d0) go to 780
            call cdiv(-ra,-sa,w,q,h(i,na),h(i,en))
            go to 790
c     .......... solve complex equations ..........
  780       x = h(i,i+1)
            y = h(i+1,i)
            vr = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i) - q * q
            vi = (wr(i) - p) * 2.0d0 * q
            if (vr .ne. 0.0d0 .or. vi .ne. 0.0d0) go to 784
               tst1 = norm * (dabs(w) + dabs(q) + dabs(x)
     x                      + dabs(y) + dabs(zz))
               vr = tst1
  783          vr = 0.01d0 * vr
               tst2 = tst1 + vr
               if (tst2 .gt. tst1) go to 783
  784       call cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,
     x                h(i,na),h(i,en))
            if (dabs(x) .le. dabs(zz) + dabs(q)) go to 785
            h(i+1,na) = (-ra - w * h(i,na) + q * h(i,en)) / x
            h(i+1,en) = (-sa - w * h(i,en) - q * h(i,na)) / x
            go to 790
  785       call cdiv(-r-y*h(i,na),-s-y*h(i,en),zz,q,
     x                h(i+1,na),h(i+1,en))
c
c     .......... overflow control ..........
  790       t = dmax1(dabs(h(i,na)), dabs(h(i,en)))
            if (t .eq. 0.0d0) go to 795
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 795
            do 792 j = i, en
               h(j,na) = h(j,na)/t
               h(j,en) = h(j,en)/t
  792       continue
c
  795    continue
c     .......... end complex vector ..........
  800 continue
c     .......... end back substitution.
c                vectors of isolated roots ..........
      do 840 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 840
c
         do 820 j = i, n
  820    z(i,j) = h(i,j)
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, n
         j = n + low - jj
         m = min0(j,igh)
c
         do 880 i = low, igh
            zz = 0.0d0
c
            do 860 k = low, m
  860       zz = zz + z(i,k) * h(k,j)
c
            z(i,j) = zz
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine cg_eispack(nm,n,ar,ai,wr,wi,matz,zr,zi,fv1,fv2,fv3
     &     ,ierr)
      integer n,nm,is1,is2,ierr,matz
      double precision ar(nm,n),ai(nm,n),wr(n),wi(n),zr(nm,n),zi(nm,n),
     x       fv1(n),fv2(n),fv3(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a complex general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a=(ar,ai).
c
c        ar  and  ai  contain the real and imaginary parts,
c        respectively, of the complex general matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.
c
c        zr  and  zi  contain the real and imaginary parts,
c        respectively, of the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for comqr
c           and comqr2.  the normal completion code is zero.
c
c        fv1, fv2, and  fv3  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  cbal(nm,n,ar,ai,is1,is2,fv1)
      call  corth(nm,n,is1,is2,ar,ai,fv2,fv3)
      if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  comqr(nm,n,is1,is2,ar,ai,wr,wi,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  comqr2(nm,n,is1,is2,fv2,fv3,ar,ai,wr,wi,zr,zi,ierr)
      if (ierr .ne. 0) go to 50
      call  cbabk2(nm,n,is1,is2,fv1,n,zr,zi)
   50 return
      end
      subroutine cbabk2(nm,n,low,igh,scale,m,zr,zi)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),zr(nm,m),zi(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure
c     cbabk2, which is a complex version of balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a complex general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  cbal.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  cbal.
c
c        scale contains information determining the permutations
c          and scaling factors used by  cbal.
c
c        m is the number of eigenvectors to be back transformed.
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the eigenvectors to be
c          back transformed in their first m columns.
c
c     on output
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the transformed eigenvectors
c          in their first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
            zr(i,j) = zr(i,j) * s
            zi(i,j) = zi(i,j) * s
  100    continue
c
  110 continue
c     .......... for i=low-1 step -1 until 1,
c                igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = scale(i)
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = zr(i,j)
            zr(i,j) = zr(k,j)
            zr(k,j) = s
            s = zi(i,j)
            zi(i,j) = zi(k,j)
            zi(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end
      subroutine cbal(nm,n,ar,ai,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision ar(nm,n),ai(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure
c     cbalance, which is a complex version of balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a complex matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the complex matrix to be balanced.
c
c     on output
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the balanced matrix.
c
c        low and igh are two integers such that ar(i,j) and ai(i,j)
c          are equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j)       j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in cbalance appears in
c     cbal  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     arithmetic is real throughout.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = ar(i,j)
         ar(i,j) = ar(i,m)
         ar(i,m) = f
         f = ai(i,j)
         ai(i,j) = ai(i,m)
         ai(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = ar(j,i)
         ar(j,i) = ar(m,i)
         ar(m,i) = f
         f = ai(j,i)
         ai(j,i) = ai(m,i)
         ai(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
         j = l + 1 - jj
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (ar(j,i) .ne. 0.0d0 .or. ai(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (ar(i,j) .ne. 0.0d0 .or. ai(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + dabs(ar(j,i)) + dabs(ai(j,i))
            r = r + dabs(ar(i,j)) + dabs(ai(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
            ar(i,j) = ar(i,j) * g
            ai(i,j) = ai(i,j) * g
  250    continue
c
         do 260 j = 1, l
            ar(j,i) = ar(j,i) * f
            ai(j,i) = ai(j,i) * f
  260    continue
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end
      subroutine comqr(nm,n,low,igh,hr,hi,wr,wi,ierr)
c
      integer i,j,l,n,en,ll,nm,igh,itn,its,low,lp1,enm1,ierr
      double precision hr(nm,n),hi(nm,n),wr(n),wi(n)
      double precision si,sr,ti,tr,xi,xr,yi,yr,zzi,zzr,norm,tst1,tst2,
     x       pythag
c
c     this subroutine is a translation of a unitary analogue of the
c     algol procedure  comlr, num. math. 12, 369-376(1968) by martin
c     and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 396-403(1971).
c     the unitary analogue substitutes the qr algorithm of francis
c     (comp. jour. 4, 332-345(1962)) for the lr algorithm.
c
c     this subroutine finds the eigenvalues of a complex
c     upper hessenberg matrix by the qr method.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        hr and hi contain the real and imaginary parts,
c          respectively, of the complex upper hessenberg matrix.
c          their lower triangles below the subdiagonal contain
c          information about the unitary transformations used in
c          the reduction by  corth, if performed.
c
c     on output
c
c        the upper hessenberg portions of hr and hi have been
c          destroyed.  therefore, they must be saved before
c          calling  comqr  if subsequent calculation of
c          eigenvectors is to be performed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  if an error
c          exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c     calls csroot for complex square root.
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (low .eq. igh) go to 180
c     .......... create real subdiagonal elements ..........
      l = low + 1
c
      do 170 i = l, igh
         ll = min0(i+1,igh)
         if (hi(i,i-1) .eq. 0.0d0) go to 170
         norm = pythag(hr(i,i-1),hi(i,i-1))
         yr = hr(i,i-1) / norm
         yi = hi(i,i-1) / norm
         hr(i,i-1) = norm
         hi(i,i-1) = 0.0d0
c
         do 155 j = i, igh
            si = yr * hi(i,j) - yi * hr(i,j)
            hr(i,j) = yr * hr(i,j) + yi * hi(i,j)
            hi(i,j) = si
  155    continue
c
         do 160 j = low, ll
            si = yr * hi(j,i) + yi * hr(j,i)
            hr(j,i) = yr * hr(j,i) - yi * hi(j,i)
            hi(j,i) = si
  160    continue
c
  170 continue
c     .......... store roots isolated by cbal ..........
  180 do 200 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 200
         wr(i) = hr(i,i)
         wi(i) = hi(i,i)
  200 continue
c
      en = igh
      tr = 0.0d0
      ti = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalue ..........
  220 if (en .lt. low) go to 1001
      its = 0
      enm1 = en - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low d0 -- ..........
  240 do 260 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 300
         tst1 = dabs(hr(l-1,l-1)) + dabs(hi(l-1,l-1))
     x            + dabs(hr(l,l)) + dabs(hi(l,l))
         tst2 = tst1 + dabs(hr(l,l-1))
         if (tst2 .eq. tst1) go to 300
  260 continue
c     .......... form shift ..........
  300 if (l .eq. en) go to 660
      if (itn .eq. 0) go to 1000
      if (its .eq. 10 .or. its .eq. 20) go to 320
      sr = hr(en,en)
      si = hi(en,en)
      xr = hr(enm1,en) * hr(en,enm1)
      xi = hi(enm1,en) * hr(en,enm1)
      if (xr .eq. 0.0d0 .and. xi .eq. 0.0d0) go to 340
      yr = (hr(enm1,enm1) - sr) / 2.0d0
      yi = (hi(enm1,enm1) - si) / 2.0d0
      call csroot(yr**2-yi**2+xr,2.0d0*yr*yi+xi,zzr,zzi)
      if (yr * zzr + yi * zzi .ge. 0.0d0) go to 310
      zzr = -zzr
      zzi = -zzi
  310 call cdiv(xr,xi,yr+zzr,yi+zzi,xr,xi)
      sr = sr - xr
      si = si - xi
      go to 340
c     .......... form exceptional shift ..........
  320 sr = dabs(hr(en,enm1)) + dabs(hr(enm1,en-2))
      si = 0.0d0
c
  340 do 360 i = low, en
         hr(i,i) = hr(i,i) - sr
         hi(i,i) = hi(i,i) - si
  360 continue
c
      tr = tr + sr
      ti = ti + si
      its = its + 1
      itn = itn - 1
c     .......... reduce to triangle (rows) ..........
      lp1 = l + 1
c
      do 500 i = lp1, en
         sr = hr(i,i-1)
         hr(i,i-1) = 0.0d0
         norm = pythag(pythag(hr(i-1,i-1),hi(i-1,i-1)),sr)
         xr = hr(i-1,i-1) / norm
         wr(i-1) = xr
         xi = hi(i-1,i-1) / norm
         wi(i-1) = xi
         hr(i-1,i-1) = norm
         hi(i-1,i-1) = 0.0d0
         hi(i,i-1) = sr / norm
c
         do 490 j = i, en
            yr = hr(i-1,j)
            yi = hi(i-1,j)
            zzr = hr(i,j)
            zzi = hi(i,j)
            hr(i-1,j) = xr * yr + xi * yi + hi(i,i-1) * zzr
            hi(i-1,j) = xr * yi - xi * yr + hi(i,i-1) * zzi
            hr(i,j) = xr * zzr - xi * zzi - hi(i,i-1) * yr
            hi(i,j) = xr * zzi + xi * zzr - hi(i,i-1) * yi
  490    continue
c
  500 continue
c
      si = hi(en,en)
      if (si .eq. 0.0d0) go to 540
      norm = pythag(hr(en,en),si)
      sr = hr(en,en) / norm
      si = si / norm
      hr(en,en) = norm
      hi(en,en) = 0.0d0
c     .......... inverse operation (columns) ..........
  540 do 600 j = lp1, en
         xr = wr(j-1)
         xi = wi(j-1)
c
         do 580 i = l, j
            yr = hr(i,j-1)
            yi = 0.0d0
            zzr = hr(i,j)
            zzi = hi(i,j)
            if (i .eq. j) go to 560
            yi = hi(i,j-1)
            hi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
  560       hr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            hr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            hi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  580    continue
c
  600 continue
c
      if (si .eq. 0.0d0) go to 240
c
      do 630 i = l, en
         yr = hr(i,en)
         yi = hi(i,en)
         hr(i,en) = sr * yr - si * yi
         hi(i,en) = sr * yi + si * yr
  630 continue
c
      go to 240
c     .......... a root found ..........
  660 wr(en) = hr(en,en) + tr
      wi(en) = hi(en,en) + ti
      en = enm1
      go to 220
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine comqr2(nm,n,low,igh,ortr,orti,hr,hi,wr,wi,zr,zi,ierr)
C  MESHED overflow control WITH vectors of isolated roots (10/19/89 BSG)
C  MESHED overflow control WITH triangular multiply (10/30/89 BSG)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,nm,nn,igh,ip1,
     x        itn,its,low,lp1,enm1,iend,ierr
      double precision hr(nm,n),hi(nm,n),wr(n),wi(n),zr(nm,n),zi(nm,n),
     x       ortr(igh),orti(igh)
      double precision si,sr,ti,tr,xi,xr,yi,yr,zzi,zzr,norm,tst1,tst2,
     x       pythag
c
c     this subroutine is a translation of a unitary analogue of the
c     algol procedure  comlr2, num. math. 16, 181-204(1970) by peters
c     and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c     the unitary analogue substitutes the qr algorithm of francis
c     (comp. jour. 4, 332-345(1962)) for the lr algorithm.
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a complex upper hessenberg matrix by the qr
c     method.  the eigenvectors of a complex general matrix
c     can also be found if  corth  has been used to reduce
c     this general matrix to hessenberg form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        ortr and orti contain information about the unitary trans-
c          formations used in the reduction by  corth, if performed.
c          only elements low through igh are used.  if the eigenvectors
c          of the hessenberg matrix are desired, set ortr(j) and
c          orti(j) to 0.0d0 for these elements.
c
c        hr and hi contain the real and imaginary parts,
c          respectively, of the complex upper hessenberg matrix.
c          their lower triangles below the subdiagonal contain further
c          information about the transformations which were used in the
c          reduction by  corth, if performed.  if the eigenvectors of
c          the hessenberg matrix are desired, these elements may be
c          arbitrary.
c
c     on output
c
c        ortr, orti, and the upper hessenberg portions of hr and hi
c          have been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  if an error
c          exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the eigenvectors.  the eigenvectors
c          are unnormalized.  if an error exit is made, none of
c          the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c     calls csroot for complex square root.
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated october 1989.
c
c     ------------------------------------------------------------------
c
      ierr = 0
c     .......... initialize eigenvector matrix ..........
      do 101 j = 1, n
c
         do 100 i = 1, n
            zr(i,j) = 0.0d0
            zi(i,j) = 0.0d0
  100    continue
         zr(j,j) = 1.0d0
  101 continue
c     .......... form the matrix of accumulated transformations
c                from the information left by corth ..........
      iend = igh - low - 1
      if (iend) 180, 150, 105
c     .......... for i=igh-1 step -1 until low+1 do -- ..........
  105 do 140 ii = 1, iend
         i = igh - ii
         if (ortr(i) .eq. 0.0d0 .and. orti(i) .eq. 0.0d0) go to 140
         if (hr(i,i-1) .eq. 0.0d0 .and. hi(i,i-1) .eq. 0.0d0) go to 140
c     .......... norm below is negative of h formed in corth ..........
         norm = hr(i,i-1) * ortr(i) + hi(i,i-1) * orti(i)
         ip1 = i + 1
c
         do 110 k = ip1, igh
            ortr(k) = hr(k,i-1)
            orti(k) = hi(k,i-1)
  110    continue
c
         do 130 j = i, igh
            sr = 0.0d0
            si = 0.0d0
c
            do 115 k = i, igh
               sr = sr + ortr(k) * zr(k,j) + orti(k) * zi(k,j)
               si = si + ortr(k) * zi(k,j) - orti(k) * zr(k,j)
  115       continue
c
            sr = sr / norm
            si = si / norm
c
            do 120 k = i, igh
               zr(k,j) = zr(k,j) + sr * ortr(k) - si * orti(k)
               zi(k,j) = zi(k,j) + sr * orti(k) + si * ortr(k)
  120       continue
c
  130    continue
c
  140 continue
c     .......... create real subdiagonal elements ..........
  150 l = low + 1
c
      do 170 i = l, igh
         ll = min0(i+1,igh)
         if (hi(i,i-1) .eq. 0.0d0) go to 170
         norm = pythag(hr(i,i-1),hi(i,i-1))
         yr = hr(i,i-1) / norm
         yi = hi(i,i-1) / norm
         hr(i,i-1) = norm
         hi(i,i-1) = 0.0d0
c
         do 155 j = i, n
            si = yr * hi(i,j) - yi * hr(i,j)
            hr(i,j) = yr * hr(i,j) + yi * hi(i,j)
            hi(i,j) = si
  155    continue
c
         do 160 j = 1, ll
            si = yr * hi(j,i) + yi * hr(j,i)
            hr(j,i) = yr * hr(j,i) - yi * hi(j,i)
            hi(j,i) = si
  160    continue
c
         do 165 j = low, igh
            si = yr * zi(j,i) + yi * zr(j,i)
            zr(j,i) = yr * zr(j,i) - yi * zi(j,i)
            zi(j,i) = si
  165    continue
c
  170 continue
c     .......... store roots isolated by cbal ..........
  180 do 200 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 200
         wr(i) = hr(i,i)
         wi(i) = hi(i,i)
  200 continue
c
      en = igh
      tr = 0.0d0
      ti = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalue ..........
  220 if (en .lt. low) go to 680
      its = 0
      enm1 = en - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
  240 do 260 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 300
         tst1 = dabs(hr(l-1,l-1)) + dabs(hi(l-1,l-1))
     x            + dabs(hr(l,l)) + dabs(hi(l,l))
         tst2 = tst1 + dabs(hr(l,l-1))
         if (tst2 .eq. tst1) go to 300
  260 continue
c     .......... form shift ..........
  300 if (l .eq. en) go to 660
      if (itn .eq. 0) go to 1000
      if (its .eq. 10 .or. its .eq. 20) go to 320
      sr = hr(en,en)
      si = hi(en,en)
      xr = hr(enm1,en) * hr(en,enm1)
      xi = hi(enm1,en) * hr(en,enm1)
      if (xr .eq. 0.0d0 .and. xi .eq. 0.0d0) go to 340
      yr = (hr(enm1,enm1) - sr) / 2.0d0
      yi = (hi(enm1,enm1) - si) / 2.0d0
      call csroot(yr**2-yi**2+xr,2.0d0*yr*yi+xi,zzr,zzi)
      if (yr * zzr + yi * zzi .ge. 0.0d0) go to 310
      zzr = -zzr
      zzi = -zzi
  310 call cdiv(xr,xi,yr+zzr,yi+zzi,xr,xi)
      sr = sr - xr
      si = si - xi
      go to 340
c     .......... form exceptional shift ..........
  320 sr = dabs(hr(en,enm1)) + dabs(hr(enm1,en-2))
      si = 0.0d0
c
  340 do 360 i = low, en
         hr(i,i) = hr(i,i) - sr
         hi(i,i) = hi(i,i) - si
  360 continue
c
      tr = tr + sr
      ti = ti + si
      its = its + 1
      itn = itn - 1
c     .......... reduce to triangle (rows) ..........
      lp1 = l + 1
c
      do 500 i = lp1, en
         sr = hr(i,i-1)
         hr(i,i-1) = 0.0d0
         norm = pythag(pythag(hr(i-1,i-1),hi(i-1,i-1)),sr)
         xr = hr(i-1,i-1) / norm
         wr(i-1) = xr
         xi = hi(i-1,i-1) / norm
         wi(i-1) = xi
         hr(i-1,i-1) = norm
         hi(i-1,i-1) = 0.0d0
         hi(i,i-1) = sr / norm
c
         do 490 j = i, n
            yr = hr(i-1,j)
            yi = hi(i-1,j)
            zzr = hr(i,j)
            zzi = hi(i,j)
            hr(i-1,j) = xr * yr + xi * yi + hi(i,i-1) * zzr
            hi(i-1,j) = xr * yi - xi * yr + hi(i,i-1) * zzi
            hr(i,j) = xr * zzr - xi * zzi - hi(i,i-1) * yr
            hi(i,j) = xr * zzi + xi * zzr - hi(i,i-1) * yi
  490    continue
c
  500 continue
c
      si = hi(en,en)
      if (si .eq. 0.0d0) go to 540
      norm = pythag(hr(en,en),si)
      sr = hr(en,en) / norm
      si = si / norm
      hr(en,en) = norm
      hi(en,en) = 0.0d0
      if (en .eq. n) go to 540
      ip1 = en + 1
c
      do 520 j = ip1, n
         yr = hr(en,j)
         yi = hi(en,j)
         hr(en,j) = sr * yr + si * yi
         hi(en,j) = sr * yi - si * yr
  520 continue
c     .......... inverse operation (columns) ..........
  540 do 600 j = lp1, en
         xr = wr(j-1)
         xi = wi(j-1)
c
         do 580 i = 1, j
            yr = hr(i,j-1)
            yi = 0.0d0
            zzr = hr(i,j)
            zzi = hi(i,j)
            if (i .eq. j) go to 560
            yi = hi(i,j-1)
            hi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
  560       hr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            hr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            hi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  580    continue
c
         do 590 i = low, igh
            yr = zr(i,j-1)
            yi = zi(i,j-1)
            zzr = zr(i,j)
            zzi = zi(i,j)
            zr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            zi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
            zr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            zi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  590    continue
c
  600 continue
c
      if (si .eq. 0.0d0) go to 240
c
      do 630 i = 1, en
         yr = hr(i,en)
         yi = hi(i,en)
         hr(i,en) = sr * yr - si * yi
         hi(i,en) = sr * yi + si * yr
  630 continue
c
      do 640 i = low, igh
         yr = zr(i,en)
         yi = zi(i,en)
         zr(i,en) = sr * yr - si * yi
         zi(i,en) = sr * yi + si * yr
  640 continue
c
      go to 240
c     .......... a root found ..........
  660 hr(en,en) = hr(en,en) + tr
      wr(en) = hr(en,en)
      hi(en,en) = hi(en,en) + ti
      wi(en) = hi(en,en)
      en = enm1
      go to 220
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  680 norm = 0.0d0
c
      do 720 i = 1, n
c
         do 720 j = i, n
            tr = dabs(hr(i,j)) + dabs(hi(i,j))
            if (tr .gt. norm) norm = tr
  720 continue
c
      if (n .eq. 1 .or. norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 2 do -- ..........
      do 800 nn = 2, n
         en = n + 2 - nn
         xr = wr(en)
         xi = wi(en)
         hr(en,en) = 1.0d0
         hi(en,en) = 0.0d0
         enm1 = en - 1
c     .......... for i=en-1 step -1 until 1 do -- ..........
         do 780 ii = 1, enm1
            i = en - ii
            zzr = 0.0d0
            zzi = 0.0d0
            ip1 = i + 1
c
            do 740 j = ip1, en
               zzr = zzr + hr(i,j) * hr(j,en) - hi(i,j) * hi(j,en)
               zzi = zzi + hr(i,j) * hi(j,en) + hi(i,j) * hr(j,en)
  740       continue
c
            yr = xr - wr(i)
            yi = xi - wi(i)
            if (yr .ne. 0.0d0 .or. yi .ne. 0.0d0) go to 765
               tst1 = norm
               yr = tst1
  760          yr = 0.01d0 * yr
               tst2 = norm + yr
               if (tst2 .gt. tst1) go to 760
  765       continue
            call cdiv(zzr,zzi,yr,yi,hr(i,en),hi(i,en))
c     .......... overflow control ..........
            tr = dabs(hr(i,en)) + dabs(hi(i,en))
            if (tr .eq. 0.0d0) go to 780
            tst1 = tr
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 780
            do 770 j = i, en
               hr(j,en) = hr(j,en)/tr
               hi(j,en) = hi(j,en)/tr
  770       continue
c
  780    continue
c
  800 continue
c     .......... end backsubstitution ..........
c     .......... vectors of isolated roots ..........
      do  840 i = 1, N
         if (i .ge. low .and. i .le. igh) go to 840
c
         do 820 j = I, n
            zr(i,j) = hr(i,j)
            zi(i,j) = hi(i,j)
  820    continue
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, N
         j = n + low - jj
         m = min0(j,igh)
c
         do 880 i = low, igh
            zzr = 0.0d0
            zzi = 0.0d0
c
            do 860 k = low, m
               zzr = zzr + zr(i,k) * hr(k,j) - zi(i,k) * hi(k,j)
               zzi = zzi + zr(i,k) * hi(k,j) + zi(i,k) * hr(k,j)
  860       continue
c
            zr(i,j) = zzr
            zi(i,j) = zzi
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine corth(nm,n,low,igh,ar,ai,ortr,orti)
c
      integer i,j,m,n,ii,jj,la,mp,nm,igh,kp1,low
      double precision ar(nm,n),ai(nm,n),ortr(igh),orti(igh)
      double precision f,g,h,fi,fr,scale,pythag
c
c     this subroutine is a translation of a complex analogue of
c     the algol procedure orthes, num. math. 12, 349-368(1968)
c     by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a complex general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     unitary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the complex input matrix.
c
c     on output
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the hessenberg matrix.  information
c          about the unitary transformations used in the reduction
c          is stored in the remaining triangles under the
c          hessenberg matrix.
c
c        ortr and orti contain further information about the
c          transformations.  only elements low through igh are used.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         h = 0.0d0
         ortr(m) = 0.0d0
         orti(m) = 0.0d0
         scale = 0.0d0
c     .......... scale column (algol tol then not needed) ..........
         do 90 i = m, igh
   90    scale = scale + dabs(ar(i,m-1)) + dabs(ai(i,m-1))
c
         if (scale .eq. 0.0d0) go to 180
         mp = m + igh
c     .......... for i=igh step -1 until m do -- ..........
         do 100 ii = m, igh
            i = mp - ii
            ortr(i) = ar(i,m-1) / scale
            orti(i) = ai(i,m-1) / scale
            h = h + ortr(i) * ortr(i) + orti(i) * orti(i)
  100    continue
c
         g = dsqrt(h)
         f = pythag(ortr(m),orti(m))
         if (f .eq. 0.0d0) go to 103
         h = h + f * g
         g = g / f
         ortr(m) = (1.0d0 + g) * ortr(m)
         orti(m) = (1.0d0 + g) * orti(m)
         go to 105
c
  103    ortr(m) = g
         ar(m,m-1) = scale
c     .......... form (i-(u*ut)/h) * a ..........
  105    do 130 j = m, n
            fr = 0.0d0
            fi = 0.0d0
c     .......... for i=igh step -1 until m do -- ..........
            do 110 ii = m, igh
               i = mp - ii
               fr = fr + ortr(i) * ar(i,j) + orti(i) * ai(i,j)
               fi = fi + ortr(i) * ai(i,j) - orti(i) * ar(i,j)
  110       continue
c
            fr = fr / h
            fi = fi / h
c
            do 120 i = m, igh
               ar(i,j) = ar(i,j) - fr * ortr(i) + fi * orti(i)
               ai(i,j) = ai(i,j) - fr * orti(i) - fi * ortr(i)
  120       continue
c
  130    continue
c     .......... form (i-(u*ut)/h)*a*(i-(u*ut)/h) ..........
         do 160 i = 1, igh
            fr = 0.0d0
            fi = 0.0d0
c     .......... for j=igh step -1 until m do -- ..........
            do 140 jj = m, igh
               j = mp - jj
               fr = fr + ortr(j) * ar(i,j) - orti(j) * ai(i,j)
               fi = fi + ortr(j) * ai(i,j) + orti(j) * ar(i,j)
  140       continue
c
            fr = fr / h
            fi = fi / h
c
            do 150 j = m, igh
               ar(i,j) = ar(i,j) - fr * ortr(j) - fi * orti(j)
               ai(i,j) = ai(i,j) + fr * orti(j) - fi * ortr(j)
  150       continue
c
  160    continue
c
         ortr(m) = scale * ortr(m)
         orti(m) = scale * orti(m)
         ar(m,m-1) = -g * ar(m,m-1)
         ai(m,m-1) = -g * ai(m,m-1)
  180 continue
c
  200 return
      end
      subroutine csroot(xr,xi,yr,yi)
      double precision xr,xi,yr,yi
c
c     (yr,yi) = complex dsqrt(xr,xi) 
c     branch chosen so that yr .ge. 0.0 and sign(yi) .eq. sign(xi)
c
      double precision s,tr,ti,pythag
      tr = xr
      ti = xi
      s = dsqrt(0.5d0*(pythag(tr,ti) + dabs(tr)))
      if (tr .ge. 0.0d0) yr = s
      if (ti .lt. 0.0d0) s = -s
      if (tr .le. 0.0d0) yi = s
      if (tr .lt. 0.0d0) yr = 0.5d0*(ti/yi)
      if (tr .gt. 0.0d0) yi = 0.5d0*(ti/yr)
      return
      end
      double precision function pythag(a,b)
      double precision a,b
c
c     finds dsqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dmax1(dabs(a),dabs(b))
      if (p .eq. 0.0d0) go to 20
      r = (dmin1(dabs(a),dabs(b))/p)**2
   10 continue
         t = 4.0d0 + r
         if (t .eq. 4.0d0) go to 20
         s = r/t
         u = 1.0d0 + 2.0d0*s
         p = u*p
         r = (s/u)**2 * r
      go to 10
   20 pythag = p
      return
      end
c ---------------------------
      subroutine mltpha4(katm,matm,pos,pai2,kngp,ngabc,kng1,nbase,iiba
     &     ,zmltc,zmlts)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
      implicit real*8 (a-h,o-z)
      integer nbase(*),ngabc(kngp,3)
      real*8 pos(katm,3)
      real*8 zmltc(kng1,matm),zmlts(kng1,matm)
      do ia = 1, matm
         fx = pos(ia,1)*pai2
         fy = pos(ia,2)*pai2
         fz = pos(ia,3)*pai2
         do i = 1, iiba
            nb = nbase(i)
            ph = ngabc(nb,1)*fx + ngabc(nb,2)*fy + ngabc(nb,3)*fz
            zmltc(i,ia) = dcos(ph)
            zmlts(i,ia) = dsin(ph)
         enddo
      enddo
      return
      end

      subroutine decide_alpha(kimg,dtim,nrmm,eigenr,eigeni,vector,alpha)
      implicit none
      integer  kimg
      real*8   dtim
      integer  nrmm
      real*8   eigenr(0:nrmm-1), eigeni(0:nrmm-1)
      real*8   vector(0:nrmm-1,0:nrmm-1,kimg)
      real*8   alpha(nrmm-1,kimg)

      real*8 eee
      integer i, k

      do k = 1, kimg
         do i = 1, nrmm-1
            alpha(i,k) = 0.d0
         end do
      end do

      if(nrmm .eq. 2) then
         if(eigeni(0) .ne. 0.d0) then
c            write(6,*) 'Warning: Eigen value is not real.'
            alpha(1,1) = dtim   
         else if( min(eigenr(0),eigenr(1)) .lt. 0.0d0 ) then
c            write(6,*) 'Warning: Eigen value is less than zero.'
            alpha(1,1) = dtim   
         else if( eigenr(0) .lt. eigenr(1) ) then
            if(kimg .eq. 1) then
               alpha(1,1) = vector(1,0,1)/vector(0,0,1)
               if(alpha(1,1) .le. 0.0d0) alpha(1,1) = dtim
            else if(kimg .eq. 2) then
               alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &              /dcmplx(vector(0,0,1),vector(0,0,kimg))
            end if
         else
            if(kimg .eq. 1) then
               alpha(1,1) = vector(1,1,1)/vector(0,1,1)
               if(alpha(1,1) .le. 0.0d0) alpha(1,1) = dtim
            else if(kimg .eq. 2) then
               alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &               /dcmplx(vector(0,1,1),vector(0,1,kimg))
            end if
         end if
      else if(nrmm .eq. 3) then
         eee = abs(eigeni(0))+abs(eigeni(1))+abs(eigeni(nrmm-1))
c*
         if(eee.eq.0.0d0) then  ! All eigenvalues are real.
c*
            if     ( eigenr(0).le.min(eigenr(1),eigenr(2)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,0,1)/vector(0,0,1)
                  alpha(2,1) = vector(2,0,1)/vector(0,0,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
                  alpha(2,1) = dcmplx(vector(2,0,1),vector(2,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
               endif
            else if( eigenr(1).le.min(eigenr(2),eigenr(0)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,1,1)/vector(0,1,1)
                  alpha(2,1) = vector(2,1,1)/vector(0,1,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
                  alpha(2,1) = dcmplx(vector(2,1,1),vector(2,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
               endif
            else if( eigenr(2).le.min(eigenr(0),eigenr(1)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,2,1)/vector(0,2,1)
                  alpha(2,1) = vector(2,2,1)/vector(0,2,1)
               else
                  alpha(1,1) = dcmplx(vector(1,2,1),vector(1,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
                  alpha(2,1) = dcmplx(vector(2,2,1),vector(2,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
               endif
            else 
               alpha(1,1) = dtim
               alpha(2,1) = 0.0d0
            end if
c*
         else                   ! Just one eigenvalue is real.
c*
            if     ( eigeni(0).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,0,1)/vector(0,0,1)
                  alpha(2,1) = vector(2,0,1)/vector(0,0,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
                  alpha(2,1) = dcmplx(vector(2,0,1),vector(2,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
               endif
            else if( eigeni(1).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,1,1)/vector(0,1,1)
                  alpha(2,1) = vector(2,1,1)/vector(0,1,1)
               else
                  alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
                  alpha(2,1) = dcmplx(vector(2,1,1),vector(2,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
               endif
            else if( eigeni(2).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,2,1)/vector(0,2,1)
                  alpha(2,1) = vector(2,2,1)/vector(0,2,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,2,1),vector(1,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
                  alpha(2,1) = dcmplx(vector(2,2,1),vector(2,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
               endif
            else
               alpha(1,1) = dtim
               alpha(2,1) = 0.0d0
            end if
         end if
      end if
      return
      end

      subroutine rmm3_uda(ipri,nrmm,am,sm,alpha)
      implicit real*8(a-h,o-z)
      integer ipri, nrmm
      dimension am(0:nrmm-1,0:nrmm-1),sm(0:nrmm-1,0:nrmm-1)
     &     ,alpha(nrmm-1)
      dimension c(3)
c         print *,'am=',am(0,0),am(1,0),am(2,0)
c         print *,'   ',am(1,1),am(2,1)
**********12/13******************
c      if(am(0,0)/sm(0,0).gt.1.0d-2) then
*      if(am(0,0).gt.1.0d0) then
c         print *,'calculation is made by SD'
c         print *,'am=',am(0,0),am(1,0),am(2,0)
c         print *,'   ',am(1,1),am(2,1)
c         print *,'   ',am(2,2)

c         print *,'sm=',sm(0,0),sm(1,0),sm(2,0)
c         print *,'   ',sm(1,1),sm(2,1)
c         print *,'   ',sm(2,2)

c         alpha(1)=-0.10d0
c         alpha(2)=0.0d0
c         return
c      end if
************12/13****************
      a11 = am(0,0)
      a12 = am(1,0)
      a13 = am(2,0)
      a22 = am(1,1)
      a23 = am(2,1)
      a33 = am(2,2)
c$$$      a11=am(1)
c$$$      a12=am(2)
c$$$      a13=am(3)
c$$$      a22=am(4)
c$$$      a23=am(5)
c$$$      a33=am(6)

      s11 = sm(0,0)
      s12 = sm(1,0)
      s13 = sm(2,0)
      s22 = sm(1,1)
      s23 = sm(2,1)
      s33 = sm(2,2)
c$$$      s11=sm(1)
c$$$      s12=sm(2)
c$$$      s13=sm(3)
c$$$      s22=sm(4)
c$$$      s23=sm(5)
c$$$      s33=sm(6)

c      print *,'-------------------------------------------------------'
c      print *,'a11=',a11
c      print *,'a12=',a12
c      print *,'a13=',a13
c      print *,'a22=',a22
c      print *,'a23=',a23
c      print *,'a33=',a33
c      print *,'s11=',s11
c      print *,'s12=',s12
c      print *,'s13=',s13
c      print *,'s22=',s22
c      print *,'s23=',s23
c      print *,'s33=',s33
c      print *,'a11/s11=',a11/s11
c      print *,'a22/s22=',a22/s22
c      print *,'a33/s33=',a33/s33
c

      a21=a12
      a32=a23   
      a31=a13   
      s21=s12
      s32=s23
      s31=s13

c$$$      write(6,'(" -- s(<i|S|j>) (rmm3_uda) --")')
c$$$      write(6,'(3d12.4, " : s11 s12 s13 ")') s11,s12,s13
c$$$      write(6,'(3d12.4, " : s21 s22 s23 ")') s21,s22,s23
c$$$      write(6,'(3d12.4, " : s31 s32 s33 ")') s31,s32,s33
c$$$      write(6,'(" -- a(rr=<Ri|Rj>) (rmm3_uda) --")')
c$$$      write(6,'(3d12.4, " : r11 r12 r13 ")') a11,a12,a13
c$$$      write(6,'(3d12.4, " : r21 r22 r23 ")') a21,a22,a23
c$$$      write(6,'(3d12.4, " : r31 r32 r33 ")') a31,a32,a33
      
      r10=a22*a33-a32*a23
      r20=a21*a33-a31*a23
      r30=a21*a32-a31*a22

      r11=a32*s23+a23*s32 - a22*s33-s22*a33
      r21=a31*s23+s31*a23 - a21*s33-s21*a33
      r31=a31*s22+s31*a22 - a21*s32-s21*a32

      r12=s22*s33 - s32*s23
      r22=s21*s33 - s31*s23
      r32=s21*s32 - s31*s22

      f0= a11*r10 - a12*r20 + a13*r30
      f1= a11*r11 - a12*r21 + a13*r31
     -    -s11*r10 + s12*r20 - s13*r30

      f2= a11*r12 - a12*r22 + a13*r32
     -    -s11*r11 + s12*r21 - s13*r31

      f3= -s11*r12 + s12*r22 - s13*r32
c   -------------- 20021223 -------------------- 
        f3= f3/f0
        f2= f2/f0
        f1= f1/f0
        f0= 1.0d0
c ===============================================
   
      e1=0.d0
      e2=a11/s11
c      print *,'e2=',e2
      e0=0.d0
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           e3=e2
c           e2=0.5d0*e2
c           else 
c            go to 50
c            end if
      do 40 k=1,100
         s=e2*(e2*(f3*e2+f2)+f1)+f0 
        if(s.le.0.d0) then
           go to 50
        else
         s=e2*(3.0d0*f3*e2+2.0d0*f2)+f1 
c           et=e2+1.d-30
c           s1=et*(et*(f3*et+f2)+f1)+f0 
c           if((s1-s).ge.0.d0 ) then
           if(s.ge.0.d0 ) then
              e2=e0 + (e2-e0)*0.5d0 
           else
              e3=e2
              e2 = e2 + (e2-e0)*0.5d0
              e0 = e2
           end if
        end if
 40   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3    k=100 is insufficient    *'
      write(6,*)'******************************************************'
      end if
 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'
	e1=e0

      do 10 j=1,250

        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c$$$        if((e2-e1).lt.5.d-22) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20
c        if((dabs(s).lt.1.d-90).or.((e2-e1)/e2.lt.1.d-17)) go to 20
c        if((qabs(s).lt.1.d-70).or.((e2-e1)/e2.lt.1.d-10)) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3    j=250 is insufficient    *'
      write(6,*) 'e2,e1=',e2,e1
      write(6,*)'******************************************************'
      end if
 20   continue
      if((e2/a11)*s11.ge.1.d0) then
      if(ipri .ge. 1 ) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3        vector not improved  *'
      write(6,*) 'a11/s11=',a11/s11
      write(6,*) 'e2,s=',e2,s
      write(6,*) 'e1=',e1
      write(6,*) 'j=',j
      write(6,*)'******************************************************'
      end if
      end if
c      write(6,*) 'a11=',a11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      d=(a12-e2*s12)*(a23-e2*s23)- (a13-e2*s13)*(a22-e2*s22)
      c(2)=(-(a11-e2*s11)*(a23-e2*s23)+(a13-e2*s13)*(a21-e2*s21))/d
      c(3)=(-(a12-e2*s12)*(a21-e2*s21)+(a22-e2*s22)*(a11-e2*s11))/d

      ee=(c(1)*c(1)*a11+2.d0*c(1)*c(2)*a12+c(2)*c(2)*a22+
     -     2.d0*c(1)*c(3)*a13+2.d0*c(2)*c(3)*a23+c(3)*c(3)*a33)/
     -     (c(1)*c(1)*s11+2.d0*c(1)*c(2)*s12+c(2)*c(2)*s22+
     -     2.d0*c(1)*c(3)*s13+ 2.d0*c(2)*c(3)*s23+c(3)*c(3)*s33)

      if((dabs(ee-e2)/e2.ge.1.d-5).and.(e2.gt.1.d0-20)) then
c      if((dabs(ee-e2)/e2.ge.1.d-3).and.(e2.gt.1.d0-13)) then
c      if(qabs(ee-e2)/e2.ge.1.d-5) then
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3        vector not reliable  *'
      write(6,*) 'ee=',ee
      write(6,*) 'e1=',e1
      write(6,*) 'e2=',e2
      write(6,*)'******************************************************'

cccccc12/12/2002cccccccccccccccc
      write(6,*) ' f3,f2=',f3,f2
      write(6,*) ' f1,f0=',f1,f0
      write(6,*) 'a(0,0),(0,1),(0,2)=',am(0,0),am(0,1),am(0,2)
      write(6,*) '      a(1,1),(1,2)=',am(1,1),am(1,2)
      write(6,*) '            a(2,2)=',am(2,2)
      write(6,*) 's(0,0),(0,1),(0,2)=',sm(0,0),sm(0,1),sm(0,2)
      write(6,*) '      s(1,1),(1,2)=',sm(1,1),sm(1,2)
      write(6,*) '            s(2,2)=',sm(2,2)
      end if
      end if
c      write(6,*) 'ee=',ee
c      write(6,*) 'e2=',e2

c      write(6,*)'   e1=',e1
c      write(6,*)'   e2=',e2
c      write(6,*)'   e3=',e3
c      write(6,*)' jj=',j,'   f(e1) = ',s
c       write(6,*)'eigen vector =',c(1),c(2),c(3)
c      write(6,*) 'recalculated eigen value by using c1,c2,c3'
c      write(6,*) ee
 
 30   continue
      alpha(1) = c(2)
      alpha(2) = c(3)
c      alpha(1) = c(2)*0.75d0
c      alpha(2) = c(3)*0.75d0
      return
      end

      subroutine rmm2_uda(ipri,nrmm,am,sm,alpha)
      implicit real*8(a-h,o-z)
      integer  ipri, nrmm
      dimension am(0:nrmm-1,0:nrmm-1),sm(0:nrmm-1,0:nrmm-1)
     &     ,alpha(nrmm-1)
      dimension c(2)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 2 basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2)
c 
c                      1>=|0> : trial vector
c                      2>=R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this routine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c    
c-----------------------------------------------------------------
      a11 = am(0,0)
      a12 = am(1,0)
      a22 = am(1,1)
      s11 = sm(0,0)
      s12 = sm(1,0)
      s22 = sm(1,1)

c      print *,'-------------------------------------------------------'
c      print *,'a11=',a11
c      print *,'a12=',a12
c      print *,'a22=',a22
c      print *,'s11=',s11
c      print *,'s12=',s12
c      print *,'s22=',s22

      a21=a12
      s21=s12

      f1= s11*s22 - s12*s21

      f2= a12*s21 + a21*s12 
     -     -s11*a22 - a11*s22

      f3= a11*a22  - a21*a12
    
      e1=0.d0
      e2=a11/s11
c$$$      e2 = -f2/(2*f1)
      if (e2.lt.1.d-20)then
         alpha(1)=0.0d0
         return
         end if

c      do 40 k=1,100
c           go to 50
c        else
c           et=e2+1.d-30
c           s1=et*(et*f1+f2)+f3 
c           if((s1-s).ge.0.d0 ) then
c              e2=e0 + (e2-e0)*0.5d0 
c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
        s=e2*(e2*f1+f2)+f3 
        if(s.gt.0.d0) then
           if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2  vector is not improved    *'
      write(6,*)'******************************************************'
           end if
        alpha(1)=0.0d0
        return
        end if
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      e1start = e1
      e2start = e2
      do 10 j=1,250

         s=e2*(e2*f1+f2)+f3
c$$$         if((e2-e1).lt.5.d-22) go to 20
c$$$        if((qabs(s).lt.1.d-70).or.((e2-e1)/e2.lt.1.d-10)) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if

 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2    j=250 is insufficient    *'
      write(6,*)'******************************************************'
      write(6,'(" s = ",d15.5, " e2,e1,e2-e1 = ",3d15.5)') s,e2,e1,e2-e1
      write(6,'(" e2start, e1start, e2start-e1start = ",3d15.5)')
     &     e2start,e1start,e2start-e1start
      end if
 20   continue

      if((e2/a11)*s11.ge.1.d0) then
         if( ipri. ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2        vector not improved  *'
      write(6,*)'******************************************************'
      write(6,*) 'a11/s11=',a11/s11
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'a11=',a11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      c(2)=-(a11-e2*s11)/(a12-e2*s12)

      ee=(c(1)*c(1)*a11+2.d0*c(1)*c(2)*a12+c(2)*c(2)*a22)/
     -   (c(1)*c(1)*s11+2.d0*c(1)*c(2)*s12+c(2)*c(2)*s22)

      if(dabs(ee-e2)/e2.ge.1.d-5) then
c      if(qabs(ee-e2)/e2.ge.1.d-5) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2        vector not reliable  *'
      write(6,*)'******************************************************'
      write(6,*) 'ee=',ee
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'ee=',ee
c      write(6,*) 'e2=',e2

c      write(6,*)'   e1=',e1
c      write(6,*)'   e2=',e2
c      write(6,*)'   e3=',e3
c      write(6,*)' jj=',j,'   f(e1) = ',s
c       write(6,*)'eigen vector =',c(1),c(2)
c      write(6,*) 'recalculated eigen value by using c1,c2'
c      write(6,*) ee
 
 30   continue

      alpha(1) = c(2)
      return
      end
c-----------------------------------------------------------------
      subroutine crmm2_uda(ipri,nrmm,rcam,rcsm,alpha)
      implicit real*8(a,b,d-h,o-z)
      implicit complex*16 (c)
      integer ipri, nrmm
      dimension rcam(0:nrmm-1,0:nrmm-1,2),rcsm(0:nrmm-1,0:nrmm-1,2)
     &     ,alpha(nrmm-1,2)
      complex*16 cam(0:1,0:1),csm(0:1,0:1)
      dimension c(2)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 2 basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2)
c 
c                      1>=|0> : trial vector
c                      2>=R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this rootine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c    
c    * Revised by T. Yamasaki,  14th Mar. 2003 
c        + calpha
c               --> alpha
c        + calpha(1) = c(2)
c               -->
c             alpha(1) = dreal(c(2))
c    * Revised by T. Uda and T. Yamasaki, 19th Mar. 2003
c        + alpha(nrmm-1)
c               --> alpha(nrmm-1,2)
c        + alpha(1) = dreal(c(2))
c               -->
c             alpha(1,1) = dreal(c(2))
c             alpha(1,2) = dimag(c(2))
c-----------------------------------------------------------------


      do i = 0, nrmm-1
         do j = 0, nrmm-1
            cam(i,j) = dcmplx(rcam(i,j,1),rcam(i,j,2))
            csm(i,j) = dcmplx(rcsm(i,j,1),rcam(i,j,2))
         end do
      end do
      ca11 = cam(0,0)
      ca21 = cam(1,0)
      ca12 = cam(0,1)
      ca22 = cam(1,1)

      cs11 = csm(0,0)
      cs21 = csm(1,0)
      cs12 = csm(0,1)
      cs22 = csm(1,1)

c      print *,'-------------------------------------------------------'
c      print *,'ca11=',ca11
c      print *,'ca12=',ca12
c      print *,'ca22=',ca22
c      print *,'cs11=',cs11
c      print *,'cs12=',cs12
c      print *,'cs22=',cs22


      f1= cs11*cs22 - cs12*cs21

      f2= ca12*cs21 + ca21*cs12 
     -     -cs11*ca22 - ca11*cs22

      f3= ca11*ca22  - ca21*ca12



      e1=0.d0
      e2=ca11/cs11
c$$$      e20=e2

      if (e2.lt.1.d-20) then
         alpha(1,1)=0.0d0
         alpha(1,2)=0.0d0
         return
      end if

c      do 40 k=1,100
c        if(s.le.0.d0) then
c           go to 50
c        else
c           s=2.0d0*e2*f1+f2
c           et=e2+1.d-30
c           s1=et*(et*f1+f2)+f3

        s=e2*(e2*f1+f2)+f3

           if(s.ge.0.d0 ) then
              if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2   vector is not improved   *'
      write(6,*)'******************************************************'
              end if
           
           alpha(1,1)=0.0d0
           alpha(1,2)=0.0d0
           return
           end if

c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
c 40   continue
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      do 10 j=1,250

        s=e2*(e2*f1+f2)+f3
c$$$        if((e2-e1).lt.5.d-22) go to 20
c        if((dabs(s).lt.1.d-90).or.((e2-e1)/e2.lt.1.d-10)) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s. lt. 0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2    j=250 is insufficient   *'
      write(6,*)'******************************************************'
      write(6,'(" s = ",d20.5)') s
      end if
 20   continue
      
      test = (e2/ca11)*cs11
      if(test.ge.1.d0) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2        vector not improved *'
      write(6,*)'******************************************************'
      write(6,*) 'a11/s11=',ca11/cs11
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'a11=',ca11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      c(2)=-(ca11-e2*cs11)/(ca12-e2*cs12)

      ee=real(c(1)*c(1)*ca11+2.d0*c(1)*c(2)*ca12+
     -                                     dconjg(c(2))*c(2)*ca22)/
     -   real(c(1)*c(1)*cs11+2.d0*c(1)*c(2)*cs12+
     -                                     dconjg(c(2))*c(2)*cs22)

      if(dabs(ee-e2)/e2.ge.1.d-5) then

         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2       vector not reliable  *'
      write(6,*)'******************************************************'
      write(6,*) 'ee=',ee
      write(6,*) 'e1,e2=',e1,e2
         end if
      end if
 
 30   continue

      alpha(1,1) = dreal(c(2))
      alpha(1,2) = dimag(c(2))
      return
      end
c------------------------------------------------------------------
      subroutine crmm3_uda(ipri,nrmm,rcam,rcsm,alpha)
      implicit real*8(a,b,d-h,o-z)
      implicit complex*16 (c)
      integer ipri,nrmm
      dimension rcam(0:nrmm-1,0:nrmm-1,2),rcsm(0:nrmm-1,0:nrmm-1,2)
     &     ,alpha(nrmm-1,2)
      complex*16 cam(0:2,0:2),csm(0:2,0:2),c(3)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 3basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2,3)
c 
c                      |1>=|0> : trial vector
c                      |2>=R|0>
c                      |3>=R|2>=R*R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this rootine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c
c    * Revised by T. Yamasaki,  14th Mar. 2003 
c        + calpha
c               --> alpha
c        + calpha(1) = c(2)
c          calpha(2) = c(3)
c               -->
c             alpha(1) = dreal(c(2))
c             alpha(2) = dreal(c(3))
c    * Revised by T. Uda and T. Yamasaki, 19th Mar. 2003
c        + alpha(nrmm-1)
c               --> alpha(nrmm-1,2)
c        + alpha(1) = dreal(c(2))
c          alpha(2) = dreal(c(3))
c               -->
c             alpha(1,1) = dreal(c(2))
c             alpha(2,1) = dreal(c(3))
c             alpha(1,2) = dimag(c(2))
c             alpha(2,2) = dimag(c(3))
c-----------------------------------------------------------------

c$$$      write(6,'(" <<crmm3_uda>>")')

      do i = 0, nrmm-1
         do j = 0, nrmm-1
            cam(i,j) = dcmplx(rcam(i,j,1),rcam(i,j,2))
            csm(i,j) = dcmplx(rcsm(i,j,1),rcam(i,j,2))
         end do
      end do
c
      ca11 = cam(0,0)
      ca12 = cam(0,1)
      ca13 = cam(0,2)
      ca22 = cam(1,1)
      ca23 = cam(1,2)
      ca33 = cam(2,2)
      ca21 = cam(1,0)
      ca31 = cam(2,0)
      ca32 = cam(2,1)

      cs11 = csm(0,0)
      cs12 = csm(0,1)
      cs13 = csm(0,2)
      cs22 = csm(1,1)
      cs23 = csm(1,2)
      cs33 = csm(2,2)
      cs21 = csm(1,0)
      cs31 = csm(2,0)
      cs32 = csm(2,1)
      

c$$$      ex1=ca11/cs11
c$$$      ex2=ca22/cs22
c$$$      ex3=ca33/cs33

c      print *,'ex1=',ex1
c      print *,'ex2=',ex2
c      print *,'ex3=',ex3
      
c      isign=0
c      if (ex3.lt.ex2) then
c       ctest=ca12
c       ca12 =ca13
c       ca13 =ctest



c$$$      print *,'-------------------------------------------------------'
c$$$      print *,'ca11=',ca11
c$$$      print *,'ca12=',ca12
c$$$      print *,'ca21=',ca21
c$$$      print *,'ca13=',ca13
c$$$      print *,'ca31=',ca31
c$$$      print *,'ca22=',ca22
c$$$      print *,'ca23=',ca23
c$$$      print *,'ca32=',ca32
c$$$      print *,'ca33=',ca33

c      print *,'cs11=',cs11
c      print *,'cs12=',cs12
c      print *,'cs21=',cs21
c      print *,'cs13=',cs13
c      print *,'cs31=',cs31
c      print *,'cs22=',cs22
c      print *,'cs23=',cs23
c      print *,'cs32=',cs32
c      print *,'cs33=',cs33

      f1= cs11*cs22 - cs12*cs21

      f2= ca12*cs21 + ca21*cs12 
     -     -cs11*ca22 - ca11*cs22

      f3= ca11*ca22  - ca21*ca12



      e1=0.d0
      e2=ca11/cs11
      e20=e2

      if (e2.lt.1.d-20) then
         goto 1001
c$$$         alpha(1,1)=0.0d0
c$$$         alpha(2,1)=0.0d0
c$$$         alpha(1,2)=0.0d0
c$$$         alpha(2,2)=0.0d0
c$$$         return
      end if

        s=e2*(e2*f1+f2)+f3

           if(s.ge.0.d0 ) then
              if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3   vector is not improved   *'
      write(6,*)'******************************************************'
              end if
           
              goto 1001

           return
           end if


      do 10 j1=1,250
c$$$         write(6,'(" j1 = ",i5)') j1

        s=e2*(e2*f1+f2)+f3
c$$$        if((e2-e1).lt.5.d-22) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3   j1=250 is insufficient   *'
      write(6,*)' e20,e21=',e20,e2
      write(6,*)' e1 ,e2 =',e1,e2
      write(6,*)'******************************************************'
      end if
 20   continue

c$$$      write(6,'(" !! out of 20 continue")')

      cr10=ca22*ca33-ca32*ca23
      cr20=ca21*ca33-ca31*ca23
      cr30=ca21*ca32-ca31*ca22

      cr11=ca32*cs23+ca23*cs32 - ca22*cs33-cs22*ca33
      cr21=ca31*cs23+cs31*ca23 - ca21*cs33-cs21*ca33
      cr31=ca31*cs22+cs31*ca22 - ca21*cs32-cs21*ca32

      cr12=cs22*cs33 - cs32*cs23
      cr22=cs21*cs33 - cs31*cs23
      cr32=cs21*cs32 - cs31*cs22

      f0= ca11*cr10 - ca12*cr20 + ca13*cr30
      f1= ca11*cr11 - ca12*cr21 + ca13*cr31
     -    -cs11*cr10 + cs12*cr20 - cs13*cr30

      f2= ca11*cr12 - ca12*cr22 + ca13*cr32
     -    -cs11*cr11 + cs12*cr21 - cs13*cr31

      f3= -cs11*cr12 + cs12*cr22 - cs13*cr32
c --------------------------------20030219---------------------
             f3= f3/f0
             f2= f2/f0
             f1= f1/f0
             f0= 1.0d0
c =============================================================
c$$$      do j1 = 1, 50
c$$$         write(6,'(" !! out of devided by f0: f0 = ",d20.10)') f0
c$$$      end do
    
c      e1=0.d0
c      e2=ca11/cs11
c      e20=ca11/cs11
c      print *,'e2=',e2
c      e0=0.d0
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           e3=e2
c           e2=0.5d0*e2
c           else 
c            go to 50
c            end if
c      do 40 k=1,100
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           go to 50
c        else
c           s=e2*(3.0d0*f3*e2+f2)+f1
c           et=e2+1.d-30
c           s1=et*(et*(f3*et+f2)+f1)+f0 
c           if(s.ge.0.d0 ) then
c              e2=e0 + (e2-e0)*0.5d0 
c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
c 40   continue
c      write(6,*)'******************************************************'
c      write(6,*)'*  warning from sub crmm3    k=100 is insufficient   *'
c      write(6,*)'******************************************************'
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      e1=0.0d0
      e21=e2

 
      do 110 j2=1,250
      
        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c$$$        write(6,'(" j2 = ",i5, " e2 = ",d20.10," s= ",d20.10)') j2, e2,s
c$$$        if((e2-e1).lt.1.0d-25) go to 120
        if((e2-e1)/e2.lt.1.0d-10) go to 120

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 120
        end if
 110   continue
       if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3  j2=250 is insufficient    *'
      write(6,*)' e20,e21,e2=',e20,e21,e2
      write(6,*)' e1 ,e2 =',e1,e2
      write(6,*) 'j =',j
      write(6,*)'******************************************************'
       end if
 120   continue

      d=f2*f2 - 3.d0*f1*f3
      if (d.lt.0.0d0 .or. dabs(f3).lt.1.d-50) then
         if(ipri .ge. 1)
     &   write(6,'(" !rmmsubs d = ",d20.10," f1,f2,f3 = ",3d20.10)')
     &        d, f1,f2,f3
         if(d.lt.0.0d0 .and. ipri.ge.1) 
     &        write(6,*) ' !crmm3 warning d < 0.0'
         if(dabs(f3).lt.1.d-50 .and. ipri.ge.1) 
     &        write(6,*) ' !crmm3 warning |f3| <delta'
         goto 1001
      end if

c$$$       zeropoint1 = (-f2-sqrt(d))/(3.0d0*f3)
       zeropoint2 = (-f2+sqrt(d))/(3.0d0*f3)

c$$$      write(6,'(" !rmmsubs zeropoint2 = ",d20.10)') zeropoint2

c$$$       s0=zeropoint2*(zeropoint2*(zeropoint2*f3+f2)+f1)+f0
       s1=e1*(e1*(e1*f3+f2)+f1)+f0
       s2=e2*(e2*(e2*f3+f2)+f1)+f0
c$$$       do j1 = 1, 200
c$$$          write(6,'(" !!s1,s2,zeropoint2 = ",3d20.10)') s1,s2,zeropoint2
c$$$       end do
c       write(6,*) 'zeropoint2, f(zeropoint2)=',zeropoint2,s2
c       write(6,*)' e20,e21,e2=',e20,e21,e2

      if(e2.gt.zeropoint2) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3      e2 > zero point       *'
      write(6,*)'   e2,e21,e20=',e2,e21,e20
      write(6,*)'******************************************************'
         end if
      end if
      if(s1.lt.-1.0d-10.or.s2.gt.1.0d-10) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3                            *'
      write(6,*)'   e1,e2,zeropoint2=',e1,e2,zeropoint2
      write(6,*)'   e2,e21,e20=',e1,e21,e20
      write(6,*)' f(e1)=',s1,'f(e2)=',s2
      write(6,*)'******************************************************'
         end if
      end if
 

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      cd=(ca12-e2*cs12)*(ca23-e2*cs23)- (ca13-e2*cs13)*(ca22-e2*cs22)
      c(2)=(-(ca11-e2*cs11)*(ca23-e2*cs23)+(ca13-e2*cs13)*
     -    (ca21-e2*cs21))/cd
      c(3)=(-(ca12-e2*cs12)*(ca21-e2*cs21)+(ca22-e2*cs22)*
     -    (ca11-e2*cs11))/cd

      ee=real(c(1)*c(1)*ca11+2.d0*c(1)*c(2)*ca12
     -                      +conjg(c(2))*c(2)*ca22+
     -     2.d0*c(1)*c(3)*ca13+2.d0*conjg(c(2))*c(3)*ca23
     -                      +conjg(c(3))*c(3)*ca33)/
     -     real(c(1)*c(1)*cs11+2.d0*c(1)*c(2)*cs12
     -                      +conjg(c(2))*c(2)*cs22+
     -     2.d0*c(1)*c(3)*cs13+ 2.d0*conjg(c(2))*c(3)*cs23
     -                      +conjg(c(3))*c(3)*cs33)

      if((dabs(ee-e2)/e2).ge.1.d-5) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3        vector not reliable *'
      write(6,*) 'e20,ee=',e20,ee
      write(6,*) 'e1 ,e2=',e1,e2
      write(6,*)'******************************************************'
         end if
      end if

 30   continue
      alpha(1,1) = dreal(c(2))
      alpha(2,1) = dreal(c(3))
      alpha(1,2) = dimag(c(2))
      alpha(2,2) = dimag(c(3))
      return
 1001 continue
      alpha(1,1) = 0.d0
      alpha(2,1) = 0.d0
      alpha(1,2) = 0.d0
      alpha(2,2) = 0.d0
      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  MODULE: m_ES_LHXC
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_LHXC
! $Id: m_ES_LHXC.F90 409 2014-10-27 09:24:52Z jkoga $
  use m_Electronic_Structure, only : vlhxc_l, vloc_esm
  use m_PlaneWaveBasisSet,    only : kg,kgp,gr_l
  use m_PseudoPotential,      only : psc_l, ival
  use m_Ionic_System,         only : ntyp, zfm3_l
  use m_Timing,               only : tstatc0_begin, tstatc0_end
#ifdef ENABLE_ESM_PACK
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential &
  &                                , sw_esm
#else
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential 
#endif
  use m_Const_Parameters,     only : DP, PAI4, UP, DOWN, ON, OFF, CMPLDP
  use m_Parallelization,      only : ista_kngp, iend_kngp, mype, myrank_g, mpi_comm_group
  use m_Crystal_Structure,    only : univol
  use m_Dipole,               only : vdip_l, vext_l
  use m_Screening,            only : screening
  use m_External_Potential,   only : espot_g

! ========================== added by K. Tagami ===================== 11.0
  use m_Control_Parameters,   only : ndim_chgpot, ndim_magmom
! =================================================================== 11.0

  use m_Charge_Density,       only : chgq_l

  use m_FFT,                  only : fft_box_size_CD
  use m_PlaneWaveBasisSet,    only : igfp_l

implicit none
  include 'mpif.h'
!  61. m_ESlhxc_potential
contains

!=======================================================================
!=======================================================================
!=======================================================================
  subroutine m_ESlhxc_potential_3D(nfout,chg,vxc)
   use m_Dipole,               only : m_Dipole_potential_3D, m_Dipole_calc_3D 

    integer, intent(in)       :: nfout
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,nspin)

    complex(kind=CMPLDP),allocatable :: vhar(:)
    complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
    real(kind=DP) :: ehar
    integer :: is,ik,i,it
    integer :: ist
    integer :: nfftcd,ierr,ig
    integer :: id_sname = -1

#ifdef __TIMER_SUB__
  call timer_sta(1050)
#endif
    call tstatc0_begin('m_ESlhxc_potential_3D ',id_sname)

    vlhxc_l = 0.d0
    ist = ista_kngp
    if(ist == 1) ist = 2
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
       allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
       allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
       if(kimg==1)then
          do ig=ista_kngp,iend_kngp
             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),0.d0)
          enddo
       else
          do ig=ista_kngp,iend_kngp
             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),chg(ig,2,1:nspin))
          enddo
       endif
       call esm_hartree(chgc,ehar,vhar)
       vhar(:) = 0.5d0*vhar(:) !Ry -> Ha
       deallocate(chgc)
    endif
#endif
    do is = 1, nspin
       do ik = 1, kimg
#ifdef __TIMER_DO__
  call timer_sta(1064)
#endif
          if(myrank_g==0) vlhxc_l(1,ik,is)   = vxc(1,ik,is)
#ifdef ENABLE_ESM_PACK
          if(nspin == 1 .and. sw_esm==OFF) then
#else
          if(nspin == 1) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*chg(i,ik,is)/gr_l(i)**2
             end do
#ifdef ENABLE_ESM_PACK
          else if(nspin == 2.and.sw_esm==OFF) then
#else
          else if(nspin == 2) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*(chg(i,ik,UP)+chg(i,ik,DOWN))/gr_l(i)**2
             end do
#ifdef ENABLE_ESM_PACK
          else if (sw_esm == ON)then
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) 
             end do
#endif
          endif
#ifdef __TIMER_DO__
  call timer_end(1064)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1065)
#endif
          do it    = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) &
                     & = vlhxc_l(i,ik,is)+psc_l(i,it)*zfm3_l(i,it,ik)
             end do
          end do
#ifdef ENABLE_ESM_PACK
          if(sw_esm==ON)then
             if(ik==1)then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,1,is) = vlhxc_l(i,1,is)+dble(vhar(igfp_l(i)))+dble(vloc_esm(igfp_l(i)))
                enddo
             else if(ik==2) then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,2,is) = vlhxc_l(i,2,is)+aimag(vhar(igfp_l(i)))+aimag(vloc_esm(igfp_l(i)))
                enddo
             endif
          endif
#endif
#ifdef __TIMER_DO__
  call timer_end(1065)
#endif
       end do
    end do
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       deallocate(vhar)
    endif
#endif
    if(sw_dipole_correction==ON) then
       call m_Dipole_calc_3D(nfout)
       call m_Dipole_potential_3D(nfout,chg)
#ifdef __TIMER_DO__
  call timer_sta(1066)
#endif
       do is = 1, nspin
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) + vdip_l(i,ik) + vext_l(i,ik)
             end do
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1066)
#endif
    end if
    if(iprivlhxcq >= 2) call m_ESlhxc_wd_vlhxc_3D(nfout)
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1050)
#endif
  end subroutine m_ESlhxc_potential_3D

  subroutine m_ESlhxc_wd_vlhxc_3D(nfout)

    integer, intent(in) :: nfout
    integer :: ispin, i, is, ie, ri
#ifdef __TIMER_SUB__
  call timer_sta(1056)
#endif

    is = ista_kngp
    ie = min(is+20, iend_kngp)
    do ispin = 1, nspin
       if(nspin == 2) write(nfout,'(" !lhxc ispin = ",i5)') ispin
       write(nfout,'(" vlhxc_l")')
       do ri = 1, kimg
          if(kimg == 1 .and. ri == 1) write(nfout,*) '       real part'
          if(ri == 2)                 write(nfout,*) '       imaginary part'
          write(nfout,'(" ",4d20.12)') (vlhxc_l(i,ri,ispin),i=is,ie) ! MPI
       end do
    end do
#ifdef __TIMER_SUB__
  call timer_end(1056)
#endif
  end subroutine m_ESlhxc_wd_vlhxc_3D
!=======================================================================
end module m_ES_LHXC

subroutine CoreLevelSpectrum

  use m_CoreLevel_Spectrum, only : m_CLS_rd_n, m_CLS_read_data_from_pp, &
       &                      m_CLS_alloc_core_states, m_CLS_set_core_states, &
       &                      m_CLS_alloc_DensityResponseFn, &
       &                      m_CLS_calc_DensityResponseFn, &
       &                      m_CLS_print_spectrum, sw_corelevel_spectrum
  use m_Const_Parameters,  only : OFF
  use m_Files,            only : m_Files_open_nf_LR, m_Files_close_nf_LR, nf_LR_spectra
  use m_Parallelization,  only : mype

  implicit none

  call m_CLS_rd_n
  if ( sw_corelevel_spectrum == OFF ) return

  call m_CLS_read_data_from_pp
  call m_CLS_alloc_core_states
  call m_CLS_set_core_states

  call m_CLS_alloc_DensityResponseFn
  call m_CLS_calc_DensityResponseFn

  if ( mype == 0 ) then
     call m_Files_open_nf_LR()
     call m_CLS_print_spectrum( nf_LR_spectra )
     call m_Files_close_nf_LR()
  endif

end subroutine CoreLevelSpectrum

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  MODULE:  m_Timing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  FURTHER MODIFICATION: T. Yamasaki, September 2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
!tex--\documentstyle{jarticle}
!tex--\title{module m\_Timing}
!tex--\author{T. Yamasaki}
!tex--\textwidth 480pt
!tex--\oddsidemargin -10pt
!tex--\evensidemargin 0pt
!tex--\begin{document}
!tex--\maketitle
!tex--\newenvironment{mydescription}{%
!tex--	\list{$\bullet$}{%
!tex--		\topsep 0pt \itemsep 0pt }}%
!tex--{\endlist}
!tex--
module m_Timing
!
!
! ***************************************************************
!  $Id: m_Timing.F90 409 2014-10-27 09:24:52Z jkoga $
!
!  The first version of this module was coded by T. Yamasaki 
! (JRCAT-ATP, FUJITSU LABORATORIES Ltd.) in 1999.
!
!tex--\section{��ǽ����}
!tex--  ���֥롼�����衢���뤤�ϣ�-iteraion�λ��֤�¬�ꤷ��ɽ�����롣
!tex--\section{Using modules}
  use m_Control_Parameters, only : ipri, ipritiming, printable,num_subroutines, pcpudf &
       &                         , statistics_in_parallel, sw_flatten, sw_firstlevel_only, sw_details &
       &                         , measure_count_limit
  use m_Const_Parameters,   only : DP, ON, OFF, START,ITERATIVE,FINISH,TAG_FORMAT,TAG_LINE,TABLE
  use m_Parallelization,    only : mpi_comm_group,npes, mype, ierr

  implicit none

!tex--\section{Parameters,variables,arrays}
!tex--\subsection{Public}
!tex--   none
!tex--\subsection{Private}
!tex--\begin{itemize}
!tex--      \item {\tt [MSBRNM]:} ����¬��򤹤�subroutine�κ����
!tex--      \item {\tt [long\_name\_size]:} ����{\tt subroutine\_names}�γ����Ǥ�����ʸ���
!tex--      \item {\tt [subroutine\_names]:} suburoutine̾���ߤ�������
!tex--      \item {\tt [tstart] (0:MSBRNM):} ¬�곫�ϻ�����ߤ�������
!tex--      \item {\tt [ecpu] (0:MSBRNM):} ¬�ꤷ���в���֤��ߤ�������{\tt ecpu(0)}��
!tex--            ��SCF����ʬ�ηв���֤��ߤ����롣
!tex--      \item {\tt [iorder] (MMSBRM):} ¬����֤��礭���ν���Ϳ��������
!tex--      \item {\tt [n\_sub\_names]:} ¬�ꤷ��subroutine�ο�
!tex--      \item {\tt [PCPUDF = 0.03]:} SCF-iteration�ηв���֤�����ηв����
!tex-- ({\tt ecpu\_previous})�Ȥκ���{\tt PCPUDF}$\times${\tt ecpu\_previous}����礭���Ȥ���
!tex-- ¬���̤�񤭽Ф���{\tt subroutine tstatc\_wd}����Ѥ��롣
!tex--      \item {\tt [N\_SUBROUTINES] = 10:} {\tt subroutine tstatc\_wd}�ǽ񤭽Ф�subroutine�ο��ξ��
!tex--\end{itemize}
  integer, private, parameter                            :: MSBRNM         = 100
  integer, private, parameter                            :: MSBRNM_EXT     = 10
  integer, private, parameter                            :: INCRE_MSBRNM   = 10
  integer, private, parameter                            :: long_name_size = 32
  character(len=long_name_size),private,dimension(0:MSBRNM) :: subroutine_names
  integer, private, dimension(0:MSBRNM)                  :: subroutine_name_length
  character(len=long_name_size),private                     :: temp_str
  real(DP),private, dimension(0:MSBRNM)                  :: tstart=0, ecpu=0
  integer, private, dimension(MSBRNM)                    :: iorder, counter=0
  integer, private, dimension(MSBRNM)                    :: ilevel=-1
  integer, private                                       :: levelset = OFF
  integer, private                                       :: n_sub_names = 0
  real(DP),private               :: ecpu_previous = 0.d0
  real(DP),private, parameter    :: UMICRO = 1.d-6
  integer, private :: switch_of_timing = OFF
  real(DP),private :: wct_start = 0.d0
! --> T. Yamasaki, 2th Sep. 2009
  integer, private :: id_ext, id_ext_max = 0, n_allocated_subhir = 0
  integer, private, dimension(MSBRNM_EXT) :: id_ext_stack=0
  integer, private :: id_ext_pointer = 0
  type t_subhir
     integer :: id
     integer :: level
     integer :: id1
     integer :: id2
     integer :: id3
     integer :: flag
  end type t_subhir
  type(t_subhir), allocatable,  dimension(:) :: subhir
  integer,private :: level_previous,level_now=0, id123_now(1:3)=0
  real(kind=DP),private,allocatable,dimension(:) :: ecpu_ext
  integer, private, allocatable, dimension(:) :: counter_ext
  integer, private, allocatable, dimension(:) :: ip_1stlevel_subroutines
  integer :: n_1stlevel_subroutines
  integer, private, parameter :: MODE_EVALUATION = 1, MODE_WRITE = 2, MODE_SINGLE=1, MODE_PARALLEL = 2
! <--
     
!!$  real(DP),private, parameter    :: PCPUDF = 0.03
!!$  integer, private, parameter    :: N_SUBROUTINES = 20

!tex--\section{�ޤޤ��subroutines}
!tex-- {\tt a)tstatc0\_begin, b)tstatc0\_end, c)tstatc\_init, d)tstatc\_wd0, e)tstatc\_wd, f)tstatc\_iter}
!tex--
!tex--\section{�Ȥ���}
!tex--¬�ꤷ����subroutine�Ǥϡ��ǽ�˼�����Τ褦��{\tt tstatc0\_begin}��ƤӽФ�
!tex--\begin{verbatim}
!tex--    integer :: id_sname = -1
!tex--    call tstatc0_begin('FFT_WF ',id_sname)
!tex--\end{verbatim}
!tex--�Ǹ��
!tex--\begin{verbatim}
!tex--    call tstatc0_end(id_sname)
!tex--\end{verbatim}
!tex--��{\tt tstatc0\_end}��ƤӽФ�������ˤ�ꡢ{\tt FFT\_WF}���б�����
!tex--�����{\tt tstatc0\_begin}��{\tt tstatc0\_end}�δ֤ηв���֤��ä����롣
!tex--SCF�Σ���ηв���֤ϡ�{\tt tstatc\_iter}��ƤӽФ����Ȥ�¬���롣
!tex--SCF-iteration�ν����{\tt tstatc\_wd}��ƤӽФ��ȡ������
!tex--SCF����ʬ�ηв���֤Ȥκ���3��({\tt PCPUDF})�ʾ夢��С��в����
!tex--��Ĺ���ä����10��(={\tt N\_SUBROUTINES})��
!tex--subroutine��̾���ȷв���֡��ޤ����β�ηв���֤���Ϥ��롣
!tex--����Ū�ˤϡ�SCF-iteration�ν���˼��Τ褦�ˤ��롣
!tex--\begin{verbatim}
!tex--  call tstatc_iter(iteration, first_iteration_of_this_job)
!tex--  if(iteration == first_iteration_of_this_job) then
!tex--     call tstatc_wd0
!tex--  else
!tex--     call tstatc_wd(iteration)
!tex--  end if
!tex--  call tstatc_init
!tex--\end{verbatim}
!tex--{\tt call tstatc\_wd(iteration)}�ˤ�꼡�Τ褦�ʽ��Ϥ����롣
!tex--\begin{verbatim}
!tex-- << CPU Time Consumption -- TOP  10 Subroutines (    2) >>
!tex--   1  26                           FFT_WF     1.79200(sec.) 52.58(%)
!tex--   2  31      evolve_WFs_in_MSD_direction     1.04297(sec.) 30.60(%)
!tex--   3  17                     xc_potential     0.94531(sec.) 27.74(%)
!tex--   4  19               ggaxcp(in xc_pot.)     0.89258(sec.) 26.19(%)
!tex--   5  28              energy_eigen_values     0.57715(sec.) 16.93(%)
!tex--   6  33                      CD_softpart     0.49121(sec.) 14.41(%)
!tex--   7  36   Total_Energy(including xc_pot)     0.47168(sec.) 13.84(%)
!tex--   8  18                   inverse_FFT_CD     0.23242(sec.)  6.82(%)
!tex--   9  20                    direct_FFT_CD     0.14356(sec.)  4.21(%)
!tex--  10  34                      CD_hardpart     0.13574(sec.)  3.98(%)
!tex--      Total cpu time of (        2 )-th iteration        3.40820(sec.)
!tex--\end{verbatim}
!tex--\end{document}
  include 'mpif.h'
contains
  subroutine tstatc0_begin(a_sub_name,id,level)
    character(len=*), intent(in) :: a_sub_name
    integer, intent(inout) ::       id
    integer, intent(in), optional :: level

    real(kind=DP)             :: t_start
    integer                   :: i, len_str

    if(switch_of_timing == OFF) then
       call gettod(wct_start)
       switch_of_timing = ON
    end if

    if(sw_firstlevel_only == ON .and. sw_details == OFF) then
         if(.not.present(level)) then
           return
         else
           if(level/=1) return
         end if
    end if
!      & (.not.present(level).or.(present(level).and.level/=1))) return

    len_str = len_trim(a_sub_name)
    if(len_str > long_name_size) len_str = long_name_size

! -- finding the pointer in subroutine_names --'
    if(id <= 0) then
       do i = 1, n_sub_names
!!$          if(a_sub_name(1:len_str) == subroutine_names(i)(1:len_str)) then
          if(  len_str == subroutine_name_length(i) .and. &
               & a_sub_name(1:len_str) == subroutine_names(i)(1:len_str)) then
             id = i
              exit
          end if
       end do
    end if
    if(id <= 0) then
       if( n_sub_names < MSBRNM) then
          n_sub_names = n_sub_names + 1
          id          = n_sub_names
          write(subroutine_names(id),'(a32)') a_sub_name
          subroutine_name_length(id) = len_str
       else
          if(printable) write(6,'(" !! Size of an array of subroutine_names should be enlarged (->m_Timing)")')
       end if
    end if


    if(id >= 1 .and. id <= MSBRNM) then
       if(measure_count_limit > 0 .and. counter(id) > measure_count_limit) then
       else
          call gettod(t_start)
          tstart(id) = t_start
       end if
       if(sw_firstlevel_only == ON .or. (sw_firstlevel_only==OFF .and. sw_flatten==OFF)) then
          if(present(level) .and. ilevel(id)==-1) then
             ilevel(id) = level
             if(level/=-1 .and. levelset==OFF) levelset = ON
          end if
       end if
    end if

    if(sw_details == ON) then
       call alloc_subhir()
       call setlevels() ! --> level_now, level_previous, id123_now
       call search_id_ext() ! --> id_ext
       if(id_ext > id_ext_max) then
          subhir(id_ext)%id    = id
          subhir(id_ext)%level = level_now
          if(level_now==1) subhir(id_ext)%id1 = 0
          if(level_now>=2) subhir(id_ext)%id1 = id123_now(1)
          if(level_now>=3) subhir(id_ext)%id2 = id123_now(2)
          if(level_now>=4) subhir(id_ext)%id3 = id123_now(3)
          id_ext_max = id_ext
       end if
!!$       id_ext_pointer = min(id_ext_pointer + 1, MSBRNM_EXT)
!!$       id_ext_pointer = id_ext_pointer + 1
       id_ext_pointer = level_now
       if(id_ext_pointer <= MSBRNM_EXT) id_ext_stack(id_ext_pointer) = id_ext
    end if

    if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name
!!$   if(ipri >= 2) print '(" <<< ",a32," >>>")',subroutine_names(id)
  contains
    subroutine search_id_ext()
      integer :: i
      id_ext = 0
      if(id_ext_max == 0) then
         if(id>=1) then
            id_ext = 1
         end if
      else
         if(level_now <= 1) then
            do i = 1, id_ext_max
               if(subhir(i)%id == id) then
                  id_ext = i
                  exit
               end if
            end do
         else
            do i = 1, id_ext_max
               if(subhir(i)%id == id .and. subhir(i)%level == level_now) then
!!$                  if((subhir(i)%level == level_now).and.(subhir(i)%id1 == id123_now(1))) then
                  if(subhir(i)%id1 == id123_now(1)) then
                     id_ext = i
                     exit
                  end if
               end if
            end do
         end if
         if(id_ext == 0) id_ext = id_ext_max+1
      end if
    end subroutine search_id_ext

    subroutine setlevels()
      if(present(level)) then
         level_previous = level_now
         level_now = level
         if(level_now >= 1 .and. level_now <= 3) id123_now(level_now) = id
      else
         if(level_now >= 0) then
            level_previous = level_now
            level_now = level_now+1
            if(level_now >= 1 .and. level_now <= 3) id123_now(level_now) = id
         end if
      end if
    end subroutine setlevels
      
    subroutine alloc_subhir()
      type(t_subhir), allocatable,  dimension(:) :: subhir2
      real(kind=DP),allocatable, dimension(:) :: ecpu2
      integer, allocatable, dimension(:) :: counter2
      if(.not.allocated(subhir)) then
         allocate(subhir(MSBRNM_EXT))
         do i = 1, MSBRNM_EXT
            subhir(i)%id = 0
            subhir(i)%level = 0
            subhir(i)%id1 = 0
            subhir(i)%id2 = 0
            subhir(i)%id3 = 0
            subhir(i)%flag = 0
         end do
         allocate(ecpu_ext(MSBRNM_EXT)); ecpu_ext = 0.d0
         allocate(counter_ext(MSBRNM_EXT)); counter_ext = 0
         n_allocated_subhir = MSBRNM_EXT
      else if(id_ext_max >= n_allocated_subhir) then
         allocate(subhir2(id_ext_max))
         allocate(ecpu2(id_ext_max))
         allocate(counter2(id_ext_max))
         if(allocated(subhir)) then
            subhir2 = subhir
            deallocate(subhir)
            n_allocated_subhir = n_allocated_subhir+INCRE_MSBRNM
            allocate(subhir(n_allocated_subhir))
            subhir(1:min(id_ext_max,n_allocated_subhir)) = subhir2(1:min(id_ext_max,n_allocated_subhir))
            do i = min(id_ext_max, n_allocated_subhir)+1, n_allocated_subhir
               subhir(i)%id = 0
               subhir(i)%level = 0
               subhir(i)%id1 = 0
               subhir(i)%id2 = 0
               subhir(i)%id3 = 0
               subhir(i)%flag = 0
            end do
         end if
         if(allocated(ecpu_ext)) then
            ecpu2 = ecpu_ext
            deallocate(ecpu_ext)
            allocate(ecpu_ext(n_allocated_subhir)); ecpu_ext = 0.d0
            ecpu_ext(1:min(id_ext_max,n_allocated_subhir)) = ecpu2(1:min(id_ext_max,n_allocated_subhir))
         end if
         if(allocated(counter_ext)) then
            counter2 = counter_ext
            deallocate(counter_ext)
            allocate(counter_ext(n_allocated_subhir)); counter_ext = 0
            counter_ext(1:min(id_ext_max,n_allocated_subhir)) = counter2(1:min(id_ext_max,n_allocated_subhir))
         end if
         deallocate(counter2)
         deallocate(ecpu2)
         deallocate(subhir2)
      end if
    end subroutine alloc_subhir
         
    subroutine wd_the_subroutine_name
      integer :: i, ip
      ip = long_name_size - len_str
      ip = ip / 2
      do i = 1, ip
         temp_str(i:i) = '-'
      end do
      do i = 1, len_str
         temp_str(i+ip:i+ip) = a_sub_name(i:i)
      end do
      do i = ip + len_str + 1, long_name_size
         temp_str(i:i) = '-'
      end do
      write(6,'(" <<<",a32,">>> (",i3,"), level_now = ",i3)') temp_str,ilevel(id), level_now
    end subroutine wd_the_subroutine_name
  end subroutine tstatc0_begin

  subroutine tstatc0_end(id)
    integer, intent(in) :: id
    real(kind=DP) :: t_end, t_used

    if(id==-1)  return

    if(measure_count_limit > 0 .and. counter(id) >measure_count_limit) then
       t_used = 0.d0
    else
       call gettod(t_end)
       t_used = t_end - tstart(id)
       ecpu(id) = ecpu(id) + t_used * UMICRO
    end if
    counter(id) = counter(id) + 1

    if(sw_details == ON) then
       if(level_now >= 1) then
          level_previous = level_now
          level_now = level_now-1
       end if
       if(id_ext_pointer >=1 .and. id_ext_pointer <= MSBRNM_ext) then
          id_ext = id_ext_stack(id_ext_pointer)
          if(id_ext >=1 .and. id_ext <= n_allocated_subhir) then
             ecpu_ext(id_ext) = ecpu_ext(id_ext) + t_used *UMICRO
             counter_ext(id_ext) = counter_ext(id_ext) + 1
          end if
       else
          id_ext = 0
       end if
!!$       id_ext_pointer = id_ext_pointer-1
       id_ext_pointer = level_now
       if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name2
    end if

    if(ipritiming >= 2 .and. printable) call wd_the_subroutine_name
  contains
    subroutine wd_the_subroutine_name
      write(6,'(" >>>",a32,"<<<")') subroutine_names(id)
    end subroutine wd_the_subroutine_name
    subroutine wd_the_subroutine_name2
      write(6,'(" >>>",a32,"<<< id_ext, id_ext_pointer = ",i5,i5)') subroutine_names(id), id_ext, id_ext_pointer
    end subroutine wd_the_subroutine_name2
    
  end subroutine tstatc0_end

  subroutine tstatc_init
    tstart(1:MSBRNM) = 0.d0; ecpu(1:MSBRNM) = 0.d0; counter(1:MSBRNM) = 0
    if(sw_details == ON) then
       if(allocated(ecpu_ext)) ecpu_ext = 0.d0
       if(allocated(counter_ext)) counter_ext = 0
       id_ext_max = 0
    end if
  end subroutine tstatc_init

  subroutine tstatc_wd0
    integer :: i, ip, nsub, in, nsub0, npmax, npmin
    real(kind=DP) :: cpu_used, wct_now &
         & , cputmax, cputmin, cputmean, cputvariance, cputstddevia
    real(kind=DP), allocatable, dimension(:,:) :: ecpu_wk, ecpu_sorted
    integer, allocatable, dimension(:) :: iorder_p
    integer :: ipri0, lev, levmax, inu, j, num_sub_wd, cput_mode

    ipri0 = ipritiming
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0<=0) return

    if(measure_count_limit > 0) call correct_ecpu() ! counter,measure_count_limit,ecpu-> ecpu
    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = n_sub_names

    if(levelset == ON) then
       levmax = 2
       if(sw_firstlevel_only==ON) levmax = 1
    else
       levmax = 1
    end if

    if(statistics_in_parallel == 1 .and. npes >= 2) then
       cput_mode = MODE_PARALLEL
       if(mype == 0) then
          nsub0 = 0 
          do i = 1, nsub
             if(ecpu(iorder(i)) < UMICRO) exit
             nsub0 = i
          end do
       end if
       call mpi_bcast(nsub0,1,mpi_integer,0,mpi_comm_group,ierr)
       allocate(iorder_p(nsub0))
       if(mype == 0) iorder_p(1:nsub0) = iorder(1:nsub0)
       call mpi_bcast(iorder_p,nsub0,mpi_integer,0,mpi_comm_group,ierr)

       allocate(ecpu_wk(0:npes-1,nsub0)); ecpu_wk = 0.d0
       allocate(ecpu_sorted(0:npes-1,nsub0))
       do i = 1, nsub0
          ip = iorder_p(i)
          ecpu_wk(mype,i) = ecpu(ip)
       end do
       call mpi_allreduce(ecpu_wk, ecpu_sorted,nsub0*npes, mpi_double_precision &
            &            ,mpi_sum, mpi_comm_group,ierr)

    else
       cput_mode = MODE_SINGLE
       nsub0 = 0
       do i = 1, nsub
          if(ecpu(iorder(i)) < UMICRO) exit
          nsub0 = i
       end do
    end if

    do j = MODE_EVALUATION, MODE_WRITE
       if(j==MODE_EVALUATION) num_sub_wd = 0
       if(j==MODE_WRITE) call wd_headerlines()

       do lev = 1, levmax
          if(j==MODE_WRITE) call wd_pauseline()
          inu = 0
          do i = 1, nsub0
             if(cput_mode == MODE_PARALLEL) then
                ip = iorder_p(i)
             else if(cput_mode == MODE_SINGLE) then
                ip = iorder(i)
             end if

             if(levelset == ON) then
                if(levmax >= 2) then
                   if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
                else if(levmax == 1) then
                   if(ilevel(ip)/=lev) cycle
                end if
             end if
             inu = inu + 1

             if(j==MODE_WRITE) then
                if(cput_mode == MODE_PARALLEL) then
                   call cpu_statistics_in_parallel(ecpu_sorted(0,i) &
                        & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
                   if(printable) write(6,'(2i5,2x,a32,f11.5,i8,4f10.4,3i5)') &
                        & i,ip,subroutine_names(ip),ecpu(ip),counter(ip) &
                        & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                else
                   if(printable) write(6,'(2i5,2x,a32,f11.5,2i8)') &
                        & i,ip,subroutine_names(ip),ecpu(ip),counter(ip), inu
                end if
             end if
          end do
          if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
       end do
    end do
    if(cput_mode == MODE_PARALLEL) deallocate(iorder_p,ecpu_sorted,ecpu_wk)

!!$    else
!!$       if(printable) then
!!$          nsub0 = 0
!!$          do i = 1, nsub
!!$             if(ecpu(iorder(i)) < UMICRO) exit
!!$             nsub0 = i
!!$          end do
!!$
!!$          do j = MODE_EVALUATION, MODE_WRITE
!!$             if(j==MODE_EVALUATION) num_sub_wd = 0
!!$             if(j==MODE_WRITE) call wd_headerlines()
!!$
!!$             do lev = 1, levmax
!!$                if(j==MODE_WRITE) call wd_pauseline()
!!$                inu = 0
!!$                do i = 1, nsub0
!!$                   ip = iorder(i)
!!$                   if(levelset == ON) then
!!$                      if(levmax >= 2) then
!!$                         if(.not.((lev==levmax .and. ilevel(ip)==-1) &
!!$                              & .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
!!$                      else if(levmax == 1) then
!!$                         if(ilevel(ip)/=lev) cycle
!!$                      end if
!!$                   end if
!!$                   inu = inu+1
!!$                   if(j==MODE_WRITE .and. printable) then
!!$                      write(6,'(2i5,2x,a32,f11.5,2i8)') &
!!$                           & i,ip,subroutine_names(ip),ecpu(ip),counter(ip), inu
!!$                   end if
!!$                end do
!!$                if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
!!$             end do
!!$          end do
!!$!!$       if(sw_details == ON) then
!!!$          if(printable) then
!!!$             write(6,'(" --- detail flat---")')
!!!$             write(6,'(" id_ext_max = ", i8)') id_ext_max
!!!$             if(printable) write(6,'("   no",2x," id ","        subroutine name         ","  time(sec) "&
!!!$                  &               ,"  count","   level","   id1")')
!!!$             do i = 1, min(id_ext_max,100)
!!!$                inu = subhir(i)%id
!!!$                if(inu >= 1) write(6,'(i5,2x,i4,a32,f11.5,3i8)') i, inu,subroutine_names(inu) &
!!!$                     & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
!!!$             end do
!!!$          end if
!!!$       end if
!!$       end if
!!$    end if
    call gettod(wct_now)
    cpu_used = (wct_now - wct_start) * UMICRO
    if(printable) write(6,'(" <<Total elapsed CPU Time until now =",f12.5," (sec.)>>")') cpu_used
    if(sw_details == ON .and. printable) call wd_ecpu_details(0)

  contains
    subroutine wd_pauseline()
      if(levelset == ON .and. levmax>1 .and. printable) then
         if(lev < levmax) then
            write(6,'("    --- level ",i3," ---")') lev
         else
            write(6,'("    --- ---")')
         end if
      end if
    end subroutine wd_pauseline
!!$    subroutine wd_headerlines_parallel()
!!$      if(printable) then
!!$         write(6,'(" n_sub_names = ",i5," num_subroutines_statistics = ",i5)') n_sub_names, num_sub_wd
!!$         write(6,'(" << cpu time statistics >>")')
!!$      end if
!!$    end subroutine wd_headerlines_parallel
    subroutine wd_headerlines()
      if(printable) then
         write(6,'(" n_sub_names = ",i5," num_subroutines_statistics = ",i5)') n_sub_names, num_sub_wd
         if(num_sub_wd >=1) then
            write(6,'(" << cpu time statistics >>")')
            if(cput_mode==MODE_SINGLE) then
               write(6,'("  no "," id ",2x,"        subroutine name         ","  time(sec) "&
                    &               ,"  count","   no(2)")')
            else if(cput_mode == MODE_PARALLEL) then
               write(6,'("   no","   ip",2x,"        subroutine name         ","  time(sec) "&
                    &               ,"  count  ", " max_time    min       mean     stddevia" &
                    &  ," nmax nmin  no(2)")')
            end if
         end if
      end if
    end subroutine wd_headerlines

  end subroutine tstatc_wd0

  subroutine cpu_statistics_in_parallel(ecpu_sorted &
       & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
    real(kind=DP),intent(in),dimension(0:npes-1) :: ecpu_sorted
    real(kind=DP),intent(out)     :: cputmin,cputmax,cputmean,cputvariance,cputstddevia
    integer, intent(out) :: npmax,npmin
    integer :: in

    cputmax = ecpu_sorted(0); npmax = 0
    cputmin = ecpu_sorted(0); npmin = 0
    do in = 1, npes-1
       if(cputmax < ecpu_sorted(in)) then
          cputmax = ecpu_sorted(in);   npmax = in
       end if
       if(cputmin > ecpu_sorted(in)) then
          cputmin = ecpu_sorted(in);   npmin = in
       end if
    end do
!!$          cputmax = maxval(ecpu_sorted(0:npes-1,ic))
!!$          cputmin = minval(ecpu_sorted(0:npes-1,ic))
    cputmean = 0.d0
    do in = 0, npes-1
       cputmean = cputmean + ecpu_sorted(in)
    end do
    cputmean = cputmean/npes
    cputvariance = 0.d0
    do in =0, npes-1
       cputvariance = cputvariance + (ecpu_sorted(in)-cputmean)*(ecpu_sorted(in)-cputmean)
    end do
    cputvariance = cputvariance/npes
    cputstddevia = dsqrt(cputvariance)
    
  end subroutine cpu_statistics_in_parallel

  subroutine wd_ecpu_details(iteration)
    integer, intent(in) :: iteration
    integer :: i, ip, ic, inu, ips, id, icflag

    n_1stlevel_subroutines = 0
    do i = 1, n_sub_names
       if(ilevel(i) == 1) n_1stlevel_subroutines = n_1stlevel_subroutines+1
    end do
    if(n_1stlevel_subroutines ==0) return
    allocate(ip_1stlevel_subroutines(n_1stlevel_subroutines))
    n_1stlevel_subroutines = 0
    do i = 1, n_sub_names
       ip = iorder(i)
       if(ilevel(ip) == 1) then
          n_1stlevel_subroutines = n_1stlevel_subroutines+1
          ip_1stlevel_subroutines(n_1stlevel_subroutines) = ip
       end if
    end do

    write(6,'("--- cputiming details BEGIN ( iteration = ",i8," ) ----")') iteration
    write(6,'("   no "," id ",2x,"        subroutine name         ","  time(sec) "&
         &               ,"  count","   level","   id1")')
    subhir(1:id_ext_max)%flag = 0

    icflag = 0
    do i = 1, n_1stlevel_subroutines
       ip = ip_1stlevel_subroutines(i)
       ic = 0
       do inu = 1, id_ext_max
          ips = subhir(inu)%id1
          if(subhir(inu)%level>=2 .and. ips == ip) then
             if(ecpu_ext(inu) > UMICRO) ic = ic+1
             ic = ic+1
          end if
       end do
       if(ic >=1) then
          write(6,'(" ",60("="))')
          write(6,'("  *  ",i5,2x,a32,f11.5,2i8,"    *")') ip,subroutine_names(ip), ecpu(ip),counter(ip),ilevel(ip)
          write(6,'(" ",60("-"))')
!!$          write(6,'("  ----------------------------------------")')
          ic = 0
          do inu = 1, id_ext_max
             ips = subhir(inu)%id1
             if(subhir(inu)%level>=2 .and. ips == ip) then
                if(ecpu_ext(inu) > UMICRO) then
                   ic = ic+1
                   id = subhir(inu)%id
                   if(id >=1) then
                      write(6,'(2i5,2x,a32,f11.5,3i8)') ic,id,subroutine_names(id) &
                           & , ecpu_ext(inu),counter_ext(inu),subhir(inu)%level, subhir(inu)%id1
                   else
                      write(6,'("id = ",i8," <=0")') id
                   end if
                   subhir(inu)%flag = 1
                   icflag = icflag + 1
                end if
             end if
          end do
       end if
    end do
    if(icflag < id_ext_max) then
       ic = 0
       do i = 1, id_ext_max
          if(subhir(i)%flag == 0 .and. subhir(i)%level >= 2) then
             if(ecpu_ext(i) > UMICRO) then
                ic = ic + 1
             end if
          else if(subhir(i)%flag == 0 .and. subhir(i)%level==1) then
             id = subhir(i)%id
             if(1<=id .and. id <=MSBRNM .and. ilevel(id) /= 1) then
                if(ecpu_ext(i) > UMICRO) then
                   ic = ic + 1
                end if
             end if
          end if
       end do
       if(ic>=1) then
          write(6,'(" === other subroutines ",40("="))')
          ic = 0
          do i = 1, id_ext_max
             icflag = 0
             if(subhir(i)%flag == 0 .and. subhir(i)%level >= 2) then
                if(ecpu_ext(i) > UMICRO) then
                   ic = ic + 1
                   id = subhir(i)%id
                   icflag = 1
                end if
             else if(subhir(i)%flag == 0 .and. subhir(i)%level<=1) then
                id = subhir(i)%id
                if(1<=id .and. id <=MSBRNM .and. ilevel(id) /= 1) then
                   if(ecpu_ext(i) > UMICRO) then
                      ic = ic + 1
                      icflag = 1
                   end if
                end if
             end if
             if(icflag == 1)  write(6,'(2i5,2x,a32,f11.5,3i8)') ic, id,subroutine_names(id) &
                  & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
          end do
       end if
    end if
    write(6,'("--- cputiming details END ( iteration = ",i8," ) ----")') iteration

    deallocate(ip_1stlevel_subroutines)
  end subroutine wd_ecpu_details

  subroutine tstatc_wd(iteration)
    integer, intent(in) :: iteration
!!$    integer i, ip, nsub, in, ic, nsub0, npmax, npmin
    integer i, ip, nsub, ic, nsub0, npmax, npmin
    real(kind=DP) :: cpudif, pecpu, wct_now, cputmax, cputmin, cputmean, cputvariance, cputstddevia
    real(kind=DP), allocatable, dimension(:,:) :: ecpu_wk, ecpu_sorted
    integer, allocatable, dimension(:) :: iorder_p
    integer :: ipri0, lev, levmax, inu, j, num_sub_wd,  cput_mode

    ipri0 = ipritiming
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0<=0) return

    ipri0 = 0
    cpudif = dabs(ecpu(0) - ecpu_previous)
    if(cpudif < ecpu_previous * PCPUDF .or. ecpu(0) < UMICRO) ipri0=1
    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
    if(ipri0>0) then
       goto 1001
    end if

    if(measure_count_limit > 0) call correct_ecpu() ! counter,measure_count_limit,ecpu-> ecpu
    call tsort(ecpu(1),MSBRNM,iorder)

    if(levelset == ON) then
       levmax = 2
       if(sw_firstlevel_only==ON) levmax = 1
    else
       levmax = 1
    end if
    nsub = 0
    if(sw_firstlevel_only == ON .and. levmax == 1) then
      ic = 0
       do i = 1, n_sub_names
          ip = iorder(i)
          if(ecpu(ip) < UMICRO) exit
          if(ilevel(ip) == 1) then
             ic = ic + 1
             if(ic > num_subroutines) exit
             nsub = i
          end if
       end do
    else
       nsub = min(n_sub_names, num_subroutines)
    end if

!!$    if(printable) write(6,'(" nsub = ",i8)') nsub

    if(statistics_in_parallel == 1 .and. npes >= 2) then
       cput_mode = MODE_PARALLEL
       call mpi_barrier(mpi_comm_group,ierr)
       if(mype == 0) then
          nsub0 = 0 
          do i = 1, nsub
             if(ecpu(iorder(i)) < UMICRO) exit
             nsub0 = i
          end do
       end if
       call mpi_bcast(nsub0,1,mpi_integer,0,mpi_comm_group,ierr)
       allocate(iorder_p(nsub0))
       if(mype == 0) iorder_p(1:nsub0) = iorder(1:nsub0)
       call mpi_bcast(iorder_p,nsub0,mpi_integer,0,mpi_comm_group,ierr)

       allocate(ecpu_wk(0:npes-1,0:nsub0)); ecpu_wk = 0.d0
       allocate(ecpu_sorted(0:npes-1,0:nsub0))
       ecpu_wk(mype,0) = ecpu(0)
       do i = 1, nsub0
          ip = iorder_p(i)
          ecpu_wk(mype,i) = ecpu(ip)
       end do
       call mpi_allreduce(ecpu_wk, ecpu_sorted,(nsub0+1)*npes, mpi_double_precision &
            &            ,mpi_sum, mpi_comm_group,ierr)
       subroutine_names(0) = " total cpu of this iteration "
       subroutine_name_length(0) = 30
       nsub0 = nsub0 + 1
    else
       cput_mode = MODE_SINGLE
       nsub0 = 0
       do i = 1, nsub
          if(ecpu(iorder(i)) < UMICRO) exit
          nsub0 = i
       end do
    end if

    do j = MODE_EVALUATION, MODE_WRITE
       if(j==MODE_EVALUATION) num_sub_wd = 0
       if(j==MODE_WRITE) call wd_headerlines()

       do lev = 1, levmax
          if(j==MODE_WRITE) call wd_pauseline()
          inu = 0
          do i = 1, nsub0
             if(cput_mode == MODE_PARALLEL) then
                if(i <= nsub0-1) then
                   ip = iorder_p(i)
                   ic = i
                else if(i == nsub0) then
                   ip = 0
                   ic = 0
                end if
             else if(cput_mode == MODE_SINGLE) then
                ip = iorder(i)
             end if
             
!!$             if(levelset == ON .and. ip/=0) then
             if(levelset == ON .and. ip>0) then
                if(levmax >= 2) then
                   if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
                else if(levmax == 1) then
                   if(ilevel(ip)/=lev) cycle
                end if
!!$             else if(levelset == ON .and. ip == 0) then
             else if(levelset == ON .and. ip <= 0) then
                if(lev < levmax) cycle
             end if
             inu = inu+1

             if(j==MODE_WRITE) then
                if(cput_mode == MODE_PARALLEL) then
                   call cpu_statistics_in_parallel(ecpu_sorted(0,ic) &
                        & ,cputmin,cputmax,cputmean,cputvariance,cputstddevia,npmax,npmin)
                end if
                pecpu = ecpu(ip)/ecpu(0) * 100

                if(printable) then
                   if(cput_mode == MODE_PARALLEL) then
                      if(ip /= 0) then
                         write(6,'(2i4,2x,a32,f10.4,f6.2,i9,4f10.4,3i5)') &
                              & ic,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip) &
                              & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                      else if(ip == 0) then
                         write(6,'(2i4,2x,a32,f10.4,f6.1,i9,4f10.4,3i5)') &
                              & ic,ip, subroutine_names(ip),ecpu(ip),pecpu,1 &
                              & ,cputmax,cputmin,cputmean,cputstddevia,npmax,npmin,inu
                      end if
                   else
                      write(6,'(2i4,2x,a32,f11.5,f6.2,2i8)') &
                           & i,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip),inu
                   end if
                end if
             end if
          end do
          if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
       end do
    end do
    if(cput_mode == MODE_PARALLEL)  deallocate(iorder_p,ecpu_sorted,ecpu_wk)
!!$    else
!!$       nsub0 = 0
!!$       do i = 1, nsub
!!$          if(ecpu(iorder(i)) < UMICRO) exit
!!$          nsub0 = i
!!$       end do
!!$
!!$       do j = MODE_EVALUATION, MODE_WRITE
!!$          if(j==MODE_EVALUATION) num_sub_wd = 0
!!$          if(j==MODE_WRITE) call wd_header()
!!$          do lev = 1, levmax
!!$             if(j==MODE_WRITE) call wd_pauseline()
!!$
!!$             inu = 0
!!$             do i = 1, nsub0
!!$                ip = iorder(i)
!!$                if(levelset == ON) then
!!$                   if(levmax >= 2) then
!!$                      if(.not.((lev==levmax .and. ilevel(ip)==-1) .or. (lev<levmax .and. ilevel(ip)==lev))) cycle
!!$                   else if(levmax == 1) then
!!$                      if(ilevel(ip)/=lev) cycle
!!$                   end if
!!$                end if
!!$                inu = inu+1
!!$                if(j==MODE_WRITE) then
!!$                   pecpu = ecpu(ip)/ecpu(0) * 100
!!$
!!$                   if(printable) write(6,'(2i4,2x,a32,f11.5,f6.2,2i8)') &
!!$                        & i,ip, subroutine_names(ip),ecpu(ip),pecpu,counter(ip),inu
!!$                end if
!!$             end do
!!$             if(j==MODE_EVALUATION) num_sub_wd = num_sub_wd+inu
!!$          end do
!!$       end do
!!$!!!$       if(sw_details == ON .and. printable) then
!!$!!!$          write(6,'(" --- detail ---")')
!!$!!!$          write(6,'(" id_ext_max = ", i8)') id_ext_max
!!$!!!$          if(printable) write(6,'("   no",2x," id ","        subroutine name         ","  time(sec) "&
!!$!!!$               &               ,"  count","   level","   id1")')
!!$!!!$          do i = 1, min(id_ext_max,100)
!!$!!!$             inu = subhir(i)%id
!!$!!!$             if(inu >= 1) write(6,'(i5,2x,i4,a32,f11.5,3i8)') i, inu,subroutine_names(inu) &
!!$!!!$                  & , ecpu_ext(i), counter_ext(i), subhir(i)%level, subhir(i)%id1
!!$!!!$          end do
!!$!!!$       end if
!!$    end if
    call gettod(wct_now)
    cpudif = (wct_now - wct_start)*UMICRO
!!$    write(6,'(6x,"Total cpu time of ( ",i8," )-th iteration",4x,f11.5 &
!!$         & ,"(sec.)")') iteration, ecpu(0)
    if(printable) then
       if(iteration < 10000) then
          if(cpudif < 10**6) then
             write(6,'(1x,"Total cputime of ( ",i4," )-th iteration",3x,f11.5," /",f10.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          else 
             write(6,'(1x,"Total cputime of ( ",i4," )-th iteration",3x,f11.5," /",f12.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          end if
       else
          if(cpudif < 10**6) then
             write(6,'(1x,"Total cputime of ( ",i8," )-th iteration",1x,f11.5," /",f10.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          else 
             write(6,'(1x,"Total cputime of ( ",i8," )-th iteration",1x,f11.5," /",f12.3 &
                  & ," (sec.)")') iteration, ecpu(0), cpudif
          end if
       end if
    end if

    if(sw_details == ON .and. printable) call wd_ecpu_details(iteration)
1001 ecpu_previous = ecpu(0)

  contains
    subroutine wd_pauseline()
      if(levelset == ON .and. levmax>1 .and. printable) then
         if(lev < levmax) then
            write(6,'("    --- level ",i3," ---")') lev
         else
            write(6,'("    --- ---")')
         end if
      end if
    end subroutine wd_pauseline

    subroutine wd_headerlines()
      integer :: num_sub
      if(printable) then
         if(cput_mode == MODE_PARALLEL) then
            num_sub = num_sub_wd-1
         else
            num_sub = num_sub_wd
         end if
         write(6,'(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")') &
                 &     num_sub, iteration
         if(cput_mode == MODE_PARALLEL) then
            write(6,'("  no "," id ",2x,"        subroutine name         ","time(sec) "&
                 &               ," r(%) ","   count  ", "max_time    min       mean     stddevia"," nmax nmin  no(2)")')
         else
            write(6,'("  no "," id ",2x,"        subroutine name         "," time(sec) "&
                 &               ," r(%) ","   count","   no(2)")')
         end if
      end if
    end subroutine wd_headerlines

!!$    subroutine wd_headerlines()
!!$      if(printable) then
!!$         write(6,'(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")') &
!!$              &     num_sub_wd, iteration
!!$         write(6,'("  no "," id ",2x,"        subroutine name         "," time(sec) "&
!!$              &               ," r(%) ","   count","   no(2)")')
!!$      end if
!!$    end subroutine wd_headerlines
  end subroutine tstatc_wd

  subroutine tstatc_iter(iteration, first_iteration_of_this_job)
    integer, intent(in) :: iteration, first_iteration_of_this_job
    real(kind=DP) :: t_end, t_used
#ifdef NEC_ITER_REG
    character(len=7) :: str_reg
#endif
    call gettod(t_end)
    if(iteration > first_iteration_of_this_job) then
#ifdef NEC_ITER_REG
       write(str_reg, '(A3,I4.4)') 'IT_',iteration
       call FTRACE_REGION_END(str_reg)
#endif
       t_used  = t_end - tstart(0)
       ecpu(0) = t_used * UMICRO
    end if
    tstart(0) = t_end
#ifdef NEC_ITER_REG
       write(str_reg, '(A3,I4.4)') 'IT_',iteration+1
       call FTRACE_REGION_BEGIN(str_reg)
#endif
  end subroutine tstatc_iter

  subroutine m_Timing_wd_timenow(chars)
    character(len=*), intent(in) :: chars

    integer, dimension(8) :: ipresent_time
    integer :: i, j, ilen
    integer, parameter :: max_chars = 80, max_chars0 = 55
    character(len=80) :: aline
    character(len=20) :: dateandtime = ''

    call date_and_time(values=ipresent_time)
    
    ilen = len_trim(chars)
    if(ilen > max_chars0) ilen = max_chars0

!!$    aline = ''
!!$    do i = 1, ilen
!!$       aline(i:i) = chars(i:i)
!!$    end do
!!$    write(aline(ilen+6:max_chars),'(",i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
!!$         & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    write(dateandtime,'(i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
         & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    do i = 1,20
       if(i >= 9 .and. i <= 10) cycle
       if(dateandtime(i:i) == ' ' ) dateandtime(i:i) = '0'
    end do

    aline = chars(1:ilen)//'     '//dateandtime

    write(6,'(a80)') aline

  end subroutine m_Timing_wd_timenow

  subroutine m_Timing_init_timer()
#ifdef HIUX
    real(kind=DP) :: time0
#endif
    call gettod(wct_start)
    switch_of_timing = ON
#ifdef HIUX
    call xclock(time0,7)
    call xclock(time0,3)
#endif
  end subroutine m_Timing_init_timer

  subroutine m_Timing_wd_status(nfstatus, jobstatus_format,jobstatus_series,status_wdmode &
       &       , iteration, iteration_ionic, iteration_electronic)
    integer, intent(in) :: nfstatus, jobstatus_format, jobstatus_series, status_wdmode &
         &               , iteration, iteration_ionic, iteration_electronic
    integer :: switch_header
    character(len=9) :: modename
    real(kind=DP) :: elapsed_time

#ifdef HIUX
    real(kind=DP) :: cpu_time
    call xclock(elapsed_time,8)
    call xclock(cpu_time,5)
#else
    real(kind=DP) :: wct_now
    call gettod(wct_now)
    elapsed_time = (wct_now - wct_start) * UMICRO
#endif
    if(status_wdmode == START) then
       modename = 'START'
    else if(status_wdmode == ITERATIVE) then
       modename = 'ITERATIVE'
    else if(status_wdmode == FINISH) then
       modename = 'FINISHED'
    end if
    switch_header = ON
    if(jobstatus_format == TAG_FORMAT .or. jobstatus_format == TAG_LINE) then
       switch_header = OFF
    else if(jobstatus_format == TABLE) then
       if(jobstatus_series == ON .and. status_wdmode /= START) switch_header = OFF
    else
       if(printable) write(6,'(" jobstatus_format (= ",i5,") is illegal")') jobstatus_format
    end if
    if(jobstatus_format == TABLE) then
#ifdef HIUX
       if(switch_header == ON) &
            & write(nfstatus,'("status     iteration  iter_ionic  iter_elec  elapsed_time  cpu_time")')
       write(nfstatus,'(a9,i11,i11,i11,f14.4,f14.4)') modename, iteration &
            & , iteration_ionic, iteration_electronic, elapsed_time, cpu_time
#else
       if(switch_header == ON) &
            & write(nfstatus,'("status     iteration  iter_ionic  iter_elec  elapsed_time")')
       write(nfstatus,'(a9,i11,i11,i11,f14.4)') modename, iteration &
            & , iteration_ionic, iteration_electronic, elapsed_time
#endif
    else if(jobstatus_format == TAG_FORMAT) then
       write(nfstatus,'(" status       = ",a14)') modename
       write(nfstatus,'(" iteration    = ",i14)') iteration
       write(nfstatus,'(" iter_ionic   = ",i14)') iteration_ionic
       write(nfstatus,'(" iter_elec    = ",i14)') iteration_electronic
       write(nfstatus,'(" elapsed_time = ",f14.4)') elapsed_time
#ifdef HIUX
       write(nfstatus,'(" cpu_time     = ",f14.4)') cpu_time
#endif
    else if(jobstatus_format == TAG_LINE) then
#ifdef HIUX
       write(nfstatus,'(" status = ",a9,", iteration = ",i10,", iter_ionic = ",i10 &
            & ,", iter_elec = ",i10,", elapsed_time = ",f14.4,", cpu_time = ",f14.4)') &
            & modename,iteration,iteration_ionic,iteration_electronic &
            &,elapsed_time, cpu_time
#else 
       write(nfstatus,'(" status = ",a9,", iteration = ",i10,", iter_ionic = ",i10 &
            & ,", iter_elec = ",i10,", elapsed_time = ",f14.4)') &
            & modename,iteration,iteration_ionic,iteration_electronic &
            &,elapsed_time
#endif
    end if

  end subroutine m_Timing_wd_status

  subroutine correct_ecpu()
    !   input  : ecpu, counter, measure_count_limit
    !      condition : measure_count_limit > 0
    !   output : ecpu, ecpu_ext
    integer :: i
    real(kind=DP) :: d, ecpu0
    if(measure_count_limit <= 0) return
    d = 1.d0/measure_count_limit
    do i = 1, MSBRNM
       if(counter(i) > measure_count_limit) then
          ecpu0 = ecpu(i) 
          ecpu(i) = ecpu(i)*counter(i)/measure_count_limit
          if(ipritiming >= 2) write(6,'(" id = ",i8, " ecpu new, old = ",2f8.4)') i, ecpu(i),ecpu0
       end if
    end do
    if(sw_details == ON) then
       do i = 1, n_allocated_subhir
          if(counter_ext(i) > measure_count_limit) then
             ecpu0 = ecpu_ext(i)
             ecpu_ext(i) = ecpu_ext(i)*counter_ext(i)/measure_count_limit
             if(ipritiming >= 2) write(6,'(" id = ",i8, " ecpu_ext new, old = ",2f8.4)') i, ecpu_ext(i),ecpu0
          end if
       end do
    end if
  end subroutine correct_ecpu

end module m_Timing

module m_CS_NonCollinear
! $Id: m_CS_NonCollinear.f90 409 2014-10-27 09:24:52Z jkoga $
  use m_Const_Parameters,   only : DP, BUCS, CARTS, CRDTYP, DELTA10, &
       &                           oh=>oh_symbol, d6h=>d6h_symbol, ON, DELTA07, &
       &                           CMPLDP, zi, PAI

  use m_Crystal_Structure,      only : nopr, op, ig01, tau, m_CS_op_in_PUCD, &
       &                               pg_symbol_system, ngen, igen, jgen, &
       &                               alloc_igen_jgen, dealloc_igen_jgen, &
       &                               sw_reduce_sym_by_magmom, &
       &                               sw_reduce_sym_by_orbital, sw_neglect_magmom

  use m_Ionic_System,       only : natm, ntyp, ityp, mag_direction0_atomtyp, &
       &                           natm2, pos, iwei, magmom_local_now, &
       &                           has_partially_filled_lcore

  use m_Files,                 only : nfout

! == KT_add === 2014/08/14
  use m_Ionic_System,  only :   lattice_system_from_m_CS_SG
! ============= 2014/08/14

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

! ---------------------------
  integer :: nopr_before_sym_reduction
  real(kind=DP), allocatable :: op_before_sym_reduction(:,:,:)
  real(kind=DP) :: invop(48)
! -------------------------

! == KT_add === 2014/08/14
  integer, allocatable :: magmom_dir_inversion_opr_flag(:)
! ============= 2014/08/14

contains

! ------------------------------------------------------------------------
!!
!!!   Removing sym. operations by considering magnetic moment
!!
! ------------------------------------------------------------------------
  subroutine m_CS_set_Magnetic_Sym

    real(kind=DP) :: mag_loc(natm2,3)
    real(kind=DP) :: pos2(natm2,3)

    integer :: nsym_with_magmom

    call set_val_pos2( pos2 )
    call set_val_mag_loc( mag_loc )

    if ( .not. allocated( op_before_sym_reduction ) ) then
       allocate( op_before_sym_reduction(3,3,nopr) )
    endif

    nopr_before_sym_reduction = nopr
    op_before_sym_reduction = op

! == KT_add === 2014/08/14
    if ( .not. allocated( magmom_dir_inversion_opr_flag ) ) then
       allocate( magmom_dir_inversion_opr_flag( nopr ) )
    endif
! ============= 2014/08/14

! ==== KT_add === 2014/09/26
    if ( sw_neglect_magmom == ON ) then
       magmom_dir_inversion_opr_flag = 1
       return
    endif
! =============== 2014/09/26

    call set_magnetic_symm( natm2, pos2, nopr, ig01, op, tau, mag_loc, &
         &                  nsym_with_magmom, magmom_dir_inversion_opr_flag )

    call resize_matrix_size( nopr, nsym_with_magmom )

    call set_magnetic_tspace_gnerators( nopr, ig01, op, tau )

  contains

    subroutine set_val_pos2( pos2 )
      real(kind=DP), intent(out) :: pos2(natm2,3)
      integer :: i, ia

      pos2(1:natm,1:3) = pos(1:natm,1:3)

      i = natm
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            pos2(i,1:3) = -pos(ia,1:3)
         end if
      end do
    end subroutine set_val_pos2

    subroutine set_val_mag_loc( mag_loc )
      real(kind=DP), intent(out) :: mag_loc(natm2,3)
      integer :: i, ia

      i = natm
      mag_loc(1:natm,:) = magmom_local_now(1:natm,:)
      do ia=1,natm
         if (iwei(ia)/=1) then
            i = i+1
            mag_loc(i,1:3) = magmom_local_now(ia,1:3)
         end if
      end do

    end subroutine set_val_mag_loc

    subroutine set_magnetic_symm( natom, apos, nsym, nopr, rot, tau, mag_loc, &
         &                        nsym_with_mag, magmom_dir_inversion_opr_flag )
      integer, intent(in) :: natom
      integer, intent(inout) :: nsym
      integer, intent(out) :: nopr(48), nsym_with_mag
      integer, intent(inout) :: magmom_dir_inversion_opr_flag(nsym)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), intent(in) :: apos(natom,3)
      real(kind=DP), intent(in) :: mag_loc(natom,3)

      logical :: mag_sym_flag(nsym)
      integer :: isym, count
! ----
!      write(*,*) 'sw_reduce_ = ',  sw_reduce_sym_by_magmom
      if ( sw_reduce_sym_by_magmom==ON ) then
         call check_if_op_has_sym_for_magmom( natom, apos, nsym, rot, tau, &
              &                               mag_loc, mag_sym_flag, &
              &                               magmom_dir_inversion_opr_flag )
      else
         mag_sym_flag = .true.
      endif

      if ( sw_reduce_sym_by_orbital==ON ) then
         call check_if_op_has_sym_for_orb( natom, nsym, rot, mag_loc, mag_sym_flag )
      endif
! -----
      count = 0
      Do isym=1, nsym
         if ( mag_sym_flag(isym) ) then
            count = count + 1
            nopr(count) = nopr(isym)
            rot(:,:,count) = rot(:,:,isym)
            tau(:,count,:) = tau(:,isym,:)
            magmom_dir_inversion_opr_flag(count) = magmom_dir_inversion_opr_flag(isym)
         endif
      End do

      nsym_with_mag = count

    end subroutine set_magnetic_symm

    subroutine check_if_op_has_sym_for_orb( natom, nsym, rot, &
         &                                  mag_loc, mag_sym_flag )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(48)
      real(kind=DP), intent(inout) :: rot(3,3,nsym)
      real(kind=DP), intent(in) :: mag_loc(natom,3)

      integer :: isym, it, ia
      real(kind=DP) :: c1, c2
      real(kind=DP) :: vec1(3), vec_tmp(3), dvec_m(3), dvec_p(3)
      real(kind=DP), parameter :: criterion = 1.0D-5

      Do isym=1, nsym
         if ( .not. mag_sym_flag(isym) ) cycle

         Do it=1, ntyp
            if ( has_partially_filled_lcore(it) == 0 ) cycle

            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle
               
               call calc_normal_vector( mag_loc(ia,1:3), vec1(1:3) )
               vec_tmp(1:3) = matmul( rot(:,:,isym), vec1(1:3) )
!
               dvec_m(1:3) = vec_tmp(1:3) - vec1(1:3)
               dvec_p(1:3) = vec_tmp(1:3) + vec1(1:3)
!
               c1 = abs( dvec_m(1) ) +abs( dvec_m(2) ) +abs( dvec_m(3) )
               c2 = abs( dvec_p(1) ) +abs( dvec_p(2) ) +abs( dvec_p(3) )
!
               if ( c1 < criterion .or. c2 < criterion ) then
                  mag_sym_flag(isym) = .true.
               else
                  mag_sym_flag(isym) = .false.
               endif

               exit
            End do
         End Do

      End Do
!
    end subroutine check_if_op_has_sym_for_orb

    subroutine calc_normal_vector( vec_in, vec_out )
      real(kind=DP), intent(in)  :: vec_in(3)
      real(kind=DP), intent(out) :: vec_out(3)
!
      integer :: k
      real(kind=DP) :: c1, cnorm, vec_tmp(3)
      real(kind=DP), parameter :: criterion = 1.0D-5

! --- trial 1 --
      vec_tmp(1) = 1.0;  vec_tmp(2) = 2.0;    vec_tmp(3) = 3.0
!
      c1 = 0.0d0; cnorm = 0.0d0
      Do k=1, 3
         c1 = c1 + vec_tmp(k)*vec_in(k)
      End do
      vec_tmp(:) = vec_tmp(:) - c1*vec_in(:)
      Do k=1, 3
         cnorm = cnorm + vec_tmp(k)**2
      End do
      cnorm = sqrt(cnorm)
!
      if ( cnorm > criterion ) then
         vec_out(:) = vec_tmp(:) / cnorm
!         write(*,*) 'vec_out = ', vec_out
         return
      endif

! --- trial 2 --
      vec_tmp(1) = 3.0;  vec_tmp(2) = 2.0;    vec_tmp(3) = 1.0
!
      c1 = 0.0d0; cnorm = 0.0d0
      Do k=1, 3
         c1 = c1 + vec_tmp(k)*vec_in(k)
      End do
      vec_tmp(:) = vec_tmp(:) - c1*vec_in(:)
      Do k=1, 3
         cnorm = cnorm + vec_tmp(k)**2
      End do
      cnorm = sqrt(cnorm)
!
      if ( cnorm > criterion ) then
         vec_out(:) = vec_tmp(:) / cnorm
      endif

    end subroutine calc_normal_vector

    subroutine check_if_op_has_sym_for_magmom( natom, apos, nsym, rot, &
         &                                     tau, mag_loc, mag_sym_flag, &
         &                                     magmom_dir_inversion_opr_flag )
      integer, intent(in) :: natom, nsym
      logical, intent(inout) :: mag_sym_flag(nsym)
      integer, intent(inout) :: magmom_dir_inversion_opr_flag(nsym)
      real(kind=DP), intent(in) :: apos(natom,3), mag_loc(natom,3)

! --------------------- kDEBUG --------------------------------- 20121020
!      real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48,CRDTYP)
      real(kind=DP), intent(inout) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
! --------------------- kDEBUG --------------------------------- 20121020

      real(kind=DP), parameter :: criterion = 1.0D-5
      real(kind=DP), allocatable :: apos_t(:,:)

      integer :: i, ia, ja, ja_found, it, isym, count
      real(kind=DP) :: coord_tmp(3), dcoord(3), dist
      real(kind=DP) :: mag_tmp(3), dmag_p(3), dmag_m(3)
      real(kind=DP) :: c1, c2
!
      real(kind=DP) :: rot_pr(3,3,nsym)
!
! -- init --
      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .true., &
           &                '***** Before considering magnetic symmetry ****** ')

      allocate(apos_t(natom,3))
      apos_t(1:natm,1:3) = apos(1:natom,1:3)
      do ia = 1, natom
         do i = 1, 3
            apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
         end do
      end do

      mag_sym_flag = .false.

      magmom_dir_inversion_opr_flag = 1

! -- begin --
      Do isym=1, nsym

! ================== KT_add ======= 2014/08/14
         if ( lattice_system_from_m_CS_SG == "cubic" ) then
            if ( ig01(isym) > 24 ) cycle
         else if ( lattice_system_from_m_CS_SG == "hexagonal" ) then
            if ( ig01(isym) > 12 ) cycle
         endif
! ================================= 2014/08/14

         Do it=1, ntyp
            Do ia=1, natom
               if ( ityp(ia) /=it ) cycle

               coord_tmp(1:3) = matmul( rot_pr(:,:,isym), apos_t(ia,1:3) ) &
                    &         + tau(1:3,isym,BUCS)
               coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))

               ja_found = 0
               Do ja=1, natom
                  dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)

                  dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
                  dist = sqrt(dist)

                  dist = dist - floor( dist +DELTA10 )

                  if ( dist < criterion ) then
                     ja_found = ja
                     !  goto 100
                     exit
                  endif
               End do

100            continue
               !
               if ( ja_found ==0 ) then
                  write(*,*) 'kt: Not found symmetry', isym, ia
                  stop
               endif

               mag_tmp(1:3) = matmul( rot(:,:,isym), mag_loc(ia,1:3) )
!
               dmag_m(1:3) = mag_tmp(1:3) - mag_loc(ja_found,1:3)
               dmag_p(1:3) = mag_tmp(1:3) + mag_loc(ja_found,1:3)
!
               c1 = abs( dmag_m(1) ) +abs( dmag_m(2) ) +abs( dmag_m(3) )
               c2 = abs( dmag_p(1) ) +abs( dmag_p(2) ) +abs( dmag_p(3) )
!
! ====== KT_mod === 2014/08/14
!               if ( c1 < criterion ) then
!                  mag_sym_flag(isym) = .true.
!                  exit
!               endif
!               if ( mag_sym_flag(isym) ) then
!                  if ( c1 > criterion ) then
!                     mag_sym_flag(isym) = .false.
!                  endif
!               endif
! --
               if ( c1 < criterion ) then
                  mag_sym_flag(isym) = .true.
                  magmom_dir_inversion_opr_flag(isym) = 1
                  exit
               endif
               if ( c2 < criterion ) then
                  mag_sym_flag(isym) = .true.
                  magmom_dir_inversion_opr_flag(isym) = -1
                  exit
               endif
               if ( mag_sym_flag(isym) ) then
                  if ( c1 > criterion .and. c2 > criterion ) then
                     mag_sym_flag(isym) = .false.
                  endif
               endif
! =============== 2014/08/14
            End do
         End do
      End do

    end subroutine check_if_op_has_sym_for_magmom

    subroutine resize_matrix_size( nsym, nsym_with_mag )
      integer, intent(inout) :: nsym, nsym_with_mag
      real(kind=DP), allocatable :: rot_tmp(:,:,:), tau_tmp(:,:,:)
      integer, allocatable :: magmom_dir_inversion_opr_flag_tmp(:)
!
      allocate( rot_tmp(3,3,nsym) );      rot_tmp = 0.0d0
      allocate( tau_tmp(3,nsym,CRDTYP) ); tau_tmp = 0.0d0
!
      rot_tmp = op;  tau_tmp = tau
      deallocate( op );  deallocate( tau )
!
      allocate( op(3,3,nsym_with_mag ) );       op = 0.0d0
      allocate( tau(3,nsym_with_mag,CRDTYP ) ); tau = 0.0d0
!
      op(:,:,1:nsym_with_mag) = rot_tmp(:,:,1:nsym_with_mag)
      tau(:,1:nsym_with_mag,:) = tau_tmp(:,1:nsym_with_mag,:)
!
      deallocate( rot_tmp ); deallocate( tau_tmp )
!
! === KT_add === 2014/08/14
      allocate( magmom_dir_inversion_opr_flag_tmp( nsym ) )
      magmom_dir_inversion_opr_flag_tmp = 0

      magmom_dir_inversion_opr_flag_tmp = magmom_dir_inversion_opr_flag
      deallocate( magmom_dir_inversion_opr_flag )

      allocate( magmom_dir_inversion_opr_flag(nsym_with_mag) )
      magmom_dir_inversion_opr_flag = 0

      magmom_dir_inversion_opr_flag(1:nsym_with_mag) &
           &         = magmom_dir_inversion_opr_flag_tmp(1:nsym_with_mag)
      deallocate( magmom_dir_inversion_opr_flag_tmp )
! ============== 2014/08/14

      nsym = nsym_with_mag

    end subroutine resize_matrix_size

    subroutine set_magnetic_tspace_gnerators( nsym, nopr, rot, tau )
      integer, intent(in) :: nsym
      integer, intent(in) :: nopr(48)
      real(kind=DP), intent(in) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
      
      integer :: iptab(nsym,nsym)
      integer :: ng, ig(3)
      character(len=9) :: system

      system = pg_symbol_system

      call set_mini_product_table( nsym, rot, tau, iptab )
      call search_generators( nsym, iptab, ng, ig )
      call set_generators( ng, ig, nopr )
      call write_tspace_generators(system)

    end subroutine set_magnetic_tspace_gnerators

! --
    subroutine set_mini_product_table( nsym, rot, tau, iptab )
      integer, intent(in) :: nsym
      integer, intent(out) :: iptab(nsym,nsym)
      real(kind=DP), intent(in) :: rot(3,3,nsym), tau(3,nsym,CRDTYP)
      
      real(kind=DP) :: rot_pr(3,3,48)
      real(kind=DP) :: op_tmp(3,3), tau_tmp(3)
      real(kind=DP) :: c1, c2, cx, cy, cz
      real(kind=DP), parameter :: eps = 1.d-4

      integer :: isym, jsym, ksym
      integer :: ksym_found
      integer :: m1, m2, m3
      integer :: nx, ny, nz

      iptab = 0

      call m_CS_op_in_PUCD( nfout, rot_pr, nsym, .false. )

      Do jsym=1, nsym
         Do isym=1, nsym
            
            op_tmp = 0.0d0; tau_tmp = 0.0d0
            Do m1=1, 3
               Do m2=1, 3
                  Do m3=1, 3
                     op_tmp(m1,m2) = op_tmp(m1,m2) &
                          & + rot_pr(m1,m3,isym) *rot_pr(m3,m2,jsym) 
                  End do
               End Do
            End do
            Do m1=1, 3
               Do m2=1, 3
                  tau_tmp(m1) = tau_tmp(m1) &
                       &       + rot_pr(m1,m2,isym)*tau(m2,jsym,BUCS)
               End do
               tau_tmp(m1) = tau_tmp(m1) + tau(m1,isym,BUCS)
            End do
! ---------------------------------
            ksym_found = 0
! ---------------------------------

!            write(*,*) 'isym jsym ', isym, jsym
!            write(*,*) 'op_tmp ', op_tmp(1,1), op_tmp(1,2), op_tmp(1,3)
!            write(*,*) 'op_tmp ', op_tmp(2,1), op_tmp(2,2), op_tmp(2,3)
!            write(*,*) 'op_tmp ', op_tmp(3,1), op_tmp(3,2), op_tmp(3,3)
!            write(*,*) 'tau_tmp ', tau_tmp(1), tau_tmp(2), tau_tmp(3)


            Do ksym=1, nsym
               c1 = 0.0d0
               Do m1=1, 3
                  Do m2=1, 3
                     c1 = c1 + abs( op_tmp(m1,m2) - rot_pr(m1,m2,ksym) )
                  End do
               End do

               if ( c1 < eps ) then
                  Do nx=-1, 1
                     Do ny=-1, 1
                        Do nz=-1, 1
                           cx = tau_tmp(1) - tau(1,ksym,BUCS) +nx
                           cy = tau_tmp(2) - tau(2,ksym,BUCS) +ny
                           cz = tau_tmp(3) - tau(3,ksym,BUCS) +nz

                           c2 = abs(cx) + abs(cy) + abs(cz)

                           if ( c2 < eps ) then
                              ksym_found = ksym
                              goto 1000
                           endif
                        End Do
                     End Do
                  End Do
               endif
            End Do

1000        continue
            iptab(isym,jsym) = ksym_found
!            write(*,*) 'isym jsym ', isym, jsym, ksym_found
         End do
      End do

    end subroutine set_mini_product_table

    subroutine search_generators( nsym, iptab, ng, ig )
      integer, intent(in) :: nsym, iptab(nsym,nsym)
      integer, intent(out) :: ng, ig(3)
      
      integer :: i,j,k
      logical :: fexist(1:nsym)
      integer :: ii

! --------------
      ng = 1
      do i=1,nsym
         fexist(1:nsym) = .false.
         fexist(i) = .true.
         if (group_is_the_same(nsym,fexist,iptab)) then
            ig(ng) = i
            return
         end if
      end do
! --------------
      ng = 2
      do i=2,nsym
         do j=i+1,nsym
            fexist(1:nsym) = .false.
            fexist(i) = .true.
            fexist(j) = .true.
            if (group_is_the_same(nsym,fexist,iptab)) then
               ig(1)  = i
               ig(ng) = j
               return
            end if
         end do
      end do
! ------------
      ng = 3
      do i=2,nsym
         do j=i+1,nsym
            do k=j+1,nsym
               fexist(1:nsym) = .false.
               fexist(i) = .true.
               fexist(j) = .true.
               fexist(k) = .true.
               if (group_is_the_same(nsym,fexist,iptab)) then
                  ig(1)  = i
                  ig(2)  = j
                  ig(ng) = k
                  return
               end if
            end do
         end do
      end do

      stop 'Set of generators of the space group was not found.'

    end subroutine search_generators

    logical function group_is_the_same( nsym, fexist, iptab)
      integer, intent(in) :: nsym
      integer, intent(in) :: iptab(nsym,nsym)
      logical, intent(inout) :: fexist(nsym)

      integer :: i,j
      integer :: n,no
      logical :: flag(nsym)

      n=0
      no=-1 
      do while(n > no)
         flag(1:nsym) = .false.
         do j=1,nsym
            do i=1,nsym
               if(fexist(i).and.fexist(j)) flag(iptab(i,j)) = .true.
            end do
         end do
         do i=1,nsym
            if(flag(i)) fexist(i) = .true.
         end do
         no = n
         n = 0
         do i=1,nsym
            if(fexist(i)) n=n+1
         end do
      end do
      if(n==nsym) then
         group_is_the_same = .true.
      else
         group_is_the_same = .false.
      end if

    end function group_is_the_same

    subroutine set_generators( ng, ig, nopr )
      integer, intent(in) :: ng, ig(3)
      integer, intent(in) :: nopr(48)

      integer :: i,j,k,n
      real(kind=DP) :: t,r,tb(3)
      real(kind=DP), parameter :: eps = 1.d-4

      ngen = ng
      call dealloc_igen_jgen
      call alloc_igen_jgen

      do i=1,ngen
         igen(i) = nopr(ig(i))

         tb(:) = tau(:,ig(i),BUCS)

         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jgen(1,j,i) = nint(r)
                  jgen(2,j,i) = k
                  exit
               end if
            end do
         end do
      end do
      
    end subroutine set_generators

    subroutine set_translations_zero
      integer :: i,j
      do i=1,ngen
         do j=1,3
            jgen(1,j,i) = 0
            jgen(2,j,i) = 1
         end do
      end do
    end subroutine set_translations_zero

    subroutine write_tspace_generators(system)
      character(len=9), intent(in) :: system
      
      integer :: i
      
      write(nfout,*) '----------------------------------- '
      write(nfout,'("TSPACE Generators with Magnetic symmetry :")')
      
      if (system == 'cubic') then
         do i=1,ngen
            write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),oh(igen(i)),jgen(:,:,i)
         end do
      else
         do i=1,ngen
            write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),d6h(igen(i)),jgen(:,:,i)
         end do
      end if

    end subroutine write_tspace_generators

  end subroutine m_CS_set_Magnetic_Sym

! ---------------------------------------------------------------------------
  subroutine m_CS_set_inverse_operation
    integer :: iopr1, iopr2
    real(kind=DP) :: ss(3,3)

    do iopr1=1,nopr
       do iopr2=1,nopr
          ss = matmul(op(:,:,iopr1),op(:,:,iopr2))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
          & abs(ss(2,2)-1.d0)<DELTA07 .and. &
          & abs(ss(3,3)-1.d0)<DELTA07 .and. &
          & abs(ss(1,2))<DELTA07 .and. &
          & abs(ss(1,3))<DELTA07 .and. &
          & abs(ss(2,3))<DELTA07) then
             invop(iopr1) = iopr2
             exit
          end if
       end do
    end do

  end subroutine m_CS_set_inverse_operation

end module m_CS_NonCollinear

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 1200)
!
!  MODULE: m_Positron_Wave_Functions
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!    Further modification by T. Yamasaki   April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_Positron_Wave_Functions
! $Id: m_Positron_Wave_Functions.F90 412 2014-11-30 12:02:22Z yamasaki $
  use m_Const_Parameters, only   : DP,POSITRON,OFF,ON,DIRECT,INVERSE, DELTAevdff, SD, MSD &
       &                         , DENSITY_ONLY, VTK, CUBE
  use m_Control_Parameters, only : af, nspin, npeg,kimg,ipripositron &
       &                         , delta_pev, evaluation_pev_diff &
       &                         , num_extra_pev, sw_gga_p, sw_epsilon_ele, epsilon_ele &
       &                         , sw_positron_file,positron_filetype, positron_title &
       &                         , m_CtrlP_pstrn_ntcnvg_incre &
       &                         , m_CtrlP_pstrn_ntcnvg_reset &
       &                         , m_CtrlP_pstrn_ntcnvg_clear
  use m_IterationNumbers, only :   iteration_positron_wf
  use m_Timing, only :             tstatc0_begin, tstatc0_end
  use m_Files, only :              nfout, nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &
       &                         , m_Files_open_nfpstrn, m_Files_open_nfvelec &
       &                         , m_Files_open_nfeppair,m_Files_open_nfeppair2 &
       &                         , m_Files_open_nfvelec_grad &
       &                         , m_Files_close_nfpstrn,m_Files_close_nfvelec &
       &                         , m_Files_close_nfeppair,m_Files_close_nfeppair2 &
       &                         , m_Files_close_nfvelec_grad
  use m_Crystal_Structure, only  : univol
  use m_PlaneWaveBasisSet, only  : kg_pwf, kg1_pwf, igf_pstrn, igfp_l, igfp_nonpara &
       &                         , m_pwBS_pstrn_kinetic_energies
  use m_Electronic_Structure,only: vlhxc_l
  use m_Parallelization, only :    mype, npes, ista_kngp, iend_kngp &
       &                         , ista_sfftph, iend_sfftph, ierr, mpi_comm_group
  use m_FFT, only   :              nfft, nfftp, nfftp_nonpara, nfft_pstrn, fft_box_size_pWF &
       &                         , fft_box_size_CD, fft_box_size_CD_nonpara &
       &                         , m_FFT_alloc_pWF_work, m_FFT_dealloc_WF_work &
       &                         , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                         , m_FFT_Vlocal_pW &
       &                         , m_FFT_coef_CD_integration
  use m_Crystal_Structure,  only : altv
  use m_Ionic_System,         only : ntyp,ityp,zfm3_l,natm2, iatomn &
       &                         , m_IS_pack_all_ions_in_uc
  use m_epc_potential, only      : tchgr_l, grad_tchgr_l
  use m_PseudoPotential, only    : rhchg_l, ival

  implicit none
  include 'mpif.h'

  real(kind=DP),allocatable,dimension(:,:,:) :: pzaj   ! positron wave functions d(kg1_pwf,npeg,kimg)
  real(kind=DP),allocatable,dimension(:,:,:) :: pzaj_old ! d(kg1_pwf,npeg,kimg)
  real(kind=DP),allocatable,dimension(:,:) ::   pchg_l ! positron charge in g-space, d(ista_kngp:iend_kngp,kimg)
  real(kind=DP),allocatable,dimension(:) ::     pchr_l ! positron charge in r-space, d(ista_sfftph:iend_sfftph)
  integer, allocatable, dimension(:) ::         npeordr, nprvf_ordr !d(npeg)
  real(kind=DP),allocatable,dimension(:) ::     pev, pev1   ! d(npeg)
  real(kind=DP),private,allocatable,dimension(:) :: pevdff !d(3)

!!$  real(kind=DP),private,allocatable,dimension(:,:,:) :: vlhepc_l !d(ista_kngp:iend_kngp,kimg,nspin)
  real(kind=DP),private,allocatable, dimension(:) ::  afft, bfft, ekin, afft_mpi
  real(kind=DP),private,allocatable, dimension(:) ::  p
  real(kind=DP),private::valence_annihilation_rate,core_annihilation_rate
  real(kind=DP),private::valence_annihilation_rate_down,valence_annihilation_rate_total
  real(kind=DP),private::p_new_lifetime,p_new_lifetime_down,p_new_lifetime_total,p_old_lifetime,p_core_rate

contains

  subroutine m_pWF_copy_pzaj_to_pzaj_old()
    pzaj_old = pzaj
  end subroutine m_pWF_copy_pzaj_to_pzaj_old

  subroutine m_pWF_allocate_pzaj_etc()
    integer :: ib
    allocate(pzaj(kg1_pwf,npeg,kimg))
    allocate(pzaj_old(kg1_pwf,npeg,kimg))
    allocate(npeordr(npeg))
    allocate(nprvf_ordr(npeg))
    npeordr(1:npeg) = (/(ib,ib=1,npeg)/)
    nprvf_ordr(1:npeg) = (/(ib,ib=1,npeg)/)
    allocate(pev(1:npeg))
    allocate(pev1(1:npeg)); pev1 = 0.d0
    allocate(pevdff(3))
    allocate(pchg_l(ista_kngp:iend_kngp,kimg))
    allocate(pchr_l(ista_sfftph:iend_sfftph))
  end subroutine m_pWF_allocate_pzaj_etc

  subroutine m_pWF_deallocate_pzaj_etc()
    if(allocated(pchr_l)) deallocate(pchr_l)
    if(allocated(pchg_l)) deallocate(pchg_l)
    if(allocated(pevdff)) deallocate(pevdff)
    if(allocated(pev)) deallocate(pev)
    if(allocated(pev1)) deallocate(pev1)
    if(allocated(nprvf_ordr)) deallocate(nprvf_ordr)
    if(allocated(npeordr)) deallocate(npeordr)
    if(allocated(pzaj_old)) deallocate(pzaj_old)
    if(allocated(pzaj)) deallocate(pzaj)
  end subroutine m_pWF_deallocate_pzaj_etc

  subroutine m_pWF_alloc_afft_etc()
    allocate(afft(nfft_pstrn))
    allocate(bfft(nfft_pstrn))
    allocate(ekin(kg1_pwf))
    call m_FFT_alloc_pWF_work()
  end subroutine m_pWF_alloc_afft_etc

  subroutine m_pWF_dealloc_afft_etc()
    deallocate(afft,bfft,ekin)
    call m_FFT_dealloc_WF_work()
  end subroutine m_pWF_dealloc_afft_etc

  subroutine m_pWF_IW_by_randomnumbers()
    real(kind=DP)   :: a,b,p,xn
    data a,b,p/32771.d0,1234567891.d0,2147483648.d0/

    integer :: iimg, ieg, i
    integer :: id_sname = -1
    call tstatc0_begin('m_pWF_IW_by_randomnumbers ',id_sname)

    if(ipripositron >= 2) then
       write(nfout,*)
       write(nfout,'(" <<< m_pWF_IW_by_randomnumbers >>>")')
    end if

    pzaj = 0.d0

    xn = 0.d0
!!$    do iimg = 1, kimg
    do iimg = 1, 1
       do ieg = 1, npeg
          do i = 1,  kg1_pwf
             xn = mod(xn*a+b,p)
             pzaj(i,ieg,iimg) = xn/p
          enddo
       enddo
    enddo

    call tstatc0_end(id_sname)
  end subroutine m_pWF_IW_by_randomnumbers


  subroutine evolve_each_pWF_again(dt_new,dt_old)
    real(kind=DP), intent(in) :: dt_new, dt_old
    integer :: ir, ib, ig
    real(kind=DP) :: dtt

    dtt = dt_new/dt_old
    do ir=1,kimg
       do ib=1, npeg
          do ig=1, kg1_pwf
             pzaj(ig,ib,ir) = (1-dtt)*pzaj_old(ig,ib,ir) + dtt*pzaj(ig,ib,ir)
          end do
       end do
    end do
  end subroutine evolve_each_pWF_again
    
  subroutine steepest_descent_p(precon,ib,dtim,ekin,VlocalpW,p)
    integer, intent(in) ::                             precon,ib
    real(kind=DP), intent(in) ::                       dtim
    real(kind=DP), intent(in), dimension(kg1_pwf) ::   ekin
    real(kind=DP), intent(in), dimension(nfft_pstrn) ::VlocalpW
    real(kind=DP),             dimension(kg1_pwf) ::   p

    integer :: i, i1
    real(kind=DP) :: evr,devr,denom,evi,e1,devi

    denom = 1.d0/product(fft_box_size_pWF(1:3,1))
    call decide_precon_factor_p(precon,ib,ekin,p) ! -> p(1:kg1_pwf)

    if(kimg==1) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1)
          devr = (ekin(i) - pev(ib))*evr + VlocalpW(i1)*denom
          pzaj(i,ib,1) = evr - p(i)*dtim*devr
       end do
    else if(kimg==2) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1); evi = pzaj(i,ib,kimg)
          e1 = ekin(i) - pev(ib)
          devr = e1*evr+VlocalpW(2*i1-1)*denom
          devi = e1*evi+VlocalpW(2*i1  )*denom
          pzaj(i,ib,1)    = evr - p(i)*dtim*devr
          pzaj(i,ib,kimg) = evi - p(i)*dtim*devi
       end do
    end if
  end subroutine steepest_descent_p

  subroutine modified_sd_p(precon,ib,dtim,vlhxc0,ekin,VlocalpW,p)
    integer, intent(in) ::                             precon,ib
    real(kind=DP), intent(in) ::                       dtim, vlhxc0
    real(kind=DP), intent(in), dimension(kg1_pwf) ::   ekin
    real(kind=DP), intent(in), dimension(nfft_pstrn) ::VlocalpW
    real(kind=DP),             dimension(kg1_pwf) ::   p

    integer :: i, i1
    real(kind=DP) :: evr,devr,denom,evi,e1,devi, wdi, fdexp

    denom = 1.d0/product(fft_box_size_pWF(1:3,1))
    call decide_precon_factor_p(precon,ib,ekin,p) ! -> p(1:kg1_pwf)

    if(kimg==1) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1)
          devr = (ekin(i) - pev(ib))*evr + VlocalpW(i1)*denom
          wdi = ekin(i) + vlhxc0 - pev(ib)
          fdexp = dexp( -p(i) * wdi * dtim)
          pzaj(i,ib,1) = (fdexp - 1) * devr/wdi + evr
       end do
    else if(kimg==2) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1); evi = pzaj(i,ib,kimg)
          e1 = ekin(i) - pev(ib)
          devr = e1*evr+VlocalpW(2*i1-1)*denom
          devi = e1*evi+VlocalpW(2*i1  )*denom
          wdi  = ekin(i) + vlhxc0 - pev(ib)
          fdexp = dexp( -p(i) * wdi * dtim)
          pzaj(i,ib,1)    = (fdexp -1)*devr/wdi + evr
          pzaj(i,ib,kimg) = (fdexp -1)*devi/wdi + evi
       end do
    end if
  end subroutine modified_sd_p


  subroutine decide_precon_factor_p(precon,ib,ekin,p)
    integer,intent(in) ::                           precon,ib
    real(kind=DP),intent(in),dimension(kg1_pwf)  :: ekin
    real(kind=DP),intent(out),dimension(kg1_pwf) :: p

    integer  :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

    if(precon == ON) then
       call kinetic_energy_p(ib,ekin,ektot)
       d_ektot = 1.d0/ektot
       do i = 1, kg1_pwf
          x = ekin(i)*d_ektot
          x1 = 27 + (18 + (12 + 8*x)*x)*x
          x2 = 16*(x*x)*(x*x)
          p(i) = x1/(x1 + x2)
       end do
    else
       p = 1.d0
    end if
  end subroutine decide_precon_factor_p

  subroutine kinetic_energy_p(ib,dekin,ektot)
    integer, intent(in) :: ib
    real(kind=DP), intent(in), dimension(kg1_pwf) :: dekin
    real(kind=DP), intent(out) ::                    ektot
    integer :: i, ri
    ektot = 0.d0
    do ri = 1, kimg
       do i = 1, kg1_pwf
          ektot = ektot + dekin(i)*pzaj(i,ib,ri)*pzaj(i,ib,ri)
       end do
    end do
  end subroutine kinetic_energy_p
    

  subroutine m_pWF_modified_gram_schmidt()
    integer :: i, ito, nmax
    real(kind=DP) :: fr
    real(kind=DP),pointer, dimension(:,:) :: p1p2
    integer,      pointer, dimension(:)   :: ib2to_a, ib2back_a

    allocate(ib2to_a(npeg), ib2back_a(npeg))
    allocate(p1p2(npeg,kimg))
    do i = 1, npeg
       ito = npeordr(i)
       call WW(ito,fr)
       call normalize_pzaj(ito,fr)
       call substitute_jto_ib2back(i,nmax)
       call W1W2(ito)
       call modify_pzaj(i,ito)
    end do
    deallocate(p1p2,ib2back_a,ib2to_a)

  contains
    subroutine WW(j,fr)
      integer, intent(in) ::        j
      real(kind=DP), intent(out) :: fr

      integer ::       ri, ig
      real(kind=DP) :: fr1, fi1
      if(kimg == 1) then
         fr1 = 0.d0
         do ig = 1, kg1_pwf
            fr1 = fr1 + pzaj(ig,j,1)*pzaj(ig,j,1)
         end do
         fr = fr1
      else
         fr1 = 0.d0; fi1 = 0.d0
         do ig = 1, kg1_pwf
!!$            fr1 = fr1 + pzaj(ig,j,1)**2+pzaj(ig,j,2)**2
            fr1 = fr1 + pzaj(ig,j,1)*pzaj(ig,j,1)
            fi1 = fi1 + pzaj(ig,j,2)*pzaj(ig,j,2)
         end do
         fr = fr1 + fi1
      end if

      if(fr < 0.d0) then
         if(ipripositron >= 1) then 
            write(nfout,'(" i, ito, j = ",3i8)') i, ito, j
            write(nfout,'(" fr = ",d23.10)') fr
            if(kimg == 2) write(nfout,'(" fr1, fi1 = ",2d23.10)') fr1, fi1
         end if
         stop ' fr < 0 <<m_pWF_modified_gram_schmidt.WW>>'
      else
         fr = 1.d0/dsqrt(fr)
      end if
    end subroutine WW

    subroutine normalize_pzaj(ibo,fr)
      integer, intent(in) :: ibo
      real(kind=DP), intent(in) :: fr
      integer :: ri, i
      do ri = 1, kimg
         do i = 1, kg1_pwf
            pzaj(i,ibo,ri) = fr*pzaj(i,ibo,ri)
         end do
      end do
    end subroutine normalize_pzaj

    subroutine substitute_jto_ib2back(i,nmax)
      integer, intent(in)  :: i
      integer, intent(out) :: nmax

      integer              ::jto, j
      jto = 0
      do j = 1, npeg
         if(nprvf_ordr(j) <= i) cycle
         jto = jto + 1
         ib2to_a(jto)  = j
         ib2back_a(j)  = jto
      end do
      nmax = jto
    end subroutine substitute_jto_ib2back

    subroutine W1W2(ito)
      integer, intent(in) :: ito

      real(kind=DP) :: ar, ai
      integer :: jto, j, ia

      p1p2 = 0.d0
      if(kimg == 1) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, kg1_pwf
               p1p2(jto,1) = p1p2(jto,1) + pzaj(ia,ito,1)*pzaj(ia,j,1)
            end do
         end do
      else if(kimg == 2) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, kg1_pwf
               ar = pzaj(ia,ito,1)
               ai = pzaj(ia,ito,2)
               p1p2(jto,1) = p1p2(jto,1) + ar*pzaj(ia,j,1)+ai*pzaj(ia,j,2)
               p1p2(jto,2) = p1p2(jto,2) + ar*pzaj(ia,j,2)-ai*pzaj(ia,j,1)
            end do
         end do
      end if
    end subroutine W1W2

    subroutine modify_pzaj(i,ito)
      
      integer, intent(in) :: i, ito
      integer :: j, ia, jto
      real(kind=DP) :: sr, si
      do j = 1, npeg
         if(nprvf_ordr(j) <= i) cycle
         jto = ib2back_a(j)
         if(kimg == 1) then
            do ia = 1, kg1_pwf
               pzaj(ia,j,1) = pzaj(ia,j,1) - p1p2(jto,1)*pzaj(ia,ito,1)
            end do
         else if(kimg == 2) then
            do ia = 1, kg1_pwf
               sr = pzaj(ia,ito,1);         si = pzaj(ia,ito,2)
               pzaj(ia,j,1) = pzaj(ia,j,1) - p1p2(jto,1)*sr+p1p2(jto,2)*si
               pzaj(ia,j,2) = pzaj(ia,j,2) - p1p2(jto,1)*si-p1p2(jto,2)*sr
            end do
         end if
      end do
    end subroutine modify_pzaj

  end subroutine m_pWF_modified_gram_schmidt

  logical function m_pWF_pevdff()
    integer :: ib
    real(kind=DP) :: fac, tmp
    if(evaluation_pev_diff == OFF) then
       m_pWF_pevdff = .false.
       return
    end if

    pevdff = 0.d0
    fac = 1.d0/npeg
    do ib = 1, npeg
       if(nprvf_ordr(ib) > npeg- num_extra_pev) cycle
       tmp = pev(ib) - pev1(ib)
       pevdff(1) = pevdff(1) + tmp*tmp
       pevdff(2) = pevdff(2) + dabs(tmp)
       if(dabs(tmp) > DELTAevdff) &
            & pevdff(3) = pevdff(3) + dsqrt(dabs(pev1(ib)**2 - pev(ib)**2))
    end do

    pevdff(1) = dsqrt(fac*pevdff(1))
    pevdff(2) = fac*pevdff(2)
    pevdff(3) = fac*pevdff(3)

    pev1 = pev

    if(ipripositron >= 1) write(nfout,*)'lifetime: ',p_old_lifetime,p_new_lifetime
    if(max(pevdff(1),pevdff(2)) < delta_pev.and. &
         & dabs(p_old_lifetime-p_new_lifetime) < 1.d0  ) then
       ib = m_CtrlP_pstrn_ntcnvg_incre()
       if(ipripositron >= 1) &
            & write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_positron_wf,ib
    else
       call m_CtrlP_pstrn_ntcnvg_reset()
    end if
    if(ipripositron >= 1) &
         & write(nfout,'(" >> (",i6,") <pev_old-pev_new>:(",3d13.5,")")') &
         &    iteration_positron_wf, pevdff(1), pevdff(2), pevdff(3)

    p_old_lifetime=p_new_lifetime
    m_pWF_pevdff = m_CtrlP_pstrn_ntcnvg_clear()

  end function m_pWF_pevdff

  subroutine m_pWF_wd_pev(nf)
    integer, intent(in) :: nf
    integer :: ib

    if(ipripositron >= 1) then
       write(nf,*) '=== positron eigen values ==='
       write(nf,'(99(4f18.10,/))') (pev(npeordr(ib)),ib=1,npeg-num_extra_pev)
       write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
            & (pev(npeordr(ib)),ib=npeg-num_extra_pev+1, npeg)
    end if
  end subroutine m_pWF_wd_pev

!!$  subroutine m_pWF_wd_pev(nfout)
!!$    integer, intent(in) :: nfout
!!$
!!$    integer :: ib
!!$    write(nfout,'(" -- Positron Energy Eigen Values --")')
!!$    write(nfout,'(" ",99(10f8.4,/))') (pev(npeordr(ib)),ib=1,npeg)
!!$  end subroutine m_pWF_wd_pev


  subroutine m_pWF_sort_eigen_values()
    integer :: ib, jb, ibo, jbo
    real(kind=DP), parameter :: delta = 1.d-12

    npeordr(1:npeg) = (/(ib,ib=1,npeg)/)
    do ib = 1, npeg-1
       do jb = ib+1, npeg
          ibo = npeordr(ib)
          jbo = npeordr(jb)
          if(pev(jbo) < pev(ibo) - delta) then
             npeordr(jb) = ibo
             npeordr(ib) = jbo
          end if
       end do
    end do
    do ib = 1, npeg
       do jb = 1, npeg
          if(ib == npeordr(jb)) then
             nprvf_ordr(ib) = jb
             exit
          end if
       end do
    end do

  end subroutine m_pWF_sort_eigen_values


  subroutine m_pWF_W_T_W(ib)
    integer, intent(in) :: ib
    integer :: i, ri
    pev(ib) = 0.d0
    do ri = 1, kimg
       do i = 1, kg1_pwf
          pev(ib) = pev(ib) + ekin(i)*pzaj(i,ib,ri)**2
       end do
    end do
  end subroutine m_pWF_W_T_W


  real(kind=DP) function m_pWF_tell_band_energy()
    integer :: ib
    real(kind=DP) :: eband
    eband = 0.d0
    do ib = 1, npeg
       if(nprvf_ordr(ib) > npeg - num_extra_pev ) cycle
       eband = eband + pev(ib)
    end do
    m_pWF_tell_band_energy = eband
  end function m_pWF_tell_band_energy
 
  subroutine m_pWF_core_annihilation()
    integer :: it, ri, i
    real(kind=DP) :: sss, sss_mpi
!!$    integer :: i, j, ip,idp,mmp,mnp,ipp,k,nlp,nmp,nnp,up_down &
!!$         ,inew,jnew,knew, nlphf,nmesh,n,ri,it
!!$    real(kind=DP) ::fac,fac2
!!$    real(kind=DP),allocatable,dimension(:,:,:) ::wkchr
!!$    real(kind=DP),allocatable,dimension(:,:,:) ::wkchr2
!!$    real(kind=DP),allocatable,dimension(:) ::gr_l
!!$    real(kind=DP),allocatable,dimension(:) ::radr,wos,rhcr,wky,wkx
!!$    real(kind=DP) ::sss,ssk,enhanc,sss1,sss2,gabs
!!$
!!$    rewind 501

    sss=0.d0
    do it=1,ntyp
!!$       read(501,*)nmesh
!!$       allocate(radr(1:nmesh),wos(1:nmesh),rhcr(1:nmesh),gr_l(ista_kngp:iend_kngp))
!!$       allocate(wky(1:nmesh),wkx(1:nmesh))
!!$       read(501,*)radr(1:nmesh)
!!$       read(501,*)wos(1:nmesh)
!!$       read(501,*)rhcr(1:nmesh)
!!$       read(501,*)wky(1:nmesh)
!!$       read(501,*)gr_l(ista_kngp:iend_kngp)
       do ri = 1, kimg
          do i = ista_kngp, iend_kngp 
             sss = sss + rhchg_l(i,it)*pchg_l(i,ri)*zfm3_l(i,it,ri)
          end do
       end do

       if(ipripositron >= 3) then
          if(it == 1) write(nfout,'(" -- rhchg_l, pchgq_l, zfm3_l <<m_pWF_core_annihilation>>")')
          write(nfout,'(" -- it = ",i8)') it
          write(nfout,'(" --- i, rhchg_l pchg_l zfm3_l --")')
          do i = ista_kngp, min(ista_kngp+max(10,20*ipripositron), iend_kngp)
             write(nfout,'(i8,3f20.8)') i, rhchg_l(i,it), pchg_l(i,1), zfm3_l(i,it,1)
          end do
          write(nfout,'(" sss = ",f20.8)') sss
       end if
!!$          gabs = gr_l(i)
!!$          wkx(1:nmesh) = gabs*radr(1:nmesh)
!!$          call dsjnv(0,nmesh,wkx,wky)
!!$          do ri=1,kimg
!!$             do n = 1, nmesh
!!$                fac2=rhcr(n)/radr(n)/4.d0/3.1415926d0
!!$                call enhance_0(fac2,enhanc)
!!$                fac = wos(n)*rhcr(n)/univol*enhanc
!!$                sss=sss+fac*wky(n)* pchg_l(i,ri)*zfm3_l(i,it,ri)
!!$!                sss=sss+fac*wky(n)* pchg_l(i,ri)*2.d0
!!$             end do
!!$          enddo
!!$       end do
    enddo

    if(npes >= 2) then
       call mpi_allreduce(sss,sss_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       sss = sss_mpi
    end if
!                       valence_annihilation_rate=sss1
!                       ssk=((0.5292d0)**3)*1.d4/(2.8d0**2)/3.d0/3.1415926d0
!    core_annihilation_rate=sss/dsqrt(4.d0*3.1415926d0)
     core_annihilation_rate=sss/2.d0*univol

  end subroutine m_pWF_core_annihilation

  subroutine m_pWF_valence_annihilation()
    integer :: i, j, ip,idp,mmp,mnp,ipp,k,nlp,nmp,nnp,up_down &
         & ,inew,jnew,knew, nlphf, nd1,nd2,nd3
  
    real(kind=DP),allocatable,dimension(:)     :: f2or1
    real(kind=DP),allocatable,dimension(:,:,:) :: wkchr
    real(kind=DP),allocatable,dimension(:,:,:) :: wkchr2,wkchr3, wkchr4,wkchr22,wkchr32
    real(kind=DP) ::sss,sss_down,sss_total,ssk,enhanc,sss1,sss2, sss_mpi
    allocate(f2or1(ista_sfftph:iend_sfftph))
    call m_FFT_coef_CD_integration(f2or1)

#ifdef FFTW3
    idp = fft_box_size_CD(1,1)
    mmp = fft_box_size_CD(2,1)
    mnp = fft_box_size_CD(3,1)
#else
    idp = fft_box_size_CD(1,0)
    mmp = fft_box_size_CD(2,0)
    mnp = fft_box_size_CD(3,0)
#endif
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)

    if(sw_positron_file == ON) then

    if(kimg == 1) then
       nlphf = idp/2
    else
       nlphf = idp
    end if

    if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
       nd1 = nlp; nd2 = nmp; nd3 = nnp
    else if(positron_filetype == CUBE) then
       nd1 = nnp; nd2 = nmp; nd3 = nlp
    end if
    allocate(wkchr(nd1,nd2,nd3)); wkchr = 0.d0
    allocate(wkchr2(nd1,nd2,nd3)); wkchr2 = 0.d0
    allocate(wkchr3(nd1,nd2,nd3)); wkchr3 = 0.d0
    if(nspin==2) then
       allocate(wkchr22(nd1,nd2,nd3)); wkchr22 = 0.d0
       allocate(wkchr32(nd1,nd2,nd3)); wkchr32 = 0.d0
    end if
    if(sw_gga_p == ON) then
       allocate(wkchr4(nd1,nd2,nd3)); wkchr4 = 0.d0
    end if

    up_down=1
    do i = 1, nmp
       do j = 1, nnp
          do k = 1,nlp
             if(kimg == 1 .and. k > nlphf) then
                knew = idp - k
                jnew = nnp+2 - j
                inew = nmp+2 - i
                if(jnew > nnp) then
                   jnew = jnew - nnp
                end if
                if(inew > nmp) then
                   inew = inew - nmp
                end if
             else
                knew = k; jnew = j; inew = i
             end if
             ip=nlphf*mmp*(jnew-1) + nlphf*(inew-1) + knew
             if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
!                wkchr(k,i,j) = afft(ip*2-2+up_down)
                wkchr(k,i,j) = afft(ip*2-2+up_down)/2
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) then
                   wkchr2(k,i,j) = tchgr_l(ip,1)
                   if(nspin==2) wkchr22(k,i,j) = tchgr_l(ip,2)
                   if(sw_gga_p == ON) wkchr4(k,i,j) = grad_tchgr_l(ip,1)
                end if
             else if(positron_filetype == CUBE) then
! lin
!             if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then

!                wkchr(k,i,j) = afft(ip*2-2+up_down)
                if(ip*2-2+up_down<1) cycle
                wkchr(j,i,k) = afft(ip*2-2+up_down)/2
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) then
                   wkchr2(j,i,k) = tchgr_l(ip,1)
                   if(nspin==2) wkchr22(j,i,k) = tchgr_l(ip,2)       
                   if(sw_gga_p == ON) wkchr4(j,i,k) = grad_tchgr_l(ip,1)
                end if
! lin
!             end if

             end if
          end do
       end do
    end do
    if(npes>=2)then
       call mpi_allreduce(MPI_IN_PLACE,wkchr2,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(nspin==2) &
         & call mpi_allreduce(MPI_IN_PLACE,wkchr22,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(sw_gga_p==ON) then
          call mpi_allreduce(MPI_IN_PLACE,wkchr4,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       end if
    end if
    wkchr3 = 0.d0

    up_down=1

    if(nspin==1) then

    if(sw_epsilon_ele == OFF) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
!!$             if(kimg == 1 .and. k > nlphf) then
!!$                knew = idp - k
!!$                jnew = nnp+2 - j
!!$                inew = nmp+2 - i
!!$                if(jnew > nnp) then
!!$                   jnew = jnew - nnp
!!$                end if
!!$                if(inew > nmp) then
!!$                   inew = inew - nmp
!!$                end if
!!$             else
!!$                knew = k; jnew = j; inew = i
!!$             end if
!!$             ip=nlphf*mmp*(jnew-1) + nlphf*(inew-1) + knew
!!$             wkchr(j,i,k) = afft(ip*2-2+up_down)
!!$             wkchr2(j,i,k) = tchgr_l(ip,1)
!c --------------->
!!$             if(sw_gga_p == ON) then
!!$                call enhance_gga_0(wkchr2(j,i,k)*nspin,wkchr4(j,i,k)*nspin,enhanc)
!!$             else
                call enhance_0(wkchr2(j,i,k)*nspin,enhanc)
!!$             end if
!c <--------------
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    else if(sw_epsilon_ele == ON) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_01(wkchr2(j,i,k)*nspin,enhanc,epsilon_ele)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else if(positron_filetype == CUBE) then
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    end if

    else if(nspin==2) then
    if(sw_epsilon_ele == OFF) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_0(wkchr2(j,i,k)+wkchr22(j,i,k),enhanc)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(k,i,j) = wkchr(k,i,j)*wkchr22(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(j,i,k) = wkchr(j,i,k)*wkchr22(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    else if(sw_epsilon_ele == ON) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_01(wkchr2(j,i,k)+wkchr22(j,i,k),enhanc,epsilon_ele)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(k,i,j) = wkchr(k,i,j)*wkchr22(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else if(positron_filetype == CUBE) then
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(j,i,k) = wkchr(j,i,k)*wkchr22(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    end if
    end if
!end of seperate the cases of nonmagnetic and magnetic

    end if
!!$      rewind 500
!!$      read(500,*) wkchr2
!!$      sss=0.d0
!!$      sss1=0.d0
!!$      sss2=0.d0
!!$      do j=1,nnp
!!$         do i=1,nmp
!!$            do k=1,nlp
!!$               call enhance_0(wkchr2(j,i,k),enhanc)
!!$               wkchr3(j,i,k)=wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
!!$               sss=sss+wkchr3(j,i,k)
!!$               sss1=sss1+wkchr(j,i,k)/(nnp*nmp*nlp)*univol
!!$               sss2=sss2+wkchr2(j,i,k)/(nnp*nmp*nlp)*univol
!!$            enddo
!!$         enddo
!!$      enddo
!!$      write(nfout,'(" (1) sss, sss1, sss2 = ",3f12.4)') sss, sss1, sss2

!!$      write(6,'(" tchgr_l")')
!!$    do i = ista_sfftph, ista_sfftph+10
!!$         write(6,'(i3,f20.8)') i, tchgr_l(i,1)
!!$    end do

   ! wkchr  <- afft
   ! wkchr2 <- tchgr_l
      sss=0.d0
      sss1=0.d0
      sss2=0.d0
      sss_down = 0.d0
      sss_total = 0.d0

    if(nspin == 1) then
      if(sw_epsilon_ele == OFF) then
         do i = ista_sfftph, iend_sfftph
!c --------------->
!!$         if(sw_gga_p == ON) then
!!$            call enhance_gga_0(tchgr_l(i,1)*nspin,grad_tchgr_l(i,1)*nspin,enhanc)
!!$         else
            call enhance_0(tchgr_l(i,1)*nspin,enhanc)
!!$         end if
!c <--------------
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + tchgr_l(i,1)*nspin*f2or1(i)
         end do
      else if(sw_epsilon_ele == ON) then
         do i = ista_sfftph, iend_sfftph
            call enhance_01(tchgr_l(i,1)*nspin,enhanc,epsilon_ele)
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + tchgr_l(i,1)*nspin*f2or1(i)
         end do
      end if
!magnetic system,nspin=2
    else if(nspin==2) then
       if(sw_epsilon_ele == OFF) then
         do i = ista_sfftph, iend_sfftph
!c --------------->
!!$         if(sw_gga_p == ON) then
!!$            call enhance_gga_0(tchgr_l(i,1)*nspin,grad_tchgr_l(i,1)*nspin,enhanc)
!!$         else
            call enhance_0((tchgr_l(i,1)+tchgr_l(i,2)),enhanc)
!!$         end if
!c <--------------
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc     ! up_spin
            sss_down =  sss_down + afft(i*2-1)*tchgr_l(i,2)*nspin*f2or1(i)*enhanc    ! down_spin
            sss_total =  sss_total + afft(i*2-1)*(tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)*enhanc      ! total_spin
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + (tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)
         end do
      else if(sw_epsilon_ele == ON) then
         do i = ista_sfftph, iend_sfftph
            call enhance_01((tchgr_l(i,1)+tchgr_l(i,2)),enhanc,epsilon_ele)
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc     ! up_spin
            sss_down =  sss_down + afft(i*2-1)*tchgr_l(i,2)*nspin*f2or1(i)*enhanc    ! down_spin
            sss_total =  sss_total + afft(i*2-1)*(tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)*enhanc      ! total_spin
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + (tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)
         end do
      end if
!end of magnetic system
    end if

      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,sss,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         call mpi_allreduce(MPI_IN_PLACE,sss1,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         call mpi_allreduce(MPI_IN_PLACE,sss2,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         if(nspin==2) then
            call mpi_allreduce(MPI_IN_PLACE,sss_down,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
            call mpi_allreduce(MPI_IN_PLACE,sss_total,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         end if
      end if
      if(nspin == 1) then
         sss_down = sss
         sss_total = sss
      end if

      sss  = sss/(nnp*nmp*nlp)*univol
      sss1 = sss1/(nnp*nmp*nlp)*univol
      sss2 = sss2/(nnp*nmp*nlp)*univol
      sss_down  = sss_down/(nnp*nmp*nlp)*univol
      sss_total  = sss_total/(nnp*nmp*nlp)*univol

      if(ipripositron >= 1) write(nfout,'(" (2) sss, sss1, sss2 = ",&
           & 3f12.4)') sss, sss1, sss2

      if(sw_positron_file == ON) then
         call m_Files_open_nfpstrn()
         call m_Files_open_nfvelec()
         call m_Files_open_nfeppair()
         if(nspin==2) call m_Files_open_nfeppair2()
         if(sw_gga_p == ON) call m_Files_open_nfvelec_grad()

!!$rewind 300
!!$rewind 310
!!$rewind 320
         if(mype == 0) call wdchgr(nfout,nfpstrn,1,positron_title(1))
         if(mype == 0) call wdchgr(nfout,nfvelec,2,positron_title(2))
         if(mype == 0) call wdchgr(nfout,nfeppair,3,positron_title(3))
         if(nspin==2) then
            if(mype == 0) call wdchgr(nfout,nfeppair2,5,positron_title(5))
         end if
!!$write(300,*) 'cube file of positron density'
!!$write(300,'(6e13.5)') wkchr
!!$write(310,*) 'cube file of valence electron density'
!!$write(310,'(6e13.5)') wkchr2
!!$write(320,*) 'cube file of e-p pair'
!!$write(320,'(6e13.5)') wkchr3
         if(sw_gga_p == ON) then
!!$         rewind 330
            if(mype == 0) call wdchgr(nfout,nfvelec_grad,4,positron_title(4))
!!$         write(330,*)  'cube file of gradient of valence electron density'
!!$         write(330,'(6e13.5)') wkchr4
         end if
   
         call m_Files_close_nfpstrn()
         call m_Files_close_nfvelec()
         call m_Files_close_nfeppair()
         if(nspin==2) call m_Files_close_nfeppair2()
         if(sw_gga_p == ON) call m_Files_close_nfvelec_grad()
         if(sw_gga_p == ON) deallocate(wkchr4)
         deallocate(wkchr)
         deallocate(wkchr2)
         deallocate(wkchr3)
         if(nspin==2) deallocate(wkchr22)
         if(nspin==2) deallocate(wkchr32)
      end if

     if(nspin==1) then
       valence_annihilation_rate=sss/2.d0
       ssk=((0.5292d0)**3)*1.d4/(2.8d0**2)/3.d0/3.1415926d0
       ssk=ssk
       sss=core_annihilation_rate+valence_annihilation_rate
       p_new_lifetime=ssk/sss
       p_core_rate=core_annihilation_rate/sss*100.d0
     else if(nspin==2) then 
        valence_annihilation_rate=sss/2.d0
        valence_annihilation_rate_down=sss_down/2.d0
        valence_annihilation_rate_total=sss_total/2.d0
        ssk=((0.5292d0)**3)*1.d4/(2.8d0**2)/3.d0/3.1415926d0
        ssk=ssk
        sss=core_annihilation_rate+valence_annihilation_rate
        sss_down=core_annihilation_rate+valence_annihilation_rate_down
        sss_total=core_annihilation_rate+valence_annihilation_rate_total
        p_new_lifetime=ssk/sss
        p_new_lifetime_down=ssk/sss_down
        p_new_lifetime_total=ssk/sss_total
        p_core_rate=core_annihilation_rate/sss*100.d0
     end if
     if(ipripositron >= 1) write(nfout,*)core_annihilation_rate, valence_annihilation_rate

     deallocate(f2or1)
   contains
     subroutine wdchgr(nfout,nfchr,np,str)
       integer, intent(in) :: nfout, nfchr,np
       character(len=*), intent(in) :: str
       integer :: n1,n2,n3,i,j,k, m, iloop
       real(kind=DP) :: dn1,dn2,dn3,x,y,z
       real(kind=DP),allocatable,dimension(:,:) :: cps_full
       integer, allocatable,dimension(:) :: ityp_full

       if(positron_filetype == DENSITY_ONLY) then
          write(nfchr,9001) nlp*nmp*nnp, nlp, nmp, nnp
9001      format(' CHARGE DENSITY NE = ',i8,'(',3i5,')')
          if(np == 1) then
             write(nfchr,'(6e13.5)') wkchr
          else if(np == 2) then
             write(nfchr,'(6e13.5)') wkchr2
          else if(np == 3) then
             write(nfchr,'(6e13.5)') wkchr3
          else if(np == 4) then
             write(nfchr,'(6e13.5)') wkchr4
          else if(np == 5) then
             if(allocated(wkchr32)) &
                  & write(nfchr,'(6e13.5)') wkchr32
          end if
       else if(positron_filetype == VTK) then
          write(nfchr,'("# vtk DataFile Version 2.0")')
          if(len_trim(str) >= 1) then
             write(nfchr,*) trim(str)
          else
             write(nfchr,'(" Calculated by PHASE")')
          end if

          write(nfchr,'("ASCII")')
          write(nfchr,'("DATASET STRUCTURED_GRID")')
          write(nfchr,'("DIMENSIONS",3(1x,i5))') nlp+1,nmp+1,nnp+1
          write(nfchr,'("POINTS",1x,i7,1x,"float")') (nlp+1)*(nmp+1)*(nnp+1)
          do n1=0,nlp
             do n2=0,nmp
                do n3=0,nnp
                   dn1 = n1/dble(nlp)
                   dn2 = n2/dble(nmp)
                   dn3 = n3/dble(nnp)
                   x = altv(1,1)*dn1 + altv(1,2)*dn2 + altv(1,3)*dn3
                   y = altv(2,1)*dn1 + altv(2,2)*dn2 + altv(2,3)*dn3
                   z = altv(3,1)*dn1 + altv(3,2)*dn2 + altv(3,3)*dn3
                   write(nfchr,'(3(1x,e13.5))') x,y,z
                end do
             end do
          end do
          if(np.le.4.or.(np==5.and.allocated(wkchr32))) then
             write(nfchr,'("")')
             write(nfchr,'("POINT_DATA",1x,i7)') (nlp+1)*(nmp+1)*(nnp+1)
             write(nfchr,'("SCALARS scalars float")')
             write(nfchr,'("LOOKUP_TABLE default")')
             do n1=0,nlp
                i=n1+1
                if(n1==nlp) i=1
                do n2=0,nmp
                   j=n2+1
                   if(n2==nmp) j=1
                   do n3=0,nnp
                      k=n3+1
                      if(n3==nnp) k=1
                      if(np==1) then
                         write(nfchr,'(e13.5)') wkchr(i,j,k)
                      else if(np==2) then
                         write(nfchr,'(e13.5)') wkchr2(i,j,k)
                      else if(np==3) then
                         write(nfchr,'(e13.5)') wkchr3(i,j,k)
                      else if(np==4) then
                         write(nfchr,'(e13.5)') wkchr4(i,j,k)
                      else if(np==5) then
                         write(nfchr,'(e13.5)') wkchr32(i,j,k)
                      end if
                   end do
                end do
             end do
          end if
       else if(positron_filetype == CUBE) then
          if(len_trim(str) >= 1) then
             write(nfchr,*) trim(str)
          else
             write(nfchr,'(" Calculated by phase")')
          end if
          if(nspin == 2) then
             if(iloop == 1) then
                write(nfchr,'(" SCF Total Density  UP")')
             else
                write(nfchr,'(" SCF Total Density  DOWN")')
             end if
          else
             write(nfchr,'(" SCF Total Density")')
          end if
          x = 0.d0; y = 0.d0; z = 0.d0
          write(nfchr,'(i6,3f10.4)') natm2, x,y,z
          do i = 1, 3
             write(nfchr,'(i6,3f10.6)') fft_box_size_CD(i,1), altv(1:3,i)/dble(fft_box_size_CD(i,1))
          end do

          allocate(cps_full(natm2,3))
          allocate(ityp_full(natm2))
          call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
          do i = 1, natm2
             m = ityp_full(i)
             write(nfchr,'(i6,4f10.6)') nint(iatomn(m)), ival(m), cps_full(i,1:3)
          end do
          deallocate(ityp_full,cps_full)

          if(np==1) then
             write(nfchr,'(6e13.5)') wkchr
          else if(np==2) then
             write(nfchr,'(6e13.5)') wkchr2
          else if(np==3) then
             write(nfchr,'(6e13.5)') wkchr3
          else if(np==4) then
             write(nfchr,'(6e13.5)') wkchr4
          else if(np==5) then
             if(allocated(wkchr32)) &
                  & write(nfchr,'(6e13.5)') wkchr32
          end if
       end if
     end subroutine wdchgr
end subroutine m_pWF_valence_annihilation

subroutine m_pWF_wlifetime()

  if(ipripositron >= 1) then
     write(nfout,*) '***************************************************'
     write(nfout,*)'positron lifetime(ps)', p_new_lifetime 
!!$     write(nfout,*)'core rate',core_annihilation_rate
     write(nfout,*)'core rate',p_core_rate,'%'
     write(nfout,*) '*************************************************'
  end if
end subroutine m_pWF_wlifetime

  subroutine m_pWF_wd_pzaj(nfout,comment,nc)
    integer,        intent(in) :: nfout, nc
    character(len=nc), intent(in) :: comment

    character(len=5) :: a
    integer :: i, ib, ri, j
    integer, parameter :: NZAJSIZE = 20
    integer :: nelm

    if(ipripositron <= 1) return 
    write(nfout,*) comment
    a = "     "
    do ib = 1, npeg
       do ri = 1, kimg
          if(ri == 1 .and. kimg == 2) a = "(Re) "
          if(ri == 2) a = "(Im) "

          if(ri == 1) write(nfout,'(" pev(",i3,")= ",e14.6," ",a4,5e14.6)') &
               & ib,pev(ib),a,(pzaj(i,ib,ri),i=1,5)
          if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(pzaj(i,ib,ri),i=1,5)
       end do
       if(ipripositron >= 3) then
          nelm = min(kg1_pwf,NZAJSIZE)
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" pev(",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,pev(ib),a,(pzaj(i,ib,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(pzaj(i,ib,ri),i=1,5)
             write(nfout,'(35x,5e14.6)') (pzaj(i,ib,ri),i=6,nelm)

          end do
       end if
    end do
  end subroutine m_pWF_wd_pzaj
end module m_Positron_Wave_Functions

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: Gauss_Legendre
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine Gauss_Legendre(x,w,n)
! $Id: Real_space_integ.f90 409 2014-10-27 09:24:52Z jkoga $
implicit none
!
! int root(1-x**2) * f(x) dex = sum_{i} w_i * f(x_i)
!
integer, intent(in) :: n
real(kind=8), intent(out) :: x(n),w(n)

integer, parameter :: itermax = 100
real(kind=8), parameter :: eps = 3.d-14

integer :: i,j,iter,m
real(kind=8) :: z,z1,p1,p2,p3,pp
logical :: conv

m=(n+1)/2

!!! write(*,'("m=",i3)') m

do i=1,m
   z = cos(4.d0*atan(1.d0)*(i-0.25d0)/(n+0.5d0))
   do iter=1,itermax
      p1=1.d0
      p2=0.d0
      do j=1,n
         p3=p2
         p2=p1
         p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
      end do
      pp=n*(z*p1-p2)/(z*z-1.d0)
      z1 = z
      z = z1 - p1/pp
      ! debug
      !  write(*,*) 'i=',i,'iter=',iter,' z=',z
      ! end debug
      if(abs(z-z1) <= eps) then
         conv = .true.
         exit
      end if
   end do
   if(.not.conv) write(6,*) 'too many iterations in Gauss_Legendre'
   x(i) = -z
   x(n+1-i) = z
   w(i) = 2.d0/((1.d0-z*z)*pp*pp)
   w(n+1-i) = w(i)
end do
      
end subroutine Gauss_Legendre

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: int_spherical_surf
!
!  AUTHOR: Takenori Yamamotoi   June/01/2004
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) at Jun. 1, 2004
!
subroutine int_spherical_surf(lmax,nmax,n,x,y,z,w)
! $Id: Real_space_integ.f90 409 2014-10-27 09:24:52Z jkoga $
!
!  Int F(x,y,z) dOmega = sum_i w(i) * F(x(i),y(i),z(i))
!  ( x^2 + y^2 + z^2 = 1 )
!
!  nt = 1 + int(3*lmax/2)
!  np = 1 + 3*lmax
!  n = np*nt
!
implicit none
integer, intent(in) :: lmax,nmax
integer, intent(out) :: n
real(kind=8), intent(out) :: x(nmax),y(nmax),z(nmax),w(nmax)

integer :: i,j,m,nt,np
real(kind=8), allocatable :: xt(:),wt(:)
real(kind=8) :: pi,wp,dt,dp,p

nt = 1+int(3*lmax/2)
np = 1+3*lmax
n  = nt*np

if(nmax < n) stop 'nmax is too samll.'

allocate(xt(nt),wt(nt))

call Gauss_Legendre(xt,wt,nt)
! debug
!write(*,'("debug: nt=",i3))') nt
!do i=1,nt
!  write(*,'("debug:",2(1x,f10.5))') xt(i),wt(i)
!end do
! end debug

pi = 4.d0*atan(1.d0)
wp = 2.d0*pi/dble(np)
dp = 2.d0*pi/dble(np)

do i=1,nt
   do j=1,np
      m = (j-1)*nt + (i-1) + 1
      p = dp*(j-1)
      x(m)=sin(acos(xt(i)))*cos(p)
      y(m)=sin(acos(xt(i)))*sin(p)
      z(m)=xt(i)
      w(m)=wt(i)*wp
   end do
end do

deallocate(xt)
deallocate(wt)

end subroutine int_spherical_surf

subroutine memsize(nfout)
implicit none
integer, intent(in) :: nfout
integer :: ipid, imemsize
character*16 :: cpid, c1, c2
character*256 :: status_file
real(kind=8) :: mb
integer :: getpid

ipid = getpid()
write(cpid,*) ipid

write(status_file,*) '/proc/', trim(adjustl(cpid)), '/status'

open(1, file=trim(adjustl(status_file)), action='read')

do while(.true.)
   read(1,*,end=999) c1, c2
   if(c1(1:6) .eq. 'VmHWM:') then
      read(c2,*) imemsize
      exit
   end if
end do

999 continue

close(1)

mb = dble(imemsize) / 1024.d0 ! with MB

!print '(1x,a,f10.3)', 'Memory Usage[MB]: ', mb
write(nfout, '(1x,a,f10.3)') 'Memory Usage[MB]: ', mb

return
end subroutine memsize

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

  type(DFTI_DESCRIPTOR), POINTER :: dh_WF, dh_CD 
  type(mklfft_rdh) :: rdh_WF, rdh_CD
  integer :: strides(4), Status

  ! ------- Positron start 
  type(DFTI_DESCRIPTOR), POINTER :: dh_pWF
  type(mklfft_rdh) :: rdh_pWF
  ! ------- Positron end

  integer :: sw_avoiding_odd_fftbox = OFF
  integer :: sw_zero_padding = OFF

  include 'mpif.h'
contains

  subroutine m_FFT_alloc_WF_work
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       allocate(afft_CD(nfftp), stat=istat)
    end if
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    integer :: istat
    if(sw_mpifft == OFF) then
       deallocate(afft_CD, stat=istat)
    end if
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    integer :: ipad
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 1
    end if
! --- fft_box_size_WF, fft_box_size_pWF ---
    fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + ipad
    fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1)
    if(sw_positron /= OFF) then
       fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + ipad
       fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1)
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
! --- fft_box_size_CD ---
    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    if(sw_mpifft == ON) then
       if(ipri >= 1) write(nfout,*) '!FFT_CD = MPIFFT <<m_FFT_setup>>'
       call set_mpifft_box_size_CD(inversion_symmetry) ! -> fft_box_size_CD, fft_box_size_CD_c, ny_d, nz_d, etc.
       nfftp  = product(fft_box_size_CD_c(1:3,0)) * (2-inversion_symmetry)
       nfftps = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    else
       fft_box_size_CD(1:3,0) = fft_box_size_CD_nonpara(1:3,0)
       fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
       nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
       nfftps = nfftp
    end if

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    if(.not. paramset) then
! Initialization of the Wave-Function FFT
       call init_fft_coefficients_arrays_WF()

       if(sw_mpifft == OFF) then
! Initialization of the Charge-Density FFT
          call CDFFT_setup()
       end if
    endif

    call tstatc0_end(id_sname)
  contains
    subroutine init_fft_coefficients_arrays_WF()
      integer :: id, id_p

      if(kimg == 1) then
         call init_mkl_rfft(fft_box_size_WF(1,1) &
                         & ,fft_box_size_WF(2,1) &
                         & ,fft_box_size_WF(3,1) &
                         & ,fft_box_size_WF(1,0) &
                         & ,fft_box_size_WF(2,0) &
                         & ,fft_box_size_WF(3,0) &
                         & ,rdh_WF)
      else
         id = fft_box_size_WF(1,0)
         Status = DftiCreateDescriptor( dh_WF, DFTI_DOUBLE, &
                             & DFTI_COMPLEX, 3, fft_box_size_WF(1,1))
         strides(1) = 0
         strides(2) = 1
         strides(3) = id
         strides(4) = id*fft_box_size_WF(2,0)
         Status = DftiSetValue(dh_WF, DFTI_INPUT_STRIDES, strides)
         Status = DftiCommitDescriptor( dh_WF )
      end if
      if(sw_positron /= OFF) then
         if(kimg == 1) then
            call init_mkl_rfft(fft_box_size_pWF(1,1) &
                            & ,fft_box_size_pWF(2,1) &
                            & ,fft_box_size_pWF(3,1) &
                            & ,fft_box_size_pWF(1,0) &
                            & ,fft_box_size_pWF(2,0) &
                            & ,fft_box_size_pWF(3,0) &
                            & ,rdh_pWF)
         else
            id_p = fft_box_size_pWF(1,0)
            Status = DftiCreateDescriptor( dh_pWF, DFTI_DOUBLE, &
                     & DFTI_COMPLEX, 3, fft_box_size_pWF(1,1))
            strides(1) = 0
            strides(2) = 1
            strides(3) = id_p
            strides(4) = id_p*fft_box_size_pWF(2,0)
            Status = DftiSetValue(dh_pWF, DFTI_INPUT_STRIDES, strides)
            Status = DftiCommitDescriptor( dh_pWF )
         end if
      end if
    end subroutine init_fft_coefficients_arrays_WF

  end subroutine m_FFT_setup

  subroutine CDFFT_setup()

    call init_fft_coefficients_arrays_CD()
    CD_setup_is_done = YES
  contains
    subroutine init_fft_coefficients_arrays_CD
      integer :: id

   !  ---> FFT for Charge density
      if(kimg == 1) then
         call init_mkl_rfft(fft_box_size_CD(1,1) &
                         & ,fft_box_size_CD(2,1) &
                         & ,fft_box_size_CD(3,1) &
                         & ,fft_box_size_CD_nonpara(1,0) &
                         & ,fft_box_size_CD_nonpara(2,0) &
                         & ,fft_box_size_CD_nonpara(3,0) &
                         & ,rdh_CD)
      else
         id = fft_box_size_CD_nonpara(1,0)
         Status = DftiCreateDescriptor( dh_CD, DFTI_DOUBLE, &
                             & DFTI_COMPLEX, 3, fft_box_size_CD(1,1))
         strides(1) = 0
         strides(2) = 1
         strides(3) = id
         strides(4) = id*fft_box_size_CD_nonpara(2,0)
         Status = DftiSetValue(dh_CD, DFTI_INPUT_STRIDES, strides)
         Status = DftiCommitDescriptor( dh_CD )
      end if
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    integer :: id_sname = -1

    if(electron_or_positron == ELECTRON) then
       call tstatc0_begin('m_FFT_WF ',id_sname)
    else if(electron_or_positron == POSITRON) then
       call tstatc0_begin('m_FFT_pWF ',id_sname)
    end if

    if(electron_or_positron == ELECTRON) then
       if(inverse_or_direct == DIRECT) then
          if(kimg == 1) then
             call mkl_rfft(1,rdh_WF,afft)
          else
             Status = DftiComputeForward( dh_WF, afft)
          end if
       else
          if(kimg == 1) then
             call mkl_rfft(-1,rdh_WF,afft)
          else
             Status = DftiComputeBackward( dh_WF, afft)
          end if
       end if
    else if(electron_or_positron == POSITRON) then
       if(inverse_or_direct == DIRECT) then
          if(kimg == 1) then
             call mkl_rfft(1,rdh_pWF,afft)
          else
             Status = DftiComputeForward( dh_pWF, afft)
          end if
       else
          if(kimg == 1) then
             call mkl_rfft(-1,rdh_pWF,afft)
          else
             Status = DftiComputeBackward( dh_pWF, afft)
          end if
       end if
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_WF

  subroutine fft_CD_inverse_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD

    if(kimg == 1) then
       call mkl_rfft(-1,rdh_CD,afft_CD)
    else
       Status = DftiComputeBackward( dh_CD, afft_CD)
    end if
  end subroutine fft_CD_inverse_core

  subroutine fft_CD_direct_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    if(kimg == 1) then
       call mkl_rfft(1,rdh_CD,afft_CD)
    else
       Status = DftiComputeForward( dh_CD, afft_CD)
    end if
  end subroutine fft_CD_direct_core
  ! --------------------------

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.
subroutine Esm_interface_map_parameters(nat_,upf_zp_,tau_,alat_,at_,nr1x_,nr2x_,nr3x_,  &
                                   &    esm_bc_,gamma_only_,ngm_,nspin_,mill_,nl_,nlm_, &
                                   &    esm_w_,esm_efield_,izwall_,z_wall_,bar_height_,bar_width_)
  use ESM_VARS
  implicit none
  integer, intent(in) :: nat_
  real(8), dimension(nat_), intent(in)   :: upf_zp_
  real(8), dimension(3,nat_), intent(in) :: tau_
  real(8), intent(in) :: alat_
  real(8), intent(in) :: at_(3,3)
  integer, intent(in) :: nr1x_,nr2x_,nr3x_
  character(len=3), intent(in) :: esm_bc_
  logical, intent(in) :: gamma_only_
  integer, intent(in) :: ngm_,nspin_
  integer, dimension(3,ngm_), intent(in) :: mill_
  integer, dimension(ngm_), intent(in) :: nl_,nlm_
  real(8), intent(in) :: esm_w_
  real(8), intent(in) :: esm_efield_
  integer, intent(in) :: izwall_
  real(8), intent(in) :: z_wall_
  real(8), intent(in) :: bar_height_
  real(8), intent(in) :: bar_width_

  Real(8) :: at12(3)
  Real(8), External :: InnerProd
  
  integer :: i,j
  Real(8) :: a1,a2,cc

  nat = nat_
  if(.not.allocated(tau)) allocate(tau(3,nat))
  if(.not.allocated(upf_zp)) allocate(upf_zp(nat))
  do i=1,nat
     do j=1,3
        tau(j,i) = tau_(j,i)
     enddo
     upf_zp(i) = upf_zp_(i)
  enddo
  alat = alat_
  at = at_
  nr1x = nr1x_
  nr2x = nr2x_
  nr3x = nr3x_
  esm_bc = esm_bc_
  gamma_only = gamma_only_
  ngm = ngm_
  nspin = nspin_
  if(.not.allocated(mill)) allocate(mill(3,ngm))
  if(.not.allocated(nl))   allocate(nl(ngm))
  if(.not.allocated(nlm))  allocate(nlm(ngm))

  mill(:,:) = mill_(:,:)
  nl(:)     = nl_(:)
  nlm(:)    = nlm_(:)

  esm_w      = esm_w_
  esm_efield = esm_efield_

  izwall     = izwall_
  z_wall     = z_wall_
  bar_height = bar_height_
  bar_width  = bar_width_

! calculate parameters
  Call OuterProd( at(1,1), at(1,2), at12 )
  omega = InnerProd( at12, at(1,3) ) * ( alat ** 3 )

!  gew = sqrt(pi/omega/(at(3,3)*alat))

  tpiba2 = ( tpi / alat ) ** 2
  !!$gcutm = dual * ecutwfc / tpiba2

  Call MakeRecLatVec( at, bg )

  nrxx = nr1x * nr2x * nr3x

  allocate(rhog_(ngm,nspin))

  call esm_ggen_2d()

  call esm_gen_vbar()

  return
end subroutine Esm_interface_map_parameters

subroutine Esm_interface_set_tau(tau_)
  use ESM_VARS
  implicit none
  real(kind=8), intent(in), dimension(3,nat) :: tau_
  integer :: i,j
  tau(:,:) = tau_(:,:)
end subroutine Esm_interface_set_tau

subroutine Esm_interface_set_communicator(comm)
  use ESM_VARS
  implicit none
  integer, intent(in) :: comm
  communicator = comm 
end subroutine Esm_interface_set_communicator

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.01)
!
!  SUBROUINE: Renewal_of_OccMat
!
!  AUTHOR(S): T. Yamamoto   June/08/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!   patch 0.1 by K. Tagami @adv    2009/02/04
! 
!   patch 0.1 :  change from m_OP_occ_mat_ao to m_OP_occ_mat_ao_kt
!        
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! =========================================== modified by K. Tagami ========== 5.0
!!subroutine Renewal_of_OccMat( pmode )
subroutine Renewal_of_OccMat( flag_dm, pmode )
! ============================================================================ 5.0

! $Id: Renewal_of_OccMat.F90 376 2014-06-17 07:48:31Z jkoga $
  use m_Files,               only : nfout
  use m_Const_Parameters,   only : SPHERICAL_HARMONICS, ATOMIC_ORBITAL, ON
  use m_Control_Parameters, only : num_projectors, projector_type, sw_hubbard
  use m_Kpoints,            only : kv3
  use m_Charge_Density,     only : m_CD_den_mat
! ============================================ Modified by K. Tagami ======== 0.1
!  use m_Orbital_Population,only  : m_OP_occ_mat_ylm, m_OP_occ_mat_ao &
!       &                         , m_OP_rd_occ_mat 
  use m_Orbital_Population,only  : m_OP_occ_mat_ylm, m_OP_occ_mat_ao &
       &                         , m_OP_rd_occ_mat &
       &                         , m_OP_occ_mat_ao_kt
! =======================================

! ================================= added by K. Tagami ===================== 5.0
  use m_Control_Parameters,      only : occmat_type
  use m_Const_Parameters,       only : OccMat_Type1, OccMat_Type2
! ============================================================================ 5.0

! ================================ added by K. Tagami =============== 11.0
  use m_Control_parameters,    only : noncol
  use m_Orbital_Population,    only  : m_OP_occ_mat_ylm_noncl, &
       &                               m_OP_occ_mat_ao_kt_noncl
! ================================================================== 11.0

  implicit none
  logical, intent(in) :: flag_dm
  integer, intent(in) :: pmode
#ifdef __TIMER_SUB__
  call timer_sta(735)
#endif

! ================================= modified by K. Tagami =============== 5.0
!  if(num_projectors>0 .and. sw_hubbard == ON) then
!     if(projector_type == SPHERICAL_HARMONICS) then
!        !!$write(*,*) "m_CD_occ_mat_ylm"
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ylm(nfout)
!     else if(projector_type == ATOMIC_ORBITAL) then
!!!! ====================================== Modified by K. Tagami ============ 0.1
!!        call m_OP_occ_mat_ao(nfout)
!        call m_OP_occ_mat_ao_kt(nfout)
!! ============================================================
!     end if
!  end if

! ====================== modified by K. Tagami ========== 11.0
  if ( num_projectors>0 .and. sw_hubbard == ON ) then
!     select case ( occmat_type )
!     case ( OccMat_Type1 )
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ylm( nfout, pmode )
!     case ( OccMat_Type2 )
!        if(flag_dm) call m_CD_den_mat(nfout,kv3)
!        call m_OP_occ_mat_ao_kt(nfout, pmode)
!     end select

     if ( noncol ) then
        select case ( occmat_type )
        case ( OccMat_Type1 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ylm_noncl( nfout, pmode )
        case ( OccMat_Type2 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ao_kt_noncl(nfout, pmode)
        end select
     else
        select case ( occmat_type )
        case ( OccMat_Type1 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ylm( nfout, pmode )
        case ( OccMat_Type2 )
           if(flag_dm) call m_CD_den_mat(nfout,kv3)
           call m_OP_occ_mat_ao_kt(nfout, pmode)
        end select
     endif
! ========================================================= 11.0
  end if
! =========================================================================-- 5.0

#ifdef __TIMER_SUB__
  call timer_end(735)
#endif

end subroutine Renewal_of_OccMat

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
  integer, private      :: istat = 0
  integer :: idp, idp2, idp3, nlp, nmp, nnp
  integer :: sw_avoiding_odd_fftbox = ON
  integer :: sw_zero_padding = ON
  real(kind=DP),private,pointer,dimension(:)               :: cfft
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1,cw2,cw3
  real(kind=DP),private,allocatable,dimension(:)           :: trigs_WF, trigs_pWF, trigs_CD
  integer,      private,allocatable,dimension(:)           :: ifax_WF, ifax_pWF, ifax_CD
!
! ------- Positron start
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1_pstrn,cw2_pstrn,cw3_pstrn
  ! ------- Positron end
  real(kind=DP),private,allocatable, dimension(:)          :: ftw
!
  include 'mpif.h'
contains
  subroutine fft_WFCD_work_alloc
    integer :: nid,nnl,nnm,nnn
! ----> work arrays of fft for wave functions
    nid  = fft_box_size_WF(1,0);  nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
    if(ipri >= 1) write(nfout,'(" !!allocation of cw1,cw2,cw3 (fft_WFCD_work_alloc)")')
    if(kimg == 1) then
       allocate(trigs_WF(nnl+2*(nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    else if(kimg == 2) then
       allocate(trigs_WF(2*(nnl+nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT")')
    end if
! ------- Positron start
! ----> and work arrays of fft for positron wave functions
    if(sw_positron /= OFF) then
       nid  = fft_box_size_pWF(1,0);  nnl  = fft_box_size_pWF(1,1)
       nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)

       if(ipri >= 1) write(nfout,'(" !!allocation of cw1_pstrn,cw2_pstrn,cw3_pstrn (fft_WFCD_work_alloc)")')
       if(kimg == 1) then
          allocate(trigs_pWF(nnl+2*(nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       else if(kimg == 2) then
          allocate(trigs_pWF(2*(nnl+nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       end if
    end if
! ------- Positron end

! ----> work arrays of ifft for the charge density
    nid = fft_box_size_CD(1,0);  nnl = fft_box_size_CD(1,1)
    nnm = fft_box_size_CD(2,1);  nnn = fft_box_size_CD(3,1)
    if(kimg == 1) then
          allocate(trigs_CD(nnl+2*(nnm+nnn)), stat=istat)
          allocate(ifax_CD(60), stat=istat)
          if(ipri >= 1) write(nfout,'(" !! CD_ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    else
          allocate(trigs_CD(2*(nnl+nnm+nnn)), stat=istat)
          allocate(ifax_CD(60), stat=istat)
       if(ipri >= 1) &
            & write(nfout,'(" !! trigs_CD and ifax_CD have been allocated, ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    end if
  end subroutine fft_WFCD_work_alloc

  subroutine m_FFT_alloc_WF_work
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_WF(1,0);  nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)

    if(kimg == 1) then
       allocate(ftw(nfft), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfft), stat=istat)
    end if
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_pWF(1,0);  nnl  = fft_box_size_pWF(1,1)
    nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)

    if(kimg == 1) then
       allocate(ftw(nfft_pstrn), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfft_pstrn), stat=istat)
    end if
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
       if(istat /= 0 ) then
          if(ipri>=1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_dealloc_WF_work'
             write(nfout,*) 'stat=', istat
          end if
          stop
       end if
    end if
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_CD(1,0);  nnl  = fft_box_size_CD(1,1)
    nnm  = fft_box_size_CD(2,1);  nnn  = fft_box_size_CD(3,1)
    if(kimg == 1) then
       allocate(ftw(nfftp), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfftp), stat=istat);
    end if
    allocate(afft_CD(nfftp), stat=istat)
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
    end if
    deallocate(afft_CD, stat=istat)
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset
    integer :: nid,nnl,nnm,nnn
    integer :: nfft_t
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)


! --- fft_box_size_WF, fft_box_size_pWF ---
    if(ipri >= 1) write(nfout,*) '!FFT_WF = ASLFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_WF(1,1),4) == 2) then
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 4
       else
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 2
       end if
       fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1) + 1
       if(sw_positron /= OFF) then
          if(mod(fft_box_size_pWF(1,1),4) == 2) then
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 4
          else
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 2
          end if
          fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1) + 1
       end if
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_WF(1:3,0) = fft_box_size_WF(1:3,1) + 1
       if(sw_positron /= OFF) then
          fft_box_size_pWF(1:3,0) = fft_box_size_pWF(1:3,1) + 1
       end if
    endif

! --- fft_box_size_CD ---
    if(ipri >= 1) write(nfout,*) '!FFT_CD = ASLFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_CD(1,1),4) == 2) then
          fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 4
       else
          fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 2
       end if
       fft_box_size_CD(2:3,0) = fft_box_size_CD(2:3,1) + 1
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_CD(1:3,0) = fft_box_size_CD(1:3,1) + 1
    endif

    fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
    nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    nfftps = nfftp

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    idp  = fft_box_size_CD(1,0)
    idp2 = fft_box_size_CD(2,0)
    idp3 = fft_box_size_CD(3,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    nfft_t = nfft
    if(sw_positron /= OFF .and. nfft_t < nfft_pstrn) nfft_t = nfft_pstrn
    if(.not. paramset) then
       if(kimg == 1) then
          call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated
       else if(kimg == 2) then
          call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated
       end if

! Initialization of the Wave-Function FFT
       if(kimg == 1) then
          if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
             call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
          else
             call m_FFT_alloc_WF_work()   ! <ftw> is allocated
          end if
          allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
          if(istat /= 0) then
             if(ipri >= 1) then
                write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat, 'nfft =', nfft
             end if
             stop
          end if
       else if(kimg == 2) then
          if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
             call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
          else
             call m_FFT_alloc_WF_work()   ! <ftw> is allocated
          end if
          allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
          if(istat /= 0) then
             if(ipri >= 1) then
                write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat, 'nfft =', nfft
             end if
             stop
          end if
       end if

       call init_fft_coefficients_arrays_WF()

       if(kimg == 1) then
          call m_FFT_dealloc_WF_work()
          deallocate(cfft,stat=istat)
          if(istat /= 0 ) then
             if(ipri >= 1) then
                write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat
             end if
             stop
          end if
       else if(kimg == 2) then
          call m_FFT_dealloc_WF_work()
          deallocate(cfft, stat=istat)
          if(istat /= 0 ) then
             if(ipri >= 1) then
                write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat
             end if
             stop
          end if
       end if

! Initialization of the Charge-Density FFT
       call CDFFT_setup()
    endif

    call tstatc0_end(id_sname)

  contains
    subroutine init_fft_coefficients_arrays_WF()
      use m_Parallelization,   only : itask
      integer :: id, nl, nm, nn, ierr
      integer :: id_p, nl_p, nm_p, nn_p
      real(kind=DP) :: ftw(nfft+nfft_pstrn)
      integer :: id2, id3, id_p2, id_p3

      id = fft_box_size_WF(1,0)
      id2 = fft_box_size_WF(2,0)
      id3 = fft_box_size_WF(3,0)

      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         id_p = fft_box_size_pWF(1,0)
         id_p2 = fft_box_size_pWF(2,0)
         id_p3 = fft_box_size_pWF(3,0)
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         call qfr3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
              call qfr3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         endif
      else
         call hfc3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
              call hfc3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         end if
      endif
    end subroutine init_fft_coefficients_arrays_WF
  end subroutine m_FFT_setup

  subroutine CDFFT_setup()
    if(kimg == 1) then
       call m_FFT_alloc_CD_box()       ! <ftw> is allocated
    else if(kimg == 2) then
       call m_FFT_alloc_CD_box()       ! <ftw> is allocated
    end if

    call init_fft_coefficients_arrays_CD()
    CD_setup_is_done = YES

    if(kimg == 1) then
       call m_FFT_dealloc_CD_box()
    else if(kimg == 2) then
       call m_FFT_dealloc_CD_box()
    end if
  contains
    subroutine init_fft_coefficients_arrays_CD
      use m_Parallelization,   only : itask
      integer :: id, nl, nm, nn, ierr
      real(kind=DP) :: ftw(nfftp)
      integer :: id2, id3

      !  ---> FFT for Charge density
      id = fft_box_size_CD(1,0)
      id2 = fft_box_size_CD(2,0)
      id3 = fft_box_size_CD(3,0)

      nl = fft_box_size_CD(1,1)
      nm = fft_box_size_CD(2,1)
      nn = fft_box_size_CD(3,1)

      if(kimg == 1) then
         call qfr3fb(nl,nm,nn,afft_CD,id,id2,id3,0,ifax_CD,trigs_CD,ftw,itask,ierr)
      else
         call hfc3fb(nl,nm,nn,afft_CD,id,id2,id3,0,ifax_CD,trigs_CD,ftw,itask,ierr)
      end if
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    use m_Parallelization,       only : itask
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch
    complex(kind=CMPLDP),pointer,dimension(:) :: cw1_t, cw2_t, cw3_t
    integer :: id, nl, nm, nn, ier1 = 0
    real(kind=DP) :: ftw(nfft)
    integer, dimension(2) :: flag_asl_rfft      = (/-1,  1/)
    integer, dimension(2) :: flag_asl_cfft      = (/ 1, -1/)
    integer :: id2, id3
    integer :: isw

    integer :: id_sname = -1
    if(electron_or_positron == ELECTRON) then
       id = fft_box_size_WF(1,0)
       id2 = fft_box_size_WF(2,0)
       id3 = fft_box_size_WF(3,0)
       nl = fft_box_size_WF(1,1)
       nm = fft_box_size_WF(2,1)
       nn = fft_box_size_WF(3,1)
       cw1_t=>cw1; cw2_t=>cw2; cw3_t=>cw3
    else if(electron_or_positron == POSITRON) then
       id = fft_box_size_pWF(1,0)
       id2 = fft_box_size_pWF(2,0)
       id3 = fft_box_size_pWF(3,0)
       nl = fft_box_size_pWF(1,1)
       nm = fft_box_size_pWF(2,1)
       nn = fft_box_size_pWF(3,1)
       cw1_t=>cw1_pstrn; cw2_t=>cw2_pstrn; cw3_t=>cw3_pstrn
    end if

    if(electron_or_positron == ELECTRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
          if(ipri >= 2) write(nfout,*) 'size(afft)=',size(afft)
          if(ipri >= 2) write(nfout,*) 'isw=',isw
          if(ipri >= 2) write(nfout,*) 'nl,nm,nn,id,id2,id3=',nl,nm,nn,id,id2,id3
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = -flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       end if
    else if(electron_or_positron == POSITRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       end if
    end if

    call sxfft_zero_padding(afft,nl,nm,nn,id,id2,id3)

    if (ier1 /= 0) then
       if(ipri>=1) write (nfout,*) ' !!(Error fft) ier1 = ',ier1
       stop
    end if
  end subroutine m_FFT_WF

  subroutine sxfft_zero_padding(afft,nl,nm,nn,nd1,nd2,nd3)
    use m_Const_Parameters, only : DP
    implicit none
    real(kind=DP), intent(out) :: afft(*)
    integer, intent(in) :: nl,nm,nn
    integer, intent(in) :: nd1,nd2,nd3
    integer :: i,j,k,ip
    integer :: nlh,ndh
    integer :: imax
    imax = nd1*nd2*nd3

    if(kimg==1) then
       nlh = nl/2
       ndh = nd1/2
       if(ipri >= 2) write(6,*) 'ASLFFT: nl,ndh=',nlh,ndh
       do j = nlh+2, ndh
          do i = 1, nd2*nn
             ip = ndh*(i-1) + j
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
       do j = nm+1, nd2
          do k = 1, nd3
             do i = 1, ndh
                ip = i + ndh*(j-1) + ndh*nd2*(k-1)
                afft(ip*2-1) = 0.d0
                afft(ip*2) = 0.d0
             end do
          end do
       end do
       do k = nn+1, nd3
          do i = 1, ndh*nd2
             ip = i + ndh*nd2*(k-1)
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
    else if(kimg==2) then
       do j = nl+1, nd1
          do i = 1, nd2*nn
             ip = nd1*(i-1) + j
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
       do j = nm+1, nd2
          do k = 1, nn
             do i = 1, nl
                ip = i + nd1*(j-1) + nd1*nd2*(k-1)
                afft(ip*2-1) = 0.d0
                afft(ip*2) = 0.d0
             end do
          end do
       end do
       do k = nn+1, nd3
          do i = 1, nd1*nd2
             ip = i + nd1*nd2*(k-1)
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
    end if
 end subroutine sxfft_zero_padding

 subroutine fft_CD_inverse_core(afft_CD)
      use m_Parallelization,   only : itask
      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      integer :: isw, ier1

      if(kimg == 1) then
         isw =  1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw = -1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_inverse_core

 subroutine fft_CD_direct_core(afft_CD)
      use m_Parallelization,   only : itask
      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      integer :: isw, ier1

      if(kimg == 1) then
         isw = -1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw =  1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_direct_core

module m_External_Potential
  use m_Control_Parameters, only : sw_external_potential
  use m_Parallelization, only : mpi_comm_group

  implicit none

  ! external point charge
  integer :: natom_ex = 0
  real(8), allocatable, dimension(:,:) :: pos_ex
  real(8), allocatable, dimension(:) :: charge_ex
  real(8), allocatable, dimension(:) :: coulomb_rc
  real(8), allocatable, dimension(:) :: coulomb_rn
  ! external potential (electrostatic potential)
  real(8), allocatable, dimension(:,:) :: espot
  real(8), allocatable, dimension(:,:,:) :: espot_g

  ! temporary
  real(8), dimension(:,:), pointer :: mesh_coord
  real(8) :: mesh_delta(3,3)
  real(8), dimension(:), pointer :: charge_r

contains

  subroutine m_EP_alloc_point_charge
    implicit none

    if( .not. allocated(pos_ex) ) allocate(pos_ex(natom_ex,3))
    if( .not. allocated(charge_ex) ) allocate(charge_ex(natom_ex))
    if( .not. allocated(coulomb_rc) ) allocate(coulomb_rc(natom_ex))
    if( .not. allocated(coulomb_rn) ) allocate(coulomb_rn(natom_ex))

  end subroutine m_EP_alloc_point_charge

  subroutine m_EP_dealloc_point_charge
    implicit none

    if( allocated(pos_ex) ) deallocate(pos_ex)
    if( allocated(charge_ex) ) deallocate(charge_ex)
    if( allocated(coulomb_rc) ) deallocate(coulomb_rc)
    if( allocated(coulomb_rn) ) deallocate(coulomb_rn)

  end subroutine m_EP_dealloc_point_charge
  
  subroutine m_EP_set_point_charge(n,pos,q,rc,rn)
    implicit none
    integer n
    real(8) pos(n,3)
    real(8) q(n)
    real(8) rc(n)
    real(8) rn(n)
    integer i

    natom_ex = n
    call m_EP_alloc_point_charge

    pos_ex = pos
    charge_ex = q
    coulomb_rc = rc
    coulomb_rn = rn

  end subroutine m_EP_set_point_charge
    
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

end module m_External_Potential

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 410 $)
!
!  FUNCTION:  Ending_Time(), ckiter(), ChargeDensity_is_Converged(), 
!             TotalEnergy_is_Divergent(), Forces_are_Converged(), 
!             Already_Converged(), EigenValues_are_Converged(), 
!              AllKpoints_are_Calculated()
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, December/01/2003, May/16/2005,
!                                     June/04/2005, April/10/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
logical function Ending_Time()
! $Id: Convergence_Check.F90 410 2014-10-30 05:20:45Z jkoga $
  use m_Const_Parameters,   only : INITIAL, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  use m_Files,              only : nfstop,nfout,m_Files_open_nfstop,m_Files_close_nfstop
  use m_IterationNumbers,   only : iteration, iteration_ionic, iteration_electronic
  use m_Control_Parameters, only : icond, ifstop, istop, max_total_scf_iteration, max_mdstep &
       &                         , max_TS_iteration_is_given, max_mdstep_is_given, printable &
       &                         , m_CtrlP_ckcput, m_CtrlP_rd_istop
  use m_Parallelization,    only : mype,mpi_comm_group
  implicit none
  include 'mpif.h'                                      ! MPI

  logical  :: torf
  integer :: ierr

  torf = m_CtrlP_ckcput()
  Ending_Time = torf

  if(.not.torf) &
       & Ending_Time = ckiter()           ! -(contained here)
!  call mpi_barrier(mpi_comm_world, ierr)
  call mpi_barrier(mpi_comm_group, ierr)
contains
  logical function ckiter()
    integer :: imax, icaseflag
! --> T. Yamasaki, 14 July 2008
    integer, parameter :: FILE_F_INP = 1, FILE_F_INP_MDSTEP = 2
! <--
    character*8 :: file_cname
    character*9 :: c_iteration
    icaseflag = 0
    ckiter = .false.
    if(icond == INITIAL .or. icond == CONTINUATION) then
       imax = max(iteration, iteration_ionic)
#ifndef _EMPIRICAL_
       if(iteration == 0) imax = 0
#endif
!                                                                                 (max_TS_iteration_is_given, max_mdstep_is_given)
       if(max_TS_iteration_is_given .and. max_mdstep_is_given) then                   ! (.true., .true.)
! --> T. Yamasaki, 07 Aug. 2009
!!$          if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic) then
          if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic-1) then
! <--
             ckiter = .true.
             if(max_total_scf_iteration <= imax) then
                icaseflag = FILE_F_INP
             else
                icaseflag = FILE_F_INP_MDSTEP
             end if
          else if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
          end if
       else if(.not.max_mdstep_is_given) then                                         ! (.true., .false) or (.false., .false)
          if(max_total_scf_iteration <= imax) then
             ckiter = .true.
             icaseflag = FILE_F_INP
          else if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
          end if
       else if(.not.max_TS_iteration_is_given .and. max_mdstep_is_given) then         ! (.false., .true.)
! --> T. Yamasaki, 06 Aug. 2009
!!$          if(max_mdstep <= iteration_ionic) then
          if(max_mdstep <= iteration_ionic-1) then
! <--
             ckiter = .true.
             icaseflag = FILE_F_INP_MDSTEP
          else if(ifstop >= 1 ) then
             ckiter = ckiter_ifstop(imax)
          end if
       end if


!!$       if(max_total_scf_iteration <= imax .or. max_mdstep <= iteration_ionic) then
!!$          ckiter = .true.
!!$          if(max_total_scf_iteration <= imax) then
!!$             icaseflag = FILE_F_INP
!!$          else
!!$             icaseflag = FILE_F_INP_MDSTEP
!!$          end if
!!$       else if(ifstop >= 1) then
!!$          if(mod(imax,ifstop) == 0) then
!!$             call m_Files_open_nfstop
!!$             call m_CtrlP_rd_istop(nfstop)        ! ->istop
!!$             if(istop >= 0 .and. istop <= imax) ckiter = .true.
!!$             call m_Files_close_nfstop
!!$          else
!!$             if(istop >= 0 .and. istop <= imax) ckiter = .true.
!!$          end if
!!$       end if
    else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then

       if(iteration > max_total_scf_iteration) then
          ckiter = .true.
          icaseflag = FILE_F_INP
       else
          imax = max(iteration, iteration_electronic)
!!$          imax = iteration_electronic
!!$       if(imax > ek_max_iteration) then
!!$          ckiter = .true.
!!$       else
!!$          write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
!!$          write(nfout,'("  ifstop = ",i6)') ifstop
          if(ifstop >= 1) then
             ckiter = ckiter_ifstop(imax)
          end if
       end if
    end if
    if(ckiter) then
       if(icaseflag .eq. FILE_F_INP_MDSTEP) then
          file_cname = ' <F_INP>'
          imax = max_mdstep
          c_iteration = ' mdstep  '
       else if(icaseflag .eq. FILE_F_INP) then
          file_cname = ' <F_INP>'
          imax = max_total_scf_iteration
          c_iteration = 'iteration'
       else
          file_cname = '<F_STOP>'
          imax = istop
          c_iteration = 'iteration'
       end if
       if(printable) write(nfout,'(" --- This job stops because the ",a9," has exceeded " &
                              & ,i6," set in the ",a8," file ---")') c_iteration, imax,file_cname
    end if
  end function ckiter

  logical function ckiter_ifstop(imax)
    integer, intent(in) :: imax
    ckiter_ifstop = .false.
    if(mod(imax,ifstop) == 0) then
       call m_Files_open_nfstop
       call m_CtrlP_rd_istop(nfstop)        ! ->istop
       if(istop >= 0 .and. istop <= imax) ckiter_ifstop = .true.
       call m_Files_close_nfstop
    else
       if(istop >= 0 .and. istop <= imax) ckiter_ifstop = .true.
    end if

  end function ckiter_ifstop

end function Ending_Time

#ifndef _EMPIRICAL_
logical function ChargeDensity_is_Converged()
  use m_Files,          only : nfout
  use m_Const_Parameters, only : ON, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, WHOLE, INITIALLY, DP, YES
  use m_Control_Parameters, only : printable, sw_submat_is_on, submat_is_done_this_iter, icond &
       &                     , m_CtrlP_set_renew_wf, sw_hubbard, nspin, m_CtrlP_get_edelta &
       &                     , m_CtrlP_clear_lmm_status_store &
       &                     , max_scf_iteration, max_scf_iteration_is_given
  use m_Charge_Density, only : m_CD_is_converged_core
  use m_Total_Energy,   only : m_TE_is_converged &
      &                      , m_TE_Converged_Hubbard_Energy, m_TE_edeltb
  use m_ES_WF_by_submat,only : m_ESsubmat_dealloc, m_ESsubmat_reset_non_diagon
  use m_Force,          only : m_Force_get_fec_count
  use m_ES_occup,       only : m_ESoc_efermi_diff, m_ESoc_new_total_spin, m_ESoc_total_spin0
  use m_Crystal_Structure,only : sw_fix_total_spin_in, sw_fix_total_spin,spin_fix_period &
       &                     , m_CS_set_total_spin, m_CS_free_fixed_total_spin, m_CS_fix_total_spin
  use m_Ionic_System,   only : natm2
  use m_IterationNumbers, only : iteration_electronic, iteration_ionic

! ====================== added by K. Tagami ======================= 12.0Exp
  use m_Const_Parameters,    only  : ALL_AT_ONCE, EK_CONVERGED
  use m_Control_Parameters,  only : fixed_charge_k_parallel, &
       &                            m_CtrlP_set_iconvergence,xctype
! ================================================================ 12.0Exp

! ====================== KT_Test ========================================= 12.5Exp
  use m_Const_Parameters,    only  : OFF
  use m_Control_Parameters,   only : sw_hybrid_functional, &
       &                             truncate_vxw_updating, sw_update_vxw, oneshot
! ======================================================================== 12.5Exp

  implicit none
  logical, save :: renew_wf_again = .false.
  logical :: EigenValues_are_Converged
  integer ::       fec_counter
!!$  real(kind=DP) :: total_spin_new, m_ESoc_new_total_spin, m_ESoc_efermi_diff &
!!$       &          ,Delta_Efermi
  real(kind=DP) :: total_spin_new, Delta_Efermi
  logical :: totalenergy_is_converged
  real(kind=DP) :: edeltb, edelta
  real(kind=DP),parameter :: delta_efermi_lower = 0.002
  real(kind=DP),parameter :: factor_initial = 10.0
  real(kind=DP),save :: factor = factor_initial

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     if(EigenValues_are_Converged()) then
        ChargeDensity_is_Converged = .true.
! ==================================== added by K. Tagami ============ 12.0Exp
        if ( fixed_charge_k_parallel == ALL_AT_ONCE ) then
           call m_CtrlP_set_iconvergence(EK_CONVERGED)
        endif
! ==================================================================== 12.0Exp
     else
        ChargeDensity_is_Converged = .false.
     end if
     return
  end if

  call m_Force_get_fec_count(fec_counter)
  if(fec_counter /= 0) then
     ChargeDensity_is_Converged = .true.
     if(printable) &
          & write(nfout,'(" !Convergence_Check: fec_counter = ",i8," is not zero")') fec_counter
  else
     if(renew_wf_again) then
        ChargeDensity_is_Converged = .true.
     else
! --> T. Yamasaki 07th Aug. 2009
        totalenergy_is_converged = m_TE_is_converged(nfout)
!!$        if(m_TE_is_converged(nfout)) then
        if(totalenergy_is_converged) then
           if(nspin == 2 .and. sw_fix_total_spin == YES .and. spin_fix_period == INITIALLY) then
              ChargeDensity_is_Converged = .false.
           else
              ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
           end if
! <--
        else
           ChargeDensity_is_Converged = .false.
        endif
! --> T. Yamasaki 06th Aug. 2009
        if(nspin == 2 .and. sw_fix_total_spin == YES .and. spin_fix_period >= INITIALLY) then
! -->       17th Aug. 2009
           if(spin_fix_period.gt.1 .and. iteration_electronic>=spin_fix_period)then
              call m_CS_free_fixed_total_spin(nfout)
           else if(iteration_electronic>=20 .and. spin_fix_period==INITIALLY) then
!!$                 Delta_efermi = m_ESoc_efermi_diff()
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$                 if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
!!$                      &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
!!$                      &               delta_efermi, delta_efermi_lower
!!$                 call m_CS_free_fix_total_spin(nfout) ! sw_fix_total_spin = NO
              edeltb = m_TE_edeltb()
              call m_CtrlP_get_edelta(edelta)
              if(dabs(edeltb) < edelta*natm2*factor) then
                 factor = factor/2.0
                 if(factor < 1.0) factor = 1.0
                 if(printable) write(nfout,'(" dabs(edeltb) = dabs(",f16.12,") < edelta*natm2*factor = ",f16.12)') &
                      & edeltb, edelta*natm2*factor
! -->   
                 if(iteration_ionic >= 10) then   ! This is a test case
! <--
                    Delta_efermi = m_ESoc_efermi_diff()
                    if( dabs(Delta_efermi) < delta_efermi_lower ) then
                       if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
                            &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
                            &               delta_efermi, delta_efermi_lower
                       call m_CS_free_fixed_total_spin(nfout) ! sw_fix_total_spin = NO
                    else
                       if(totalenergy_is_converged) ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
                       if(.not.ChargeDensity_is_Converged) then
                          total_spin_new = m_ESoc_new_total_spin()
                          call m_CS_set_total_spin(nfout,total_spin_new)
                       end if
                    end if
                 else
                    if(totalenergy_is_converged) ChargeDensity_is_Converged = m_CD_is_converged_core(nfout)
                    if(.not.ChargeDensity_is_Converged) then
                       total_spin_new = m_ESoc_new_total_spin()
                       call m_CS_set_total_spin(nfout,total_spin_new)
                    end if
                 end if
              end if
           end if
!!$           if(iteration_electronic>=30 .and. mod(iteration_electronic,10)==1) then
!!$              Delta_efermi = m_ESoc_efermi_diff()
!!$              if(totalenergy_is_converged .and. dabs(Delta_efermi) < delta_efermi_lower ) then
!!$                 if(printable) write(nfout,'(" !** dabs(Delta_efermi) = dabs(",f16.8 &
!!$                      &                        ,") < Delta_efermi_lower = ",f16.8, " and total energy is converged")') &
!!$                      &               delta_efermi, delta_efermi_lower
!!$                 call m_CS_free_fix_total_spin(nfout) ! sw_fix_total_spin = NO
!!$              else
!!$                 total_spin_new = m_ESoc_new_total_spin()
!!$                 call m_CS_set_total_spin(nfout,total_spin_new)
!!$              end if
!!$           end if
! <--
        end if
! <--
     end if

! =========================== KT_Test ================= 12.5Exp
     if ( sw_hybrid_functional == ON ) then
        if ( truncate_vxw_updating .and. sw_update_vxw == OFF ) then
           ChargeDensity_is_Converged = .true.
        end if
     end if
! ====================================================== 12.5Exp

     if(sw_hubbard == ON) then
        if(m_TE_Converged_Hubbard_Energy(nfout)) then
           ChargeDensity_is_Converged = .true.
        end if
     end if

! --> T. Yamasaki, 18th Aug. 2009
     if(max_scf_iteration_is_given) then
        if(iteration_electronic >= max_scf_iteration) then
           ChargeDensity_is_Converged = .true.
        end if
     end if
! <--
     if(ChargeDensity_is_Converged) then
        if(renew_wf_again) then
           renew_wf_again = .false.
           call m_ESsubmat_dealloc()
        else if(sw_submat_is_on .and. .not.renew_wf_again) then
           if(.not.submat_is_done_this_iter) then
              if(printable) write(nfout,'(" !! sw_submat_is_on = .true. and renew_wf_again = .false.")')
              ChargeDensity_is_Converged = .false.
              renew_wf_again = .true.
              call m_ESsubmat_reset_non_diagon()
           end if
        else ! if(.not.sw_submat_is_on .and. .not.renew_wf_again) then
           call m_ESsubmat_dealloc()
        end if
! --> T. Yamasaki, 17th Aug. 2009
        if(nspin == 2 .and. sw_fix_total_spin_in == YES .and. spin_fix_period == INITIALLY) then
           call m_CS_fix_total_spin(nfout)
           total_spin_new = m_ESoc_total_spin0()
           call m_CS_set_total_spin(nfout,total_spin_new)
           factor = factor_initial
        end if
! <--
        call m_CtrlP_clear_lmm_status_store() ! --> T. Yamasaki, 18th Aug. 2009
#ifndef DISABLE_VDWDF
        if(xctype == 'vdwdf'.and.oneshot) call vdW_oneshot()
#endif
     end if
     call m_CtrlP_set_renew_wf(renew_wf_again)
  end if
end function ChargeDensity_is_Converged

logical function TotalEnergy_is_Divergent()
  use m_Total_Energy, only : m_TE_is_Divergent_core
  use m_Files,        only : nfout
! --> T. Yamasaki, 22nd July 2008
  use m_Control_Parameters,only : ipri,m_CtrlP_etot_1dsrch_divergent
  use m_IterationNumbers,  only : iteration_ionic, iteration_electronic
  implicit none
  TotalEnergy_is_Divergent = m_TE_is_Divergent_core(nfout)
  if(iteration_ionic > 1 .and. .not.TotalEnergy_is_Divergent) then
     TotalEnergy_is_Divergent = m_CtrlP_etot_1dsrch_divergent(iteration_electronic)
     if(TotalEnergy_is_Divergent) then
        if(ipri >= 1) write(nfout,'(" m_CtrlP_etot_1dsrch_divergent is .true.")')
     end if
  end if
! <--
end function TotalEnergy_is_Divergent

#endif

logical function AllForces_are_Converged()
  AllForces_are_Converged = .true.
end function AllForces_are_Converged

logical function Forces_are_Converged()
  use m_Control_Parameters, only : imdalg, ipriforce, icond, sw_phonon_oneshot &
       &                         , m_CtrlP_set_iconvergence &
       &                         , m_CtrlP_what_is_mdalg,sw_optimize_lattice &
#ifndef _EMPIRICAL_
       &                         , m_CtrlP_renew_edelta_ontheway, m_CtrlP_edelta_final &
       &                         , m_CtrlP_reset_edelta_ontheway
#else
       &                         , m_CtrlP_renew_edelta_ontheway, m_CtrlP_edelta_final
#endif
  use m_Const_Parameters,   only : DP,QUENCHED_CONSTRAINT,BLUEMOON &
       &                         , TEMPERATURE_CONTROL, FORCE_CONVERGED &
       &                         , VERLET, CNSTRA, ORDINA, WITHOUTTAG &
       &                         , WITHTAG, PHONON_FORCE &
       &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, INITIAL, OFF
  use m_Files,              only : nfout
  use m_IterationNumbers,   only : iteration_ionic,iteration,iteration_electronic
  use m_Ionic_System,       only : constraints_exist, move_constrained_plane &
       &                         , ekina,ega,almda,mdmode &
       &                         , forcmx_constraint_quench, cps, natm &
       &                         , m_IS_force_check_md_cnstr &
       &                         , m_IS_set_mdmode_cnstra &
       &                         , m_IS_set_mdmode_ordina &
       &                         , m_IS_evaluate_v_verlet &
! --> T. Yamasaki, 18 July 2008
       &                         , m_IS_cnstr_is_fixed_nhp &
       &                         , m_IS_force_check_md_nhp 
! <--
#ifndef _EMPIRICAL_
  use m_Phonon,             only : m_Phonon_Check_iteration
#endif
  use m_Force,              only : forcmx, forc_l &
       &                         , m_Forces_are_Converged_core
!!$       &                         , m_Forces_clear_fec_counter
  use m_Total_Energy,       only : etotal

  implicit none
  integer :: mdalg

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     Forces_are_Converged = .true.
     return
  end if

  if(imdalg == QUENCHED_CONSTRAINT) then
     if(constraints_exist .and. move_constrained_plane) then
        if(m_IS_force_check_md_cnstr() .and. m_CtrlP_edelta_final()) then
           call m_IS_set_mdmode_cnstra()
#ifndef _EMPIRICAL_
           call m_CtrlP_reset_edelta_ontheway()
#endif
        else
           call m_IS_set_mdmode_ordina()
        end if
        Forces_are_Converged = .false.
     else
        call m_IS_set_mdmode_ordina()
        Forces_are_Converged = m_IS_force_check_md_cnstr()
        if(.not.m_CtrlP_edelta_final()) Forces_are_Converged = .false.
        if(ipriforce >= 3)  then
           if(Forces_are_Converged) then
              write(nfout,'(" Forces_are_Converged(2) = .true.")')
           else
              write(nfout,'(" Forces_are_Converged(2) = .false.")')
           end if
        end if
     end if
  else if(imdalg == TEMPERATURE_CONTROL .or. imdalg == VERLET) then
     Forces_are_Converged = .false.
#ifndef _EMPIRICAL_
  else if(imdalg == PHONON_FORCE) then
     if(sw_phonon_oneshot == ON) then
        Forces_are_Converged = .true.
     else
        Forces_are_Converged = m_Phonon_Check_iteration(iteration_ionic)
	icond = INITIAL  ! asms
     end if
#endif
  else if(imdalg /= BLUEMOON) then
     if(constraints_exist .and. move_constrained_plane) then
        if(m_Forces_are_Converged_core() .and. m_CtrlP_edelta_final()) then ! This is a different
           !                                                                  line to the case of
           !                                                                 (imdalg == 
           !                                                                   QUENCHED_CONSTRAINT). 
           call m_IS_set_mdmode_cnstra()
#ifndef _EMPIRICAL_
           call m_CtrlP_reset_edelta_ontheway()
#endif
        else
           call m_IS_set_mdmode_ordina()
        end if
        Forces_are_Converged = .false.
!  --> T. Yamasaki, 18 July 2008
     else if(constraints_exist .and. m_IS_cnstr_is_fixed_nhp()) then
        if(m_IS_force_check_md_nhp()) then
           Forces_are_Converged = .true.
        else
           Forces_are_Converged = .false.
        end if
! <--
     else
        call m_IS_set_mdmode_ordina()
        Forces_are_Converged = m_Forces_are_Converged_core()
        if(.not.m_CtrlP_edelta_final()) Forces_are_Converged = .false.
     end if
  end if
  if(Forces_are_Converged) call m_CtrlP_set_iconvergence(FORCE_CONVERGED)
  mdalg = m_CtrlP_what_is_mdalg()

  if(Forces_are_Converged) then
!!$     call m_Forces_clear_fec_counter()
     if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)

     call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm
     if(sw_optimize_lattice==OFF) call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfenf
#ifndef _EMPIRICAL_
     call m_CtrlP_reset_edelta_ontheway()
#endif
  else
     if(imdalg /= BLUEMOON .and. imdalg /= TEMPERATURE_CONTROL &
          & .and. imdalg /= VERLET .and. imdalg /= PHONON_FORCE) then 
        if(imdalg /= QUENCHED_CONSTRAINT) then
           call m_CtrlP_renew_edelta_ontheway(nfout,etotal,forcmx,iteration_ionic,iteration,iteration_electronic)
        else if(imdalg == QUENCHED_CONSTRAINT) then
           call m_CtrlP_renew_edelta_ontheway(nfout,etotal,forcmx_constraint_quench,iteration_ionic,iteration,iteration_electronic)
        end if
     end if
  end if
end function Forces_are_Converged

logical function UnitCell_Converged(force_converged)
   use m_Control_Parameters, only : sw_optimize_lattice,imdalg,m_CtrlP_reset_iconvergence,icond
   use m_Const_Parameters, only : OFF,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION
   use m_UnitCell, only : m_UC_converged
   implicit none
   logical, intent(in) :: force_converged
   if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
      UnitCell_Converged = .true.
      return
   endif
   if(sw_optimize_lattice==OFF)then
      UnitCell_Converged = force_converged
      return
   endif
   UnitCell_Converged = m_UC_converged()
   if(force_converged) call wd_forces_cps_etotal_and_etc(imdalg,.false.) ! nfenf
   if(.not.UnitCell_Converged) call m_CtrlP_reset_iconvergence()
end function UnitCell_Converged


subroutine wd_forces_cps_etotal_and_etc(mdalg,flag_dynm)
  use m_Const_Parameters,   only : DP,QUENCHED_CONSTRAINT, BLUEMOON &
       &                         , TEMPERATURE_CONTROL &
       &                         , VERLET, CNSTRA, WITHOUTTAG &
       &                         , WITHTAG, OFF, ON
  use m_Files,              only : nfout, nfenf, nfdynm, m_Files_flush_nfdynm, m_Files_flush_nfenf, nfdynm_cif
  use m_IterationNumbers,   only : iteration_ionic,iteration,iteration_electronic,iteration_unit_cell
  use m_Parallelization,    only : mype
  use m_Control_Parameters, only : ipriforce, iprivelocity &
       &                         , m_CtrlP_flag_wd_force &
       &                         , m_CtrlP_set_flag_wd_force_1 &
       &                         , sw_optimize_lattice &
       &                         , sw_cif_output, xctype, printable
  use m_Force,              only : forcmx &
       &                         , m_Force_wd_force_and_cps &
       &                         , m_Force_wd_force_cps_cpd &
!!$       &                         , m_Force_cal_absforc &
       &                         , m_Force_wd_force_and_cps_lim &
       &                         , m_Force_wd_force_cps_cpd_lim
  use m_Ionic_System,       only : ekina,ega,almda,mdmode &
       &                         , forcmx_constraint_quench, cps,cpd_l,natm &
       &                         , constraints_exist, forcmx_hyperplane_vert &
       &                         , m_IS_cnstr_is_fixed_nhp &
       &                         , m_IS_wd_speciesname_etc &
       &                         , m_IS_dump_cif
  use m_Total_Energy,       only : etotal
  use m_Stress,             only : m_Stress_get_stressmx
  use m_XC_Potential,       only : ecor

  implicit none
  integer, intent(in) :: mdalg
  logical, intent(in) :: flag_dynm

  integer, parameter :: N_FORC = 10

  integer :: flag_wd_force

  if(flag_dynm) then
     flag_wd_force = m_CtrlP_flag_wd_force()
     call wd_forces_and_cps(flag_wd_force)
     if(flag_wd_force == 0) call m_CtrlP_set_flag_wd_force_1()
  else
     call wd_etotal_etc()
  end if

contains
    subroutine wd_etotal_etc
    integer        :: wd_flag = 0
    real(kind=DP)  :: econst
    real(kind=DP)  :: stressmx
    real(kind=DP)  :: big=10000000.d0
    if(wd_flag == 0) then
       if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter_total, etotal, ekina, econst, forcmx'
       else if(mdalg == BLUEMOON) then
          if(mype == 0) write(nfenf,*) &
               & ' iter_ion, iter,etotal,ekina,econst,almda,forcmx'
       else
          if(sw_optimize_lattice==OFF)then
          if(mype == 0) write(nfenf,*) ' iter_ion, iter_total, etotal, forcmx'
          else
          if(mype == 0) write(nfenf,*) ' iter_unitcell, iter_ion, iter_total, etotal, forcmx, stressmx'
          endif
       end if
       wd_flag = 1
    end if
    if(xctype=='ggapbey')then
       if(printable) then
          write(nfout,'(a)') ' !** subtracting the correlation energy from the total energy'
          write(nfout,'(a)') ' !** since xctype is ggapbey '
       endif
       etotal = etotal-ecor
    endif
    if(mdalg == VERLET .or. mdalg == TEMPERATURE_CONTROL) then
       if(mdalg == TEMPERATURE_CONTROL) then
          econst = etotal + ega
       else
          econst = etotal + ekina
       end if
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",i5,i8,4f20.10,"  converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx
             else
             write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10," ",f0.10," ",f0.10,"  converged_in_a_plane")') &
                  & iteration_ionic, iteration, etotal, ekina, econst,  forcmx
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",i5,i8,4f20.10)') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx
             else
             write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10," ",f0.10," ",f0.10)') iteration_ionic, iteration &
                  &, etotal, ekina, econst,  forcmx
             endif
          end if
       end if
    else if(mdalg == BLUEMOON) then
       econst = etotal + ega
       if(mype == 0) then
            if(abs(etotal)<big)then
            write(nfenf,'(" ",i5,i8,5f20.8)') iteration_ionic, iteration &
            &, etotal, ekina, econst, almda, forcmx
            else
            write(nfenf,'(" ",i5,i8," ",f0.8," ",f0.8," ",f0.8," ",f0.8," ",f0.8)') iteration_ionic, iteration &
            &, etotal, ekina, econst, almda, forcmx
            endif
       endif
    else if(mdalg == QUENCHED_CONSTRAINT) then
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",i5,i8,2f20.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             else
             write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             endif
          else
             if(abs(etotal)<big)then
             write(nfenf,'(" ",i5,i8,2f20.10)') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             else
             write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10)') iteration_ionic, iteration &
                  &, etotal, forcmx_constraint_quench
             endif
          end if
       end if
    else
       if(mype == 0) then
          if(mdmode == CNSTRA) then
             if(abs(etotal)<big)then
             write(nfenf,'(" ",i5,i8,2f20.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx
             else
             write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10," converged_in_a_plane")') iteration_ionic, iteration &
                  &, etotal, forcmx
             endif
          else
             if(sw_optimize_lattice==OFF)then
!  --> T. Yamasaki, 18 July 2008
             if(constraints_exist .and. m_IS_cnstr_is_fixed_nhp() &
                  & .and. forcmx_hyperplane_vert < forcmx ) then
                if(abs(etotal)<big)then
                write(nfenf,'(" ",i5,i8,2f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx_hyperplane_vert
                else
                write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10)') iteration_ionic, iteration &
                     &, etotal, forcmx_hyperplane_vert
                endif
             else
                if(abs(etotal)<big)then
                write(nfenf,'(" ",i5,i8,2f20.10)') iteration_ionic, iteration &
                     &, etotal, forcmx
                else
                write(nfenf,'(" ",i5,i8," ",f0.10," ",f0.10)') iteration_ionic, iteration &
                     &, etotal, forcmx
                endif
             end if
!  <--
             else
                stressmx = m_Stress_get_stressmx()
                if(stressmx>=0) then
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",i5,i5,i8,3f20.10)') iteration_unit_cell, iteration_ionic, iteration &
                       &, etotal, forcmx,stressmx
                  else
                  write(nfenf,'(" ",i5,i5,i8," ",f0.10," ",f0.10," ",f0.10)') iteration_unit_cell, iteration_ionic, iteration &
                       &, etotal, forcmx,stressmx
                  endif
                else
                  if(abs(etotal)<big)then
                  write(nfenf,'(" ",i5,i5,i8,2f20.10)') iteration_unit_cell, iteration_ionic, iteration &
                       &, etotal, forcmx
                  else
                  write(nfenf,'(" ",i5,i5,i8," ",f0.10," ",f0.10)') iteration_unit_cell, iteration_ionic, iteration &
                       &, etotal, forcmx
                  endif
                endif
             endif
          end if
       end if
    end if
    call m_Files_flush_nfenf()

  end subroutine wd_etotal_etc

  subroutine wd_forces_and_cps(flag_wd_force)
!
! (iprivelocity)
!    Modified by T. Yamasaki, April/10/2007
! 
    integer, intent(in) :: flag_wd_force
    character(len=256) :: ch
!!$    real(kind=DP) :: forc_lower

    if(flag_wd_force == 0) then
       call m_IS_wd_speciesname_etc(nfdynm)
    end if

    if(mype == 0 .and. iprivelocity <= 1) then
       if(mdmode == CNSTRA) then
          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
               & ,i5,i8," ) converged_in_a_plane")') iteration_ionic, iteration
       else
          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
               & ,i5,i8," )")') iteration_ionic, iteration
       end if
    else if(mype == 0 .and. iprivelocity >= 2) then
       if(mdmode == CNSTRA) then
          write(nfdynm,'(" cps cpd and forc at (iter_ion, iter_total = " &
               & ,i5,i8," ) converged_in_a_plane")') iteration_ionic, iteration
       else
          write(nfdynm,'(" cps cpd and forc at (iter_ion, iter_total = " &
               & ,i5,i8," )")') iteration_ionic, iteration
       end if
    end if

    if(iprivelocity <= 1.and.mype==0) then
       call m_Force_wd_force_and_cps(nfdynm, WITHOUTTAG, cps, natm)
    else if(iprivelocity >= 2.and.mype==0) then
       call m_Force_wd_force_cps_cpd(nfdynm, WITHOUTTAG,cps,cpd_l,natm)
    end if

    if(mype==0.and.sw_cif_output==ON)then
       write(ch,*) iteration_ionic
       call m_IS_dump_cif(nfdynm_cif,'iteration_ionic_'//trim(adjustl(ch)))
    endif

    call m_Files_flush_nfdynm()

    if(ipriforce >= 1) then
       if(mype == 0 .and. iprivelocity <= 1) then
          write(nfout,'(" !forc cps and forc at (iter_ion, iter_total = " &
               & ,i5,i8," )")') iteration_ionic, iteration
       else if(mype == 0 .and. iprivelocity >= 2) then
          write(nfout,'(" !forc cps cpd and forc at (iter_ion, iter_total = " &
               & ,i5,i8," )")') iteration_ionic, iteration
       end if
    end if
#ifdef _DEBUG_WRITE_
    if(ipriforce >= 1) then
#else
    if(ipriforce == 1 .and. natm > N_FORC) then
!!$       call m_Force_cal_absforc(N_FORC, forc_lower)
!!$       write(nfout,'(" forc_lower = ",e12.4)') forc_lower
       if(iprivelocity <= 1) then
          call m_Force_wd_force_and_cps_lim(nfout, WITHTAG, cps, natm, N_FORC)
       else if(iprivelocity >= 2) then
          call m_Force_wd_force_cps_cpd_lim(nfout, WITHTAG, cps,cpd_l,natm, N_FORC)
       end if
    else if(ipriforce >= 2 .or. (ipriforce == 1 .and. natm <= N_FORC) ) then
#endif
       if(iprivelocity <= 1) then
          call m_Force_wd_force_and_cps(nfout, WITHTAG, cps, natm)
       else if(iprivelocity >= 2) then
          call m_Force_wd_force_cps_cpd(nfout, WITHTAG, cps,cpd_l,natm)
       end if
    end if

  end subroutine wd_forces_and_cps

end subroutine wd_forces_cps_etotal_and_etc

#ifndef _EMPIRICAL_
logical function Force_errors_are_tolerable()
  use m_Const_Parameters,   only : OFF, ON
  use m_Files,              only : nfout
  use m_Control_Parameters, only : force_error_check_mode &
       &                         , force_error_check_rangeL, sw_phonon
!!$       &                         , m_CtrlP_what_is_mdalg
  use m_Force,              only : forcmx, m_Force_error_tolerable &
       &                         , m_Force_clear_fec_counter

  implicit none
!!$  integer :: mdalg

!!$  if(force_error_check_mode == OFF .or. forcmx < force_error_check_rangeL) then
  if(sw_phonon == ON .or. force_error_check_mode == OFF .or. forcmx < force_error_check_rangeL) then
     Force_errors_are_tolerable = .true.
     ! --> T. Yamasaki, August 8 2008
     call m_Force_clear_fec_counter()
     ! <--
  else
     if(m_Force_error_tolerable(nfout)) then
        Force_errors_are_tolerable = .true.
     else
        Force_errors_are_tolerable = .false.
     end if
  end if
  
!!$  mdalg = m_CtrlP_what_is_mdalg()
!!$  if(Force_errors_are_tolerable) call wd_forces_cps_etotal_and_etc(mdalg)
end function Force_errors_are_tolerable
#endif

logical function Already_Converged()
  use m_Control_Parameters, only : iconvergence_previous_job &
      &                          , sw_phonon, sw_calc_force, max_total_scf_iteration
  use m_Const_Parameters, only :   FORCE_CONVERGED
  implicit none
  if(iconvergence_previous_job >= FORCE_CONVERGED) then
     Already_Converged = .true.
  else
     Already_Converged = .false.
  end if
  if(sw_phonon == 1 .and. sw_calc_force == 0) Already_Converged = .true.
  if(max_total_scf_iteration <= 0) Already_Converged = .true.
end function Already_Converged

logical function MultiReplicaMode()
  use m_Control_Parameters, only  : multiple_replica_mode
  use m_Ionic_System,       only  : number_of_replicas
  use m_Const_Parameters, only    : ON
  if(multiple_replica_mode == ON .and. number_of_replicas >= 2) then
     MultiReplicaMode = .true.
  else
     MultiReplicaMode = .false.
  end if
end function MultiReplicaMode

#ifndef _EMPIRICAL_
logical function EigenValues_are_Converged()
  use m_Const_Parameters,     only : EK, SCF,GRID, ON, YES, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                           , ONE_BY_ONE, OFF
  use m_Control_Parameters,   only : ekmode,nspin,neg,max_total_scf_iteration,ipri,ipriekzaj,iprievdff &
       &                           , ek_max_iteration, sw_berry_phase, sw_ekzaj, printable, icond &
       &                           , fixed_charge_k_parallel
  use m_IterationNumbers,     only : iteration_electronic, iteration, nk_converged &
       &                           , m_Iter_set_converged_nk, nkgroup, nk_in_the_process
  use m_Files,                only : nfout, nfeng, nfzaj &
       &                           , m_Files_open_nfzaj_with_check
  use m_Kpoints,              only : kv3_ek, kv3
  use m_Parallelization,      only : nrank_k, npes, ierr, mype, mpi_comm_group
  use m_Electronic_Structure, only : m_ES_eekdif, m_ES_eekdif2 &
       &                           , m_ES_cp_eko_l_to_eko_ek &
       &                           , m_ES_cp_eko_l_to_eko_ek2 &
       &                           , m_ES_wd_eko

  use m_ES_IO,                only : m_ESIO_wd_WFs_and_EVs_ek
  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_BerryPhase,           only : m_BP_write_wfbp, m_BP_write_wfbp_gshift

  implicit none
  include 'mpif.h'                                      ! MPI
  integer :: ipri0, kv3_t

  if(ekmode == OFF .and. &
       & (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) &
       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
     EigenValues_are_Converged = m_ES_eekdif2()
!!$     if(nrank_k >= 2) then
!!$        call m_ESIO_wd_EigenValues(nfout,iprievdff,nooccupation=YES)
!!$     end if
  else     
     EigenValues_are_Converged = m_ES_eekdif()
  end if

  if(sw_ekzaj==ON .and. ekmode==ON ) EigenValues_are_Converged = .true.

  if(EigenValues_are_Converged) then
!!$     if(nk_in_the_process >= kv3_ek) stop ' nk_in_the_process >= kv3_ek <<Eigenvalues_are_converged>>'
     if(printable) write(nfout,'(" Wave Functions have converged at ",i7," -th iteration")') iteration_electronic

! ===================== modified by K. Tagami ========================= 12.0Exp
!     if(nk_converged == 0 .and. mype==0) then
!!!$     write(nfeng,'(" nk_converged = ",i6)') nk_converged
!        write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!        write(nfeng,'(" num_bands   = ",i6)') neg
!        write(nfeng,'(" nspin       = ",i6)') nspin
!        write(nfeng,'(" Fermi energy level = "/)')
!     end if
!
     if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
        if (nk_converged == 0 .and. mype==0) then
           write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
           write(nfeng,'(" num_bands   = ",i6)') neg
           write(nfeng,'(" nspin       = ",i6)') nspin
           write(nfeng,'(" Fermi energy level = "/)')
        end if
     else
        if (nk_converged == 0 .and. mype==0) then
           write(nfeng,'(" num_kpoints = ",i6)') kv3
           write(nfeng,'(" num_bands   = ",i6)') neg
           write(nfeng,'(" nspin       = ",i6)') nspin
           write(nfeng,'(" Fermi energy level = "/)')
        end if
     endif
! ==================================================================== 12.0Exp

     if(ekmode == ON) then
! === DEBUG by tkato 2013/10/18 ================================================
!       call m_ES_cp_eko_l_to_eko_ek()
        call m_ES_cp_eko_l_to_eko_ek2()
! ==============================================================================
     else if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
           fixed_charge_k_parallel == ONE_BY_ONE) then
        call m_ES_cp_eko_l_to_eko_ek2()
     end if

     if(nrank_k >= 2) then
        call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=YES)
     else
        call m_ES_wd_eko(nfout,mode=EK)
        call m_ES_wd_eko(nfeng,mode=EK)
     end if
!!$     if(nk_in_the_process >= kv3_ek) stop ' nk_in_the_process >= kv3_ek (2)<<Eigenvalues_are_converged>>'
  else if(iteration_electronic >= ek_max_iteration) then
!!$       & .or. iteration >= max_total_scf_iteration ) then
     if(ekmode == ON) then
! === DEBUG by tkato 2013/10/18 ================================================
!       call m_ES_cp_eko_l_to_eko_ek()
!       write(nfout,'(" m_ES_cp_eko_l_to_eko_ek")')
        call m_ES_cp_eko_l_to_eko_ek2()
! ==============================================================================
     else if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
           fixed_charge_k_parallel == ONE_BY_ONE) then
        call m_ES_cp_eko_l_to_eko_ek2()
!!$        write(nfout,'(" m_ES_cp_eko_l_to_eko_ek2")')
     end if
     if(mype == 0) then
        write(nfout,'(" Wave Functions have not converged")')
        write(nfout,'(" iteration_electronic reached to ek_max_iteration (= ",i5," )")') ek_max_iteration
     end if
     if(nrank_k >= 2) then
        call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=YES)
     else
        call m_ES_wd_eko(nfout,mode=EK)
        call m_ES_wd_eko(nfeng,mode=EK)
     end if
     EigenValues_are_Converged = .true.
!!$     if(iteration >= max_total_scf_iteration) write(nfout,'(" iteration has reached to max_total_scf_iteration")')
     if(iteration_electronic >= ek_max_iteration .and. mype==0) & 
      & write(nfout,'(" iteration_electronic has reached to ek_max_iteration")')
  end if

! ============================== added by K. Tagami =============== 12.0Exp
  if ( fixed_charge_k_parallel /= ONE_BY_ONE ) return
! ================================================================= 12.0Exp

  if(EigenValues_are_Converged) then
     if(ipri >= 2) write(nfout,'(" ipriekzaj = ",i8," <<EigenValues_are_Converged>>")') ipriekzaj
     if(ipriekzaj >= 1 .and. ekmode /= GRID .and. sw_ekzaj/=ON) then
        call m_Files_open_nfzaj_with_check()
        call m_ESIO_wd_WFs_and_EVs_ek(nfout,nfzaj)
     end if
     if(sw_berry_phase == 1) then
        call m_BP_write_wfbp_gshift ! for the initial k-point of a strig
        call m_BP_write_wfbp
     end if
!!$     call m_Iter_set_converged_nk(nspin)
     kv3_t = min(kv3, kv3_ek-kv3*(nkgroup-1))
     call m_Iter_set_converged_nk(kv3_t)
  else
     ipri0 = iprievdff
!!$     if(nrank_k>=2) call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
     if(npes>=2)    call mpi_bcast(ipri0,1,mpi_integer,0,mpi_comm_group,ierr)
     if((ipri0 >= 1 .and. mod(iteration_electronic,10)==1) &
          .or. ipri0 >= 2 ) then
        if(printable) write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
        if(nrank_k >= 2) then
           call m_ESIO_wd_EigenValues(nfout,2,nooccupation=YES)
        else
           call m_ES_wd_eko(nfout,mode=EK)
        end if
     end if
  end if
end function EigenValues_are_Converged

logical function AllKpoints_are_Calculated()
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_converged, m_Iter_nk_incre2
  use m_Control_Parameters, only : nspin, ipri, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek

  AllKpoints_are_Calculated = .false.
  if(ipri >= 2) write(nfout,'(" !!! nk_converged = ",i8)') nk_converged
  if(nk_converged+nspin-1 >= kv3_ek) then
     AllKpoints_are_Calculated = .true.
     if(ipri >= 1) write(nfout,'(" All kpoints have been calculated ")')
  end if
  if(AllKpoints_are_Calculated) then
     call m_CtrlP_set_iconvergence(EK_CONVERGED)
     call m_Iter_nk_incre2(nspin,kv3_ek)
  end if
end function AllKpoints_are_Calculated

logical function AllKpoints_are_Converged()
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_in_the_process
  use m_Control_Parameters, only : ipri, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek

  AllKpoints_are_Converged = .false.
  if(nk_in_the_process > kv3_ek) then
     AllKpoints_are_Converged = .true.
     if(ipri >= 1) write(nfout,'(" All Kpoints have been converged")')
  end if
  if(AllKpoints_are_Converged) call m_CtrlP_set_iconvergence(EK_CONVERGED)
end function AllKpoints_are_Converged

logical function AllKpoints_are_Calculated2(nk)
  use m_Files,              only : nfout
  use m_Const_Parameters,   only : EK_CONVERGED
  use m_IterationNumbers,   only : nk_converged, nk_in_the_process, m_Iter_nk_incre2
  use m_Control_Parameters, only : ipri, nspin, m_CtrlP_set_iconvergence
  use m_Kpoints,            only : kv3_ek, kv3

  integer, intent(inout) :: nk

  nk = nk + kv3
  if(ipri >= 1) write(nfout,'(" nk, nk_in_the_process = ",2i8)') nk,nk_in_the_process
!!$  if(nk >= kv3_ek) then
!!$  if(nk_in_the_process >= kv3_ek) then
!!$  if(nk_in_the_process+kv3 >= kv3_ek) then
  if(nk_converged >= kv3_ek) then
     AllKpoints_are_Calculated2 = .true.
     call m_Iter_nk_incre2(nspin,kv3_ek) !-> nk_in_the_process
  else
     AllKpoints_are_Calculated2 = .false.
  end if
  if(AllKpoints_are_Calculated2) call m_CtrlP_set_iconvergence(EK_CONVERGED)
end function AllKpoints_are_Calculated2

subroutine Set_converged_nk()
  use m_IterationNumbers,   only : m_Iter_set_converged_nk
  use m_Control_Parameters, only : nspin
  call m_Iter_set_converged_nk(nspin)
end subroutine Set_converged_nk

logical function Already_Converged2()
  ! coded by T. Yamasaki, 31 May 2007
  use m_Const_Parameters, only : FORCE_CONVERGED
  use m_Control_Parameters, only : iconvergence, iconvergence_previous_job
  if(iconvergence >= FORCE_CONVERGED .or. iconvergence_previous_job >= FORCE_CONVERGED) then
     Already_Converged2 = .true.
  else
     Already_Converged2 = .false.
  end if
end function Already_Converged2

logical function Already_Converged_for_kgroup()
  use m_Kpoints, only           : kv3_ek, kv3
  use m_IterationNumbers, only  : nkgroup, nk_in_the_process
  use m_Control_Parameters,only : ipri,nspin
  use m_Const_Parameters, only  : EK_CONVERGED
  use m_Electronic_Structure, only : iconv_ek
  use m_Files, only             : nfout
  integer :: i
  Already_Converged_for_kgroup = .true.
  do i = nk_in_the_process, min(nk_in_the_process + kv3, kv3_ek)
     if(iconv_ek(i) < EK_CONVERGED) then
        Already_Converged_for_kgroup = .false.
        exit
     end if
  end do
  if(ipri >= 2 .and. .not.Already_Converged_for_kgroup) then
     write(nfout,'(" -- Convergence status for ek --")')
     write(nfout,'(40i2)') (iconv_ek(i),i=nk_in_the_process, min(nk_in_the_process+kv3,kv3_ek))
  end if
!!$  if(Already_Converged_for_kgroup) call m_Iter_nkgroup_incre() !-> nk_in_the_process
end function Already_Converged_for_kgroup

logical function Positron_Bulk()
  ! Coded by T. Yamasaki, 29 Oct. 2003
  use m_Const_Parameters, only :   BULK
  use m_Control_Parameters, only : sw_positron
  if(sw_positron == BULK) then
     Positron_Bulk = .true.
  else
     Positron_Bulk = .false.
  end if
end function Positron_Bulk

logical function Positron_Defect()
  ! Coded by T. Yamasaki, 11 Dec. 2005
  use m_Const_Parameters, only :   DEFECT
  use m_Control_Parameters, only : sw_positron
  if(sw_positron == DEFECT) then
     Positron_Defect = .true.
  else
     Positron_Defect = .false.
  end if
end function Positron_Defect

logical function Structure_is_fixed()
  ! Coded by T. Yamasaki, 25 Jul. 2008
  use m_Const_Parameters, only :   ON, VERLET
  use m_Control_Parameters, only : sw_fix &
       &                         , m_CtrlP_set_iconvergence &
       &                         , m_CtrlP_what_is_mdalg
  use m_Const_Parameters,   only : FORCE_CONVERGED
  use m_Ionic_System,       only : m_IS_evaluate_v_verlet
  use m_Force,              only : forc_l
  integer :: mdalg

  if(sw_fix == ON) then
     Structure_is_fixed = .true.
  else
     Structure_is_fixed = .false.
  end if
  if(Structure_is_fixed) call m_CtrlP_set_iconvergence(FORCE_CONVERGED)
  if(Structure_is_fixed) then
     mdalg = m_CtrlP_what_is_mdalg()
     if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)
     call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfenf
  end if
end function Structure_is_fixed

logical function Hubbard_model()
  use m_Const_Parameters, only : ON
  use m_Control_Parameters, only : sw_hubbard
  use m_Total_Energy,   only : m_TE_Converged_Hubbard_Energy
  implicit none
  Hubbard_model=.false.
  if(sw_hubbard == ON) then
     Hubbard_model=.true.
     !!if(m_TE_Converged_Hubbard_Energy(nfout)) Hubbard_model=.false.
  end if
  !!$write(6,*) "Hubbard_model=",Hubbard_model
end function Hubbard_model
#endif

! AAS for Modified Davidson and Modified Kosugi
module m_ES_WF_by_ModifiedDavidson
#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF,GAMMA,OTHER_BANDS,SKIP,EXECUT,ELECTRON, OLD
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,ista_g1,mpi_k_world,ierr,map_z &
       &                          , np_e,npes,nrank_e,mype
  use m_Control_Parameters,  only : nspin,ipridavidson,kimg,neg,af,npartition_david &
       &                          , delta_eig_empty &
       &                          , delta_eig_occup &
       &                          , max_iter_david, sw_MRCV_only,eps_david &
#ifdef SAVE_FFT_TIMES
       &                          , sw_divide_subspace, sw_save_fft, sw_hybrid_functional
#else
       &                          , sw_divide_subspace, sw_hybrid_functional
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF, m_FFT_Vlocal_W, m_FFT_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr, eko_l, vlhxcQ &
       &                          , occup_l &
       &                          , fsr_l,fsi_l, vnlph_l, vlhxc_l &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , m_ES_Vlocal_in_Rspace &
       &                          , m_ES_WF_in_Rspace &
       &                          , m_ES_wd_zaj_small_portion &
       &                          , m_ES_wd_eko &
       &                          , m_ES_sort_eigen_values
  use m_ES_ortho,           only : np_g1k_x                                          &
       &                         , m_ES_W_transpose_r                                &
       &                         , m_ES_W_transpose_back_r                           &
       &                         , m_ES_orthogonal_phi_to_WFs
  use m_ES_nonlocal,        only : m_ES_Vnonlocal_W                                  &
       &                         , m_ES_betar_dot_WFs_4_each_k                       &
       &                         , m_ES_alloc_scss_etc                               &
       &                         , m_ES_dealloc_scss_etc                             &
       &                         , m_ES_betar_dot_Psi_4_each_k
  use m_Ionic_System,       only : natm, iwei, ityp, ntyp
  use m_PseudoPotential,    only : ilmt,nlmta,lmta,q,dion &
       &                         , lmtt,ltp,mtp &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw,dion_paw,modnrm
  use m_NonLocal_Potential, only : snl

! ============================== added by K. Tagami ================== 11.0
  use m_Const_Parameters,   only : CMPLDP, Neglected
  use m_Control_Parameters,  only : ndim_spinor, noncol, ndim_chgpot, SpinOrbit_mode, &
       &                            sw_hubbard
  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl
  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl

  use m_FFT,                 only : m_FFT_Vlocal_W_noncl
  use m_ES_ortho,              only : m_ES_orthogonl_SD_to_WFs_noncl
  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
! ==================================================================== 11.0


  use m_ES_ExactExchange, only : m_ES_Vexx_W,m_ES_EXX_get_vexx,m_ES_EXX_eigenvalue,m_ES_EXX_gather_valence_states

  implicit none
  integer, private, parameter                         :: sw_timing_2ndlevel = ON

  private
  
  integer, allocatable, dimension(:) :: nsize_subspace, nsize_matrix
  integer, allocatable, dimension(:) :: ista_e_l,iend_e_l,ielm_e_l
  integer :: nsize_sb_now, nsize_mt_now, nsize_mt_old,msize_matrix
  integer :: nblock,msize_subspace
  real(kind=DP), allocatable, target, dimension(:) :: w1hw2,w1hw2_mpi
  real(kind=DP), allocatable, target, dimension(:) :: w1sw2,w1sw2_mpi
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zah_l
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr,fsi
  real(kind=DP), pointer, dimension(:,:,:) :: fsr_p,fsi_p
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr_t,fsi_t
  real(kind=DP), allocatable, dimension(:,:,:) :: fsr_mpi,fsi_mpi
  real(kind=DP), pointer, dimension(:,:,:,:) :: zat_l_p, zah_l_p
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l_t,zah_l_t
  logical, allocatable, target, dimension(:)   :: feigconv_t
  logical, allocatable, dimension(:)   :: feigconv_mpi
  logical, pointer, dimension(:)   :: feigconv_p
  real(kind=DP), allocatable, dimension(:,:,:) :: zajold_l
  real(kind=DP), allocatable, dimension(:,:,:) :: zaj_l_backup
  real(kind=DP), allocatable, dimension(:,:) :: fsrold_l,fsiold_l
  real(kind=DP), allocatable, dimension(:,:,:,:):: wfsd_l  !d(kg1,np_e,ik:ik,kimg)
  real(kind=DP), allocatable, dimension(:,:,:)  :: bsdr_l, bsdi_l !d(np_e,nlmta,1)
  real(kind=DP) :: eps_residual
  logical, allocatable, target, dimension(:)   :: feigconv
  integer, allocatable, dimension(:,:) :: ibover

  real(kind=DP), allocatable,dimension(:) ::     eko_d
  real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
  integer, allocatable,dimension(:) ::     occup
  
  public :: m_ESmddavid_Renew_WF
  public :: m_ESmddavid_Subspace_Rotation
    
! =========================== added by K. Tagami ============== 11.0
  public :: m_ESmddavid_Renew_WF_noncl
  public :: m_ESmddavid_Subspace_Rot_noncl
! ============================================================= 11.0
  
! ================================= added by K. Tagami ================= 11.0
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zat_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zah_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: fsr_noncl, fsi_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_l_backup_noncl
!
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zajold_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:) :: fsrold_l_noncl,fsiold_l_noncl
! ===================================================================== 11.0

  include 'mpif.h'

contains
  
! ================================= added by K. Tagami ================ 11.0
  subroutine m_ESmddavid_Renew_WF_noncl(nfout,precon)
    integer, intent(in) :: nfout,precon
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: iblock,itot

    real(kind=DP), allocatable ::  afft_kt(:,:)
    real(kind=DP), allocatable ::  bfft_kt(:,:)
    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    real(kind=DP), allocatable, dimension(:) :: ekin,p

    logical :: frestart
    integer :: max_itot
    integer :: iblock_now, itot_now, ipri0
    integer :: n_unconv

    integer :: is1, is2, istmp, k2

    max_itot = 1

    allocate(ekin(kg1),p(kg1))

    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0
    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    call allocate_matrix_noncl
    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )    ! (ptfft1) vlhxc_l->afft

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k )  cycle          ! MPI
       iksnl = (ik-1)/ndim_spinor + 1

       call allocate_t_matrix_noncl( ik, ik +ndim_spinor -1 ) ! -> np_g1k_x
       call m_pwBS_kinetic_energies( ik, vkxyz, ekin ) ! (diakin) ->ekin


       max_itot=0
       feigconv = .false.

       Loop: do itot=1,max_iter_david
          itot_now = itot
          if (itot>max_itot) max_itot=itot
          
          vnlph_noncl = 0.0d0
          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1-1 )*ndim_spinor +is2
                k2 = ik +is2 -1

                if ( precon==ON ) then
                   call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=OFF )
                   ! -> vnlph_l
                   if(sw_hybrid_functional==ON) call m_ES_Vexx_W(k2)
                else
                   call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=ON )
                   if(sw_hybrid_functional==ON) call m_ES_Vexx_W(k2)
                   ! -> vnlph_l
                endif
                vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
                     &                     + vnlph_l(:,:,:)
             End do
          End do

          call decide_correction_vec_noncl( precon, ik, ekin, &
               &                               afft_kt, bfft_kt, vnlph_noncl, p )  
                                                              ! -> wfsd_l
               
          call prepare_Hloc_phi_noncl( ik, ekin, afft_kt, bfft_kt, itot )  
          
          Block_Loop: do iblock=1,nblock
             iblock_now = iblock
             call evolve_WFs_in_subspace_noncl( ik, ekin, afft_kt, &
                  &                             iblock, itot, frestart )

             if (ik==1.and.ipridavidson>= 2) then
                Do is1=1, ndim_spinor
                   call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, &
                        &                          " -- after md davidson --",21 )
                End do
             endif

!             if(frestart) exit David_Loop
!            if(eigenvalues_are_converged(n_unconv)) exit Loop

          end do Block_Loop

! -
          Do is1=1, ndim_spinor
             call m_ES_betar_dot_WFs_4_each_k( nfout, ik+is1-1 )   ! -> fsr_l,fsi_l
          End do

       end do Loop

       if(ipridavidson>=2) then
          write(nfout,'("MdDavidson: ik=",i5," itot=",i5," subspace=",i5)') &
               &               ik, itot_now, nsize_sb_now
       end if

       call deallocate_t_matrix
    enddo      ! k-point loop

    call deallocate_matrix_noncl

    if (ipridavidson>=2) then
       write(nfout,'("Modified Davidson: max_itot=",i5)') max_itot
    end if
!
    call m_ES_sort_eigen_vals_noncl()


    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
!
    deallocate(bfft_kt);   deallocate(afft_kt)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin,p)

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,np_e
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged

  end subroutine m_ESmddavid_Renew_WF_noncl
! ================================================================= 11.0

! =========================== added by K. Tagami ============== 11.0
  subroutine allocate_matrix_noncl
    integer:: i,j
    
    nblock = npartition_david
    if(np_e .lt. npartition_david) nblock = np_e
!!$    nblock = npartition_mddavid
!!$    if(np_e .lt. npartition_mddavid) nblock = np_e
    
    allocate(nsize_subspace(nblock))
    allocate(nsize_matrix(nblock))
    allocate(ista_e_l(nblock))
    allocate(iend_e_l(nblock))
    allocate(ielm_e_l(nblock))
    ielm_e_l=np_e/nblock
    j = mod(np_e,nblock)
    do i = 1, j
       ielm_e_l(i) = ielm_e_l(i) + 1
    end do
    ista_e_l(1) = 1
    do i = 2, nblock
       ista_e_l(i) = ista_e_l(i-1) + ielm_e_l(i-1)
       iend_e_l(i-1) = ista_e_l(i) - 1
    end do
    iend_e_l(nblock) = np_e
    do i=1,nblock
      if(sw_MRCV_only==ON)then
         nsize_subspace(i)=ielm_e_l(i)*2
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      else
         nsize_subspace(i)=ielm_e_l(i)*(max_iter_david+1)
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      endif
    end do
    msize_subspace=maxval(nsize_subspace)
    msize_matrix=maxval(nsize_matrix)
    allocate(feigconv(np_e))
    allocate(ibover(msize_subspace,nblock))

    if(sw_MRCV_only==ON)then
       allocate( fsr_noncl(np_e,nlmta,2,ndim_spinor ) )
       if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi_noncl(np_e,nlmta,2,ndim_spinor))
       end if
    else
       allocate(fsr_noncl(np_e,nlmta,max_iter_david+1,ndim_spinor))
       if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi_noncl(np_e,nlmta,max_iter_david+1,ndim_spinor))
       end if
    endif
    eps_residual = eps_david
!!    allocate(zajold_l(kg1,np_e,kimg,ndavid)) ! MPI
!!    allocate(zaj_l_backup(kg1,np_e,kimg)) ! MPI

! ----------------------------------------- KTDebug : 2012/09/26 --
    if ( .not. allocated(zajold_l_noncl ) ) then
       allocate(zajold_l_noncl(kg1,np_e,kimg,ndim_spinor))
    endif
    if ( .not. allocated(fsrold_l_noncl ) ) then
       allocate(fsrold_l_noncl(np_e,nlmta,ndim_spinor))
    endif

    if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       if ( .not. allocated(fsiold_l_noncl ) ) then
          allocate(fsiold_l_noncl(np_e,nlmta,ndim_spinor))
       endif
    end if
! ----------------------------------------- KTDebug : 2012/09/26 --

  end subroutine allocate_matrix_noncl
! ======================================================== 11.0

! =========================== addd by K. Tagami ============= 11.0
  subroutine deallocate_matrix_noncl
    deallocate(nsize_subspace)
    deallocate(nsize_matrix)
    deallocate(ista_e_l)
    deallocate(iend_e_l)
    deallocate(ielm_e_l)
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr_noncl)
    if ( allocated(fsi_noncl) )  deallocate( fsi_noncl )
    if(sw_MRCV_only==OFF)then
       deallocate(zajold_l_noncl)
       deallocate(fsrold_l_noncl)
       if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          deallocate(fsiold_l_noncl)
       end if
    endif
!!    deallocate(zajold_l)
!!    deallocate(zaj_l_backup)
  end subroutine deallocate_matrix_noncl
! ============================================================ 11.0

! ====================== added by K. Tagami ================== 11.0
  subroutine allocate_t_matrix_noncl( ik1, ik2 )
    integer, intent(in) :: ik1, ik2
    integer :: kimg_t
    integer :: is,k1

! ---------------------------------------- KTDebug : 2012/09/26 --
    integer :: niter
! ---------------------------------------- KTDebug : 2012/09/26 --

    if(k_symmetry(ik1) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    

! ---------------------------------------- KTDebug : 2012/09/26 --
!    allocate(zat_l_noncl(kg1,np_e,kimg,2,ndim_spinor)) ! MPI
!    allocate(zah_l_noncl(kg1,np_e,kimg,2,ndim_spinor)) ! MPI

    niter = max_iter_david+1
    if(sw_MRCV_only==ON) niter = 2

    allocate(zat_l_noncl(kg1,np_e,kimg,niter,ndim_spinor)) ! MPI
    allocate(zah_l_noncl(kg1,np_e,kimg,niter,ndim_spinor)) ! MPI
!
! ---------------------------------------- KTDebug : 2012/09/26 --

    allocate(w1hw2(msize_matrix*kimg_t))
    allocate(w1sw2(msize_matrix*kimg_t))

    if(npes>1) then
! ---------------------------------- KTDebug : 2012/10/28 --
!!       allocate(w1hw2_mpi(msize_matrix*kimg_t))
!!       allocate(w1sw2_mpi(msize_matrix*kimg_t))
       if ( allocated(w1hw2_mpi) ) deallocate(w1hw2_mpi)
       if ( allocated(w1sw2_mpi) ) deallocate(w1sw2_mpi)
       allocate(w1hw2_mpi(msize_matrix*kimg_t))
       allocate(w1sw2_mpi(msize_matrix*kimg_t))
! ---------------------------------- KTDebug : 2012/10/28 --
    end if

    allocate(wfsd_l(kg1,np_e,ik1:ik2,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik1:ik2)); bsdr_l = 0.d0
    allocate(bsdi_l(np_e,nlmta,ik1:ik2)); bsdi_l = 0.d0
    if(sw_MRCV_only==OFF)then
       Do is=1, ndim_spinor
          k1 = ik1 + is -1
          zajold_l_noncl(:,:,:,is)= zaj_l(:,:,k1,:)
          fsrold_l_noncl(:,:,is)  = fsr_l(:,:,k1)

          if (.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             fsiold_l_noncl(:,:,is) = fsi_l(:,:,k1)
          end if
       End do
    endif
  end subroutine allocate_t_matrix_noncl
! ============================================================ 11.0
  
  subroutine SD_direction(precon,ik,ibo,ekin,VlocalW,p)
    integer     , intent(in)                   :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)             , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: devr,denom, e1, devi, norm

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    norm = 0.d0

    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,ik,1)&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          wfsd_l(i,ib,ik,1) = - devr
          norm = norm + devr*devr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*zaj_l(i,ib,ik,1) + VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*zaj_l(i,ib,ik,2) + VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          wfsd_l(i,ib,ik,1) = - devr
          wfsd_l(i,ib,ik,2) = - devi
          norm = norm + devr*devr + devi*devi
       end do
       if(k_symmetry(ik) == GAMMA) then
          devr=wfsd_l(1,ib,ik,1)
          devi=wfsd_l(1,ib,ik,2)
          norm = norm*2.d0 - devr*devr - devi*devi
       end if
    end if
    
    feigconv(ib)=.false.
    if(sqrt(norm) .lt. eps_residual) feigconv(ib)=.true.
    
    if(precon==ON) then
      call decide_precon_factor_wfsd(ik,ibo,ekin,p)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
      if(kimg == 1) then
         do i = 1, iba(ik)
            wfsd_l(i,ib,ik,1) = p(i)*wfsd_l(i,ib,ik,1)
         end do
      else if(kimg == 2) then
         do i = 1, iba(ik)
            wfsd_l(i,ib,ik,1) = p(i)*wfsd_l(i,ib,ik,1)
            wfsd_l(i,ib,ik,2) = p(i)*wfsd_l(i,ib,ik,2)
         end do
      end if
    end if
  end subroutine SD_direction
  
! ============================= added by K. Tagami ================ 11.0
  subroutine SD_direction_noncl( precon, ik, ibo, ekin, VlocalW_noncl, &
       &                         vnlph_noncl, p )
    integer     , intent(in)                   :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)             , dimension(kg1)  :: p

    integer       :: i, i1, ib, is, k1
    real(kind=DP) :: devr,denom, e1, devi, norm, ctmp

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    norm = 0.d0

    if(kimg == 1) then
       Do is=1, ndim_spinor
          k1 = ik + is -1
          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,k1,1)&
                  & + VlocalW_noncl(i1,is)*denom + vnlph_noncl(i,ib,1,is)
             wfsd_l(i,ib,k1,1) = - devr
             norm = norm + devr*devr
          end do
       End do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
          k1 = ik + is -1
          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             e1    = ekin(i) - eko_l(ib,ik)
             devr  = e1*zaj_l(i,ib,k1,1) + VlocalW_noncl(2*i1-1,is)*denom &
                  &  +vnlph_noncl(i,ib,1,is)
             devi  = e1*zaj_l(i,ib,k1,2) + VlocalW_noncl(2*i1  ,is)*denom &
                  &  +vnlph_noncl(i,ib,2,is)
             wfsd_l(i,ib,k1,1) = - devr
             wfsd_l(i,ib,k1,2) = - devi
             norm = norm + devr*devr + devi*devi
          end do
       End do

       if(k_symmetry(ik) == GAMMA) then
          ctmp = 0.0d0
          Do is=1, ndim_spinor
             k1 = ik + is -1
             devr = wfsd_l(1,ib,k1,1)
             devi = wfsd_l(1,ib,k1,2)
             ctmp = ctmp + devr*devr + devi*devi
          End do
          norm = norm*2.d0 - ctmp
       end if
    end if
    
    feigconv(ib)=.false.
    if(sqrt(norm) .lt. eps_residual) feigconv(ib)=.true.
    
    if(precon==ON) then
      call decide_precon_factor_wfsd(ik,ibo,ekin,p)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
      if(kimg == 1) then
         Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,ib,k1,1) = p(i)*wfsd_l(i,ib,k1,1)
            end do
         End do
      else if(kimg == 2) then
         Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,ib,k1,1) = p(i)*wfsd_l(i,ib,k1,1)
               wfsd_l(i,ib,k1,2) = p(i)*wfsd_l(i,ib,k1,2)
            end do
         End do
      end if
    end if
  end subroutine SD_direction_noncl
! ============================================================= 11.0

  subroutine decide_precon_factor_wfsd(ik,ibo,ekin,p)
    integer, intent(in)                         :: ik,ibo
    real(kind=DP), intent(in),  dimension(kg1)  :: ekin
    real(kind=DP), intent(out), dimension(kg1)  :: p

    integer       :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

!    call kinetic_energy_wfsd(ik,ibo,ekin,ektot)   ! -here

! ====================== modified by K. Tagami =============== 11.0
!    call kinetic_energy(ik,ibo,ekin,ektot)   ! -here

    if ( noncol ) then
       call kinetic_energy_noncl(ik,ibo,ekin,ektot)   ! -here
    else
       call kinetic_energy(ik,ibo,ekin,ektot)   ! -here
    end if
! ============================================================ 11.0

    d_ektot = 4.d0/ektot/3.d0
    p = 0.d0
    do i = 1, iba(ik)
       x = ekin(i)*d_ektot
       x1 = (x*x+9.d0)*(x+3.d0)
       x2 = (x*x)*(x*x)
       p(i)  = x1/(x1 + x2 )
    end do
!    p=p*d_ektot
  end subroutine decide_precon_factor_wfsd
  
  subroutine kinetic_energy_wfsd(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri, ib
    ektot = 0.d0
    ib=map_z(ibo)
    do ri = 1, kimg
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*wfsd_l(i,ib,ik,ri)**2   ! MPI
       end do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd
  
  subroutine kinetic_energy(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ib
    ektot = 0.d0
    ib = map_z(ibo)
    if(kimg == 1) then
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*zaj_l(i,ib,ik,1)**2
       end do
    else
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*( zaj_l(i,ib,ik,1)**2 &
               &                   + zaj_l(i,ib,ik,2)**2)
       end do
    end if
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy

! ======================= added by K. Tagami =============== 11.0
  subroutine kinetic_energy_noncl( ik, ibo, dekin, ektot )
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ib, is, k1

    ektot = 0.d0
    ib = map_z(ibo)
    if(kimg == 1) then
       Do is=1, ndim_spinor
          k1 = ik + is -1
          do i = 1, iba(ik)
             ektot = ektot + dekin(i)*zaj_l(i,ib,k1,1)**2
          end do
       End do
    else
       Do is=1, ndim_spinor
          k1 = ik + is -1
          do i = 1, iba(ik)
             ektot = ektot + dekin(i)*( zaj_l(i,ib,k1,1)**2 &
                  &                   + zaj_l(i,ib,k1,2)**2)
          end do
       End do
    end if
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy_noncl
! ======================================================== 11.0

  

! ===================== added by K. Tagami =================== 11.0
  subroutine orthogonalize_SD_drctns_noncl(ik,to)
    integer, intent(in) :: ik,to

    integer :: is, itmp, k1
    integer :: id_sname = -1

    call tstatc0_begin('orthogonalize_SD_drctns_noncl in Modified Davidson ', id_sname)
    if(sw_MRCV_only==OFF)then
       Do is=1, ndim_spinor
          k1 = ik + is -1
          zat_l_noncl(:,:,:,1,is) = zaj_l(:,:,k1,:)
          fsr_noncl(:,:,1,is)     = fsr_l(:,:,k1)
       End do

       if (.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             fsi_noncl(:,:,1,is) = fsi_l(:,:,k1)
          End do
       end if
    
       Do is=1, ndim_spinor
          k1 = ik + is -1
          zaj_l(:,:,k1,:) = zajold_l_noncl(:,:,:,is)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(:,k1) = OLD
#endif
          fsr_l(:,:,k1) = fsrold_l_noncl(:,:,is)
          if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             fsi_l(:,:,k1) = fsiold_l_noncl(:,:,is)
          end if
       End do
    endif

    itmp = modnrm;  modnrm = EXECUT
    Do is=1, ndim_spinor
       call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_l, ik, ik+ndim_spinor-1, &
            &                            ik +is -1, bsdr_l, bsdi_l )
                                        !           ->bsd(ri)_l
    End do

    call m_ES_orthogonl_SD_to_WFs_noncl( ik, to, ik, ik+ndim_spinor-1, &
        &                                wfsd_l, bsdr_l, bsdi_l)
                                             ! ->(wfsd_l,bsd(ri)_l)
    modnrm=itmp

    call tstatc0_end(id_sname)

  end subroutine orthogonalize_SD_drctns_noncl
! ================================================================== 11.0
  
  subroutine normalize_wfsd(ik)
    integer,intent(in) :: ik
    real(kind=DP) :: norm, wfsdr, wfsdi
    integer :: ib1,ii,ib
  
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib=map_z(ib1)
       norm = 0.d0
       if(kimg==1) then
          do ii=1,iba(ik)
             wfsdr = wfsd_l(ii,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr
          end do
          norm = 1.d0/sqrt(norm)
          do ii=1,iba(ik)
             wfsd_l(ii,ib,ik,1) = wfsd_l(ii,ib,ik,1)*norm
          end do
          bsdr_l(ib,1:nlmta,ik) = bsdr_l(ib,1:nlmta,ik)*norm
          bsdi_l(ib,1:nlmta,ik) = bsdi_l(ib,1:nlmta,ik)*norm
       else
          do ii=1,iba(ik)
             wfsdr = wfsd_l(ii,ib,ik,1   )
             wfsdi = wfsd_l(ii,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr+wfsdi*wfsdi
          end do
          norm = 1.d0/sqrt(norm)
          do ii=1,iba(ik)
             wfsd_l(ii,ib,ik,1) = wfsd_l(ii,ib,ik,1)*norm
             wfsd_l(ii,ib,ik,2) = wfsd_l(ii,ib,ik,2)*norm
          enddo
          if(k_symmetry(ik) == GAMMA) then
            bsdr_l(ib,1:nlmta,ik) = bsdr_l(ib,1:nlmta,ik)*norm
          else
            bsdr_l(ib,1:nlmta,ik) = bsdr_l(ib,1:nlmta,ik)*norm
            bsdi_l(ib,1:nlmta,ik) = bsdi_l(ib,1:nlmta,ik)*norm
          end if
       end if
    end do
    
  end subroutine normalize_wfsd

! ===================== added by K. Tagami  ================== 11.0
  subroutine normalize_wfsd_noncl(ik)
    integer,intent(in) :: ik
    real(kind=DP) :: norm, wfsdr, wfsdi
    integer :: ib1,ii,ib, is, k1

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib=map_z(ib1)
       norm = 0.d0
       if (kimg==1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                wfsdr = wfsd_l(ii,ib,k1,kimg)
                norm = norm + wfsdr*wfsdr
             end do
          End do
          norm = 1.d0 /sqrt(norm)
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                wfsd_l(ii,ib,k1,1) = wfsd_l(ii,ib,k1,1)*norm
             end do
             bsdr_l(ib,1:nlmta,k1) = bsdr_l(ib,1:nlmta,k1)*norm
             bsdi_l(ib,1:nlmta,k1) = bsdi_l(ib,1:nlmta,k1)*norm
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                wfsdr = wfsd_l(ii,ib,k1,1   )
                wfsdi = wfsd_l(ii,ib,k1,kimg)
                norm = norm + wfsdr*wfsdr+wfsdi*wfsdi
             end do
          End do
          norm = 1.d0/sqrt(norm)
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                wfsd_l(ii,ib,k1,1) = wfsd_l(ii,ib,k1,1)*norm
                wfsd_l(ii,ib,k1,2) = wfsd_l(ii,ib,k1,2)*norm
             enddo
             if(k_symmetry(ik) == GAMMA) then
                bsdr_l(ib,1:nlmta,k1) = bsdr_l(ib,1:nlmta,k1)*norm
             else
                bsdr_l(ib,1:nlmta,k1) = bsdr_l(ib,1:nlmta,k1)*norm
                bsdi_l(ib,1:nlmta,k1) = bsdi_l(ib,1:nlmta,k1)*norm
             end if
          End do
       end if
    end do
    
  end subroutine normalize_wfsd_noncl
! =========================================================== 11.0

  
! =========================== added by K. Tagami =============== 11.0
  subroutine prepare_Hloc_phi_noncl( ik, ekin, afft_kt, bfft_kt, itot )
    integer, intent(in) :: ik
    integer, intent(in) :: itot
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)

    integer       :: ib1,i1,ii,ib, is, k1
    real(kind=DP) :: denom
    real(kind=DP) :: dr1,dr2,di1,di2,dd
    integer :: id_sname = -1, ipri0

    call tstatc0_begin('prepare_Hloc_phi_noncl (mddavidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))


! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)

    if(sw_MRCV_only==ON)then
       Do is=1, ndim_spinor
          zat_l_noncl(:,:,:,1,is) =  zaj_l(:,:,ik+is-1,:)
          zat_l_noncl(:,:,:,2,is) = wfsd_l(:,:,ik+is-1,:)
       End do

       Do is=1, ndim_spinor
          fsr_noncl(:,:,1,is) = fsr_l(:,:,ik+is-1)
          fsr_noncl(:,:,2,is) = bsdr_l(:,:,ik+is-1)
       End do
       if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          Do is=1, ndim_spinor
             fsi_noncl(:,:,1,is) =  fsi_l(:,:,ik+is-1)
             fsi_noncl(:,:,2,is) = bsdi_l(:,:,ik+is-1)
          End do
       end if
    else
       Do is=1, ndim_spinor
!!       zat_l_noncl(:,:,:,1,is) = zaj_l(:,:,ik+is-1,:)
          zat_l_noncl(:,:,:,itot+1,is) = wfsd_l(:,:,ik+is-1,:)
       End do
    
       Do is=1, ndim_spinor
!       fsr_noncl(:,:,1,is) = fsr_l(:,:,ik+is-1)
          fsr_noncl(:,:,itot+1,is)=bsdr_l(:,:,ik+is-1)
       End do

       if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          Do is=1, ndim_spinor
!          fsi_noncl(:,:,1,is) = fsi_l(:,:,ik+is-1)
             fsi_noncl(:,:,itot+1,is) = bsdi_l(:,:,ik+is-1)
          End do
       end if
    endif

    if(itot == 1) then
       do ib1 = ista_e, iend_e, istep_e     ! MPI
          Do is=1, ndim_spinor
             k1 = ik +is- 1
             call m_ES_WF_in_Rspace( k1, ib1, bfft_kt(:,is) )   !(swffft)
          End do
          call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                       ! (afft, bfft)-> (bfft)
          Do is=1, ndim_spinor
             call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
          End do

          ib = map_z(ib1)                 ! MPI
          if(kimg == 1) then
             Do is=1, ndim_spinor
                k1 = ik + is -1
                do ii=1,iba(ik)
                   i1  = igf(nbase(ii,ik))
                   dr1 = zaj_l( ii, ib, k1,1 )
                   dr2 = bfft_kt( i1,is )*denom
                   zah_l_noncl(ii,ib,1,1,is) = ekin(ii)*dr1+dr2
                enddo
             End do
          else
             Do is=1, ndim_spinor
                k1 = ik + is -1
                do ii=1,iba(ik)
                   i1  = igf(nbase(ii,ik))
                   dr1  = zaj_l( ii, ib, k1, 1 )
                   di1  = zaj_l( ii, ib, k1, kimg )
                   zah_l_noncl(ii,ib,   1,1,is) = ekin(ii)*dr1 &
                        &                        +bfft_kt(2*i1-1,is)*denom
                   zah_l_noncl(ii,ib,kimg,1,is) = ekin(ii)*di1 &
                        &                        +bfft_kt(2*i1,is)*denom
                enddo
             End do
          endif
       enddo
    end if
    
!!( tenchi ) (zah_l <- zaj_l)
    Do is=1, ndim_spinor
       k1 = ik + is -1
       zaj_l(:,:,k1,:) = wfsd_l(:,:,k1,:)
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,k1) = OLD
#endif
    End do

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       Do is=1, ndim_spinor
          k1 = ik +is- 1
          call m_ES_WF_in_Rspace( k1, ib1, bfft_kt(:,is) )!(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                       ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
          call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
       if (kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(ii,ib,k1,1)
                dr2 = bfft_kt(i1,is)*denom
                if(sw_MRCV_only==ON)then
                   zah_l_noncl(ii,ib,1,2,is) = ekin(ii)*dr1+dr2
                else
                   zah_l_noncl(ii,ib,1,itot+1,is) = ekin(ii)*dr1+dr2
                endif
             enddo
          End Do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(ii,ib,k1,1)
                di1  = zaj_l(ii,ib,k1,kimg)
                if(sw_MRCV_only==ON)then
                   zah_l_noncl(ii,ib,1,   2,is) = ekin(ii)*dr1 &
                     &                        +bfft_kt(2*i1-1,is)*denom
                   zah_l_noncl(ii,ib,kimg,2,is) = ekin(ii)*di1 &
                     &                        +bfft_kt(2*i1,is)*denom
                else
                   zah_l_noncl(ii,ib,1,   itot+1,is) = ekin(ii)*dr1 &
                     &                        +bfft_kt(2*i1-1,is)*denom
                   zah_l_noncl(ii,ib,kimg,itot+1,is) = ekin(ii)*di1 &
                     &                        +bfft_kt(2*i1,is)*denom
                endif
             enddo
          End do
       endif
    enddo
    
    call tstatc0_end(id_sname)

  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine prepare_Hloc_phi_noncl
! ================================================================= 11.0

! ======================================= added by K. Tagami ============= 11.0
  subroutine evolve_WFs_in_subspace_noncl( ik, ekin, afft_kt, &
       &                                   iblock,itot,frestart )
    integer, intent(in) :: ik
    integer, intent(in) :: iblock,itot
    logical, intent(out) :: frestart
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)

! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: nel,nsta,nend
    integer :: id_sname = -1, ipri0

    integer :: is
 
    call tstatc0_begin('evolve_WFs_in_subspace_noncl (modified davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)
    
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
    nel =ielm_e_l(iblock)
    nsta=ista_e_l(iblock)
    nend=iend_e_l(iblock)

!    ip0=nsize_subspace(iblock)
!    do ib=1,ip0
!      ibover(ib,iblock) = ib
!    end do
    if(sw_MRCV_only==ON)then
       ip0=nel
       do ib=1,nel
         ibover(ib,iblock)=ib
         if(.not.feigconv(nsta+ib-1)) then
           ip0=ip0+1
           ibover(nel+ib,iblock) = ip0 
         else
           ibover(nel+ib,iblock) = -1
         end if
       end do

       nsize_sb_now = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
!      nsize_max_sb_now = neg*idavid
!      nsize_sb_now = nsize_subspace(iblock)          ! For the moment
!      nsize_mt_now = nsize_matrix(iblock)
       nsize_max_sb_now = nsize_subspace(iblock)
    else
       if(itot==1) then
         do ib=1,nel
           ibover(ib,iblock)=ib
         end do
         nsize_subspace(iblock)=nel
       end if

!       ip0=nsize_subspace(iblock)
!       do ib=1,ip0
!         ibover(ib,iblock) = ib
!       end do
    
       noffset=nel*itot
       ip0=nsize_subspace(iblock)
       do ib=1,nel
         if(.not.feigconv(nsta+ib-1)) then
           ip0=ip0+1
           ibover(noffset+ib,iblock) = ip0 
         else
           ibover(noffset+ib,iblock) = -1
         end if
       end do

       nsize_sb_now = ip0
       nsize_subspace(iblock) = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nel*(itot+1)                   !nsize_subspace(iblock)
    endif
       
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now,iblock)
    end if
!
    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
!    allocate(eko_d(neg));     eko_d = 0.d0
!    allocate(eko_d_mpi(neg))
!    allocate(occup(neg)); occup=0
!    allocate(occup_mpi(neg))

    if(ipridavidson >=2) then
       write(nfout,*) 'Modified Davidson:ik,iblock,nsize_sb_now=', ik,iblock,nsize_sb_now
    end if

!    do ib1 = 1, neg
!       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
!    end do
!    call mpi_allreduce(eko_d,eko_d_mpi,neg,mpi_double_precision,mpi_sum &
!         & ,mpi_k_world(myrank_k),ierr)       ! MPI
!    eko_d = eko_d_mpi                         ! MPI
    eko1 = sum(eko_l(nsta:nend,ik))
!
!    do ib1=1,neg
!       if(map_e(ib1) == myrank_e) then !MPI
!          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
!       end if
!    end do
!    call mpi_allreduce(occup,occup_mpi,neg,mpi_integer,mpi_sum &
!         & ,mpi_k_world(myrank_k),ierr)       ! MPI
!    occup = occup_mpi                         ! MPI
!
!! (zaj_l <- (T+Vloc)|phi> )
!!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!!( tenchi ) (zat_l <- zaj_l)
!    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,idavid))
!    do ib1 = ista_e, iend_e, istep_e     ! MPI
!       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
!       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
!       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
!       ib = map_z(ib1)                 ! MPI
!       if(kimg == 1) then
!          do ii=1,iba(ik)
!             i1  = igf(nbase(ii,ik))
!             dr1 = zaj_l(ii,ib,ik,1)
!             dr2 = bfft(i1)*denom
!             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+dr2
!          enddo
!       else
!          do ii=1,iba(ik)
!             i1  = igf(nbase(ii,ik))
!             dr1  = zaj_l(ii,ib,ik,1)
!             di1  = zaj_l(ii,ib,ik,kimg)
!             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
!             zaj_l(ii,ib,ik,kimg)= ekin(ii)*di1+bfft(2*i1)*denom
!          enddo
!       endif
!    enddo
!!( tenchi ) (zah_l <- zaj_l)
!    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l(1,1,1))

!! (make matrix elements )
!    ! <n|T+Vloc|m> !
    do ibb2 = 1,nsize_max_sb_now
       if(ibover(ibb2,iblock)<0) cycle
       ib2 = ibover(ibb2,iblock)
       iter2 = (ibb2-1)/nel+1
       ii2  = ibb2-nel*(iter2-1)
       ii2  = nsta+ii2-1
       ip0b = ib2*(ib2-1)/2
       do ibb1 = 1,ibb2
          if(ibover(ibb1,iblock)<0) cycle
          ib1 = ibover(ibb1,iblock)
          iter1 = (ibb1-1)/nel+1
          ii1 = ibb1-nel*(iter1-1)
          ii1 = nsta+ii1-1
          ip0 = ip0b + ib1

          if (kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
             Do is=1, ndim_spinor
                do ii = 1, iba(ik)            ! MPI
                   hr2 = zah_l_noncl(ii,ii2,1,iter2,is)
                   dr2 = zat_l_noncl(ii,ii2,1,iter2,is)
                   dr1 = zat_l_noncl(ii,ii1,1,iter1,is)
                   w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                   w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
                end do
             End do
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
!!                ig1 = 1;  if(myrank_e == 0) ig1 = 2
                ig1 = 2
                Do is=1, ndim_spinor
                   do ii = ig1, iba(ik)            ! MPI
                      hr2 = zah_l_noncl(ii,ii2,1,iter2,is) ! MPI
                      hi2 = zah_l_noncl(ii,ii2,2,iter2,is) ! MPI
                      dr2 = zat_l_noncl(ii,ii2,1,iter2,is) ! MPI
                      di2 = zat_l_noncl(ii,ii2,2,iter2,is) ! MPI
                      dr1 = zat_l_noncl(ii,ii1,1,iter1,is) ! MPI
                      di1 = zat_l_noncl(ii,ii1,2,iter1,is) ! MPI
                      w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                      w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                   end do
                End do
!!$                if(mype == 0) then
!!                if(myrank_e == 0) then

                Do is=1, ndim_spinor
                   hr2 = zah_l_noncl(1,ii2,1,iter2,is) ! MPI
                   hi2 = zah_l_noncl(1,ii2,2,iter2,is) ! MPI
                   dr2 = zat_l_noncl(1,ii2,1,iter2,is) ! MPI
                   di2 = zat_l_noncl(1,ii2,2,iter2,is) ! MPI
                   dr1 = zat_l_noncl(1,ii1,1,iter1,is) ! MPI
                   di1 = zat_l_noncl(1,ii1,2,iter1,is) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                End do
!!                end if

             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                Do is=1, ndim_spinor
                   do ii = 1, iba(ik)           ! MPI
                      hr2 = zah_l_noncl(ii,ii2,1,iter2,is) ! MPI
                      hi2 = zah_l_noncl(ii,ii2,2,iter2,is) ! MPI
                      dr2 = zat_l_noncl(ii,ii2,1,iter2,is) ! MPI
                      di2 = zat_l_noncl(ii,ii2,2,iter2,is) ! MPI
                      dr1 = zat_l_noncl(ii,ii1,1,iter1,is) ! MPI
                      di1 = zat_l_noncl(ii,ii1,2,iter1,is) ! MPI
                      w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                      w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                      w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                      w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                   end do
                End do
             end if
          end if
       end do
    end do
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--",iblock)
    ! <n|Vnl|m> 
    call add_nonlocal_part_noncl ! w1hw2 = w1hw2 + w1Vnlw2
                                 ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
!
!!$    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --",iblock)

!    if(ipridavidson >= 2) then
!       write(nfout,*) 'neordr for ik = ',ik
!       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'nrvf_ordr for ik = ',ik
!       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'eig'
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
!    endif
!9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(kimg_t == 1) then
       call dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    endif

    frestart = .false.
    if(ierr_diag /= 0) then
!       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
!       do ib1 = 1, neg
!          if(map_e(ib1) == myrank_e) then         ! MPI
!             eko_l(map_z(ib1),ik)=eko_d(ib1)
!          end if
!       end do
       frestart = .true.
       
       Do is=1, ndim_spinor
          zaj_l(:,nsta:nend,ik+is-1,:) = zat_l_noncl(:,nsta:nend,:,1,is)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik+is-1) = OLD
#endif
       End do

       if(ipridavidson >= 2) then
          write(nfout,*) '** restart Modified Davidson iteration **'
          write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
       end if
!!$print *,'Restart'
       goto 9000

    else

       feigconv(nsta:nend) = .false.
       do ib=1,nel
          if(occup_l(nsta+ib-1,ik) > 0.d0) then
             if(abs(eko_l(nsta+ib-1,ik)-eig(ib)) < delta_eig_occup) &
                  feigconv(nsta+ib-1) = .true.
          else
             if(abs(eko_l(nsta+ib-1,ik)-eig(ib)) < delta_eig_empty) &
                  feigconv(nsta+ib-1) = .true.
          end if
       end do
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_l for ik = ',ik
          write(nfout,*) 'iblock       = ',iblock
          write(nfout,9001) (eko_l(nsta+ib-1,ik),ib=1,nel)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,nel)
          call wd_w1hw2(" -- after diagonalization --",iblock)
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,nel
             dr1=dr1+eko_l(nsta+ib1-1,ik) ! MPI
             dr2=dr2+eig(ib1)
          enddo
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif

!!! (subspace rotation) !!
       call subspace_rotation_noncl ! vec,zat_l -> zat_l

!!( tenchi ) (zaj_l <- zat_l)
!       iter = min(idavid+1,ndavid)
!       call m_ES_W_transpose_back(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
!!       zaj_l_backup(:,nsta:nend,:) = zaj_l(:,nsta:nend,ik,:)
!! (eko_l)

       do ib1 = 1, nel
          eko_l(nsta+ib1-1,ik)=eig(ib1)
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:nel))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel)
       endif
1201   format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001   format(5x,6f12.5)
!!! (neordr & nrvf_ordr)
       !
    end if
9000 continue
    !    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!
!! (deallocate)  
!    deallocate(eko_d)
!    deallocate(eko_d_mpi)
    deallocate(eig)
    deallocate(vec)
!    deallocate(occup)
!    deallocate(occup_mpi)
!
    call tstatc0_end(id_sname)
!
  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
!
    subroutine wd_w1hw2(somecomment,iblock)
      character(len=*), intent(in) :: somecomment
      integer,intent(in) :: iblock
      integer :: ib1, ib2, nel_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      nel_wd = 8
      nsb_wd = 8
      if(nel_wd > nel) nel_wd = nel
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part_noncl
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: tmpr,tmpi

      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: mdvdb

      complex(kind=CMPLDP) :: facv,facq
      real(kind=DP) :: vr,vi,qr,qi, cv1, cv2, cq1, cq2

      do ibb2 = 1,nsize_max_sb_now
         if(ibover(ibb2,iblock)<0) cycle
         ib2 = ibover(ibb2,iblock)
         iter2= (ibb2-1)/nel+1
         ii2  = ibb2-nel*(iter2-1)
         ii2  = nsta+ii2-1
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1,iblock)<0) cycle
            ib1 = ibover(ibb1,iblock)
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            ip0 = ip0b + ib1
!            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if

            do ia = 1, natm
               it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
               mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                     
! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                     if ( mdvdb == SKIP ) then
                        if ( il1 /= il2 ) cycle
                        if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                           if ( im1 /= im2 ) cycle
                        endif
                     endif
#endif
! ---------------------------------------------------- 11.0S

                     Do is1=1, ndim_spinor
                        Do is2=1, ndim_spinor
                           is_tmp = 2*( is1 -1 ) +is2
                           facv = iwei(ia) *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )
                           facq = iwei(ia) *q_noncl( lmt1, lmt2, is_tmp, it )
                           
                           if ( kimg==1 ) then
                              tmpr =  fsr_noncl( ii1, p, iter1, is1 ) &
                                   & *fsr_noncl( ii2, s, iter2, is2 ) &
                                   & +fsi_noncl( ii1, p, iter1, is1 ) &
                                   & *fsi_noncl( ii2, s, iter2, is2 )
                              tmpi = fsr_noncl( ii1, p, iter1, is1 )&
        &                           *fsi_noncl( ii2, s, iter2, is2 )&
        &                          - fsi_noncl( ii1, p, iter1, is1 )&
        &                           *fsr_noncl( ii2, s, iter2, is2 )

                              vr = vr + real( facv )*tmpr -aimag( facv )*tmpi
                              qr = qr + real( facq )*tmpr -aimag( facq )*tmpi

                           else
                              if ( k_symmetry(ik) == GAMMA ) then
                                 tmpr = fsr_noncl( ii1, p, iter1, is1 )&
        &                              *fsr_noncl( ii2, s, iter2, is2 )
                                 vr = vr + real( facv )*tmpr
                                 qr = qr + real( facq )*tmpr
                              else
                                 tmpr = fsr_noncl( ii1, p, iter1, is1 )&
        &                              *fsr_noncl( ii2, s, iter2, is2 )&
        &                             + fsi_noncl( ii1, p, iter1, is1 )&
        &                              *fsi_noncl( ii2, s, iter2, is2 )
                                 tmpi = fsr_noncl( ii1, p, iter1, is1 )&
        &                              *fsi_noncl( ii2, s, iter2, is2 )&
        &                             - fsi_noncl( ii1, p, iter1, is1 )&
        &                              *fsr_noncl( ii2, s, iter2, is2 )

                                 cv1 = real(facv);  cv2 = aimag(facv)
                                 cq1 = real(facq);  cq2 = aimag(facq)

                                 vr = vr + cv1 *tmpr - cv2 *tmpi
                                 vi = vi + cv1 *tmpi + cv2 *tmpr
                                 qr = qr + cq1 *tmpr - cq2 *tmpi
                                 qi = qi + cq1 *tmpi + cq2 *tmpr
                              endif
                           endif
                        End do
                     End do

                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part_noncl

    subroutine subspace_rotation_noncl
      integer :: ib1,ib2,ibb2
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:,:) :: zah_wk
      real(kind=DP), allocatable, dimension(:,:,:)   :: fsr_wk
      real(kind=DP), allocatable, dimension(:,:,:)   :: fsi_wk

      integer :: is, k1

      allocate(zaj_wk(kg1,nel,kimg,ndim_spinor))
      if(itot /= max_iter_david) then
        allocate(zah_wk(kg1,nel,kimg,ndim_spinor))
        zah_wk(:,:,:,:) = 0.d0
      end if

      allocate(fsr_wk(nel,nlmta,ndim_spinor))
      if(k_symmetry(ik) /= GAMMA) then
        allocate(fsi_wk(nel,nlmta,ndim_spinor))
        fsi_wk(:,:,:)=0.d0
      end if

      zaj_wk(:,:,:,:) = 0.d0
      fsr_wk(:,:,:)=0.d0

      if (kimg==1) then
         do ib1=1,nel
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2,iblock)<0) cycle
               ib2 = ibover(ibb2,iblock)
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               hr2=vec(ib2,ib1)

               Do is=1, ndim_spinor
                  do ii=1,iba(ik)
                     zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) &
                          &                 + zat_l_noncl(ii,ii2,kimg,iter2,is)*hr2
                  end do
               End do

               Do is=1, ndim_spinor
                  do ii=1,nlmta
                     fsr_wk(ib1,ii,is) = fsr_wk(ib1,ii,is) &
                          &            + fsr_noncl(ii2,ii,iter2,is) *hr2
                     fsi_wk(ib1,ii,is) = fsi_wk(ib1,ii,is) &
                          &            + fsi_noncl(ii2,ii,iter2,is)*hr2
                  end do
               End do
               if (itot /= max_iter_david) then
                  Do is=1, ndim_spinor
                     do ii=1,iba(ik)
                        zah_wk(ii,ib1,kimg,is) = zah_wk(ii,ib1,kimg,is)  &
                             &                 + zah_l_noncl(ii,ii2,kimg,iter2,is)*hr2
                     end do
                  End do
               end if
            end do
         end do

      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(ib2,ib1)

                  Do is=1, ndim_spinor
                     do ii=1,iba(ik)
                        dr1 = zat_l_noncl(ii,ii2,1   ,iter2,is)
                        di1 = zat_l_noncl(ii,ii2,kimg,iter2,is)
                        zaj_wk(ii,ib1,1,   is) = zaj_wk(ii,ib1,1,   is) + dr1*hr2
                        zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) + di1*hr2
                     end do
                  End do
                  Do is=1, ndim_spinor
                     do ii=1,nlmta
                        fsr_wk(ib1,ii,is) = fsr_wk(ib1,ii,is) &
                             &            + fsr_noncl(ii2,ii,iter2,is)*hr2
                     end do
                  End Do
                  if(itot /= max_iter_david) then
                     Do is=1, ndim_spinor
                        do ii=1,iba(ik)
                           dr1 = zah_l_noncl(ii,ii2,1   ,iter2,is)
                           di1 = zah_l_noncl(ii,ii2,kimg,iter2,is)
                           zah_wk(ii,ib1,1,   is) = zah_wk(ii,ib1,1,   is) +dr1*hr2
                           zah_wk(ii,ib1,kimg,is) = zah_wk(ii,ib1,kimg,is) +di1*hr2
                        end do
                     End do
                  end if
               end do
            end do
         else
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)

                  Do is=1, ndim_spinor
                     do ii=1,iba(ik)
                        dr1 = zat_l_noncl(ii,ii2,1   ,iter2,is)
                        di1 = zat_l_noncl(ii,ii2,kimg,iter2,is)
                        zaj_wk(ii,ib1,1   ,is) = zaj_wk(ii,ib1,1,   is) +dr1*hr2 -di1*hi2
                        zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) +dr1*hi2 +di1*hr2
                     end do
                  End Do
                  Do is=1, ndim_spinor
                     do ii=1,nlmta
                        dr1 = fsr_noncl(ii2,ii,iter2,is)
                        di1 = fsi_noncl(ii2,ii,iter2,is)
                        fsr_wk(ib1,ii,is) = fsr_wk(ib1,ii,is) + dr1*hr2 - di1*hi2
                        fsi_wk(ib1,ii,is) = fsi_wk(ib1,ii,is) + dr1*hi2 + di1*hr2
                     end do
                  End do
                  if (itot /= max_iter_david) then
                     Do is=1, ndim_spinor
                        do ii=1,iba(ik)
                           dr1 = zah_l_noncl(ii,ii2,1   ,iter2,is)
                           di1 = zah_l_noncl(ii,ii2,kimg,iter2,is)
                           zah_wk(ii,ib1,1,   is) = zah_wk(ii,ib1,1,   is) &
                                &                  +dr1*hr2 -di1*hi2
                           zah_wk(ii,ib1,kimg,is) = zah_wk(ii,ib1,kimg,is) &
                                &                  +dr1*hi2 +di1*hr2
                        end do
                     End do
                  end if
               end do
            end do
         end if
      end if
!print *,itot,  itot /= max_iter_david    

      Do is=1, ndim_spinor
         k1 = ik + is -1
         zaj_l(:,nsta:nend,k1,:) = zaj_wk(:,:,:,is)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,k1) = OLD
#endif
      End do

      if(itot /= max_iter_david) then
         Do is=1, ndim_spinor
            zah_l_noncl(:,nsta:nend,:,1,is) = zah_wk(:,:,:,is)
         End do
      endif
      Do is=1, ndim_spinor
         k1 = ik + is -1
         fsr_l(nsta:nend,:,k1) = fsr_wk(:,:,is)
         if (k_symmetry(ik) /= GAMMA) then
            fsi_l(nsta:nend,:,k1) = fsi_wk(:,:,is)
         endif
      End do
      
      deallocate(zaj_wk,fsr_wk)
      if(itot /= max_iter_david) deallocate(zah_wk)
      if(k_symmetry(ik) /= GAMMA) deallocate(fsi_wk)

    end subroutine subspace_rotation_noncl

  end subroutine evolve_WFs_in_subspace_noncl
! ============================================================== 11.0  
  
  subroutine m_ESmddavid_Subspace_Rotation(nfout)
    integer, intent(in) :: nfout     
    
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin
    integer :: ipri0

    allocate(ekin(kg1))
    call m_ES_alloc_scss_etc()
    allocate(afft(nfft)); allocate(bfft(nfft))  
    call allocate_fsri
    
    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          iksnl = (ik-1)/nspin + 1
          
          call allocate_t_matrix_sr(ik) ! -> np_g1k_x
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
          call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l
          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)
          call allreduce_fs_sr(ik) ! -> fsr,fsi
          call evolve_WFs_in_subspace_sr&     !-(m_ES_WF_by_ModifiedDavidson)
                                      &(ik,ispin,ekin,afft,bfft) !-> zaj_l
          if(ik==1.and.ipridavidson>= 2) &
            & call m_ES_wd_zaj_small_portion(nfout,ik," -- after davidson subspace rotation --",21)
          call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
          if(ipridavidson>=2) then
             write(nfout,'("Davidson Subspace Rotation: ik=",i5," subspace=",i5)') ik, nsize_sb_now
          end if
          call deallocate_t_matrix_sr
          
       enddo      ! k-point loop
    enddo      ! spin loop
    
    call deallocate_fsri

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin)
    
  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr
  
  end subroutine m_ESmddavid_Subspace_Rotation
  
  subroutine do_transpose(ik,itot)
     integer, intent(in) :: ik
     integer, intent(in) :: itot
     integer :: i
     integer :: ntot
     real(kind=DP),allocatable,dimension(:,:,:) :: tmp
     allocate(tmp(np_g1k_x,neg,kimg));tmp=0.d0

     ntot = itot+1
     if(sw_MRCV_only==ON) ntot = 2

     zat_l_t=0.d0;zah_l_t=0.d0
     do i=1,ntot
        zaj_l(:,:,ik,:) = zat_l(:,:,:,i)
        call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,tmp)
        zat_l_t(:,:,:,i) = tmp(:,:,:)

        zaj_l(:,:,ik,:) = zah_l(:,:,:,i)
        call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,tmp)
        zah_l_t(:,:,:,i) = tmp(:,:,:)
     enddo
     zaj_l(:,:,ik,:)=wfsd_l(:,:,ik,:)
#ifdef SAVE_FFT_TIMES
     if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
     deallocate(tmp)
  end subroutine do_transpose

  subroutine do_allreduce(ik)
     integer, intent(in) :: ik
     integer :: i,ierr
     integer :: niter
     niter=max_iter_david+1
     if(sw_MRCV_only==ON) niter = 2

     allocate(fsr_mpi(neg,nlmta,niter));fsr_mpi=0.0d0
     if(k_symmetry(ik)/=GAMMA) then
        allocate(fsi_mpi(neg,nlmta,niter))
        fsi_mpi=0.d0
     endif
     feigconv_t=.false.;occup=0;eko_d=0.d0;fsr_t=0.d0
     if(k_symmetry(ik)/=GAMMA) fsi_t=0.d0
     do i=ista_e, iend_e, istep_e
        feigconv_t(i) = feigconv(map_z(i))
        eko_d(i) = eko_l(map_z(i),ik)
        if(occup_l(map_z(i),ik)>0.d0) occup(i)=1
        fsr_t(i,1:nlmta,1:niter) = fsr(map_z(i),1:nlmta,1:niter)
        if(k_symmetry(ik)/=GAMMA) fsi_t(i,1:nlmta,1:niter) = fsi(map_z(i),1:nlmta,1:niter)
     enddo
     call mpi_allreduce(MPI_IN_PLACE,feigconv_t,neg,mpi_logical,mpi_land,mpi_k_world(myrank_k),ierr)
     call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     call mpi_allreduce(MPI_IN_PLACE,occup,neg,mpi_integer,mpi_sum,mpi_k_world(myrank_k),ierr)
     call mpi_allreduce(fsr_t,fsr_mpi,neg*nlmta*niter,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     if(k_symmetry(ik)/=GAMMA) &
     & call mpi_allreduce(fsi_t,fsi_mpi,neg*nlmta*niter,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     fsr_t = fsr_mpi
     if(k_symmetry(ik)/=GAMMA) fsi_t = fsi_mpi
     deallocate(fsr_mpi)
     if(k_symmetry(ik)/=GAMMA) deallocate(fsi_mpi)
  end subroutine do_allreduce

! ================================ added by K. Tagami ================ 11.0
  subroutine m_ESmddavid_Subspace_Rot_noncl(nfout)
    integer, intent(in) :: nfout     
    
    integer             :: ik, iksnl, switch_of_eko_part
    real(kind=DP), allocatable ::  afft_kt(:,:)
    real(kind=DP), allocatable ::  bfft_kt(:,:)
    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)
    real(kind=DP), allocatable, dimension(:) :: ekin
    integer :: ipri0

    integer :: precon, is1, is2, istmp, k2

    precon = ON

    allocate(ekin(kg1))
    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0
    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    call allocate_fsri_noncl
    
    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )    ! (ptfft1) vlhxc_l->afft

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k )  cycle          ! MPI
       iksnl = (ik-1)/ndim_spinor + 1

       call allocate_t_matrix_sr_noncl(ik)         ! -> np_g1k_x
       call m_pwBS_kinetic_energies( ik, vkxyz, ekin ) ! (diakin) ->ekin

       vnlph_noncl = 0.0d0
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             istmp = ( is1-1 )*ndim_spinor +is2
             k2 = ik +is2 -1

             if ( precon==ON ) then
                call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=OFF )
                if(sw_hybrid_functional==ON) call m_ES_Vexx_W(k2)
                ! -> vnlph_l
             else
                call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=ON )
                if(sw_hybrid_functional==ON) call m_ES_Vexx_W(k2)
                ! -> vnlph_l
             endif
             vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
                  &                     + vnlph_l(:,:,:)
          End do
       End do
       
       call allreduce_fs_sr_noncl(ik) ! -> fsr,fsi
       call evolve_WFs_in_subspace_sr_noncl( ik, ekin, afft_kt, bfft_kt ) 
                                             !-> zaj_l
                                             !-(m_ES_WF_by_ModifiedDavidson)
       
       if (ik==1.and.ipridavidson>= 2) then
          Do is1=1, ndim_spinor
             call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, &
                  &                         " -- after davidson subspace rotation --",21 )
          End do
       endif
          
       Do is1=1, ndim_spinor
          call m_ES_betar_dot_WFs_4_each_k( nfout,ik+is1-1 )   ! -> fsr_l,fsi_l
       End do

       if(ipridavidson>=2) then
          write(nfout,'("Davidson Subspace Rotation: ik=",i5," subspace=",i5)') &
               &        ik, nsize_sb_now
       end if
       call deallocate_t_matrix_sr
          
    enddo      ! k-point loop
    
    call deallocate_fsri_noncl

    call m_ES_sort_eigen_vals_noncl()

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate(bfft_kt);   deallocate(afft_kt)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin)
    
  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine m_ESmddavid_Subspace_Rot_noncl
! ================================================================= 11.0

  subroutine allocate_fsri
    nsize_sb_now = neg
    nsize_mt_now =  nsize_sb_now*(nsize_sb_now+1)/2
    allocate(fsr(neg,nlmta,1))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi(neg,nlmta,1))
    end if
    allocate(zaj_l_backup(kg1,np_e,kimg)) ! MPI
  end subroutine allocate_fsri

! ===================== added by K. Tagami ==================== 11.0
  subroutine allocate_fsri_noncl
    nsize_sb_now = neg
    nsize_mt_now =  nsize_sb_now*(nsize_sb_now+1)/2
    allocate(fsr_noncl(neg,nlmta,1,ndim_spinor))
    if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi_noncl(neg,nlmta,1,ndim_spinor))
    end if
    allocate(zaj_l_backup_noncl(kg1,np_e,kimg,ndim_spinor)) ! MPI
  end subroutine allocate_fsri_noncl
! ============================================================== 11.0

  subroutine deallocate_fsri
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    deallocate(zaj_l_backup)
  end subroutine deallocate_fsri
    
! =============================== added by K. Tagami ============= 11.0
  subroutine deallocate_fsri_noncl
    deallocate(fsr_noncl)
    if(.not.(kv3/ndim_spinor == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi_noncl)
    end if
    deallocate(zaj_l_backup_noncl)
  end subroutine deallocate_fsri_noncl
! ================================================================= 11.0    

  subroutine allocate_t_matrix_sr(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(np_g1k_x,neg,kimg,1)) ! MPI
    allocate(zah_l(np_g1k_x,neg,kimg,1)) ! MPI
    allocate(w1hw2(nsize_mt_now*kimg_t))
    allocate(w1sw2(nsize_mt_now*kimg_t))
    if(npes>1) then
       allocate(w1hw2_mpi(nsize_mt_now*kimg_t))
       allocate(w1sw2_mpi(nsize_mt_now*kimg_t))
    end if
    zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
  end subroutine allocate_t_matrix_sr

! =============================== added by K. Tagami ============= 11.0
  subroutine allocate_t_matrix_sr_noncl(ik)
    integer, intent(in) :: ik
    integer :: kimg_t, is

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif

    allocate(zat_l_noncl(np_g1k_x,neg,kimg,1,ndim_spinor)) ! MPI
    allocate(zah_l_noncl(np_g1k_x,neg,kimg,1,ndim_spinor)) ! MPI
    allocate(w1hw2(nsize_mt_now*kimg_t))
    allocate(w1sw2(nsize_mt_now*kimg_t))

    if(npes>1) then
! ------------- -------------------- KTDebug : 2012/10/28 --
!!       allocate(w1hw2_mpi(nsize_mt_now*kimg_t))
!!       allocate(w1sw2_mpi(nsize_mt_now*kimg_t))
!
       if ( allocated(w1hw2_mpi) ) deallocate(w1hw2_mpi)
       if ( allocated(w1sw2_mpi) ) deallocate(w1sw2_mpi)
       allocate(w1hw2_mpi(nsize_mt_now*kimg_t))
       allocate(w1sw2_mpi(nsize_mt_now*kimg_t))
! ------------- -------------------- KTDebug : 2012/10/28 --
    end if

    Do is=1, ndim_spinor
       zaj_l_backup_noncl(:,:,:,is) = zaj_l(:,:,ik+is-1,:)
    End Do
  end subroutine allocate_t_matrix_sr_noncl
! ============================================================ 11.0

  subroutine deallocate_t_matrix_sr
! ============================ modified by K. Tagami ========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

    if ( noncol ) then
       deallocate(zat_l_noncl) ! MPI
       deallocate(zah_l_noncl) ! MPI
    else
       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
    endif
! ============================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    if(npes>1) then
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    end if
  end subroutine deallocate_t_matrix_sr
  
  subroutine allreduce_fs_sr(ik)
    integer, intent(in) :: ik
    integer :: ib,ib1,kimg_t
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi

    allocate(fs_mpi(neg,nlmta))
    
    fs_mpi=0.d0
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib=map_z(ib1)
       fs_mpi(ib1,1:nlmta) = fsr_l(ib,1:nlmta,ik)
    end do
    call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
      & ,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
    fsr(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    if(.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do ib1 = ista_e, iend_e, istep_e     ! MPI
          ib=map_z(ib1)
          fs_mpi(ib1,1:nlmta) = fsi_l(ib,1:nlmta,ik)
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
         & ,mpi_double_precision,mpi_sum ,mpi_k_world(myrank_k),ierr)       ! MPI
       fsi(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    end if
    deallocate(fs_mpi)
  end subroutine allreduce_fs_sr
! ================================= added by K. Tagami ============= 11.0  
  subroutine allreduce_fs_sr_noncl(ik)
    integer, intent(in) :: ik

    integer :: ib, ib1, kimg_t, is
    real(kind=DP), allocatable, dimension(:,:,:) :: fs_mpi,fs_mpi2

    allocate(fs_mpi(neg,nlmta,ndim_spinor))
    allocate(fs_mpi2(neg,nlmta,ndim_spinor))
    
    fs_mpi=0.d0
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib=map_z(ib1)
       Do is=1, ndim_spinor
          fs_mpi(ib1,1:nlmta,is) = fsr_l(ib,1:nlmta,ik+is-1)
       End Do
    end do

    fs_mpi2=0.d0
    call mpi_allreduce( fs_mpi, fs_mpi2, neg*nlmta*ndim_spinor, &
         &              mpi_double_precision, mpi_sum, &
         &              mpi_k_world(myrank_k),ierr )       ! MPI

    fsr_noncl(1:neg,1:nlmta,1,:) = fs_mpi2(1:neg,1:nlmta,:)

    if (.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do ib1 = ista_e, iend_e, istep_e     ! MPI
          ib=map_z(ib1)
          Do is=1, ndim_spinor
             fs_mpi(ib1,1:nlmta,is) = fsi_l(ib,1:nlmta,ik+is-1)
          End do
       end do

       fs_mpi2=0.d0
       call mpi_allreduce( fs_mpi, fs_mpi2, neg*nlmta*ndim_spinor, &
            &              mpi_double_precision, mpi_sum, &
            &              mpi_k_world(myrank_k),ierr )       ! MPI

       fsi_noncl(1:neg,1:nlmta,1,:) = fs_mpi2(1:neg,1:nlmta,:)
    end if

    deallocate(fs_mpi);    deallocate(fs_mpi2)

  end subroutine allreduce_fs_sr_noncl
! ============================================================= 11.0
  
  subroutine evolve_WFs_in_subspace_sr(ik,ispin,ekin,afft,bfft)
    integer, intent(in) :: ik,ispin
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
!    integer       :: ibb1,ibb2
!    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
!    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0
    call tstatc0_begin('evolve_WFs_in_subspace_sr(davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
!    nsize_sb_now = nsize_subspace(1)
!    nsize_mt_now = nsize_matrix(1)

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(occup(neg)); occup=0

    if(ipridavidson >=2) then
       write(nfout,*) 'MdDavidson Subspace Rotation:ik,nsize_sb_now=', ik,nsize_sb_now
    end if


    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(MPI_IN_PLACE,occup,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)
    call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,1))
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
       if(kimg == 1) then
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(ii,ib,ik,1)
             dr2 = bfft(i1)*denom
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+dr2
          enddo
       else
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(ii,ib,ik,1)
             di1  = zaj_l(ii,ib,ik,kimg)
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
             zaj_l(ii,ib,ik,kimg)= ekin(ii)*di1+bfft(2*i1)*denom
          enddo
       endif
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    enddo
!( tenchi ) (zah_l <- zaj_l)
    call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zah_l(1,1,1,1))

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    do ib2 = 1,nsize_sb_now
       ip0b = ib2*(ib2-1)/2
       do ib1 = 1,ib2
          ip0 = ip0b + ib1
          if(kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
             do ii = 1, np_g1k(ik)            ! MPI
                hr2 = zah_l(ii,ib2,1,1)
                dr2 = zat_l(ii,ib2,1,1)
                dr1 = zat_l(ii,ib1,1,1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
                ig1 = 1;  if(myrank_e == 0) ig1 = 2
                do ii = ig1, np_g1k(ik)            ! MPI
                   hr2 = zah_l(ii,ib2,1,1) ! MPI
                   hi2 = zah_l(ii,ib2,2,1) ! MPI
                   dr2 = zat_l(ii,ib2,1,1) ! MPI
                   di2 = zat_l(ii,ib2,2,1) ! MPI
                   dr1 = zat_l(ii,ib1,1,1) ! MPI
                   di1 = zat_l(ii,ib1,2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
!!$                if(mype == 0) then
                if(myrank_e == 0) then
                   hr2 = zah_l(1,ib2,1,1) ! MPI
                   hi2 = zah_l(1,ib2,2,1) ! MPI
                   dr2 = zat_l(1,ib2,1,1) ! MPI
                   di2 = zat_l(1,ib2,2,1) ! MPI
                   dr1 = zat_l(1,ib1,1,1) ! MPI
                   di1 = zat_l(1,ib1,2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                do ii = 1, np_g1k(ik)           ! MPI
                   hr2 = zah_l(ii,ib2,1,1) ! MPI
                   hi2 = zah_l(ii,ib2,2,1) ! MPI
                   dr2 = zat_l(ii,ib2,1,1) ! MPI
                   di2 = zat_l(ii,ib2,2,1) ! MPI
                   dr1 = zat_l(ii,ib1,1,1) ! MPI
                   di1 = zat_l(ii,ib1,2,1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
    end do
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = 0
       ndata = nsize_mt_now*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif

    if(ierr_diag /= 0) then
       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eko_d(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          write(nfout,*) '** Mod Davidson SR error **'
          stop
       end if
    else

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,neg
             ib1to = neordr(ib1,ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik) ! MPI
             dr2=dr2+eig(ib1)
          enddo
          call mpi_allreduce(MPI_IN_PLACE,dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif
!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
!( tenchi ) (zaj_l <- zat_l)
       call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,1))
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
!! (eko_l)
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eig(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,neg)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
! ========================== added by K. Tagami ========== 11.0
#ifdef forsafe
      integer :: ipaw_tmp
#endif
! ======================================================== 11.0
      do ib2 = 1,nsize_sb_now
         ip0b = ib2*(ib2-1)/2
         do ib1 = 1,ib2
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
! ========================== added by K. Tagami =================== 11.0
#ifdef forsafe
               ipaw_tmp = ipaw(it)
#endif
! ================================================================= 11.0
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
!OCL NOPREEX
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
! ========================== modified by K. Tagami =================== 11.0
!                     if(ipaw(it)==0)then
#ifdef forsafe
                     if ( ipaw_tmp == 0 ) then
#else
                     if (ipaw(it)==0 ) then
#endif
! ================================================================= 11.0
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                           tmpi = fsr(ib1,p,1)*fsi(ib2,s,1)&
                    &        - fsi(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part

    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
      allocate(zaj_wk(np_g1k_x,neg,kimg))

      zaj_wk(:,:,:) = 0.d0
      if(kimg==1) then
         do ib1=1,neg
            do ib2=1,neg
               do ii=1,np_g1k(ik)
                  zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + zat_l(ii,ib2,kimg,1)*vec(ib2,ib1)
               end do
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,neg
               do ib2=1,neg
                  hr2=vec(ib2,ib1)
                  do ii=1,np_g1k(ik)
                     dr1=zat_l(ii,ib2,1   ,1)
                     di1=zat_l(ii,ib2,kimg,1)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + di1*hr2
                  end do
               end do
            end do
         else
            do ib1=1,neg
               do ib2=1,neg
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
                  do ii=1,np_g1k(ik)
                     dr1=zat_l(ii,ib2,1   ,1)
                     di1=zat_l(ii,ib2,kimg,1)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
               end do
            end do
         end if
      end if
      zat_l(:,:,:,1) = zaj_wk(:,:,:)
      deallocate(zaj_wk)
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_sr

! =========================== added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_subspace_sr_noncl( ik, ekin, afft_kt, bfft_kt )
    integer, intent(in) :: ik
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)

! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
!    integer       :: ibb1,ibb2
!    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
!    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0

    integer :: is, k1

    call tstatc0_begin('evolve_WFs_in_subspace_sr_noncl(davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
!    nsize_sb_now = nsize_subspace(1)
!    nsize_mt_now = nsize_matrix(1)

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(occup(neg)); occup=0

    if(ipridavidson >=2) then
       write(nfout,*) 'MdDavidson Subspace Rotation:ik,nsize_sb_now=', ik,nsize_sb_now
    end if


    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(MPI_IN_PLACE,occup,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)

    Do is=1, ndim_spinor
       k1 = ik + is -1
       call m_ES_W_transpose_r(.false., ista_k, iend_k, k1, zaj_l, &
            &                 zat_l_noncl(1,1,1,1,is))
    End do

    do ib1 = ista_e, iend_e, istep_e     ! MPI
       Do is=1, ndim_spinor
          k1 = ik +is -1
         call m_ES_WF_in_Rspace( k1, ib1, bfft_kt(:,is) )!(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                       ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
       if (kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1 = zaj_l(ii,ib,k1,1)
                dr2 = bfft_kt(i1,is)*denom
                zaj_l(ii,ib,k1,1) = ekin(ii)*dr1 +dr2
             enddo
#ifdef SAVE_FFT_TIMES
             if(sw_save_fft == ON) status_saved_phifftr(ib,k1) = OLD
#endif
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do ii=1,iba(ik)
                i1  = igf(nbase(ii,ik))
                dr1  = zaj_l(ii,ib,k1,1)
                di1  = zaj_l(ii,ib,k1,kimg)
                zaj_l(ii,ib,k1,1)   = ekin(ii)*dr1 +bfft_kt(2*i1-1,is)*denom
                zaj_l(ii,ib,k1,kimg)= ekin(ii)*di1 +bfft_kt(2*i1,  is)*denom
             enddo
#ifdef SAVE_FFT_TIMES
             if(sw_save_fft == ON) status_saved_phifftr(ib,k1) = OLD
#endif
          End Do
       endif
    enddo
!( tenchi ) (zah_l <- zaj_l)
    Do is=1, ndim_spinor
       k1 = ik + is -1
       call m_ES_W_transpose_r(.false., ista_k, iend_k, k1, zaj_l, &
            &                 zah_l_noncl(1,1,1,1,is) )
    End do

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    do ib2 = 1,nsize_sb_now
       ip0b = ib2*(ib2-1)/2
       do ib1 = 1,ib2
          ip0 = ip0b + ib1
          if (kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0

             Do is=1, ndim_spinor
                do ii = 1, np_g1k(ik)            ! MPI
                   hr2 = zah_l_noncl(ii,ib2,1,1,is)
                   dr2 = zat_l_noncl(ii,ib2,1,1,is)
                   dr1 = zat_l_noncl(ii,ib1,1,1,is)
                   w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                   w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
                end do
             End Do
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
                ig1 = 1;  if(myrank_e == 0) ig1 = 2

                Do is=1, ndim_spinor
                   do ii = ig1, np_g1k(ik)            ! MPI
                      hr2 = zah_l_noncl(ii,ib2,1,1,is) ! MPI
                      hi2 = zah_l_noncl(ii,ib2,2,1,is) ! MPI
                      dr2 = zat_l_noncl(ii,ib2,1,1,is) ! MPI
                      di2 = zat_l_noncl(ii,ib2,2,1,is) ! MPI
                      dr1 = zat_l_noncl(ii,ib1,1,1,is) ! MPI
                      di1 = zat_l_noncl(ii,ib1,2,1,is) ! MPI
                      w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                      w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                   end do
                End do
!!$                if(mype == 0) then

                if(myrank_e == 0) then
                   Do is=1, ndim_spinor
                      hr2 = zah_l_noncl(1,ib2,1,1,is) ! MPI
                      hi2 = zah_l_noncl(1,ib2,2,1,is) ! MPI
                      dr2 = zat_l_noncl(1,ib2,1,1,is) ! MPI
                      di2 = zat_l_noncl(1,ib2,2,1,is) ! MPI
                      dr1 = zat_l_noncl(1,ib1,1,1,is) ! MPI
                      di1 = zat_l_noncl(1,ib1,2,1,is) ! MPI
                      w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                      w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                   End do
                end if
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                Do is=1, ndim_spinor
                   do ii = 1, np_g1k(ik)           ! MPI
                      hr2 = zah_l_noncl(ii,ib2,1,1,is) ! MPI
                      hi2 = zah_l_noncl(ii,ib2,2,1,is) ! MPI
                      dr2 = zat_l_noncl(ii,ib2,1,1,is) ! MPI
                      di2 = zat_l_noncl(ii,ib2,2,1,is) ! MPI
                      dr1 = zat_l_noncl(ii,ib1,1,1,is) ! MPI
                      di1 = zat_l_noncl(ii,ib1,2,1,is) ! MPI
                      w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                      w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                      w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                      w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                   end do
                End do
             end if
          end if
       end do
    end do

    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    call add_nonlocal_part_noncl  ! w1hw2 = w1hw2 + w1Vnlw2
                                  ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = 0
       ndata = nsize_mt_now*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif

    if(ierr_diag /= 0) then
       Do is=1, ndim_spinor
          zaj_l(:,:,ik+is-1,:) = zaj_l_backup_noncl(:,:,:,is)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(:,ik+is-1) = OLD
#endif
       End do
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eko_d(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          write(nfout,*) '** Mod Davidson SR error **'
          stop
       end if
    else

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,neg
             ib1to = neordr(ib1,ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik) ! MPI
             dr2=dr2+eig(ib1)
          enddo
          call mpi_allreduce(MPI_IN_PLACE,dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif


!! (subspace rotation) !!
       call subspace_rotation_noncl          ! vec,zat_l -> zat_l
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

!( tenchi ) (zaj_l <- zat_l)
       Do is=1, ndim_spinor
          k1 = ik + is -1
          call m_ES_W_transpose_back_r(.false., ista_k, iend_k, k1, zaj_l, &
               &                      zat_l_noncl(1,1,1,1,is) )
          zaj_l_backup_noncl(:,:,:,is) = zaj_l(:,:,k1,:)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(:,k1) = OLD
#endif
       End do

!! (eko_l)
       do ib1 = 1, neg
          if(map_e(ib1) == myrank_e) then         ! MPI
             eko_l(map_z(ib1),ik)=eig(ib1)
          end if
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,neg)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part_noncl
      integer :: ip,ib1,ib2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: mdvdb

      complex(kind=CMPLDP) :: facv,facq
      real(kind=DP) :: vr,vi,qr,qi, cv1, cv2, cq1, cq2
      real(kind=DP) :: tmpr,tmpi

      do ib2 = 1,nsize_sb_now
         ip0b = ib2*(ib2-1)/2
         do ib1 = 1,ib2
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if

            do ia = 1, natm
               it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
               mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                     if ( mdvdb == SKIP ) then
                        if ( il1 /= il2 ) cycle
                        if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                           if ( im1 /= im2 ) cycle
                        endif
                     endif
#endif
! ---------------------------------------------------- 11.0S

                     Do is1=1, ndim_spinor
                        Do is2=1, ndim_spinor
                           is_tmp = 2*( is1 -1 ) +is2
                           facv = iwei(ia) *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )
                           facq = iwei(ia) *q_noncl( lmt1, lmt2, is_tmp, it )

                           if ( kimg==1 ) then
                              tmpr = fsr_noncl( ib1, p, 1, is1 ) &
        &                           *fsr_noncl( ib2, s, 1, is2 ) &
        &                          + fsi_noncl( ib1, p, 1, is1 ) &
        &                           *fsi_noncl( ib2, s, 1, is2 )
                              tmpi = fsr_noncl( ib1, p, 1, is1 )&
        &                           *fsi_noncl( ib2, s, 1, is2 )&
        &                          - fsi_noncl( ib1, p, 1, is1 )&
        &                           *fsr_noncl( ib2, s, 1, is2 )
                              vr = vr + real( facv )*tmpr -aimag( facv )*tmpi
                              qr = qr + real( facq )*tmpr -aimag( facq )*tmpi
                           else
                              if ( k_symmetry(ik) == GAMMA ) then
                                 tmpr = fsr_noncl( ib1, p, 1, is1 )&
        &                              *fsr_noncl( ib2, s, 1, is2 )
                                 vr = vr + real( facv )*tmpr
                                 qr = qr + real( facq )*tmpr
                              else
                                 tmpr = fsr_noncl( ib1, p, 1, is1 )&
        &                              *fsr_noncl( ib2, s, 1, is2 )&
                    &                 + fsi_noncl( ib1, p, 1, is1 )&
        &                              *fsi_noncl( ib2, s, 1, is2 )
                                 tmpi = fsr_noncl( ib1, p, 1, is1 )&
        &                              *fsi_noncl( ib2, s, 1, is2 )&
        &                             - fsi_noncl( ib1, p, 1, is1 )&
        &                              *fsr_noncl( ib2, s, 1, is2 )

                                 cv1 = real(facv);  cv2 = aimag(facv)
                                 cq1 = real(facq);  cq2 = aimag(facq)

                                 vr = vr + cv1 *tmpr - cv2 *tmpi
                                 vi = vi + cv1 *tmpi + cv2 *tmpr
                                 qr = qr + cq1 *tmpr - cq2 *tmpi
                                 qi = qi + cq1 *tmpi + cq2 *tmpr

                              endif
                           end if
                        End do
                     End do
                  end do
               end do
            end do

            if ( kimg_t==1 ) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part_noncl

    subroutine subspace_rotation_noncl
      integer :: ib1,ib2,ibb2, is
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_wk
      allocate(zaj_wk(np_g1k_x,neg,kimg,ndim_spinor))

      zaj_wk = 0.d0
      if (kimg==1) then
         do ib1=1,neg
            do ib2=1,neg
               Do is=1, ndim_spinor
                  do ii=1,np_g1k(ik)
                     zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) &
                          &                 + zat_l_noncl(ii,ib2,kimg,1,is)*vec(ib2,ib1)
                  end do
               End Do
            end do
         end do
      else
         if (k_symmetry(ik) == GAMMA) then
            do ib1=1,neg
               do ib2=1,neg
                  hr2=vec(ib2,ib1)
                  Do is=1, ndim_spinor
                     do ii=1,np_g1k(ik)
                        dr1 = zat_l_noncl(ii,ib2,1   ,1,is)
                        di1 = zat_l_noncl(ii,ib2,kimg,1,is)
                        zaj_wk(ii,ib1,1   ,is) = zaj_wk(ii,ib1,1   ,is) +dr1*hr2
                        zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) +di1*hr2
                     end do
                  End do
               end do
            end do
         else
            do ib1=1,neg
               do ib2=1,neg
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
                  Do is=1, ndim_spinor
                     do ii=1,np_g1k(ik)
                        dr1 = zat_l_noncl(ii,ib2,1   ,1,is)
                        di1 = zat_l_noncl(ii,ib2,kimg,1,is)
                        zaj_wk(ii,ib1,1   ,is) = zaj_wk(ii,ib1,1   ,is) +dr1*hr2 -di1*hi2
                        zaj_wk(ii,ib1,kimg,is) = zaj_wk(ii,ib1,kimg,is) +dr1*hi2 +di1*hr2
                     end do
                  End do

               end do
            end do
         end if
      end if

      Do is=1, ndim_spinor
         zat_l_noncl(:,:,:,1,is) = zaj_wk(:,:,:,is)
      End Do
      deallocate(zaj_wk)

    end subroutine subspace_rotation_noncl

  end subroutine evolve_WFs_in_subspace_sr_noncl
! =================================================================== 11.0

  subroutine dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*neg) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel
    
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver
  
  subroutine dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr,nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*nel) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver_loc
#ifdef DGEMM_PSUBSPACE
  subroutine dsygvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now)               :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*nel)           :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    real(kind=DP) :: vl, vu, abstol, work_tmp
    real(kind=DP), allocatable, dimension(:) :: work
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, iwork, ifail, info)

    lwork = int(work_tmp)
    allocate(work(lwork))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(dsygvx) info=",info
       write(nfout,*) "debug(dsygvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dsygvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dsygvx_driver
#endif

  subroutine zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*kimg,nsize_sb_now) :: vec
    real(kind=DP), intent(in) ,dimension(nsize_mt_now*kimg) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    real(kind=DP),allocatable,dimension(:) :: rwork_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now*kimg) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp
    integer :: ib,i

    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(2*nsize_sb_now*kimg)); work_lapack = 0.d0
    allocate(rwork_lapack(7*nsize_sb_now)); rwork_lapack = 0.d0
    allocate(iwork_lapack(5*nsize_sb_now)); iwork_lapack = 0
    allocate(ifail_lapack(nsize_sb_now)); ifail_lapack=0
    allocate(ap(nsize_mt_now*kimg));ap=0.d0
    allocate(bp(nsize_mt_now*kimg));bp=0.d0

    if(ipridavidson >=3 ) then
       write(nfout,*) "debug(zhpgvx) i,w1hw2,w1sw2"
       do ib=1,nsize_sb_now
          i = ib*(ib-1)/2 + ib
          write(nfout,*) ib,w1hw2(2*i-1),w1sw2(2*i-1)
       end do
       ap = w1sw2
       write(nfout,*) "debug(zhpgvx) i,ap,w1sw2"
       do i=1,nsize_mt_now
          write(nfout,*) i,ap(2*i-1),w1sw2(2*i-1)
       end do
       call zhpevx('N','A','U',nsize_sb_now,ap,vl,vu,il,iu,abstol,m &
    &          ,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)
       write(nfout,*) "debug(zhpgvx) eig of w1sw2"
       do ib=1,nsize_sb_now
          write(nfout,*) ib,eig(ib)
       end do
    end if

    ap = w1hw2
    bp = w1sw2

    call zhpgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(zhpgvx) info=",info
       write(nfout,*) "debug(zhpgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(zhpgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if
    
    deallocate(work_lapack)
    deallocate(rwork_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)
    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "zhpgvx: info=",info
       !!stop 'error in zhpgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhpgvx_driver
#ifdef DGEMM_PSUBSPACE
  subroutine zhegvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in):: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*kimg, nel) :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now*kimg, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    complex(kind=DP) :: work_tmp
    complex(kind=DP), allocatable, dimension(:) :: work
    real(kind=DP), allocatable, dimension(:) :: rwork
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP) :: vl, vu, abstol
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(rwork(7*nsize_sb_now))
    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, rwork, iwork, ifail, info)

    lwork = int(real(work_tmp))
    allocate(work(lwork))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, rwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(zhegvx) info=",info
       write(nfout,*) "debug(zhegvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(zhegvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if
    
    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhegvx_driver
#endif
  
  subroutine m_ESmddavid_Renew_WF(nfout,precon)
    integer, intent(in) :: nfout,precon
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: iblock,itot
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin,p
    logical :: frestart
    integer :: iblock_now, itot_now, ipri0
    integer :: n_unconv

    allocate(ekin(kg1),p(kg1))
    call m_ES_alloc_scss_etc()
    allocate(afft(nfft)); allocate(bfft(nfft))

    call allocate_matrix()
    if(sw_hybrid_functional==ON) then
       call m_ES_EXX_gather_valence_states(nfout)
    endif
    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
!!$       call tstatc0_begin('m_ESmddavid_Renew_WF ', id_sname,1)
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          iksnl = (ik-1)/nspin + 1
          call allocate_t_matrix(ik)
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
          feigconv = .false.
          Loop: do itot=1,max_iter_david
             itot_now = itot
             if(ipridavidson >= 2 .and. ik == 1) write(nfout,'(" itot = ",i8, " nblock = ", i8)') itot,nblock
             call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=ON) ! -> vnlph_l
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)
             call decide_correction_vector(precon,ik,ekin,afft,bfft,p)   ! -> wfsd_l
             call prepare_Hloc_phi(ik,ispin,ekin,afft,bfft,itot)  
!print *,ik,itot  
!!$if(ipridavidson>=2) write(nfout,*) 'B',feigconv     
             Block_Loop: do iblock=1,nblock
                iblock_now = iblock
                call evolve_WFs_in_subspace(ik,ispin,iblock,itot,frestart)
             end do Block_Loop
!!$if(ipridavidson>=2) write(nfout,*) 'A',feigconv
!             call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
          end do Loop
          if(ipridavidson>=2) then
             write(nfout,'("Mddavid: ik=",i5," itot=",i5," subspace=",i5)') &
                                                                 ik, itot_now, nsize_sb_now
          end if
          call deallocate_t_matrix
       enddo      ! k-point loop
!!$       call tstatc0_end(id_sname)
    enddo      ! spin loop
    call deallocate_matrix
!    if(ipridavidson>=2) then
!       write(nfout,'("Modified Davidson: max_itot=",i5)') max_itot
!    end if
!
    call m_ES_sort_eigen_values()
!!!  ( in case of af=1 )
!    if(af /= 0) then
!       call cp_eigen_values_for_af       !-(contained here)
!       call expand_neordr_and_nrvf_ordr  !-(contained here)
!    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
!
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin,p)
!deallocate(vnldi,hdiag,sdiag)

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,np_e
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged
    
  end subroutine m_ESmddavid_Renew_WF
  
  subroutine allocate_matrix()
    integer:: i,j
    integer :: np_e_tmp
    integer, save :: parameter_printed = OFF
    np_e_tmp = np_e 
    if(sw_divide_subspace==OFF) np_e_tmp=neg

    nblock = npartition_david
    if(np_e .lt. npartition_david) nblock = np_e
!!$    nblock = npartition_mddavid
!!$    if(np_e .lt. npartition_mddavid) nblock = np_e
    if(sw_divide_subspace==OFF) nblock=1
    
    allocate(nsize_subspace(nblock))
    allocate(nsize_matrix(nblock))
    allocate(ista_e_l(nblock))
    allocate(iend_e_l(nblock))
    allocate(ielm_e_l(nblock))
    ielm_e_l=np_e_tmp/nblock
    j = mod(np_e_tmp,nblock)
    do i = 1, j
       ielm_e_l(i) = ielm_e_l(i) + 1
    end do
    ista_e_l(1) = 1
    do i = 2, nblock
       ista_e_l(i) = ista_e_l(i-1) + ielm_e_l(i-1)
       iend_e_l(i-1) = ista_e_l(i) - 1
    end do
    iend_e_l(nblock) = np_e_tmp
    do i=1,nblock
      if(sw_MRCV_only==ON)then
        nsize_subspace(i)=ielm_e_l(i)*2
        nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      else
        nsize_subspace(i)=ielm_e_l(i)*(max_iter_david+1)
        nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      endif
    end do
    msize_subspace=maxval(nsize_subspace)
    msize_matrix=maxval(nsize_matrix)
    allocate(feigconv(np_e))
    allocate(ibover(msize_subspace,nblock))
    if(sw_MRCV_only==ON)then
       allocate(fsr(np_e,nlmta,2));fsr=0.d0
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,2));fsi=0.d0
       end if
    else
       allocate(fsr(np_e,nlmta,max_iter_david+1))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,max_iter_david+1))
       end if
    endif
    eps_residual = eps_david
    if(sw_MRCV_only==OFF)then
       allocate(zajold_l(kg1,np_e,kimg))
       allocate(fsrold_l(np_e,nlmta))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         allocate(fsiold_l(np_e,nlmta))
       endif
    end if
    if(ipridavidson >= 1 .and. parameter_printed == OFF) then
       write(nfout,'(" ---- Parameters decided in allocate_matrix of MdDavidson ---")')
       write(nfout,'(" -- npartition_david, nblock, np_e = ",3i8," --")') &
            & npartition_david, nblock, np_e
       write(nfout,'(" -- ista_e_l, iend_e_l, ielm_e_l --")')
       do i = 1, nblock
          write(nfout,'(" (",i3,")",3i9)') i, ista_e_l(i), iend_e_l(i), ielm_e_l(i)
       end do
       parameter_printed = ON
    end if
  end subroutine allocate_matrix

  
  subroutine deallocate_matrix
    deallocate(nsize_subspace)
    deallocate(nsize_matrix)
    deallocate(ista_e_l)
    deallocate(iend_e_l)
    deallocate(ielm_e_l)
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    if(sw_MRCV_only==OFF)then
       deallocate(zajold_l)
       deallocate(fsrold_l)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         deallocate(fsiold_l)
       end if
    endif
  end subroutine deallocate_matrix

  subroutine allocate_t_matrix(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    integer :: niter
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    
    niter=max_iter_david+1
    if(sw_MRCV_only==ON) niter = 2
    allocate(zat_l(kg1,np_e,kimg,niter)) ! MPI
    allocate(zah_l(kg1,np_e,kimg,niter)) ! MPI
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(w1hw2(msize_matrix*kimg_t))
    allocate(w1sw2(msize_matrix*kimg_t))
    allocate(wfsd_l(kg1,np_e,ik:ik,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik:ik)); bsdr_l = 0.d0
    allocate(bsdi_l(np_e,nlmta,ik:ik)); bsdi_l = 0.d0
    if(sw_MRCV_only==OFF)then
       zajold_l(:,:,:)=zaj_l(:,:,ik,:)
       fsrold_l(:,:)=fsr_l(:,:,ik)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         fsiold_l(:,:)=fsi_l(:,:,ik)
       end if
    endif
    if(sw_divide_subspace==OFF)then
       allocate(zat_l_t(np_g1k_x,neg,kimg,niter));zat_l_t=0.d0 ! MPI
       allocate(zah_l_t(np_g1k_x,neg,kimg,niter));zah_l_t=0.d0 ! MPI
       allocate(feigconv_t(neg));feigconv_t=.false.
       allocate(fsr_t(neg,nlmta,niter));fsr_t=0.d0
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi_t(neg,nlmta,niter));fsi_t=0.d0
       endif
       allocate(w1hw2_mpi(msize_matrix*kimg_t));w1hw2_mpi=0.0d0
       allocate(w1sw2_mpi(msize_matrix*kimg_t));w1sw2_mpi=0.0d0
    endif
  end subroutine allocate_t_matrix


  subroutine deallocate_t_matrix
! ================================== modified by K. Tagami =========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

    if ( noncol ) then
       deallocate(zat_l_noncl) ! MPI
       deallocate(zah_l_noncl) ! MPI
    else
       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
    endif
! ==================================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    deallocate(wfsd_l)
    deallocate(bsdr_l)
    deallocate(bsdi_l)
    if(sw_divide_subspace==OFF)then
       if ( allocated( zat_l_t ) ) deallocate(zat_l_t)
       if ( allocated( zah_l_t ) ) deallocate(zah_l_t)
       if ( allocated( feigconv_t ) ) deallocate(feigconv_t)
       if ( allocated( fsr_t) ) deallocate(fsr_t)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          if ( allocated( fsi_t) ) deallocate(fsi_t)
       endif
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    endif
  end subroutine deallocate_t_matrix
  
  subroutine prepare_Hloc_phi(ik,ispin,ekin,afft,bfft,itot)
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: itot
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)

    integer       :: ib1,i1,ii,ib
    real(kind=DP) :: denom
    real(kind=DP) :: dr1,dr2,di1,di2,dd
    integer :: is,is1,ib2,ibesize
    integer :: id_sname = -1, id_sname1=-1, id_sname2=-1, id_sname3=-1, ipri0
    real(kind=DP), allocatable, dimension(:,:) :: vexx
    integer :: niter
    integer :: ng
    call tstatc0_begin('prepare_Hloc_phi ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(sw_hybrid_functional==ON) then
        ng = kg1
        allocate(vexx(ng,kimg))
        vexx = 0.0d0
    endif
! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)

    if(sw_MRCV_only==ON)then
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
       zat_l(:,:,:,2) = wfsd_l(:,:,ik,:)
       fsr(:,:,1)=fsr_l(:,:,ik)
       fsr(:,:,2)=bsdr_l(:,:,ik)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fsi(:,:,1)=fsi_l(:,:,ik)
          fsi(:,:,2)=bsdi_l(:,:,ik)
       end if
    else
        zat_l(:,:,:,itot+1) = wfsd_l(:,:,ik,:)
        fsr(:,:,itot+1)=bsdr_l(:,:,ik)
        if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
           fsi(:,:,itot+1)=bsdi_l(:,:,ik)
        end if
    endif

    if(itot == 1) then

      do ib1 = ista_e, iend_e, istep_e     ! MPI
         call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
         call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
         call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
         ib = map_z(ib1)                 ! MPI

         if(sw_hybrid_functional==ON) then
            if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr_l(ib,1:nlmta,ik),fsi_l(ib,1:nlmta,ik),vexx,0)
            else
                call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr_l(ib,1:nlmta,ik),fsr_l(ib,1:nlmta,ik),vexx,0)
            endif
         endif

         if(kimg == 1) then
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1 = zaj_l(ii,ib,ik,1)
               dr2 = bfft(i1)*denom
               zah_l(ii,ib,1,1) = ekin(ii)*dr1+dr2
            enddo
            if(sw_hybrid_functional==ON)then
               do ii=1,iba(ik)
                  zah_l(ii,ib,1,1) = zah_l(ii,ib,1,1) + vexx(ii,1)
               enddo
            endif
         else
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1  = zaj_l(ii,ib,ik,1)
               di1  = zaj_l(ii,ib,ik,kimg)
               zah_l(ii,ib,1,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
               zah_l(ii,ib,kimg,1)= ekin(ii)*di1+bfft(2*i1)*denom
            enddo
            if(sw_hybrid_functional==ON)then
               do ii=1,iba(ik)
                  zah_l(ii,ib,1,1) = zah_l(ii,ib,1,1) + vexx(ii,1)
                  zah_l(ii,ib,kimg,1) = zah_l(ii,ib,kimg,1) + vexx(ii,kimg)
               enddo
            endif
         endif
      enddo
    end if
    
!!( tenchi ) (zah_l <- zaj_l)
    zaj_l(:,:,ik,:) = wfsd_l(:,:,ik,:)
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
       if(sw_hybrid_functional==ON) then
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          if(sw_MRCV_only==ON)then
             call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr(ib,1:nlmta,2),fsi(ib,1:nlmta,2),vexx)
          else
             call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr(ib,1:nlmta,itot+1),fsi(ib,1:nlmta,itot+1),vexx)
          endif
          else
          if(sw_MRCV_only==ON)then
             call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr(ib,1:nlmta,2),fsr(ib,1:nlmta,2),vexx)
          else
             call m_ES_EXX_get_vexx(nfout,ispin,ib,ik,ng,fsr(ib,1:nlmta,itot+1),fsr(ib,1:nlmta,itot+1),vexx)
          endif
          endif
       endif
       if(kimg == 1) then
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(ii,ib,ik,1)
             dr2 = bfft(i1)*denom
!             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+dr2
             if(sw_MRCV_only==ON)then
                zah_l(ii,ib,1,2) = ekin(ii)*dr1+dr2
             else
                zah_l(ii,ib,1,itot+1) = ekin(ii)*dr1+dr2
             endif
          enddo
          if(sw_hybrid_functional==ON)then
             do ii=1,iba(ik)
                if(sw_MRCV_only==ON)then
                   zah_l(ii,ib,1,2) = zah_l(ii,ib,1,2) + vexx(ii,1)
                else
                   zah_l(ii,ib,1,itot+1) = zah_l(ii,ib,1,itot+1) + vexx(ii,1)
                endif
             enddo
          endif
       else
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(ii,ib,ik,1)
             di1  = zaj_l(ii,ib,ik,kimg)
!             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
!             zaj_l(ii,ib,ik,kimg)= ekin(ii)*di1+bfft(2*i1)*denom
             if(sw_MRCV_only==ON)then
                zah_l(ii,ib,1,2)= ekin(ii)*dr1+bfft(2*i1-1)*denom
                zah_l(ii,ib,kimg,2)= ekin(ii)*di1+bfft(2*i1)*denom
             else
                zah_l(ii,ib,1,itot+1)= ekin(ii)*dr1+bfft(2*i1-1)*denom
                zah_l(ii,ib,kimg,itot+1)= ekin(ii)*di1+bfft(2*i1)*denom
             endif
          enddo
          if(sw_hybrid_functional==ON)then
             do ii=1,iba(ik)
                if(sw_MRCV_only==ON)then
                   zah_l(ii,ib,1,2)= zah_l(ii,ib,1,2)+vexx(ii,1)
                   zah_l(ii,ib,kimg,2)= zah_l(ii,ib,kimg,2)+vexx(ii,kimg)
                else
                   zah_l(ii,ib,1,itot+1)= zah_l(ii,ib,1,itot+1)+vexx(ii,1)
                   zah_l(ii,ib,kimg,itot+1)= zah_l(ii,ib,kimg,itot+1)+vexx(ii,kimg)
                endif
             enddo
          endif
       endif
    enddo
    
    if(sw_hybrid_functional==ON) deallocate(vexx)

    call tstatc0_end(id_sname)

  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine prepare_Hloc_phi
  
  subroutine evolve_WFs_in_subspace   (ik,ispin,iblock,itot,frestart)
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: iblock,itot
    logical, intent(out) :: frestart
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer :: i,iel

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: nel,nsta,nend
    integer :: ng
    integer :: id_sname = -1, ipri0
#ifdef DGEMM_PSUBSPACE
    integer :: num, k, lda, ldb, ldc
    real(kind=DP), allocatable, dimension(:,:) :: w1hw2_, w1sw2_
    real(kind=DP), allocatable, dimension(:,:,:) :: zat_t, zah_t
    real(kind=DP), allocatable, dimension(:,:) :: zat_t1, zah_t1
    complex(kind=DP), parameter :: c0 = (0.0d0, 0.0d0), c1 = (1.0d0, 0.0d0)
#endif
    call tstatc0_begin('evolve_WFs_in_subspace  ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)
    
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
    nel =ielm_e_l(iblock)
    nsta=ista_e_l(iblock)
    nend=iend_e_l(iblock)
    
    if(sw_divide_subspace==OFF)then
       nel=neg
       nsta=1
       nend=neg
    endif
    allocate(eko_d(neg));eko_d=0.d0
    allocate(occup(neg));occup=0.d0
    if(sw_divide_subspace==ON)then
        zah_l_p => zah_l
        zat_l_p => zat_l
        fsr_p   => fsr
        fsi_p   => fsi
        feigconv_p => feigconv
        do iel=1,nel
           eko_d(nsta+iel-1) = eko_l(iel,ik)
           occup(nsta+iel-1) = occup_l(iel,ik)
        enddo
    else
        call do_transpose(ik,itot)
        call do_allreduce(ik)
        zah_l_p => zah_l_t
        zat_l_p => zat_l_t
        fsr_p   => fsr_t
        fsi_p   => fsi_t
        feigconv_p => feigconv_t
    endif
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

    if(sw_MRCV_only==ON)then
       ip0=nel
       do ib=1,nel
         ibover(ib,iblock)=ib
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(nel+ib,iblock) = ip0 
         else
           ibover(nel+ib,iblock) = -1
         end if
       end do
       nsize_sb_now = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nsize_subspace(iblock)
    else
       if(itot==1) then
         do ib=1,nel
           ibover(ib,iblock)=ib
         end do
         nsize_subspace(iblock)=nel
       end if

       noffset=nel*itot
       ip0=nsize_subspace(iblock)
       do ib=1,nel
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(noffset+ib,iblock) = ip0 
         else
           ibover(noffset+ib,iblock) = -1
         end if
       end do

       nsize_sb_now = ip0
       nsize_subspace(iblock) = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nel*(itot+1)                   !nsize_subspace(iblock)
    endif
    
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now,iblock)
    end if
!
    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))

    if(ipridavidson >=2) then
       write(nfout,*) 'Modified Davidson:ik,iblock,nsize_sb_now=', ik,iblock,nsize_sb_now
    end if
    
    ng = iba(ik)
    if(sw_divide_subspace==OFF) ng = np_g1k(ik)
    eko1 = sum(eko_d(1:neg))
#ifdef DGEMM_PSUBSPACE
    allocate(w1hw2_(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(w1sw2_(nsize_sb_now*kimg_t,nsize_sb_now))

    if(kimg == 1) then
       allocate(zah_t(maxval(iba),nsize_sb_now,1))
       allocate(zat_t(maxval(iba),nsize_sb_now,1))
       num = 0
       do ibb1 = 1, nsize_max_sb_now
          if(ibover(ibb1,iblock) < 0) cycle
          iter1 = (ibb1-1)/nel+1
          ii1  = ibb1-nel*(iter1-1)
          ii1  = nsta+ii1-1
          num = num + 1
          zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
          zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
       end do
       k = iba(ik); lda = maxval(iba); ldb = maxval(iba); ldc = nsize_sb_now
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zah_t,ldb,0.0d0,w1hw2_,ldc)
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zat_t,ldb,0.0d0,w1sw2_,ldc)
    else
      if(k_symmetry(ik) == GAMMA) then
         allocate(zah_t(maxval(iba),nsize_sb_now,kimg))
         allocate(zat_t(maxval(iba),nsize_sb_now,kimg))
         allocate(zah_t1(nsize_sb_now,kimg))
         allocate(zat_t1(nsize_sb_now,kimg))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
            zah_t(:,num,2) = zah_l(:,ii1,2,iter1)
            zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
            zat_t(:,num,2) = zat_l(:,ii1,2,iter1)
         end do
         !!if(ista_g1k(ik) == 1) then
         if(iba(ik) == 1) then
            zat_t1(:,:) = zat_t(1,:,:)
            zah_t1(:,:) = zah_t(1,:,:)
            zat_t(1,:,:) = zat_t(1,:,:)/sqrt(2.0d0)
            zah_t(1,:,:) = zah_t(1,:,:)/sqrt(2.0d0)
         end if
         k = iba(ik); lda = maxval(iba); ldb = maxval(iba); ldc = nsize_sb_now
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zah_t(1,1,1),ldb,0.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zah_t(1,1,2),ldb,1.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zat_t(1,1,1),ldb,0.0d0,w1sw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zat_t(1,1,2),ldb,1.0d0,w1sw2_,ldc)
         if(iba(ik) == 1) then
            zat_t(1,:,:) = zat_t1(:,:)
            zah_t(1,:,:) = zah_t1(:,:)
         end if
         deallocate(zah_t1)
         deallocate(zat_t1)
      else
         allocate(zah_t(maxval(iba)*kimg,nsize_sb_now,1))
         allocate(zat_t(maxval(iba)*kimg,nsize_sb_now,1))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            do ii = 1, iba(ik)
               zah_t(2*ii-1,num,1) = zah_l(ii,ii1,1,iter1)
               zah_t(2*ii,  num,1) = zah_l(ii,ii1,2,iter1)
               zat_t(2*ii-1,num,1) = zat_l(ii,ii1,1,iter1)
               zat_t(2*ii,  num,1) = zat_l(ii,ii1,2,iter1)
            end do
         end do
         k = iba(ik); lda = maxval(iba); ldb = maxval(iba); ldc = nsize_sb_now
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zah_t,ldb,c0,w1hw2_,ldc)
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zat_t,ldb,c0,w1sw2_,ldc)
      end if
    end if
#else
!! (make matrix elements )
!    ! <n|T+Vloc|m> !
    do ibb2 = 1,nsize_max_sb_now
       if(ibover(ibb2,iblock)<0) cycle
       ib2 = ibover(ibb2,iblock)
       iter2 = (ibb2-1)/nel+1
       ii2  = ibb2-nel*(iter2-1)
       ii2  = nsta+ii2-1
       ip0b = ib2*(ib2-1)/2
       do ibb1 = 1,ibb2
          if(ibover(ibb1,iblock)<0) cycle
          ib1 = ibover(ibb1,iblock)
          iter1 = (ibb1-1)/nel+1
          ii1 = ibb1-nel*(iter1-1)
          ii1 = nsta+ii1-1
          ip0 = ip0b + ib1
          if(kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
!!!             do ii = 1, iba(ik)            ! MPI
             do ii = 1, ng            ! MPI
                hr2 = zah_l_p(ii,ii2,1,iter2)
                dr2 = zat_l_p(ii,ii2,1,iter2)
                dr1 = zat_l_p(ii,ii1,1,iter1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
!!$                ig1 = 1;  if(mype == 0) ig1 = 2
!!                ig1 = 1;  if(myrank_e == 0) ig1 = 2
                if(sw_divide_subspace==OFF)then
                   ig1 = 1;  if(myrank_e == 0) ig1 = 2
                else
                   ig1 = 2
                endif
!!                do ii = ig1, iba(ik)            ! MPI
                do ii = ig1, ng            ! MPI
                   hr2 = zah_l_p(ii,ii2,1,iter2) ! MPI
                   hi2 = zah_l_p(ii,ii2,2,iter2) ! MPI
                   dr2 = zat_l_p(ii,ii2,1,iter2) ! MPI
                   di2 = zat_l_p(ii,ii2,2,iter2) ! MPI
                   dr1 = zat_l_p(ii,ii1,1,iter1) ! MPI
                   di1 = zat_l_p(ii,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
!!$                if(mype == 0) then
                if(sw_divide_subspace==ON .or. myrank_e == 0) then
                   hr2 = zah_l_p(1,ii2,1,iter2) ! MPI
                   hi2 = zah_l_p(1,ii2,2,iter2) ! MPI
                   dr2 = zat_l_p(1,ii2,1,iter2) ! MPI
                   di2 = zat_l_p(1,ii2,2,iter2) ! MPI
                   dr1 = zat_l_p(1,ii1,1,iter1) ! MPI
                   di1 = zat_l_p(1,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                endif
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
!!                do ii = 1, iba(ik)           ! MPI
                do ii = 1, ng           ! MPI
                   hr2 = zah_l_p(ii,ii2,1,iter2) ! MPI
                   hi2 = zah_l_p(ii,ii2,2,iter2) ! MPI
                   dr2 = zat_l_p(ii,ii2,1,iter2) ! MPI
                   di2 = zat_l_p(ii,ii2,2,iter2) ! MPI
                   dr1 = zat_l_p(ii,ii1,1,iter1) ! MPI
                   di1 = zat_l_p(ii,ii1,2,iter1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
    end do
#endif
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 without nl part--",iblock)
    ! <n|Vnl|m> 
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
!
!!$    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --",iblock)

    if(sw_divide_subspace==OFF .and. npes>1)then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       call mpi_allreduce(w1hw2,w1hw2_mpi,msize_matrix*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       w1hw2 = w1hw2_mpi
       call mpi_allreduce(w1sw2,w1sw2_mpi,msize_matrix*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       w1sw2 = w1sw2_mpi
    endif

!    if(ipridavidson >= 2) then
!       write(nfout,*) 'neordr for ik = ',ik
!       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'nrvf_ordr for ik = ',ik
!       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'eig'
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
!    endif
!9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(ipridavidson >= 2 .and. ik == 1 .and. iblock == 1) then
       call wd_w1hw2(" -- w1hw2 after reduction --",iblock)
       ekod = 0.d0
       eko1 = 0.d0
       if(kimg_t == 1) then
          do ib1 = 1, msize_matrix
             ekod = ekod + w1hw2(ib1)*w1hw2(ib1)
             eko1 = eko1 + w1sw2(ib1)*w1sw2(ib1)
          end do
       else
          do ib1 = 1, msize_matrix
             ekod = ekod + (w1hw2(ib1*2-1)*w1hw2(ib1*2-1) +  w1hw2(ib1*2)*w1hw2(ib1*2))
             eko1 = eko1 + (w1sw2(ib1*2-1)*w1sw2(ib1*2-1) +  w1sw2(ib1*2)*w1sw2(ib1*2))
          end do
       end if
       write(nfout,'(" sum_of_square(w1hw2), sum_of_square(w1sw2) = ",2d20.6, " msize_matrix = ",i8)') ekod, eko1, msize_matrix
    end if
       
#ifdef DGEMM_PSUBSPACE
    if(kimg_t == 1) then
       call dsygvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    else
       call zhegvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    endif
    deallocate(w1hw2_)
    deallocate(w1sw2_)
#else
    if(kimg_t == 1) then
       call dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
       if(ipridavidson >= 2 .and. ik == 1 .and. iblock == 1) then
          write(nfout,'(" -- eig , ik = ",i8," iblock = ",i8)') ik, iblock
          write(nfout,'(5x,6f12.5)') (eig(ib),ib=1,nel)
          write(nfout,'(" -- vec --")')
          do ib = 1, nel
             write(nfout,'(" ib = ", i8, " eig = ",f12.5)') ib,eig(ib)
             write(nfout,'(5x,6f12.6)') vec(1:6,ib)
          end do
       end if
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    endif
#endif

    if(ipridavidson >= 2 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 after dspgvx_driv_",iblock)

    frestart = .false.
    if(ierr_diag /= 0) then
!       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
!       do ib1 = 1, neg
!          if(map_e(ib1) == myrank_e) then         ! MPI
!             eko_l(map_z(ib1),ik)=eko_d(ib1)
!          end if
!       end do
      frestart = .true.
! === DEBUG by T.Kato 2013/08/01 ===============================================
!     do i=1,np_e
      do i=1,nel
! ==============================================================================
         zaj_l(:,i-1+nsta,ik,:)=zat_l(:,i,:,1)
      enddo
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do i=1,nel
            status_saved_phifftr(i-1+nsta,ik) = OLD
         end do
      end if
#endif
      if(ipridavidson >= 2) then
        write(nfout,*) '** restart Modified Davidson iteration **'
        write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      end if
      write(nfout,*) '** restart Modified Davidson **'
      write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      call wd_w1hw2(" -- restart Modified Davidson iteration --",iblock)
!!$ print *,'Restart'
      goto 9000
    else

      feigconv_p(nsta:nend) = .false.
      do ib=1,nel
         if(occup(nsta+ib-1) > 0.d0) then
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_occup) &
                                                   feigconv_p(nsta+ib-1) = .true.
         else
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_empty) &
                                                   feigconv_p(nsta+ib-1) = .true.
         end if
      end do 
      if(ipri0 >= 2) then
         if(ik == 1 .and. iblock == 1) then
            write(nfout,*) 'eko_l for ik = ',ik
            write(nfout,*) 'iblock       = ',iblock
            write(nfout,9001) (eko_d(nsta+ib-1),ib=1,nel)
            write(nfout,*) 'eig for ik = ',ik
            write(nfout,9001) (eig(ib),ib=1,nel)
            if(ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
            call wd_w1hw2(" -- after diagonalization --",iblock)
!sum eko
            dr1=0.d0;dr2=0.d0
            do ib1=1,nel
               dr1=dr1+eko_d(nsta+ib1-1) ! MPI
               dr2=dr2+eig(ib1)
            enddo
            write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
         end if
      endif
    endif

!!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
       if(ipridavidson>=2 .and. ik==1 .and. iblock == 1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!( tenchi ) (zaj_l <- zat_l)
!       iter = min(idavid+1,ndavid)
!       call m_ES_W_transpose_back(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
!!       zaj_l_backup(:,nsta:nend,:) = zaj_l(:,nsta:nend,ik,:)
!! (eko_l)
    if(sw_divide_subspace==ON)then
       do ib1 = 1, nel
          eko_l(nsta+ib1-1,ik)=eig(ib1)
       end do
    else
       do ib1 = 1,neg
          if(map_e(ib1)==myrank_e) eko_l(map_z(ib1),ik) = eig(ib1)
       enddo
    endif

    if(ipridavidson >= 2) then
       if(ik == 1 .and. iblock == 1) then
          eko2 = sum(eig(1:nel))
          write(nfout,1201) ik,eko1,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_d(nsta+ib1-1),ib1=1,nel)
       end if
    endif

1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!!! (neordr & nrvf_ordr)
!
9000 continue
!    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!
!! (deallocate)  
#ifdef DGEMM_PSUBSPACE
    deallocate(zah_t)
    deallocate(zat_t)
#endif
    deallocate(eko_d)
    deallocate(occup)

    deallocate(eig)
    deallocate(vec)
    nullify(zah_l_p,zat_l_p,fsr_p,fsi_p,feigconv_p)
!
    call tstatc0_end(id_sname)
!
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
!
    subroutine wd_w1hw2(somecomment,iblock)
      character(len=*), intent(in) :: somecomment
      integer,intent(in) :: iblock
      integer :: ib1, ib2, nel_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      nel_wd = 8
      nsb_wd = 8
      if(nel_wd > nel) nel_wd = nel
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
! ========================== added by K. Tagami ========== 11.0
#ifdef forsafe
      integer :: ipaw_tmp
#endif
! ======================================================== 11.0
#ifdef DGEMM_PSUBSPACE
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsr_t, fsr_v, fsr_q
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsi_t, fsi_v, fsi_q
      real(kind=DP), allocatable, dimension(:,:) :: fsr_tt, fsr_vt, fsr_qt
      real(kind=DP), allocatable, dimension(:,:) :: fsi_tt, fsi_vt, fsi_qt
      integer :: iter, ncount, i,itot0
      itot0 = itot
      if(sw_MRCV_only==ON) itot0 = 1
      if(kimg == 1) then
         fsr_v = 0.0d0
         fsr_q = 0.0d0
         fsi_v = 0.0d0
         fsi_q = 0.0d0
         do iter = 1, itot0+1
            ncount = 0
            do ia = 1,natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  ncount = ncount + 1
                  p = lmta(lmt1,ia)
                  do ibb1 = 1, nel
                     ibb2 = nsta+ibb1-1
                     fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                  end do ! ibb1
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     if(ipaw(it) == 0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                        fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                        fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                     end do ! ibb1
                  end do ! lmt2
               end do ! lmt1
            end do ! ia
         end do ! iter
         allocate(fsr_tt(ncount,nsize_sb_now))
         allocate(fsr_vt(ncount,nsize_sb_now))
         allocate(fsr_qt(ncount,nsize_sb_now))
         allocate(fsi_tt(ncount,nsize_sb_now))
         allocate(fsi_vt(ncount,nsize_sb_now))
         allocate(fsi_qt(ncount,nsize_sb_now))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock)<0) cycle
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            num = num + 1
            fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
            fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
            fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            fsi_tt(1:ncount,num) = fsi_t(1:ncount,ii1,iter1)
            fsi_vt(1:ncount,num) = fsi_v(1:ncount,ii1,iter1)
            fsi_qt(1:ncount,num) = fsi_q(1:ncount,ii1,iter1)
         end do
         ldc = nsize_sb_now
         if(ncount>0)then
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_qt,ncount,1.0d0,w1sw2_,ldc)
         endif
         deallocate(fsr_tt)
         deallocate(fsr_vt)
         deallocate(fsr_qt)
         deallocate(fsi_tt)
         deallocate(fsi_vt)
         deallocate(fsi_qt)
      else ! if(kimg == 1)
         if(k_symmetry(ik) == GAMMA) then
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount,nsize_sb_now))
            allocate(fsr_vt(ncount,nsize_sb_now))
            allocate(fsr_qt(ncount,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
               fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
               fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            end do
            ldc = nsize_sb_now
            if(ncount>0) then
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            end if
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         else ! if(k_symmetry(ik) == GAMMA)
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            fsi_v = 0.0d0
            fsi_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                        fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                           fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                           fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount*kimg,nsize_sb_now))
            allocate(fsr_vt(ncount*kimg,nsize_sb_now))
            allocate(fsr_qt(ncount*kimg,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               do i = 1, ncount
                  fsr_tt(i*2-1,num) = fsr_t(i,ii1,iter1)
                  fsr_tt(i*2,  num) = fsi_t(i,ii1,iter1)
                  fsr_vt(i*2-1,num) = fsr_v(i,ii1,iter1)
                  fsr_vt(i*2,  num) = fsi_v(i,ii1,iter1)
                  fsr_qt(i*2-1,num) = fsr_q(i,ii1,iter1)
                  fsr_qt(i*2,  num) = fsi_q(i,ii1,iter1)
               end do
            end do
            ldc = nsize_sb_now
            if(ncount>0)then
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_vt,ncount,c1,w1hw2_,ldc)
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_qt,ncount,c1,w1sw2_,ldc)
            endif
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         end if ! if(k_symmetry(ik) == GAMMA)
      end if ! if(kimg == 1)
#else
      do ibb2 = 1,nsize_max_sb_now
         if(ibover(ibb2,iblock)<0) cycle
         ib2 = ibover(ibb2,iblock)
         iter2= (ibb2-1)/nel+1
         ii2  = ibb2-nel*(iter2-1)
         ii2  = nsta+ii2-1
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1,iblock)<0) cycle
            ib1 = ibover(ibb1,iblock)
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            ip0 = ip0b + ib1
!            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(mod(ip0-1,nrank_e)/=myrank_e.and.sw_divide_subspace==OFF) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
! ========================== added by K. Tagami =================== 11.0
#ifdef forsafe
               ipaw_tmp = ipaw(it)
#endif
! ================================================================= 11.0
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
!OCL NOPREEX
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
! ========================== modified by K. Tagami =================== 11.0
!                     if(ipaw(it)==0)then
#ifdef forsafe
                     if ( ipaw_tmp == 0 ) then
#else
                     if (ipaw(it)==0 ) then
#endif
! ================================================================= 11.0
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr_p(ii1,p,iter1)*fsr_p(ii2,s,iter2)&
                    &        + fsi_p(ii1,p,iter1)*fsi_p(ii2,s,iter2)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr_p(ii1,p,iter1)*fsr_p(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr_p(ii1,p,iter1)*fsr_p(ii2,s,iter2)&
                    &        + fsi_p(ii1,p,iter1)*fsi_p(ii2,s,iter2)
                           tmpi = fsr_p(ii1,p,iter1)*fsi_p(ii2,s,iter2)&
                    &        - fsi_p(ii1,p,iter1)*fsr_p(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
#endif
    end subroutine add_nonlocal_part


    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zah_wk
      real(kind=DP), allocatable, dimension(:,:,:,:) :: zah_wk2
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_wk
      real(kind=DP), allocatable, dimension(:,:)   :: fsi_wk
      integer :: ngsize
#ifdef DGEMM_PSUBSPACE
      integer :: i,is
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_t, fsi_t

      if(kimg==1) then
         allocate(zaj_wk(maxval(iba),nel,kimg))
         if(itot /= max_iter_david) allocate(zah_wk(maxval(iba),nel,kimg))
         allocate(fsr_wk(nel,nlmta),fsi_wk(nel,nlmta))
         allocate(fsr_t(nsize_sb_now,nlmta),fsi_t(nsize_sb_now,nlmta))
         num = 0
         do ibb2 = 1, nsize_max_sb_now
            if(ibover(ibb2,iblock) < 0) cycle
            iter2=(ibb2-1)/nel+1
            ii2=ibb2-nel*(iter2-1)
            ii2=nsta+ii2-1
            num = num + 1
            fsr_t(num,:) = fsr(ii2,:,iter2)
            fsi_t(num,:) = fsi(ii2,:,iter2)
         end do
         call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zat_t,maxval(iba),vec,nsize_sb_now,0.0d0,zaj_wk,maxval(iba))
         call dgemm('T','N',nel,nlmta,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
         call dgemm('T','N',nel,nlmta,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsi_t,nsize_sb_now,0.0d0,fsi_wk,nel)
         if(itot /= max_iter_david) then
            call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zah_t,maxval(iba),vec,nsize_sb_now,0.0d0,zah_wk,maxval(iba))
         end if
         zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
         if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
         do ib = nsta, nend ! MPI
            fsr_l(ib,:,ik) = fsr_wk(ib-nsta+1,:)
            fsi_l(ib,:,ik) = fsi_wk(ib-nsta+1,:)
         end do
         deallocate(fsr_t,fsi_t)
         deallocate(zaj_wk,fsr_wk,fsi_wk)
         if(itot /= max_iter_david) deallocate(zah_wk)
      else
         if(k_symmetry(ik) == GAMMA) then
            allocate(zaj_wk(maxval(iba),nel,kimg))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(iba),nel,kimg))
            allocate(fsr_wk(nel,nlmta))
            allocate(fsr_t(nsize_sb_now,nlmta))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               fsr_t(num,:) = fsr(ii2,:,iter2)
            end do
            call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,1),   maxval(iba),vec,nsize_sb_now,0.0d0,&
                  & zaj_wk(1,1,1),   maxval(iba))
            call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,kimg),maxval(iba),vec,nsize_sb_now,0.0d0,&
                  & zaj_wk(1,1,kimg),maxval(iba))
            call dgemm('T','N',nel,nlmta,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,1),   maxval(iba),vec,nsize_sb_now,0.0d0,&
                  & zah_wk(1,1,1),   maxval(iba))
               call dgemm('N','N',iba(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,kimg),maxval(iba),vec,nsize_sb_now,0.0d0,&
                  & zah_wk(1,1,kimg),maxval(iba))
            end if
            zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
            do ib = nsta, nend ! MPI
               fsr_l(ib,:,ik) = fsr_wk(ib-nsta+1,:)
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         else
            allocate(zaj_wk(maxval(iba)*kimg,nel,1))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(iba)*kimg,nel,1))
            allocate(fsr_wk(nel*kimg,nlmta))
            allocate(fsr_t(nsize_sb_now*kimg,nlmta))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               fsr_t(2*num-1,:) = fsr(ii2,:,iter2)
               fsr_t(2*num,  :) = fsi(ii2,:,iter2)
            end do
            call zgemm('N','N',iba(ik),nel,nsize_sb_now,c1,zat_t,maxval(iba),vec,nsize_sb_now,c0,zaj_wk,maxval(iba))
            call zgemm('T','N',nel,nlmta,nsize_sb_now,c1,vec,nsize_sb_now,fsr_t,nsize_sb_now,c0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call zgemm('N','N',iba(ik),nel,nsize_sb_now,c1,zah_t,maxval(iba),vec,nsize_sb_now,c0,zah_wk,maxval(iba))
            end if
            do ib = nsta, nend
               i = ib - nsta + 1
               do ii = 1, iba(ik)
                  zaj_l(ii,ib,ik,1)    = zaj_wk(2*ii-1,i,1)
                  zaj_l(ii,ib,ik,kimg) = zaj_wk(2*ii,  i,1)
               end do
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) then
               do ib = nsta, nend
                  i = ib - nsta + 1
                  do ii = 1, iba(ik)
                     zah_l(ii,ib,1,   1) = zah_wk(2*ii-1,i,1)
                     zah_l(ii,ib,kimg,1) = zah_wk(2*ii,  i,1)
                  end do
               end do
            end if
            do is = 1, nlmta ! MPI
               do ib = nsta, nend ! MPI
                  i = ib - nsta + 1
                  fsr_l(ib,is,ik) = fsr_wk(2*i-1,is)
                  fsi_l(ib,is,ik) = fsr_wk(2*i,  is)
               end do
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         end if
      end if
#else
      if(sw_divide_subspace==ON)then
         ngsize = kg1
      else
         ngsize = np_g1k_x
      endif
      allocate(zaj_wk(ngsize,nel,kimg))
      if(itot /= max_iter_david) then
        allocate(zah_wk(ngsize,nel,kimg))
        zah_wk(:,:,:) = 0.d0
        if(sw_divide_subspace==OFF)then
           allocate(zah_wk2(kg1,np_e,ista_k:iend_k,kimg))
           zah_wk2=0.d0
        endif
      end if
      allocate(fsr_wk(nel,nlmta))
      if(k_symmetry(ik) /= GAMMA) then
        allocate(fsi_wk(nel,nlmta))
        fsi_wk(:,:)=0.d0
      end if

      zaj_wk(:,:,:) = 0.d0
      fsr_wk(:,:)=0.d0
      if(kimg==1) then
         do ib1=1,nel
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2,iblock)<0) cycle
               ib2 = ibover(ibb2,iblock)
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               hr2=vec(ib2,ib1)
!!               do ii=1,iba(ik)
               do ii=1,ng
!                  zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + zat_l(ii,ii2,kimg,iter2)*vec(ib2,ib1)
                  zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + zat_l_p(ii,ii2,kimg,iter2)*hr2
               end do
               do ii=1,nlmta
                 fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr_p(ii2,ii,iter2)*hr2
                 fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + fsi_p(ii2,ii,iter2)*hr2
               end do
               if(itot /= max_iter_david) then
!!$                 do ii=1,iba(ik)
                 do ii=1,ng
                    zah_wk(ii,ib1,kimg) = zah_wk(ii,ib1,kimg) + zah_l_p(ii,ii2,kimg,iter2)*hr2
                 end do
               end if
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(ib2,ib1)
!                  do ii=1,iba(ik)
                  do ii=1,ng
                     dr1=zat_l_p(ii,ii2,1   ,iter2)
                     di1=zat_l_p(ii,ii2,kimg,iter2)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + di1*hr2
                  end do
                  do ii=1,nlmta
                    fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr_p(ii2,ii,iter2)*hr2
                  end do
                  if(itot /= max_iter_david) then
!!$                    do ii=1,iba(ik)
                    do ii=1,ng
                       dr1=zah_l_p(ii,ii2,1   ,iter2)
                       di1=zah_l_p(ii,ii2,kimg,iter2)
                       zah_wk(ii,ib1,1   ) = zah_wk(ii,ib1,1   ) + dr1*hr2
                       zah_wk(ii,ib1,kimg) = zah_wk(ii,ib1,kimg) + di1*hr2
                    end do
                  end if
               end do
            end do
         else
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
!                  do ii=1,iba(ik)
                  do ii=1,ng
                     dr1=zat_l_p(ii,ii2,1   ,iter2)
                     di1=zat_l_p(ii,ii2,kimg,iter2)
                     zaj_wk(ii,ib1,1   ) = zaj_wk(ii,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(ii,ib1,kimg) = zaj_wk(ii,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
                  do ii=1,nlmta
                     dr1=fsr_p(ii2,ii,iter2)
                     di1=fsi_p(ii2,ii,iter2)
                     fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + dr1*hr2 - di1*hi2
                     fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + dr1*hi2 + di1*hr2
                  end do
                  if(itot /= max_iter_david) then
!                    do ii=1,iba(ik)
                    do ii=1,ng
                       dr1=zah_l_p(ii,ii2,1   ,iter2)
                       di1=zah_l_p(ii,ii2,kimg,iter2)
                       zah_wk(ii,ib1,1   ) = zah_wk(ii,ib1,1   ) + dr1*hr2 - di1*hi2
                       zah_wk(ii,ib1,kimg) = zah_wk(ii,ib1,kimg) + dr1*hi2 + di1*hr2
                    end do
                  end if
               end do
            end do
         end if
      end if
      if(sw_divide_subspace==ON)then
         zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
         if(itot /= max_iter_david) zah_l_p(:,nsta:nend,:,1) = zah_wk(:,:,:)
         fsr_l(nsta:nend,:,ik) = fsr_wk(:,:)
         if(k_symmetry(ik) /= GAMMA) fsi_l(nsta:nend,:,ik) = fsi_wk(:,:)
      else
         call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zaj_wk)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
         if(itot /= max_iter_david) then
            call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zah_wk2,zah_wk)
            zah_l(:,:,:,1) = zah_wk2(:,:,ik,:)
         endif
         do ib1=1,neg
            if(map_e(ib1)==myrank_e)then
               fsr_l(map_z(ib1),:,ik) = fsr_wk(ib1,:)
               if(k_symmetry(ik) /= GAMMA) fsi_l(map_z(ib1),:,ik) = fsi_wk(ib1,:)
            endif
         enddo
      endif
      
      deallocate(zaj_wk,fsr_wk)
      if(itot /= max_iter_david) then
         deallocate(zah_wk)
         if(sw_divide_subspace==OFF) deallocate(zah_wk2)
      endif
      if(k_symmetry(ik) /= GAMMA) deallocate(fsi_wk)
#endif
    end subroutine subspace_rotation


  end subroutine evolve_WFs_in_subspace
  
  subroutine decide_correction_vector(precon,ik,ekin,afft,bfft,p)
    integer, intent(in)       :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)
    
    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('decide_correction_vector ', id_sname,1)
!!$    call tstatc0_begin('decide_correction_vector ', id_sname)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p) !-here
       if(ipridavidson >=2 .and. ib == ista_e) call wd_wfsd_l(ik,ib)
    end do

    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)
    
!!$    call normalize_wfsd(ik)

    call tstatc0_end(id_sname)
  end subroutine decide_correction_vector

  subroutine wd_wfsd_l(ik,ib)
    integer, intent(in) :: ik,ib
    integer :: i, ibt
    ibt = map_z(ib)
    write(nfout,'(" --- wfsd_l ---, ik = ",i8, " ib = ",i8)') ik, ib
    write(nfout,'(8f12.6)') (wfsd_l(i,ibt,ik,1),i=1,20)
    if(kimg==2) then
       write(nfout,'(8f12.6)') (wfsd_l(i,ibt,ik,2),i=1,20)
    end if
  end subroutine wd_wfsd_l
      
! ========================= added by K. Tagami ======================== 11.0
  subroutine decide_correction_vec_noncl( precon, ik, ekin, &
       &                                   afft_kt, bfft_kt, vnlph_noncl, p )

    integer, intent(in)       :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)              :: p(kg1)
    
    integer :: ib, is
    integer :: id_sname = -1

    call tstatc0_begin('decide_correction_vec_noncl ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI

       Do is=1, ndim_spinor
          call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) ) ! (swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                           ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call SD_direction_noncl( precon,ik, ib, ekin, bfft_kt, &
            &                   vnlph_noncl, p ) !-here
    end do

    call orthogonalize_SD_drctns_noncl(ik,to=OTHER_BANDS)

!    call orthogonalize_SD_drctns(ik,to=ALL_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)
    
    call normalize_wfsd_noncl(ik)

    call tstatc0_end(id_sname)
  end subroutine decide_correction_vec_noncl
! ================================================================ 11.0
  
  subroutine orthogonalize_SD_drctns(ik,to)
    integer, intent(in) :: ik,to

    integer :: itmp
    integer :: id_sname = -1
    call tstatc0_begin('orthogonalize_SD_drctns(Mddavid) ', id_sname,1)

!    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    !                                        ->bsd(ri)_l
    
    if(sw_MRCV_only==OFF)then
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
       fsr(:,:,1)=fsr_l(:,:,ik)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fsi(:,:,1)=fsi_l(:,:,ik)
       end if
    
       zaj_l(:,:,ik,:) = zajold_l(:,:,:)
       fsr_l(:,:,ik) = fsrold_l(:,:)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fsi_l(:,:,ik) = fsiold_l(:,:)
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    endif
    
    call tstatc0_end(id_sname)
!!$    itmp=modnrm
!!$    modnrm=EXECUT
!    if(sw_divide_subspace==ON) then
!!$       call m_ES_betar_dot_Psi_4_each_k(wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
!!$       call m_ES_orthogonalize_SD_to_WFs(ik,to,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
!!$    end if
    if(modnrm==EXECUT) then
       call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
    else
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
       call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    end if
!    end if
  end subroutine orthogonalize_SD_drctns
  
#endif
end module m_ES_WF_by_ModifiedDavidson

!================================================
!  Software name : STM
!  Module : m_FFT
!  Subroutine(s) : m_FFT_Vlocal_W_fine, m_FFT_query_inversion_symmetry
!                  m_FFT_rd_fine_fft_box_size, m_FFT_rd_fft_box_size,
!                  m_FFT_set_fft_box_size_fine, Vlocal_W, fft_phase_work_alloc
!                  fft_WF_work_alloc, fft_WF_work_dealloc, m_FFT_setup,
!                  init_fft_coefficients_arrays, WD_FFTboxsizes, FFT_WF, FFT_WF_fine,
!                  FFT_fine, FFT_CD, check_of_negative_CD, W_Vlocal_W, m_FFT_dFFT_fine,
!                  WF_2dFFT_backward, WF_dFFT_forward, substitute_afft_with_data, pr_afft
!  Author(s)     : Takahiro Yamasaki and Koichi Kato (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_FFT
! $Id: m_FFT.F90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters, only : kimg
  use m_Const_Parameters, only : DP,CMPLDP, ON, OFF, INVERSE, DIRECT, PAI2
  use m_Control_Parameters,only: n_fc

  implicit none

  integer, dimension(0:3) :: fft_box_size_WF, fft_box_size_CD &
       &,   fft_box_size_fine
  integer                 :: nfft, nfftp, nfftpf
  integer                 :: nlpf

  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1,cw2,cw3
  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1p,cw2p,cw3p
  complex(kind=CMPLDP), allocatable, dimension(:)    :: cw1pf,cw2pf,cw3pf

  real(kind=DP), allocatable, dimension(:)           :: cfft

  real(kind=DP), allocatable, dimension(:)           :: ftw

contains
  subroutine m_FFT_Vlocal_W_fine(afft,bfft,cfft)
    real(kind=DP), intent(in),  dimension(nfftpf) :: afft,bfft
    real(kind=DP), intent(out), dimension(nfftpf) :: cfft

    integer :: i
    !  V_{local} := bfft   : real
    !  \Psi      := afft   : complex

!!$    print *, ' nfftpf = ', nfftpf
    do i = 1, nfftpf-1, 2
       cfft(i)   = bfft(i) * afft(i)
       cfft(i+1) = bfft(i) * afft(i+1)
    end do
  end subroutine M_FFT_Vlocal_W_fine

  subroutine m_FFT_query_inversion_symmetry(inversion_symmetry)
    integer,intent(out) :: inversion_symmetry
    if(kimg == 1) inversion_symmetry = ON
    if(kimg == 2) inversion_symmetry = OFF
  end subroutine m_FFT_query_inversion_symmetry

  subroutine m_FFT_rd_fine_fft_box_size(nfinp)
    integer,intent(in) :: nfinp
    read(nfinp,*) nlpf
  end subroutine m_FFT_rd_fine_fft_box_size

  subroutine m_FFT_rd_fft_box_size(nfcntn_bin)
    integer,intent(in) :: nfcntn_bin
    read(nfcntn_bin) fft_box_size_WF(1:3),fft_box_size_CD(1:3)
  end subroutine m_FFT_rd_fft_box_size

  subroutine m_FFT_set_fft_box_size_fine
    if( kimg == 1 ) then
        nlpf = fft_box_size_CD(n_fc(1))* 0.5
    else if ( kimg == 2) then
        nlpf = fft_box_size_CD(n_fc(1))
    end if
    fft_box_size_fine(1) = fft_box_size_CD(n_fc(1))
    fft_box_size_fine(2) = fft_box_size_CD(n_fc(2))
    fft_box_size_fine(3) = fft_box_size_CD(n_fc(3))
  end subroutine m_FFT_set_fft_box_size_fine

  subroutine Vlocal_W(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer i
    do i = 1, nfft-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft,2) == 1) bfft(nfft) = afft(nfft)*bfft(nfft)
  end subroutine Vlocal_W

  subroutine fft_phase_work_alloc
    integer :: nnl,nnm,nnn

    nnl  = fft_box_size_WF(1);  nnm  = fft_box_size_WF(2)
    nnn  = fft_box_size_WF(3)
    allocate(cw1(nnl)); allocate(cw2(nnm)); allocate(cw3(nnn))

    nnl = fft_box_size_CD(1);   nnm = fft_box_size_CD(2)
    nnn = fft_box_size_CD(3)
    allocate(cw1p(nnl)); allocate(cw2p(nnm)); allocate(cw3p(nnn))

    nnl = fft_box_size_fine(1); nnm = fft_box_size_fine(2)
    nnn = fft_box_size_fine(3)
    allocate(cw1pf(nnl));allocate(cw2pf(nnm));allocate(cw3pf(nnn))
  end subroutine fft_phase_work_alloc

  subroutine fft_WF_work_alloc
    integer nfftwk
    nfftwk = nfft
    if(nfftwk < nfftp)  nfftwk = nfftp
    if(nfftwk < nfftpf) nfftwk = nfftpf
    allocate(ftw(nfftwk))
  end subroutine fft_WF_work_alloc

  subroutine fft_WF_work_dealloc
    deallocate(ftw)
  end subroutine fft_WF_work_dealloc

  subroutine m_FFT_setup(nfout,inversion_symmetry)
    integer, intent(in)           :: nfout, inversion_symmetry

    integer :: id_sname = -1

    if(inversion_symmetry == ON) then
       fft_box_size_WF(0) = fft_box_size_WF(1) + 2
       fft_box_size_CD(0) = fft_box_size_CD(1) + 2
       fft_box_size_fine(0) = fft_box_size_fine(1) + 2
    else if(inversion_symmetry == OFF) then
       fft_box_size_WF(0) = fft_box_size_WF(1) + 1
       fft_box_size_CD(0) = fft_box_size_CD(1) + 1
       fft_box_size_fine(0) = fft_box_size_fine(1) + 1
    endif
    nfft = fft_box_size_WF(0)*fft_box_size_WF(2)*fft_box_size_WF(3)&
         &*(2-inversion_symmetry)
    nfftp= fft_box_size_CD(0)*fft_box_size_CD(2)*fft_box_size_CD(3)&
         &*(2-inversion_symmetry)
    nfftpf= fft_box_size_fine(0)*fft_box_size_fine(2)*fft_box_size_fine(3)&
         &*(2-inversion_symmetry)

    call fft_WF_work_alloc
    allocate(cfft(nfft))
    call fft_phase_work_alloc

    call init_fft_coefficients_arrays  ! -(contained here)

    deallocate(cfft)

  contains
    subroutine init_fft_coefficients_arrays
      integer id, nl, nm, nn
      id = fft_box_size_WF(0)
      nl = fft_box_size_WF(1)
      nm = fft_box_size_WF(2)
      nn = fft_box_size_WF(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
      endif

      id = fft_box_size_CD(0)
      nl = fft_box_size_CD(1)
      nm = fft_box_size_CD(2)
      nn = fft_box_size_CD(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1p,cw2p,cw3p,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1p,cw2p,cw3p,0,0,0,0)
      endif

      id = fft_box_size_fine(0)
      nl = fft_box_size_fine(1)
      nm = fft_box_size_fine(2)
      nn = fft_box_size_fine(3)

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1pf,cw2pf,cw3pf,0,0,0,0)
      else
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1pf,cw2pf,cw3pf,0,0,0,0)
      endif

    end subroutine init_fft_coefficients_arrays

    subroutine WD_FFTboxsizes(nfout)
      integer, intent(in) :: nfout

      write(nfout,*) ' ---- (WF)FFT size ----'
      write(nfout,'(a44,i7)') &
           &     '  total FFT elements(including work area) = ', nfft
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & , fft_box_size_WF(0), fft_box_size_WF(2), fft_box_size_WF(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & , fft_box_size_WF(1), fft_box_size_WF(2), fft_box_size_WF(3)

      write(nfout,*) ' ---- (CD)FFT size ----'
      write(nfout,'(a44,i7)') &
           & '  total FFT elements(including work area) = ', nfftp
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & , fft_box_size_CD(0), fft_box_size_CD(2), fft_box_size_CD(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & , fft_box_size_CD(1), fft_box_size_CD(2), fft_box_size_CD(3)

      write(nfout,*) ' ---- (fine)FFT size ----'
      write(nfout,'(a44,i7)') &
           & '  total FFT elements(including work area) = ', nfftpf
      write(nfout,'(a44,3i5)') &
           & ' actual FFT box size                      = ' &
           & ,fft_box_size_fine(0),fft_box_size_fine(2),fft_box_size_fine(3)
      write(nfout,'(a44,3i5)') &
           & '   real FFT size                          = ' &
           & ,fft_box_size_fine(1),fft_box_size_fine(2),fft_box_size_fine(3)
    end subroutine WD_FFTboxsizes

  end subroutine m_FFT_setup

  subroutine FFT_WF(afft,inverse_or_direct,switch)  ! G space --> R space
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch
    integer :: id, nl, nm, nn, ier1 = 0

    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)

    integer kc1, kc2, kc3

    integer :: id_sname = -1

    id = fft_box_size_WF(0)
    nl = fft_box_size_WF(1)
    nm = fft_box_size_WF(2)
    nn = fft_box_size_WF(3)

    if(switch == ON) then
       kc1 = 0;       kc2 = nm/4 + 1;       kc3 = nn/4 + 1
    else
       kc1 = 0;       kc2 = 0       ;       kc3 = 0
    endif
    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,id,nl,nm,nn,cw1,cw2,cw3,kc1,kc2,kc3&
            & ,flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,id,nl,nm,nn,cw1,cw2,cw3,kc1,kc2,kc3&
            & ,flag_jrcat_c3ft(inverse_or_direct))
    endif
    if (ier1 /= 0) then
       print *, ' !!(Error fft) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_WF

  subroutine FFT_WF_fine(afft,inverse_or_direct)
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct
!!$    call FFT_CD(afft,inverse_or_direct)
    call FFT_fine(afft,inverse_or_direct)
  end subroutine FFT_WF_fine

  subroutine FFT_fine(afft,inverse_or_direct)   ! R space --> G space
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct

    integer :: idp,nlp, nmp, nnp, ier1 = 0, kc1 = 0, kc2 = 0, kc3 = 0
    integer :: id_sname = -1
    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)

 
    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf &
            & ,kc1,kc2,kc3, flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf &
            & ,kc1,kc2,kc3 ,flag_jrcat_c3ft(inverse_or_direct))
    endif

    if (ier1 /= 0) then
       print *, ' !!Error  fft(direct) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_fine

  subroutine FFT_CD(afft,inverse_or_direct)   ! R space --> G space
    real(kind=DP), intent(inout) :: afft(nfftp)
    integer, intent(in)          :: inverse_or_direct

    integer :: idp,nlp, nmp, nnp, ier1 = 0, kc1 = 0, kc2 = 0, kc3 = 0
    integer :: id_sname = -1
    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)


    idp = fft_box_size_CD(0)
    nlp = fft_box_size_CD(1)
    nmp = fft_box_size_CD(2)
    nnp = fft_box_size_CD(3)

    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,kc1,kc2,kc3&
            &, flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,kc1,kc2,kc3&
            & ,flag_jrcat_c3ft(inverse_or_direct))
    endif

    if (ier1 /= 0) then
       print *, ' !!Error  fft(direct) ier1 = ',ier1
       stop
    end if
  end subroutine FFT_CD

  subroutine check_of_negative_CD(afft,nfout,nspin,ispin)
    real(kind=DP), intent(inout) :: afft(nfftp)
    integer, intent(in)          :: nfout,nspin,ispin

    integer                   :: imodi, i
    integer                   :: icwarn_NEGA, icwarn_IMAG
    integer, parameter        :: MXWARN = 10
    real(kind=DP),parameter   :: chgdel = 8.d-5

    if(kimg.eq.1) then
       imodi = nfftp+10
    else if(kimg.eq.2) then
       imodi = fft_box_size_CD(0)
    end if

    icwarn_NEGA = 0
    icwarn_IMAG = 0
    do i = 1,nfftp-1,2
       if( (afft(i) <= -chgdel) .and. (mod(i+1,imodi) /= 0)) then
          icwarn_NEGA = icwarn_NEGA + 1
          if(icwarn_NEGA.le.MXWARN) then
             if(icwarn_NEGA.eq.1.and.nspin.eq.2) then
                write(nfout,*) ' #spin = ', ispin
             endif
             write(nfout,110) i,afft(i)
110          format(1h ,'**WARN CHG.DEN<0.0 AT ',I7,2D15.7,'***')
          endif
          afft(i) = 1.d-40
       else if (afft(i) <= 0.d0) then
          afft(i) = 1.d-40
       end if
       if( (abs(afft(i+1)) > chgdel).and. (mod(i+1,imodi) /= 0) ) then
          icwarn_IMAG = icwarn_IMAG + 1
          if(icwarn_IMAG.le.MXWARN) then
             if(icwarn_IMAG.eq.1.and.nspin.eq.2) then
                write(nfout,*) ' #spin = ', ispin
             endif
             write(nfout,120) i,afft(i+1)
120          format(1h ,'**WARN IMAG(CHG)>0.0 AT ',I7,2D15.7,'***')
          endif
          afft(i+1) = 0.d0
       else if (abs(afft(i+1)).gt.0.d0) then
          afft(i+1) = 0.d0
       end if
    end do
    if(icwarn_NEGA.gt.MXWARN) then
       if(nspin.eq.2) &
            &   write(nfout,*) ' #spin = ',ispin,' : 1 = UP, 2 = DOWN'
       write(nfout,*) &
            &  ' Warning of <<Negative Charge Density>> = ',icwarn_NEGA
    endif
    if(icwarn_IMAG.gt.MXWARN) then
       if(nspin.eq.2)  &
            &   write(nfout,*) ' #spin = ',ispin,' : 1 = UP, 2 = DOWN'
       write(nfout,*) &
            &  ' Warning of <<Imaginary Charge Density>> = ',icwarn_IMAG
    endif
  end subroutine check_of_negative_CD

  subroutine W_Vlocal_W(afft,bfft,eg)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft
    real(kind=DP), intent(out)                 :: eg

    integer i, nl, nm, nn, id
    real(kind=DP) :: vcel, s

    id = fft_box_size_WF(0)
    nl = fft_box_size_WF(1)
    nm = fft_box_size_WF(2)
    nn = fft_box_size_WF(3)

    do i = 1, nfft-1, 2
       bfft(i) = afft(i)*(bfft(i)**2 + bfft(i+1)**2)
    end do
    vcel = 1.d0/(nl*nm*nn)
    s = 0.d0
    if(kimg == 1) then
       do i = 1, nfft-1, 2
          s = s + bfft(i)
       end do
       s = s + s
       do i = 1, nfft-1, id
          s = s - bfft(i)
       end do
       do i = id-1, nfft-1, id
          s = s - bfft(i)
       end do
    else if(kimg == 2) then
       do i = 1, nfft-1, 2
          s = s + bfft(i)
       end do
    end if
    eg = s * vcel
  end subroutine W_Vlocal_W

  subroutine m_FFT_WF_2dFFT_fine(afft,inverse_or_direct)
    real(kind=DP), intent(inout) :: afft(nfftpf)
    integer, intent(in)          :: inverse_or_direct
!	INVERSE: 1, DIRECT: 2

    integer, dimension(2) :: flag_jrcat_r2ft = (/-1, 1/)
    integer, dimension(2) :: flag_jrcat_c2ft = (/ 1, -1/)

    real(kind=DP) :: factor
    integer :: idp, nlp, nmp, nnp

    integer :: id_sname = -1


    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    ftw = 0.d0
    if(kimg == 1) then
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf &
            & ,flag_jrcat_r2ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf &
            & ,flag_jrcat_c2ft(inverse_or_direct))
    endif
    if(inverse_or_direct .eq. DIRECT) then
       factor = 1.d0/(nmp*nnp)
       afft = afft*factor
    end if

  end subroutine M_FFT_WF_2dFFT_fine

  subroutine WF_2dFFT_backward(afft)
    real(kind=DP), intent(inout) :: afft(nfftpf)

    real(kind=DP) :: factor
    integer :: idp, nlp, nmp, nnp
    integer :: id_sname = -1
    integer :: key

    key = +1

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

    factor = 1.d0/(nmp*nnp)

    ftw = 0.d0
    if(kimg == 1) then
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$    call jrcat_r2ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
    else if(kimg == 2) then
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       call jrcat_c2ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
    endif
    afft = afft*factor

  end subroutine WF_2dFFT_backward

  subroutine WF_2dFFT_forward(afft)
    real(kind=DP), intent(inout) :: afft(nfftpf)

    integer :: idp, nlp, nmp, nnp
    integer :: id_sname = -1
    integer :: key

    key = -1

    idp = fft_box_size_fine(0)
    nlp = fft_box_size_fine(1)
    nmp = fft_box_size_fine(2)
    nnp = fft_box_size_fine(3)

!!$    factor = 1.d0/(nlp*nmp*nnp)

    ftw = 0.d0
    if(kimg == 1) then
!!$       call jrcat_r1ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw1pf)
!!$       call jrcat_r3ft(afft,ftw,idp,nlp,nmp,nnp,cw1pf,cw2pf,cw3pf,0,0,0,-1)
!!$    call jrcat_r2ft_of_3D_forward(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
       call jrcat_r2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       afft = afft*factor
    else if(kimg == 2) then
!!$       call jrcat_c1ft_of_3D_back(afft,ftw,idp,nlp,nmp,nnp,cw1p)
!!$       call jrcat_c3ft(afft,ftw,idp,nlp,nmp,nnp,cw1p,cw2p,cw3p,0,0,0,-1)
!!$    call jrcat_c2ft_of_3D_forward(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf)
       call jrcat_c2ft_of_3D(afft,ftw,idp,nlp,nmp,nnp,cw2pf,cw3pf,key)
!!$       afft = afft*factor
    endif

  end subroutine WF_2dFFT_forward

  subroutine substitute_afft_with_data(p,q,afft)
    integer, intent(in)                           :: p,q
    real(kind=DP), intent(out), dimension(nfftpf) :: afft
    real(kind=DP), pointer, dimension(:)          :: d1,d2,d3

    integer       :: nlpfh, nlpf_t, nmpf, nnpf, i,j,k,ip,igfpf, imax
    real(kind=DP) :: phase

    nlpf_t = fft_box_size_fine(1)
    if(kimg == 1) then
       nlpfh = fft_box_size_fine(0)/2
    else
       nlpfh = fft_box_size_fine(0)
    end if
    nmpf = fft_box_size_fine(2); nnpf = fft_box_size_fine(3)

    if(kimg == 1) then
       imax = nlpfh
    else
       imax = nlpf_t
    end if

    allocate(d1(imax)); allocate(d2(nmpf)); allocate(d3(nnpf))

    do i = 1, imax
       d1(i) = (nlpf_t-i+1)/dble(nlpf_t)
    end do

    do i = 1, nmpf
       phase = PAI2*p*(i-1)/nmpf
       d2(i) = dcos(phase)
    end do

    do i = 1, nnpf
       phase = PAI2*q*(i-1)/nnpf
       d3(i) = dcos(phase)
    end do

    do k = 1, nnpf
       do j = 1, nmpf
          do i = 1, imax
             igfpf = i + (j-1)*nlpfh + (k-1)*nlpfh*nmpf
             ip = 2*igfpf-1
             afft(ip) = d1(i)*d2(j)*d3(k)
             afft(ip+1) = 0.d0
          end do
       end do
    end do

    deallocate(d1); deallocate(d2); deallocate(d3)
  end subroutine substitute_afft_with_data

  subroutine pr_afft(p,q,afft)
    integer, intent(in)                          :: p,q
    real(kind=DP), intent(in), dimension(nfftpf) :: afft

    integer :: i,j,k,imin,imax,jmin,jmax,kmin,kmax,nlpfh,nmpf
    integer, pointer, dimension(:) :: ip
    
    if(kimg == 1) then
       nlpfh = fft_box_size_fine(0)/2
    else
       nlpfh = fft_box_size_fine(0)
    end if
    nmpf  = fft_box_size_fine(2)

    imin = 1; imax = 3

    jmin = p-3; jmax = p+3
    if(jmin < 1) jmin = 1
    if(jmax > fft_box_size_fine(2)) jmax = fft_box_size_fine(2)
    allocate(ip(jmin:jmax))

    kmin = q-3; kmax = q+3
    if(kmin < 1) kmin = 1
    if(kmax > fft_box_size_fine(3)) kmax = fft_box_size_fine(3)


    print '(" p,q = ",i5,i5)',p,q
    do i = imin, imax
       print '(" i = ", i5)',i
       print '(" range : (",i5,":",i5,",",i5,":",i5,")")' &
            & , jmin,jmax,kmin,kmax
       do k = kmin, kmax
          do j = jmin, jmax
             ip(j) = 2*(i+(j-1)*nlpfh+(k-1)*nlpfh*nmpf) - 1
          end do
          print '(" (k = ",i5,")",8f10.4)',k,(afft(ip(j)),j=jmin,jmax)
       end do
    end do
  end subroutine pr_afft

end module m_FFT

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 410 $)
!
!  MODULE: m_ES_WF_by_MatDiagon
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,   August/22/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_MATDIAGON_DGEMM
#define MATDIAGON_DGEMM
#endif

module m_ES_WF_by_MatDiagon
! $Id: m_ES_WF_by_MatDiagon.F90 410 2014-10-30 05:20:45Z jkoga $
  use m_Electronic_Structure,only : zaj_l, eko_l &
       &                          , vlhxcQ,vlhxc_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                          , m_ES_wd_zaj_small_portion
  use m_ES_nonlocal,         only : m_ES_betar_dot_WFs 
  use m_NonLocal_Potential,  only : snl
  use m_PlaneWaveBasisSet,   only : kg1_ext,kg1,iba2,iba,nmatsz,nmatsz2,nbmat,nbmat2,nbase,ngabc,ttr,igpo &
       &                          , n_rGsv, nbase_gamma, kg2_gamma &
       &                          , m_pwBS_alloc_igpo &
       &                          , m_pwBS_dealloc_igpo &
       &                          , m_pwBS_GminusGmapfunction &
       &                          , m_pwBS_set_gmaxs &
       &                          , m_pwBS_alloc_nbmat_and_iba2 &
       &                          , m_pwBS_dealloc_nbmat_and_iba2 &
       &                          , m_pwBS_mat_for_each_WF
  use m_PseudoPotential,     only : modnrm,n_non0_lmtxlmt,index_lmt1_lmt2,lmtt &
       &                          , ltp,mtp,ilmt,dion,q,ivanl, nlmtt &
       &                          , ipaw,dion_paw
  use m_Kpoints,             only : kv3, vkxyz, k_symmetry
  use m_Ionic_System,        only : ntyp, natm, ityp, iwei, pos, ivan
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,kimg,af,neg,iprimatdiagon,intzaj &
       &                          , n_matrix_size,gmax,eps_solve_Hx_eq_ex,gmaxs_given,ekmode &
#ifdef SAVE_FFT_TIMES
       &                          , skip_alloc_phonon, sw_save_fft
#else
       &                          , skip_alloc_phonon
#endif
  use m_Const_Parameters,    only : DP,PAI2,EXECUT,CMPLDP,BUCS,SmallestPositiveNumber,by_matrix_diagon,ON, GAMMA &
       &                          , GAMMA_base_symmetrization, OLD
  use m_Parallelization,     only : mpi_comm_group,myrank_k,map_k,ierr,npes, np_e &
       &                          , ista_kngp,iend_kngp,ista_e,iend_e &
       &                          , istep_e,map_z

! =========================== added by K. Tagami =================== 11.0
  use m_Control_Parameters,  only : noncol, ndim_chgpot, ndim_spinor 
  use m_PseudoPotential,     only : dion_scr_noncl, q_noncl
  use m_ES_NonCollinear,      only : m_ES_MagMom_to_DensMat_Gspace, &
       &                             m_ES_MagMom_to_DensMat_vlhxcl
  use m_Electronic_Structure,  only : m_ES_sort_eigen_vals_noncl
! ================================================================== 11.0

! =========================== added by K. Tagami =================== 11.0
  use m_Control_Parameters,   only : SpinOrbit_mode, sw_hubbard 
  use m_PseudoPotential,     only : nlmt
  use m_Const_Parameters,     only : Neglected, BuiltIn, OFF, SKIP
! ================================================================== 11.0



  implicit none

  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat_s !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat1
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat1_check
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat2
  real(kind=DP),private,allocatable,dimension(:,:,:):: Linv  !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: ldag  !d(nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: vlhxc_t !d(nmatsz2,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: vlhxc   !d(nmatsz2,kimg)
  real(kind=DP),private,allocatable,dimension(:)    :: zfcos,zfsin !d(nmatsz2)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: zaj_mat !d(nmatsz,np_e,kimg)
  integer :: npcol_md, nprow_md
  integer :: nsclcol_md, nsclrow_md

!ScaLAPACK
    logical, save :: nsame
    integer :: iiii, jjjj

! ==================================== added by K. Tagami =============== 11.0
  real(kind=DP),private,allocatable :: vlhxc_ssrep(:,:,:)
! ======================================================================= 11.0  

! ==================================== added by K. Tagami =============== 11.0
    integer :: nmatsz_noncl
    integer :: sw_use_zhegvx = on
! ======================================================================= 11.0

  include 'mpif.h'

contains

  subroutine alloc_matrices()
!f    allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
!!$    write(6,'(" -- hsmat is allocated, nmatsz = ",i5)') nmatsz
    allocate(vlhxc_t(nmatsz2,kimg))
    allocate(vlhxc(nmatsz2,kimg))
    allocate(zfcos(0:nmatsz2))
    allocate(zfsin(0:nmatsz2))
!!$    write(6,'(" -- zfcos, zfsin are allocated, nmatsz2 = ",i5)') nmatsz2
!f    if(modnrm == EXECUT) then
!f       allocate(linv(nmatsz,nmatsz,kimg))
!f       allocate(ldag(nmatsz,kimg))
!f    end if
!f    allocate(zaj_mat(nmatsz,np_e,kimg))
! ============================ modified by K. Tagami ================= 11.0
!    allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
!    if(modnrm == EXECUT) then
!       allocate(linv(nmatsz,nmatsz,kimg))
!       allocate(ldag(nmatsz,kimg))
!    end if
!    allocate(zaj_mat(nmatsz,np_e,kimg))
!
    if ( noncol ) then
      nmatsz_noncl = nmatsz *ndim_spinor
      allocate( hsmat( nmatsz_noncl, nmatsz_noncl, kimg )); hsmat =0.d0

      if ( modnrm == EXECUT ) then
         if ( sw_use_zhegvx == ON ) then
            allocate( hsmat_s( nmatsz_noncl, nmatsz_noncl, kimg) ); hsmat_s = 0.0d0
         else
            allocate( linv( nmatsz_noncl, nmatsz_noncl, kimg) )
            allocate( ldag( nmatsz_noncl, kimg ) )
         end if
      endif

      allocate( zaj_mat( nmatsz_noncl, np_e, kimg ) )

      allocate( vlhxc_ssrep( ista_kngp:iend_kngp,kimg,ndim_chgpot) )
      vlhxc_ssrep = 0.0d0

    else
      allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
      if ( modnrm == EXECUT ) then
         allocate(linv(nmatsz,nmatsz,kimg))
         allocate(ldag(nmatsz,kimg))
      end if
      allocate(zaj_mat(nmatsz,np_e,kimg))
    endif
! ===================================================================== 11.0
  end subroutine alloc_matrices

  subroutine dealloc_matrices()
    if(allocated(zaj_mat)) deallocate(zaj_mat)
    if(allocated(ldag))  deallocate(ldag)
    if(allocated(linv))  deallocate(linv)
    if(allocated(zfsin)) deallocate(zfsin)
    if(allocated(zfcos)) deallocate(zfcos)
    if(allocated(vlhxc)) deallocate(vlhxc)
    if(allocated(vlhxc_t)) deallocate(vlhxc_t)
    if(allocated(hsmat)) deallocate(hsmat)

! ====================================== added by K. Tagami ========== 11.0
    if ( allocated(vlhxc_ssrep) ) deallocate( vlhxc_ssrep )
! ==================================================================== 11.0

    if(allocated(hsmat_s)) deallocate(hsmat_s)

  end subroutine dealloc_matrices

  subroutine m_ESmat_solve_Hx_eq_eSx(nfout,iteration,iteration_electronic)
    integer, intent(in) :: nfout, iteration, iteration_electronic

    integer,parameter :: PRINT_LEVEL = 2
    integer   :: ispin, ik, iksnl, n=0
    integer   :: id_sname = -1
    call tstatc0_begin('m_ESmat_solve_Hx_eq_eSx ',id_sname,1)

    if(iprimatdiagon >= 2) then
       write(nfout,'(" !! iteration = ",i6, " m_ESmat_solve_Hx_eq_eSx")') iteration
!!$       write(nfout,'(" !! intzaj    = ",i6)') intzaj
    end if
!!$    if(iteration == 1 .and. intzaj == by_random_numbers .or. iteration > 1)&
!!$         & call m_pwBS_set_gmaxs(n,gmax) ! -> gmaxs,nmatsz,n_rGv
    if(ekmode == ON ) then
       if(iteration_electronic == 1) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    else
       if(iteration == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if(skip_alloc_phonon .and. iteration_electronic == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    end if

    call m_pwBS_alloc_nbmat_and_iba2()
    call m_pwBS_mat_for_each_WF() ! -> nbmat,nbmat2,iba2

    call m_pwBS_alloc_igpo()
    call m_pwBS_GminusGmapfunction()  ! -> igpo, nmatsz2
    if(iprimatdiagon >= 3) write(nfout,'(" nmatsz2 = ",i9)') nmatsz2
    if(iprimatdiagon >= PRINT_LEVEL) &
         & write(nfout,'(" nmatsz, kg1_ext = ", 2i9)') nmatsz, kg1_ext

    call alloc_matrices()

    do ispin = 1, nspin, af+1
       call prjvlhxc_l2vlhxc_t()   ! vlhxc_l -> vlhxc
       do ik = ispin, kv3-nspin+ispin,nspin
          if(map_k(ik) /= myrank_k) cycle
          if(iprimatdiagon >= PRINT_LEVEL) &
               & write(nfout,'(" iba2(",i3,") = ", i9)') ik, iba2(ik)

          iksnl = (ik-1)/nspin + 1
          hsmat = 0.d0
          if(modnrm == EXECUT) then
             if(iprimatdiagon >=3 ) write(nfout,'(" !! modnrm == EXECUT (m_ESmat_solve_Hx_eq_eSx)")')
             call ovmtrx() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- ovmtrx --")
             call cholde() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- cholde --")   ! -> linv
          end if
          call nlmtrx()           ! (nlmtrx) -> hsmat <- snl
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- nlmtrx --")
          call amtrxkinetic()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxkinetic --")
          call amtrxlocalpt()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxlocalpt --")
          if(modnrm == EXECUT) call lhl() ! -> hsmat
                          if(modnrm == EXECUT .and. iprimatdiagon >= 3) call wd_hsmat(" -- lhl --")
      ! [LAPACK] with LAPACK library
      !***** LAPACK [begin] ***** M.Okamoto
          call solve_Hx_eq_ex_LAPACK()
      !***** LAPACK [end] ***** M.Okamoto
          if(iprimatdiagon >= 3) call wd_hsmat(" -- after diagonalization --")
          if(modnrm == EXECUT) call lx() ! -> zaj_mat
          ! Debug
!!$          call zaj_mapping()
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) call phase_mult()
          call cp_zaj_mat_to_zaj_l() ! zaj_mat -> zaj_l
       end do
    end do

    if(iprimatdiagon >= 3) then
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_wd_zaj_small_portion(nfout,ik," (m_ESmat_solve_Hx_eq_eSx)",26)
!!$          write(nfout,'(" ik = ", i5)') ik
       end do
    end if

    call dealloc_matrices()
    call m_pwBS_dealloc_igpo()
    call m_pwBS_dealloc_nbmat_and_iba2()

    call m_ES_betar_dot_WFs(nfout) ! (fsrfsi) -> fsr_l, fsi_l

    call tstatc0_end(id_sname)
  contains
    subroutine wd_hsmat(str)
      character(len=*),intent(in) :: str
      integer :: i, imax, j, jmax
      integer, parameter :: NMATSIZE = 10
      write(nfout,'(a30," ik= ",i5)') str,ik
      imax = min(NMATSIZE, nmatsz)
      jmax = min(NMATSIZE, nmatsz)
      do j = 1, jmax
         write(nfout,'(" hsmat(1:*,",i3,",1): ",10f8.4,99(/19x,10f8.4))') j &
              & , (hsmat(i,j,1),i=1,imax)
      end do
      if(kimg == 2) then
         do j = 1, jmax
            write(nfout,'(" hsmat(1:*,",i3,",2): ",10f8.4,99(/19x,10f8.4))') j &
                 & , (hsmat(i,j,2),i=1,imax)
         end do
      end if
    end subroutine wd_hsmat

!!$    subroutine zaj_mapping()
!!$      integer :: ib, i, j, ib2
!!$      if(iba2(ik) < iba(ik)) then
!!$         write(nfout,'(" << zaj_mapping >> (nbmat -> nbase)")')
!!$         do ib = ista_e, iend_e, istep_e
!!$            ib2 = map_z(ib)
!!$            zfcos = 0.d0
!!$            do j = 1, iba2(ik)
!!$               do i = 1, iba(ik)
!!$                  if(nbase(i,ik) == nbmat(j,ik)) zfcos(i) = zaj_l(j,ib2,ik,1)
!!$               end do
!!$            end do
!!$            do i = 1, iba(ik)
!!$               zaj_l(i,ib2,ik,1) = zfcos(i)
!!$            end do
!!$         end do
!!$         if(kimg == 2) then
!!$            do ib = ista_e, iend_e, istep_e
!!$               ib2 = map_z(ib)
!!$               zfcos = 0.d0
!!$               do j = 1, iba2(ik)
!!$                  do i = 1, iba(ik)
!!$                     if(nbase(i,ik) == nbmat(j,ik)) zfcos(i) = zaj_l(j,ib2,ik,2)
!!$                  end do
!!$               end do
!!$               do i = 1, iba(ik)
!!$                  zaj_l(i,ib2,ik,2) = zfcos(i)
!!$               end do
!!$            end do
!!$         end if
!!$      end if
!!$    end subroutine zaj_mapping

   ! [LAPACK] with LAPACK library
   !***** LAPACK [begin] ***** M.Okamoto
    subroutine solve_Hx_eq_ex_LAPACK()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, &
                 i, j, ib, lwork, k
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable :: &
         ifail(:), iwork(:)
      real(kind=DP),allocatable :: &
         amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: &
         cmat(:,:), cvmat(:,:), cwork(:)
      complex(kind=CMPLDP),parameter :: IMG = (0.d0,1.d0)
      character(len=5) :: a
      integer :: ri
! === DEBUG by tkato 2011/09/06 ================================================
      complex(kind=CMPLDP) :: ctemp
! ==============================================================================

!!$      zaj_l(:,:,ik,:) = 0.d0
      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz
      !!$ vl = -1.d10 ; vu = 1.d10 ; il = ista_e ; iu = iend_e
      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg
      ne = iu - il + 1
      !abstol = eps_solve_Hx_eq_ex
!!$      abstol = 1.d-15
      !abstol = -1.d0
      abstol = 2*dlamch('S')
      if (kimg == 1) then
         n = iba2(ik)
         lwork = max(1,12*n)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(amat(lda,n),rvmat(lda,ne),rwork(lwork))
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         amat(:,:) = 0.d0
         do i = 1,n
         do j = 1,n
            amat(i,j) = hsmat(i,j,1)
         end do
         end do
         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- n   = ", i8, " <<solve_Hx_eq_ex_LAPACK>>")') n
            write(nfout,'(" --- lda = ",i8)') lda
            write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
            write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
            write(nfout,'(" --- lwork = ",i8)') lwork
            write(nfout,'(" --- abstol = ", d20.8)') abstol
            write(nfout,'(" --- amat(diagonal) = ",8f8.4)') (amat(i,i),i=1,n)
         end if
         call dsyevx('V','I','U',n,amat,lda,vl,vu,il,iu,abstol, &
            ne_found,evec,rvmat,lda,rwork,lwork,iwork,ifail,info)
         if(iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_LAPACK): ik = ",i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
            a = "     "
            do ib = ista_e, iend_e, istep_e               ! MPI
               write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                    & ib,ik,evec(ib),a,(rvmat(i,ib),i=1,5)
            end do
         end if
         if (ne_found /= ne) then
            write(*,*) '### ERROR ### ne_found != ne'
            write(*,*) '   ne_found ...',ne_found
            write(*,*) '   ne       ...',ne
            stop
         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = rvmat(i,ib)
               !!$ zaj_l(i,j,ik,1) = rvmat(i,ib-ista_e+1) ! M.Okamoto (August 22,2003)
            end do
            eko_l(j,ik) = evec(ib)
            !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++
         deallocate(amat,rvmat,rwork)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
         n = iba2(ik)
!!$         lwork = max(1,4*n)
! === DEBUG by tkato 2011/09/06 ================================================
!        lwork = max(1,6*n)
! ==============================================================================
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
! === DEBUG by tkato 2011/09/06 ================================================
!        allocate(cmat(lda,n),cvmat(lda,ne),cwork(lwork),rwork(7*n))
         allocate(cmat(lda,n),cvmat(lda,ne),rwork(7*n))
! ==============================================================================
         evec = 0.d0; iwork = 0; ifail = 0; cmat = dcmplx(0.d0,0.d0)
! === DEBUG by tkato 2011/09/06 ================================================
!        cvmat = cmplx(0.d0,0.d0); cwork = cmplx(0.d0,0.d0); rwork = 0.d0;
         cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
! ==============================================================================
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         cmat(:,:) = 0.d0
         do i = 1,n
         do j = 1,n
            cmat(i,j) = dcmplx(hsmat(i,j,1),hsmat(i,j,2))
         end do
         end do
! === DEBUG by tkato 2011/09/06 ================================================
         call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
            ne_found,evec,cvmat,lda,ctemp,-1,rwork,iwork,ifail,info)
         lwork = int(real(ctemp))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)
! ==============================================================================
         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- n   = ", i8, " <<solve_Hx_eq_ex_LAPACK>>")') n
            write(nfout,'(" --- lda = ",i8)') lda
            write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
            write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
            write(nfout,'(" --- lwork = ",i8)') lwork
            write(nfout,'(" --- abstol = ", d20.8)') abstol
            write(nfout,'(" --- cmat(diagonal) = ",8f8.4)') (cmat(i,i),i=1,n)
         end if
         call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
            ne_found,evec,cvmat,lda,cwork,lwork,rwork,iwork,ifail,info)
         if(iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_LAPACK): ik = ",i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
            a = "     "
            do ib = ista_e, iend_e, istep_e               ! MPI
               do ri = 1, kimg
                  if(ri == 1 .and. kimg == 2) a = "(Re) "
                  if(ri == 2) a = "(Im) "
                  if(ri == 1) write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                       & ib,ik,evec(ib),a,(real(cvmat(i,ib)),i=1,5)
                  if(ri == 2) write(nfout,'(32x,a4,5e14.6)') a,(aimag(cvmat(i,ib)),i=1,5)
               end do
            end do
         end if
         if (ne_found /= ne) then
            write(*,*) '### ERROR ### ne_found != ne'
            write(*,*) '   ne_found ...',ne_found
            write(*,*) '   ne       ...',ne
            stop
         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
!!$               k = nbmat2(i,ik)
!!$               zaj_l(k,j,ik,1)    = real(cvmat(i,ib))
!!$               zaj_l(k,j,ik,kimg) = aimag(cvmat(i,ib))
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
               !!$ zaj_l(i,j,ik,1)    = real(cvmat(i,ib-ista_e+1))  ! M.Okamoto (August 22,2003)
               !!$ zaj_l(i,j,ik,kimg) = aimag(cvmat(i,ib-ista_e+1)) ! M.Okamoto (August 22,2003) 
            end do
            eko_l(j,ik) = evec(ib)
            !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if
      if (iprimatdiagon >= 2) then
         write(nfout,'(" -- eigen values (solve_Hx_eq_ex): ik = ",i8)') ik
         write(nfout,'(8f10.6)') (evec(i),i=1,ne)
         a = "     "
         do ib = ista_e, iend_e, istep_e               ! MPI
            do ri = 1, kimg
               if(ri == 1 .and. kimg == 2) a = "(Re) "
               if(ri == 2) a = "(Im) "
               if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                    & ib,ik,eko_l(map_z(ib),ik),a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               write(nfout,'(35x,5e14.6)') (zaj_mat(i,map_z(ib),ri),i=6,20)
            end do
         end do
      end if
      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) stop ' ! illegal evec (solve_Hx_eq_ex)'
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum
     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++
    end subroutine solve_Hx_eq_ex_LAPACK
   !***** LAPACK [end] ***** M.Okamoto

    subroutine calphase(ia)
      integer, intent(in) :: ia
      integer       :: i
      real(kind=DP) :: ph
      do i = 1, nmatsz2
         ph = (pos(ia,1)*ngabc(i,1)+pos(ia,2)*ngabc(i,2)+pos(ia,3)*ngabc(i,3))*PAI2
         zfcos(i) = cos(ph)
         zfsin(i) = sin(ph)
      end do
      zfcos(0) = 0.d0; zfsin(0) = 0.d0
    end subroutine calphase
         
    subroutine nlmtrx
      real(kind=DP),pointer,dimension(:,:,:) :: a
!!$      real(kind=DP),pointer,dimension(:,:)   :: s
      real(kind=DP),allocatable,dimension(:,:)  :: s
      integer, pointer, dimension(:,:)       :: ng
      
      complex(kind=CMPLDP),parameter :: zi = (0.d0,1.d0)
      integer :: i,j,it,ia,u,v,n,lmt1,il1,lmt2,il2,j1,l1,l2,l3,ip,y,i1
      integer :: i2,j2,m
      real(kind=DP) :: fr,f21,f12,t

      a => hsmat
      ng => ngabc
!!$      s => snl(:,:,iksnl)
      allocate(s(kg1_ext,nlmtt)); s = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) == GAMMA <<nlmtrx>>")')
         if(iprimatdiagon >= 2) write(nfout,'(" kg2_gamma, iba(ik), iba2(ik) = ",3i8)') kg2_gamma,iba(ik),iba2(ik)
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            il1 = ltp(lmt1,it)
            if(iprimatdiagon >= 2) write(nfout,'(" nlmtt, j, lmt1, it, il1 = ",5i8)') nlmtt,j,lmt1,it,il1
            s(1,j) = snl(1,j,iksnl)
            if(mod(il1,2) == 0) then
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
      else
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) /= GAMMA <<nlmtrx>>")')
         do j = 1, nlmtt
            do i = 1, iba(ik)
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      a = 0.d0
      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1  = index_lmt1_lmt2(ip,it,1)
            lmt2  = index_lmt1_lmt2(ip,it,2)
            u     = lmtt(lmt1,it)
            v     = lmtt(lmt2,it)
            il1   = ltp(lmt1,it)
            il2   = ltp(lmt2,it)
            if(lmt2 <= lmt1) cycle
!!$            if(ivanl(il1,it) /= 1 .and. &
            if(ivan(it) /= 1 .and. &
                 & (il1 /= il2 .or. mtp(lmt1,it) /= mtp(lmt2,it))) cycle
!!$            write(nfout,'(" il1, il2 = ",2i8)') il1, il2
            if(mod(il1+il2,2) == 0) then
               if(ipaw(it)==0) then
                   fr  = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr  = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               endif
               if(il1==il2) then
                  f21 = fr*iwei(ia)
                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if(kimg == 1) then
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a(i,j,1) = a(i,j,1)+f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))
                           a(i,j,1) = a(i,j,1) + t*zfcos(y)
                           a(i,j,2) = a(i,j,2) - t*zfsin(y)
                        end do
                     end if
                  end do
               else
                  f21 = real(zi**(il2-il1))*fr*iwei(ia)
                  f12 = real(zi**(il1-il2))*fr*iwei(ia)
                  write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)
                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if(kimg == 1) then
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a(i,j,1) = a(i,j,1)+(f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                           a(i,j,1) = a(i,j,1) + t*zfcos(y)
                           a(i,j,2) = a(i,j,2) - t*zfsin(y)
                        end do
                     end if
                  end do
               end if
            else if(mod(il1+il2,2) == 1) then
!!$               write(nfout,'(" !! mod(il1+il2,2)==1: il1, il2 = ",2i8)') il1, il2
!!$               fr = vlhxcQ(lmt1,lmt2,ia,ispin)
               if(ipaw(it)==0) then
                   fr = vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               end if
               f21 = -aimag(zi**(il2-il1))*fr*iwei(ia)
               f12 = -aimag(zi**(il1-il2))*fr*iwei(ia)
               do j = 1, iba2(ik)
                  j1 = nbmat(j,ik)
                  j2 = nbmat2(j,ik)
                  l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                  if(kimg == 1) then
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        a(i,j,1) = a(i,j,1)+ &
                            & (f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfsin(y)
                     end do
                  else
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                        a(i,j,1) = a(i,j,1) + t*zfsin(y)
                        a(i,j,2) = a(i,j,2) + t*zfcos(y)
                     end do
                  end if
               end do
            end if
         end do
         do lmt1 = 1, ilmt(it)
            if(ipaw(it)==0) then
                fr = (dion(lmt1,lmt1,it) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            else
                fr = (dion_paw(lmt1,lmt1,ispin,ia) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            endif
            u  = lmtt(lmt1,it)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a(i,j,1) = a(i,j,1) + fr*s(i2,u)*s(j2,u)*zfcos(y)
                  end do
               else if(kimg == 2) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t = fr*s(i2,u)*s(j2,u)
                     a(i,j,1) = a(i,j,1) + t*zfcos(y)
                     a(i,j,2) = a(i,j,2) - t*zfsin(y)
                  end do
               end if
            end do
         end do
      end do
      deallocate(s)

    end subroutine nlmtrx

    subroutine ovmtrx
      integer :: i,j,it,ia,u,v,n,ip,y,jn,j1,l1,l2,l3,i1,lmt1,lmt2
      integer :: i2,j2,m,jm
      real(kind=DP) :: fr,t
      real(kind=DP),pointer,dimension(:,:,:) :: a
!!$      real(kind=DP),pointer,dimension(:,:)   :: s
      real(kind=DP),allocatable,dimension(:,:)   :: s
      integer,pointer,dimension(:,:)         :: ng

      a => hsmat
      ng => ngabc
!!$      s => snl(:,:,iksnl)
! === DEBUG by tkato 2011/09/06 ================================================
!     allocate(s(kg1_ext,nlmtt))
      allocate(s(kg1_ext,nlmtt)); s = 0.0d0
! ==============================================================================

      if(k_symmetry(ik) == GAMMA) then
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            l1 = ltp(lmt1,it)
            s(1,j) = snl(1,j,iksnl)
            if(mod(l1,2) == 0) then
               do i = 2, iba(ik)
!!$                  i1 = nbase(i,1)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) =  snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, iba(ik)
!!$                  i1 = nbase(i,1)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
         if(iprimatdiagon >= 3) then
            write(nfout,'(" --- ovmtrx ---")')
            write(nfout,'(" ik = ",i8)') ik
            do j = 1, nlmtt
               write(nfout,'(" s(1:*,",i3,")      : ",10f8.4)')j, (s(i,j),i=1,10)
            end do
         end if
      else
         do j = 1, nlmtt
            do i = 1, kg1
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      a = 0.d0
      do i = 1, iba2(ik)
         a(i,i,1) = 1.d0
      end do
      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1 = index_lmt1_lmt2(ip,it,1)
            u = lmtt(lmt1,it)
            lmt2 = index_lmt1_lmt2(ip,it,2)
            if(lmt2 <= lmt1) cycle
            v = lmtt(lmt2,it)
            if(ltp(lmt1,it) /= ltp(lmt2,it) .or. mtp(lmt1,it) /= mtp(lmt2,it) ) cycle
            fr = q(lmt1,lmt2,it)*iwei(ia)
            do j = 1, iba2(ik)
               jn = nbmat(j,ik)
               jm = nbmat2(j,ik)
               l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                     a(i,j,1) = a(i,j,1)+fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))*zfcos(y)
                  end do
               else
                  do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                     t  = fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))
                     a(i,j,1) = a(i,j,1) + t*zfcos(y)
                     a(i,j,2) = a(i,j,2) - t*zfsin(y)
                  end do
               end if
            end do
         end do
         do lmt1 = 1, ilmt(it)
            u  = lmtt(lmt1,it)
            fr = q(lmt1,lmt1,it)*iwei(ia)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a(i,j,1) = a(i,j,1)+fr*s(i2,u)*s(j2,u)*zfcos(ip)
                  end do
               else if(kimg == 2) then
                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t  = fr*s(i2,u)*s(j2,u)
                     a(i,j,1) = a(i,j,1) + t*zfcos(ip)
                     a(i,j,2) = a(i,j,2) - t*zfsin(ip)
                  end do
               end if
            end do
         end do
      end do

      if(kimg == 1) then
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) = a(j,i,1)
            end do
         end do
      else
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) =  a(j,i,1)
               a(i,j,2) = -a(j,i,2)
            end do
         end do
      end if
      deallocate(s)

    end subroutine ovmtrx

    subroutine cholde
! Choleski decomposition.
! ref: S.G.Louie,K.M.Ho,and M.L.Cohen, PRB19,(1979),p1774.
      integer       :: n,i,j
      real(kind=DP) :: t
      integer  :: imax, jmax
      integer, parameter :: NMATSIZE = 10

      linv = 0.d0
      linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if(kimg == 1) then
         do n = 1, iba2(ik)-1
            ldag = 0.d0
            do  i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) + linv(i,j,1)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1)=linv(n+1,i,1)-linv(n+1,n+1,1)*ldag(j,1)*linv(j,i,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do n = 1, iba2(ik)-1
            ldag = 0.d0
            do i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) &
                       & + linv(i,j,1)*hsmat(j,n+1,1)-linv(i,j,2)*hsmat(j,n+1,2)
                  ldag(i,2) = ldag(i,2) &
                       & + linv(i,j,1)*hsmat(j,n+1,2)+linv(i,j,2)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2 + ldag(i,2)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1) = linv(n+1,i,1) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,1) &
                       &                         +ldag(j,2)*linv(j,i,2))&
                       &       + linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,2)&
                       &                         -ldag(j,2)*linv(j,i,1) )
                  linv(n+1,i,2) = linv(n+1,i,2) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,2) &
                       &                         -ldag(j,2)*linv(j,i,1))&
                       &       - linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,1)&
                       &                         -ldag(j,2)*linv(j,i,2) )
               end do
            end do
         end do
      end if
      if(iprimatdiagon >= 2) then
         imax = NMATSIZE; if(imax > nmatsz) imax = nmatsz
         jmax = NMATSIZE; if(jmax > nmatsz) jmax = nmatsz
         do j = 1, jmax
            write(nfout,'(" linv(1:*,",i3,",1): ",10f8.4,99(/18x,10f8.4))') j &
                 & , (linv(i,j,1),i=1,imax)
         end do
         if(kimg == 2) then
            do j = 1, jmax
               write(nfout,'(" linv(1:*,",i3,",2): ",10f8.4,99(/18x,10f8.4))') j &
                    & , (linv(i,j,2),i=1,imax)
            end do
         end if
      end if
    end subroutine cholde

    subroutine amtrxkinetic
      integer :: i,j
      real(kind=DP) :: ga,gb,gc
      do i = 1, iba2(ik)
         j = nbmat(i,ik)
         ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
         gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
         gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
         hsmat(i,i,1) = hsmat(i,i,1) + 0.5 &
              & * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              & +  ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
      end do
    end subroutine amtrxkinetic

    subroutine prjvlhxc_l2vlhxc_t()
      integer :: i,irc
      vlhxc_t = 0.d0; vlhxc = 0.d0
      do irc = 1, kimg
         do i = ista_kngp, iend_kngp
            if(i > nmatsz2) cycle
            vlhxc_t(i,irc) = vlhxc_l(i,irc,ispin)
         end do
      end do
      if(npes >= 2) then
         call mpi_allreduce(vlhxc_t,vlhxc,nmatsz2*kimg,mpi_double_precision &
              &            ,mpi_sum,mpi_comm_group,ierr)
      else
         vlhxc = vlhxc_t
      end if
    end subroutine prjvlhxc_l2vlhxc_t

    subroutine amtrxlocalpt()
      integer :: j,j1,l1,l2,l3,i,n,ip
      real(kind=DP),pointer,dimension(:,:,:) :: a
      integer,      pointer,dimension(:,:)   :: ng
      a  => hsmat
      ng => ngabc

      do j = 1, iba2(ik)
         j1 = nbmat(j,ik)
         l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
         if(kimg == 1) then
            do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
            end do
         else
            do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
               a(i,j,2) = a(i,j,2) + vlhxc(ip,2)
            end do
         end if
      end do
      if(kimg == 1) then
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) = a(j,i,1)
            end do
         end do
      else
         do j = 2, iba2(ik)
            do i = 1, j-1
               a(i,j,1) =  a(j,i,1)
               a(i,j,2) = -a(j,i,2)
            end do
         end do
      end if
    end subroutine amtrxlocalpt

    subroutine lhl
      real(kind=DP),pointer,dimension(:,:,:)     :: h
      real(kind=DP),allocatable,dimension(:,:,:) :: ww
      integer :: i,j,k, M, N

      h => hsmat
      allocate(ww(nmatsz,nmatsz,kimg)); ww = 0.d0

      if(kimg == 1) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,1),nmatsz,0.d0, ww(1,1,1),nmatsz)
#else
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1) + linv(i,k,1)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,1),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,1),nmatsz)
#else
         h = 0.d0
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, j
                  h(i,j,1) = h(i,j,1) + ww(i,k,1)*linv(j,k,1)
              end do
            end do
         end do
#endif
      else if(kimg == 2) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,1),nmatsz,0.d0, ww(1,1,1),nmatsz)
         call DGEMM__('N','N',M,N,K,-1.d0, linv(1,1,2),nmatsz,h(1,1,2),nmatsz,1.d0, ww(1,1,1),nmatsz)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,1),nmatsz,h(1,1,2),nmatsz,0.d0, ww(1,1,2),nmatsz)
         call DGEMM__('N','N',M,N,K, 1.d0, linv(1,1,2),nmatsz,h(1,1,1),nmatsz,1.d0, ww(1,1,2),nmatsz)
#else
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1)+linv(i,k,1)*h(k,j,1)-linv(i,k,2)*h(k,j,2)
                  ww(i,j,2) = ww(i,j,2)+linv(i,k,1)*h(k,j,2)+linv(i,k,2)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         M = iba2(ik); N = iba2(ik); K = iba2(ik)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,1),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,1),nmatsz)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,2),nmatsz,linv(1,1,2),nmatsz,1.d0, h(1,1,1),nmatsz)
         call DGEMM__('N','T',M,N,K, 1.d0, ww(1,1,2),nmatsz,linv(1,1,1),nmatsz,0.d0, h(1,1,2),nmatsz)
         call DGEMM__('N','T',M,N,K,-1.d0, ww(1,1,1),nmatsz,linv(1,1,2),nmatsz,1.d0, h(1,1,2),nmatsz)
#else
         h = 0.d0
         do i = 1, iba2(ik)
            do j = 1, iba2(ik)
               do k = 1, j
                  h(i,j,1) = h(i,j,1)+ww(i,k,1)*linv(j,k,1)+ww(i,k,2)*linv(j,k,2)
                  h(i,j,2) = h(i,j,2)+ww(i,k,2)*linv(j,k,1)-ww(i,k,1)*linv(j,k,2)
               end do
            end do
         end do
#endif
      end if
      deallocate(ww)
    end subroutine lhl

    subroutine lx()
#ifdef HIUX
! *** 'poption''s have been inserted by Dr. Kino (National Institute  ***
! *** for Materials Science, Japan).  12 July 2005                    ***
#endif
      integer :: ib, ib2, i, j
      integer :: i1
      if(kimg == 1) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
            do i = 1, iba2(ik)
!!$               i1=nbmat2(i,ik)
               ldag(i,1) = zaj_mat(i,ib2,1)
            end do
            zaj_mat(:,ib2,1) = 0.d0
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
            do i = 1, iba2(ik)
!!$               i1=nbmat2(i,ik)
               do j = 1, iba2(ik)
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv(j,i,1)*ldag(j,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
!!$            if(iprimatdiagon >= 3) then
!!$               write(nfout,'(" iba2(ik) = ",i8," nmatsz = ",i8)') iba2(ik), nmatsz
!!$            end if
            if(iba2(ik) > nmatsz)  stop ' iba2(ik) > nmatsz'
            do i = 1, iba2(ik)
!!$               i1=nbmat2(i,ik)
               ldag(i,1) = zaj_mat(i,ib2,1)
               ldag(i,2) = zaj_mat(i,ib2,2)
            end do
            zaj_mat(:,ib2,1:2) = 0.d0
#ifdef HIUX
*poption parallel , tlocal(i1)
#endif
            do i = 1, iba2(ik)
!!$               i1=nbmat2(i,ik)
               do j = i, iba2(ik)
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) &
                       &        + linv(j,i,1)*ldag(j,1) + linv(j,i,2)*ldag(j,2)
                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) &
                       &        + linv(j,i,1)*ldag(j,2) - linv(j,i,2)*ldag(j,1)
               end do
            end do
         end do
      end if
    end subroutine lx

    subroutine phase_mult()
      integer :: ib, ib2, ig
      real(kind=DP) :: wfr,wfi,sqrwf, pcos,psin
#ifndef _PHASE_MULT_0_
      integer :: ig1, ig2, ig_max 
      complex(kind=CMPLDP) :: exp2theta, exptheta
      real(kind=DP) :: sqrwf0, wfr2, wfi2, sqrwfi, sqrwf1, sqrwf2,f &
           &          ,phase2r, phase2i, cos2theta, pcos0,psin0, norm
      real(kind=DP), parameter :: abswf_min = 1.d-16
#endif
      
!!$      do ig = 1, nmatsz
      if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef _PHASE_MULT_0_
            wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
            if(abs(wfi*wfi) > 1.d-30) then
               sqrwf = wfr**2 + wfi**2
               f = dsqrt(sqrwf)
               pcos = -wfr/f; psin = wfi/f
               if(iprimatdiagon >= 2) then
                  write(nfout,'(4x," pcos, psin = ",2e14.6)') pcos, psin
               end if
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
            end if
#else
            wfi = zaj_mat(1,ib2,2)
            sqrwfi = wfi*wfi
            !!$if(sqrwfi > 1.d-30) then
            !!$ Bugfix proposed by T.Yamamasaki 
            if(sqrwfi > 1.d-35) then
            !!$if(sqrwfi > 1.d-40) then
            !!$if(sqrwfi > 1.d-50) then
               wfr = zaj_mat(1,ib2,1)
               sqrwf0 = wfr**2 + sqrwfi
!!$               if(sqrwf0 > abswf_min) then
               if(sqrwfi > abswf_min) then
                  ig_max = 1
               else
                  ig_max = 1
                  g_search: do ig = 2, kg2_gamma
                     ig1 = nbase_gamma(ig,1)
                     wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                     sqrwfi = wfi*wfi
                     sqrwf = wfr**2 + sqrwfi
                     if(sqrwfi > abswf_min) then
                        ig_max = ig
                        exit g_search
                     else
                        if(sqrwf > sqrwf0) then
                           ig_max = ig
                           sqrwf0 = sqrwf
                        end if
                     end if
                  end do g_search
               end if
               if(ig_max == 1) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos = -wfr/f; psin = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf = ",e14.6)') sqrwf0
                  end if
               else if(ig_max >= 2) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos0 = -wfr/f; psin0 = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig =  0")') pcos0, psin0
                  end if
                  ig1 = nbase_gamma(ig_max,1)
                  ig2 = nbase_gamma(ig_max,2)
                  wfr  = zaj_mat(ig1,ib2,1);  wfi  = zaj_mat(ig1,ib2,2)
                  wfr2 = zaj_mat(ig2,ib2,1);  wfi2 = zaj_mat(ig2,ib2,2)
                  sqrwf1 = wfr**2 + wfi**2
                  sqrwf2 = wfr2**2 + wfi2**2
                  sqrwf = sqrt(sqrwf1*sqrwf2)
                  phase2r =  (wfr*wfr2 - wfi*wfi2)/sqrwf
                  phase2i = -(wfr*wfi2 + wfr2*wfi)/sqrwf
                  norm = sqrt(phase2r*phase2r + phase2i*phase2i)
                  phase2r = phase2r/norm
                  phase2i = phase2i/norm
                  exp2theta = dcmplx(phase2r,phase2i)
                  exptheta = sqrt(exp2theta)
                  pcos = real(exptheta)
                  psin = imag(exptheta)
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf1, sqrwf2, sqrwf = ",3e14.6)') sqrwf1, sqrwf2, sqrwf
                  end if
                  cos2theta = (wfr*wfr2 - wfi*wfi2)/sqrwf
                  cos2theta = cos2theta/norm
                  if(cos2theta > 1.0) cos2theta = 1.d0
                  if(cos2theta < -1.0) then
                     pcos = 0.d0
                     psin = 1.d0
                  else
                     pcos =  sqrt((1+cos2theta)/2.0)
                     psin =  sqrt((1-cos2theta)/2.0)
                  end if
                  if(pcos0 < 0.0) pcos = - pcos
                  if(psin0 < 0.0) psin = - psin 
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                  end if
               end if
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
!!$                  zaj_mat(ig,ib2,1) = phaser*wfr - phasei*wfi
!!$                  zaj_mat(ig,ib2,2) = phaser*wfi + phasei*wfr
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
               zaj_mat(1,ib2,2) = 0.d0
            !$else
            !$   do ig = 2, kg2_gamma
            !$      ig1 = nbase_gamma(ig,1)
            !$      wfr = zaj_mat(ig1,ib2,1)
            !$      sqrwf = sqrwf + wfr**2
            !$   end do
            !$   sqrwf = 2.d0*sqrwf + zaj_mat(1,ib2,1)**2
            !$   sqrwf = 1.d0/sqrt(sqrwf)
            !$   do ig = 1, iba2(ik)
            !$      wfr = zaj_mat(ig,ib2,1)
            !$      zaj_mat(ig,ib2,1) = wfr*sqrwf
            !$      zaj_mat(ig,ib2,2) = 0.d0
            !$   end do
            end if
#endif
            if(iprimatdiagon >=2 ) then
               write(nfout,'(i4," Re ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),1),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),1),ig=6,40)
               write(nfout,'(i4," Im ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),2),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),2),ig=6,40)
            end if
         end do

         if(k_symmetry(ik) == GAMMA_base_symmetrization) then
            do ib = ista_e, iend_e, istep_e
               ib2 = map_z(ib)
               do ig = 2, kg2_gamma
                  ig1 = nbase_gamma(ig,1)
                  ig2 = nbase_gamma(ig,2)
                  wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                  zaj_mat(ig2,ib2,1) = wfr
                  zaj_mat(ig2,ib2,2) = -wfi
               end do
            end do
         end if
      end if
      if(iprimatdiagon >= 2) write(nfout,'(" out of <<phase_mult>>")')
    end subroutine phase_mult

    subroutine cp_zaj_mat_to_zaj_l()
      integer :: ib,ig, i
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            zaj_l(:,:,ik,1) = 0.d0
            do ib = 1, np_e
               do ig = 1, kg2_gamma
                  i = nbase(ig,ik)
                  zaj_l(ig,ib,ik,1) = zaj_mat(i,ib,1)
               end do
            end do
         else if(kimg == 2) then
            zaj_l(:,:,ik,1) = 0.d0
            zaj_l(:,:,ik,2) = 0.d0
            do ib = 1, np_e
               do i = 1, kg2_gamma
                  ig = nbase(i,ik)
                  zaj_l(i,ib,ik,1) = zaj_mat(ig,ib,1)
                  zaj_l(i,ib,ik,2) = zaj_mat(ig,ib,2)
               end do
            end do
         end if
      else
         if(kimg == 1) then
            zaj_l(:,:,ik,1) = 0.d0
            do ib = 1, np_e
               do i = 1, iba2(ik)
                  ig = nbmat2(i,ik)
                  zaj_l(ig,ib,ik,1) = zaj_mat(i,ib,1)
               end do
            end do
         else if(kimg == 2) then
            zaj_l(:,:,ik,1) = 0.d0
            zaj_l(:,:,ik,2) = 0.d0
            do ib = 1, np_e
               do i = 1, iba2(ik)
                  ig = nbmat2(i,ik)
                  zaj_l(ig,ib,ik,1) = zaj_mat(i,ib,1)
                  zaj_l(ig,ib,ik,2) = zaj_mat(i,ib,2)
               end do
            end do
         end if
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do ib = 1, np_e
            status_saved_phifftr(ib,ik) = OLD
         end do
      end if
#endif
    end subroutine cp_zaj_mat_to_zaj_l
            
  end subroutine m_ESmat_solve_Hx_eq_eSx

! ============================== added by Tagami ======================== 11.0
  subroutine m_ESmat_solve_Hx_eq_eSx_noncl( nfout,iteration,iteration_electronic )
    integer, intent(in) :: nfout, iteration, iteration_electronic

    integer,parameter :: PRINT_LEVEL = 2
    integer   :: ik, iksnl, n=0
    integer   :: is1, is2
    integer :: is_tmp


    integer   :: id_sname = -1
    call tstatc0_begin('m_ESmat_solve_Hx_eq_eSx_noncl ',id_sname,1)

    if(iprimatdiagon >= 2) then
       write(nfout,'(" !! iteration = ",i6, " m_ESmat_solve_Hx_eq_eSx_noncl")') &
	&        iteration
    end if

    if(ekmode == ON ) then
       if(iteration_electronic == 1) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    else
       if(iteration == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if ( skip_alloc_phonon .and. iteration_electronic == 1 &
                    	         & .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    end if

    call m_pwBS_alloc_nbmat_and_iba2()
    call m_pwBS_mat_for_each_WF() ! -> nbmat,nbmat2,iba2

    call m_pwBS_alloc_igpo()
    call m_pwBS_GminusGmapfunction()  ! -> igpo, nmatsz2

    if(iprimatdiagon >= 3) write(nfout,'(" nmatsz2 = ",i9)') nmatsz2
    if(iprimatdiagon >= PRINT_LEVEL) &
         & write(nfout,'(" nmatsz, kg1_ext = ", 2i9)') nmatsz, kg1_ext

    call alloc_matrices()
! 
    call m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )
! 
    do ik = 1, kv3, ndim_spinor

       if(map_k(ik) /= myrank_k) cycle
       if(iprimatdiagon >= PRINT_LEVEL) &
               & write(nfout,'(" iba2(",i3,") = ", i9)') ik, iba2(ik)

       iksnl = (ik-1)/ndim_spinor + 1
       hsmat = 0.d0

       if ( modnrm == EXECUT ) then
          if ( iprimatdiagon >=3 ) then
            write(nfout,'(" !! modnrm == EXECUT (m_ESmat_solve_Hx_eq_eSx_noncl)")')
          endif

          Do is1=1, ndim_spinor
             call ovmtrx_noncl( is1, is1 )
             if ( iprimatdiagon >= 3 ) then
                call wd_hsmat_noncl(" -- ovmtrx --", is1, is1 )
             end if
          End do

          call complete_hermite_matrix_noncl

          if ( sw_use_zhegvx == ON ) then
             hsmat_s = hsmat
          else
             call cholde_noncl()
             if ( iprimatdiagon >= 3 ) then
                Do is1=1, ndim_spinor
                   call wd_hsmat_noncl(" -- cholde --",is1,is1 )
                End do
             endif
          endif

       endif 
        
       hsmat = 0.d0
       Do is1=1, ndim_spinor       
          Do is2=1, ndim_spinor       
             call nlmtrx_noncl( is1, is2 )           ! (nlmtrx) -> hsmat <- snl
             if ( iprimatdiagon >= 3 ) then
                call wd_hsmat_noncl(" -- nlmtrx --",is1,is2 )
             end if

             if ( is1==is2 ) then
                call amtrxkinetic_noncl( is1, is2 )     !  -> hsmat
                if ( iprimatdiagon >= 3 ) then
                   call wd_hsmat_noncl(" -- amtrxkinetic --", is1, is2 )
                endif
             endif

             is_tmp = ( is1 -1 )*ndim_spinor + is2
             call prjvlhxc_l2vlhxc_t_noncl( is_tmp )    ! vlhxc_l -> vlhxc
             call amtrxlocalpt_noncl( is1, is2 )                !  -> hsmat
             if ( iprimatdiagon >= 3 ) then
	        call wd_hsmat_noncl(" -- amtrxlocalpt --", is1, is2 )
             endif
          End do
       End do

       call complete_hermite_matrix_noncl

       if ( modnrm == EXECUT ) then
          if ( sw_use_zhegvx == OFF ) then
             call lhl_noncl() ! -> hsmat
             if ( iprimatdiagon >= 3 ) then
                Do is1=1, ndim_spinor
                   Do is2=1, ndim_spinor
                      call wd_hsmat_noncl(" -- lhl --", is1, is2 )
                   End do
                End do
             endif
          endif
       endif

       if ( modnrm == EXECUT .and. sw_use_zhegvx == ON ) then
          call solve_Hx_eq_ex_LAPACK_noncl2()
       else
          call solve_Hx_eq_ex_LAPACK_noncl()
       endif

       if ( iprimatdiagon >= 3 ) then
          Do is1=1, ndim_spinor
             call wd_hsmat_noncl(" -- after diagonalization --",is1,1 )
          End do
       endif

       if ( modnrm == EXECUT ) then
          if ( sw_use_zhegvx == OFF ) then
             call lx_noncl() ! -> zaj_mat
          endif
       endif

!       if ( k_symmetry(ik) == GAMMA .or. &
!	&     k_symmetry(ik) == GAMMA_base_symmetrization ) then
!	  call phase_mult_noncl()
!       endif

       call cp_zaj_mat_to_zaj_l_noncl()     ! zaj_mat -> zaj_l

    end do


    if ( iprimatdiagon >= 3 ) then
       do ik = 1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle
          call m_ES_wd_zaj_small_portion( nfout, ik, &
	&                         " (m_ESmat_solve_Hx_eq_eSx_noncl)",31 )
       end do
    end if

    call dealloc_matrices()
    call m_pwBS_dealloc_igpo()
    call m_pwBS_dealloc_nbmat_and_iba2()

    call m_ES_betar_dot_WFs(nfout) ! (fsrfsi) -> fsr_l, fsi_l

! ****************************************** This is important ******
    call m_ES_sort_eigen_vals_noncl()
! *******************************************************************

    call tstatc0_end(id_sname)

  contains

    subroutine wd_hsmat_noncl( str, is1, is2 )
      character(len=*),intent(in) :: str
      integer, intent(in) :: is1, is2

      integer :: i, imax, j, jmax
      integer :: ishift, jshift

      integer, parameter :: NMATSIZE = 10
      write(nfout,'(a30," ik= ",i5)') str,ik

      imax = min(NMATSIZE, nmatsz)
      jmax = min(NMATSIZE, nmatsz)
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      write(nfout,*) 'istart = ', ishift +1
      do j = 1, jmax
         write(nfout,'(" hsmat(istart:*,",i3,",1): ",10f8.4,99(/19x,10f8.4))') j+jshift &
              & , (hsmat( i+ishift, j+jshift, 1 ),i=1,imax)
      end do
      if(kimg == 2) then
         do j = 1, jmax
            write(nfout,'(" hsmat(istart:*,",i3,",2): ",10f8.4,99(/19x,10f8.4))') j+jshift &
                 & , (hsmat( i+ishift,j+jshift,2 ),i=1,imax)
         end do
      end if
    end subroutine wd_hsmat_noncl

   ! [LAPACK] with LAPACK library
   !***** LAPACK [begin] ***** M.Okamoto
    subroutine solve_Hx_eq_ex_LAPACK_noncl()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, &
                 i, j, ib, lwork, k
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable :: &
         ifail(:), iwork(:)
      real(kind=DP),allocatable :: &
         amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: &
         cmat(:,:), cvmat(:,:), cwork(:)
      complex(kind=CMPLDP),parameter :: IMG = (0.d0,1.d0)
      character(len=5) :: a
      integer :: ri

! -------------------------------- ktDEBUG --------
      complex(kind=CMPLDP) :: ctemp
! -------------------------------- ktDEBUG --------

      zaj_mat(:,:,:) = 0.d0 
      lda = nmatsz *ndim_spinor

      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg

      ne = iu - il + 1
      !abstol = eps_solve_Hx_eq_ex
!!$      abstol = 1.d-15
      !abstol = -1.d0

      abstol = 2*dlamch('S')
      if ( kimg == 1 ) then
         n = iba2(ik) *ndim_spinor

         lwork = max(1,12*n)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(amat(lda,n),rvmat(lda,ne),rwork(lwork))
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         amat(:,:) = 0.d0
         do i = 1,n
            do j = 1,n
               amat(i,j) = hsmat(i,j,1)
            end do
         end do
         if ( iprimatdiagon >= 2 ) then
            write(nfout,'(" --- n   = ", i8, " <<solve_Hx_eq_ex_LAPACK_noncl>>")') n
            write(nfout,'(" --- lda = ",i8)') lda
            write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
            write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
            write(nfout,'(" --- lwork = ",i8)') lwork
            write(nfout,'(" --- abstol = ", d20.8)') abstol
            write(nfout,'(" --- amat(diagonal) = ",8f8.4)') (amat(i,i),i=1,n)
         end if
         call dsyevx( 'V', 'I', 'U', n, amat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, rvmat, lda, rwork, lwork, iwork, ifail, info )

         if ( iprimatdiagon >= 2 ) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_LAPACK_noncl): ik = ",&
	&                  i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
            a = "     "
            do ib = ista_e, iend_e, istep_e               ! MPI
               write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                    & ib,ik,evec(ib),a,(rvmat(i,ib),i=1,5)
            end do
         end if

         if (ne_found /= ne) then
            write(*,*) '### ERROR ### ne_found != ne'
            write(*,*) '   ne_found ...',ne_found
            write(*,*) '   ne       ...',ne
            stop
         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = rvmat(i,ib)
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++
         deallocate(amat,rvmat,rwork)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
         n = iba2(ik) *ndim_spinor

! -------------------------------- ktDEBUG --------
!         lwork = max(1,6*n)
! -------------------------------- ktDEBUG --------

        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))

! -------------------------------- ktDEBUG --------
!         allocate(cmat(lda,n),cvmat(lda,ne),cwork(lwork),rwork(7*n))
         allocate(cmat(lda,n),cvmat(lda,ne),rwork(7*n))
! -------------------------------- ktDEBUG --------
         
         evec = 0.d0; iwork = 0; ifail = 0; cmat = cmplx(0.d0,0.d0)

! -------------------------------- ktDEBUG --------
!         cvmat = cmplx(0.d0,0.d0); cwork = cmplx(0.d0,0.d0); rwork = 0.d0;
         cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
! -------------------------------- ktDEBUG --------
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         cmat(:,:) = 0.d0
         do i = 1,n
           do j = 1,n
              cmat(i,j) = cmplx(hsmat(i,j,1),hsmat(i,j,2))
           end do
         end do

! -------------------------------- ktDEBUG --------
         call zheevx( 'V', 'I', 'U', n, cmat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, cvmat, lda, ctemp, -1, rwork, iwork, &
                       ifail, info )
         lwork = int(real(ctemp))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)
! -------------------------------- ktDEBUG --------

         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- n   = ", i8, " <<solve_Hx_eq_ex_LAPACK_noncl>>")') n
            write(nfout,'(" --- lda = ",i8)') lda
            write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
            write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
            write(nfout,'(" --- lwork = ",i8)') lwork
            write(nfout,'(" --- abstol = ", d20.8)') abstol
            write(nfout,'(" --- cmat(diagonal) = ",8f8.4)') (cmat(i,i),i=1,n)
         end if

         call zheevx( 'V', 'I', 'U', n, cmat, lda, vl, vu, il, iu, abstol, &
                       ne_found, evec, cvmat, lda, cwork, lwork, rwork, iwork, &
	               ifail, info )

         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_LAPACK_noncl): ik = ",&
                         &  i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
            a = "     "
            do ib = ista_e, iend_e, istep_e               ! MPI
               do ri = 1, kimg
                  if(ri == 1 .and. kimg == 2) a = "(Re) "
                  if(ri == 2) a = "(Im) "
                  if(ri == 1) write(nfout,'(" evec(",i4,",",i3,")= ",e14.6,&
	                         &          " ",a4,5e14.6)') &
                                 & ib,ik,evec(ib),a,(real(cvmat(i,ib)),i=1,5)
                  if(ri == 2) write(nfout,'(32x,a4,5e14.6)') a,(aimag(cvmat(i,ib)),i=1,5)
               end do
            end do
         end if

         if (ne_found /= ne) then
            write(*,*) '### ERROR ### ne_found != ne'
            write(*,*) '   ne_found ...',ne_found
            write(*,*) '   ne       ...',ne
            stop
         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if


         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if


      if ( iprimatdiagon >= 2 ) then
         write(nfout,'(" -- eigen values (solve_Hx_eq_ex_noncl): ik = ",i8)') ik
         write(nfout,'(8f10.6)') (evec(i),i=1,ne)
         a = "     "
         do ib = ista_e, iend_e, istep_e               ! MPI
            do ri = 1, kimg
               if(ri == 1 .and. kimg == 2) a = "(Re) "
               if(ri == 2) a = "(Im) "
               if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                    & ib,ik,eko_l(map_z(ib),ik),a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               write(nfout,'(35x,5e14.6)') (zaj_mat(i,map_z(ib),ri),i=6,20)
            end do
         end do
      end if

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) then
         stop ' ! illegal evec (solve_Hx_eq_ex_noncl)'
      endif
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum

     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++

    end subroutine solve_Hx_eq_ex_LAPACK_noncl

    subroutine solve_Hx_eq_ex_LAPACK_noncl2()
      integer :: n, lda, ne, ne_found, il, iu, info, ipos, &
                 i, j, ib, lwork, k
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable :: ifail(:), iwork(:)
      real(kind=DP),allocatable :: amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: cmat(:,:), cmat2(:,:), cvmat(:,:), cwork(:)

      complex(kind=CMPLDP),parameter :: IMG = (0.d0,1.d0)

      character(len=5) :: a
      integer :: ri

! -------------------------------- ktDEBUG --------
      complex(kind=CMPLDP) :: ctemp
! -------------------------------- ktDEBUG --------

      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz *ndim_spinor

      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg
      ne = iu - il + 1

      abstol = 2*dlamch('S')

      if ( kimg == 1 ) then

      else if (kimg == 2) then
         n = iba2(ik) *ndim_spinor

         allocate(evec(n),iwork(5*n),ifail(n))
         allocate(cmat(lda,n),cmat2(lda,n),cvmat(lda,ne),rwork(7*n))

         evec = 0.d0; iwork = 0; ifail = 0;
         cmat = 0.0d0; cmat2 = 0.0d0
         cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;

         do i = 1,n
           do j = 1,n
              cmat(i,j) = cmplx(hsmat(i,j,1),hsmat(i,j,2))
              cmat2(i,j) = cmplx(hsmat_s(i,j,1),hsmat_s(i,j,2))
           end do
         end do

         call zhegvx( 1, 'V', 'I', 'U', n, cmat, lda, cmat2, lda, &
              &       vl, vu, il, iu, abstol, &
                      ne_found, evec, cvmat, lda, ctemp, -1, rwork, iwork, &
                      ifail, info )
         lwork = int(real(ctemp))
         allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)

         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- n   = ", i8, " <<solve_Hx_eq_ex_LAPACK_noncl2>>")') n
            write(nfout,'(" --- lda = ",i8)') lda
            write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
            write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
            write(nfout,'(" --- lwork = ",i8)') lwork
            write(nfout,'(" --- abstol = ", d20.8)') abstol
            write(nfout,'(" --- cmat(diagonal) = ",8f8.4)') (cmat(i,i),i=1,n)
         end if

         call zhegvx( 1, 'V', 'I', 'U', n, cmat, lda, cmat2, lda, &
              &       vl, vu, il, iu, abstol, &
                      ne_found, evec, cvmat, lda, cwork, lwork, rwork, iwork, &
                      ifail, info )

         if (iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_LAPACK_noncl2): ik = ",&
                         &  i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
            a = "     "
            do ib = ista_e, iend_e, istep_e               ! MPI
               do ri = 1, kimg
                  if(ri == 1 .and. kimg == 2) a = "(Re) "
                  if(ri == 2) a = "(Im) "
                  if(ri == 1) write(nfout,'(" evec(",i4,",",i3,")= ",e14.6,&
                                 &          " ",a4,5e14.6)') &
                                 & ib,ik,evec(ib),a,(real(cvmat(i,ib)),i=1,5)
                  if(ri == 2) write(nfout,'(32x,a4,5e14.6)') a,(aimag(cvmat(i,ib)),i=1,5)
               end do
            end do
         end if

         if (ne_found /= ne) then
            write(*,*) '### ERROR ### ne_found != ne'
            write(*,*) '   ne_found ...',ne_found
            write(*,*) '   ne       ...',ne
            stop
         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if


         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib))
            end do
            eko_l(j,ik) = evec(ib)
         end do
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cmat2,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if


      if ( iprimatdiagon >= 2 ) then
         write(nfout,'(" -- eigen values (solve_Hx_eq_ex_noncl2): ik = ",i8)') ik
         write(nfout,'(8f10.6)') (evec(i),i=1,ne)
         a = "     "
         do ib = ista_e, iend_e, istep_e               ! MPI
            do ri = 1, kimg
               if(ri == 1 .and. kimg == 2) a = "(Re) "
               if(ri == 2) a = "(Im) "
               if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                    & ib,ik,eko_l(map_z(ib),ik),a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_mat(i,map_z(ib),ri),i=1,5)
               write(nfout,'(35x,5e14.6)') (zaj_mat(i,map_z(ib),ri),i=6,20)
            end do
         end do
      end if

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) then
         stop ' ! illegal evec (solve_Hx_eq_ex_noncl)'
      endif
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum

     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++

    end subroutine solve_Hx_eq_ex_LAPACK_noncl2

    subroutine calphase(ia)
      integer, intent(in) :: ia
      integer       :: i
      real(kind=DP) :: ph
      do i = 1, nmatsz2
         ph = (pos(ia,1)*ngabc(i,1)+pos(ia,2)*ngabc(i,2)+pos(ia,3)*ngabc(i,3))*PAI2
         zfcos(i) = cos(ph)
         zfsin(i) = sin(ph)
      end do
      zfcos(0) = 0.d0; zfsin(0) = 0.d0
    end subroutine calphase
         
    subroutine nlmtrx_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      real(kind=DP),pointer,dimension(:,:,:) :: a
!!$      real(kind=DP),pointer,dimension(:,:)   :: s
      real(kind=DP),allocatable,dimension(:,:)  :: s
      integer, pointer, dimension(:,:)       :: ng
      
      complex(kind=CMPLDP),parameter :: zi = (0.d0,1.d0)
      integer :: i,j,it,ia,u,v,n,lmt1,il1,lmt2,il2,j1,l1,l2,l3,ip,y,i1
      integer :: i2,j2,m
      integer :: ishift, jshift
 
      integer :: is_tmp

      complex(kind=CMPLDP) :: fr,f21,f12,t, fr_tmp1, fr_tmp2
      real(kind=DP) :: t_r, t_i

!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      is_tmp = ( is1 -1 )*ndim_spinor + is2
!
      a => hsmat
      ng => ngabc

!!$      s => snl(:,:,iksnl)
      allocate(s(kg1_ext,nlmtt)); s = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) == GAMMA <<nlmtrx>>")')
         if(iprimatdiagon >= 2) write(nfout,'(" kg2_gamma, iba(ik), iba2(ik) = ",3i8)') kg2_gamma,iba(ik),iba2(ik)
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            il1 = ltp(lmt1,it)
            if(iprimatdiagon >= 2) write(nfout,'(" nlmtt, j, lmt1, it, il1 = ",5i8)') nlmtt,j,lmt1,it,il1
            s(1,j) = snl(1,j,iksnl)
            if(mod(il1,2) == 0) then
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, kg2_gamma
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
      else
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) /= GAMMA <<nlmtrx>>")')
         do j = 1, nlmtt
            do i = 1, iba(ik)
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin

! ===============
         if ( modnrm == SKIP .and. SpinOrbit_mode == Neglected &
              &              .and. sw_hubbard == OFF ) then
            do ip = 1, n_non0_lmtxlmt(it)       
                                             ! This counts only m1==m2, l1==l2
               lmt1  = index_lmt1_lmt2(ip,it,1)
               lmt2  = index_lmt1_lmt2(ip,it,2)
               u     = lmtt(lmt1,it)
               v     = lmtt(lmt2,it)
               il1   = ltp(lmt1,it)
               il2   = ltp(lmt2,it)

               if(lmt2 <= lmt1) cycle

               if(ivan(it) /= 1 .and. &
                    & (il1 /= il2 .or. mtp(lmt1,it) /= mtp(lmt2,it))) cycle
               
               if(mod(il1+il2,2) == 0) then
                  
                  fr = dion_scr_noncl(lmt1,lmt2,is_tmp,ia) 
                  
                  if(il1==il2) then
                     f21 = fr *iwei(ia)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                        if(kimg == 1) then
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + f21*( s(m,u)*s(j2,v) &
                                   &                          +s(m,v)*s(j2,u) ) &
                                   &                    *zfcos(y)
                           end do
                        else
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              t  = f21*( s(m,u)*s(j2,v)+s(m,v)*s(j2,u) )
                              
                              t_r = real(t);  t_i = aimag(t)
                              
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   - t_r *zfsin(y) + t_i *zfcos(y)
                           end do
                        end if
                     end do
                  else
                     f21 = real(zi**(il2-il1)) *fr *iwei(ia)
                     f12 = real(zi**(il1-il2)) *fr *iwei(ia)
                     
                     write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                        
                        if(kimg == 1) then
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift,1 )&
                                   &                      +( f21*s(m,u)*s(j2,v) &
                                   &                        +f12*s(m,v)*s(j2,u) ) &
                                   &                       *zfcos(y)
                           end do
                        else
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              
                              t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                              
                              t_r = real(t);  t_i = aimag(t)
                              
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   - t_r *zfsin(y) + t_i *zfcos(y)

                           end do
                        end if
                     end do
                  end if
               else if(mod(il1+il2,2) == 1) then

                  fr = dion_scr_noncl(lmt1,lmt2,is_tmp,ia) 

!                  f21 = -aimag(zi**(il2-il1))*fr*iwei(ia)
!                  f12 = -aimag(zi**(il1-il2))*fr*iwei(ia)
                  f21 = aimag(zi**(il2-il1))*fr*iwei(ia)
                  f12 = aimag(zi**(il1-il2))*fr*iwei(ia)
                  
                  do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                     if ( kimg == 1 ) then

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 )&
                                &                    + ( f21*s(m,u)*s(j2,v) &
                                &                       +f12*s(m,v)*s(j2,u) ) &
                                &                     *zfsin(y)
                        end do
                     else
                        
                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                           
                           t_r = real(t);  t_i = aimag(t)
                           
                           a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                &                   + t_r *zfsin(y) - t_i *zfcos(y)
                           a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                &                   + t_r *zfcos(y) + t_i *zfsin(y)
                        end do
                     end if
                  end do
               end if
            end do
! ----------------------------------------------- when Spin-Orbit is included --
         else
!            write(*,*) 'it, ivan = ', it, ivan(it)

!            do lmt1=1, nlmt
!               Do lmt2=1, nlmt
            do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  u     = lmtt(lmt1,it)
                  v     = lmtt(lmt2,it)
                  il1   = ltp(lmt1,it)
                  il2   = ltp(lmt2,it)

                  if (lmt2 <= lmt1 ) cycle

!                  if(ivan(it) /= 1 .and. (il1 /= il2) ) cycle
!                  if ( il1 /= il2 ) cycle
               
                  if(mod(il1+il2,2) == 0) then
                  
                     fr_tmp1 = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)
                     fr_tmp2 = dion_scr_noncl(lmt2,lmt1,is_tmp,ia)
                  
                     if(il1==il2) then
                        f21 = fr_tmp1 *iwei(ia)
                        f12 = fr_tmp2 *iwei(ia)
                        
                        do j = 1, iba2(ik)
                           j1 = nbmat(j,ik)
                           j2 = nbmat2(j,ik)
                           l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                           if(kimg == 1) then
                           
                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                      &                   + ( f21 *s(m,u)*s(j2,v) &
                                      &                      +f12 *s(m,v)*s(j2,u) ) &
                                      &                    *zfcos(y)
                              end do
                           else
                              
                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)

                                 t  = f21*s(m,u)*s(j2,v) + f12*s(m,v)*s(j2,u)
                                 
                                 t_r = real(t);  t_i = aimag(t)
                                 
                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                      &                   + t_r *zfcos(y) + t_i *zfsin(y)
                                 a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                      &                   - t_r *zfsin(y) + t_i *zfcos(y)
                              end do
                           end if
                        end do
                     else

                        f21 = real(zi**(il2-il1)) *fr_tmp1 *iwei(ia)
                        f12 = real(zi**(il1-il2)) *fr_tmp2 *iwei(ia)
                        
!!!!                        write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)
                        
                        do j = 1, iba2(ik)
                           j1 = nbmat(j,ik)
                           j2 = nbmat2(j,ik)
                           l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                           
                           if(kimg == 1) then
                              
                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                                 a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift,1 )&
                                      &                      +( f21*s(m,u)*s(j2,v) &
                                      &                        +f12*s(m,v)*s(j2,u) ) &
                                      &                       *zfcos(y)
                              end do
                           else
                              
                              do i = j, iba2(ik)
                                 n = nbmat(i,ik)
                                 m = nbmat2(i,ik)
                                 y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                                 
                                 t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                                 
                                 t_r = real(t);  t_i = aimag(t)
                                 
                                 a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1) &
                                      &                   + t_r *zfcos(y) + t_i *zfsin(y)
                                 a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                      &                   - t_r *zfsin(y) + t_i *zfcos(y)
                                 
                              end do
                           end if
                        end do
                     end if

                  else if(mod(il1+il2,2) == 1) then
                     
                     fr_tmp1 = dion_scr_noncl(lmt1,lmt2,is_tmp,ia)
                     fr_tmp2 = dion_scr_noncl(lmt2,lmt1,is_tmp,ia)

!                     f21 = -aimag(zi**(il2-il1))*fr_tmp1*iwei(ia)
!                     f12 = -aimag(zi**(il1-il2))*fr_tmp2*iwei(ia)
                     f21 = aimag(zi**(il2-il1))*fr_tmp1*iwei(ia)
                     f12 = aimag(zi**(il1-il2))*fr_tmp2*iwei(ia)

                     do j = 1, iba2(ik)
                        j1 = nbmat(j,ik)
                        j2 = nbmat2(j,ik)
                        l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
                        if ( kimg == 1 ) then
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 )&
                                   &                    + ( f21*s(m,u)*s(j2,v) &
                                   &                       +f12*s(m,v)*s(j2,u) ) &
                                   &                     *zfsin(y)
                           end do
                        else
                           
                           do i = j, iba2(ik)
                              n = nbmat(i,ik)
                              m = nbmat2(i,ik)
                              y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                              t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                              
                              t_r = real(t);  t_i = aimag(t)
                              
                              a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
                                   &                   + t_r *zfsin(y) - t_i *zfcos(y)
                              a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
                                   &                   + t_r *zfcos(y) + t_i *zfsin(y)
                           end do
                        end if
                     end do
                  end if
               end do
            end do
         endif
! ------------------------------------------ diagonal term ----
         do lmt1 = 1, ilmt(it)

            fr = ( dion_scr_noncl(lmt1,lmt1,is_tmp,ia) )*iwei(ia)

            u  = lmtt(lmt1,it)
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
               if(kimg == 1) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + fr*s(i2,u)*s(j2,u)*zfcos(y)
                  end do
               else if(kimg == 2) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t = fr*s(i2,u)*s(j2,u)

                     t_r = real(t);  t_i = aimag(t)

                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                                       + t_r *zfcos(y) + t_i *zfsin(y)
                     a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
	&                                       - t_r *zfsin(y) + t_i *zfcos(y)
                  end do
               end if
            end do
         end do
      end do
      deallocate(s)

    end subroutine nlmtrx_noncl

    subroutine ovmtrx_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: i,j,it,ia,u,v,n,ip,y,jn,j1,l1,l2,l3,i1,lmt1,lmt2
      integer :: i2,j2,m,jm
      integer :: il1, il2

      integer :: ishift, jshift

      integer :: is_tmp

      complex(kind=CMPLDP) :: fr,t, fr_tmp1, fr_tmp2
      real(kind=DP) :: t_r, t_i

      real(kind=DP),pointer,dimension(:,:,:) :: a
!!$      real(kind=DP),pointer,dimension(:,:)   :: s
      real(kind=DP),allocatable,dimension(:,:)   :: s
      integer,pointer,dimension(:,:)         :: ng
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!

      is_tmp = ( is1 -1 )*ndim_spinor + is2
!

      a => hsmat;        ng => ngabc
      allocate(s(kg1_ext,nlmtt))

      if(k_symmetry(ik) == GAMMA) then
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            l1 = ltp(lmt1,it)
            s(1,j) = snl(1,j,iksnl)
            if(mod(l1,2) == 0) then
               do i = 2, iba(ik)
!!$                  i1 = nbase(i,1)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) =  snl(i,j,iksnl)
                  s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = 2, iba(ik)
!!$                  i1 = nbase(i,1)
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
         if(iprimatdiagon >= 3) then
            write(nfout,'(" --- ovmtrx ---")')
            write(nfout,'(" ik = ",i8)') ik
            do j = 1, nlmtt
               write(nfout,'(" s(1:*,",i3,")      : ",10f8.4)')j, (s(i,j),i=1,10)
            end do
         end if
      else
         do j = 1, nlmtt
            do i = 1, kg1
               s(i,j) = snl(i,j,iksnl)
            end do
         end do
      end if

      do i = 1, iba2(ik)
         a( i+ishift,i+jshift,1 ) = 1.d0
      end do

      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin

! ===============
         if ( SpinOrbit_mode /= BuiltIn  ) then
            do ip = 1, n_non0_lmtxlmt(it)
               lmt1 = index_lmt1_lmt2(ip,it,1)
               u = lmtt(lmt1,it)
               lmt2 = index_lmt1_lmt2(ip,it,2)

               if(lmt2 <= lmt1) cycle
               v = lmtt(lmt2,it)

               if(ltp(lmt1,it) /= ltp(lmt2,it) .or. mtp(lmt1,it) /= mtp(lmt2,it) ) cycle
               
               fr = q_noncl( lmt1, lmt2, is_tmp, it ) *iwei(ia)
               
               do j = 1, iba2(ik)
                  jn = nbmat(j,ik)
                  jm = nbmat2(j,ik)
                  l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)
                  
                  if ( kimg == 1 ) then
                     
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift, 1 ) &
                             &                      + fr *( s(m,u)*s(jm,v) &
                             &                             +s(m,v)*s(jm,u) ) &
                             &                        *zfcos(y)
                     end do
                  else
                     
                     do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        
                        t  = fr *( s(m,u)*s(jm,v)+s(m,v)*s(jm,u) )
                        t_r = real(t);  t_i = aimag(t)
                        
                        a( i+ishift, j+jshift, 1 ) = a( i+ishift,j+jshift, 1 ) &
                             &                      + t_r *zfcos(y) + t_i *zfsin(y)
                        a( i+ishift, j+jshift, 2 ) = a( i+ishift,j+jshift, 2 ) &
                             &                      - t_r *zfsin(y) + t_i *zfcos(y)
                     end do
                  end if
               end do
            end do

         else
! -------------------------------------- when Spin-Orbit is included -- ( builtin )
!            do lmt1=1, nlmt
!               Do lmt2=1, nlmt
            do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  u     = lmtt(lmt1,it)
                  v     = lmtt(lmt2,it)
                  il1   = ltp(lmt1,it)
                  il2   = ltp(lmt2,it)

                  if(lmt2 <= lmt1) cycle

                  v = lmtt(lmt2,it)

                  if ( ltp(lmt1,it) /= ltp(lmt2,it) ) cycle

                  fr_tmp1 = q_noncl( lmt1, lmt2, is_tmp, it ) *iwei(ia)
                  fr_tmp2 = q_noncl( lmt2, lmt1, is_tmp, it ) *iwei(ia)

                  do j = 1, iba2(ik)
                     jn = nbmat(j,ik)
                     jm = nbmat2(j,ik)
                     l1 = ng(jn,1); l2 = ng(jn,2); l3 = ng(jn,3)

                     if ( kimg == 1 ) then

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           a( i+ishift, j+jshift, 1 ) = a( i+ishift, j+jshift, 1 ) &
                                &                      + ( fr_tmp1*s(m,u)*s(jm,v) &
                                &                       +fr_tmp2*s(m,v)*s(jm,u) ) &
                                &                       *zfcos(y)
                        end do
                     else

                        do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           
                           t  = fr_tmp1*s(m,u)*s(jm,v) +fr_tmp2*s(m,v)*s(jm,u)

                           t_r = real(t);  t_i = aimag(t)

                           a( i+ishift, j+jshift, 1 ) = a( i+ishift,j+jshift, 1 ) &
                                &                      + t_r *zfcos(y) + t_i *zfsin(y)
                           a( i+ishift, j+jshift, 2 ) = a( i+ishift,j+jshift, 2 ) &
                                &                      - t_r *zfsin(y) + t_i *zfcos(y)
                        end do
                     end if
                  end do
               End do
            End do
            
         endif
! ------------------------------------------ diagonal term ----
         do lmt1 = 1, ilmt(it)
            u  = lmtt(lmt1,it)
            
            fr = q_noncl(lmt1,lmt1,is_tmp,it) *iwei(ia)
            
            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

               if ( kimg == 1 ) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + fr *s(i2,u)*s(j2,u)*zfcos(ip)
                  end do
               else if (kimg == 2) then

                  do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)

                     t  = fr *s(i2,u)*s(j2,u)
                     t_r = real(t);  t_i = aimag(t)

                     a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) &
	&                         + t_r *zfcos(ip) + t_i *zfsin(ip)
                     a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) &
	&                         - t_r *zfsin(ip) + t_i *zfcos(ip)
                  end do
               end if
            end do
         end do
      end do

!      if(kimg == 1) then
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a(i+isfhit,j+jshift,1) = a(j+jshift,i+isfhit,1)
!            end do
!         end do
!      else
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a(i+isfhit,j+jsfhit,1) =  a(j+jshift,i+ishift,1)
!               a(i+isfhit,j+jshift,2) = -a(j+jshift,i+isfhit,2)
!            end do
!         end do
!      end if

      deallocate(s)

    end subroutine ovmtrx_noncl

    subroutine cholde_noncl
! Choleski decomposition.
! ref: S.G.Louie,K.M.Ho,and M.L.Cohen, PRB19,(1979),p1774.
      integer       :: n,i,j
      real(kind=DP) :: t
      integer  :: imax, jmax
      integer, parameter :: NMATSIZE = 10

      linv = 0.d0
      linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if ( kimg == 1 ) then
         do n = 1, iba2(ik)*ndim_spinor -1
            ldag = 0.d0
            do  i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) + linv(i,j,1)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2
            end do
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1)=linv(n+1,i,1)-linv(n+1,n+1,1)*ldag(j,1)*linv(j,i,1)
               end do
            end do
         end do
      else if(kimg == 2) then

         do n = 1, iba2(ik)*ndim_spinor -1
            ldag = 0.d0
            do i = 1, n
               do j = 1, i
                  ldag(i,1) = ldag(i,1) &
                       & + linv(i,j,1)*hsmat(j,n+1,1)-linv(i,j,2)*hsmat(j,n+1,2)
                  ldag(i,2) = ldag(i,2) &
                       & + linv(i,j,1)*hsmat(j,n+1,2)+linv(i,j,2)*hsmat(j,n+1,1)
               end do
            end do
            t = 0.d0
            do i = 1, n
               t = t + ldag(i,1)**2 + ldag(i,2)**2
            end do

!
            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
            do i = 1, n
               do j = 1, n
                  linv(n+1,i,1) = linv(n+1,i,1) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,1) &
                       &                         +ldag(j,2)*linv(j,i,2))&
                       &       + linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,2)&
                       &                         -ldag(j,2)*linv(j,i,1) )
                  linv(n+1,i,2) = linv(n+1,i,2) &
                       &       - linv(n+1,n+1,1)*(ldag(j,1)*linv(j,i,2) &
                       &                         -ldag(j,2)*linv(j,i,1))&
                       &       - linv(n+1,n+1,2)*(ldag(j,1)*linv(j,i,1)&
                       &                         -ldag(j,2)*linv(j,i,2) )
               end do
            end do
         end do
      end if

      if(iprimatdiagon >= 2) then
         imax = NMATSIZE; if(imax > nmatsz) imax = nmatsz
         jmax = NMATSIZE; if(jmax > nmatsz) jmax = nmatsz

         do j = 1, jmax
            write(nfout,'(" linv(1:*,",i3,",1): ",10f8.4,99(/18x,10f8.4))') j &
                 & , (linv(i,j,1),i=1,imax)
         end do

         if(kimg == 2) then
            do j = 1, jmax
               write(nfout,'(" linv(1:*,",i3,",2): ",10f8.4,99(/18x,10f8.4))') j &
                    & , (linv(i,j,2),i=1,imax)
            end do
         end if

      end if
    end subroutine cholde_noncl

    subroutine amtrxkinetic_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: i,j
      integer :: ishift, jshift
      real(kind=DP) :: ga,gb,gc
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      do i = 1, iba2(ik)
         j = nbmat(i,ik)
         ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
         gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
         gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
         hsmat( i+ishift,i+jshift,1 ) = hsmat( i+ishift,i+jshift, 1 ) &
	      & + 0.5d0 * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              &           +ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
      end do
    end subroutine amtrxkinetic_noncl

    subroutine prjvlhxc_l2vlhxc_t_noncl( is )
      integer, intent(in) :: is

      integer :: i,irc
      vlhxc_t = 0.d0; vlhxc = 0.d0
      do irc = 1, kimg
         do i = ista_kngp, iend_kngp
            if(i > nmatsz2) cycle
            vlhxc_t(i,irc) = vlhxc_ssrep(i,irc,is)
         end do
      end do
      if(npes >= 2) then
         call mpi_allreduce(vlhxc_t,vlhxc,nmatsz2*kimg,mpi_double_precision &
              &            ,mpi_sum,mpi_comm_group,ierr)
      else
         vlhxc = vlhxc_t
      end if
    end subroutine prjvlhxc_l2vlhxc_t_noncl

    subroutine amtrxlocalpt_noncl( is1, is2 )
      integer, intent(in) :: is1, is2

      integer :: j,j1,l1,l2,l3,i,n,ip
      integer :: ishift, jshift
      real(kind=DP),pointer,dimension(:,:,:) :: a
      integer,      pointer,dimension(:,:)   :: ng
!
      ishift = ( is1 -1 )*iba2(ik)
      jshift = ( is2 -1 )*iba2(ik)
!
      a  => hsmat
      ng => ngabc

      do j = 1, iba2(ik)
         j1 = nbmat(j,ik)
         l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
         if(kimg == 1) then
!!!!!!!            do i = j, iba2(ik)
            do i = 1, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) + vlhxc(ip,1)
            end do
         else
!!!!!!!            do i = j, iba2(ik)
            do i = 1, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               a( i+ishift,j+jshift,1 ) = a( i+ishift,j+jshift,1 ) + vlhxc(ip,1)
               a( i+ishift,j+jshift,2 ) = a( i+ishift,j+jshift,2 ) + vlhxc(ip,2)
            end do
         end if
      end do
! ============= dangerous -
!      if(kimg == 1) then
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a( i+isfhit,j+jshift,1)  = a( j+jshift,i+isfhit,1 )
!!            end do
!         end do
!      else
!         do j = 2, iba2(ik)
!            do i = 1, j-1
!               a( i+ishift,j+jshift,1 ) =  a( j+jshift,i+ishift,1 )
!               a( i+ishift,j+jshift,2 ) = -a( j+jshift,i+ishift,2 )
!            end do
!         end do
!      end if
! ======================
    end subroutine amtrxlocalpt_noncl

    subroutine complete_hermite_matrix_noncl
      integer :: is1, is2, i, j
      integer :: ishift, jshift
      real(kind=DP),pointer,dimension(:,:,:) :: a

      a  => hsmat

      Do is1=1, ndim_spinor
         Do is2=1, ndim_spinor
            ishift = ( is1 -1 )*iba2(ik)
            jshift = ( is2 -1 )*iba2(ik)

!            istmp1 = ( is1 -1 )*ndim_spinor + is2
!            istmp2 = ( is2 -1 )*ndim_spinor + is1
!
            Do j=2, iba2(ik)
               Do i=1, j-1
                  a( i+ishift,j+jshift,1 ) =  a( j+jshift,i+ishift,1 )
                  a( i+ishift,j+jshift,2 ) = -a( j+jshift,i+ishift,2 )
               End do
            End do

         End do
      End do

    end subroutine complete_hermite_matrix_noncl

    subroutine lhl_noncl
      real(kind=DP),pointer,dimension(:,:,:)     :: h
      real(kind=DP),allocatable,dimension(:,:,:) :: ww
      integer :: i,j,k, M, N

      h => hsmat
      allocate( ww( nmatsz*ndim_spinor, nmatsz*ndim_spinor, kimg ) ); ww = 0.d0

      if (kimg == 1) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor;
	 N = iba2(ik) *ndim_spinor; 
	 K = iba2(ik) *ndim_spinor
         call DGEMM__(' N', 'N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor, &
	&              h(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              ww(1,1,1), nmatsz*ndim_spinor )
#else
         do i = 1, iba2(ik)*ndim_spinor
            do j = 1, iba2(ik)*ndim_spinor
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1) + linv(i,k,1)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
#else
         h = 0.d0
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, j
                  h(i,j,1) = h(i,j,1) + ww(i,k,1)*linv(j,k,1)
              end do
            end do
         end do
#endif
      else if (kimg == 2) then
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor
	 N = iba2(ik) *ndim_spinor
	 K = iba2(ik) *ndim_spinor
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor,&
	&               h(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&               ww(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K,-1.d0, linv(1,1,2), nmatsz*ndim_spinor,&
	&               h(1,1,2), nmatsz*ndim_spinor, 1.d0, &	
	&               ww(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,1), nmatsz*ndim_spinor,&
	&               h(1,1,2), nmatsz*ndim_spinor, 0.d0, &
	&               ww(1,1,2), nmatsz*ndim_spinor )
         call DGEMM__( 'N','N', M, N, K, 1.d0, linv(1,1,2), nmatsz*ndim_spinor,&
	&               h(1,1,1), nmatsz*ndim_spinor, 1.d0, &
	&               ww(1,1,2), nmatsz*ndim_spinor )
#else
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, i
                  ww(i,j,1) = ww(i,j,1)+linv(i,k,1)*h(k,j,1)-linv(i,k,2)*h(k,j,2)
                  ww(i,j,2) = ww(i,j,2)+linv(i,k,1)*h(k,j,2)+linv(i,k,2)*h(k,j,1)
               end do
            end do
         end do
#endif
#ifdef MATDIAGON_DGEMM
         M = iba2(ik) *ndim_spinor; 
	 N = iba2(ik) *ndim_spinor;
	 K = iba2(ik) *ndim_spinor
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,2), nmatsz*ndim_spinor, &
	&              linv(1,1,2), nmatsz*ndim_spinor, 1.d0, &
	&              h(1,1,1), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K, 1.d0, ww(1,1,2), nmatsz*ndim_spinor, &
	&              linv(1,1,1), nmatsz*ndim_spinor, 0.d0, &
	&              h(1,1,2), nmatsz*ndim_spinor )
         call DGEMM__( 'N','T', M, N, K,-1.d0, ww(1,1,1), nmatsz*ndim_spinor, &
	&              linv(1,1,2), nmatsz*ndim_spinor, 1.d0, &
	&              h(1,1,2), nmatsz*ndim_spinor )
#else
         h = 0.d0
         do i = 1, iba2(ik) *ndim_spinor
            do j = 1, iba2(ik) *ndim_spinor
               do k = 1, j
                  h(i,j,1) = h(i,j,1)+ww(i,k,1)*linv(j,k,1)+ww(i,k,2)*linv(j,k,2)
                  h(i,j,2) = h(i,j,2)+ww(i,k,2)*linv(j,k,1)-ww(i,k,1)*linv(j,k,2)
               end do
            end do
         end do
#endif
      end if
      deallocate(ww)
    end subroutine lhl_noncl

    subroutine lx_noncl()
#ifdef HIUX
! *** 'poption''s have been inserted by Dr. Kino (National Institute  ***
! *** for Materials Science, Japan).  12 July 2005                    ***
#endif
      integer :: ib, ib2, i, j
      integer :: i1
      if(kimg == 1) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
            do i = 1, iba2(ik) *ndim_spinor
               ldag(i,1) = zaj_mat(i,ib2,1)
            end do
            zaj_mat(:,ib2,1) = 0.d0
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
            do i = 1, iba2(ik) *ndim_spinor
               do j = 1, iba2(ik) *ndim_spinor
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv(j,i,1)*ldag(j,1)
               end do
            end do
         end do
      else if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef HIUX
*poption parallel, tlocal(i1)
#endif
            if(iba2(ik) > nmatsz)  stop ' iba2(ik) > nmatsz'
            do i = 1, iba2(ik) *ndim_spinor
               ldag(i,1) = zaj_mat(i,ib2,1)
               ldag(i,2) = zaj_mat(i,ib2,2)
            end do
            zaj_mat(:,ib2,1:2) = 0.d0
#ifdef HIUX
*poption parallel , tlocal(i1)
#endif
            do i = 1, iba2(ik) *ndim_spinor
               do j = i, iba2(ik)*ndim_spinor
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) &
                       &        + linv(j,i,1)*ldag(j,1) + linv(j,i,2)*ldag(j,2)
                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) &
                       &        + linv(j,i,1)*ldag(j,2) - linv(j,i,2)*ldag(j,1)
               end do
            end do
         end do
      end if
    end subroutine lx_noncl

    subroutine phase_mult_noncl()
      integer :: ib, ib2, ig
      real(kind=DP) :: wfr, wfi, sqrwf, pcos,psin
#ifndef _PHASE_MULT_0_
      integer :: ig1, ig2, ig_max 
      complex(kind=CMPLDP) :: exp2theta, exptheta
      real(kind=DP) :: sqrwf0, wfr2, wfi2, sqrwfi, sqrwf1, sqrwf2,f &
           &          ,phase2r, phase2i, cos2theta, pcos0,psin0, norm
      real(kind=DP), parameter :: abswf_min = 1.d-16
#endif
      
      integer :: is, igshift

!!$      do ig = 1, nmatsz
      if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = map_z(ib)
#ifdef _PHASE_MULT_0_

            Do is=1, ndim_spinor
              igshift = ( is-1 )*iba2(ik)
              wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )

              if (abs( wfi*wfi ) > 1.d-30) then
                 sqrwf = wfr1**2 + wfi**2
                 f = dsqrt(sqrwf)
                 pcos = -wfr/f; psin = wfi/f
                 if(iprimatdiagon >= 2) then
                    write(nfout,'(4x," pcos, psin = ",2e14.6)') pcos, psin
                 end if
                 do ig = 1, iba2(ik)
                    wfr = zaj_mat( ig+igshift,ib2,1 )
	            wfi = zaj_mat( ig+igshift,ib2,2 )
                    zaj_mat( ig+igshift,ib2,1 ) = pcos*wfr - psin*wfi
                    zaj_mat( ig+igshift,ib2,2 ) = pcos*wfi + psin*wfr
                 end do

              end if
            end do
#else
            Do is=1, ndim_spinor
              igshift = ( is-1 )*iba2(ik)
	      wfi = zaj_mat( igshift+1,ib2,2 )
              sqrwfi = wfi*wfi

              if (sqrwfi > 1.d-35) then
	         wfr = zaj_mat( igshift+1,ib2,1 ); 
                 sqrwf0 = wfr**2 + sqrwfi

                 if (sqrwfi > abswf_min) then
                    ig_max = 1
                 else
                    ig_max = 1
                    g_search: do ig = 2, kg2_gamma
                       ig1 = nbase_gamma(ig,1)
                       wfr = zaj_mat( ig1+igshift,ib2,1 ); 
                       wfi = zaj_mat( ig1+igshift,ib2,2 )
   
                       sqrwfi = wfi*wfi
                       sqrwf = wfr**2 + sqrwfi

                       if(sqrwfi > abswf_min) then
                          ig_max = ig
                          exit g_search
                       else
                          if(sqrwf > sqrwf0) then
                            ig_max = ig
                            sqrwf0 = sqrwf
                          end if
                       end if
                    end do g_search
                 end if

                 if (ig_max == 1) then
                    wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )
                    sqrwf0 = wfr**2 + wfi**2
                    f = dsqrt(sqrwf0)
                    pcos = -wfr/f; psin = wfi/f
                    if (iprimatdiagon >= 2 ) then
                        write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                        pcos, psin,ig_max
                        write(nfout,'(4x," sqrwf = ",e14.6)') sqrwf0
                    end if
                 else if(ig_max >= 2) then
                    wfr = zaj_mat( igshift+1,ib2,1 ); wfi = zaj_mat( igshift+1,ib2,2 )
                    sqrwf0 = wfr**2 + wfi**2
                    f = dsqrt(sqrwf0)
                    pcos0 = -wfr/f; psin0 = wfi/f
                    if (iprimatdiagon >= 2) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig =  0")') &
	&                       pcos0, psin0
                    end if

                    ig1 = nbase_gamma(ig_max,1);  ig2 = nbase_gamma(ig_max,2)

                    wfr  = zaj_mat( ig1+igshift,ib2,1 )
	            wfi  = zaj_mat( ig1+igshift,ib2,2 )
                    wfr2 = zaj_mat( ig2+igshift,ib2,1 )
	            wfi2 = zaj_mat( ig2+igshift,ib2,2 )

                    sqrwf1 = wfr**2 + wfi**2
                    sqrwf2 = wfr2**2 + wfi2**2
                    sqrwf = sqrt(sqrwf1*sqrwf2)
   
                    phase2r =  (wfr*wfr2 - wfi*wfi2)/sqrwf
                    phase2i = -(wfr*wfi2 + wfr2*wfi)/sqrwf
                    norm = sqrt(phase2r*phase2r + phase2i*phase2i)
                    phase2r = phase2r/norm;  phase2i = phase2i/norm
                    exp2theta = cmplx(phase2r,phase2i)
                    exptheta = sqrt(exp2theta)

                    pcos = real(exptheta);      psin = imag(exptheta)

                    if (iprimatdiagon >= 2) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                            pcos, psin,ig_max
                       write(nfout,'(4x," sqrwf1, sqrwf2, sqrwf = ",3e14.6)') &
	&                            sqrwf1, sqrwf2, sqrwf
                    end if

                    cos2theta = (wfr*wfr2 - wfi*wfi2)/sqrwf
                    cos2theta = cos2theta/norm
                    if (cos2theta > 1.0 ) cos2theta = 1.d0
                    if (cos2theta < -1.0 ) then
                       pcos = 0.d0;  psin = 1.d0
                    else
                       pcos = sqrt((1+cos2theta)/2.0); psin = sqrt((1-cos2theta)/2.0)
                    end if
                    if (pcos0 < 0.0 ) pcos = - pcos
                    if (psin0 < 0.0 ) psin = - psin 
                    if (iprimatdiagon >= 2 ) then
                       write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') &
	&                                 pcos, psin,ig_max
                    end if
                 end if

                 do ig = 1, iba2(ik)
                    wfr = zaj_mat( ig+igshift,ib2,1 )
                    wfi = zaj_mat( ig+igshift,ib2,2 )
                    zaj_mat( ig+igshift,ib2,1 ) = pcos*wfr - psin*wfi
                    zaj_mat( ig+igshift,ib2,2 ) = pcos*wfi + psin*wfr
                 end do
                 zaj_mat( igshift+1,ib2,2 ) = 0.d0

              end if
            end do
#endif
            if ( iprimatdiagon >=2 ) then
               write(nfout,'(i4," Re ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),1),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),1),ig=6,40)
               write(nfout,'(i4," Im ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),2),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),2),ig=6,40)
            end if
         end do

         if (k_symmetry(ik) == GAMMA_base_symmetrization) then
            do ib = ista_e, iend_e, istep_e
               ib2 = map_z(ib)
               Do is=1, ndim_spinor
!!!!!!!                  igshift = ( is-1 ) *kg2_gamma
                  igshift = ( is-1 ) *iba2(ik)           ! ?????? kt : uncertain !!!

                  do ig = 2, kg2_gamma
                    ig1 = nbase_gamma(ig,1)
                    ig2 = nbase_gamma(ig,2)
                    wfr = zaj_mat( ig1+igshift,ib2,1 )
	            wfi = zaj_mat( ig1+igshift,ib2,2 )
                    zaj_mat( ig2+igshift,ib2,1 ) = wfr
                    zaj_mat( ig2+igshift,ib2,2 ) = -wfi
                  end do
               end do
            end do
         end if
      end if
      if(iprimatdiagon >= 2) write(nfout,'(" out of <<phase_mult_noncl>>")')
    end subroutine phase_mult_noncl

    subroutine cp_zaj_mat_to_zaj_l_noncl()
      integer :: ib,ig, i, is
      integer :: igshift

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
	    Do is=1, ndim_spinor
!!!!!!!	      igshift = kg2_gamma *(is-1)
	      igshift = iba2(ik) *(is-1)

              zaj_l( :, :, ik+is-1, 1 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, kg2_gamma
                    ig = nbase(i,ik)
                    zaj_l( i, ib, ik+is-1, 1 ) = zaj_mat( ig+igshift, ib, 1 )
                 end do
               end do
            end do
         else if(kimg == 2) then
	    Do is=1, ndim_spinor
!!!!!!!	      igshift = kg2_gamma *(is-1)

	      igshift = iba2(ik) *(is-1)

              zaj_l( : ,:, ik+is-1, 1 ) = 0.d0
              zaj_l( : ,:, ik+is-1, 2 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, kg2_gamma
                    ig = nbase(i,ik)
                    zaj_l( i, ib, ik+is-1, 1 ) = zaj_mat( ig+igshift, ib, 1 )
                    zaj_l( i, ib, ik+is-1, 2 ) = zaj_mat( ig+igshift, ib, 2 )
                 end do
              end do
           end do
         end if
      else
         if(kimg == 1) then
	    Do is=1, ndim_spinor
	      igshift = iba2(ik) *(is-1)
              zaj_l( :, :, ik+is-1, 1 ) = 0.d0

              do ib = 1, np_e
                 do i = 1, iba2(ik)
                    ig = nbmat2(i,ik)
                    zaj_l( ig, ib, ik+is-1, 1 ) = zaj_mat( i+igshift, ib, 1 )
                 end do
              end do
            end do
         else if(kimg == 2) then
	    Do is=1, ndim_spinor
	      igshift = iba2(ik) *(is-1)
              zaj_l( :, :, ik+is-1, 1 ) = 0.d0
              zaj_l( :, :, ik+is-1, 2 ) = 0.d0
              do ib = 1, np_e
                 do i = 1, iba2(ik)
                   ig = nbmat2(i,ik)
                   zaj_l( ig, ib, ik+is-1, 1 ) = zaj_mat( i+igshift, ib, 1 )
                   zaj_l( ig, ib, ik+is-1, 2 ) = zaj_mat( i+igshift, ib, 2 )
                 end do
               end do
            end do
         end if
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do is=1,ndim_spinor
            do ib=1,np_e
               status_saved_phifftr(ib,ik+is-1) = OLD
            end do
         end do
      end if
#endif
    end subroutine cp_zaj_mat_to_zaj_l_noncl
            
  end subroutine m_ESmat_solve_Hx_eq_eSx_noncl
!=============================================================================== 11.0

!===============================================================================
end module m_ES_WF_by_MatDiagon

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifndef DISABLE_VDWDF
subroutine vdW_scf(nspin,ispin,na,nb,nc,chgr,grad_rho,ecnl,dFdrho,dFddrho)
  use m_Const_Parameters, only : DP
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_vdWDF, only : initialize_vdwdf_scf,build_theta,vdWdf_core,corrections, &
  &   get_dFdrho_dFddrho,finalize_vdwdf,Ecnl_12,Ecnl_3,Ecnl_3s,univol,rinplw
  implicit none
  integer, intent(in) :: nspin,ispin,na,nb,nc
  real(kind=DP), dimension(na*nb*nc), intent(in) :: chgr,grad_rho
  real(kind=DP), intent(out) :: ecnl
  real(kind=DP), dimension(na,nb,nc), intent(out) :: dFdrho,dFddrho
  integer :: i,i1,i2,i3
  logical, save :: initialized=.false.
  integer :: id_sname=-1
  call tstatc0_begin('vdW_scf ',id_sname,1)
  call initialize_vdwdf_scf(nspin,ispin,na,nb,nc,chgr,grad_rho)
  call build_theta()
  call vdWdf_core()
  call corrections()
  ecnl = (Ecnl_12 + Ecnl_3 - Ecnl_3s)/(univol*rinplw)
  call get_dFdrho_dFddrho(na,nb,nc,dFdrho,dFddrho)
  call finalize_vdwdf()
  call tstatc0_end(id_sname)
end subroutine vdW_scf

subroutine vdW_oneshot()
  use m_Const_Parameters, only : DP
  use m_Control_Parameters, only : printable
  use m_Files, only : nfout
  use m_Parallelization, only : mype
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_Total_Energy, only : etotal
  use m_vdWDF, only: initialize_vdwdf_oneshot,build_theta,vdWdf_core,corrections,Ecnl_12,Ecnl_3,Ecnl_3s,finalize_vdwdf
  implicit none
  integer :: id_sname = -1
  real(kind=DP) :: Ecnl
  call tstatc0_begin('vdW_oneshot ',id_sname,1)
  if(mype==0) then
     write(nfout,'(a)')    "** 'oneshot' calculation of the vdW-interaction **"
  endif
  call initialize_vdwdf_oneshot()
  call build_theta()
  call vdWdf_core()
  call corrections()
  Ecnl = (Ecnl_12 + Ecnl_3 - Ecnl_3s)
  etotal = etotal + Ecnl
  if(printable) then
     write(nfout,'(a,f20.10,a)') 'vdW energy       : ',Ecnl,  ' hartree'
     write(nfout,'(a,f20.10,a)') '--> total energy : ',etotal,' hartree'
  endif
  call finalize_vdwdf()
  call tstatc0_end(id_sname)
end subroutine vdW_oneshot
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: skip2number, f_strcpy, skip2RHS, read_LHS_number, read_RHS_number,
!             rewind_to_tag0, f_strncmp, ch4prc, chnnm2, skip2alph, ch4mix, 
!             rd_alpha, rd_cutoff, rd_hownew, rd_nbxmix, rd_istrbr, 
!             check_mix_tag_name, check_decomp, nameck, skip2next, 
!             strncmp2, strncmp0, chchn0, isnumm, isnums, isalph, chnnm,
!             skip_to_subtagname, read_energy_unit, read_itagvalue, read_dtagvalue
!
!  FUNCTION:  skip_to_tagbegin, skip_to_tagbegin2, strncmp3
!
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!                           @(#)b_Words.f90 1.3 03/02/19 00:46:15
!***************************************************************
!
!  Subroutines in this file "b_Words" are all coded by T. Yamasaki
!  in 1993 - 1999
!
! $Id: b_Words.f90 409 2014-10-27 09:24:52Z jkoga $
logical function skip_to_tagbegin(nfinp,tag)
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag
      
  integer, parameter :: len_str = 132
  character(len=len_str) :: str
  logical :: tf

  rewind nfinp
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,len(tag),tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  skip_to_tagbegin = tf

end function skip_to_tagbegin

logical function skip_to_tagbegin2(nfinp,tag)
  integer, intent(in)         :: nfinp
  character(len=*),intent(in) :: tag

  integer :: ip
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  skip_to_tagbegin2 = .false.
  rewind nfinp
  ip = 0
1 read(nfinp,'(a132)',end=1001) str
  ip = index(str,tag)
!!$      write(6,'(i4,a76)') ip,str(1:76)
  if(ip <= 0) goto 1
1001 continue
  if(ip >= 1) skip_to_tagbegin2 = .true.
  write(6,'(" ip (skip_to_tagbegin2) = ",i4)') ip
end function skip_to_tagbegin2

subroutine read_dtagvalue(nfinp,tag_begin,tag,value)
  use m_Const_Parameters, only : DP
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag_begin,tag
  real(kind=DP), intent(inout) :: value
      
  logical :: tf, tf2, skip_to_tagbegin
  integer :: nsize
  real(kind=DP), dimension(1) :: work
  
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  if(tf) then
!!$         write(6,'(" -- tag is found -- ",a31)') tag
     call chnnm2(str,len_str,1,work,nsize)
     value = work(1)
  else
     write(6,'(" -- no tag value -- ",a31)') tag
  end if
!!$      write(6,'(20x,a31," = ",d20.12)') tag, value
  write(6,'(3x,a31," = ",d20.12)') tag, value

end subroutine read_dtagvalue

subroutine read_itagvalue(nfinp,tag_begin,tag,value)
  use m_Const_Parameters, only : DP
  integer, intent(in)          :: nfinp
  character(len=*), intent(in) :: tag_begin,tag
  integer, intent(inout)       :: value
      
  logical :: tf, tf2, skip_to_tagbegin
  integer :: nsize

  real(kind=DP), dimension(1)  :: work
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf)
  if(.not.tf) goto 1
1001 continue

  if(tf) then
     call chnnm2(str,len_str,1,work,nsize)
     value = nint(work(1))
  else
     write(6,'(" -- no tag value -- ",a31,"  default value is set")') tag
  end if
  write(6,'(3x,a31," = ",i8)') tag, value

end subroutine read_itagvalue

subroutine read_energy_unit(nfinp,tag_begin,tag,energy_unit)
  use m_Const_Parameters, only : HR_ENERGY_UNIT, EV_ENERGY_UNIT
  integer, intent(in) ::               nfinp
  character(len=*), intent(in) ::      tag_begin,tag
  integer, intent(out) ::              energy_unit

  logical :: tf
  integer :: ip, strncmp3
  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  call skip_to_subtagname(nfinp, tag_begin,tag,len_str,str,tf)
  if(tf) then
     ip = strncmp3(str,"=")
     if(strncmp3(str(ip+1:len_str),"hartree") >=1 ) then
        energy_unit = HR_ENERGY_UNIT
        write(6,'(" !  energy_unit (dos)= HARTREE")')
     else if(strncmp3(str(ip+1:len_str),"eV") >= 1 ) then
        energy_unit = eV_ENERGY_UNIT
        write(6,'(" !  energy_unit (dos)= eV")')
     end if
  end if
end subroutine read_energy_unit

subroutine skip_to_subtagname(nfinp,tag_begin,tag,len_str,str,tf)
  integer, intent(in) ::               nfinp,len_str
  character(len=*), intent(in) ::      tag_begin,tag
  character(len=len_str),intent(out):: str
  logical, intent(out) ::              tf
      
  logical :: tf1, tf2, skip_to_tagbegin

  if(.not.skip_to_tagbegin(nfinp,tag_begin)) return

  tf1 = .false.
1 read(nfinp,'(a132)',end = 1001) str
  call strncmp2(str,3,"end",3,tf2)
  if(tf2) goto 1001
  call strncmp2(str,len_str,tag,len(tag),tf1)
  if(.not.tf1) goto 1
1001 continue
  tf = tf1
end subroutine skip_to_subtagname

subroutine chnnm(str,len_str,n,wka,incunt)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in) :: len_str, n
  real(kind=DP), intent(out), dimension(n) :: wka
  integer, intent(out) :: incunt
  
  logical tf
  character(len=1) c
!!$  integer, parameter :: maxclm = 10
  real(kind=DP) :: xnum1
  integer icount
  integer i,ic2
  
  xnum1 = 0.d0
  call rsreal(n,wka)
  icount = 0
  incunt = 0
  
1001 continue
  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c.eq.':') goto 1006
     call isalph(c,tf)
     if(tf) goto 1006
     call isnumm(c,tf)
     if(tf) then
        read(str(i:len_str),*) xnum1
!          call chtonm(str(i:len_str),maxclm,xnum1)
        goto 1002
     endif
  enddo
  goto 1006
1002 continue
  incunt = incunt + 1
  wka(incunt) = xnum1

  if(incunt.eq.n) goto 1006
  
  ic2 = icount + 1
  do i = icount+1, len_str
     if(str(i:i).eq.' ') then
        ic2 = i
        goto 1004
     else if(str(i:i).eq.':') then
        goto 1006
     endif
  enddo
1004 continue
  icount = ic2
  goto 1001
1006 continue
end subroutine chnnm

subroutine isalph(chr,trorfa)
  implicit none
  character, intent(in):: chr
  logical, intent(out) :: trorfa
  if((ichar(chr) >= ichar('a') .and. ichar(chr) <= ichar('z')) &
       &     .or.(ichar(chr) >= ichar('A') .and. ichar(chr) <= ichar('Z')) &
       &     ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isalph

subroutine isnums(chr,trorfa )
  implicit none
  character, intent(in) :: chr
  logical ,intent(out) :: trorfa

  if(( ichar(chr).ge.ichar('0').and.ichar(chr).le.ichar('9') ) &
       &    .or.chr.eq.'.'.or.chr.eq.'-' &
       &    .or.(chr.eq.'D'.or.chr.eq.'E'.or.chr.eq.'Q') &
       &    ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isnums

subroutine isnumm(chr,trorfa )
  implicit none
  character, intent(in) :: chr
  logical ,intent(out) :: trorfa
  
  if(( ichar(chr).ge.ichar('0').and.ichar(chr).le.ichar('9') ) &
       &    .or.chr.eq.'.'.or.chr.eq.'-' ) then
     trorfa = .true.
  else
     trorfa = .false.
  endif
end subroutine isnumm

subroutine chchn0(str,len_str,n,name,ns)
  implicit none
  integer, intent(in)         :: len_str,n
  character(len=len_str), intent(in) :: str
  character(len=n), intent(out)  :: name
  integer, intent(out)        :: ns
  
  integer, parameter :: DP = kind(1.d0)
  real(kind=DP) :: xnum1
  integer :: ip, i, icount, ndif
  character c
  logical tf

  ip = 0
  do i = 1, n
     icount = i
     call isalph(str(i:i),tf)
     if(tf) goto 2000
  enddo
  stop ' >>> Invalid input data <<<'
2000 continue
  do i = icount, icount + n - 1
     icount = i
     if(str(i:i) /= ' '.and.str(i:i) /= ':') then
        ip     = ip + 1
        name(ip:ip) = str(i:i)
     else
        goto 2001
     endif
  enddo
2001 continue

  name(ip+1:n) = ' '
  !      do i = ip+1, n
  !        name(i:i) = ' '
  !      enddo

  ndif = ichar('a') - ichar('A')
  do i = 1, n
     c = name(i:i)
     if(ichar(c) >= ichar('A') .and. ichar(c) <= ichar('Z')) then
        name(i:i) = char(ichar(c) + ndif)
     endif
  enddo

  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c.eq.':') goto 2006
     call isnumm(c,tf)
     if(tf) then
        read(str(i:len_str),*) xnum1
!          call chtonm(str(i:len_str),maxclm,xnum1)
        goto 2002
     endif
  enddo
2002 continue

  do i = icount+1, len_str
     if(str(i:i) == ' ') then
        goto 2004
     else if(str(i:i) == ':') then
        goto 2006
     endif
  enddo
2004 continue
  
2006 continue
  ns   = xnum1
end subroutine chchn0

subroutine strncmp0(str1,str2,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  logical, intent(out) ::         tf

  integer :: len1, lencmp
  integer :: ndif, i, icharAcap,icharZcap,ichara,icharz,icharx &
       &   , icharupper, icharlower
!!$  character c
!  ----------
  len1 = len(str1)

  icharAcap = ichar('A')
  icharZcap = ichar('Z')
  ichara    = ichar('a')
  icharz    = ichar('z')

  ndif = ichar('A') - ichar('a')

  lencmp = len(str2)
  if(lencmp > len1) lencmp = len1
  tf = .false.
  do i = 1, lencmp
     icharx = ichar(str2(i:i))
     if(icharAcap <= icharx .and. icharx <= icharZcap) then
        icharupper = icharx
        icharlower = icharx - ndif
     else if(ichara <= icharx .and. icharx <= icharz) then
        icharupper = icharx + ndif
        icharlower = icharx
     else
        icharupper = icharx; icharlower = icharx
     end if
     if(str1(i:i).ne.char(icharupper).and.str1(i:i).ne.char(icharlower)) goto 1000
  enddo
  tf = .true.
1000 continue
end subroutine strncmp0

subroutine strncmp2(str1,len_str,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in)       :: len_str, n
  logical, intent(out)      :: tf

  integer :: ndif, istart, i2,i
  character c
!  ----------
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do istart = 1, len_str - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        c = char(ichar(str2(i2:i2)) + ndif)
        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
     enddo
     tf = .true.
1000 continue
     if(tf) return
  enddo

end subroutine strncmp2

subroutine strncmp2b(str1,len_str,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in)       :: len_str, n
  logical, intent(out)      :: tf

  integer :: ndif, istart, i2,i
  character c
!  ----------
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do istart = 1, len_str - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        c = char(ichar(str2(i2:i2)) + ndif)
        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
     enddo
     tf = .true.
1000 continue
     if(tf) then
        if(istart >= 2) then
           c = str1(istart-1:istart-1)
           if(c.ne.' ') tf = .false.
        end if
        if(i <= len_str) then
           c = str1(i:i)
           if(c.ne.' ' .and. c.ne.'=') tf = .false.
        end if
     end if
     if(tf) return
  enddo

end subroutine strncmp2b

integer function strncmp3(str1,str2)
  implicit none
  character(len=*), intent(in) :: str1, str2
!!$  integer, intent(in)       :: len_str

  integer :: ip,n,len1
  logical :: tf
  integer :: ndif, istart, i2,i, icharAcap,icharZcap,ichara,icharz,icharx &
       &   , icharupper, icharlower
!!$  character c
!  ----------
  len1 = len(str1)
  n = len(str2)
  icharAcap = ichar('A')
  icharZcap = ichar('Z')
  ichara    = ichar('a')
  icharz    = ichar('z')

  ndif = ichar('A') - ichar('a')

  tf = .false.
  strncmp3 = 0
  ip = 0
  do istart = 1, len1 - n + 1
     i2 = 0
     do i = istart, istart-1+n
        i2 = i2 + 1
        icharx = ichar(str2(i2:i2))
        if(icharAcap <= icharx .and. icharx <= icharZcap) then
           icharupper = icharx
           icharlower = icharx - ndif
        else if(ichara <= icharx .and. icharx <= icharz) then
           icharupper = icharx + ndif
           icharlower = icharx
        else
           icharupper = icharx; icharlower = icharx
        end if
!!$        c = char(ichar(str2(i2:i2)) + ndif)
!!$        if(str1(i:i).ne.str2(i2:i2).and.str1(i:i).ne.c) goto 1000
        if(str1(i:i).ne.char(icharupper).and.str1(i:i).ne.char(icharlower)) goto 1000
     enddo
     tf = .true.
     ip = istart
     strncmp3 = ip
1000 continue
     if(tf) return
  enddo
end function strncmp3

subroutine skip2next(str,len_str,charc,ic)
  implicit none
  character(len=*), intent(in) :: str
  character,     intent(in)  ::   charc
  integer,       intent(in)  ::   len_str
  integer,       intent(out) ::   ic

  logical ::          tf, flag
  character(len=1) :: c, c0
  integer ::          ndif, i, ipnt, ipnt2

  ndif = ichar('A') - ichar('a')
  c0   = charc
  if(ichar(c0) >= ichar('a') .and. ichar(c0) <= ichar('z')) c0 = char(ichar(c0) + ndif)

  flag = .false.

  do i = 1, len_str
     c = str(i:i)
     call isalph(c,tf)
     if(.not.flag.and.tf) then
        ipnt = i
        if(ichar(c) >= ichar('a') .and. ichar(c) <= ichar('z')) then
           c = char(ichar(c) + ndif)
        endif
        if(c == c0) goto 1001
     endif
     if(tf) then
        flag = .true.
     else
        flag = .false.
     endif
  enddo
  stop ' no matching character'

1001 continue
  do i = ipnt+1, len_str
     ipnt2 = i
     if(str(i:i) == '=') goto 1002
  enddo
  stop ' no = character'
  
1002 continue
  do i = ipnt2+1, len_str
     call isnumm(str(i:i),tf)
     if(tf) then
        ic = i
        return
     else
        call isalph(str(i:i),tf)
        if(tf) then
           ic = i
           return
        endif
     endif
  enddo
  stop ' no alphabet or number'
end subroutine skip2next

subroutine nameck(name,n)
  implicit none
  character(len=*), intent(inout) :: name
  integer, intent(in)          :: n

  integer i, icount

  icount = 0
  do  i = 1, n
     if(name(i:i).eq.' ') then
        icount = i
        goto 2
     endif
  enddo

2 continue
  if(icount.ne.0) then
     do  i = icount+1, n
        name(i:i) = ' '
     enddo
  endif
end subroutine nameck

subroutine ch4mix(str,len_str,waymix,istrbr,nbxmix,hownew &
     & ,cutoff_mix,decomp_into_charge_spin,work,nsize)
  use m_Const_Parameters, only : DP, SIMPLE, BROYD1, BROYD2, DFP, PULAY &
       &, ANEW, RENEW, SMALL, MEDIUM, LARGE
  implicit none
  character(len=*), intent(in)  :: str
  integer, intent(in)        :: len_str
  integer, intent(out)       :: waymix, istrbr, nbxmix, hownew
  integer, intent(out)       :: cutoff_mix
  logical, intent(out)       :: decomp_into_charge_spin
  real(DP), intent(out)      :: work(*)
  integer, intent(out)       :: nsize

  logical       :: tf
  integer       :: ic
  real(kind=DP) :: alpha

  call check_decomp

  call skip2alph(str,len_str,ic)
  if(ic <= 0) then
     call chnnm(str,len_str,5,work,nsize)
     if(nsize < 4) stop ' shortage of data for mixing ratios(2)'
     waymix = SIMPLE
     return
  end if

  call check_mix_tag_name(ic) ! -> waymix

  if(waymix /= SIMPLE) then
     call rd_istrbr   ! -> istrbr
     call rd_nbxmix   ! -> nbxmix
     call rd_hownew   ! -> hownew
     call rd_alpha    ! -> alpha
     work(1:5) = alpha
     nsize = 5
     call rd_cutoff   ! -> cutoff_mix
  end if

contains
  subroutine check_decomp
    logical :: tf

    call strncmp2(str,len_str,'nodecomp',8,tf)
    if(tf) then
       decomp_into_charge_spin = .false.
    else
       call strncmp2(str,len_str,'decomp',6,tf)
       if(tf) then
          decomp_into_charge_spin = .true.
       else
          decomp_into_charge_spin = .false.
       end if
    end if
  end subroutine check_decomp

  subroutine check_mix_tag_name(ic)
    integer, intent(in) :: ic
    logical :: tf
    call strncmp2(str(ic:len_str),6,'simple',6,tf)
    if(tf) then
       waymix = SIMPLE
       call chnnm2(str,len_str,5,work,nsize)
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),6,'broyd1',6,tf)
       if(tf) waymix = BROYD1
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'broyden1',8,tf)
       if(tf) waymix = BROYD1
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),6,'broyd2',6,tf)
       if(tf) waymix = BROYD2
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'broyden2',8,tf)
       if(tf) waymix = BROYD2
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),8,'dfp',3,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),7,'bluegel',7,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),2,'bl',2,tf)
       if(tf) waymix = DFP
    end if

    if(.not.tf) then
       call strncmp2(str(ic:len_str),5 ,'pulay',5,tf)
       if(tf) waymix = PULAY
    end if

    if(.not.tf)  stop ' ! no appropriate tag name'
  end subroutine check_mix_tag_name

  subroutine rd_istrbr
    integer :: ic
    call skip2next(str,len_str,'I',ic)
    read(str(ic:len_str),*) istrbr
    if(istrbr <= 0) then
       print *, ' istrbr is reset as to be 1, because istrbr(=',istrbr,') is invalid.'
       istrbr = 1
    endif
  end subroutine rd_istrbr

  subroutine rd_nbxmix
    integer :: ic
     call skip2next(str,len_str,'N',ic)
     read(str(ic:len_str),*) nbxmix
     if(nbxmix <= 0) then
        print *, ' nbxmix is reset as to be 5, because nbxmix(=',nbxmix,') is invalid.'
        nbxmix = 5
     endif
   end subroutine rd_nbxmix

   subroutine rd_hownew
     integer :: ic
     call skip2next(str,len_str,'H',ic)
     call strncmp2(str(ic:len_str),5 ,'renew',5,tf)
     if(tf) hownew = RENEW
     if(.not.tf) then
        call strncmp2(str(ic:len_str),4,'anew',4,tf)
        if(tf) then
           hownew = ANEW
        else
           print *,' hownew is set as to be RENEW, because hownew is not given properly '
           hownew = RENEW
        end if
     end if
   end subroutine rd_hownew

   subroutine rd_cutoff
     logical :: tf
     call strncmp2(str,len_str,'cutoff',6,tf)
     if(tf) call skip2next(str,len_str,'C',ic)
     call strncmp2(str(ic:len_str),5,'small',5,tf)
     if(tf) then
        cutoff_mix = SMALL
        return
     endif

     call strncmp2(str(ic:len_str),6,'medium',6,tf)
     if(tf) then
        cutoff_mix = MEDIUM
        return
     end if

     call strncmp2(str(ic:len_str),5,'large',5,tf)
     if(tf) then
        cutoff_mix = LARGE
        return
     end if
   end subroutine rd_cutoff

   subroutine rd_alpha
     integer :: ic
     call skip2next(str,len_str,'A',ic)
     read(str(ic:len_str),*) alpha
     if(alpha < 0.d0 .or. alpha > 1.0) then
        print *, ' alpha is set as to be 0.3,'&
        &       , ' because alpha(=',alpha,') is not given properly'
        alpha = 0.3d0
     end if
   end subroutine rd_alpha
end subroutine ch4mix

subroutine skip2alph(str,len_str,ic)
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in)       :: len_str
  integer, intent(out)      :: ic

  integer :: i
  logical :: tf
  ic = 0
  do i = 1, len_str
     ic = i
     call isalph(str(i:i),tf)
     if(str(i:i).eq.':') goto 999
     if(tf) return
  enddo
999 ic = 0
  return
end subroutine skip2alph

subroutine chnnm2(str,len_str,n,wka,incunt)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*), intent(in) :: str
  integer, intent(in)       :: len_str,n
  real(DP), intent(out),dimension(n) :: wka
  integer, intent(out)      :: incunt

  logical  ::         tf
  character(len=1) :: c
  logical  ::         is_chr
  real(kind=DP) ::    xnum1
  integer  ::         icount, i, ic2

  xnum1 = 0.d0

  wka = 0.d0

  incunt = 0
  icount = 0
  is_chr = .false.
1001 continue
  do i = icount+1, len_str
     icount = i
     c = str(i:i)
     if(c == ':') goto 1006
     call isnumm(c,tf)
     if(.not.is_chr.and.tf) then
        read(str(i:len_str),*) xnum1
        goto 1002
     endif
     if(c == '='.or.c == ' ') then
        is_chr = .false.
     else
        is_chr = .true.
     endif
  end do
  goto 1006
1002 continue
  incunt = incunt + 1
  wka(incunt) = xnum1

  if(incunt == n) goto 1006

  ic2 = icount + 1
  do i = icount+1, len_str
     if(str(i:i) == ' '.or.str(i:i) == ',') then
        ic2 = i
        goto 1004
     else if(str(i:i) == ':') then
        goto 1006
     endif
  end do
1004 continue
  icount = ic2
  is_chr = .false.
  goto 1001

1006 continue
end subroutine chnnm2

subroutine ch4prc(str,len_str,c_precon,amix,bmix,precon_charge_only &
     &,isterm)
  use m_Const_Parameters, only : DP
  implicit none
  character(len=*),intent(in) :: str
  integer,intent(in) ::          len_str
  logical,intent(out) ::         c_precon, precon_charge_only
  real(DP), intent(out) ::       amix, bmix
  logical,intent(out) ::         isterm

  logical  :: tf
  integer  :: i, ic, icc

  c_precon = .false.
  amix = -1.d0
  bmix = -1.d0
  precon_charge_only = .false.
  isterm = .false.

  call skip2alph(str,len_str,ic)
  if(ic <= 0) return

  isterm = .true.
  call strncmp2(str(ic:len_str),2,'cp',2,tf)
  if(tf) then
     c_precon = .true.
  else
     c_precon = .false.
  endif

  if(c_precon) then
     call skip2next(str,len_str,'A',ic)
     read(str(ic:len_str),*) amix
     if(amix > 1.d0) then
        print *,' amix is reset as to be 1.0, because amix (=',amix,') is too large.'
        amix = 1.d0
     endif

     call skip2next(str,len_str,'B',ic)
     read(str(ic:len_str),*) bmix

     do i = ic, len_str
        icc = i
        call isalph(str(i:i),tf)
        if(tf) goto 2000
        if(str(i:i).eq.':') return
     enddo

2000 continue
     ic = icc

     write(6,*) ' !! precon_charge_only = ', precon_charge_only
     if(str(ic:ic).eq.'p'.or.str(ic:ic).eq.'P') then
        call f_strncmp(str(ic:len_str),'precon_charge_only',17,tf)
        if(tf) precon_charge_only = .true.
     endif
  endif
end subroutine ch4prc

subroutine f_strncmp(str1,str2,n,tf)
  implicit none
  character(len=*), intent(in) :: str1, str2
  integer, intent(in) ::          n
  logical, intent(out) ::         tf

  character :: c
  integer   :: ndif, i
  ndif = ichar('A') - ichar('a')

  tf = .false.
  do i = 1, n
     c = char(ichar(str2(i:i)) + ndif)
     if(str1(i:i)/=str2(i:i).and.str1(i:i)/=c) goto 1000
  enddo
  tf = .true.
1000 continue
end subroutine f_strncmp

subroutine rewind_to_tag0(nfinp, len_tag, tag, eof_reach, tag_is_found&
     &, str, len_str)
!                           @(#)b_Words.f90 1.3 98/12/24 02:06:35
  implicit none
  integer, intent(in) ::       nfinp
  integer, intent(in) ::       len_tag
  character(len=*), intent(in) :: tag
  logical, intent(out) ::      eof_reach, tag_is_found
  integer, intent(in) ::       len_str
  character(len=*) ::          str

  tag_is_found = .false.
  rewind(nfinp)
  do while(.not.tag_is_found)
     read(nfinp,'(a132)',end=1001) str
!!$     call strncmp2(str,len_str,tag,len_tag,tag_is_found)
     call strncmp2b(str,len_str,tag,len_tag,tag_is_found)
  enddo
  return
1001 tag_is_found = .false.
  eof_reach = .true.
  return
end subroutine rewind_to_tag0

subroutine read_RHS_number(str,len_str,values,n)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)              :: len_str,n
  character(len=len_str), intent(out) :: str
  real(kind=DP),intent(out)        :: values(n)

  integer ic, incunt

  call skip2RHS(str,len_str,ic)
  call chnnm2(str(ic:len_str),len_str-ic+1,n,values,incunt)
  if(incunt < n) print *,' !D incunt(=',incunt,' < n(= ',n,')'
end subroutine read_RHS_number

subroutine read_LHS_number(str,len_str,values,n)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)              :: len_str,n
  character(len=len_str), intent(out) :: str
  real(kind=DP),intent(out)        :: values(n)

  integer   :: ic, incunt

  call skip2number(str,len_str,ic)
  call chnnm(str(ic:len_str),len_str-ic+1,n,values,incunt)
  if(incunt < n) print *, ' !D incunt(=',incunt,' < n(= ',n,')'
end subroutine read_LHS_number

subroutine skip2RHS(str,len_str,ic)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: len_str
  integer, intent(out)      :: ic
  character(len=*), intent(in) :: str

  logical     ::  tf
  character(len=1) :: charc, c
  data charc/'='/
  integer     :: i, ipnt, ipnt2

  do i = 1, len_str
     c = str(i:i)
     if(c == charc) then
        ipnt = i
        tf = .true.
        goto 1001
     endif
  end do
  stop ' no matching character'

1001 continue

  ipnt2 = ipnt
  do i = ipnt2+1, len_str
     call isnumm(str(i:i),tf)
     if(tf) then
        ic = i
        return
     else
        call isalph(str(i:i),tf)
        if(tf) then
           ic = i
           return
        endif
     endif
  end do
  stop ' no alphabet or number'
end subroutine skip2RHS

subroutine f_strcpy(strin,len_strin,strout,len_strout)
  implicit none
  integer, intent(in)      :: len_strin, len_strout
  character(len=len_strin),  intent(in)  :: strin
  character(len=len_strout), intent(out) :: strout

  integer  :: i, len_cp

  if(len_strout < len_strin) then
     len_cp = len_strout
  else
     len_cp = len_strin
  endif

  do i = len_cp + 1, len_strout
     strout(i:i) = ' '
  enddo

  do i = 1, len_cp
     strout(i:i) = strin(i:i)
  enddo

end subroutine f_strcpy

subroutine skip2number(str,len_str,ic)
  implicit none
  integer,         intent(in)  ::    len_str
  integer,         intent(out) ::    ic
  character(len=len_str), intent(in)  :: str

  integer :: i
  logical :: tf
  ic = 0
  do i = 1, len_str
     ic = i
     call isnumm(str(i:i),tf)
     if(str(i:i) == ':') goto 999
     if(tf) return
  enddo
999 ic = 0
end subroutine skip2number

module m_ES_Mag_Constraint
! $Id: m_ES_Mag_Constraint.f90 409 2014-10-27 09:24:52Z jkoga $

  use m_Parallelization,      only : ista_kngp, iend_kngp, ierr, npes, mype, &
       &                             mpi_comm_group
  use m_PlaneWaveBasisSet,    only : ngabc, kgp

  use m_PseudoPotential,    only : ilmt, nlmt, dl2p, ltp, mtp, taup, prodphi

  use m_Control_Parameters,    only : neg, ndim_spinor, ndim_magmom, noncol, kimg, &
       &                              proj_attribute, num_proj_elems, &
       &                              proj_group

  use m_Const_Parameters,  only : DP, CMPLDP, yes, PAI4, &
       &                          MAG_MOMENT_VALS_GLOBAL, MAG_MOMENT_DIREC_GLOBAL, &
       &                          MAG_MOMENT_VALS_LOCAL,  MAG_MOMENT_DIREC_LOCAL, &
       &                          MAG_MOMENT_VALS_OCCMAT, &
       &                          MAG_MOMENT_DIREC_HARDPART

  use m_Charge_Density,        only : chgq_l, chgqo_l, hsr, hsi
  use m_Ionic_System,         only : natm, ityp,  mag_direction0_atomtyp, &
       &                             magmom_local_now, mag_moment0_atomtyp, &
       &                             pos, iproj_group

  use m_CD_Mag_Moment,       only : rad_cov, RhoMag_on_atom

  use m_Crystal_Structure,  only : univol, rltv, altv, &
       &                           mag_constraint_type, &
       &                           mag_moment0_global, &
       &                           mag_direc0_global, &
       &                           mag_constraint_lambda

  use m_IterationNumbers,  only : iteration_electronic
  use m_Electronic_Structure,  only : vlhxc_l, vlhxcQ

  use m_Orbital_Population,    only : om, ommix

! === KT_add === 2014/08/09
  use m_Crystal_Structure,   only : Global_Quantz_Axis_Fixed
! ============== 2014/08/09

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  real(kind=DP) :: MagField_constrain_global(3)
  real(kind=DP), allocatable :: MagField_constrain_local(:,:,:)
  real(kind=DP), allocatable :: MagField_constrain_hardpart(:,:,:,:)

contains

  subroutine m_ES_add_MagConstraintPot_chgql
    if ( ndim_magmom == 1 ) return

    select case ( mag_constraint_type )
    case (MAG_MOMENT_VALS_GLOBAL)
       call case_constraint_moment_global
    case (MAG_MOMENT_DIREC_GLOBAL)
       call case_constraint_direc_global
    case (MAG_MOMENT_VALS_LOCAL)
       call case_constraint_moment_local
    case (MAG_MOMENT_DIREC_LOCAL)
       call case_constraint_direc_local
    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3), c1
      integer :: is, ia, it, lmt1

      if ( noncol ) then
         if ( mype == 0 ) then
            Do is=2, ndim_magmom
               MagMom(is-1) = chgq_l( 1,1,is ) *univol
            End do

            MagField_constrain_global(:) = mag_constraint_lambda &
                 &                         *( MagMom(:) -mag_moment0_global(:) )
            
            Do is=2, ndim_magmom
               vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
            End do
         endif

      else
         if ( mype == 0 ) then
            MagMom(1) = ( chgq_l( 1,1,1 ) -chgq_l( 1,1,2 ) )*univol
            
            MagField_constrain_global(1) = mag_constraint_lambda &
                 &                        *( MagMom(1) -mag_moment0_global(1) )

            vlhxc_l(1,1,1) = vlhxc_l(1,1,1) +MagField_constrain_global(1)
            vlhxc_l(1,1,2) = vlhxc_l(1,1,2) -MagField_constrain_global(1)
         endif

      endif

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global            ! only for noncol
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: is, ia, it, ixyz, lmt1

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( .not. noncol ) return

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l( 1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_global = 0.0d0
            return
         endif

         MagDirec = MagMom / cnorm

         Do ixyz=1, 3
            c1 = cnorm2 - MagMom(ixyz)**2
            c2 = cnorm**3
            MagField_constrain_global(ixyz) = &
                 &  mag_constraint_lambda *c1 /c2 &
                 & *( MagDirec(ixyz) - mag_direc0_global(ixyz) )
         End do

         Do is=2, ndim_magmom
            vlhxc_l(1,1,is) = vlhxc_l(1,1,is) + MagField_constrain_global(is-1)
         End do
      endif

    end subroutine case_constraint_direc_global

    subroutine case_constraint_moment_local
      real(kind=DP) :: MagMom(3), cfactor(3)
      real(kind=DP) :: rad1, fac1r, fac1i, fac2
      real(kind=DP) :: VecG(3), normG, normG3, gr, d1

      real(kind=DP), allocatable :: zfcos(:), zfsin(:)
      real(kind=DP), allocatable :: RhoMag_on_atom_mpi(:,:)

      integer :: i, j, ia, it, is, ixyz, ixyz_max, ist

      allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
      allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      if ( allocated( MagField_constrain_local ) ) then
         deallocate( MagField_constrain_local )
      endif

      allocate( MagField_constrain_local(ista_kngp:iend_kngp, kimg, ixyz_max ))
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         rad1 = rad_cov(ia)

         Do ixyz=1, ixyz_max
            if ( noncol ) then
               MagMom( ixyz ) = RhoMag_on_atom( ia, ixyz +1 )
            else
               MagMom( ixyz ) = RhoMag_on_atom( ia, 1 ) -RhoMag_on_atom( ia, 2 )
            endif
            
            cfactor( ixyz ) = mag_constraint_lambda /univol &
                 &               *( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )
               
            call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
                 &            zfcos, zfsin )

            if ( ista_kngp == 1 ) then
               ist = 2
            else
               ist = ista_kngp
            endif

            Do i=ist, iend_kngp
               VecG(1) = rltv(1,1)*ngabc(i,1) +rltv(1,2)*ngabc(i,2) +rltv(1,3)*ngabc(i,3)
               VecG(2) = rltv(2,1)*ngabc(i,1) +rltv(2,2)*ngabc(i,2) +rltv(2,3)*ngabc(i,3)
               VecG(3) = rltv(3,1)*ngabc(i,1) +rltv(3,2)*ngabc(i,2) +rltv(3,3)*ngabc(i,3)
            
               normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
               normG3 = normG**3
               
               fac1r = zfcos(i); fac1i = zfsin(i)
!
               gr = normG *rad1
               fac2 = -gr *cos(gr) + sin(gr)
               fac2 = fac2 *PAI4 /normG3
!
               MagField_constrain_local( i, 1, ixyz ) &
                    & = MagField_constrain_local( i, 1, ixyz ) &
                    &   +fac1r *fac2 *cfactor( ixyz )
               if ( kimg == 2 ) then
                  MagField_constrain_local( i, 2, ixyz ) &
                       & = MagField_constrain_local( i, 2, ixyz ) &
                       &  -fac1i *fac2 *cfactor( ixyz )
               endif
            End Do

            if ( mype == 0 ) then
               fac2 = PAI4 /3.0d0 *rad1**3

               MagField_constrain_local( 1, 1, ixyz ) &
                    & = MagField_constrain_local( 1, 1, ixyz ) &
                    &   +fac2 *cfactor( ixyz )
            end if
         End Do
      End Do
!
      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do is=2, ndim_magmom
               vlhxc_l(i,1,is) = vlhxc_l(i,1,is) +MagField_constrain_local(i,1,is-1)
               vlhxc_l(i,2,is) = vlhxc_l(i,2,is) +MagField_constrain_local(i,2,is-1)
            End do
         End Do
      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               vlhxc_l(i,j,1) = vlhxc_l(i,j,1) +MagField_constrain_local(i,j,1)
               vlhxc_l(i,j,2) = vlhxc_l(i,j,2) -MagField_constrain_local(i,j,1)
            End Do
         End Do
      endif

    end subroutine case_constraint_moment_local

    subroutine case_constraint_direc_local            ! only for noncol
      stop "Not supported"
    end subroutine case_constraint_direc_local

  end subroutine m_ES_add_MagConstraintPot_chgql

  subroutine m_ES_add_MagConstraintPot_hsr
    if ( ndim_magmom == 1 ) return

    select case ( mag_constraint_type )
    case (MAG_MOMENT_VALS_OCCMAT)
       call case_constraint_moment_occmat
    case (MAG_MOMENT_DIREC_HARDPART)
       call case_constraint_direc_hardpart
    end select

  contains

    subroutine case_constraint_moment_occmat
      integer :: ia, ig, it, i, ip, ilp
      integer :: ilmt1, ilmt2, l1, l2, m1, m2, t1, t2
      integer :: ixyz, ixyz_max, is

      real(kind=DP) :: MagMom(3), cfactor(3), c1

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      if ( allocated( MagField_constrain_hardpart ) ) then
         deallocate( MagField_constrain_hardpart )
      endif

      allocate( MagField_constrain_hardpart(nlmt,nlmt,natm,ixyz_max) )
      MagField_constrain_hardpart = 0.0d0
!
      do ia=1,natm
         it = ityp(ia)

         ig = iproj_group(ia)
         if(ig<1) cycle
            
         Do ixyz=1, ixyz_max
            if ( noncol ) then
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +ommix(m1,m1,i,ia,ixyz+1)
                  End Do
               End do
               MagMom(ixyz) = c1
            else
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +ommix(m1,m1,i,ia,1) -ommix(m1,m1,i,ia,2)
                  End Do
               End do
               MagMom(ixyz) = c1
            endif

            cfactor(ixyz) = mag_constraint_lambda &
                 &               *( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )
         End do

         Do ixyz=1, ixyz_max

            do i=1,num_proj_elems(ig)
               ip = proj_group(i,ig)
               it = proj_attribute(ip)%ityp
               ilp = proj_attribute(ip)%l+1
               
               do ilmt1 = 1, ilmt(it)
                  l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                  if ( l1 /= ilp ) cycle
                  
                  do ilmt2 = 1, ilmt(it)
                     l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)
                     if( l2 /= ilp ) cycle
                     
                     if ( m1 == m2 ) then
                        MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                             & = MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                             & + cfactor(ixyz) *prodphi(ip,t1,t2)
                     endif
                  end do
               end do
            end do
         End Do
      End do

      if ( noncol ) then
         Do is=2, ndim_magmom
            vlhxcQ(:,:,:,is) = vlhxcQ(:,:,:,is) &
                 &               +MagField_constrain_hardpart(:,:,:,is-1)
         End Do
      else
         vlhxcQ(:,:,:,1) = vlhxcQ(:,:,:,1) +MagField_constrain_hardpart(:,:,:,1)
         vlhxcQ(:,:,:,2) = vlhxcQ(:,:,:,2) -MagField_constrain_hardpart(:,:,:,1)
      end if

    end subroutine case_constraint_moment_occmat

    subroutine case_constraint_direc_hardpart        ! noncol only
      real(kind=DP) :: MagMom(3), MagDirec(3)
      real(kind=DP) :: c1, c2, cnorm, cnorm2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( .not. noncol ) return

      if ( .not. allocated( MagField_constrain_hardpart ) ) then
         allocate( MagField_constrain_hardpart(nlmt,nlmt,natm,3 ) );
      endif
!
      MagField_constrain_local = 0.0d0
!
      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom( ixyz ) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm < cnorm_lower_limit ) then
            MagField_constrain_hardpart(:,:,ia,:) = 0.0d0
            cycle
         endif

         MagDirec = MagMom / cnorm

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)

               Do ixyz=1, 3
                  c1 = cnorm2 - MagMom(ixyz)**2
                  c2 = cnorm**3
                  MagField_constrain_hardpart(lmt1,lmt2,ia,ixyz) = &
                       &  mag_constraint_lambda *c1 /c2 &
                       & *( MagDirec(ixyz) -mag_direction0_atomtyp(it,ixyz) ) &
                       & *dl2p(lmt1,lmt2,1,it)             ! approx
               End do
            End do
         End do

         Do lmt1=1, ilmt(it)
            Do lmt2=1, ilmt(it)
               Do is=2, ndim_magmom
                  vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                       &       + MagField_constrain_hardpart(lmt1,lmt2,ia,is-1)
               End do
            End do
         End Do

      end Do

    end subroutine case_constraint_direc_hardpart

  end subroutine m_ES_add_MagConstraintPot_hsr

  subroutine m_ES_calc_MagConstraint_Energy( ene_double_counting, ene_mag_constraint )
    real(kind=DP), intent(out) :: ene_double_counting
    real(kind=DP), intent(out) :: ene_mag_constraint

    ene_double_counting = 0.0d0;      ene_mag_constraint = 0.0d0

    select case ( mag_constraint_type )

    case (MAG_MOMENT_VALS_GLOBAL)
       call case_constraint_moment_global
    case (MAG_MOMENT_DIREC_GLOBAL)
       call case_constraint_direc_global
    case (MAG_MOMENT_VALS_LOCAL)
       call case_constraint_moment_local
    case (MAG_MOMENT_DIREC_LOCAL)
       call case_constraint_direc_local

    case (MAG_MOMENT_VALS_OCCMAT)
       call case_constraint_moment_occmat
    case (MAG_MOMENT_DIREC_HARDPART)
       call case_constraint_direc_hardpart

    end select

  contains

    subroutine case_constraint_moment_global
      real(kind=DP) :: MagMom(3), c1, c2
      real(kind=DP) :: MagMomOld(3)
      integer :: is, ixyz

      if ( mype == 0 ) then

         if ( noncol ) then
            Do is=2, ndim_magmom
               MagMom(is-1) = chgq_l(  1,1,is ) *univol
!               MagMomOld(is-1) = chgqo_l(  1,1,is ) *univol
            End do
            
            c1 = 0.0d0;  c2 = 0.0d0
            Do ixyz=1, 3
               c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
               c2 = c2 + ( MagMom(ixyz) -mag_moment0_global(ixyz) )**2
            End do
         else
            MagMom(1) = ( chgq_l( 1,1,1 ) -chgq_l( 1,1,2 ) )*univol
            
            c1 = MagField_constrain_global(1) *MagMom(1)
            c2 = ( MagMom(1) -mag_moment0_global(1) )**2
         endif

         ene_double_counting = c1
         ene_mag_constraint = c2 *mag_constraint_lambda / 2.0d0
      endif

      if (npes > 1) then
         call mpi_bcast( ene_double_counting, 1, mpi_double_precision, & 
              &          0, mpi_comm_group, ierr )
         call mpi_bcast( ene_mag_constraint,  1, mpi_double_precision, &
              &          0, mpi_comm_group, ierr )
      end if

    end subroutine case_constraint_moment_global

    subroutine case_constraint_direc_global
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: is, ixyz

      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      if ( mype == 0 ) then
         Do is=2, ndim_magmom
            MagMom(is-1) = chgq_l(  1,1,is ) *univol
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            c1 = 0.0d0;  c2 = 0.0d0
            Do ixyz=1, 3
               c1 = c1 + MagField_constrain_global(ixyz) *MagMom(ixyz)
               c2 = c2 + ( MagDirec(ixyz) -mag_direc0_global(ixyz) )**2
            End do

            ene_double_counting = c1
            ene_mag_constraint = c2 *mag_constraint_lambda /2.0d0
         endif
      endif

      if (npes > 1) then
         call mpi_bcast( ene_double_counting, 1, mpi_double_precision, & 
              &          0, mpi_comm_group, ierr )
         call mpi_bcast( ene_mag_constraint,  1, mpi_double_precision, &
              &          0, mpi_comm_group, ierr )
      end if

    end subroutine case_constraint_direc_global

    subroutine case_constraint_direc_local
      stop "kt: Not supported"
    end subroutine case_constraint_direc_local

    subroutine case_constraint_moment_local
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: i, j, ia, it, is, ixyz

      real(kind=DP) :: csum1, csum2

      csum1 = 0.0d0; csum2 = 0.0d0

      if ( noncol ) then
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               Do ixyz=1, 3
                  csum1 = csum1 + MagField_constrain_local(i,j,ixyz)*chgq_l(i,j,ixyz+1)
               End Do
            End Do
         End Do

         Do ia=1, natm
            it = ityp(ia)
            Do ixyz=1, 3
               MagMom(ixyz) = RhoMag_on_Atom( ia,ixyz+1 )
            End do
            csum2 = csum2 + ( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )**2
         End do

      else
         Do i=ista_kngp, iend_kngp
            Do j=1, kimg
               csum1 = csum1 + MagField_constrain_local(i,j,1) &
                    &         *( chgq_l(i,j,1) -chgq_l(i,j,2) )
            End Do
         End Do

         Do ia=1, natm
            it = ityp(ia)
            MagMom(1) = RhoMag_on_Atom( ia,1 ) -RhoMag_on_Atom( ia,2 )
            csum2 = ( MagMom(1) -mag_moment0_atomtyp(it,1) )**2
         End do
      endif

      if ( npes > 1 ) then
         call mpi_allreduce( csum1, c1, 1, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         csum1 = c1
      endif

      ene_double_counting = csum1 *univol
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_moment_local

    subroutine case_constraint_moment_occmat
      integer :: ia, it, ilmt1, ilmt2, m1
      integer :: i, ig, ip, ixyz, ixyz_max
      real(kind=DP) :: MagMom(3), c1, csum1, csum2

      if ( noncol ) then
         ixyz_max = 3
      else
         ixyz_max = 1
      endif

      csum1 = 0.0d0; csum2 = 0.0d0

      if ( noncol ) then
         Do ia=1, natm
            it = ityp(ia)
            Do ixyz=1, ixyz_max
               Do ilmt1=1, ilmt(it)
                  Do ilmt2=1, ilmt(it)
                     csum1 = csum1 +MagField_constrain_hardpart(ilmt1,ilmt2,ia,ixyz) &
                          &          *hsr(ia,ilmt1,ilmt2,ixyz+1) 
                  End do
               End do
            End do
         End Do
      else
         Do ia=1, natm
            it = ityp(ia)
            Do ilmt1=1, ilmt(it)
               Do ilmt2=1, ilmt(it)
                  csum1 = csum1 +MagField_constrain_hardpart(ilmt1,ilmt2,ia,1) &
                       &          *( hsr(ia,ilmt1,ilmt2,1) -hsr(ia,ilmt1,ilmt2,2) ) 
               End Do
            End do
         End do
      endif

      Do ia=1, natm
         it = ityp(ia)
            
         ig = iproj_group(ia)
         if(ig<1) cycle
            
         if ( noncol ) then
            Do ixyz=1, ixyz_max
               c1 = 0.0d0
               do i=1,num_proj_elems(ig)
                  ip = proj_group(i,ig)
                  Do m1=1, 2*proj_attribute(ip)%l +1
                     c1 = c1 +om(m1,m1,i,ia,ixyz+1)
                  End Do
               End do
               MagMom(ixyz) = c1
            End do
         else
            c1 = 0.0d0
            do i=1,num_proj_elems(ig)
               ip = proj_group(i,ig)
               Do m1=1, 2*proj_attribute(ip)%l +1
                  c1 = c1 +om(m1,m1,i,ia,1) -om(m1,m1,i,ia,2)
               End Do
            End do
            MagMom(1) = c1
         endif

         Do ixyz=1, ixyz_max
            csum2 = csum2 +( MagMom(ixyz) -mag_moment0_atomtyp(it,ixyz) )**2
         End do
      End Do

      ene_double_counting = csum1
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0
      
    end subroutine case_constraint_moment_occmat

    subroutine case_constraint_direc_hardpart
      real(kind=DP) :: MagMom(3), MagDirec(3), c1, c2
      integer :: ia, it, lmt1, lmt2, is, ixyz

      real(kind=DP) :: csum1, csum2
      real(kind=DP) :: cnorm, cnorm2
      real(kind=DP), parameter :: cnorm_lower_limit = 1.0D-10

      csum1 = 0.0d0; csum2 = 0.0d0

      Do ia=1, natm
         it = ityp(ia)
         Do ixyz=1, 3
            MagMom(ixyz) = magmom_local_now( ia,ixyz )
         End do

         cnorm2 = 0.0d0
         Do ixyz=1, 3
            cnorm2 = cnorm2 + MagMom(ixyz)**2
         End do
         cnorm = sqrt( cnorm2 )

         if ( cnorm > cnorm_lower_limit ) then
            MagDirec = MagMom / cnorm

            Do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)

                  Do ixyz=1, 3
                     csum1 = csum1 + MagField_constrain_hardpart(lmt1,lmt2,ia,ixyz) &
                          &          *hsr(ia,lmt1,lmt2,ixyz +1)
                  End do
               End do
            End do

            Do ixyz=1, 3
               csum2 = csum2 + ( MagDirec(ixyz)-mag_direction0_atomtyp(it,ixyz) )**2
            End do
         endif

      End do

      ene_double_counting = csum1
      ene_mag_constraint = csum2 *mag_constraint_lambda/ 2.0d0

    end subroutine case_constraint_direc_hardpart

  end subroutine m_ES_calc_MagConstraint_Energy

! === KT_add === 2014/08/09
  subroutine m_ES_proj_magmom_G_quantz_axis
    integer :: i, j, k, is, ia
    real(kind=DP) :: ctmp1, ctmp2

! soft part
    Do k=1, kimg
       Do i=ista_kngp, iend_kngp
          ctmp1 = 0.0d0
          Do is=1, 3
             ctmp1 = ctmp1 +chgq_l(i,k,is+1) *Global_Quantz_Axis_Fixed(is)
          End do
          Do is=1, 3
             chgq_l(i,k,is+1) = ctmp1 *Global_Quantz_Axis_Fixed(is)
          End do
       End do
    End do
!
! hard part
    Do ia=1, natm
       Do i=1, nlmt
          Do j=1, nlmt
             ctmp1 = 0.0d0
             ctmp2 = 0.0d0
             Do is=1, 3
                ctmp1 = ctmp1 +hsr(ia,i,j,is+1) *Global_Quantz_Axis_Fixed(is)
                ctmp2 = ctmp2 +hsi(ia,i,j,is+1) *Global_Quantz_Axis_Fixed(is)
             End do
             Do is=1, 3
                hsr(ia,i,j,is+1) = ctmp1 *Global_Quantz_Axis_Fixed(is)
                hsi(ia,i,j,is+1) = ctmp2 *Global_Quantz_Axis_Fixed(is)
             End do
          End do
       End do
    End Do

  end subroutine m_ES_proj_magmom_G_quantz_axis
! ============== 2014/08/09

! === KT_add === 2014/09/26
  subroutine m_ES_set_magmom_zero
    integer :: is

    Do is=2, ndim_magmom
       chgq_l(:,:,is) = 0.0d0
       hsr(:,:,:,is) = 0.0d0;    hsi(:,:,:,is) = 0.0d0
    End do
  end subroutine m_ES_set_magmom_zero
! ============== 2014/09/26

end module m_ES_Mag_Constraint

      SUBROUTINE DSPEV( JOBZ, UPLO, N, AP, W, Z, LDZ, WORK, INFO )
*
*  -- LAPACK driver routine (version 3.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2006
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDZ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), W( * ), WORK( * ), Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DSPEV computes all the eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A in packed storage.
*
*  Arguments
*  =========
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangle of A is stored;
*          = 'L':  Lower triangle of A is stored.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangle of the symmetric matrix
*          A, packed columnwise in a linear array.  The j-th column of A
*          is stored in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*          On exit, AP is overwritten by values generated during the
*          reduction to tridiagonal form.  If UPLO = 'U', the diagonal
*          and first superdiagonal of the tridiagonal matrix T overwrite
*          the corresponding elements of A, and if UPLO = 'L', the
*          diagonal and first subdiagonal of T overwrite the
*          corresponding elements of A.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
*          eigenvectors of the matrix A, with the i-th column of Z
*          holding the eigenvector associated with W(i).
*          If JOBZ = 'N', then Z is not referenced.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTZ
      INTEGER            IINFO, IMAX, INDE, INDTAU, INDWRK, ISCALE
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANSP
      EXTERNAL           LSAME, DLAMCH, DLANSP
*     ..
*     .. External Subroutines ..
      EXTERNAL           DOPGTR, DSCAL, DSPTRD, DSTEQR, DSTERF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LSAME( UPLO, 'U' ) .OR. LSAME( UPLO, 'L' ) ) )
     $          THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.N ) ) THEN
         INFO = -7
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSPEV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = AP( 1 )
         IF( WANTZ )
     $      Z( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = DLANSP( 'M', UPLO, N, AP, WORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( ( N*( N+1 ) ) / 2, SIGMA, AP, 1 )
      END IF
*
*     Call DSPTRD to reduce symmetric packed matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = INDE + N
      CALL DSPTRD( UPLO, N, AP, W, WORK( INDE ), WORK( INDTAU ), IINFO )
*
*     For eigenvalues only, call DSTERF.  For eigenvectors, first call
*     DOPGTR to generate the orthogonal matrix, then call DSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         INDWRK = INDTAU + N
         CALL DOPGTR( UPLO, N, AP, WORK( INDTAU ), Z, LDZ,
     $                WORK( INDWRK ), IINFO )
         CALL DSTEQR( JOBZ, N, W, WORK( INDE ), Z, LDZ, WORK( INDTAU ),
     $                INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
      RETURN
*
*     End of DSPEV
*
      END

#if 0

#define ORIGINAL

!===============================================================================
  subroutine dump_zaj(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(kg1,np_e,ista_k:iend_k,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_zaj'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.dat1'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kg1,neg,ista_k:iend_k,kimg) )
   allocate( t_wk2(kg1,neg,ista_k:iend_k,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do k = ista_k, iend_k
   do j = 1,np_e
   do i = 1,iba(k)
     js = nis_e(myrank_e) + j-1
     t_wk2(i,js,k,l) = zinn(i,j,k,l)
   enddo
   enddo
   enddo
   enddo

   nn = kg1*neg*(iend_k-ista_k+1)*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_comm_world,err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_zaj'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 4
         write(2100) kg1
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) kimg
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_zaj

!===============================================================================
  subroutine dump_eko(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_eko'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k:iend_k) )
   allocate( t_wk2(neg,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k, iend_k
   do i = 1,np_e
     t_wk2(ista_e+i-1,j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_eko

!===============================================================================
  subroutine dump_occup(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_occup'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k:iend_k) )
   allocate( t_wk2(neg,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k, iend_k
   do i = 1,np_e
     t_wk2(ista_e+i-1,j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_occup

!===============================================================================
  subroutine dump_neordr(neordr)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: neordr(neg,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_neordr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI


   if (myrank_e .eq. 0) then
      write(*,*)'called dump_neordr'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) neordr
         close(2100)
      endif
   endif
  end subroutine dump_neordr

!===============================================================================
  subroutine dump_nrvf_ordr(nrvf_ordr)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: nrvf_ordr(neg,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_nrvf_ordr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI


   if (myrank_e .eq. 0) then
      write(*,*)'called dump_nrvf_ordr'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k-ista_k+1)
         write(2100) nrvf_ordr
         close(2100)
      endif
   endif
  end subroutine dump_nrvf_ordr


!===============================================================================
  subroutine dump_chgq(chgq_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_chgq'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,kimg,nspin) )
   allocate( t_wk2(kgp,kimg,nspin) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = 1, nspin
   do j = 1, kimg
   do i = ista_kngp, iend_kngp
     t_wk2(i,j,k) = chgq_l(i,j,k)
   enddo
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*kimg*nspin,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_chgq'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kgp
         write(2100) kimg
         write(2100) nspin
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_chgq

!===============================================================================
  subroutine dump_vxc(vxc_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_vxc'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,kimg,nspin) )
   allocate( t_wk2(kgp,kimg,nspin) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = 1, nspin
   do j = 1, kimg
   do i = ista_kngp, iend_kngp
     t_wk2(i,j,k) = vxc_l(i,j,k)
   enddo
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*kimg*nspin,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_vxc'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kgp
         write(2100) kimg
         write(2100) nspin
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_vxc

!===============================================================================
  subroutine dump_vlhxcQ(vlhxcQ)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e

  integer :: ierr,err

  real(kind=8),intent(in) :: vlhxcQ(nlmt,nlmt,natm,nspin)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=11) :: psuffix = 'dump_vlhxcQ'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_vlhxcQ'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 4
         write(2100) nlmt
         write(2100) nlmt
         write(2100) natm
         write(2100) nspin
         write(2100) vlhxcQ
         close(2100)
      endif
   endif
  end subroutine dump_vlhxcQ

!===============================================================================
  subroutine dump_snl(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,mype
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup
  use m_Parallelization,    only : ista_snl, iend_snl
  use m_PseudoPotential,    only : nlmtt

  integer :: ierr,err
  real(kind=8) :: zinn(kg1,nlmtt,ista_snl:iend_snl)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, ik, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname



#if 1
!   if (myrank_e .eq. 0) then
   if (mype .eq. 0) then
      write(*,*)'called dump snl'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
!         fname='dump_snl'//'.'//C_NUM//c_img//'.dat'
         fname='dump_snl'//'_'//C_NUM//'.data'
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) kg1
         write(2100) nlmtt
         write(2100) (iend_snl-ista_snl+1)
         write(2100) zinn
         close(2100)
      endif
   endif
#endif
  end subroutine dump_snl

!===============================================================================
  subroutine dump_qitg(qitg_l,n)

  use m_PlaneWaveBasisSet,  only : kg1, iba, kgp
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e, ista_kngp, iend_kngp
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: qitg_l(ista_kngp:iend_kngp,n)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_qitg'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.dat3'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(kgp,n) )
   allocate( t_wk2(kgp,n) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = 1, n
   do i = ista_kngp, iend_kngp
     t_wk2(i,j) = qitg_l(i,j)
   enddo
   enddo

   call mpi_allreduce(t_wk2,t_wk1,kgp*n,mpi_real8,mpi_sum, mpi_k_world(myrank_k),err)

   if (myrank_e .eq. 0) then
      write(*,*)'called dump_qitg'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) kgp
         write(2100) n
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_qitg

!===============================================================================
  subroutine dump_amat(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  real(kind=8),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_amat'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_amat

  subroutine dump_zajmat3D(zinn)

  use m_PlaneWaveBasisSet,  only : kg1, iba,iba2,iba,nmatsz,nmatsz2
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e_3D,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,mype,mpi_kg_world,neg_g
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(nmatsz,np_e_3D,kimg)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_zajm'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.dat1'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(nmatsz,neg,kimg) )
   allocate( t_wk2(nmatsz,neg,kimg) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do l = 1, kimg
   do j = 1,np_e_3D
   do i = 1,nmatsz
     js = neg_g(j)
     t_wk2(i,js,l) = zinn(i,j,l)
   enddo
   enddo
   enddo

   nn = nmatsz*neg*kimg
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_kg_world,err)

   if (mype .eq. 0) then
      write(*,*)'called dump_zaj'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) nmatsz
         write(2100) neg
         write(2100) kimg
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_zajmat3D

  subroutine dump_eko3D(eko_l)

  use m_PlaneWaveBasisSet,  only : kg1, iba
  use m_Control_Parameters, only : nspin, kimg, neg, meg
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e_3D,mpi_k_world,myrank_k,map_k,ista_k_3D,iend_k_3D &
       &                         , nis_e, nie_e,mype,mpi_kg_world,neg_g
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: eko_l(np_e_3D,ista_k_3D:iend_k_3D)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_eko3'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,ista_k_3D:iend_k_3D) )
   allocate( t_wk2(neg,ista_k_3D:iend_k_3D) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do j = ista_k_3D, iend_k_3D
   do i = 1,np_e_3D
     t_wk2(neg_g(i),j) = eko_l(i,j)
   enddo
   enddo

   nn = neg*(iend_k_3D-ista_k_3D+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_kg_world,err)

   if (mype .eq. 0) then
      write(*,*)'called dump_eko'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) neg
         write(2100) (iend_k_3D-ista_k_3D+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_eko3D


  subroutine dump_dbg(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  real(kind=8),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_dbg'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_dbg

  subroutine dump_dbg_int(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype

  integer :: ierr,err

  integer,intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_int'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_dbg_int

  subroutine dump_amat_c(amat,ix,iy)

  use m_PseudoPotential,    only : nlmt
  use m_Ionic_System,       only : natm
  use m_Control_Parameters, only : nspin, kimg
  use m_IterationNumbers,   only : iteration
  use m_Parallelization,    only : myrank_e,mype
  use m_Const_Parameters,    only : CMPLDP

  integer :: ierr,err

  complex(kind=CMPLDP),intent(in) :: amat(ix,iy)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num, c_iter
  character(len=80) :: fname
  character(len=9) :: psuffix = 'dump_amat'

  character(len=5)  :: suffix = '.data'

   if (mype .eq. 0) then
      write(*,*)'called dump_amat'
      do i = 0,999
         write(c_num,'(i3.3)') i
         write(c_iter,'(i3.3)') iteration
         fname=psuffix//'_'//c_iter//'_'//C_NUM//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 2
         write(2100) ix
         write(2100) iy
         write(2100) amat
         close(2100)
      endif
   endif
  end subroutine dump_amat_c

!===============================================================================

!===============================================================================
#ifndef ORIGINAL
  subroutine dump_many(string)
  use m_Electronic_Structure,only : zaj_l_3D,zaj_ball &
 &                                , eko_l_3D,vnlph_l_3D,nrvf_ordr,neordr &
 &                                , fsr_l_3D,fsi_l_3D ,fsr_l_2d,fsi_l_2d,fsr_l,fsi_l  &
 &                                , vlhxc_l, vlhxc_l_3D, occup_l_3D
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_Parallelization,     only : np_e_3D, ista_k_3D, iend_k_3D, ista_snl, iend_snl, np_g1k_3D &
 &                                , ista_kngp_3D, iend_kngp_3D
  use m_Control_Parameters,  only : neg
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_ES_WF_by_SDorCG,     only : zaj_old, zaj_old_3D

  character(len=32),intent(in) :: string
  integer :: i, j, k, l, m, n, is, js, nn, ifrom, IJK=40
#if 0
  write(1002,'("***** ",32a)') string

  write(1002,'("zaj_l_3D(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(1,i,1,1),i=1,np_e_3D)
  write(1002,'("zaj_l_3D(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(2,i,1,1),i=1,np_e_3D)

  if (allocated(zaj_old_3D)) then
  write(1002,'("zaj_old_3D(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(1,i,1,1),i=1,np_e_3D)
  write(1002,'("zaj_old_3D(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(2,i,1,1),i=1,np_e_3D)
  endif

  write(1002,'("zaj_ball(1,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(1,i,1,1),i=1,min(neg,IJK))
  write(1002,'("zaj_ball(2,:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(2,i,1,1),i=1,min(neg,IJK))

  write(1002,'("fsr_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,1,1),i=1,min(np_e_3D,IJK))
  write(1002,'("fsr_l_3D(:,2,1)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,2,1),i=1,min(np_e_3D,IJK))

  write(1002,'("eko_l_3D(:,1)")')
  write(1002,'(10(1x,f9.6))')  (eko_l_3D(i,ista_k_3D),i=1,min(np_e_3D,IJK))

  write(1002,'("occup_l_3D(:,1)")')
  write(1002,'(10(1x,f9.6))')  (occup_l_3D(i,ista_k_3D),i=1,min(np_e_3D,IJK))

  write(1002,'("vnlph_l_3D(1,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(1,i,1),i=1,min(np_e_3D,IJK))
  write(1002,'("vnlph_l_3D(2,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(2,i,1),i=1,min(np_e_3D,IJK))

! write(1002,'("snl_l_3D(:,1,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,1,ista_snl),i=1,min(np_g1k_3D(1),IJK))
! write(1002,'("snl_l_3D(:,2,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,2,ista_snl),i=1,min(np_g1k_3D(1),IJK))
! write(1002,'("snl_l_3D(:,3,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,3,ista_snl),i=1,min(np_g1k_3D(1),IJK))

  write(1002,'("vlhxc_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (vlhxc_l_3D(i,1,1),i=ista_kngp_3D,min(ista_kngp_3D+IJK,iend_kngp_3D))
#endif
  end subroutine dump_many

!===============================================================================
  subroutine dump_many_ik(ik,string)
  use m_Electronic_Structure,only : zaj_l_3D,zaj_ball &
 &                                , eko_l_3D,vnlph_l_3D,nrvf_ordr,neordr &
 &                                , fsr_l_3D,fsi_l_3D ,fsr_l_2d,fsi_l_2d,fsr_l,fsi_l  &
 &                                , vlhxc_l, vlhxc_l_3D, occup_l_3D
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_Parallelization,     only : np_e_3D, ista_k_3D, iend_k_3D, ista_snl, iend_snl, np_g1k_3D &
 &                                , ista_kngp_3D, iend_kngp_3D
  use m_Control_Parameters,  only : neg
  use m_NonLocal_Potential,  only : snl, snl_l_3D
  use m_ES_WF_by_SDorCG,     only : zaj_old, zaj_old_3D

  character(len=32),intent(in) :: string
  integer          ,intent(in) :: ik
  integer :: i, j, k, l, m, n, is, js, nn, ifrom, IJK=40
#if 0
  write(1002,'("***** ",32a)') string

  write(1002,'("IK:",i4)') ik
  write(1002,'("zaj_l_3D(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(1,i,ik,1),i=1,np_e_3D)
  write(1002,'("zaj_l_3D(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_l_3D(2,i,ik,1),i=1,np_e_3D)

  if (allocated(zaj_old_3D)) then
  write(1002,'("zaj_old_3D(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(1,i,ik,1),i=1,np_e_3D)
  write(1002,'("zaj_old_3D(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_old_3D(2,i,ik,1),i=1,np_e_3D)
  endif

  write(1002,'("zaj_ball(1,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(1,i,ik,1),i=1,min(neg,IJK))
  write(1002,'("zaj_ball(2,:,ik,1)")')
  write(1002,'(10(1x,f9.6))')  (zaj_ball(2,i,ik,1),i=1,min(neg,IJK))

  write(1002,'("fsr_l_3D(:,1,ik)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,1,ik),i=1,min(np_e_3D,IJK))
  write(1002,'("fsr_l_3D(:,2,ik)")')
  write(1002,'(10(1x,f9.6))')  (fsr_l_3D(i,2,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("eko_l_3D(:,ik)")')
  write(1002,'(10(1x,f9.6))')  (eko_l_3D(i,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("occup_l_3D(:,ik)")')
  write(1002,'(10(1x,f9.6))')  (occup_l_3D(i,ik),i=1,min(np_e_3D,IJK))

  write(1002,'("vnlph_l_3D(1,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(1,i,1),i=1,min(np_e_3D,IJK))
  write(1002,'("vnlph_l_3D(2,:,1)")')
  write(1002,'(10(1x,f9.6))')  (vnlph_l_3D(2,i,1),i=1,min(np_e_3D,IJK))

! write(1002,'("snl_l_3D(:,1,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,1,ik),i=1,min(np_g1k_3D(ik),IJK))
! write(1002,'("snl_l_3D(:,2,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,2,ik),i=1,min(np_g1k_3D(ik),IJK))
! write(1002,'("snl_l_3D(:,3,1)")')
! write(1002,'(10(1x,f9.6))')  (snl_l_3D(i,3,ik),i=1,min(np_g1k_3D(ik),IJK))

  write(1002,'("vlhxc_l_3D(:,1,1)")')
  write(1002,'(10(1x,f9.6))')  (vlhxc_l_3D(i,1,1),i=ista_kngp_3D,min(ista_kngp_3D+IJK,iend_kngp_3D))
#endif
  end subroutine dump_many_ik

#endif


#endif  ! if0
!===============================================================================
  subroutine dump_fsr(zinn)

  use m_Control_Parameters, only : neg
  use m_PseudoPotential,    only : nlmta
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , nis_e, nie_e,ista_fs,iend_fs,np_fs
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, iteration, nkgroup

  integer :: ierr,err

  real(kind=8),intent(in) :: zinn(np_e,np_fs,ista_k:iend_k)
  integer :: NB, nbs, lb
  integer :: i, j, k, l, m, n, is, js, nn, ifrom
  real(kind=8), allocatable, dimension(:,:,:) :: t_wk1, t_wk2
  character(len=4) :: sort
  logical :: existance
  character(len=3) :: c_num
  character(len=2) :: c_img
  character(len=80) :: fname
  character(len=8) :: psuffix = 'dump_fsr'
#ifdef ORIGINAL
  character(len=5)  :: suffix = '.data'
#else
  character(len=5)  :: suffix = '.data'
#endif

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

   allocate( t_wk1(neg,nlmta,ista_k:iend_k) )
   allocate( t_wk2(neg,nlmta,ista_k:iend_k) )

   t_wk1   = 0.0d0
   t_wk2   = 0.0d0

   do k = ista_k, iend_k
   do j = 1,np_fs
   do i = 1,np_e
     js = ista_fs + j - 1
     is = ista_e  + i - 1
     t_wk2(is,js,k) = zinn(i,j,k)
   enddo
   enddo
   enddo

   nn = neg*nlmta*(iend_k-ista_k+1)
   call mpi_allreduce(t_wk2,t_wk1,nn,mpi_real8,mpi_sum, mpi_comm_world,err)

!   if (myrank_e .eq. 0) then
   if (mype .eq. 0) then
      write(*,*)'called dump_fsr'
      c_img='_1'
      if (kimg == 2) c_img='_2'
      do i = 0,999
         write(c_num,'(i3.3)') i
         fname=psuffix//'_'//C_NUM//c_img//suffix
         inquire(file=trim(fname), exist=existance)
         if(existance) cycle
         if(.not.existance) exit
      enddo
      if (.not.existance) then
         open(unit=2100,file=fname,form='UNFORMATTED',status='NEW')
         write(2100) 3
         write(2100) neg
         write(2100) nlmta
         write(2100) (iend_k-ista_k+1)
         write(2100) t_wk1
         close(2100)
      endif
   endif
   deallocate( t_wk1, t_wk2)
  end subroutine dump_fsr

!===============================================================================

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 409 $)
!
!  MODULE: m_Phonon
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Phonon
! $Id: m_Phonon.F90 409 2014-10-27 09:24:52Z jkoga $
use m_Const_parameters,   only : DP, ON, OFF, NOCONV, FMAXVALLEN, PAI, PAI2, PAI4 &
                         &     , PHONON_GAMMA, PHONON_BAND, PHONON_DOS &
                         &     , LOWER, CARTS, UNIT_PIEZO_CONST &
                         &     , CRDTYP, FILE, FERMI_DIRAC
use m_Control_Parameters, only : sw_phonon, sw_calc_force, sw_calc_force_all &
                         &     , sw_vibrational_modes, sw_lo_to_splitting &
                         &     , sw_lattice_dielectric_tensor &
                         &     , sw_dielectric_function &
                         &     , sw_correct_force_constants &
                         &     , sw_polynomial_fit, norder &
                         &     , sw_int_strain_piezo_tensor, sw_phonon_oneshot &
                         &     , phonon_method, num_phonon_calc_mode &
                         &     , ipriphonon, printable, way_of_smearing, width, width_tetra
use m_Crystal_Structure,  only : altv,rltv,altv_super,rltv_super,nlpnt,lpnt,nbztyp_spg
use m_Ionic_System,       only : num_force_data, phonon_atom &
                              &, phonon_displacement &
                              &,displaced_atom, displacement &
                              &,input_coordinate_system,u &
                              &,natm,ionic_mass,speciesname,ityp,ntyp &
                              &,istart_phonon,iend_phonon &
                              &,natm_prim,natm_super &
                              &,pos,cps
use m_BP_Properties,      only : zeff
use m_Files,              only : nfout,nfkpoint,nfmatbp,m_Files_open_kpoint_files
use m_Parallelization,    only : mype,npes,ierr, mpi_comm_group

! === KT_add === 13.1R
use m_Control_Parameters,  only : sw_phonon_with_epsilon
use m_Raman,               only : m_Raman_read_nfinp, m_Raman_initialize, &
     &                            m_Raman_print_param, m_Raman_calc_susceptibility, &
     &                            dielectric_read_from_file => dielectric
! ============== 13.1R

implicit none
include 'mpif.h'

real(kind=DP),allocatable,dimension(:,:,:) :: force_data ! dim(natm_super,3,num_force_data)
real(kind=DP),allocatable,dimension(:,:,:) :: forces ! dim(natm_super*3,natm_prim*3,norder*2)
real(kind=DP),allocatable,dimension(:) :: force0 ! dim(natm_super*3)
real(kind=DP) :: dielectric(3,3) = 0.d0
real(kind=DP) :: kvec_dir(3) = 0.d0
character(len=3), allocatable, dimension(:) :: point_group ! dim(nqvec)
character(len=3) :: pg_gamma = ''
integer :: nlat(3) ! lattice size
real(kind=DP),allocatable,dimension(:,:) :: qvec ! dim(nqvec,3)
real(kind=DP),allocatable,dimension(:,:) :: qvin ! dim(nqvec,3)
real(kind=DP),allocatable,dimension(:)   :: wght ! dim(nqvec)
real(kind=DP),allocatable,dimension(:,:) :: qdir ! dim(nqvec,3)
integer :: nsp = 1
real(kind=DP),allocatable,dimension(:,:) :: spcpnt ! dim(nsp,3)
character(len=3), allocatable, dimension(:)  :: pg_spcpnt ! dim(nsp)
integer :: nsl = 1
integer,allocatable,dimension(:,:) :: symln  ! dim(nsl,2)
integer,allocatable,dimension(:) :: ndiv     ! dim(nsl)
character(len=3), allocatable, dimension(:)  :: pg_symln ! dim(nsl)
logical, allocatable, dimension(:,:) :: fksym ! dim(48,nqvec)
real(kind=DP) :: rho_loto = 1.4d0
! strain force coupling const.
real(kind=DP),allocatable         :: strfrc(:,:,:)   !d(3,natm,6)
real(kind=DP) :: piezoelectric(3,6) = 0.d0

! energy range for dielectric function
real(kind=DP), private :: max_energy = 0.01d0
real(kind=DP), private :: min_energy = 0.d0
integer, private :: num_division = 100
real(kind=DP), private :: damping_factor = 1.d-2

! Phonon DOS
integer, private :: phonon_dos_mesh(3)
integer                           :: np0,np1,np2
integer,allocatable, dimension(:) :: ip20,ip10,ip02,ip12
integer,allocatable, dimension(:) :: ip01,ip21,iu21,iv21,iwt,ip2cub
integer, dimension(3)             :: nxyz_tetra
real(kind=DP)                     :: DeltaE_dos = 1.d-5


! calculated
integer :: nmodes ! = 3*natm
integer :: nqvec = 1
integer :: qvec_from_file = ON
real(kind=DP), allocatable,dimension(:,:,:) :: dynmat  ! dim(3*natm,3*natm,nlpnt)
complex(kind=DP), allocatable,dimension(:,:,:) :: dynmatq ! dim(3*natm,3*natm,nqvec)
real(kind=DP), allocatable,dimension(:,:)   :: omega   ! dim(3*natm,nqvec)
complex(kind=DP), allocatable,dimension(:,:,:) :: modes   ! dim(3*natm,3*natm,nqvec)
character(len=3), allocatable,dimension(:,:) :: mode_irr_rep ! dim(3*natm,nqvec)
character(len=4), allocatable,dimension(:,:) :: mode_active  ! dim(3*natm,nqvec)
real(kind=DP), allocatable,dimension(:)   :: msqinv     ! dim(3*natm)
real(kind=DP), allocatable,dimension(:,:) :: zeff_mode  ! dim(3,nmodes)
real(kind=DP) :: static_dielectric(3,3) ! static dielectric tensor 
real(kind=DP) :: lattice_dielectric(3,3) ! lattice dielectric tensor 
real(kind=DP), allocatable,dimension(:,:) :: strphcpl  ! dim(6,nmodes)

! Ewald sum
real(kind=DP) :: deteps ! Det(epsilon)
real(kind=DP), dimension(3,3) :: epsinv ! (epsilon)^-1

! Tags
character(len("phonon")),private,parameter :: tag_phonon = "phonon"
character(len("sw_phonon")),private,parameter :: tag_sw_phonon = "sw_phonon"
character(len("sw_calc_force")),private,parameter :: tag_sw_calc_force = "sw_calc_force"
character(len("sw_calc_force_all")),private,parameter :: tag_sw_calc_force_all = "sw_calc_force_all"
character(len("sw_polynomial_fit")),private,parameter :: tag_sw_polynomial_fit = "sw_polynomial_fit"
character(len("sw_phonon_oneshot")),private,parameter :: tag_sw_phonon_oneshot = "sw_phonon_oneshot"
character(len("num_phonon_calc_mode")),private,parameter :: tag_num_phonon_calc_mode = "num_phonon_calc_mode"
character(len("norder")),private,parameter :: tag_norder = "norder"
character(len("displacement")),private,parameter :: tag_displacement = "displacement"
character(len("force_calc")),private,parameter :: tag_force_calc = "force_calc"
character(len("start")),private,parameter :: tag_start = "start"
character(len("end")),private,parameter :: tag_end = "end"

character(len("sw_vibrational_modes")),private,parameter :: tag_sw_vibrational_modes = "sw_vibrational_modes"
character(len("sw_correct_force_constants")),private,parameter :: tag_sw_correct_force_constants = "sw_correct_force_constants"
character(len("point_group")),private,parameter :: tag_point_group = "point_group"
character(len("sw_lo_to_splitting")),private,parameter :: tag_sw_lo_to_splitting = "sw_lo_to_splitting"
character(len("electronic_dielectric_constant")),private,parameter :: &
 & tag_electronic_dielectric_cnst = "electronic_dielectric_constant"
character(len("exx")),private,parameter :: tag_exx = "exx"
character(len("eyy")),private,parameter :: tag_eyy = "eyy"
character(len("ezz")),private,parameter :: tag_ezz = "ezz"
character(len("exy")),private,parameter :: tag_exy = "exy"
character(len("eyz")),private,parameter :: tag_eyz = "eyz"
character(len("ezx")),private,parameter :: tag_ezx = "ezx"
character(len("k_vector")),private,parameter :: tag_k_vector = "k_vector"
character(len("kx")),private,parameter :: tag_kx = "kx"
character(len("ky")),private,parameter :: tag_ky = "ky"
character(len("kz")),private,parameter :: tag_kz = "kz"

character(len("sw_lattice_dielectric_tensor")),private,parameter :: & 
 & tag_sw_lattice_dielec_tensor = "sw_lattice_dielectric_tensor"
character(len("sw_internal_strain_piezoelectric_tensor")),private,parameter :: & 
 & tag_sw_int_strain_piezo_tensor = "sw_internal_strain_piezoelectric_tensor"

character(len("sw_dielectric_function")),private,parameter :: tag_sw_dielectric_function = "sw_dielectric_function"
character(len("energy_range")),private,parameter :: tag_energy_range = "energy_range"
character(len("min_energy")),private,parameter :: tag_min_energy = "min_energy"
character(len("max_energy")),private,parameter :: tag_max_energy = "max_energy"
character(len("division_number")),private,parameter :: tag_division_number = "division_number"
character(len("damping_factor")),private,parameter :: tag_damping_factor = "damping_factor"


character(len("lattice")),private,parameter :: tag_lattice = "lattice"
character(len("l1")),private,parameter :: tag_l1 = "l1"
character(len("l2")),private,parameter :: tag_l2 = "l2"
character(len("l3")),private,parameter :: tag_l3 = "l3"

character(len("no")),private,parameter :: tag_no = "no"
character(len("id")),private,parameter :: tag_id = "id"
character(len("special_points")),private,parameter :: tag_special_points = "special_points"
character(len("symmetry_lines")),private,parameter :: tag_symmetry_lines = "symmetry_lines"
character(len("k1")),private,parameter :: tag_k1 = "k1"
character(len("k2")),private,parameter :: tag_k2 = "k2"
character(len("k3")),private,parameter :: tag_k3 = "k3"
character(len("num_division")),private,parameter :: tag_num_division = "num_division"

character(len("method")),private,parameter :: tag_method = "method"
character(len("calc_type")),private,parameter :: tag_calc_type = "calc_type"
character(len("gamma")),private,parameter  :: tag_gamma  = "gamma"
character(len("zone_center")),private,parameter :: tag_zone_center = "zone_center"
character(len("band")),private,parameter   :: tag_band   = "band"
character(len("dispersion")),private,parameter :: tag_dispersion = "dispersion"
character(len("dos")),private,parameter    :: tag_dos    = "dos"

character(len("mesh")),private,parameter   :: tag_mesh   = "mesh"
character(len("nx")),private,parameter     :: tag_nx     = "nx"
character(len("ny")),private,parameter     :: tag_ny     = "ny"
character(len("nz")),private,parameter     :: tag_nz     = "nz"
character(len("deltae")),private,parameter :: tag_deltae = "deltae"

character(len("rho")),private,parameter :: tag_rho = "rho"

character(len("qvec_from_file")),private, parameter :: tag_qvec_from_file = "qvec_from_file"

contains

subroutine m_Phonon_rd_param(nfout)

integer, intent(in) :: nfout

integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue, f_getStringValue
integer :: f_selectParentBlock, f_selectTop
real(kind=DP) :: dret
character(len=FMAXVALLEN) :: cret
real(kind=DP) :: dnorm

iret = f_selectTop()
if( f_selectBlock( tag_phonon) == 0) then
   if( f_getIntValue( tag_sw_phonon, iret) == 0) sw_phonon = iret
   if(sw_phonon == ON) then
      sw_calc_force = ON
      if( f_getStringValue( tag_method, cret,LOWER) == 0) then
         call set_phonon_method(cret) ! -> phonon_method
      else if( f_getStringValue( tag_calc_type, cret,LOWER) == 0) then
         call set_phonon_method(cret) ! -> phonon_method
      end if
      if( f_getIntValue( tag_sw_calc_force, iret) == 0) sw_calc_force = iret
      if( f_getIntValue( tag_sw_calc_force_all, iret) == 0) sw_calc_force_all = iret
      if( f_getIntValue( tag_sw_polynomial_fit, iret) == 0) sw_polynomial_fit = iret
      if( f_getIntValue( tag_norder, iret) == 0) norder = iret
      if( f_getRealValue( tag_displacement, dret, 'bohr') == 0) then
         u = dret   
      else
         u = 0.1d0 ! default value
      end if
      if( f_getRealValue( tag_damping_factor, dret, '') == 0) damping_factor = dret
      damping_factor = abs(damping_factor)
      if( f_getIntValue( tag_sw_vibrational_modes, iret) == 0) sw_vibrational_modes = iret
      if( f_getIntValue( tag_sw_correct_force_constants, iret) == 0) sw_correct_force_constants = iret
      if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
         pg_gamma = cret(1:3)
      else
         pg_gamma = '' ! default value
      end if

      if( f_getIntValue( tag_sw_phonon_oneshot, iret)==0) sw_phonon_oneshot = iret
      if( f_getIntValue( tag_num_phonon_calc_mode,iret)==0) num_phonon_calc_mode = iret
 
! ==== KT_add ==== 13.1R
      call m_Raman_read_nfinp
! =============== 13.1R

      if( f_getIntValue( tag_sw_lattice_dielec_tensor, iret) == 0) & 
      &  sw_lattice_dielectric_tensor = iret
      if( f_getIntValue( tag_sw_int_strain_piezo_tensor, iret) == 0) & 
      &  sw_int_strain_piezo_tensor = iret

      if( f_getIntValue( tag_sw_dielectric_function, iret) == 0) sw_dielectric_function = iret

      if( f_getIntValue( tag_sw_lo_to_splitting, iret) == 0) sw_lo_to_splitting = iret
      if(sw_lo_to_splitting == ON) then
         if( f_getRealValue( tag_rho, dret, '') == 0) rho_loto = dret
      end if
      if( f_selectBlock( tag_force_calc) == 0) then
         if( f_getIntValue( tag_start, iret) == 0) istart_phonon = iret
         if( f_getIntValue( tag_end, iret) == 0) iend_phonon = iret
         iret = f_selectParentBlock()
      end if
      if( f_selectBlock( tag_electronic_dielectric_cnst) == 0) then
         if( f_getRealValue( tag_exx, dret, '') == 0) dielectric(1,1) = dret
         if( f_getRealValue( tag_eyy, dret, '') == 0) dielectric(2,2) = dret
         if( f_getRealValue( tag_ezz, dret, '') == 0) dielectric(3,3) = dret
         if( f_getRealValue( tag_exy, dret, '') == 0) dielectric(1,2) = dret
         dielectric(2,1) = dielectric(1,2)
         if( f_getRealValue( tag_eyz, dret, '') == 0) dielectric(2,3) = dret
         dielectric(3,2) = dielectric(2,3)
         if( f_getRealValue( tag_ezx, dret, '') == 0) dielectric(3,1) = dret
         dielectric(1,3) = dielectric(3,1)
         iret = f_selectParentBlock()
      end if
      if( f_selectBlock( tag_energy_range ) == 0) then
         if( f_getRealValue( tag_min_energy, dret, 'hartree') == 0) min_energy = dret
         if( f_getRealValue( tag_max_energy, dret, 'hartree') == 0) max_energy = dret
         if( f_getIntValue( tag_division_number, iret) == 0) num_division = iret
         iret = f_selectParentBlock()
      end if

      if( f_getIntValue(tag_qvec_from_file,iret)==0) qvec_from_file = iret

! ==== KT_add ====== 13.1R
      if( phonon_method == PHONON_GAMMA ) qvec_from_file = OFF
! ================== 13.1R

      if(qvec_from_file==OFF)then
         if( f_selectBlock( tag_k_vector) == 0) then
            if( f_getRealValue( tag_kx, dret, '') == 0) kvec_dir(1) = dret
            if( f_getRealValue( tag_ky, dret, '') == 0) kvec_dir(2) = dret
            if( f_getRealValue( tag_kz, dret, '') == 0) kvec_dir(3) = dret
            iret = f_selectParentBlock()
            dnorm = sqrt(sum(kvec_dir(1:3)**2))
            if(abs(dnorm) < 1.d-10) then
               kvec_dir(1:2)=0.d0
               kvec_dir(3)=1.d0
               dnorm = 1.d0
            end if
            kvec_dir(1:3) = kvec_dir(1:3)/dnorm
            iret = f_selectParentBlock()
         else
            kvec_dir(3) = 1.d0  ! default value
         end if
      endif

! === KT_add === 13.1R
      if ( sw_phonon_with_epsilon == ON ) then
         call m_Raman_initialize( kvec_dir )
         dielectric = dielectric_read_from_file
      endif
! ================ 13.1R

      if( phonon_method /= PHONON_GAMMA) then
         if( f_selectBlock( tag_lattice) == 0) then
            if( f_getIntValue( tag_l1, iret) == 0) nlat(1) = iret
            if( f_getIntValue( tag_l2, iret) == 0) nlat(2) = iret
            if( f_getIntValue( tag_l3, iret) == 0) nlat(3) = iret
            iret = f_selectParentBlock()
         else
            nlat(1:3) = 2
         end if
      else
         nlat(1:3) = 0
      end if

      if( phonon_method == PHONON_BAND) then
         call rd_spcpnt_and_symln()
      else if( phonon_method == PHONON_DOS) then
         phonon_dos_mesh(1:3) = 4 ! default values
         if( f_selectBlock( tag_dos) == 0) then
            if( f_selectBlock( tag_mesh) == 0) then
               if( f_getIntValue( tag_nx, iret) == 0) phonon_dos_mesh(1) = iret
               if( f_getIntValue( tag_ny, iret) == 0) phonon_dos_mesh(2) = iret
               if( f_getIntValue( tag_nz, iret) == 0) phonon_dos_mesh(3) = iret
               iret = f_selectParentBlock()
            end if
            if( f_getRealValue( tag_deltae, dret, '') == 0) DeltaE_dos = dret
            iret = f_selectParentBlock()
         end if
      end if

      iret = f_selectParentBlock()
   end if

   iret = f_selectParentBlock()
end if

if(sw_lattice_dielectric_tensor == ON) then
   phonon_method = PHONON_GAMMA
   sw_lo_to_splitting = OFF
end if

if(ipriphonon >= 1) then
   write(nfout,*) '!** sw_phonon = ',sw_phonon
   if(sw_phonon == ON) then
      write(nfout,*) '!** sw_calc_force = ',sw_calc_force
      write(nfout,*) '!** sw_calc_force_all = ',sw_calc_force_all
      write(nfout,*) '!** istart_phonon = ',istart_phonon
      write(nfout,*) '!** iend_phonon   = ',iend_phonon
      write(nfout,*) '!** displacement (Phonon) = ',u
      write(nfout,*) '!** sw_vibrational_modes = ',sw_vibrational_modes
      write(nfout,*) '!** sw_polynomial_fit = ',sw_polynomial_fit
      write(nfout,*) '!** norder = ',norder
      write(nfout,*) '!** nlat = ',nlat
      write(nfout,*) '!** sw_correct_force_constants = ',sw_correct_force_constants
      write(nfout,*) '!** point_group = ',pg_gamma
      write(nfout,*) '!** sw_lo_to_splitting = ',sw_lo_to_splitting
      write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,1)
      write(nfout,'(" !** epsilon = [",3(1x,f10.5),1x,"]")') dielectric(1:3,2)
      write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,3)
      write(nfout,'(" !** k_vector =",3(1x,f10.5))') kvec_dir(1:3)
      write(nfout,*) '!** sw_lattice_dielectric_tensor = ',sw_lattice_dielectric_tensor
      write(nfout,*) '!** sw_dielectric_function = ',sw_dielectric_function
      write(nfout,*) '!** energy_range = ',min_energy,max_energy,num_division
      write(nfout,*) '!** damping_factor = ',damping_factor
      write(nfout,*) '!** sw_internal_strain_piezoelectric_tensor = ',sw_int_strain_piezo_tensor
      if( phonon_method == PHONON_DOS) then
         write(nfout,*) '!** phonon_dos_mesh = ',phonon_dos_mesh(1:3)
      end if
      write(nfout,*) '!** sw_phonon_oneshot = ', sw_phonon_oneshot 
      if(sw_phonon_oneshot == ON) then
         write(nfout,*) '!** num_phonon_calc_mode = ',num_phonon_calc_mode
      end if
! ====== KT_add ==== 13.1R
      if ( sw_phonon_with_epsilon == ON ) call m_Raman_print_param
! ================== 13.1R
   end if
end if

contains
  subroutine rd_spcpnt_and_symln()
    integer :: num

    call read_spcpnt(.true.,nsp,num)  ! paramset = .true.  -> nsp
    nsp = num
    allocate(spcpnt(nsp,3))
    allocate(pg_spcpnt(nsp))
    call read_spcpnt(.false.,nsp,num) ! paramset = .false. -> spcpnt,pg_spcpnt

    call read_symln(.true.,nsl,num)  ! paramset = .true.  -> nsl
    nsl = num
    allocate(symln(nsl,3))
    allocate(ndiv(nsl))
    allocate(pg_symln(nsl))
    call read_symln(.false.,nsl,num) ! paramset = .false. -> symln,ndiv,pg_symln
  end subroutine rd_spcpnt_and_symln

  subroutine read_spcpnt(paramset,num,icounted)
    logical, intent(in) :: paramset
    integer, intent(in) ::  num
    integer, intent(out) :: icounted

    integer :: i, no, iret
    integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
    real(kind=dP) :: dret
    character(len=FMAXVALLEN) :: cret

    i = 1
    if( f_selectBlock( tag_special_points) == 0) then
       do
          if(i == 1) then
             if( f_selectFirstTableLine() /= 0 ) then
                exit
             end if
          else
             if( f_selectNextTableLine() /= 0 ) then
                exit
             end if
          end if
          if(.not.paramset) then
             if(i > num) exit
             no = i
             if(f_getIntValue(tag_no, iret) == 0) then
                no = iret
             else if(f_getIntValue(tag_id, iret) == 0) then
                no = iret
             end if
             if(no <= num) then
                if(f_getRealValue(tag_k1,dret,'') == 0) spcpnt(no,1) = dret
                if(f_getRealValue(tag_k2,dret,'') == 0) spcpnt(no,2) = dret
                if(f_getRealValue(tag_k3,dret,'') == 0) spcpnt(no,3) = dret
                if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                   pg_spcpnt(no) = cret(1:3)
                else
                   pg_spcpnt(no) = '' ! default value
                end if
             end if
          end if
          i = i+1
       end do
       iret = f_selectParentBlock()
    end if
    icounted = i - 1

  end subroutine read_spcpnt

  subroutine read_symln(paramset,num,icounted)
    logical, intent(in) :: paramset
    integer, intent(in) ::  num
    integer, intent(out) :: icounted

    integer :: i, no, iret
    integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
    character(len=FMAXVALLEN) :: cret

    i = 1
    if( f_selectBlock( tag_symmetry_lines) == 0) then
       do
          if(i == 1) then
             if( f_selectFirstTableLine() /= 0 ) then
                exit
             end if
          else
             if( f_selectNextTableLine() /= 0 ) then
                exit
             end if
          end if
          if(.not.paramset) then
             if(i > num) exit
             no = i
             if(f_getIntValue(tag_no, iret) == 0) then
                no = iret
             else if(f_getIntValue(tag_id, iret) == 0) then
                no = iret
             end if
             if(no <= num) then
                if(f_getIntValue(tag_k1,iret) == 0) symln(no,1) = iret
                if(f_getIntValue(tag_k2,iret) == 0) symln(no,2) = iret
                if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                   pg_symln(no) = cret(1:3)
                else
                   pg_symln(no) = '' ! default value
                end if
                if(f_getIntValue(tag_num_division,iret) == 0) ndiv(no) = iret
                if(iret <= 0) ndiv(no) = 1 
             end if
          end if
          i = i+1
       end do
       iret = f_selectParentBlock()
    end if
    icounted = i - 1

  end subroutine read_symln

  subroutine set_phonon_method(rstr)
    character(len=FMAXVALLEN),intent(in) :: rstr
    logical :: tf
    call strncmp2(rstr, FMAXVALLEN, tag_gamma, len(tag_gamma), tf)
    if(.not.tf) &
    & call strncmp2(rstr, FMAXVALLEN, tag_zone_center, len(tag_zone_center), tf)
    if(tf) then
       phonon_method = PHONON_GAMMA
       goto 1001
    end if
    call strncmp2(rstr, FMAXVALLEN, tag_band, len(tag_band), tf)
    if(.not.tf) &
    & call strncmp2(rstr, FMAXVALLEN, tag_dispersion, len(tag_dispersion), tf)
    if(tf) then
       phonon_method = PHONON_BAND
       goto 1001
    end if
    call strncmp2(rstr, FMAXVALLEN, tag_dos, len(tag_dos), tf)
    if(tf) then
       phonon_method = PHONON_DOS
       goto 1001
    end if
1001 continue
  end subroutine set_phonon_method
  
end subroutine m_Phonon_rd_param

subroutine m_Phonon_alloc_qvec()
  integer :: isl,ishf
  real(kind=DP),allocatable,dimension(:,:,:) :: vkxyz_t
  real(kind=DP),allocatable,dimension(:) :: qwgt_t
  integer :: qnv3
  if(phonon_method == PHONON_GAMMA) then
     nqvec = 1
  else if(phonon_method == PHONON_BAND) then
     if(qvec_from_file==OFF)then
        nqvec = 0
        do isl=1,nsl
           ishf = 0
           if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
           nqvec = nqvec + ndiv(isl) + 1 - ishf
        end do
     else
        allocate(vkxyz_t(1,1,1))
        allocate(qwgt_t(1))
        qnv3=0
        call m_Files_open_kpoint_files(FILE,nbztyp_spg)
        call readk0(.true.,nfout,ipriphonon,qnv3,rltv,nfkpoint,nfmatbp &
          & ,nqvec,vkxyz_t,qwgt_t)
        write(nfout,'(a,i5)') ' !** number of k-points for the phonon-band calculation : ',nqvec
        deallocate(vkxyz_t)
        deallocate(qwgt_t)
     endif
  else if(phonon_method == PHONON_DOS) then
     call make_qpoint_set(0,nqvec,.true.) ! ipri=0, paramset = .true.
     allocate(wght(nqvec))
  end if

  allocate(qvec(nqvec,3))
  allocate(qvin(nqvec,3))
  allocate(qdir(nqvec,3))
  allocate(point_group(nqvec)); point_group = ''
  allocate(fksym(48,nqvec)); fksym = .false.
end subroutine m_Phonon_alloc_qvec

subroutine m_Phonon_set_qvec(nfout)
  integer, intent(in) :: nfout

  call set_qvec(nfout)
  call set_qvec_point_group(nfout)
  call wd_qvec(nfout)
contains
  subroutine set_qvec(nfout)
    integer,intent(in) :: nfout

    integer :: k1,k2
    integer :: i,isl,ishf,iqvec
    real(kind=DP) :: q1(3),q2(3),dq(3)
    real(kind=DP), allocatable, dimension(:,:,:) :: qvec_t
    real(kind=DP), allocatable, dimension(:) :: qw_t
    if(phonon_method == PHONON_GAMMA) then
       nqvec = 1
       qvec(nqvec,1:3) = 0.d0
       qvin(nqvec,1:3) = 0.d0
       qdir(nqvec,1:3) = kvec_dir(1:3)
       point_group(nqvec) = pg_gamma
    else if(phonon_method == PHONON_BAND) then
       if(qvec_from_file==OFF)then
          nqvec = 0
          do isl=1,nsl
             k1 = symln(isl,1)
             k2 = symln(isl,2)
             q1(1:3) = rltv(1:3,1)*spcpnt(k1,1) &
                & + rltv(1:3,2)*spcpnt(k1,2) &
                & + rltv(1:3,3)*spcpnt(k1,3)
             q2(1:3) = rltv(1:3,1)*spcpnt(k2,1) &
                & + rltv(1:3,2)*spcpnt(k2,2) &
                & + rltv(1:3,3)*spcpnt(k2,3)
             dq(1:3) = (q2(1:3)-q1(1:3))/ndiv(isl)  
             ishf = 0
             if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
             iqvec = nqvec + 1
             do i=0,ndiv(isl)-ishf
                nqvec = nqvec + 1
                qvec(nqvec,1:3) = i*dq(1:3)+q1(1:3)
                qdir(nqvec,1:3) = dq(1:3)
                point_group(nqvec) = pg_symln(isl)
             end do
             point_group(iqvec) = pg_spcpnt(k1)
             if(ishf==0) point_group(nqvec) = pg_spcpnt(k2)
          end do
       else
          allocate(qvec_t(nqvec,3,CRDTYP));qvec_t=0.d0
          allocate(qw_t(nqvec));qw_t=1.d0
          call readk0(.false.,nfout,ipriphonon,nqvec,rltv,nfkpoint,nfmatbp &
          & , nqvec, qvec_t, qw_t)
          qdir=0.d0
          do i=1,nqvec
             qvec(i,1:3) = qvec_t(i,1:3,CARTS)
          enddo
          do i=1,nqvec-1
             qdir(i,1) = qvec(i+1,1)-qvec(i,1)
             qdir(i,2) = qvec(i+1,2)-qvec(i,2)
             qdir(i,3) = qvec(i+1,3)-qvec(i,3)
          enddo
          if(nqvec>1) qdir(nqvec,:) = qdir(nqvec-1,:)
       endif
       do iqvec=1,nqvec
          do i=1,3
             qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
          end do
       end do
    else if(phonon_method == PHONON_DOS) then
       call make_qpoint_set(1,nqvec,.false.) ! ipri=1, paramset = .false.
       do iqvec=1,nqvec
          do i=1,3
             qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
          end do
          qdir(iqvec,1:3) = rltv(1:3,1)+rltv(1:3,2)+rltv(1:3,3)
       end do
    end if
  end subroutine set_qvec

  subroutine set_qvec_point_group(nfout)
    use m_Const_Parameters,  only: AUTOMATIC
    use m_Crystal_Structure, only: nopr,op,ig01,il,symmetry_method
    use m_CS_SpaceGroup,     only: lattice_system, &
                                 & get_kpoint_symmetry,get_point_group_name
    integer,intent(in) :: nfout

    integer :: i,j
    integer :: nopro,ig01o(48)
    integer :: nopro2,ig01o2(48)
    real(kind=DP) :: kvec(3)
    character(len=3) :: pg_name
    character(len=5) :: pg_name_i
    character(len=9) :: system

    if(symmetry_method==AUTOMATIC) then
       system = lattice_system
    else
       if(il>0) then
          system = 'cubic'
       else
          system = 'hexagonal'
       end if
    end if 

    do i=1,nqvec
       if(point_group(i) == '') then
          kvec = qvec(i,1:3)
          call get_kpoint_symmetry(nopr,ig01,op,kvec,nopro,ig01o,nopro2,ig01o2)
          do j=1,nopro2
             fksym(ig01o2(j),i) = .true.
          end do
          call get_point_group_name(nfout,system,nopro,ig01o,pg_name,pg_name_i)
          point_group(i) = pg_name
       else
          fksym(1:nopr,i) = .true.
       end if
    end do
  end subroutine set_qvec_point_group

  subroutine wd_qvec(nfout)
    integer,intent(in) :: nfout

    integer :: i
    if(ipriphonon > 0) then
       write(nfout,'("=== q-vectors ===")')
       write(nfout,'("number of q-vecotrs = ",i5)') nqvec
       write(nfout,'(4x,"i",5x,"qvec(3)",26x,"qvin(3)",22x,"point_group")')
       do i=1,nqvec
          write(nfout,'(i5,3(1x,f10.5),3(1x,f10.5),1x,a3)') i,qvec(i,1:3),qvin(i,1:3),point_group(i)
       end do
    end if
  end subroutine wd_qvec

end subroutine m_Phonon_set_qvec

subroutine make_qpoint_set(ipri,nqvec,paramset)
  use m_Crystal_Structure, only: il,inv,ngen,igen,jgen,a,b,c,ca,cb,cc
  integer, intent(in) :: ipri
  integer, intent(inout) :: nqvec
  logical, intent(in) :: paramset

  integer :: nx1,ny1,nz1
  integer :: nx,ny,nz
  integer :: nxx,nyy,nzz
  integer :: nd, lmnp0, lmnp1, lmnp2
  real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb 
  integer,       pointer, dimension(:,:) :: ka0,ka2
  integer,       pointer, dimension(:,:) :: ip2cub_wk
  integer,       pointer, dimension(:)   :: nstar2
  integer                                :: i
  real(kind=DP) :: nv(3),trmat(3,3)

  nx = phonon_dos_mesh(1)
  ny = phonon_dos_mesh(2)
  nz = phonon_dos_mesh(3)
  call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

  lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
  lmnp1=lmnp0
  lmnp2=lmnp0

  nxyz_tetra = 0
  allocate(ip10(lmnp0))  ; ip10 = 0        
  if(paramset) allocate(ip20(lmnp0))
  ip20 = 0        
  allocate(ip01(lmnp1))    ; ip01 = 0
  allocate(ip02(lmnp2))    ; ip02 = 0
  allocate(ip21(lmnp1))    ; ip21 = 0
  allocate(ip12(lmnp2))    ; ip12 = 0
  allocate(iu21(lmnp1))    ; iu21 = 0
  allocate(iv21(lmnp1))    ; iv21 = 0
  allocate(nstar2(lmnp2))  ; nstar2 = 0
  allocate(pa0(3,lmnp0))  ; pa0 = 0
  allocate(pb0(3,lmnp0))  ; pb0 = 0
  allocate(pb(3,lmnp2))  ; pb = 0
  allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$  allocate(ka2(4,lmnp2))  ; ka2 = 0

  call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
       &               ,nx,ny,nz &
       &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
       &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
       &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
       &               ,nstar2,pa0,pb0,pb,ka0 &
       &               ,ipri)

  if(.not.paramset) then
     call get_trmat1  !-(contained here) ->(trmat)
     do i=1,nqvec
        nv(1:3) = dble(ka0(1:3,ip02(i)))/dble(ka0(4,ip02(i)))
        qvec(i,1:3) = matmul(trmat,nv)
        wght(i)     = dble(nstar2(i))/dble(np1)
     end do
  else
     nqvec = np2
  end if

  deallocate(ip10)
  deallocate(ip01)
  deallocate(ip02)
  deallocate(ip21)
  deallocate(ip12)
  deallocate(iu21)
  deallocate(iv21)
  deallocate(nstar2)
  deallocate(pa0)
  deallocate(pb0)
  deallocate(pb)
  deallocate(ka0)
!!$  deallocate(ka2)

  if(paramset) return

  allocate(iwt(np2)) ; iwt = 0
  allocate(ip2cub(np1)) ; ip2cub = 0

  allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3))) 
  ip2cub_wk = 0.d0
  call wtetra &
    &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
    &  ,iwt,ip2cub &
    &  ,ip2cub_wk)
  deallocate(ip2cub_wk)
contains
  subroutine get_trmat1
    real(kind=DP), dimension(3,3) :: trbp,trpb,mat1,mat2
!    make translation matrix  trpb (P -> B)

    call getspgtab(trbp)  ! spg+tetra

    call inver3n(3,trbp,trpb)

    mat1 = transpose(trpb)
    call inver3n(3,mat1,mat2)
    call matpr3(rltv,mat2,trmat)

  end subroutine get_trmat1
end subroutine make_qpoint_set

subroutine m_Phonon_write_forces()
use m_IterationNumbers, only : iteration_ionic, iteration_electronic
use m_Files, only : nfforce, m_Files_open_nfforce
use m_Ionic_system, only : natm,num_force_calc,iconf
use m_Control_Parameters, only : num_phonon_calc_mode
use m_Force, only : forc_l
#ifdef WINDOWS
use ifport
#endif

! local variables
integer :: i,ic

if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
ic = iconf(iteration_ionic)
force_data(1:natm_super,1:3,ic) = forc_l(1:natm_super,1:3)

if(mype /= 0) return

if(iteration_ionic == 1) then
   call m_Files_open_nfforce(.false.)  ! new file (asms)
   if(istart_phonon == 1) then
      if(sw_phonon_oneshot == ON) then
         write(nfforce,'(4(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit, num_phonon_calc_mode")') &
              & num_force_calc,  norder, sw_polynomial_fit, num_phonon_calc_mode
      else
         write(nfforce,'(3(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit")') &
              & num_force_calc, norder, sw_polynomial_fit
      end if
   end if
else
   call m_Files_open_nfforce(.true.)  ! append (asms)
end if
write(nfforce,'(i4,3(1x,e25.12),2i6,"  : displaced_atom, displacement(1:3), iteration_ionic,iteration_electronic")') &
     & displaced_atom,displacement(1:3),iteration_ionic,iteration_electronic
do i=1,natm_super
   write(nfforce,'(i4,3(1x,e25.12))') i,forc_l(i,1:3)
end do
call flush(nfforce)

end subroutine m_Phonon_write_forces

! ==== KT_add == 13.1R
subroutine m_Phonon_print_Raman_susc
  call m_Raman_calc_susceptibility( nmodes, omega, modes, &
       &                            mode_active, mode_irr_rep )
end subroutine m_Phonon_print_Raman_susc
! =============== 13.1R

function m_Phonon_Check_iteration(iteration_ionic)
use m_Control_Parameters, only : skip_alloc_phonon
use m_Crystal_Structure, only : m_CS_phonon_symmetry
use m_Ionic_System, only : m_IS_phonon_equilibrium, m_IS_cps_to_pos &
                       & , istart_phonon, iend_phonon, num_force_calc &
                       & , iconf
logical :: m_Phonon_Check_iteration
integer, intent(in) :: iteration_ionic
integer :: id

if(ipriphonon>=1) then
   id = iteration_ionic+istart_phonon-1
   write(nfout,*) 'PHONON: num_force_calc  = ',num_force_calc
   write(nfout,*) 'PHONON: istart, iend = ',istart_phonon, iend_phonon
   write(nfout,*) 'PHONON: id = ',id
   write(nfout,*) 'PHONON: iconf = ',iconf(id)
   write(nfout,*) 'PHONON: iteration_ionic = ',iteration_ionic
end if

if(iteration_ionic >= iend_phonon-istart_phonon+1 ) then
  m_Phonon_Check_iteration = .true.
  call m_IS_phonon_equilibrium()
  call m_IS_cps_to_pos()
  call m_CS_phonon_symmetry(ON)
else 
  m_Phonon_Check_iteration = .false.
end if
skip_alloc_phonon = .true.

end function m_Phonon_Check_iteration

subroutine m_Phonon_read_forces()
use m_Files,        only : m_Files_open_nfforce, nfforce
use m_Ionic_System, only : num_force_calc, napt_phonon, iequconf &
    &                    , iopr_equconf, iconf
use m_Crystal_Structure, only : op
#ifdef WINDOWS
use ifport
#endif
implicit none

! local variables
integer :: n,i,ia,ja,ind,j,ic,iopr
integer :: istart,idummy
character(len=5) :: num

if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Reading forces'
call flush(nfout)

nmodes = natm_prim*3
allocate(forces(3*natm_super,nmodes,norder*2))
allocate(force0(3*natm_super))

!if(sw_calc_force == OFF) then
!   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = OFF")')

  num_force_data = nmodes*norder*2
  if(sw_polynomial_fit == ON) num_force_data = num_force_data + 1
  if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))

  if(mype == 0) then
    call m_Files_open_nfforce(.false.)
    rewind nfforce
    read(nfforce,*) num_force_calc, norder, sw_polynomial_fit
    do i=1,num_force_calc
      read(nfforce,*) displaced_atom,displacement(1:3)
      ic = iconf(i)
      do ia=1,natm_super
        read(nfforce,*) idummy,force_data(ia,1:3,ic)
      end do
    end do
  end if

!else
!   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = ON")')
!end if

if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
do i=1,num_force_data
   ic = iequconf(i)
   if(ipriphonon>=2) write(nfout,'(" i, ic = ",2i8)') i, ic
   if(ic >= 0) cycle
   ic = abs(ic)
   iopr = iopr_equconf(i)
   if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
   do ia=1,natm_super
      ja = napt_phonon(ia,i)
      do j=1,3
         force_data(ia,j,ic) = (force_data(ia,j,ic) + dot_product(op(1:3,j,iopr),force_data(ja,1:3,i)))*0.5d0
      end do
   end do
end do

if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
do i=1,num_force_data
   ic = iequconf(i)
   if(ic == 0) cycle
   ic = abs(ic)
   iopr = iopr_equconf(i)
   if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
   do ia=1,natm_super
      ja = napt_phonon(ia,i)
      do j=1,3
         force_data(ja,j,i) =  dot_product(op(j,1:3,iopr),force_data(ia,1:3,ic))
      end do
   end do
end do

if(sw_polynomial_fit == ON) then
  ind=1
  do ia=1,natm_super
    istart = 3*(ia-1)+1
    force0(istart:istart+2) = force_data(ia,1:3,ind)
  end do
else
  ind=0
end if
do i=1,nmodes
  do n=1,norder*2
    ind = ind+1
    do ia=1,natm_super
      istart = 3*(ia-1)+1
      forces(istart:istart+2,i,n) = force_data(ia,1:3,ind)
    end do
  end do
end do

if(npes>1) then
  call mpi_bcast(forces,3*natm_super*nmodes*norder*2,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(force0,3*natm_super,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
end if

if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Forces are read.'
call flush(nfout)

! check sum of force
!!if(ipriphonon>=0) then
if(ipriphonon>=2) then
   write(nfout,*) "check sum of force"
   do i=1,num_force_data
      do j=1,3
         write(nfout,*) i,j,sum(force_data(1:natm_super,j,i))
      end do
   end do
end if

return
end subroutine m_Phonon_read_forces


subroutine m_Phonon_calc_dynamical_matrix()
use m_Crystal_Structure, only : univol, altv
implicit none

! local variables
integer :: i,j,k
integer :: istart
real(kind=DP) :: mi,ui

real(kind=DP) :: coefna
complex(kind=DP), allocatable :: nadynmat(:,:,:) ! dim(nmodes,nmodes,nqvec)
complex(kind=DP), allocatable :: nafd(:,:,:) ! dim(3,3,natm)
real(kind=DP) :: sum_rule(nmodes,3)
integer :: na,ia,ja,ir,jr,ira,jra,n
real(kind=DP) :: ae,ai,amelem
integer :: icell,nre,jas
real(kind=DP) :: r(3),re(3,8)
real(kind=DP) :: ph,w
complex(kind=DP) :: expqr
integer :: ii,jj,iu,ju
integer :: iq
real(kind=DP) :: s(3)
integer :: ng,nr
real(kind=DP), allocatable :: gv(:,:),rv(:,:)
real(kind=DP) :: g2bz

real(kind=DP), parameter :: eps = 1.d-6

allocate(dynmat(nmodes,nmodes,nlpnt))
allocate(dynmatq(nmodes,nmodes,nqvec))
allocate(msqinv(nmodes))

call m_Phonon_force_constant_matrix(dynmat)

deallocate(forces)
deallocate(force0)

if(ipriphonon >=2) then
! output
   write(nfout,*) 'calculated force constants:'
   call write_dynmat(dynmat)
end if

! symmetrized force constants in Real space
call symmetrize_force_const_Real(dynmat)
if(ipriphonon >=2) then
! output
   write(nfout,*) 'symmetrized force constants:'
   call write_dynmat(dynmat)
end if

! check sum rule of force constants
if(ipriphonon >=2) &
  & write(nfout,*) 'j ir sum_of_force_constants'
do ia=1,natm_prim
   do ir=1,3
      i = (ia-1)*3+ir
      do jr=1,3
         sum_rule(i,jr)=0
         do n=1,nlpnt
            do ja=1,natm_prim
               j=(ja-1)*3+jr
               if(n==1.and.ia==ja) cycle
               sum_rule(i,jr) = sum_rule(i,jr) + dynmat(i,j,n) 
            end do
         end do
         if(ipriphonon >=2) then
            j=(ia-1)*3+jr
            write(nfout,*) i,jr,sum_rule(i,jr)+dynmat(i,j,1)
         end if
      end do
   end do 
end do
! correct force constants
if(sw_correct_force_constants == ON) then
   do i=1,nmodes
      ia = (i+2)/3
      do jr=1,3
         j=(ia-1)*3+jr
         dynmat(i,j,1) = - sum_rule(i,jr)
      end do
   end do
end if

! output
if(sw_correct_force_constants == ON) then
   if(printable) write(nfout,*) '*** Force constants were corrected. ***'
   if(ipriphonon >=2) then
      write(nfout,*) 'Corrected force constants:'
      call write_dynmat(dynmat)
   end if
else
   if(printable) write(nfout,*) '*** Force constants were NOT corrected. ***'
end if

! Fourier transform of force constants
dynmatq(:,:,:) = dcmplx(0.d0,0.d0)
do n=1,nqvec
   !!$write(nfout,*) 'qvin=',qvin(n,1:3)
   !!$write(nfout,*) 'qvec=',qvec(n,1:3)
   do icell=1,nlpnt
      do j=1,nmodes
         ja = (j-1)/3 + 1
         !!$ju = mod(j-1,3)
         jas = ja + (icell-1)*natm
         do i=1,nmodes
            ia = (i-1)/3 + 1
            !!$iu = mod(i-1,3)
            !!$r(1:3) = cps(jas,1:3)-cps(ia,1:3)
            r(1:3) = cps(ia,1:3)-cps(jas,1:3)
            call get_pos_in_extcell(r,nre,re)
            expqr = dcmplx(0.d0,0.d0)
            do k=1,nre
               ph = sum(qvec(n,1:3)*re(1:3,k))
               expqr = expqr + dcmplx(cos(ph),sin(ph))
            end do
            expqr = expqr/dble(nre)
            !!$write(nfout,*) 'ia,ja,i,j=',ia,ja,i,j
            !!$write(nfout,'("r =",3f10.5)') r(1:3)
            !!$do k=1,nre
            !!$   write(nfout,'("k,re =",i3,3f10.5)') k,re(1:3,k)
            !!$end do
            !!$write(nfout,*) 'ph,expqr=',ph,expqr

            dynmatq(i,j,n) = dynmatq(i,j,n)+dynmat(i,j,icell)*expqr
            !!$ii = (ja-1)*3 + iu + 1
            !!$jj = (ia-1)*3 + ju + 1
            !!$dynmatq(ii,jj,n) = dynmatq(ii,jj,n)+dynmat(i,j,icell)*expqr
         end do
      end do
   end do
end do
deallocate(dynmat)

if(ipriphonon >=2) then
! output
   write(nfout,*) 'Force constant matrix in Fourier space:'
   call write_dynmatq(dynmatq)
end if

! symmetrized force constants in Fourier space
call symmetrize_force_const_Fourier(dynmatq)

if(ipriphonon >=2) then
! output
   write(nfout,*) 'Symmetrized force constants Fourier space:'
   call write_dynmatq(dynmatq)
end if


if(ipriphonon >=2) then
! output
   write(nfout,*) 'Dynamical matrix in Fourier space:'
   call write_dynmatq(dynmatq)
end if

! non-analytic part
if(sw_lo_to_splitting == ON) then
   allocate(nadynmat(nmodes,nmodes,nqvec))
   call get_g2bz(g2bz)
   do iq=1,nqvec
      s = qvin(iq,1:3)
      call mod1(s)
      if(abs(sum(s(1:3)**2)) < eps) then
        ! Gamma point
         call calc_napart_gamma(iq,nadynmat(1,1,iq))
      else
         call calc_napart_parlinski(iq,nadynmat(1,1,iq),g2bz)
      end if
   end do

   if(ipriphonon >=2) then
   ! output
      write(nfout,*) 'Non-analytic part of force constant matrix in Fourier space:'
      call write_dynmatq(nadynmat)
   end if

   do iq=1,nqvec
      do j=1,nmodes
         do i=1,nmodes
            dynmatq(i,j,iq) = dynmatq(i,j,iq) + nadynmat(i,j,iq)
         end do
      end do
   end do

   if(ipriphonon >=2) then
   ! output
      write(nfout,*) 'Total force constant matrix in Fourier space:'
      call write_dynmatq(dynmatq)
   end if

   deallocate(nadynmat)

end if

! calculate 1/sqrt(mass)
do i=1,natm_prim
   istart=3*(i-1)+1
   mi = 1.d0/sqrt(ionic_mass(i))
   msqinv(istart) = mi
   msqinv(istart+1) = mi
   msqinv(istart+2) = mi
end do
if(ipriphonon > 1) then
   do i=1,nmodes
      write(nfout,*) 'debug: i= ',i,' msqinv = ',msqinv(i)
   end do
end if

! calculate dynamical matrix in Fourier space
do n=1,nqvec
   do j=1,nmodes
      do i=1,nmodes
         dynmatq(i,j,n) = dynmatq(i,j,n)*msqinv(i)*msqinv(j)
      end do
   end do
end do


do iq=1,nqvec
   !search the absolute maximum element
   amelem = abs(dynmatq(1,1,iq))
   do i=1,nmodes
      do j=i,nmodes
         ae = abs(dynmatq(i,j,iq))
         if(ae > amelem) amelem = ae
      end do
   end do
   if(ipriphonon >=2) then
      write(nfout,*) 'amelem = ',amelem
   end if
   do i=1,nmodes
      do j=1,nmodes
         ae = dble(dynmatq(i,j,iq))
         ai = dimag(dynmatq(i,j,iq))
         if(abs(ae) < amelem*1.d-14) ae = 0.d0
         if(abs(ai) < amelem*1.d-14) ai = 0.d0
         dynmatq(i,j,iq) = dcmplx(ae,ai)
      end do
   end do
end do
if(ipriphonon >=2) then
   ! output
   write(nfout,*) 'Dynamical matrix after removing small elements:'
   call write_dynmatq(dynmatq)
end if

return

contains
  subroutine get_pos_in_extcell(r,nre,re)
    real(kind=DP), intent(in) :: r(3)
    integer, intent(out) :: nre
    real(kind=DP), intent(out) :: re(3,8)

    integer :: i,j,k,n(3),l
    real(kind=DP) :: s(3),p(3)
    real(kind=DP) :: eps = 1.d-6

    do i=1,3
       s(i) = sum(rltv_super(1:3,i)*r(1:3))/PAI2
    end do
    call mod1(s)
    do i=1,3
       n(i) = 1
       if(abs(s(i)-0.5d0)<eps) n(i) = 2
    end do
    do i=1,3
       if(s(i)>0.5d0-eps) s(i) = s(i) - 1.d0
    end do
    nre = 0
    do k=1,n(3)
       do j=1,n(2)
          do i=1,n(1)
             nre = nre + 1
             p(1) = s(1)+i-1
             p(2) = s(2)+j-1
             p(3) = s(3)+k-1
             do l=1,3
                re(l,nre) = sum(altv_super(l,1:3)*p(1:3))
             end do
          end do
       end do
    end do
  end subroutine get_pos_in_extcell

  subroutine mod1(t)
    real(kind=DP), intent(inout) :: t(3)
    real(kind=DP), parameter :: eps = 1.d-6
    integer :: k
    t(1:3) = mod(t(1:3),1.d0)
    do k=1,3
       if(t(k) < -eps) t(k) = t(k) + 1.d0
       if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
    end do
  end subroutine mod1

  subroutine symmetrize_force_const_Real(fc)
  use m_Crystal_Structure, only : nopr,op,tau
  real(kind=DP), intent(inout) :: fc(nmodes,nmodes,nlpnt)
  ! local variables
  integer :: i,j,icell,jcell,kcell,irc,jrc
  integer :: nr(natm,nlpnt),l(3,nlpnt),lx(3),ll(3)
  integer :: lr(natm,nlpnt),llr(nlpnt,nlpnt)
!!$  real(kind=DP) :: nonsym_fc(nmodes,nmodes,nlpnt)
  real(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fc
  real(kind=DP) :: tensor(3,3)
  real(kind=DP) :: x(3),y(3)
  real(kind=DP) :: aa(3,3)
  real(kind=DP) :: eps = 1.d-6
  allocate(nonsym_fc(nmodes,nmodes,nlpnt));nonsym_fc=0.d0
  nonsym_fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)
  fc(1:nmodes,1:nmodes,1:nlpnt) = 0.d0

  do icell=1,nlpnt
     l(1:3,icell) = nint(matmul(transpose(rltv),lpnt(icell,1:3))/PAI2)
  end do

  aa = matmul(transpose(rltv_super),altv)/PAI2
  do icell=1,nlpnt
     do jcell=1,nlpnt
        ll = l(1:3,jcell)-l(1:3,icell)
        do kcell=1,nlpnt
           x = matmul(aa,ll-l(1:3,kcell))
           if(sum(abs(x-nint(x)))<eps) then
             llr(icell,jcell) = kcell
             exit
           end if
        end do
     end do
  end do

  do n=1,nopr
     do icell=1,nlpnt
        ATOM: do i=1,natm
           x(1:3) = cps(i,1:3) + lpnt(icell,1:3)
           y = matmul(op(1:3,1:3,n),x) + tau(1:3,n,CARTS)
           do j=1,natm
              x = y-cps(j,1:3)
              x = matmul(transpose(rltv),x)/PAI2
              lx = nint(x(1:3))
              if(sum(abs(x-lx))<eps) then
                 nr(i,icell) = j
                 do jcell=1,nlpnt
                    ll = lx-l(1:3,jcell)
                    x = matmul(aa,ll)
                    if(sum(abs(x-nint(x)))<eps) then
                       lr(i,icell) = jcell
                       exit
                    end if
                 end do
                 cycle ATOM
              end if
           end do
           write(nfout,'("No equivalent atom for the atom ",i5," in the cell ",i5)') i,icell
           stop 'No equivalent atom'
        end do ATOM
     end do
     icell = 1
     do jcell=1,nlpnt
        do j=1,natm 
           ja=3*(j-1)+1
           jr=nr(j,jcell)
           jra=3*(jr-1)+1
           jrc = lr(j,jcell)
           do i=1,natm
              ia=3*(i-1)+1
              ir=nr(i,icell)
              ira=3*(ir-1)+1
              irc = lr(i,icell)
              kcell = llr(irc,jrc)
              tensor(1:3,1:3)=nonsym_fc(ia:ia+2,ja:ja+2,jcell)
              call rotate_tensor(tensor,n)
              fc(ira:ira+2,jra:jra+2,kcell)= &
                 & fc(ira:ira+2,jra:jra+2,kcell) + tensor(1:3,1:3)
           end do
        end do
     end do
  end do
  fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)/nopr
  deallocate(nonsym_fc)
  end subroutine symmetrize_force_const_Real

  subroutine rotate_tensor(tensor,n)
  use m_Crystal_Structure, only : op
  real(kind=DP), intent(inout) :: tensor(3,3)
  integer, intent(in) :: n ! index of rotation

  ! local variables
  integer :: i,j,k,l
  real(kind=DP) :: tnew(3,3)
 
  tnew(1:3,1:3)=0.d0

  do l=1,3
    do i=1,3
      do k=1,3
        do j=1,3
          !!$tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
          tnew(i,l)=tnew(i,l)+op(i,j,n)*tensor(j,k)*op(l,k,n)
        end do
      end do
    end do
  end do
  
  tensor(1:3,1:3)=tnew(1:3,1:3)
  end subroutine rotate_tensor

  subroutine symmetrize_force_const_Fourier(fcq)
  use m_Ionic_System, only : napt
  use m_Crystal_Structure, only : nopr,op
  complex(kind=DP), intent(inout) :: fcq(nmodes,nmodes,nqvec)
  ! local variables
  integer :: i,j,nop,iq
!!$  complex(kind=DP) :: nonsym_fcq(nmodes,nmodes,nqvec)
  complex(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fcq
  complex(kind=DP) :: tensor(3,3)
  complex(kind=DP) :: expgr
  real(kind=DP) :: ph,g(3)

  allocate(nonsym_fcq(nmodes,nmodes,nqvec));nonsym_fcq=0.d0
  nonsym_fcq(1:nmodes,1:nmodes,1:nqvec) = fcq(1:nmodes,1:nmodes,1:nqvec)
  fcq(1:nmodes,1:nmodes,1:nqvec) = 0.d0

  do iq=1,nqvec
     nop = 0
     do n=1,nopr
        if(.not.fksym(n,iq)) cycle
        nop = nop + 1
        g = matmul(op(1:3,1:3,n),qvec(iq,1:3)) - qvec(iq,1:3)
        do j=1,natm
           ja=3*(j-1)+1
           jr=napt(j,n)
           jra=3*(jr-1)+1
           do i=1,natm
              ia=3*(i-1)+1
              ir=napt(i,n)
              ira=3*(ir-1)+1
              ph = dot_product(g,cps(j,1:3)-cps(i,1:3))
              expgr = dcmplx(cos(ph),sin(ph))
              tensor(1:3,1:3)=nonsym_fcq(ira:ira+2,jra:jra+2,iq)
              call rotate_complex_tensor(tensor,n)
              fcq(ia:ia+2,ja:ja+2,iq)= &
                 & fcq(ia:ia+2,ja:ja+2,iq) + tensor(1:3,1:3)*expgr
           end do
        end do
     end do
     fcq(1:nmodes,1:nmodes,iq) = fcq(1:nmodes,1:nmodes,iq)/nop
  end do
  deallocate(nonsym_fcq)
  do iq=1,nqvec
     do j=1,nmodes
        do i=1,j
           fcq(i,j,iq)=(fcq(i,j,iq)+dconjg(fcq(j,i,iq)))*0.5d0
           fcq(j,i,iq)=dconjg(fcq(i,j,iq))
        end do
     end do
  end do

  end subroutine symmetrize_force_const_Fourier


  subroutine rotate_complex_tensor(tensor,n)
  use m_Crystal_Structure, only : op
  complex(kind=DP), intent(inout) :: tensor(3,3)
  integer, intent(in) :: n ! index of rotation

  ! local variables
  integer :: i,j,k,l
  complex(kind=DP) :: tnew(3,3)
 
  tnew(1:3,1:3)=0.d0

  do l=1,3
    do i=1,3
      do k=1,3
        do j=1,3
          tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
        end do
      end do
    end do
  end do
  
  tensor(1:3,1:3)=tnew(1:3,1:3)
  end subroutine rotate_complex_tensor

  subroutine write_dynmat(dynmat)
    real(kind=DP), intent(in) :: dynmat(nmodes,nmodes,nlpnt)
    integer :: icell,l1,l2,l3,n
    do icell=1,nlpnt
       l1 = nint(sum(rltv(1:3,1)*lpnt(icell,1:3))/PAI2)
       l2 = nint(sum(rltv(1:3,2)*lpnt(icell,1:3))/PAI2)
       l3 = nint(sum(rltv(1:3,3)*lpnt(icell,1:3))/PAI2)
       write(nfout,'("icell=",i4," l1=",i3," l2=",i3," l3=",i3," lp=",3f10.5)') icell,l1,l2,l3,lpnt(icell,1:3)
       do n=1,nmodes
          write(nfout,'(50(1x,e12.5))') dynmat(n,1:nmodes,icell)
       end do
    end do
  end subroutine write_dynmat

  subroutine write_dynmatq(dynmatq)
    complex(kind=DP), intent(in) :: dynmatq(nmodes,nmodes,nqvec)
    integer :: iq
    do iq=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
       write(nfout,'("=== Real part ===")') 
       do n=1,nmodes
          write(nfout,'(50(1x,e12.5))') dble(dynmatq(n,1:nmodes,iq))
       end do
       write(nfout,'("=== Imag part ===")') 
       do n=1,nmodes
          write(nfout,'(50(1x,e12.5))') dimag(dynmatq(n,1:nmodes,iq))
       end do
    end do
  end subroutine write_dynmatq

  subroutine calc_napart_gamma(iq,nafc)
    integer, intent(in) :: iq
    complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)

    real(kind=DP) :: coefna,kzeff(nmodes)
    integer :: i,j,na,ia

    coefna = 0.d0
    do j=1,3
       do i=1,3
          coefna = coefna + qdir(iq,i)*dielectric(i,j)*qdir(iq,j)
       end do
    end do
    coefna = PAI4/(univol*coefna)
    i=0
    do na=1,natm
       do ia=1,3
          i=i+1
          kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,ia,na))
       end do
    end do
    do j=1,nmodes
       do i=1,nmodes
          nafc(i,j) = coefna*kzeff(i)*kzeff(j)
       end do
    end do

  end subroutine calc_napart_gamma

  subroutine calc_napart_parlinski(iq,nafc,g2bz)
    integer, intent(in) :: iq
    complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)
    real(kind=DP), intent(in) :: g2bz

    real(kind=DP) :: coefna,kzeff(nmodes)
    real(kind=DP) :: expk,rho2
    integer :: i,j,na,ia

    rho2 = rho_loto**2*g2bz*0.25d0

    coefna = 0.d0
    do j=1,3
       do i=1,3
          coefna = coefna + qvec(iq,i)*dielectric(i,j)*qvec(iq,j)
       end do
    end do
    coefna = PAI4/(univol*coefna)
    i=0
    do na=1,natm
       do ia=1,3
          i=i+1
          kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,ia,na))
       end do
    end do
    expk = exp(-PAI**2*sum(qvec(iq,1:3)**2)/rho2)
    do j=1,nmodes
       do i=1,nmodes
          nafc(i,j) = coefna*kzeff(i)*kzeff(j)*expk
       end do
    end do

  end subroutine calc_napart_parlinski

  subroutine get_g2bz(g2)
    real(kind=DP), intent(out) :: g2

    integer :: i,j,k
    real(kind=DP) :: g(3),gg

    g2 = dot_product(rltv(1:3,1),rltv(1:3,1))
    do i=-2,2
       do j=-2,2
          do k=-2,2
             g(1:3) = i*rltv(1:3,1)+j*rltv(1:3,2)+k*rltv(1:3,3)
             gg = dot_product(g,g)
             if(abs(gg) > eps .and. gg < g2) then
                g2 = gg
             end if
          end do
       end do
    end do
  end subroutine get_g2bz

end subroutine m_Phonon_calc_dynamical_matrix

subroutine m_Phonon_force_constant_matrix(force_const_mat)
implicit none

real(kind=DP), intent(out) :: force_const_mat(nmodes,nmodes,nlpnt)

! local variables
integer :: is,nc,ind,i,j,jj,ic,icell
real(kind=DP) :: ui,x
real(kind=DP), allocatable :: cmat(:,:) !dim(nc,nc)
real(kind=DP), allocatable :: fvec(:) !dim(nc)

if(sw_polynomial_fit == ON) then
  nc = norder*2+1
  allocate(cmat(nc,nc)); cmat = 0.d0
  allocate(fvec(nc))
  cmat(1:nc,1) = 1.d0
  ind = 1
  do is = -norder,norder
    if(is==0) cycle
    ind=ind+1
    x = u/dble(is)
    do i=2,nc
       cmat(ind,i) = x**(i-1)
    end do
  end do
  do ic=1,nlpnt
     do j=1,nmodes
        jj = nmodes*(ic-1)+j
        do i=1,nmodes
           fvec(1) = force0(jj)
           fvec(2:nc) = forces(jj,i,1:nc-1)
           force_const_mat(i,j,ic) = -polyfit_diff(nc,cmat,fvec)
        end do
     end do
  end do
else
  ui=dble(norder)/u
  if(printable .and. ipriphonon>=2) then
     write(nfout,*) 'u=',u
     write(nfout,*) 'ui= norder/u =',ui
  endif
  if(norder == 1) then
    ui = -0.5d0*ui
    do ic=1,nlpnt
       do j=1,nmodes
          jj = nmodes*(ic-1)+j
          do i=1,nmodes
             force_const_mat(i,j,ic) = (forces(jj,i,2)-forces(jj,i,1))*ui
          end do
       end do
    end do
  else if(norder == 2) then
    ui = -ui/12.d0
    do ic=1,nlpnt
       do j=1,nmodes
          jj = nmodes*(ic-1)+j
          do i=1,nmodes
             force_const_mat(i,j,ic) = (-8.d0*forces(jj,i,1)+forces(jj,i,2) &
                             &  -forces(jj,i,3)+8.d0*forces(jj,i,4))*ui
          end do
       end do
    end do
  else
    stop 'Your inputed norder is not supported for the differencial approximation.'
  end if
end if

contains

function polyfit_diff(nd,mat,vec)
implicit none

real(kind=DP) :: polyfit_diff

integer, intent(in) :: nd
real(kind=DP), intent(in) :: mat(nd,nd)
real(kind=DP), intent(in) :: vec(nd)

! local variables
integer :: ipiv(nd),info,i
real(kind=DP) :: a(nd,nd),b(nd)
real(kind=DP) :: x0,df
real(kind=DP) :: xold
real(kind=DP) :: eps = 1.d-10

real(kind=DP) :: ux

! debug
!  write(nfout,*) '<<polyfit_diff>>'
!  call flush(nfout)
! end debug

a = mat
b = vec

!debug
!do i=1,nd
!  write(nfout,*) 'a=',a(i,1:nd)
!end do
!do i=1,nd
!  write(nfout,*) 'b=',b(i)
!end do
!  call flush(nfout)
!end debug

call dgesv(nd,1,a,nd,ipiv,b,nd,info)
if(info .ne. 0 ) then
   if(printable) write(nfout,*) 'LAPACK routine DGETRS failure: info=',info
  stop 'LAPACK routine DGETRS failure'
end if
! debug
!  do i=1,nd
!    print *,'i=',i,' b=',b(i)
!  end do
!  write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(1),polyfunc(nd,b,0.d0)
!  i=0
!  do is=-norder,norder
!    if(is==0) cycle
!    i=i+1
!    ux = u/dble(is) 
!    write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(i+1),polyfunc(nd,b,ux)
!  end do
!  call flush(nfout)
! end debug

x0 = 0.d0
df = diff_polyfunc(nd,b,x0)
  ! debug
  !print *,'df=',df
  ! end debug
polyfit_diff = df

end function polyfit_diff

function polyfunc(nd,b,x)
implicit none

real(kind=DP) :: polyfunc

integer, intent(in) :: nd
real(kind=DP), intent(in) :: b(nd),x

integer :: i
real(kind=DP) :: f

f = b(1)
do i=2,nd
  f = f + b(i)*x**(i-1)
end do
polyfunc = f

end function polyfunc

function diff_polyfunc(nd,b,x)
implicit none

real(kind=DP) :: diff_polyfunc

integer, intent(in) :: nd
real(kind=DP), intent(in) :: b(nd),x

integer :: i
real(kind=DP) :: df

df = b(2)
do i=3,nd
  df = df + b(i)*dble(i-1)*x**(i-2)
end do
diff_polyfunc = df

end function diff_polyfunc

end subroutine m_Phonon_force_constant_matrix


subroutine m_Phonon_calc_vib_modes()
implicit none

! local variables
integer :: i,j
!!$real(DP) :: eps=1.d-8
real(DP) :: eps=1.d-16
real(DP) :: norm

allocate(omega(nmodes,nqvec),modes(nmodes,nmodes,nqvec))

write(nfout,*) 'calc_vib_modes is started.'

do j=1,nqvec
   write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') j,qvin(j,1:3)
   call solve_eigenproblem(dynmatq(1,1,j) ,omega(1,j),modes(1,1,j))
   do i=1,nmodes
      if(ipriphonon>=2) &
      & write(nfout,*) 'omega**2 = ',omega(i,j)  
      if(abs(omega(i,j)) < eps) omega(i,j)=0.d0
      if(omega(i,j) > 0.d0) then
         omega(i,j)=sqrt(omega(i,j))
      else
         omega(i,j)=-sqrt(abs(omega(i,j))) ! for the soft mode
      end if 
      if(ipriphonon >=2) &
       & write(nfout,*) '==> omega = ',omega(i,j)  
   end do
end do

deallocate(dynmatq)

contains
  subroutine solve_eigenproblem(dynmat,omega,modes)
    complex(kind=DP), intent(inout) :: dynmat(nmodes,nmodes)
    real(kind=DP), intent(out)      :: omega(nmodes)
    complex(kind=DP), intent(out)   :: modes(nmodes,nmodes)

    real(kind=DP) :: abstol
    integer :: lcwork,lrwork,liwork
    complex(kind=DP), allocatable :: cwork(:) ! dim(lcwork)
    real(kind=DP), allocatable :: rwork(:) ! dim(lrwork)
    integer, allocatable :: iwork(:) ! dim(liwork)
    integer, allocatable :: ifail(:) ! dim(nmodes)
    integer :: info
    integer :: m
    integer :: il,iu
    real(DP) :: vl,vu

    real(DP), external :: dlamch

    abstol=2*dlamch('S')
    !abstol=4.45014771701440D-308
    !print *,'abstol=',abstol
    !!$lwork=8*nmodes
    lcwork=4*nmodes
    lrwork=7*nmodes
    liwork=5*nmodes
    !!$allocate(work(lwork))
    allocate(cwork(lcwork))
    allocate(rwork(lrwork))
    allocate(iwork(liwork),ifail(nmodes))
    lcwork=-1
    call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
     &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
    !!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
    !!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
    !!$ &      ifail,info)
    lcwork = cwork(1)
    !print *,'lwork=',lwork
    !print *,'info=',info
    deallocate(cwork)
    allocate(cwork(lcwork))
    call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
     &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
    !!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
    !!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
    !!$ &      ifail,info)
    !print *,'info=',info
    !print *,'ifail=',ifail(1:nmodes)
    deallocate(cwork,rwork,iwork,ifail)
  end subroutine solve_eigenproblem
end subroutine m_Phonon_calc_vib_modes

subroutine m_Phonon_det_irr_rep()
use m_Representation, only : get_irr_rep
use m_Crystal_Structure, only : nopr
implicit none

! local variabes
integer :: i,j,ia,ja,ist,n
real(DP) :: norm
real(DP) :: eir(3),ejr(3),xir(1:nmodes)
real(DP) :: eii(3),eji(3),xii(1:nmodes)
integer :: nrep,nsym
integer :: rep(48,12)
character(len=3) :: symbol_irrep(12)
character(len=4) :: active_rep(12)
real(DP) :: eps = 1.d-1
integer :: iq

write(nfout,*) '** Representation **'

allocate(mode_irr_rep(nmodes,nqvec))
allocate(mode_active(nmodes,nqvec))
do iq=1,nqvec
   write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
   call get_irr_rep(point_group(iq),nsym,nrep,rep,symbol_irrep,active_rep)

   if(printable)  then
      write(nfout,'("Character table:",a3)') point_group(iq)
      do j=1,nrep
         write(nfout,'(a3,1x,48i3)') symbol_irrep(j), rep(1:nsym,j)
      end do 
   end if
! debug
!write(nfout,'("Product table:",a3)') point_group
!do j=1,nrep
!  write(nfout,'(a3,1x,48i3)') symbol_irrep(j),(sum(rep(1:nopr,j)*rep(1:nopr,i)),i=1,nrep)
!end do
! end debug


   do i=1,nmodes
! debug
!        write(nfout,*) 'index of the mode =',i
!        write(nfout,*) 'norm =',sum(dble(modes(1:nmodes,i,iq))**2+dimag(modes(1:nmodes,i,iq))**2)
! end debug
      mode_irr_rep(i,iq)='NON'
      Representation: do j=1,nrep
         xir(1:nmodes)=0.d0
         xii(1:nmodes)=0.d0
         do n=1,nopr
            do ia=1,natm
               ist = 3*(ia-1)+1
               eir(1:3) = dble(modes(ist:ist+2,i,iq))
               eii(1:3) = dimag(modes(ist:ist+2,i,iq))
               call rotate_eigenvector(n,ia,ja,eir,ejr)
               call rotate_eigenvector(n,ia,ja,eii,eji)
               ist = 3*(ja-1)+1
               xir(ist:ist+2)=xir(ist:ist+2)+rep(n,j)*ejr(1:3)
               xii(ist:ist+2)=xii(ist:ist+2)+rep(n,j)*eji(1:3)
! debug
!        write(nfout,*) 'j =',j
!        write(nfout,*) 'n =',n
!        write(nfout,*) 'ia=',ia
!        write(nfout,*) 'eir=',eir(1:3)
!        write(nfout,*) 'eii=',eii(1:3)
!        write(nfout,*) 'ja=',ja
!        write(nfout,*) 'ejr=',ejr(1:3)
!        write(nfout,*) 'eji=',eji(1:3)
! end debug
            end do 
         end do
         !xi(1:nmodes) = xi(1:nmodes)/nopr 
         norm = sum(xir(1:nmodes)**2+xii(1:nmodes)**2)
         ! debug
         !write(nfout,*) 'j=',j,' norm=',norm
         ! end debug
         if(norm > eps) then
            mode_irr_rep(i,iq)= symbol_irrep(j)
            mode_active(i,iq) = active_rep(j)
            ! exit Representation
         end if
      end do Representation
      if(printable) write(nfout,'(1x,i5,1x,a3,1x,a4)') i,mode_irr_rep(i,iq),mode_active(i,iq)
   end do
end do ! q loop

contains

  subroutine rotate_eigenvector(n,ia,ja,ei,ej)
  use m_Ionic_System, only : napt
  use m_Crystal_Structure, only : op
  integer, intent(in) :: n, ia
  integer, intent(out) :: ja
  real(kind=DP), intent(in) :: ei(3)
  real(kind=DP), intent(out) :: ej(3)
  
  ! local variables
  integer :: i

  ja = napt(ia,n)
 
  do i=1,3
    ej(i) = sum(op(i,1:3,n)*ei(1:3))
  end do
 
  end subroutine rotate_eigenvector

end subroutine m_Phonon_det_irr_rep


subroutine m_Phonon_calc_static_dielectric()
use m_Crystal_Structure, only : univol
implicit none

! local variables
integer :: im,i,na,ia,j
real(DP) :: zsum
real(DP) :: coef

if(sw_lo_to_splitting == ON) return
if(nqvec/=1) return

allocate(zeff_mode(3,nmodes))
do im=1,nmodes
  do i=1,3
    zsum = 0.d0
    j=0
    do na=1,natm
      do ia=1,3
        j=j+1
        zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
      end do
    end do
    zeff_mode(i,im) = zsum
  end do
end do 

coef = 16.d0*atan(1.d0)/univol
lattice_dielectric(1:3,1:3) = 0.d0
do im=1,nmodes
  if(omega(im,nqvec)>1.d-10) then
    do j=1,3
      do i=1,3
         lattice_dielectric(i,j) = lattice_dielectric(i,j) +  &
          & zeff_mode(i,im)*zeff_mode(j,im)/omega(im,nqvec)**2
      end do
    end do
    if(printable) write(nfout,'("im=",i4,1x,a3,1x,a4,2(1x,f25.10))')  &
         &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
         & ,omega(im,nqvec)*27.211383411/1.23984185d-4 &
         & ,coef*sum(zeff_mode(1:3,im)**2)/omega(im,nqvec)**2
  end if
end do
lattice_dielectric(1:3,1:3) = coef*lattice_dielectric(1:3,1:3)

static_dielectric(1:3,1:3) =  &
  & lattice_dielectric(1:3,1:3) + dielectric(1:3,1:3)

end subroutine m_Phonon_calc_static_dielectric


subroutine m_Phonon_write_vib_modes()
use m_Files, only : m_Files_open_nfmode, nfmode
use m_Ionic_System, only : cps
use m_Crystal_Structure, only : altv
implicit none

! local variabes
real(DP), parameter :: amu = 1822.88847974 ! 1 amu = 1822.88847974 Me
real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
integer :: i,j,istart,iq
real(DP) :: omega_ev,omega_cm 
real(DP) :: zamu(3),znorm
real(DP) :: x,hbarW,free_e

call  m_Files_open_nfmode()

if(mype /= 0) return

write(nfmode,'(1x,"--- primitive lattice vectors ---")') 
do i=1,3
  write(nfmode,'(1x,3(f14.10,1x))') altv(1:3,i)
end do
write(nfmode,'(1x,"--- Equilibrium position and mass of each atom---")') 
write(nfmode,'(1x,"Natom=",i5)') natm
do i=1,natm
  write(nfmode,'(1x,i5,3(1x,f14.10),1x,f14.5,1x,a4)') &
  &                      i,cps(i,1:3),ionic_mass(i),speciesname(ityp(i))
end do
write(nfmode,'(1x,"--- Vibrational modes ---")') 
if(phonon_method == PHONON_GAMMA) then
   write(nfmode,'(1x,"Nmode=",i5," Natom=",i5)') nmodes,natm
else
   write(nfmode,'(1x,"Nmode=",i5," Natom=",i5," Nqvec",i5)') nmodes,natm,nqvec
end if
if(phonon_method==PHONON_DOS .and. way_of_smearing==FERMI_DIRAC) free_e=0.d0
do iq=1,nqvec
   if(phonon_method == PHONON_DOS) then
      write(nfmode,'(1x,"iq=",i5," q=(",f10.5,",",f10.5,",",f10.5,") (",f10.5,",",f10.5,",",f10.5,")",1x,f15.10)') &
    & iq,qvin(iq,1:3),qvec(iq,1:3),wght(iq)
   else if(phonon_method /= PHONON_GAMMA) then
      write(nfmode,'(1x,"iq=",i5," q=(",f10.5,",",f10.5,",",f10.5,") (",f10.5,",",f10.5,",",f10.5,")")') &
    & iq,qvin(iq,1:3),qvec(iq,1:3)
   end if
   do i=1,nmodes
      omega_ev = omega(i,iq)*ha2ev
      omega_cm = omega_ev*ev2cminv 
      write(nfmode,'(1x,"n= ",i5,1x,a3,1x,a4, &
   &                  /5x,"hbarW= ",e15.8," Ha = ",e15.8," eV; nu= ",e15.8," cm^-1")') &
   &                  i,mode_irr_rep(i,iq),mode_active(i,iq),omega(i,iq),omega_ev,omega_cm
      do j=1,natm
         istart = 3*(j-1)+1
         write(nfmode,'(1x,i5,1x,3f14.10)') j,dble(modes(istart:istart+2,i,iq))
      end do
      if(nqvec>1) then
         do j=1,natm
            istart = 3*(j-1)+1
            write(nfmode,'(1x,i5,1x,3f14.10)') j,dimag(modes(istart:istart+2,i,iq))
         end do
      end if
      if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
         write(nfmode,'(3x,"Mode effective charge and its norm:")')
         zamu(1:3)=zeff_mode(1:3,i)*sqrt(amu)
         znorm = sqrt(sum(zamu(1:3)**2)) 
         write(nfmode,'(3x,"Z=",3(f14.10,1x),"Norm=",f14.10)') zamu(1:3),znorm
      end if
      if(phonon_method == PHONON_DOS.and.way_of_smearing==FERMI_DIRAC)then
          hbarW = omega(i,iq)
          x = hbarW/width
          if(x.gt.1.d-10) free_e = free_e + wght(iq)*(0.5d0*hbarW+width*log(1.d0-exp(-x)))
      endif
   end do
end do
if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
  write(nfmode,'(1x,"--- Lattice and static dielectric tensors ---")') 
  do i=1,3
    write(nfmode,'(1x,"[",3(1x,f10.4)," ]",2x,"[",3(1x,f10.4)," ]")') &
      & lattice_dielectric(i,1:3), static_dielectric(i,1:3)
  end do
end if
if(way_of_smearing==FERMI_DIRAC.and.phonon_method==PHONON_DOS.and.printable)then
   write(nfout,'(a,f15.10,a)') '!** Free energy due to lattice vibration : ',free_e,' hartree/cell'
endif

return
end subroutine m_Phonon_write_vib_modes

subroutine m_Phonon_write_epsilon()
use m_Crystal_Structure, only : univol
use m_Files, only : m_Files_open_nfepsilon, nfepsilon
implicit none

! local variables
real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
integer :: n,im,i,j
real(kind=DP) :: e,de,e2,e3,e4
real(kind=DP) :: coef
real(kind=DP) :: epsilon(3,3,2,0:num_division)

if(nqvec /= 1) return

coef = 16.d0*atan(1.d0)/univol
de = (max_energy-min_energy)/num_division

do n=0,num_division
  e = min_energy + de * n
  epsilon(1:3,1:3,1:2,n) = 0.d0
  do im=1,nmodes
    if(omega(im,nqvec)>1.d-5) then
      e2 = omega(im,nqvec)**2-e**2
      e3 = e*omega(im,nqvec)*damping_factor
      e4 = e2**2+e3**2
      if(abs(damping_factor) < 1.d-10) then
      if(abs(omega(im,nqvec)-e) < 1.d-10) then
        if(e2 > 0.d0) then
          e2 = 1.d-10   
        else
          e2 = -1.d-10
        end if
      end if
      do j=1,3
        do i=1,j
          epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)/e2
          epsilon(i,j,2,n) = 0.d0
        end do
      end do
      else
        do j=1,3
          do i=1,j
            epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)*e2/e4
            epsilon(i,j,2,n) = epsilon(i,j,2,n) + zeff_mode(i,im)*zeff_mode(j,im)*e3/e4
          end do
        end do
      end if
    end if
  end do
  epsilon(1:3,1:3,1,n)=dielectric(1:3,1:3)+coef*epsilon(1:3,1:3,1,n)
  epsilon(1:3,1:3,2,n)=coef*epsilon(1:3,1:3,2,n)
end do

call m_Files_open_nfepsilon()
if(mype /= 0) return
write(nfepsilon,'("Energy(eV) E1xx E1yy E1zz E1yz E1zx E1xy E2xx E2yy E2zz E2yz E2zx E2xy")')
do n=0,num_division
  e = (min_energy + de * n) * ha2ev
  write(nfepsilon,'(13(1x,e25.10))') &
  & e, ((epsilon(i,i,j,n),i=1,3),epsilon(2,3,j,n),epsilon(1,3,j,n),epsilon(1,2,j,n),j=1,2)
end do

end subroutine m_Phonon_write_epsilon

subroutine m_Phonon_set_supercell
  use m_Crystal_Structure, only: m_CS_supercell_on
  integer :: n1,n2,n3
  n1 = nlat(1)
  n2 = nlat(2)
  n3 = nlat(3)
  if(n1==0.and.n2==0.and.n3==0) then
     n1 = 1; n2 = 1; n3 = 1
     call m_CS_supercell_on(nfout,1,n1,n2,n3) ! 1: PRIMITIVE
  else
     call m_CS_supercell_on(nfout,0,n1,n2,n3) ! 0: BRAVAIS
  end if
end subroutine m_Phonon_set_supercell

subroutine m_Phonon_calc_dos()
  integer :: idim = 3
  integer :: iq,im,ie
  integer :: newin
  real(kind=DP) :: emin,emax
!  real(kind=DP), dimension(np2,nmodes) :: omega2
!  real(kind=DP), dimension(np0) :: eawk, cdwk, cswk
  real(kind=DP), allocatable, dimension(:,:) :: omega2 ! dim(np2,nmodes)            <ASMS>
  real(kind=DP), allocatable, dimension(:)   :: eawk, cdwk, cswk ! dim(np0)         <ASMS>
  real(kind=DP), allocatable, dimension(:,:,:) :: cdos,cind ! dim(np2,nmodes,0:newin)
  real(kind=DP), allocatable, dimension(:) :: e,dos,sumdos ! dim(0:newin)

  allocate(omega2(np2,nmodes))                     ! <ASMS>
  allocate(eawk(np0),cdwk(np0),cswk(np0))          ! <ASMS>
  eawk=0.d0
  cdwk=0.d0
  cswk=0.d0

  do iq=1,np2
     do im=1,nmodes 
        omega2(iq,im) = omega(im,iq) * 1.0d3
     end do
  end do

  emin = minval(omega2) - 0.0005 ! (mhartree)
  emax = maxval(omega2) + 0.0005 ! (mhartree)
  newin = (emax - emin)/(DeltaE_dos*1.0d3) + 1
  
  allocate(cdos(np2,nmodes,0:newin)); cdos = 0.d0
  allocate(cind(np2,nmodes,0:newin)); cind = 0.d0

  allocate(e(0:newin))
  allocate(dos(0:newin)); dos=0.d0
  allocate(sumdos(0:newin)); sumdos=0.d0
  e(0:newin) = (/(emin + (DeltaE_dos*1.0d3)*ie,ie=0,newin)/)

  call nstt3i(idim,newin,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
          &  ,np2,np2,nmodes,omega2 &
          &  ,ip20,np0,eawk,cdwk,cswk,np2,nmodes,cdos,cind,width_tetra )

  do iq=1,np2
     do im=1,nmodes
        do ie=0,newin
           dos(ie)    = dos(ie)    + cdos(iq,im,ie)
           sumdos(ie) = sumdos(ie) + cind(iq,im,ie)
        end do
     end do
  end do
  deallocate(cdos)
  deallocate(cind)

  call write_dos(newin,e,dos,sumdos)

  deallocate(e)
  deallocate(dos)
  deallocate(sumdos)
contains

  subroutine write_dos(newin,e,dos,sumdos)
    use m_Files, only : m_Files_open_nfphdos, nfphdos
    integer, intent(in) :: newin
    real(kind=DP), intent(in) :: e(0:newin), dos(0:newin), sumdos(0:newin)
    integer :: ie
    real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
    real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
    real(DP) :: eev, ecminv, dosev, doscminv

    if(mype /= 0) return
    call m_Files_open_nfphdos()

    write(nfphdos,'("# Index Omega(mHa) Omega(eV) Omega(cm-1) DOS(States/Ha) DOS(States/eV) DOS(States/cm-1) IntDOS(States)")') 
    do ie = 0, newin
       eev = e(ie)*ha2ev/1.0d3  ! Hartree
       ecminv = eev*ev2cminv
       dosev = dos(ie)/ha2ev*1.0d3 ! Hartree
       doscminv = dosev/ev2cminv
       write(nfphdos,'(i7,7(1x,f15.8))') ie,e(ie), eev, ecminv, dos(ie), dosev, doscminv, sumdos(ie)
    end do
  end subroutine write_dos
end subroutine m_Phonon_calc_dos

subroutine m_Phonon_read_strain_forces
  use m_Files, only : nfout, nfstrfrc, m_Files_open_nfstrfrc
  integer :: i, ia, num_force, istr, ipm
  real(kind=DP) :: str, force(3,natm,6,2), strain(6,2), eps(3,3)
  logical :: present(6)

  strain = 0.d0
  present = .false.

  allocate(strfrc(3,natm,6))
  strfrc = 0.d0

  call m_Files_open_nfstrfrc()
  read(nfstrfrc,*) num_force
  do i=1,num_force
     read(nfstrfrc,*) istr, str
     if(str>0.d0) then
	ipm = 1
     else
	ipm = 2
     end if
     strain(istr,ipm) = str
     do ia=1,natm
        read(nfstrfrc,*) force(1:3,ia,istr,ipm)
     end do
  end do
  
  do istr=1,6
     if(strain(istr,1) > 1.d-8 .and. strain(istr,2) < -1.d-8 &
       & .and. abs(abs(strain(istr,1))-abs(strain(istr,2))) < 1.d-10) then
	present(istr) = .true.
     end if
  end do

  write(nfout,*) 'present strain : ',present

  do istr=1,6
     if(.not.present(istr)) cycle
     str = strain(istr,1)-strain(istr,2)
     eps = 0.d0
     if(istr==1) then
       eps(1,1) = 0.5d0
     else if(istr==2) then
       eps(2,2) = 0.5d0
     else if(istr==3) then
       eps(3,3) = 0.5d0
     else if(istr==4) then
       eps(2,3) = 0.25d0
       eps(3,2) = 0.25d0
     else if(istr==5) then
       eps(3,1) = 0.25d0
       eps(1,3) = 0.25d0
     else if(istr==6) then
       eps(1,2) = 0.25d0
       eps(2,1) = 0.25d0
     end if
     do ia=1,natm
        strfrc(1:3,ia,istr) = (force(1:3,ia,istr,1)-force(1:3,ia,istr,2))/str &
                          & + matmul(eps,force(1:3,ia,istr,1)+force(1:3,ia,istr,2))
     end do
  end do

  write(nfout,*) '=== Strain-force coupling constants ==='
  do istr=1,6
     if(.not.present(istr)) cycle
     write(nfout,'("Strain : ",i1)') istr
     do ia=1,natm
	Write(nfout,'(i5,3(1x,f15.5))') ia,strfrc(1:3,ia,istr)
     end do
  end do

end subroutine m_Phonon_read_strain_forces


subroutine m_Phonon_calc_int_strain_piezo
use m_Crystal_Structure, only : univol
implicit none

! local variables
integer :: im,i,na,ia,j
real(DP) :: zsum,csum
real(DP) :: coef

if(sw_lo_to_splitting == ON) return
if(nqvec/=1) return

allocate(zeff_mode(3,nmodes))
allocate(strphcpl(6,nmodes))
do im=1,nmodes
  do i=1,3
    zsum = 0.d0
    j=0
    do na=1,natm
      do ia=1,3
        j=j+1
        zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
      end do
    end do
    zeff_mode(i,im) = zsum
  end do
  do i=1,6
    csum = 0.d0
    j=0
    do na=1,natm
      do ia=1,3
        j=j+1
        csum = csum + strfrc(ia,na,i)*dble(modes(j,im,nqvec))*msqinv(j)
      end do
    end do
    strphcpl(i,im) = csum
  end do
end do 

coef = 1.d0/univol
piezoelectric(1:3,1:6) = 0.d0
do j=1,6
  do i=1,3
    write(nfout,'("Direction:",i1," Strain:",i1)') i,j
    do im=1,nmodes
      if(omega(im,nqvec)>1.d-10) then
         piezoelectric(i,j) = piezoelectric(i,j) +  &
          & zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
         if(printable) write(nfout,'("im=",i4,1x,a3,1x,a4,3(1x,f25.10))')  &
         &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
         & ,omega(im,nqvec)*27.211383411/1.23984185d-4 &
         & ,coef*zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
      end if
    end do
  end do
end do
piezoelectric(1:3,1:6) = coef*piezoelectric(1:3,1:6)

if(printable) then
  write(nfout,*) '=== Internal-strain piezoelectric tensor (a.u.) ==='
  do j=1,6
    write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)
  end do
  write(nfout,*) '=== Internal-strain piezoelectric tensor (C/m^2) ==='
  do j=1,6
    write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)*UNIT_PIEZO_CONST
  end do
end if

end subroutine m_Phonon_calc_int_strain_piezo

end module m_Phonon

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: forcaf2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: b_Force_f77.F 409 2014-10-27 09:24:52Z jkoga $
      subroutine forcaf2
     >     (katm,katm2,kopr,natm,nopr,napt,iwei,op,ipri,af
     =     ,fnlxyz_l
     w     ,forc_up,forc_dn )
c $Id: b_Force_f77.F 409 2014-10-27 09:24:52Z jkoga $
c The forces of the down-spin are calculated by operating
c the anti-ferromagnetic operation to those of the up-spin.
c This subroutine is called from vnlsum.
c
c antiferromagnetic calculation is added on 9th Jul. 1996
c                                          by H.Sawada
C**********************************************************************
      implicit none

#ifdef VPP
#ifdef PARA
      include 'nproc.inc'
!xocl processor pe(npe)
!xocl subprocessor pes(npe)=pe(1:npe)
      include 'inddef_p.inc'
#endif
#endif
      integer katm,katm2,natm,kopr,nopr,iopr
     &     ,iwei(katm),napt(katm,kopr)
      integer ipri,af
      integer ia,mm,nap, j
      real*8 op(3,3,kopr)
     w     ,forc_up(katm2,3),forc_dn(katm2,3),px,py,pz
c
#ifdef PARA
      real*8 fnlxyz_l(katm_p,3)
!xocl local fnlxyz_l(/ind_katm,:)
#else
      real*8 fnlxyz_l(katm,3)
#endif

      if(ipri.ge.2) then
         print *, ' forces only for up-spin (vnlsum)'
         do 610 ia = 1, natm
!xocl spread do/ind_katm
!xocl index ia
         print '(" ia=",i3,3d15.7)',ia,(fnlxyz_l(ia,j),j=1,3)
!xocl end spread
 610     continue
      endif

      do 620 ia = 1, katm2
      forc_up(ia,1)=0.d0
      forc_up(ia,2)=0.d0
      forc_up(ia,3)=0.d0
 620  continue

!xocl spread do/ind_katm
      do 500 ia = 1, natm
      do j = 1, 3
      forc_up(ia,j) = fnlxyz_l(ia,j)
      enddo
 500  continue
!xocl end spread sum(forc_up)

      mm=0
      do 300 ia = 1, natm
      if (iwei(ia).eq.2) then
         mm=mm+1
         forc_up(natm+mm,1) = - forc_up(ia,1)
         forc_up(natm+mm,2) = - forc_up(ia,2)
         forc_up(natm+mm,3) = - forc_up(ia,3)
      end if
 300  continue

      iopr = nopr +af
      do 100 ia = 1, natm
      nap = napt(ia,iopr)
      px = forc_up(nap,1)
      py = forc_up(nap,2)
      pz = forc_up(nap,3)
      forc_dn(ia,1) = op(1,1,iopr)*px+op(2,1,iopr)*py+op(3,1,iopr)*pz
      forc_dn(ia,2) = op(1,2,iopr)*px+op(2,2,iopr)*py+op(3,2,iopr)*pz
      forc_dn(ia,3) = op(1,3,iopr)*px+op(2,3,iopr)*py+op(3,3,iopr)*pz
 100  continue

!xocl spread do/ind_katm
      do 400 ia = 1, natm
      do j = 1, 3
      fnlxyz_l(ia,j) = fnlxyz_l(ia,j) + forc_dn(ia,j)
      enddo
 400  continue
!xocl end spread

      if(ipri.ge.2) then
         print *, ' forces for up- and down-spin (vnlsum)'
         do 600 ia = 1, natm
!xocl spread do/ind_katm
!xocl index ia
         print '(" ia=",i3,3d15.7)',ia,(fnlxyz_l(ia,j),j=1,3)
!xocl end spread
 600     continue
      endif

      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 412 $)
!
!  SUBROUINE: ChargeDensity_Mixing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine WriteDownData_onto_Files(final_call)
! $Id: WriteDownData_onto_Files.F90 412 2014-11-30 12:02:22Z yamasaki $
  use m_Files,               only : m_Files_open_nfcntn,    m_Files_close_all &
       &                          , m_Files_open_nfstatus,  m_Files_skiptoend &
       &                          , m_Files_close_nfinp &
       &                          , m_Files_reopen_nfcntn,  m_Files_reopen_nfcntn_bin &
       &                          , m_Files_close_nfcntn &
       &                          , m_Files_open_nfvlc,     m_Files_open_nfcntn_bin_paw &
       &                          , m_Files_reopen_nfzaj,   m_Files_reopen_nfchgt &
       &                          , m_Files_open_nfefermi,  m_Files_close_nfefermi &
       &                          , m_Files_open_nfPsicoef, m_Files_close_nfPsicoef &
       &                          , m_Files_open_nfBandSymInput, m_Files_close_nfBandSymInput &
       &                          , m_Files_open_nfeng,     m_Files_close_nfeng &
       &                          , nfstatus, F_ZAJ_partitioned, F_CHGT_partitioned &
       &                          , F_ZAJ_in_partitioned, F_CHGT_in_partitioned & 
       &                          , F_CNTN_BIN_partitioned, F_CNTN_BIN_in_partitioned &
#ifdef _EMPIRICAL_
       &                     ,nfcntn,nfout
#else 
       &                     ,nfcntn,nfchgt,nfzaj,nfpsicoef,nfbandsyminput,nfeng &
       &                     ,nfcntn_bin,nfout,nfvlc,nfefermi  &
       &                     ,nfcntn_bin_paw
#endif
  use m_Const_Parameters,    only: T_CONTROL, BLUEMOON, QUENCHED_CONSTRAINT &
       &                         , ON,OFF,YES,NO,FORCE_CONVERGED, Valence_plus_PC_Charge &
       &                         , VXC_AND_EXC, FINISH, INITIAL, EK_CONVERGED &
       &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ONE_BY_ONE, EK &
       &                         , DRIVER_CONSTRAINT, BFGS, GDIIS, ALL_AT_ONCE, GRID
  use m_IterationNumbers,    only: m_Iter_wd_iteration_numbers &
       &                         , iteration, iteration_ionic, iteration_electronic
  use m_Timing,              only: tstatc_wd0, m_Timing_wd_status
  use m_Ionic_System,        only: m_IS_wd_pos_and_v, m_IS_wd_forcp_etc &
       &                         , m_IS_wd_nrsv,      m_IS_wd_cps, m_IS_wd_diis_history &
       &                         , m_IS_natm_can_change, m_IS_wd_curr_atom_reservoir
  use m_Total_Energy,        only: m_TE_wd_total_energy
  use m_Control_Parameters, only : imdalg,iconvergence_previous_job &
       &                         , continuation_using_ppdata &
       &                         , driver &
       &                         , m_CtrlP_wd_cpu_total &
       &                         , m_CtrlP_wd_iconvergence &
       &                         , m_CtrlP_wd_edelta_ontheway &
       &                         , m_CtrlP_set_corecharge_cntnbin &
       &                         , m_CtrlP_wd_corecharge_cntnbin &
#ifndef _EMPIRICAL_
       &                         , sw_ekzaj, sw_hubbard, sw_positron &
       &                         , m_CtrlP_wd_neg &
       &                         , sw_rttddft,iconvergence &
#endif
       &                         , iprijobstatus, jobstatus_series, jobstatus_format &
       &                         , icond &
       &                         , sw_optimize_lattice, ipricoefwf, sw_band_symmetry_analysis
#ifndef _EMPIRICAL_
  use m_IterationNumbers,    only: m_Iter_wd_iters_and_nk
  use m_Control_Parameters,  only: sw_fine_STM_simulation, fixed_charge_k_parallel &
       &                         , m_CtrlP_wd_isolver &
       &                         , m_CtrlP_wd_iconv_ek
  use m_Kpoints,             only: kv3, kv3_ek, m_Kp_wd_kv3, m_Kp_wd_BandSymInput
  use m_PseudoPotential,     only: flg_paw,m_PP_wd_PAW_parameters
  use m_NonLocal_Potential,  only: m_NLP_wd_snl_3D
  use m_PseudoPotential,     only: m_PP_wd_PP_parameters_3D
  use m_ES_IO,               only: m_ESIO_wd_EigenValues, m_ESIO_wd_EigenValues_etc &
       &                         , m_ESIO_wd_Efermi
  use m_ES_IO,               only: m_ESIO_wd_WFs_3D
!!$       &                         , m_ESIO_wd_WFs_dp_3D &  ! write file DP test
  use m_Electronic_Structure,only: iconv_ek, vbm, efermi, metalic_system, check_if_metalic_flag
  use m_Charge_Density,      only: m_CD_wd_hsr
  use m_Charge_Density,      only: m_CD_wd_chgq
  use m_Orbital_Population,  only: m_OP_wd_occ_mat
  use m_PlaneWaveBasisSet,   only: kgp
  use m_PAW_ChargeDensity,   only: m_PAWCD_wd_cd
  use m_Crystal_Structure,   only: m_CS_wd_fix_spin_status, m_CS_wd_BandSymInput
#endif
  use m_Parallelization,     only: mype, npes, conf_para,  mpi_comm_group
  use m_Parallelization,     only: m_Parallel_wd_npes_etc_3D
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters,  only: m_CtrlP_wd_dtim_previous
! ==============================================================================

  use m_Control_Parameters,   only : noncol, ndim_spinor, num_extra_bands, neg, nspin, ekmode &
       &                           , neg_is_enlarged

  use m_ES_occup,             only: m_ESoc_check_num_bands, m_ESoc_check_if_metalic
! === Restart with phase ek-mode is supported. by tkato 2014/01/23 =============
  use m_Control_Parameters,  only : m_CtrlP_wd_numk_zajsaved
  use m_IterationNumbers,    only : nk_in_the_process
! ==============================================================================
! ======================================= added by K. Tagami ============ 11.0
  use m_Control_Parameters,   only :  noncol
!  use m_Charge_Density,       only : m_CD_wd_chgq_noncl
  use m_Orbital_Population,   only: m_OP_wd_occ_mat_noncl
! ======================================================================== 11.0

  implicit none
  logical,intent(in),optional :: final_call
  logical :: final_c = .true.
  integer :: status_wdmode

  integer :: mpi_err
  integer :: sw_wd_Psi_coef = OFF
! === Restart with phase ek-mode is supported. by tkato 2014/01/23 =============
  integer :: numk_zajsaved
! ==============================================================================

#ifndef _EMPIRICAL_
  logical :: ChargeDensity_is_Converged
#endif

  include 'mpif.h'                                      ! MPI

! === An IF BLOCK STRUCTURE ===
!=  if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
!=       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
!=     if(iconvergence_previous_job < EK_CONVERGED) then
!=        ....
!=     else
!=         write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
!=     end if
!=  else
!=     if(iconvergence_previous_job < FORCE_CONVERGED .or. sw_rttddft == ON) then
!=        ....
!=     else
!=        if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL) then
!=           ....
!=        end if
!=        if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL) then
!=           ....
!=        end if
!=        ....
!=     end if
!=  end if

  if (present(final_call)) final_c = final_call
#ifndef _EMPIRICAL_
  if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
     if(iconvergence_previous_job < EK_CONVERGED) then
        call m_Files_open_nfcntn
        if(mype == 0) rewind nfcntn
        call m_Iter_wd_iters_and_nk(nfcntn)
        call m_Parallel_wd_npes_etc_3D(nfcntn)
        call m_Kp_wd_kv3(nfcntn)
        call m_CtrlP_wd_iconvergence(nfcntn)
        call m_CtrlP_wd_iconv_ek(kv3_ek,iconv_ek,nfcntn)
     else
        write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
     end if
  else
#endif
!  if(iconvergence_previous_job < FORCE_CONVERGED) then
  if(iconvergence_previous_job < FORCE_CONVERGED .or. sw_rttddft == ON) then
     if(sw_rttddft == ON .and. iconvergence_previous_job>=FORCE_CONVERGED) iconvergence=FORCE_CONVERGED
     if (.not.conf_para) then
       call m_Files_open_nfcntn                        ! -(m_Files)
     else
       call m_Files_reopen_nfcntn
     endif
     if(mype==0) rewind nfcntn
     call m_Iter_wd_iteration_numbers(nfcntn)
     call m_IS_wd_pos_and_v(nfcntn)
     call m_IS_wd_cps(nfout)
     call m_TE_wd_total_energy(nfcntn)
#ifndef _EMPIRICAL_
     call m_CtrlP_wd_isolver(nfcntn)
#endif
     if(imdalg == T_CONTROL .or. imdalg == BLUEMOON .or. &
          & imdalg == QUENCHED_CONSTRAINT) then
        if(imdalg /= QUENCHED_CONSTRAINT) &
             & call m_IS_wd_nrsv(nfcntn)
        call m_IS_wd_forcp_etc(imdalg,nfcntn)
     end if
     if(imdalg == BFGS .or. imdalg == GDIIS)then
        call m_IS_wd_diis_history(nfcntn)
     endif
     call m_CtrlP_wd_iconvergence(nfcntn)
     call m_CtrlP_wd_edelta_ontheway(nfcntn)
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
     call m_CtrlP_wd_dtim_previous(nfcntn)
! ==============================================================================
#ifndef _EMPIRICAL_
     call m_ESIO_wd_EigenValues(nfout,2,nooccupation=NO)
     call m_Files_open_nfeng(icond)
     if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
          & .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
!!$        if ( noncol ) then
        if(mype == 0) write(nfeng,'(" num_kpoints = ",i6)') kv3 /ndim_spinor
        if(neg_is_enlarged) then
           if(mype == 0) write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
        else
           if(mype == 0) write(nfeng,'(" num_bands   = ",i6)') neg
        end if
        if(mype == 0) write(nfeng,'(" nspin       = ",i6)') nspin / ndim_spinor
        if(m_ESoc_check_num_bands()) then
           call m_ESoc_check_if_metalic(nfout)
!!$           if(metalic_system .or. .not.check_if_metalic_flag) then
           if(metalic_system) then
              if(mype == 0) write(nfeng,'(" Fermi energy level = ",f10.6)') efermi
           else
!!$           write(nfeng,'(" The Highest occupied band energy = ",f10.6/)') vbm
              if(mype == 0) write(nfeng,'(" Valence band max   = ",f10.6)') vbm
           end if
        else
           if(mype == 0) write(nfeng,'(" Fermi energy level = unknown")')
        end if
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=NO)
     else
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=NO)
     end if
     call m_Files_close_nfeng()

     if(sw_positron == ON) then
        call m_CtrlP_set_corecharge_cntnbin(ON)
     else
        call m_CtrlP_set_corecharge_cntnbin(OFF)
     end if
     call m_CtrlP_wd_corecharge_cntnbin(nfcntn)
     call m_CtrlP_wd_neg(nfcntn)
     call m_CS_wd_fix_spin_status(nfcntn)
     call m_IS_wd_curr_atom_reservoir(nfcntn)

     call m_Files_reopen_nfcntn_bin()
!!$     call m_Files_open_nfcntn_bin
!!$     if(mype==0) rewind nfcntn_bin
     if(continuation_using_ppdata == YES) then
        call m_PP_wd_PP_parameters_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kgp)
        call m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
     end if
     call m_ESIO_wd_EigenValues_etc(nfcntn_bin,F_CNTN_BIN_partitioned,totch_flag=ON)

     if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL .or. conf_para) &
          & call m_Files_reopen_nfzaj()
     if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL .or. conf_para) &
          & call m_Files_reopen_nfchgt()

! ===================== added by K. Tagami ======================= 12.0Exp
     if ( (icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) .and. &
          &        fixed_charge_k_parallel /= ONE_BY_ONE ) then
        call m_Files_reopen_nfzaj()
     endif
! ================================================================ 12.0Exp

     if(sw_ekzaj == OFF) then
        call m_ESIO_wd_WFs_3D(nfout,nfzaj,F_ZAJ_partitioned)
     else
     end if


     if(flg_paw) then
        call m_Files_open_nfcntn_bin_paw
        if(mype==0) rewind nfcntn_bin_paw
        call m_PP_wd_PAW_parameters(nfout,nfcntn_bin_paw)
        call m_CD_wd_hsr(nfcntn_bin_paw)
        !!$call m_PAWCD_wd_cd(nfout)
     end if

     call m_CD_wd_chgq(nfchgt,F_CHGT_partitioned) ! write chgq_l


! ================================= modified by K. Tagami ============= 11.0
!     if(sw_hubbard == ON) call m_OP_wd_occ_mat(nfout) ! write occupation matrix
!
     if(sw_hubbard == ON) then
        if ( noncol ) then
           call m_OP_wd_occ_mat_noncl(nfout)
        else
           call m_OP_wd_occ_mat(nfout) ! write occupation matrix
        endif
     endif
! ===================================================================== 11.0

     call m_Files_open_nfefermi()
     call m_ESIO_wd_Efermi(nfout,nfefermi)
     call m_Files_close_nfefermi()
  else
     if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL) then
        if(sw_ekzaj == OFF) then
           call m_Files_reopen_nfzaj()
           call m_ESIO_wd_WFs_3D(nfout,nfzaj,F_ZAJ_partitioned)
        end if
     end if


     if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL) then
        call m_Files_reopen_nfchgt()

        call m_CD_wd_chgq(nfchgt,F_CHGT_partitioned) ! write chgq_l

     end if
     if(flg_paw) then
        call m_Files_open_nfcntn_bin_paw
        if(mype==0) rewind nfcntn_bin_paw
        call m_PP_wd_PAW_parameters(nfout,nfcntn_bin_paw)
        call m_CD_wd_hsr(nfcntn_bin_paw)
        !!$call m_PAWCD_wd_cd(nfout)
     end if
#endif
  end if
#ifndef _EMPIRICAL_
  end if
#endif
  call m_CtrlP_wd_cpu_total()

! ============================= KT_Test ================ 12.5Exp
#ifdef USE_ZAJ_HISTORY
  call m_ES_wf_wd_zaj_history
#endif
! ====================================================== 12.5Exp

  if(iprijobstatus >= 1) then
!!$     write(nfout,'(" WDD onto Files")')
     call m_Files_open_nfstatus()
     if(jobstatus_series == ON) then
!!$        switch_header = OFF
        call m_Files_skiptoend(nfstatus)
     else
!!$        switch_header = ON
     end if
     status_wdmode = FINISH
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          &                , iteration,iteration_ionic,iteration_electronic)
  end if
  call tstatc_wd0

  if (conf_para.and.driver==DRIVER_CONSTRAINT) call mpi_barrier(mpi_comm_world,mpi_err)

  if(final_c) then
     call m_Files_close_all(final_c)                    ! -(m_Files)
  else
     call m_Files_close_nfinp()
     call m_Files_close_nfcntn()
!!$     if(mype==0)then
!!$        close(nfcntn)
!!$        close(nfinp)
!!$     endif
  endif
contains
  integer function bcast_ipri(ipri_in)
    integer, intent(in)  :: ipri_in
    integer :: ipri_out, ierr
    if(npes > 1) then
       if(mype == 0) ipri_out = ipri_in
       call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
    else
       ipri_out = ipri_in
    end if
!!$    if(ipri_out /= OFF) ipri_out = ON
    if(ipri_out /= ON) ipri_out = OFF
    bcast_ipri = ipri_out
  end function bcast_ipri
end subroutine WriteDownData_onto_Files

!!$subroutine WriteCheckPointData
!!$  use m_IterationNumbers,   only : m_Iter_wd_iteration_numbers_b, iteration_electronic
!!$  use m_Files,              only : m_Files_open_nfcheckpoint, m_Files_close_nfcheckpoint &
!!$       &                         , nfout, nfcheckpoint
!!$  use m_ES_IO,              only : m_ESIO_wd_EigenValues_etc, m_ESIO_wd_WFs
!!$  use m_Charge_Density,     only : m_CD_wd_chgq
!!$  implicit none
!!$
!!$  if((icond == CONTINUATION or. icond == INITIAL).and. iteration_electronic == 10) then
!!$     call m_Files_open_nfcheckpoint
!!$     call m_Iter_wd_iteration_numbers_b(nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_ESIO_wd_EigenValues_etc(nfcheckpoint,F_CHKPNT_partitioned,totch_flag=ON)
!!$     call m_ESIO_wd_WFs(nfout,nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_CD_wd_chgq(nfcheckpoint, F_CHKPNT_partitioned)
!!$     call m_Files_close_nfcheckpoint
!!$  end if
!!$end subroutine WriteCheckPointData
!!$
!!$subroutine ReadCheckPointData_if_needed
!!$  use m_IterationNumbers, only : iteration_ionic, iteration_electronic
!!$  implicit none
!!$  if((icond == CONTINUATION or. icond == INITIAL).and. iteration_electronic == 15) then
!!$     call m_Files_open_nfcheckpoint
!!$     call m_Iter_rd_iteration_numbers_b(nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_ESIO_rd_EigenValues_etc(
!!$
!!$
!!$end subroutine ReadCheckPointData_if_needed

module m_Fx_omega_PBE
 use m_Const_Parameters,  only : DP,PAI,PAIsqrt
 implicit none

 real(kind=DP), parameter :: &
                 ca =  1.0161144d0 &
               , cb = -0.37170836d0 &
               , cc = -0.077215461d0 &
               , cd =  0.57786348d0 &
               , ce = -0.051955731d0 &
               , ck = -4.d0/27.d0

 real(kind=DP), parameter :: &
                 a1 = -0.000205484d0 &
               , a2 = -0.109465240d0 &
               , a3 = -0.064078780d0 &
               , a4 = -0.008181735d0 &
               , a5 = -0.000110666d0

 real(kind=DP), parameter :: &
                 b1 =  0.006601306d0 &
               , b2 =  0.259931140d0 &
               , b3 =  0.520352224d0 &
               , b4 =  0.118551043d0 &
               , b5 =  0.046003777d0

 real(kind=DP), parameter :: pi = PAI
 real(kind=DP), parameter :: rpi = PAIsqrt

contains

 function Fx_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: Fx_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  Fx_omega = a1 * yjw1(alp1+b1,bet) &
           + a2 * yjw1(alp1+b2,bet) &
           + a3 * yjw2(alp1+b3,bet) &
           + a4 * yjw2(alp1+b4,bet) &
           + a5 * yjw3(alp1+b5,bet) &
           + cb * yjw1(alp2,bet) &
           + cc * (1.d0+s2*f(s)) * yjw3(alp2,bet) &
           +      (ce+s2eg(s)) * yjw5(alp2,bet)
  Fx_omega = -8.d0/9.d0 * Fx_omega
 end function Fx_omega
 
 function dFxds_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: dFxds_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, dalp, bet
  real(kind=DP) :: ff, gg
  real(kind=DP) :: dff, dgg

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd 
  dalp = 2.d0*s*h(s) + s2*dh(s)
  bet = omega/fk
  ff = cc * (1.d0+s2*f(s))
  gg = ce+s2eg(s)
  dff = cc * ( 2.d0*s*f(s) + s2*df(s) )
  dgg = 2.d0*s*eg(s) + s2*deg(s)

  dFxds_omega = ( a1 * dyjw1a(alp1+b1,bet) &
                + a2 * dyjw1a(alp1+b2,bet) &
                + a3 * dyjw2a(alp1+b3,bet) &
                + a4 * dyjw2a(alp1+b4,bet) &
                + a5 * dyjw3a(alp1+b5,bet) &
                + cb * dyjw1a(alp2,bet) &
                + ff * dyjw3a(alp2,bet) &
                + gg * dyjw5a(alp2,bet) ) * dalp &
                + dff * yjw3(alp2,bet) &
                + dgg * yjw5(alp2,bet) 
  dFxds_omega = -8.d0/9.d0 * dFxds_omega
 end function dFxds_omega

 function kdFxdk_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: kdFxdk_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  kdFxdk_omega = a1 * dyjw1b(alp1+b1,bet) &
              + a2 * dyjw1b(alp1+b2,bet) &
              + a3 * dyjw2b(alp1+b3,bet) &
              + a4 * dyjw2b(alp1+b4,bet) &
              + a5 * dyjw3b(alp1+b5,bet) &
              + cb * dyjw1b(alp2,bet) &
              + cc * (1.d0+s2*f(s)) * dyjw3b(alp2,bet) &
              +      (ce+s2eg(s)) * dyjw5b(alp2,bet)
  kdFxdk_omega = 8.d0/9.d0 * bet * kdFxdk_omega
 end function kdFxdk_omega

 function k2dFxdk_omega(fk,s,omega)
  implicit none
  real(kind=DP) :: k2dFxdk_omega
  real(kind=DP), intent(in) :: fk,s,omega

  real(kind=DP) :: s2, alp1, alp2, bet

  s2 = s*s
  alp1 = s2 * h(s)
  alp2 = alp1 + cd
  bet = omega/fk

  k2dFxdk_omega = a1 * dyjw1b(alp1+b1,bet) &
              + a2 * dyjw1b(alp1+b2,bet) &
              + a3 * dyjw2b(alp1+b3,bet) &
              + a4 * dyjw2b(alp1+b4,bet) &
              + a5 * dyjw3b(alp1+b5,bet) &
              + cb * dyjw1b(alp2,bet) &
              + cc * (1.d0+s2*f(s)) * dyjw3b(alp2,bet) &
              +      (ce+s2eg(s)) * dyjw5b(alp2,bet)
  k2dFxdk_omega = 8.d0/9.d0 * omega * k2dFxdk_omega
 end function k2dFxdk_omega

 function f(s)
  implicit none
  real(kind=DP) :: f
  real(kind=DP), intent(in) :: s
 
  f = ( h(s) * (16.d0*ca**2 + 36.d0*(cb-ca*cd)) + 9.d0*ck ) / (36.d0*cc)
 end function f

 function df(s)
  implicit none
  real(kind=DP) :: df
  real(kind=DP), intent(in) :: s
 
  df = ( dh(s) * (16.d0*ca**2 + 36.d0*(cb-ca*cd)) ) / (36.d0*cc)
 end function df

 function eg(s)
  implicit none
  real(kind=DP) :: eg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,s2,t,d

  s2 = s * s

  t = cd + h(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))

  b = 15.d0*sqrt(pi)*s2 / d

  eg = - (3.d0*pi/4.d0+a) / b
 end function eg

 function s2eg(s)
  implicit none
  real(kind=DP) :: s2eg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,s2,t,d

  s2 = s * s

  t = cd + h(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))

  b = 15.d0*sqrt(pi) / d

  s2eg = - (3.d0*pi/4.d0+a) / b
 end function s2eg


 function deg(s)
  implicit none
  real(kind=DP) :: deg
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: a,b,b2,s2,t,u,d
  real(kind=DP) :: da,db,dt
  real(kind=DP) :: rh

  s2 = s * s
  t = cd + h(s) * s2
  u = 1.d0 + f(s) * s2
  d = 16.d0 * t**3.5d0

  a = sqrt(pi) * ( 15.d0*ce + t * ( 6.d0*cc*(1.d0+f(s)*s2) &
                  + 4.d0*cb*t + 8.d0*ca*t*t ) ) / d  &
      - 3.d0*pi*sqrt(ca)/4.d0 &
               * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca))
  b = 15.d0*sqrt(pi)*s2 / d
  b2 = b * b

  dt = dh(s) * s2 + 2.d0 * s * h(s)
  rh = sqrt(h(s))
  da = sqrt(pi) * ( 6.d0*cc*( df(s)*s2 + 2.d0*s*f(s) ) * t &
     &            + ( 6.d0*cc*u + 8.d0*cb*t+24.d0*ca*t*t ) * dt ) &
     &            / d &
     & - 7.d0*sqrt(pi)/32.d0 * ( 15.d0*ce + 6.d0*cc*u*t + 4.d0*cb*t*t + 8.d0*ca*t**3 ) &
     &                      * dt / t**4.5d0 &
     & - 27.d0*pi/(16.d0*sqrt(ca)) * dt * exp(9.d0*h(s)*s2/(4.d0*ca)) * erfc(1.5d0*s*sqrt(h(s)/ca)) &           
     & + 9.d0*sqrt(pi)/4.d0*( rh + 0.5d0*s*dh(s)/rh )
  db = 15.d0*sqrt(pi) * ( 2.d0*s - 3.5d0*s2*dt/t ) / d

  deg = -da/b + db*(3.d0*pi/4.d0+a)/b2 
 end function deg

 function h(s)
  implicit none
  real(kind=DP) :: h
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: s2, s4
  real(kind=DP), parameter :: a1 = 0.00979681d0 &
                           , a2 = 0.0410834d0 &
                           , a3 = 0.187440d0 &
                           , a4 = 0.00120824d0 &
                           , a5 = 0.0347188d0

  s2 = s * s
  s4 = s2 * s2

  h = ( a1 * s2 + a2 * s4 ) / ( 1.d0 + s4 * (a3 + a4 * s + a5 * s2 ) )
 end function h

 function dh(s)
  implicit none
  real(kind=DP) :: dh
  real(kind=DP), intent(in) :: s

  real(kind=DP) :: s2, s4, s5, s6
  real(kind=DP), parameter :: a1 = 0.00979681d0 &
                           , a2 = 0.0410834d0 &
                           , a3 = 0.187440d0 &
                           , a4 = 0.00120824d0 &
                           , a5 = 0.0347188d0

  s2 = s * s
  s4 = s2 * s2
  s5 = s * s4
  s6 = s2 * s4

  dh = -s*( a1*( 2.d0*a3*s4 + 3.d0*a4*s5 + 4.d0*a5*s6 - 2.d0) + a2*s2*(a4*s5+2.d0*a5*s6-4.d0)) &
     &    / ( 1.d0 + s4 * (a3 + a4 * s + a5 * s2 ) )**2
 end function dh

 function yjw1(a,b)
  implicit none
  real(kind=DP) :: yjw1
  real(kind=DP), intent(in) :: a, b
  
  yjw1 = (1.d0-b/sqrt(a+b*b))/(2.d0*a)
 end function yjw1

 function dyjw1a(a,b)
  implicit none
  real(kind=DP) :: dyjw1a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: apb2
  real(kind=DP) :: rapb2

  apb2 = a + b*b
  rapb2 = sqrt(apb2)

  dyjw1a = (b*(2.d0/rapb2+a/(apb2*rapb2))-2.d0)/(4.d0*a*a)
 end function dyjw1a

 function dyjw1b(a,b)
  implicit none
  real(kind=DP) :: dyjw1b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: apb2

  apb2 = a + b*b

  dyjw1b = -0.5d0/apb2**1.5d0
 end function dyjw1b

 function yjw2(a,b)
  implicit none
  real(kind=DP) :: yjw2
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ra, b2

  ra = sqrt(a)
  b2 = b * b

  yjw2 = (-ra*b+(a+b2)*acot(b/ra))/(2.d0*a**(3.d0/2.d0)*(a+b2)*rpi)
 end function yjw2

 function dyjw2a(a,b)
  implicit none
  real(kind=DP) :: dyjw2a
  real(kind=DP), intent(in) :: a, b
 
  real(kind=DP) :: ra, b2

  ra = sqrt(a)
  b2 = b * b

  dyjw2a = (ra*b*(5.d0*a+3.d0*b2)-3.d0*(a+b2)**2*acot(b/ra))/(4.d0*a**(5.d0/2.d0)*(a+b2)**2*rpi)
 end function dyjw2a

 function dyjw2b(a,b)
  implicit none
  real(kind=DP) :: dyjw2b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw2b = -1.d0/(sqrt(pi)*ab2*ab2)
 end function dyjw2b

 function yjw3(a,b)
  implicit none
  real(kind=DP) :: yjw3
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: b2, ab2, rab2

  b2 = b * b
  ab2 = a+b2
  rab2 = sqrt(ab2)

  yjw3 = (2.d0*b2*(-b+rab2)+a*(-3.d0*b+2.d0*rab2))/(4.d0*a*a*ab2*rab2)
 end function yjw3

 function dyjw3a(a,b)
  implicit none
  real(kind=DP) :: dyjw3a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, b2, b4, ab2, rab2

  a2 = a * a
  b2 = b * b
  b4 = b2 * b2
  ab2 = a+b2
  rab2 = sqrt(ab2)

  dyjw3a = (a2*(15.d0*b-8.d0*rab2) + 8.d0*b4*(b-rab2) - 4.d0*a*b2*(4.d0*rab2-5.d0*b))/(8.d0*a2*a*ab2*ab2*rab2)
 end function dyjw3a

 function dyjw3b(a,b)
  implicit none
  real(kind=DP) :: dyjw3b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw3b = -0.75d0/ab2**2.5d0
 end function dyjw3b

 function yjw5(a,b)
  implicit none
  real(kind=DP) :: yjw5
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, b2, b4, ab2, rab2

  a2 = a * a
  b2 = b * b
  b4 = b2 * b2
  ab2 = a+b2
  rab2 = sqrt(ab2)

  yjw5 = (8.d0*b4*(-b+rab2)+4.d0*a*b2*(-5.d0*b+4.d0*rab2)+a2*(-15.d0*b+8.d0*rab2))/(8.d0*a2*a*ab2*ab2*rab2)
 end function yjw5

 function dyjw5a(a,b)
  implicit none
  real(kind=DP) :: dyjw5a
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: a2, a3, a4, b2, b4, b6, ab2, rab2

  a2 = a * a
  a3 = a * a2
  a4 = a2 * a2
  b2 = b * b
  b4 = b2 * b2
  b6 = b2 * b4
  ab2 = a+b2
  rab2 = sqrt(ab2)

  dyjw5a = -3.d0*( 16.d0*b6*(rab2-b) + 8.d0*a*b4*(6.d0*rab2-7.d0*b) + a3*(16.d0*rab2-35.d0*b) &
                & + 2.d0*a2*b2*(24.d0*rab2 - 35.d0*b) ) / (16.d0*a4*ab2*ab2*ab2*rab2)
 end function dyjw5a

 function dyjw5b(a,b)
  implicit none
  real(kind=DP) :: dyjw5b
  real(kind=DP), intent(in) :: a, b

  real(kind=DP) :: ab2

  ab2 = a + b*b

  dyjw5b = -15.d0/(8.d0*ab2**3.5d0)
 end function dyjw5b

 function acot(a)
  implicit none
  real(kind=DP) :: acot
  real(kind=DP), intent(in) :: a
 
  acot = atan(1.d0/a)
 end function acot
 
end module m_Fx_omega_PBE

subroutine ex_omegapbe(amix,omega,nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho,nfft_y)
  use m_Const_Parameters,  only : DP,PAI,PAI4
  use m_Fx_omega_PBE,      only : Fx_omega, dFxds_omega, k2dFxdk_omega
  implicit none

  real(kind=DP),intent(in)  :: amix,omega
  integer,intent(in)        :: nspin,ispin,nfft_y
  integer,intent(in)        :: ista_fftph, iend_fftph
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dFx_drho(1:nfft_y,nspin)
  real(kind=DP),intent(inout) :: dFx_dgradrho(1:nfft_y,nspin)

  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: th8pi = -0.1193662073189215d0

  real(kind=DP) :: facw,d,dd,fk,s,fac,f,ex,fs,ff,exd,exdd,exc0,exc1
  integer       :: is,i

!---- Spin dependency

  facw = ispin
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = 1, nfft_y
        d  = facw * chgrhr_l(i, is)
        if(abs(d) < 1.d-30) d = 1.d-30
        fk = (3*PAI*PAI*d)**thrd
        dd = facw * grad_rho(i, is)
        if(abs(d) > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        end if
!-------------------------------------
        f = Fx_omega(fk,s,omega)
        ff = k2dFxdk_omega(fk,s,omega)
        if(abs(s)>1.d-10) then
           fs = dFxds_omega(fk,s,omega)
        else
           fs = 0.d0
           !!write(2000,'("s=",f20.5," f=",f20.5," ff=",f20.5)') s, f, ff
        end if
        fac = ax*d**thrd
        ex  = fac*f*d
        exd = thrd4*fac*(f-s*fs)-ff/PAI4
        exdd = th8pi*fs
!------------------------------------------     
        exc0 = ex / facw
        dFx_drho(i, is) = dFx_drho(i, is) + amix * exd 
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = dFx_dgradrho(i, is) + amix * exdd / grad_rho(i, is)
        endif
        exc1 = exc1 + exc0*f2or1(i)
        !!write(1000,'("i,f,fs,ff,d,dd,fk,s=",i8,1x,7(1x,f20.5))') i,f,fs,ff,d,dd,fk,s
     end do
     exc = exc + amix * exc1
  end do
  !!stop 'Debug: OmegaPBE'
end subroutine ex_omegapbe

subroutine init_cubic_spline(n,x,y,y2)
  implicit none
  integer,intent(in) :: n
  real(kind=8), dimension(n), intent(in) :: x,y
  real(kind=8), dimension(n), intent(out) :: y2
  integer i,j
  real(kind=8) a,b
  real(kind=8), allocatable, dimension(:) :: tmp

  allocate(tmp(n));tmp=0.d0
  y2 = 0.0d0

  do i=2,n-1
    a=(x(i)-x(i-1))/(x(i+1)-x(i-1))
    b=a*y2(i-1)+2
    y2(i)=(a-1)/b
    tmp(i)=(6.d0*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1)) &
    & /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-a*tmp(i-1))/b
  enddo

  do j=n-1,1,-1
    y2(j) = y2(j)*y2(j+1)+tmp(j)
  enddo
  deallocate(tmp)

end subroutine init_cubic_spline

subroutine cubic_spline(n,x,y,y2,xin,yout,y1out)
  integer, intent(in) :: n
  real(kind=8), dimension(n), intent(in) :: x,y,y2
  real(kind=8), intent(in) :: xin
  real(kind=8), intent(out) :: yout,y1out
  real(kind=8) :: a,b,h
  integer :: i,i0,i1

  i0=1
  i1=n

  do while ( (i1-i0).gt.1 ) 
    i=(i1+i0)/2
    if (x(i).gt.xin) then
        i1=i
    else
        i0=i
    endif
  enddo

  h=x(i1)-x(i0)
  a=(x(i1)-xin)/h
  b=(xin-x(i0))/h
  yout  = a*y(i0)+b*y(i1)+((a*a*a-a)*y2(i0)+(b*b*b-b)*y2(i1))*(h**2)/6.0d0
  y1out = (y(i1)-y(i0))/h-(3.0d0*a*a-1)/6.0d0*h*y2(i0)+(3.0d0*b*b-1)/6.0d0*h*y2(i1)
end subroutine cubic_spline

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 6.01)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==============
!  patch 0.1 by K. Tagami @adv    2008/10/19
!
!     patch 0.1 :  correction in the case when nspin==2
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BerryPhase
! $Id: m_BerryPhase.F90 376 2014-06-17 07:48:31Z jkoga $
use m_Const_Parameters,    only : DP, PAI, PAI2, PAI4, ON, OFF
use m_Control_Parameters,  only : ipriberry, nspin, printable
use m_Files,               only : nfout
use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &              , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e &
       &              , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &              , map_ek &
#ifdef TRANSPOSE
       &              , ierr,mp_e,nis_e,nie_e,nel_e &
       &              , ista_g1,iend_g1,np_g1,mp_g1,nis_g1,nie_g1,nel_g1
#else
       &              , ierr
#endif

implicit none
include 'mpif.h'
integer, private :: n1,n2,jpara
integer, private :: ig
integer, private :: nkvec,nkprep
integer, private :: nstate = -1
integer, private :: ikp = 0
integer, private :: sw_symmetry = 2 ! 1->idetical, 2->inversion, 3->full
integer, private :: sw_deficit = ON ! 0->off, 1->on
real(kind=DP), private :: g(3)
real(kind=DP), allocatable, private :: kvec(:,:) ! dim(3,nkvec)
real(kind=DP), allocatable, private :: wgh(:) ! dim(nkprep)
real(kind=DP), allocatable, private :: wfbp0(:,:,:,:) ! dim(kg,np_e,2,nspin)
real(kind=DP), allocatable, private :: wfbp1(:,:,:,:) ! dim(kg,np_e,2,nspin)
real(kind=DP), allocatable, private :: wfbp2(:,:,:,:) ! dim(kg,np_e,2,nspin)
integer, private :: kgbp0,kgbp1,kgbp2
complex(kind=DP), allocatable, private :: det(:,:,:) ! dim(jpara,nkprep,nspin)
real(kind=DP) :: kshift_BP(2)
logical, private :: ikp0 = .true.

! for the US correction
real(kind=DP), allocatable, private :: fsr_k0(:,:,:),fsi_k0(:,:,:) ! dim(np_e,nlmta,nspin)
real(kind=DP), allocatable, private :: fsr_k1(:,:,:),fsi_k1(:,:,:) ! dim(np_e,nlmta,nspin)
real(kind=DP), allocatable, private :: fsr_k2(:,:,:),fsi_k2(:,:,:) ! dim(np_e,nlmta,nspin
real(kind=DP), allocatable, private :: zfcos(:),zfsin(:) ! dim(natm)
real(kind=DP), allocatable, private :: ftqer(:,:,:),ftqei(:,:,:) ! dim(nlmt,nlmt,natm)

! Tags
character(len("berry_phase")),private,parameter :: tag_berry_phase = "berry_phase"
character(len("sw_berry_phase")),private,parameter :: tag_sw_berry_phase = "sw_berry_phase"
character(len("g_index")),private,parameter :: tag_g_index = "g_index"
character(len("mesh")),private,parameter :: tag_mesh = "mesh"
character(len("n1")),private,parameter :: tag_n1 = "n1"
character(len("n2")),private,parameter :: tag_n2 = "n2"
character(len("j")),private,parameter :: tag_j = "j"
character(len("kshift")),private,parameter :: tag_kshift = "kshift"
character(len("k1")),private,parameter :: tag_k1 = "k1"
character(len("k2")),private,parameter :: tag_k2 = "k2"
character(len("sw_symmetry")),private,parameter :: tag_sw_symmetry = "sw_symmetry"
character(len("sw_deficit")),private,parameter :: tag_sw_deficit = "sw_deficit"

! MPI
!integer, private :: istatus
integer, private :: istatus(mpi_status_size)

contains

subroutine m_BP_rd_parameters
use m_Crystal_Structure, only : rltv
use m_Control_Parameters,  only : icond,sw_berry_phase
use m_Const_Parameters, only : FIXED_CHARGE,FIXED_CHARGE_CONTINUATION
implicit none

integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue &
        & ,f_getRealVectorValue
integer :: f_selectParentBlock, f_selectTop
real(kind=DP) :: dret

if(icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION) return

iret = f_selectTop()
if( f_selectBlock( tag_berry_phase) == 0) then
  if( f_getIntValue( tag_sw_berry_phase, iret) == 0) sw_berry_phase = iret
  if( f_getIntValue( tag_sw_symmetry, iret) == 0) sw_symmetry = iret
  if( f_getIntValue( tag_sw_deficit, iret) == 0) sw_deficit = iret
  if( f_getIntValue( tag_g_index, iret) == 0) then
    ig = iret
  else
    ig = 1 ! default value
  end if
  if( f_selectBlock( tag_mesh) == 0) then
    if( f_getIntValue( tag_n1, iret) == 0) n1 = iret
    if( f_getIntValue( tag_n2, iret) == 0) n2 = iret
    if( f_getIntValue( tag_j, iret) == 0)  jpara = iret
  else
    n1 = 4 ! default value
    n2 = 4 ! default value
    jpara = 20 ! default value
  end if
  iret = f_selectParentBlock()
  if( f_selectBlock( tag_kshift) == 0) then
    if( f_getRealValue( tag_k1, dret, '' ) == 0) kshift_BP(1) = dret
    if( f_getRealValue( tag_k2, dret, '' ) == 0) kshift_BP(2) = dret
  else
    kshift_BP(1:2) = 0.d0 ! default value
  end if
  iret = f_selectParentBlock()
end if
iret = f_selectParentBlock()

if(sw_berry_phase == ON .and. printable) then
   write(nfout,'(1x,"<< Berry Phase")')
   write(nfout,'(1x,"ig=",i1,1x,"g=",3(1x,f10.5))') ig,rltv(1:3,ig)
   write(nfout,'(1x,"n1=",i3,1x,"n2=",i3,1x,"J=",i3)') n1,n2,jpara
   write(nfout,'(1x,"k1=",f8.5,1x,"k2=",f8.5)') kshift_BP(1:2)
   write(nfout,'(1x,"sw_symmetry = ",i1)') sw_symmetry
   write(nfout,'(1x,"sw_deficit = ",i1)') sw_deficit
   write(nfout,'(1x,"   Berry Phase >>")')
end if

end subroutine m_BP_rd_parameters


subroutine m_BP_gen_Kpoints(preallocation)
use m_Kpoints, only: special_kpoints, kshift, mp_index
use m_Crystal_Structure, only : rltv, nopr, op, imag
use m_Const_Parameters,  only : CARTS,BUCS,PARA
use m_Kpoints, only : kv3, vkxyz, qwgt, m_Kp_alloc_kpoints
implicit none

logical, intent(in) :: preallocation

! local variables
integer :: i,j,k
integer :: printlevel = 1
integer :: nkpoint,nsym
integer, parameter :: nkpmax0 = 10000
real(kind=DP) :: kpoint(3,nkpmax0), weight(nkpmax0)
real(kind=DP) :: bmat(3,3)
real(kind=DP) :: c(3,2),b(3,2)
real(kind=DP) :: cdot,g2,dg,w
real(kind=DP) :: a1(3),a2(3),a3(3),volg
real(kind=DP) :: rot(3,3,48),rot_g(3)
real(kind=DP) :: scaled_g(3),scaled_a3(3)
real(kind=DP) :: theta
real(kind=DP), parameter :: eps = 1.d-12
logical :: sw_trs = .true. ! time reversal symmetry
logical :: magnetic, use_trs

use_trs = .true.
if(imag/=PARA) then
   magnetic = .true.
else
   magnetic = .false.
end if
bmat(1:3,1:3)=rltv(1:3,1:3)/PAI2

g(1:3) = bmat(1:3,ig)
k=0
do i=1,3
  if(i /= ig) then
    k=k+1
    b(1:3,k)=bmat(1:3,i)
  end if
end do

g2 = sum(g(1:3)**2)
do k=1,2
  cdot = sum(b(1:3,k)*g(1:3))/g2 
  c(1:3,k) = b(1:3,k) - cdot*g(1:3)
end do

call cross(c(1,2),g,a1)
volg = sum(c(1:3,1)*a1(1:3))
a1(1:3)=a1(1:3)/volg
call cross(g,c(1,1),a2)
a2(1:3)=a2(1:3)/volg
call cross(c(1,1),c(1,2),a3)
a3(1:3)=a3(1:3)/volg

nsym=0
do i=1,nopr
  do j=1,3
    rot_g(j) = sum(op(j,1:3,i)*g(1:3))
  end do
  if(abs(rot_g(1)-g(1)) < eps .and. &
   & abs(rot_g(2)-g(2)) < eps .and. &
   & abs(rot_g(3)-g(3)) < eps ) then
    nsym=nsym+1
    rot(1:3,1:3,nsym) = op(1:3,1:3,i)
  end if
end do

if(preallocation .and. printable) then
write(nfout,'(1x,"<< k-points for an area integral in Berry phase calc.")')
write(nfout,*) 'c1 = ',c(1:3,1)
write(nfout,*) 'c2 = ',c(1:3,2)
write(nfout,*) 'g  = ',g(1:3)
write(nfout,*) 'a1 = ',a1(1:3)
write(nfout,*) 'a2 = ',a2(1:3)
write(nfout,*) 'a3 = ',a3(1:3)
theta = sum(a1(1:3)*a2(1:3))/(sqrt(sum(a1(1:3)**2))*sqrt(sum(a2(1:3)**2)))
theta = acos(theta)*360/PAI2
write(nfout,*) 'angle between a1 and a2 (deg.) =',theta
end if

! debug
!if(printable) then
!write(nfout,*) '<< left symmetry operations >>'
!write(nfout,*) 'Nsym = ', nsym
!do i=1,nsym
!  write(nfout,'(1x,"i=",i2)') i
!  write(nfout,'(1x,3(f10.5,1x))') rot(1,1:3,i)
!  write(nfout,'(1x,3(f10.5,1x))') rot(2,1:3,i)
!  write(nfout,'(1x,3(f10.5,1x))') rot(3,1:3,i)
!end do
!end if
! end debug

! for identical symmetry olny
if(sw_symmetry == 1 .or. sw_symmetry == 2) then
  nsym=1
  rot(1:3,1:3,nsym) = 0.d0
  do i=1,3
    rot(i,i,nsym) = 1.d0
  end do
end if
if(sw_symmetry == 1) sw_trs = .false.

mp_index(1)=n1
mp_index(2)=n2
mp_index(3)=1
kshift(1:2)=kshift_BP(1:2)
kshift(3)=0.d0
scaled_g(1:3)  = g(1:3)/dble(100)
scaled_a3(1:3) = a3(1:3)*dble(100)
nkprep = 0
call special_kpoints(printlevel,nfout,nsym,rot &
  & , c(1,1),c(1,2),scaled_g,a1,a2,scaled_a3 &
  !& , c(1,1),c(1,2),g,a1,a2,a3 &
  & , nkprep,nkpmax0,kpoint,weight,magnetic,use_trs)
if(preallocation.and.printable) then
   write(nfout,'(1x,"   k-points for an area integral in Berry phase calc. >>")')
end if

nkvec=nkprep*jpara
allocate(kvec(3,nkvec))
allocate(wgh(nkprep))
dg = 1.d0/jpara
nkvec=0
do j=1,nkprep
  wgh(j)=weight(j)/dble(nspin)
  do i=1,jpara
    nkvec=nkvec+1
    kvec(1:2,nkvec) = kpoint(1:2,j)
    kvec(3,nkvec)   = dg*dble(i-1)
  end do
end do

!kv3 = nkvec*nspin
!call m_Kp_alloc_kpoints


if(.not.preallocation) then

kv3 = nkvec
w=1.d0/dble(kv3)
do i=1,nkvec
  vkxyz(i,1:3,CARTS) = 0.d0
  do j=1,2
    vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ c(1:3,j)*kvec(j,i)
  end do
  vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ g(1:3)*kvec(j,i)
  vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)*PAI2
  qwgt(i) = w
end do

if(printable) then
write(nfout,'("<< generated k-points")')
do i=1,nkvec
  write(nfout,'(1x,i4," k=",3(1x,f10.5),1x," k_cart=", &
    & 3(1x,f10.5),1x,"w= ",f10.5)') &
    & i,kvec(1:3,i),vkxyz(i,1:3,CARTS),qwgt(i)
end do
write(nfout,'("   generated k-points >>")')
end if

allocate(det(jpara,nkprep,nspin));det=(0.d0,0.d0)

call set_dk_BP()

else
   kv3 = nkvec*nspin
   deallocate(kvec,wgh)
end if

!stop 'm_BP_gen_Kpoints'

contains

  subroutine cross(a,b,c)
  implicit none
  real(kind=DP), intent(in) :: a(3),b(3)
  real(kind=DP), intent(out) :: c(3)

  !local variables
  integer :: i,j,k

  c(1) = a(2)*b(3)-a(3)*b(2)
  c(2) = a(3)*b(1)-a(1)*b(3)
  c(3) = a(1)*b(2)-a(2)*b(1)

  end subroutine cross

  subroutine set_dk_BP()
  use m_PseudoPotential, only : dk_BP

  dk_BP(1) = sqrt(sum(g(1:3)**2))/jpara*PAI2
  !dk_BP(1) = 0.d0 ! for debug of Fourier transforms
if(printable) then
  write(nfout,*) '!** set_dk_BP: dk_BP=',dk_BP(1)
end if

  end subroutine set_dk_BP

end subroutine m_BP_gen_Kpoints



subroutine calc_phase_for_Berry()
use m_Ionic_System,        only : pos,natm

! local variables
integer       :: ia
real(kind=DP) :: ph

if(.not.allocated(zfcos)) allocate(zfcos(natm),zfsin(natm))

! debug
!do ia=1,natm
!  if(printable) write(nfout,*) ia,': pos=',pos(ia,1:3)
!end do
!if(printable) write(nfout,*) '--- ia,zfcos,zfsin ---'
! end debug
do ia=1,natm
  ph = pos(ia,ig)*PAI2
  zfcos(ia) = cos(ph)
  zfsin(ia) = sin(ph)
  ! debug
  ! if(printable) write(nfout,*) ia,zfcos(ia),zfsin(ia)
  ! end debug
end do

end subroutine calc_phase_for_Berry



subroutine m_BP_calc_det()
use m_PseudoPotential,     only : nlmta
! === DEBUG by T.Kato 2013/07/11 ===============================================
!use m_Electronic_Structure, only : neg, neordr
use m_Electronic_Structure, only : neordr
use m_Control_Parameters, only : neg
! ==============================================================================
implicit none

! local variables
integer :: i,k,k1,k2,j1,j2,kg,nk1,nk2
integer :: ik,is
integer :: j1_mpi,j1_ordr
real(kind=DP) :: mr(nstate,nstate),mi(nstate,nstate)
real(kind=DP), allocatable :: mr_mpi(:,:),mi_mpi(:,:)
real(kind=DP), allocatable :: wfbp(:,:,:,:)
real(kind=DP), allocatable :: fsr_k(:,:,:),fsi_k(:,:,:)

! for debug
integer :: n


nk1 = mod(ikp,jpara)
nk2 = ikp/jpara+1

if(jpara>1) then

kg = min(kgbp1,kgbp2)

allocate(wfbp(kgbp2,nstate,2,nspin))
call copy_old_wfbp_to_temp_wfbp(kgbp2,wfbp2,wfbp) ! MPI
if(sw_deficit == ON) then
  allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
  call copy_old_fs_to_temp_fs(fsr_k2,fsi_k2,fsr_k,fsi_k) ! MPI
!debug
! if(printable) then
!    do i=1,nlmta
!    do n=1,nstate
!      write(nfout,'("n=",i2," i=",i2," fsr_k2=",f10.5," fsr_k=",f10.5)') & 
!           &         n,i,fsr_k2(n,i),fsr_k(n,i)
!      write(nfout,'("n=",i2," i=",i2," fsi_k2=",f10.5," fsi_k=",f10.5)') & 
!           &         n,i,fsi_k2(n,i),fsi_k(n,i)
!    end do
!    end do
! end if
!end debug
end if

SPIN: do is =1,nspin
mr=0.d0; mi=0.d0
ik=is
do j2=1,nstate
  do j1=1,neg
    if(map_ek(j1,ik) /= mype) cycle
    j1_mpi = map_z(j1)
    j1_ordr = neordr(j1,ik)
    !if(printable) write(nfout,*) 'j1=',j1,' j1_mpi=',j1_mpi,' j1_ordr=',j1_ordr,' mype=',mype
    if(j1_ordr > nstate) cycle
    !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'
    do i=1,kg
      !debug
      !if(i<10.and.printable) write(nfout,'("OM: wfbp1 = ",2f10.5)')  wfbp1(i,j1_mpi,1:2) 
      !if(i<10.and.printable) write(nfout,'("OM: wfbp2 = ",2f10.5)')  wfbp(i,j2,1:2) 
      !debug end
      mr(j1_ordr,j2) = mr(j1_ordr,j2) + &
      & wfbp1(i,j1_mpi,1,is)*wfbp(i,j2,1,is) + wfbp1(i,j1_mpi,2,is)*wfbp(i,j2,2,is)
      mi(j1_ordr,j2) = mi(j1_ordr,j2) - &
      & wfbp1(i,j1_mpi,2,is)*wfbp(i,j2,1,is) + wfbp1(i,j1_mpi,1,is)*wfbp(i,j2,2,is)
    end do
    if(sw_deficit == ON) &
    & call add_deficit_term(mr(j1_ordr,j2),mi(j1_ordr,j2) &
    &                      ,fsr_k1,fsi_k1 &
    &                      ,fsr_k,fsi_k &
    &                      ,j1_mpi,j2,is)
  end do
end do
call mpi_barrier(mpi_comm_group,ierr)
if(npes>1) then
  allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
  mr_mpi=0.d0; mi_mpi=0.d0
  call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum &
                   &,mpi_comm_group,ierr)
  mr = mr_mpi
  call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum &
                   &,mpi_comm_group,ierr)
  mi = mi_mpi
  deallocate(mr_mpi,mi_mpi)
end if

call determinant(nstate,mr,mi,det(nk1,nk2,is))

if(ipriberry > 1 .and. printable) then
   write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
   write(nfout,'(1x,"ikp=",i4)') ikp
   write(nfout,'(1x,"ikprep=",i4)') nk2
   write(nfout,'(1x,"kg=",i0)') kg
   write(nfout,'(1x,"Real part:")')
   do j1=1,nstate
      write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
   end do
   write(nfout,'(1x,"Imag part:")')
   do j1=1,nstate
      write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
   end do
   write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
   write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(nk1,nk2,is)
end if

end do SPIN
deallocate(wfbp)
if(sw_deficit==ON) deallocate(fsr_k,fsi_k)

end if

if(nk1==jpara-1) then
  kg = min(kgbp2,kgbp0)

  allocate(wfbp(kgbp0,nstate,2,nspin))
  call copy_old_wfbp_to_temp_wfbp(kgbp0,wfbp0,wfbp) ! MPI
  if(sw_deficit == ON) then
    allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
    call copy_old_fs_to_temp_fs(fsr_k0,fsi_k0,fsr_k,fsi_k) ! MPI
! debug
! if(printable) then
!    do i=1,nlmta
!    do n=1,nstate
!      write(nfout,'("n=",i2," i=",i2," fsr_k0=",f10.5," fsr_k=",f10.5)') & 
!           &         n,i,fsr_k0(n,i),fsr_k(n,i)
!      write(nfout,'("n=",i2," i=",i2," fsi_k0=",f10.5," fsi_k=",f10.5)') & 
!           &         n,i,fsi_k0(n,i),fsi_k(n,i)
!    end do
!    end do
! end if
! end debug
  end if

  SPIN2: do is=1,nspin
  mr =0.d0; mi=0.d0
  ik = is
  do j2=1,nstate
    do j1=1,neg
      if(map_ek(j1,ik) /= mype) cycle
      j1_mpi = map_z(j1)
      j1_ordr = neordr(j1,ik)
      !if(printable) write(nfout,*) 'j1=',j1,' j1_mpi=',j1_mpi,' j1_ordr=',j1_ordr,' mype=',mype
      if(j1_ordr > nstate) cycle
      !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'
      do i=1,kg
        !debug
        !if(i<10.and.printable) write(nfout,'("OM: wfbp2 = ",2f10.5)')  wfbp2(i,j1_mpi,1:2)
        !if(i<10.and.printable) write(nfout,'("OM: wfbp0 = ",2f10.5)')  wfbp(i,j2,1:2)
        !debug end
        mr(j1_ordr,j2) = mr(j1_ordr,j2) + &
        & wfbp2(i,j1_mpi,1,is)*wfbp(i,j2,1,is) + wfbp2(i,j1_mpi,2,is)*wfbp(i,j2,2,is)
        mi(j1_ordr,j2) = mi(j1_ordr,j2) - &
        & wfbp2(i,j1_mpi,2,is)*wfbp(i,j2,1,is) + wfbp2(i,j1_mpi,1,is)*wfbp(i,j2,2,is)
      end do
      if(sw_deficit == ON) &
      & call add_deficit_term(mr(j1_ordr,j2),mi(j1_ordr,j2) &
      &                      ,fsr_k2,fsi_k2 &
      &                      ,fsr_k,fsi_k &
      &                      ,j1_mpi,j2,is)
    end do
  end do
  call mpi_barrier(mpi_comm_group,ierr)

! ==================== modified by K. Tagami ========= 0.1
!    deallocate(wfbp)
!    if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ==================================================== 0.1
  if(npes>1) then
    allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
    mr_mpi=0.d0; mi_mpi=0.d0
    call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum &
                     &,mpi_comm_group,ierr)
    mr = mr_mpi
    call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum &
                     &,mpi_comm_group,ierr)
    mi = mi_mpi
    deallocate(mr_mpi,mi_mpi)
  end if

  call determinant(nstate,mr,mi,det(jpara,nk2,is))

  if(ipriberry > 1 .and. printable) then
     write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') jpara,jpara+1,is
     write(nfout,'(1x,"ikprep=",i4)') nk2
     write(nfout,'(1x,"Real part:")')
     do j1=1,nstate
        write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
     end do
     write(nfout,'(1x,"Imag part:")')
     do j1=1,nstate
        write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
     end do
! =================== modified by K. Tagami ====== 0.1
!!     write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') jpara,jpara+1
       write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') jpara,jpara+1, is
! ================================================ 0.1
     write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(jpara,nk2,is)
  end if

  end do SPIN2

! ================= Added by K. Tagami ==== 0.1
  deallocate(wfbp)
  if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ===========================================

  if(allocated(wfbp0)) deallocate(wfbp0)
  if(allocated(wfbp1)) deallocate(wfbp1)
  if(allocated(wfbp2)) deallocate(wfbp2)
  if(allocated(fsr_k0)) deallocate(fsr_k0,fsi_k0)
  if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
  if(allocated(fsr_k2)) deallocate(fsr_k2,fsi_k2)

end if

contains

subroutine add_deficit_term(mr,mi,fr1,fi1,fr2,fi2,j1,j2,ispin)
use m_Const_Parameters,    only : SKIP
use m_Ionic_System,        only : natm, ityp
use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
       &                        , ltp,mtp,taup,ilmt &
       &                        , qitg_BP,iqitg,isph,il2p,dl2p &
       &                        , m_PP_include_vanderbilt_pot &
       &                        , n_non0_lmtxlmt &
       &                        , nlmta
implicit none
real(kind=DP), intent(inout) :: mr,mi
real(kind=DP), intent(in), dimension(np_e,nlmta,nspin) :: fr1,fi1
real(kind=DP), intent(in), dimension(nstate,nlmta,nspin) :: fr2,fi2
integer, intent(in) :: j1,j2,ispin

! local varialbes
integer :: ia,it,ik,ip,lmt1,lmt2,u,v
real(kind=DP) :: eps = 1.d-13
real(kind=DP) :: hsr,hsi
integer :: mdvdb

ATOM: do ia = 1, natm
  it = ityp(ia)
  mdvdb = m_PP_include_vanderbilt_pot(it)
  if(mdvdb == SKIP) cycle ATOM
! debug
!  if(printable) write(nfout,*) 'ia=',ia,' it=',it
! end debug
  LMT_1: do lmt1=1,ilmt(it)
    u = lmta(lmt1,ia)
    !LMT_2: do lmt2=lmt1,ilmt(it)
    LMT_2: do lmt2=1,ilmt(it)
      v = lmta(lmt2,ia)
      hsr = fr1(j1,u,ispin)*fr2(j2,v,ispin) + fi1(j1,u,ispin)*fi2(j2,v,ispin)
      hsi = fr1(j1,u,ispin)*fi2(j2,v,ispin) - fi1(j1,u,ispin)*fr2(j2,v,ispin)
      mr = mr + ftqer(lmt1,lmt2,ia)*hsr-ftqei(lmt1,lmt2,ia)*hsi
      mi = mi + ftqei(lmt1,lmt2,ia)*hsr+ftqer(lmt1,lmt2,ia)*hsi
! debug
!if(printable) then
!  write(nfout,*) '---- ftqe & hs ----'
!  write(nfout,*) 'lmt1 = ',lmt1
!  write(nfout,*) 'lmt2 = ',lmt2
!  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
!  write(nfout,*) 'hs   = ',hsr,hsi
!end if
! end debug
    end do LMT_2
  end do LMT_1
end do ATOM

end subroutine add_deficit_term

end subroutine m_BP_calc_det



subroutine copy_old_wfbp_to_temp_wfbp(kg,old_wfbp,temp_wfbp)
! === DEBUG by T.Kato 2013/07/11 ===============================================
!use m_Electronic_Structure, only : neg, neordr
use m_Electronic_Structure, only : neordr
use m_Control_Parameters, only : neg
! ==============================================================================
integer, intent(in) :: kg
real(kind=DP), intent(in) :: old_wfbp(kg,np_e,2,nspin)
real(kind=DP), intent(out) :: temp_wfbp(kg,nstate,2,nspin)

! local variables
real(kind=DP), allocatable :: tmp(:,:,:,:)
integer :: datasize,ie,je,j
integer :: is,ik

datasize = kg*mp_e*2*nspin
allocate(tmp(kg,mp_e,2,nspin)); tmp = 0.d0 ! MPI

! debug
!if(printable) then
!  write(nfout,*) 'copy wfbp to tmp'
!  write(nfout,*) 'kg=',kg
!  write(nfout,*) 'mp_e=',mp_e
!  write(nfout,*) 'datasize = ', datasize
!end if
! end debug
call mpi_barrier(mpi_comm_group,ierr)

do j=0,nrank_e-1
  if(j==myrank_e) tmp(1:kg,1:np_e,1:2,1:nspin) = old_wfbp(1:kg,1:np_e,1:2,1:nspin)
  call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
              & ,j,mpi_k_world(myrank_k),ierr)
  do is=1,nspin
  ik=is
  do ie = 1, nel_e(j)
    je = nis_e(j)-1+ie
    je = neordr(je,ik)
    if(je > nstate) cycle
    temp_wfbp(1:kg,je,1:2,is) = tmp(1:kg,ie,1:2,is)
  end do
  end do
  call mpi_barrier(mpi_comm_group,ierr)
end do

deallocate(tmp)

call mpi_barrier(mpi_comm_group,ierr)


end subroutine copy_old_wfbp_to_temp_wfbp


subroutine copy_old_fs_to_temp_fs(old_fsr,old_fsi,temp_fsr,temp_fsi)
! === DEBUG by T.Kato 2013/07/11 ===============================================
!use m_Electronic_Structure, only : neg, neordr
use m_Electronic_Structure, only : neordr
use m_Control_Parameters, only : neg
! ==============================================================================
use m_PseudoPotential,     only : nlmta
real(kind=DP), intent(in) :: old_fsr(np_e,nlmta,nspin),old_fsi(np_e,nlmta,nspin)
real(kind=DP), intent(out) :: temp_fsr(nstate,nlmta,nspin),temp_fsi(nstate,nlmta,nspin)

! local variables
real(kind=DP), allocatable :: tmp(:,:,:,:)
integer :: datasize,ie,je,j
integer :: is,ik

datasize = mp_e*nlmta*2*nspin
allocate(tmp(mp_e,nlmta,2,nspin)); tmp = 0.d0 ! MPI

! debug
!if(printable) then
!  write(nfout,*) 'copy fsr,fsi to tmp'
!  write(nfout,*) 'mp_e=',mp_e
!  write(nfout,*) 'nlmta =',nlmta
!  write(nfout,*) 'datasize = ', datasize
!end if
! end debug
call mpi_barrier(mpi_comm_group,ierr)

do j=0,nrank_e-1
  if(j==myrank_e) then
    tmp(1:np_e,1:nlmta,1,1:nspin) = old_fsr(1:np_e,1:nlmta,1:nspin)
    tmp(1:np_e,1:nlmta,2,1:nspin) = old_fsi(1:np_e,1:nlmta,1:nspin)
  end if
  call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
              & ,j,mpi_k_world(myrank_k),ierr)
  do is=1,nspin
  ik=is
  do ie = 1, nel_e(j)
    je = nis_e(j)-1+ie
    je = neordr(je,ik)
    if(je > nstate) cycle
    temp_fsr(je,1:nlmta,is) = tmp(ie,1:nlmta,1,is)
    temp_fsi(je,1:nlmta,is) = tmp(ie,1:nlmta,2,is)
  end do
  end do
  call mpi_barrier(mpi_comm_group,ierr)
end do

deallocate(tmp)

end subroutine copy_old_fs_to_temp_fs


subroutine constract_of_ftq()
use m_Const_Parameters,    only : SKIP,zi
use m_Ionic_System,        only : natm, ityp
use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
       &                        , ltp,mtp,taup,ilmt,nlmt &
       &                        , qitg_BP,iqitg,isph,il2p,dl2p &
       &                        , n_non0_lmtxlmt &
       &                        , m_PP_include_vanderbilt_pot &
       &                        , m_PP_find_maximum_l

! local varialbes
integer :: ia,it,ik,ip,lmt1,lmt2,u,v
real(kind=DP) :: fac
integer :: il1,il2,tau1,tau2,l3
integer :: n,ilm3,iiqitg
real(kind=DP) :: dk(3),ylm,dga
real(kind=DP) :: ftqr,ftqi,ftqb
integer :: mdvdb
integer, allocatable :: il3(:)

call m_PP_find_maximum_l(n)   !  n-1: maximum l
n = (n-1) + (n-1) + 1
allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

allocate(ftqer(nlmt,nlmt,natm)); ftqer=0.d0
allocate(ftqei(nlmt,nlmt,natm)); ftqei=0.d0

dk(1:3)=g(1:3)/jpara*PAI2

if(ipriberry > 0.and.printable) then
  write(nfout,*) '<< Construction of Qlmt(dk): start >>'
  write(nfout,*) 'dk = ', dk(1:3)
end if
! debug
!  do ia=1,natm
!    it = ityp(ia)
!    if(printable) write(nfout,'("ia=",i3," it=",i3)') ia,it
!    do ip=1,n_non0_lmtxlmt(it)
!    lmt1 = index_lmt1_lmt2(ip,it,1)
!      il1 = ltp(lmt1,it)
!      tau1 = taup(lmt1,it)
!      lmt2 = index_lmt1_lmt2(ip,it,2)
!      il2 = ltp(lmt2,it)
!      tau2 = taup(lmt2,it)
!      do n=1,il2p(lmt1,lmt2,it)
!        ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
!        iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
!        if(printable) write(nfout,'("lmt1=",i3,"lmt2=",i3,"n=",i3,"q_BP=",f10.5))') lmt1,lmt2,n,qitg_BP(1,iiqitg)
!      end do
!    end do
!  end do
! end debug

ATOM: do ia = 1, natm
  it = ityp(ia)
  mdvdb = m_PP_include_vanderbilt_pot(it)
  if(mdvdb == SKIP) cycle ATOM
! debug
!  if(printable) write(nfout,*) 'ia=',ia,' it=',it
! end debug
  LMT_1: do lmt1=1,ilmt(it)
    il1 = ltp(lmt1,it)
    tau1 = taup(lmt1,it)
    LMT_2: do lmt2=lmt1,ilmt(it)
      il2 = ltp(lmt2,it)
      tau2 = taup(lmt2,it)
! debug
!if(printable) then
!  write(nfout,*) 'lmt1 = ',lmt1
!  write(nfout,*) 'lmt2 = ',lmt2
!end if
! end debug
      ftqr = 0.d0
      ftqi = 0.d0
      LM3: do n=1,il2p(lmt1,lmt2,it)
        ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
        iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
        if(iiqitg == 0) cycle LM3
        call sphrp2_for_Berry(ilm3,dk,ylm)
        ftqb = qitg_BP(1,iiqitg)*dl2p(lmt1,lmt2,n,it)*ylm
! debug
!if(printable) then
!  write(nfout,*) '---- n = ',n,' ----'
!  write(nfout,*) 'l3 = ',l3
!  write(nfout,*) 'qitg_BP = ',qitg_BP(1,iiqitg)
!  write(nfout,*) 'dl2p    = ',dl2p(lmt1,lmt2,n,it)
!  write(nfout,*) 'ylm     = ',ylm
!  write(nfout,*) 'ftqb    = ',ftqb
!end if
! end debug
        if(mod(l3,2)==0) then
          ftqr=ftqr+real(zi**(-l3))*ftqb
        else
          ftqi=ftqi+dimag(zi**(-l3))*ftqb
        end if
      end do LM3
      ! remove exponetal factor
      !ftqer(lmt1,lmt2,ia) = ftqr*zfcos(ia)+ftqi*zfsin(ia)
      ftqer(lmt1,lmt2,ia) = ftqr
      ftqer(lmt2,lmt1,ia) = ftqer(lmt1,lmt2,ia)
      !ftqei(lmt1,lmt2,ia) = ftqi*zfcos(ia)-ftqr*zfsin(ia)
      ftqei(lmt1,lmt2,ia) = ftqi
      ftqei(lmt2,lmt1,ia) = ftqei(lmt1,lmt2,ia)
! debug
!if(printable) then
!  write(nfout,*) '---- ftqe ----'
!  write(nfout,*) 'ftq  = ',ftqr,ftqi
!  write(nfout,*) '(zfcos,zfsin) = ',zfcos(ia),zfsin(ia)
!  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
!end if
! end debug
    end do LMT_2
  end do LMT_1
end do ATOM

deallocate(il3)

if(ipriberry > 0.and.printable) then
  write(nfout,*) '<< Constuction of Qlmt(dk): end >>'
end if

end subroutine constract_of_ftq


subroutine BP_line_integral(phi,cphi,ikprep,ispin)
implicit none
real(kind=DP), intent(out) :: phi
complex(kind=DP), intent(out) :: cphi
integer, intent(in) :: ikprep, ispin

! local variables
integer :: k

cphi = cmplx(1.d0,0.d0)
do k=1,jpara
  if(printable) write(nfout,'(1x,"Det = ",e25.12," + i ",e25.12)') det(k,ikprep,ispin)
  cphi = cphi*det(k,ikprep,ispin)
end do

phi = dimag(log(cphi))

if(printable) then
   write(nfout,'("cphi = ",e25.12,1x,e25.12)') cphi
   write(nfout,'("phi = ",e25.12)') phi
end if


end subroutine BP_line_integral



subroutine m_BP_Polarization()
use m_Files, only : nfout, nfzaj
use m_Electronic_Structure, only : zaj_l, occup_l
use m_Crystal_Structure, only : univol
use m_Control_Parameters, only : nspin
use m_Ionic_System,        only : pos,natm

! =============================== KT_add =================== 13.0C
use m_Ionic_System,        only : ityp
use m_PseudoPotential, only : ival
! ========================================================== 13.0C

implicit none

! local variables
integer :: i,is,ia
real(kind=DP) :: glen, polar, dir(3)
real(kind=DP), allocatable :: phi(:,:) ! dim(nkprep)
complex(kind=DP), allocatable :: cphi(:,:) ! dim(nkprep)
real(kind=DP) :: fac
real(kind=DP) :: berry_phase, berry_ion, berry_tot
real(kind=DP) :: polar_ele, polar_ion, polar_tot, polar_max

if(mype /= 0) return ! MPI

allocate(phi(nkprep,nspin),cphi(nkprep,nspin))
do is=1,nspin
   do i=1,nkprep
      if(printable) &
      & write(nfout,'("is=",i3," ik=",i3," kprep=",2(1x,f10.5))') &
                 & is,i,kvec(1:2,i*jpara)
      call BP_line_integral(phi(i,is),cphi(i,is),i,is)
   end do
end do
glen = sqrt(sum(g(1:3)**2))

! =============================== KT_add  =================== 13.0C
berry_phase = 0.0d0
! =========================================================== 13.0C

do is = 1,nspin
   berry_phase = berry_phase + sum(phi(1:nkprep,is)*wgh(1:nkprep))
end do
fac = 2.d0/dble(nspin)
berry_phase = fac*berry_phase
berry_phase = 4.d0*atan(tan(0.25d0*berry_phase))
polar_ele = berry_phase/(univol*glen*PAI2)
berry_ion = 0.d0

do ia=1,natm
! ============================ KT_mod =================== 13.0C
!   berry_ion = berry_ion + pos(ia,ig)
   berry_ion = berry_ion + ival(ityp(ia)) *pos(ia,ig)
! ======================================================= 13.0C
end do

berry_ion = PAI2*berry_ion
berry_ion = 4.d0*atan(tan(0.25d0*berry_ion))
polar_ion = berry_ion/(univol*glen*PAI2)
berry_tot = 4.d0*atan(tan(0.25d0*(berry_ion+berry_phase)))
polar_tot = berry_tot/(univol*glen*PAI2)
polar_max = 1.d0/(univol*glen)

if(printable) then
   write(nfout,'("<< Results of Berry phase calc.")')

   do i=1,nkprep
      write(nfout,'("ik=",i3," kprep=",2(1x,f10.5))') i,kvec(1:2,i*jpara)
   end do
   write(nfout,'(1x,3x,"is",3x,"k",13x,"phi",18x,"wgh")')
   do is=1,nspin
      do i=1,nkprep
         write(nfout,'(1x,i4,1x,i4,2(1x,f20.10))') is,i,phi(i,is),wgh(i)
      end do
   end do

   dir(1:3) = g(1:3)/glen
   write(nfout,'(1x,"Unit cell volume        =",1x,e25.14)') univol
   write(nfout,'(1x,"direction of G          =",3(1x,e25.14))') dir(1:3)
   write(nfout,'(1x,"Berry phase (ele)       =",1x,e25.14)') berry_phase
   write(nfout,'(1x,"Berry phase (ion)       =",1x,e25.14)') berry_ion
   write(nfout,'(1x,"Berry phase (total)     =",1x,e25.14)') berry_tot
   write(nfout,'(1x,"Electronic polarization =",1x,e25.14)') polar_ele
   write(nfout,'(1x,"Ionic polarization      =",1x,e25.14)') polar_ion
   write(nfout,'(1x,"Total polarization      =",1x,e25.14)') polar_tot
   write(nfout,'(1x,"Maximun polarization    =",1x,e25.14)') polar_max

   write(nfout,'("   Results of Berry phase calc.>>")')
end if

call m_BP_write_Berry_phase(cphi,phi,nkprep)

deallocate(phi)

end subroutine m_BP_Polarization


subroutine m_BP_write_Berry_phase(cphi,phi,nkprep)
use m_Files, only : nfout, nfberry, m_Files_open_nfberry
use m_Ionic_System, only : displaced_atom,displacement,pos,natm
use m_Crystal_Structure, only : strain, sw_strained_cell
implicit none
integer, intent(in) :: nkprep
complex(kind=DP), intent(in) :: cphi(nkprep,nspin)
real(kind=DP), intent(in) :: phi(nkprep,nspin)

! local variables
integer :: i,ia,is

call m_Files_open_nfberry()
write(nfberry,'(3(1x,i5),3(1x,e25.14))') nkprep,ig,displaced_atom,displacement(1:3)
do is=1,nspin
do i=1,nkprep
   write(nfberry,'(i5,4(1x,e25.14))') i,cphi(i,is),phi(i,is),wgh(i)
end do 
end do
if(sw_strained_cell == ON) then
   write(nfberry,'(3(1x,e25.14))') strain(1,1:3)
   write(nfberry,'(3(1x,e25.14))') strain(2,1:3)
   write(nfberry,'(3(1x,e25.14))') strain(3,1:3)
   write(nfberry,*) natm
   do ia=1,natm
      write(nfberry,'(i7,3(1x,e25.14))') ia,pos(ia,1:3)
   end do
end if

end subroutine m_BP_write_Berry_phase


subroutine m_BP_write_wfbp
use m_Files, only : nfout, nfzaj
use m_PlaneWaveBasisSet, only : nbase, iba
use m_Electronic_Structure, only : totch, zaj_l
use m_Control_Parameters, only : nspin
implicit none

! local variables
integer :: jj,n,j,jmax

! debug
!integer :: is
!real(kind=DP) :: norm,defi
! end debug

if(nstate <= 0) nstate = int(totch + 1.d-13)/2

if(sw_deficit == ON) then
!  if(ikp==0) then
  if(ikp0) then
    call calc_phase_for_Berry()
    call constract_of_ftq()
    ikp0 = .false.
  end if
  call m_BP_save_betar_dot_WFs()
end if

if(allocated(wfbp2)) then
  if(allocated(wfbp1)) deallocate(wfbp1)
  kgbp1 = kgbp2
  allocate(wfbp1(kgbp1,np_e,2,nspin))
  wfbp1 = wfbp2
  deallocate(wfbp2)
end if

kgbp2 = nbase(iba(1),1)
allocate(wfbp2(kgbp2,np_e,2,nspin))

if(printable) then
   write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
   !write(nfout,*) 'debug iba=',iba(1)
   !write(nfout,*) 'debug kgbp2=',kgbp2
end if
do n=1,np_e
  !if(printable) write(nfout,'(1x,"n=",i3)') n
  jj=1
  do j=1,kgbp2
    if(nbase(jj,1) == j) then
      wfbp2(j,n,1,1:nspin) = zaj_l(jj,n,1:nspin,1)
      wfbp2(j,n,2,1:nspin) = zaj_l(jj,n,1:nspin,2)
      jj = jj + 1
    else
      wfbp2(j,n,1,1:nspin) = 0.d0
      wfbp2(j,n,2,1:nspin) = 0.d0
    end if
    ! debug
    !if(j < 21.and.printable) write(nfout,'("j=",i2,"wfbp=",2(1x,f10.5))') &
    !   & j,wfbp2(j,n,1,is),wfbp2(j,n,2,is)
    ! end debug
  end do
end do

! debug
!if(printable) then
!write(nfout,*) 'berry check norm: kgbp2=',kgbp2
!do is=1,nspin
!do n=1,np_e
!  defi = norm_deficit(n,is)
!  write(nfout,'(1x,"n=",i3," defi = ",f15.10)') n,defi
!  norm = 0.d0
!  do j=1,kgbp2
!    norm = norm + wfbp2(j,n,1)**2 + wfbp2(j,n,2)**2
!  end do
!  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
!  write(nfout,'(1x,"n=",i3," total norm = ",f15.10)') n,norm+defi
!end do
!end do
!call mpi_barrier(mpi_comm_group,ierr)
!end if
! end debug

if((jpara>1 .and. mod(ikp,jpara) /= 0) .or. jpara==1)  &
  & call m_BP_calc_det()

ikp = ikp + 1

contains

function norm_deficit(n,is) result(norm)
use m_PseudoPotential,     only : nlmta
use m_Electronic_Structure,only : fsr_l,fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
use m_Ionic_System,        only : natm, ityp
use m_PseudoPotential,     only : n_non0_lmtxlmt,index_lmt1_lmt2,lmta &
       &                          , ltp,mtp,ilmt,q

real(kind=DP) :: norm ! a result

integer, intent(in) :: n ! a band index
integer, intent(in) :: is ! a spin index

! local varialbes
integer :: ia,it,ik,ip,lmt1,lmt2,u,v
real(kind=DP) :: eps = 1.d-13
real(kind=DP) :: fac

norm = 0.d0

ik=is ! for ekcal mode

do ia = 1, natm
  it = ityp(ia)
! debug
!  if(printable) write(nfout,*) 'n_non0_lmtxlmt = ',n_non0_lmtxlmt(it)
! end debug
  LMT: do ip = 1, n_non0_lmtxlmt(it)
    lmt1 = index_lmt1_lmt2(ip,it,1)
    lmt2 = index_lmt1_lmt2(ip,it,2)
! debug
!if(printable) then
!  write(nfout,*) 'lmt1 = ',lmt1
!  write(nfout,*) 'lmt2 = ',lmt2
!end if
! end debug
    if(lmt2 < lmt1) cycle LMT
      u = lmta(lmt1,ia)
      v = lmta(lmt2,ia)
      if(ltp(lmt1,it) /= ltp(lmt2,it) .or. &
        & mtp(lmt1,it) /= mtp(lmt2,it) ) cycle LMT
      fac = q(lmt1,lmt2,it)
      if(abs(fac) < eps) cycle LMT
      if(lmt1 /= lmt2) fac=2.d0*fac
! debug
!if(printable) then
!  write(nfout,*) 'u = ',u
!  write(nfout,*) 'v = ',v
!  write(nfout,*) 'fsr = ',fsr_l(n,u,ik)
!  write(nfout,*) 'fsi = ',fsi_l(n,v,ik)
!  write(nfout,*) 'q = ',q(lmt1,lmt2,it)
!end if
! end debug
      norm = norm + &
           & fac*(fsr_l(n,u,ik)*fsr_l(n,v,ik)+fsi_l(n,u,ik)*fsi_l(n,v,ik))
  end do LMT
end do

end function norm_deficit

end subroutine m_BP_write_wfbp



subroutine m_BP_write_wfbp_gshift
use m_Files, only : nfout, nfzaj
use m_PlaneWaveBasisSet, only : kgp, ngabc, nbase, iba
use m_Electronic_Structure, only : totch, zaj_l
use m_Control_Parameters, only : nspin
implicit none

! local variables
integer :: jj,n,i,j,k,jmax
integer :: igs(3)
integer :: iga,igb,igc,jga,jgb,jgc

! debug
!real(kind=DP) :: norm
! end debug

if(mod(ikp,jpara)/=0) return

if(nstate <= 0) nstate = int(totch + 1.d-13)/2

igs(1:3) = 0
do i=1,3
  if(i == ig) igs(i) = 1
end do 

kgbp0 = 1
jj=1
if(printable) then
   write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
   !write(nfout,*) 'debug kgp=',kgp
   !write(nfout,*) 'debug iba=',iba(1)
end if
loop_i: do i=1,kgp
  iga = ngabc(i,1)+igs(1)
  igb = ngabc(i,2)+igs(2)
  igc = ngabc(i,3)+igs(3)
  if(jj>iba(1)) then
    kgbp0 =i-1
    exit loop_i
  end if
  loop_j: do j=1,iba(1)
    k=nbase(j,1)
    jga = ngabc(k,1)
    jgb = ngabc(k,2)
    jgc = ngabc(k,3)
    if(iga == jga .and. igb == jgb .and. igc == jgc) then
      jj=jj+1
      exit loop_j
    end if
  end do loop_j
end do loop_i

!if(printable) then
!write(nfout,*) 'debug jj=',jj
!write(nfout,*) 'debug kgbp0=',kgbp0
!end if

allocate(wfbp0(kgbp0,np_e,2,nspin)); wfbp0 = 0.d0
do n=1,np_e
  loop_i2: do i=1,kgbp0
    iga = ngabc(i,1)+igs(1)
    igb = ngabc(i,2)+igs(2)
    igc = ngabc(i,3)+igs(3)
    loop_j2: do j=1,iba(1)
      k=nbase(j,1)
      jga = ngabc(k,1)
      jgb = ngabc(k,2)
      jgc = ngabc(k,3)
      if(iga == jga .and. igb == jgb .and. igc == jgc) then
        wfbp0(i,n,1,1:nspin) = zaj_l(j,n,1:nspin,1)
        wfbp0(i,n,2,1:nspin) = zaj_l(j,n,1:nspin,2)
        exit loop_j2
      end if
    end do loop_j2
  end do loop_i2
  ! debug
  !if(printable) then
  !do j=1,20
  !  write(nfout,'("j=",i2,"wfbp0=",2(1x,f10.5))') &
  !     & j,wfbp0(j,n,1),wfbp0(j,n,2)
  !end do
  !end if
  ! end debug
end do
call mpi_barrier(mpi_comm_group,ierr)

! debug
!if(printable) then
!write(nfout,*) 'berry check norm (gshift): kgbp0=',kgbp0
!do n=1,np_e
!  norm = 0.d0
!  do j=1,kgbp0
!    norm = norm + wfbp0(j,n,1)**2 + wfbp0(j,n,2)**2
!  end do
!  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
!end do
!call mpi_barrier(mpi_comm_group,ierr)
!end if
! end debug

end subroutine m_BP_write_wfbp_gshift



subroutine m_BP_save_betar_dot_WFs
use m_Electronic_Structure,only : fsr_l, fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
use m_PseudoPotential,     only : nlmta, lmta, ilmt
use m_Ionic_System,        only : natm, ityp
implicit none

! local variables
integer :: ik,ia,i,j,n,nkp,ikprep,is

ik=1 ! for ekcal mode
nkp = mod(ikp,jpara)+1
ikprep = ikp/jpara + 1

! debug
!if(printable) then
!  write(nfout,*) 'debug(m_BP_save_betar_dot_WFs)'
!  write(nfout,*) 'nstate=',nstate
!  write(nfout,*) 'nlmta=',nlmta
!  write(nfout,*) 'jpara=',jpara
!  write(nfout,*) 'nkp=',nkp
!  write(nfout,*) 'ikprep=',ikprep
!end if
! end debug

if(allocated(fsr_k2)) then
   if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
   allocate(fsr_k1(np_e,nlmta,nspin),fsi_k1(np_e,nlmta,nspin))
   fsr_k1 = fsr_k2
   fsi_k1 = fsi_k2
   deallocate(fsr_k2,fsi_k2)
end if

allocate(fsr_k2(np_e,nlmta,nspin),fsi_k2(np_e,nlmta,nspin))
do is=1,nspin
do i=1,nlmta
  do n=1,np_e
    fsr_k2(n,i,is) = fsr_l(n,i,is)
    fsi_k2(n,i,is) = fsi_l(n,i,is)
  end do
end do
end do
if(nkp == 1) then
  allocate(fsr_k0(np_e,nlmta,nspin),fsi_k0(np_e,nlmta,nspin))
  do is=1,nspin
  do ia=1,natm
    do j=1,ilmt(ityp(ia))
       i=lmta(j,ia)
       do n=1,np_e
          fsr_k0(n,i,is) = fsr_l(n,i,is)*zfcos(ia)+fsi_l(n,i,is)*zfsin(ia)
          fsi_k0(n,i,is) = fsi_l(n,i,is)*zfcos(ia)-fsr_l(n,i,is)*zfsin(ia)
       end do
    end do
  end do
  end do
end if

end subroutine m_BP_save_betar_dot_WFs



subroutine determinant(n,mr,mi,det)
implicit none
integer, intent(in) :: n
real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
complex(kind=DP), intent(out) :: det

! local variables
integer :: i,pivot(n),parity
real(kind=DP) :: dr,di,dt

! debug
!if(printable) then
!write(nfout,'("before LU decomposition")')
!write(nfout,'("real part:")')
!do i=1,n
!   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
!end do
!write(nfout,'("imag part:")')
!do i=1,n
!   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
!end do
!end if
! end debug

call LU_decomposition(n,mr,mi,pivot,parity)

! debug
!if(printable) then
!write(nfout,'("after LU decomposition")')
!write(nfout,'("real part:")')
!do i=1,n
!   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
!end do
!write(nfout,'("imag part:")')
!do i=1,n
!   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
!end do
!end if
! end debug

dr=1.d0
di=0.d0
do i=1,n
  ! debug
  !if(printable) write(nfout,'(1x,i3," mr=",e25.12," mi=",e25.12)') i,mr(i,i),mi(i,i)
  ! end debug
  dt = dr*mr(i,i) - di*mi(i,i)
  di = di*mr(i,i) + dr*mi(i,i)
  dr = dt
end do
det = cmplx(dr,di)
det = parity*det

end subroutine determinant



subroutine LU_decomposition(n,mr,mi,pivot,parity)
implicit none
integer, intent(in) :: n
real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
integer, intent(out) :: pivot(n),parity

! local variables
integer :: i,j,k,imax
real(kind=DP) :: big,scaling(n)
real(kind=DP) :: t,dr,di
real(kind=DP) :: sumr,sumi,mt

real(kind=DP), parameter :: eps = 3.5d-15

parity = 1

do i=1,n
  big = 0.d0
  do j=1,n
    t = sqrt( mr(i,j)**2 + mi(i,j)**2 )
    if(t > big)  big = t
  end do
  if(big == 0.d0) then
    if(printable) then
       write(nfout,*) 'Error(LU_decomposition): Singular matrix'
       write(nfout,*) 'i=',i
    end if
    stop 'LU_decomposition'
  else
    scaling(i) = 1.d0/big
  end if
end do

do j=1,n
  do i=1,j-1
    sumr=0.d0
    sumi=0.d0
    do k=1,i-1
      sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
      sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
    end do
    mr(i,j) = mr(i,j) - sumr
    mi(i,j) = mi(i,j) - sumi
  end do
  big = 0.d0
  do i=j,n
    sumr=0.d0
    sumi=0.d0
    do k=1,j-1
      sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
      sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
    end do
    sumr = mr(i,j) - sumr
    sumi = mi(i,j) - sumi
    t = scaling(i)*sqrt(sumr**2+sumi**2)
    if( t >= big) then
      big = t
      imax = i
    end if
    mr(i,j) = sumr
    mi(i,j) = sumi
  end do
  if(j /= imax) then
    do k=1,n
      dr = mr(imax,k)
      di = mi(imax,k)
      mr(imax,k) = mr(j,k)
      mi(imax,k) = mi(j,k)
      mr(j,k) = dr
      mi(j,k) = di
    end do
    parity = -parity
    scaling(imax) = scaling(j)
  end if
  pivot(j) = imax
  if( dsqrt(mr(j,j)**2+mi(j,j)**2) < eps ) then
    mr(j,j) = 0.d0
    mi(j,j) = 0.d0
  end if
  if(j /= n ) then
    t  =  mr(j,j)**2 + mi(j,j)**2
    dr =  mr(j,j)/t
    di = -mi(j,j)/t
    do i=j+1,n
      mt      = mr(i,j)*dr - mi(i,j)*di
      mi(i,j) = mi(i,j)*dr + mr(i,j)*di
      mr(i,j) = mt
    end do
  end if
end do

end subroutine LU_decomposition

subroutine m_BP_wd_cntn_data()
  use m_Files, only : nfcntn_berry,m_Files_open_nfcntn_berry,m_Files_close_nfcntn_berry,nfout
  use m_ErrorMessages, only : EOF_REACHED
  logical :: logica

  if(.not.allocated(det)) return 
  call m_Files_open_nfcntn_berry()
  rewind nfcntn_berry
  if(mype==0)then
     write(nfcntn_berry) ikp
     write(nfcntn_berry) kgbp0
     write(nfcntn_berry) kgbp1
     write(nfcntn_berry) kgbp2
     write(nfcntn_berry) det
  endif

! fsr, fsi related
  logica = allocated(fsr_k2)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsr_k2,nfcntn_berry)

  logica = allocated(fsi_k2)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsi_k2,nfcntn_berry)

  logica = allocated(fsr_k1)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsr_k1,nfcntn_berry)

  logica = allocated(fsi_k1)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsi_k1,nfcntn_berry)

  logica = allocated(fsr_k0)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsr_k0,nfcntn_berry)

  logica = allocated(fsi_k0)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_fs(fsi_k0,nfcntn_berry)

! wf related
  logica = allocated(wfbp2)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_wf(kgbp2,wfbp2,nfcntn_berry)

  logica = allocated(wfbp1)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_wf(kgbp1,wfbp1,nfcntn_berry)

  logica = allocated(wfbp0)
  if(mype==0) write(nfcntn_berry) logica
  if(logica) call write_wf(kgbp0,wfbp0,nfcntn_berry)

  call m_Files_close_nfcntn_berry()

end subroutine m_BP_wd_cntn_data

subroutine m_BP_rd_cntn_data()
  use m_Files,           only : nfcntn_berry,m_Files_open_nfcntn_berry,m_Files_close_nfcntn_berry,nfout
  use m_PseudoPotential, only : nlmta
  use m_ErrorMessages,   only : EOF_REACHED
  logical :: logica
  if(.not.allocated(det)) return
  call m_Files_open_nfcntn_berry()
  rewind nfcntn_berry
  if(mype==0)then
     read(nfcntn_berry,end=9999,err=9999) ikp
     read(nfcntn_berry,end=9999,err=9999) kgbp0
     read(nfcntn_berry,end=9999,err=9999) kgbp1
     read(nfcntn_berry,end=9999,err=9999) kgbp2
     read(nfcntn_berry,end=9999,err=9999) det
  endif
  call mpi_bcast(ikp,1,mpi_double_precision,0,mpi_comm_group,ierr)
  call mpi_bcast(kgbp0,1,mpi_double_precision,0,mpi_comm_group,ierr)
  call mpi_bcast(kgbp1,1,mpi_double_precision,0,mpi_comm_group,ierr)
  call mpi_bcast(kgbp2,1,mpi_double_precision,0,mpi_comm_group,ierr)
  call mpi_bcast(det,jpara*nkprep*nspin,mpi_double_precision,0,mpi_comm_group,ierr)

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsr_k2)) allocate(fsr_k2(np_e,nlmta,nspin))
     call read_fs(fsr_k2,nfcntn_berry,1)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsi_k2)) allocate(fsi_k2(np_e,nlmta,nspin))
     call read_fs(fsi_k2,nfcntn_berry,2)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsr_k1)) allocate(fsr_k1(np_e,nlmta,nspin))
     call read_fs(fsr_k1,nfcntn_berry,3)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsi_k1)) allocate(fsi_k1(np_e,nlmta,nspin))
     call read_fs(fsi_k1,nfcntn_berry,4)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsr_k0)) allocate(fsr_k0(np_e,nlmta,nspin))
     call read_fs(fsr_k0,nfcntn_berry,5) 
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(.not.allocated(fsi_k0)) allocate(fsi_k0(np_e,nlmta,nspin))
     call read_fs(fsi_k0,nfcntn_berry,6)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if (logica) then
     if(allocated(wfbp2)) deallocate(wfbp2)
     allocate(wfbp2(kgbp2,np_e,2,nspin))
     call read_wf(kgbp2,wfbp2,nfcntn_berry,7)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if(logica) then
     if(allocated(wfbp1)) deallocate(wfbp1)
     allocate(wfbp1(kgbp1,np_e,2,nspin))
     call read_wf(kgbp1,wfbp1,nfcntn_berry,8)
  endif

  if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
  call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
  if(logica) then
     if(allocated(wfbp0)) deallocate(wfbp0)
     allocate(wfbp0(kgbp0,np_e,2,nspin))
     call read_wf(kgbp0,wfbp0,nfcntn_berry,9)
  endif

  call m_Files_close_nfcntn_berry()
  return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nfcntn_berry, __LINE__, __FILE__)
end subroutine m_BP_rd_cntn_data

subroutine write_fs(fs,nf)
!!$  use m_Electronic_Structure, only : neg
  use m_Control_Parameters, only : neg
  use m_PseudoPotential, only : nlmta
  real(kind=DP),intent(in),dimension(np_e,nlmta,nspin) :: fs
  integer, intent(in) :: nf
  real(kind=DP),allocatable,dimension(:,:) :: f
  integer :: is,ib
  integer :: ierr
  allocate(f(nlmta,nspin));f=0.0d0
  do is=1,nspin
    do ib=1,neg 
       if(map_ek(ib,is) == mype) then
          f(:,:) = fs(map_z(ib),:,:)
         if(map_ek(ib,is)/=0) call mpi_send(f,nlmta*nspin,mpi_double_precision,0,1,mpi_comm_group,ierr)
       else if (mype==0 .and. map_ek(ib,is) /= 0)then
          call mpi_recv(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
       endif
       if(mype==0) write(nf) f
    enddo
  enddo
  deallocate(f)
end subroutine write_fs

subroutine read_fs(fs,nf,tag)
!!$  use m_Electronic_Structure, only : neg
  use m_Control_Parameters, only : neg
  use m_PseudoPotential, only : nlmta
  use m_ErrorMessages, only : EOF_REACHED
  use m_Files, only : nfout
  real(kind=DP),intent(out),dimension(np_e,nlmta,nspin) :: fs
  integer, intent(in) :: nf
  integer, intent(in) :: tag
  real(kind=DP),allocatable,dimension(:,:) :: f
  integer :: is,ib
  integer :: ierr
  allocate(f(nlmta,nspin));f=0.0d0
  fs = 0.d0
  do is=1,nspin
    do ib=1,neg 
       if(mype==0) read(nf,end=9999,err=9999) f
       if(mype==0 .and. map_ek(ib,is)/=0)then
          call mpi_send(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
       else if (map_ek(ib,is)==mype .and. map_ek(ib,is) /= 0)then
          call mpi_recv(f,nlmta*nspin,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
       endif
       if(map_ek(ib,is) == mype) fs(map_z(ib),:,:) = f(:,:)
    enddo
  enddo
  deallocate(f)
  return
9999 continue
  call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)
end subroutine read_fs

subroutine write_wf(n1,wf,nf)
  use m_Control_Parameters, only : neg
  integer, intent(in) :: n1
  real(kind=DP), dimension(n1,np_e,2,nspin),intent(in) :: wf
  integer, intent(in) :: nf
  real(kind=DP), allocatable,dimension(:,:) :: wft
  integer :: is,ib
  integer :: ierr
  allocate(wft(n1,2));wft=0.d0
  do is=1,nspin
     do ib=1,neg
        if(map_ek(ib,is) == mype)then
           wft(:,1) = wf(:,map_z(ib),1,is)
           wft(:,2) = wf(:,map_z(ib),2,is)
           if(map_ek(ib,is)/=0) call mpi_send(wft,n1*2,mpi_double_precision,0,1,mpi_comm_group,ierr)
        else if (mype==0 .and. map_ek(ib,is) /= 0) then
           call mpi_recv(wft,n1*2,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
        endif
        if(mype==0) write(nf) wft
     enddo
  enddo
  deallocate(wft)
end subroutine write_wf

subroutine read_wf(n1,wf,nf,tag)
  use m_Control_Parameters, only : neg
  use m_ErrorMessages, only : EOF_REACHED
  use m_Files, only : nfout
  integer, intent(in) :: n1
  real(kind=DP), dimension(n1,np_e,2,nspin),intent(out) :: wf
  integer, intent(in) :: nf
  integer, intent(in) :: tag
  real(kind=DP), allocatable,dimension(:,:) :: wft
  integer :: is,ib
  integer :: ierr
  wf = 0.d0
  allocate(wft(n1,2));wft=0.d0
  do is=1,nspin
     do ib=1,neg
        if(mype==0) read(nf,end=9999,err=9999) wft
        if(mype==0 .and. map_ek(ib,is)/=0)then
           call mpi_send(wft,n1*2,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
        else if (map_ek(ib,is) == mype .and. map_ek(ib,is) /= 0) then
           call mpi_recv(wft,n1*2,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
        endif
        if(map_ek(ib,is) == mype) then
           wf(:,map_z(ib),1,is) = wft(:,1)
           wf(:,map_z(ib),2,is) = wft(:,2)
        endif
     enddo
  enddo
  deallocate(wft)
  return
9999 continue
  call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)
end subroutine read_wf

end module m_BerryPhase

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, this module is added.
!
! Company:  ASMS Co.,Ltd.
! Functions:
!
!     SpinOrbit strength (splitting) is read from GNCPP2 file
!
! =============================================================

module m_SpinOrbit_FromFile

  use m_Const_Parameters,  only : DP
  use m_Control_Parameters,  only: printable
  use m_Files, only : nfout, nfpot, m_Files_open_ps_files, m_Files_close_ps_files
  use m_Ionic_System,  only : natm, scaling_so, ivan, iatomn
  use m_Parallelization,  only : mype, npes, mpi_comm_group, ierr
  use m_PseudoPotential,  only : ntyp, ityp, Mat_SOC_Strength_nonpaw, nloc, ntau
  use m_Orbital_QuantumNum, only : num_orb_index_data, &
       &                           qnum_n_orb_index, qnum_l_orb_index, &
       &                           qnum_t_orb_index, qnum_tau_orb_index

  use m_SpinOrbit_Potential,  only : Mat_SOC_Strength

  implicit none
  include 'mpif.h'

contains

  subroutine m_SO_set_SOC_strength_from_PP
    integer :: it, nfp, ia, ierror

    if (mype == 0) then
       call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
       nfp = 0
       Do it=1, ntyp
          nfp = nfp +1
          call set_soc_from_pp_file( it, nfpot(nfp) )
       End Do
    endif

    if ( npes > 2 ) then
       call mpi_bcast( Mat_SOC_Strength_nonpaw, nloc*ntau*ntau*ntyp, &
            &          mpi_double_precision, 0, mpi_comm_group, ierr )
    endif

    Do ia=1, natm
       it = ityp(ia)
       Mat_SOC_Strength(:,:,:,ia) = Mat_SOC_Strength_nonpaw(:,:,:,it)  &
            &                       * scaling_so(it)
    End do

    call m_Files_close_ps_files

  contains

    subroutine set_soc_from_pp_file( it, nfp )
      integer, intent(in) :: it, nfp

      integer :: ikey
      character(len=30)    :: line

      integer :: num_soc_read
      integer :: i, j1, n1, l1, t1, n2, l2, t2, tau1, tau2
      real(kind=DP) :: c1
      
      num_soc_read = 0

      rewind(nfp)
      Do while (.true.)
         read(nfp,'(a30)',end=20) line
         ikey = index(line,'SOC-VALENCE')
         if ( ikey /=0 ) then
            read(nfp,*) num_soc_read
            goto 10
         endif
      End Do
      
! ------------------
10    Do i=1, num_soc_read
         read(nfp,*) n1, l1, t1, n2, l2, t2, c1
         
         if ( l1 /= l2 ) cycle
         
         tau1 = 0;  tau2 = 0
         Do j1=1, num_orb_index_data(it)
            if ( n1 == qnum_n_orb_index(it,j1) &
                 &    .and. l1 == qnum_l_orb_index(it,j1) &
                 &    .and. t1 == qnum_t_orb_index(it,j1) ) then       
               tau1 = qnum_tau_orb_index(it,j1)
            endif
         End do
         Do j1=1, num_orb_index_data(it)
            if ( n2 == qnum_n_orb_index(it,j1) &
                 &    .and. l2 == qnum_l_orb_index(it,j1) &
                 &    .and. t2 == qnum_t_orb_index(it,j1) ) then       
               tau2 = qnum_tau_orb_index(it,j1)
            endif
         End do

         if ( tau1 ==0 .or. tau2 == 0 ) cycle
         
         Mat_SOC_Strength_nonpaw( l1 +1, tau1, tau2, it ) = c1
      End Do

      return

! ------------------
20    if (printable) then
         write(nfout,*) "!* soc strength for valence are not found in PP for it=", it
      endif

    end subroutine set_soc_from_pp_file

  end subroutine m_SO_set_SOC_strength_from_PP

end module m_SpinOrbit_FromFile

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: Preparation_ep
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_ep
! $Id: Preparation_ep.f90 409 2014-10-27 09:24:52Z jkoga $
  use m_Control_Parameters,only: m_CtrlP_set_wct_start
  use m_Files,             only: nfout
  use m_Crystal_Structure, only: nbztyp_spg, m_CS_alloc_op_tau &
       &                       , m_CS_gnrt_symmetry_operations
  use m_Ionic_System,      only: m_IS_alloc_napt &
       &                       , m_IS_symm_check_of_pos
  use m_Force,             only: m_Force_alloc

  implicit none

  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  if(nbztyp_spg >= GENERAL) call m_Files_open_
!!$  call m_CS_gnrt_symmetry_operations(.true.,nfout,nfspg)
  call m_CS_gnrt_symmetry_operations(.true.,nfout)
!!$  if(.not.paramset) then
     call m_CS_alloc_op_tau(nfout)
!!$     call m_CS_gnrt_symmetry_operations(.false.,nfout,nfspg)
     call m_CS_gnrt_symmetry_operations(.false.,nfout)
     call m_IS_alloc_napt()
     call m_IS_symm_check_of_pos()
!!$  end if
  call m_Force_alloc()
end subroutine Preparation_ep

!   Multi Replica
!   Nudged Elastic Band Method
!   Nobutaka Nishikawa

module m_Replica

  use m_Ionic_System,  only : number_of_replicas
  use m_Const_Parameters,   only : DP

  type unit_cell_type

     real(kind=DP)  a, b, c, alpha, beta, gamma

  end type unit_cell_type

  type image_type

     integer num_atom

     type(unit_cell_type)  unit_cell

     real(kind=DP),pointer,dimension(:,:) :: pos, pos0, cps, cps0
     real(kind=DP),pointer,dimension(:,:) :: velocity, velocity0
     real(kind=DP),pointer,dimension(:,:) :: force, force0
     real(kind=DP),pointer,dimension(:,:) :: force_org, true_force, spring_force, tau

     real(kind=DP)  energy, energy0
     !real(8)  total_energy
     !real(8)  potential_energy

     real(8)  k_spring, k_spring0

     integer, pointer :: fix_flag(:)

     logical scf_convergence

  end type image_type

  type neb_cond_type

     integer  condition
     integer  ci_neb_start, ci_neb_end
     logical  climbing_image
     real(8)  k_spring_init, k_spring_min, k_spring_max

     logical k_constant
     logical k_variable
     logical k_damping
     real(8) k_damping_factor

     logical penalty_function

     integer convergence_condition
     real(8) convergence_threshold

     character(20) time_integral

  end type neb_cond_type

  type neb_file_type

     character(100)  F_OUT
     character(100)  F_DYNM
     character(100)  F_ENF
     character(100)  F_CHGT
     character(100)  F_CNTN
     character(100)  F_CNTN_BIN
     character(100)  F_ZAJ
     character(100)  F_CHR

     character(100)  F_NEB_OUT

! ======================== KT_add ================= 13.0D
     character(100)  F_CNTN_BIN_PAW
! ================================================= 13.0D

  end type neb_file_type

  type neb_type

     integer  number_of_images
     integer  max_iteration

     type(image_type), pointer :: image(:)
     type(neb_cond_type) :: cond
     type(neb_file_type) :: file

     integer  step
     real(kind=DP)  time
     real(kind=DP)  dt

     ! temporary
     real(kind=DP),pointer,dimension(:,:) :: energy

  end type neb_type

  type(neb_type)  neb
  integer nrank_r, mype_r
  integer, allocatable :: npes_image(:)

  contains

  subroutine m_Replica_finalize()
    integer :: i,j
    do i=1,neb%number_of_images
      deallocate(neb%image(i)%pos)
      deallocate(neb%image(i)%pos0)
      deallocate(neb%image(i)%cps)
      deallocate(neb%image(i)%cps0)
      deallocate(neb%image(i)%tau)
      deallocate(neb%image(i)%force)
      deallocate(neb%image(i)%force0)
      deallocate(neb%image(i)%force_org)
      deallocate(neb%image(i)%spring_force)
      deallocate(neb%image(i)%true_force)
      deallocate(neb%image(i)%fix_flag)
      deallocate(neb%image(i)%velocity)
      deallocate(neb%image(i)%velocity0)
    enddo
    deallocate(neb%energy)
    deallocate(neb%image)
  end subroutine m_Replica_finalize


end module m_Replica

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for tools used in the LR-TDDFT.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_tools

  use m_Const_Parameters,               only : DP, CARTS, BUCS, PAI, PAI2, PAI4,  &
       &                                       ELECTRON, INVERSE, ON, OFF, CMPLDP, &
       &                                       GAMMA

  use m_Files,                          only : nfout
  use m_FFT,                            only : nfft, m_FFT_WF

  use m_Kpoints,                        only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, & 
       &                                       vkxyz, qwgt, &
       &                                       k_symmetry
  use m_Control_Parameters,             only : ipri, nspin, kimg, af, neg, printable

  use m_Parallelization,                only : ista_e,iend_e,istep_e,map_z,np_e, &
    &                                          ista_k, iend_k, map_k, map_ek,  &
    &                                          myrank_k, myrank_e, map_e, npes, & 
    &                                          mpi_comm_group, ierr, mype, istatus  

  use m_Electronic_Structure, only : zaj_l, occup_l, eko_l, eko_ek, neordr, efermi
  use m_PlaneWaveBasisSet,    only : ngabc,igf,kg1,kg, iba, nbase, nbase_gamma
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged

  use m_Timing,                     only : tstatc0_begin, tstatc0_end

!  use m_LinearResponse_Control,     only : Num_Q_Points
  use m_Control_Parameters,     only : Num_Q_Points, sw_LinearResponse

! ----------------------------
  use m_LinearResponse_Control,         only : vqxyz, vec_q, nrd_efermi
  use m_LinearResponse_Control,         only : sw_tddft,  sw_LongWaveLimit
! ------------------- USPP ---
  use m_PseudoPotential,        only : modnrm, nlmta
  use m_Const_Parameters,       only : EXECUT
  use m_Electronic_Structure,    only : fsr_l, fsi_l

  use m_FFT,                    only : nfftp, m_FFT_CD_INVERSE_c
  use m_Parallelization,         only : ista_kngp, iend_kngp, &
       &                                ista_fftp, iend_fftp
  use m_PlaneWaveBasisSet,    only : kgp
! -----------------------------
  Implicit None
  include 'mpif.h'
  
  ! --------------------- temporary work arrays ------------------------
  real(kind=DP), allocatable :: wfn_k(:,:,:,:), wfn_kmq(:,:,:,:)
  integer,  allocatable      :: map_z_k(:), map_z_kmq(:)
  integer,  allocatable      :: nbase_k( :,: ), nbase_kmq(:,:)
  integer,  allocatable      :: igf_k(:), igf_kmq(:), iba_k(:), iba_kmq(:)
  !
  real(kind=DP), allocatable :: occup_k(:,:), occup_kmq(:,:)
  real(kind=DP), allocatable :: eko_k(:,:), eko_kmq(:,:)  
! -------------------- For USPP -------------
  real(kind=DP), allocatable :: fsval_k(:,:,:,:), fsval_kmq(:,:,:,:)
 ! ---------------------------------------------------------

contains

!----------------------------------------------------
!!
!!!         Alloc and Dealloc temporary arrays
!!
!----------------------------------------------------
  subroutine m_LR_alloc_Array_WFns
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( wfn_k  ( kg1, np_e, kv3, kimg) ); wfn_k = 0.0d0
       Allocate( wfn_kmq( kg1, np_e, kv3, kimg) ); wfn_kmq = 0.0d0
    else
       Allocate( wfn_k  ( kg1, np_e, kv3, kimg) ); wfn_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_WFns

  subroutine m_LR_dealloc_Array_WFns
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( wfn_k, wfn_kmq )
    else
       Deallocate( wfn_k )
    endif
  end subroutine m_LR_dealloc_Array_WFns

  subroutine m_LR_alloc_Array_MapFns
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( map_z_k  ( neg ) );      map_z_k = 0
       Allocate( map_z_kmq( neg ) );      map_z_kmq = 0
       Allocate( nbase_k  ( kg1, kv3 ) ); nbase_k = 0
       Allocate( nbase_kmq( kg1, kv3 ) ); nbase_kmq = 0
       Allocate( igf_k  ( kg ) );         igf_k = 0
       Allocate( igf_kmq( kg ) );         igf_kmq = 0
       Allocate( iba_k  ( kv3 ) );        iba_k = 0
       Allocate( iba_kmq( kv3 ) );        iba_kmq = 0
    else
       Allocate( map_z_k  ( neg ) );      map_z_k = 0
       Allocate( nbase_k  ( kg1, kv3 ) ); nbase_k = 0
       Allocate( igf_k  ( kg ) );         igf_k = 0
       Allocate( iba_k  ( kv3 ) );        iba_k = 0
    endif
  end subroutine m_LR_alloc_Array_MapFns

  subroutine m_LR_dealloc_Array_MapFns
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( map_z_k, map_z_kmq ); Deallocate( nbase_k, nbase_kmq )
       Deallocate( igf_k, igf_kmq );     Deallocate( iba_k, iba_kmq )
    else
       Deallocate( map_z_k );        Deallocate( nbase_k )
       Deallocate( igf_k );          Deallocate( iba_k )
    endif
  end subroutine m_LR_dealloc_Array_MapFns

  subroutine m_LR_alloc_Array_Occups
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( occup_k( neg, ista_k:iend_k) );   occup_k = 0.0d0
       Allocate( occup_kmq( neg, ista_k:iend_k) ); occup_kmq = 0.0d0
    else
       Allocate( occup_k( neg, ista_k:iend_k) ); occup_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_Occups

  subroutine m_LR_dealloc_Array_Occups
    if ( sw_LongWaveLimit == OFF ) then
       deallocate( occup_k, occup_kmq )
    else
       deallocate( occup_k )
    endif
  end subroutine m_LR_dealloc_Array_Occups

  subroutine m_LR_alloc_Array_EigenVals
    if ( sw_LongWaveLimit == OFF ) then
    else
       Allocate( eko_k( neg, ista_k:iend_k ) );     eko_k = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_EigenVals

  subroutine m_LR_dealloc_Array_EigenVals
    if ( sw_LongWaveLimit == OFF ) then
    else
       deallocate( eko_k )
    endif
  end subroutine m_LR_dealloc_Array_EigenVals

  subroutine m_LR_alloc_Array_CorePart
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( fsval_k  ( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_k   = 0.0d0
       Allocate( fsval_kmq( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_kmq = 0.0d0
    else
       Allocate( fsval_k  ( np_e, nlmta, ista_k:iend_k, kimg ) ); fsval_k   = 0.0d0
    endif
  end subroutine m_LR_alloc_Array_CorePart

  subroutine m_LR_dealloc_Array_CorePart
    if ( sw_LongWaveLimit == OFF ) then
       Deallocate( fsval_k, fsval_kmq )
    else
       Deallocate( fsval_k )
    endif
  end subroutine m_LR_dealloc_Array_CorePart
!-------------------------------------------------------------
!!
!!!      obtain a wavefunction in the real space
!!
!--------------------------------------------------------------
  subroutine Get_WF_in_Rspace( ik, ib, wfn_in, bfft, &
       &                       nbase_in, iba_in, igf_in, map_z_in )
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP), intent(in) :: wfn_in( kg1, np_e, kv3, kimg )

    integer, intent(in) :: ik, ib
    integer, intent(in) :: nbase_in( kg1,kv3 )
    integer, intent(in) :: igf_in( kg )
    integer, intent(in) :: iba_in( kv3 )
    integer, intent(in) :: map_z_in( neg )

    integer :: i,i1, ri, j, i2, ii
! --------------------------------------- start --------------
    bfft = 0.d0
! --------------------------------------- main ---------------
    if ( k_symmetry(ik) == GAMMA ) then
       if ( kimg == 1 ) then
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 7'
          i1 = igf_in(1)
          bfft(i1) = wfn_in(1, ib, ik, 1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_in(ik)
             i = nbase_in(ii,ik)
             i1 = igf_in(i)
             bfft(i1) = wfn_in(ii, ib, ik, 1)
             j = nbase_gamma(ii,2)
             i2 = igf_in(j)
             bfft(i2) = wfn_in(ii, ib, ik, 2)
          end do
       else ! kimg == 2
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 8'
          i1 = 2*igf_in(1) - 1
          bfft(i1)   = wfn_in(1, ib, ik, 1)
          bfft(i1+1) = wfn_in(1, ib, ik, 2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_in(ik)
             i = nbase_in( ii,ik )
             i1 = 2*igf_in(i)-1
             bfft(i1  ) = wfn_in(ii, ib, ik, 1)
             bfft(i1+1) = wfn_in(ii, ib, ik, 2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf_in(j)-1
             bfft(i2  ) =  wfn_in(ii, ib, ik, 1)
             bfft(i2+1) = -wfn_in(ii, ib, ik, 2)
          end do
       end if
    else
      if(kimg == 1) then
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 9'
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba_in(ik)
           i1 = igf_in( nbase_in(i,ik) )
           bfft(i1) = wfn_in( i, ib, ik, 1 )
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
!         write(*,*) 'YYYYYYYYYYYYYYYYYYYYYYYYYYY 10'
        do i = 1, iba_in(ik)
           i1 = 2*igf_in( nbase_in( i,ik ) ) - 1
           bfft(i1) = wfn_in( i, ib, ik, 1 )
           i2 = 2*igf_in( nbase_in(i,ik) )
           bfft(i2) = wfn_in( i, ib, ik, 2 )
        end do
      end if
    end if
! ----------------------
    call m_FFT_WF( ELECTRON,nfout,bfft,INVERSE,OFF )
!p    call m_FFT_WF( ELECTRON,nfout,bfft,INVERSE,ON )
  end subroutine Get_WF_in_Rspace

  subroutine Get_WF_in_Rspace_CD( ik, ib, wfn_in, bfft, &
       &                          nbase_in, iba_in, igfp_LR_in, map_z_in )
! --
    real(kind=DP), intent(in) :: wfn_in( kg1, np_e, ista_k:iend_k, kimg )
    real(kind=DP), intent(inout) :: bfft(ista_fftp:iend_fftp)

    integer, intent(in) :: ik, ib
    integer, intent(in) :: nbase_in( kg1,kv3 )
    integer, intent(in) :: iba_in( kv3 )
    integer, intent(in) :: map_z_in( neg )
    integer, intent(in) :: igfp_LR_in( kgp )

    integer :: i,i1, ri, j, i2, ii
    integer :: jb

    real(kind=DP), allocatable :: bfft_mpi(:)
! -------
    bfft = 0.0d0
    if ( npes > 1 ) then
       allocate( bfft_mpi( nfftp )); bfft_mpi = 0.0d0
       if ( map_e( ib ) == myrank_e ) then
          jb = map_z_in( ib )
          do ri = 1, kimg
             do i = 1, iba_in(ik)
                i1 = kimg *igfp_LR_in( nbase_in(i,ik) ) + (ri - kimg)
                bfft_mpi(i1) = wfn_in( i, jb, ik, ri )   ! MPI
             end do
          end do
       endif
       call mpi_bcast( bfft_mpi, nfftp, MPI_DOUBLE_PRECISION, &
            &          map_e(ib), mpi_comm_group, ierr )
       if ( ierr /= 0 ) write(*,*) 'MPI error ', mype, ierr
       bfft(ista_fftp:iend_fftp) = bfft_mpi(ista_fftp:iend_fftp)

       deallocate( bfft_mpi )
    else
       do ri = 1, kimg
          do i = 1, iba_in(ik)
             i1 = kimg *igfp_LR_in( nbase_in(i,ik) ) + (ri - kimg)
             bfft(i1) = wfn_in( i, ib, ik, ri )   ! MPI
          end do
       end do
    endif
! --
    call m_FFT_CD_inverse_c( nfout, bfft )   ! From G- to R-space

  end subroutine Get_WF_in_Rspace_CD
!--------------------------------------------------------
!!
!!!            Copying tools
!!
!--------------------------------------------------------

  subroutine Copy_Zaj_To( Wfn_target ) 
    real(kind=DP), intent(inout) ::  Wfn_target ( kg1, np_e, ista_k:iend_k, kimg )

! ------------------------------ start -----------
    Wfn_target( 1:kg1, 1:np_e, ista_k:iend_k, 1:kimg ) &
         & = zaj_l( 1:kg1, 1:np_e, ista_k:iend_k, 1:kimg )
! ------------------------------ end -----------
  end subroutine Copy_Zaj_To
    
  subroutine Copy_HardPart_To( fs_target )
    real(kind=DP), intent(inout) :: fs_target( np_e, nlmta, ista_k:iend_k, kimg ) 
! ---------------------------------- main ---------
    fs_target( 1:np_e, 1:nlmta, ista_k:iend_k, 1 ) &
         & = fsr_l( 1:np_e, 1:nlmta, ista_k:iend_k )
    if ( kimg ==2 ) then
       fs_target( 1:np_e, 1:nlmta, ista_k:iend_k, 2 ) &
            & = fsi_l( 1:np_e, 1:nlmta, ista_k:iend_k )
    endif
  end subroutine Copy_HardPart_To

  subroutine Copy_EigenVals_To( Eko_target, occup_tmp )
    real(kind=DP), intent(out)           :: Eko_target( neg, kv3 )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer :: ik, ie
! -------------------------- start -------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! --------------------------- main -------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    Eko_target = e2_mpi
    if ( nrd_efermi==ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
    endif
! ------------------- end ------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_EigenVals_To

  subroutine Copy_MapZ_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg )
    MapFunction  = map_z
  end subroutine Copy_MapZ_To

  subroutine Copy_MapE_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg )
    MapFunction  = map_e
  end subroutine Copy_MapE_To

  subroutine Copy_MapEK_To( MapFunction )
    integer, intent(inout) :: MapFunction( neg, kv3 )
    MapFunction  = map_ek
  end subroutine Copy_MapEK_To

  subroutine Copy_NBase_To( MapFunction )
    integer, intent(inout) :: MapFunction( kg1, kv3 )
    MapFunction  = nbase
  end subroutine Copy_NBase_To

  subroutine Copy_Igf_To( MapFunction )
    integer, intent(inout) :: MapFunction( kg  )
    MapFunction  = igf
  end Subroutine Copy_Igf_To

  subroutine Copy_Iba_To( MapFunction )
    integer, intent(inout) :: MapFunction( kv3 )
    MapFunction  = iba
  end subroutine Copy_Iba_To

  subroutine Copy_Eko_Or_Occ_To( MatA, MatB )
    real(kind=DP), intent(in)    ::  MatA( neg, kv3 )
    real(kind=DP), intent(inout) ::  MatB( neg, kv3_ek )
    integer i, ik

    Do ik=1, kv3
       Do i=1, neg
          MatB( i, ik + nk_in_the_process -1 ) = MatA( i,ik )
       End do
    End do
  end subroutine Copy_Eko_Or_Occ_To

  subroutine Copy_Eko_To( MatA, MatB )
    real(kind=DP), intent(in)    ::  MatA( neg, kv3 )
    real(kind=DP), intent(inout) ::  MatB( neg, kv3_ek )
    integer i, ik

    Do ik=1, kv3
       Do i=1, neg
          MatB( i, ik + nk_in_the_process -1 ) = MatA( i,ik )
       End do
    End do
  end subroutine Copy_Eko_To

  subroutine Copy_EigenVals_To2( Eko_target, Occup_target, occup_tmp )
    real(kind=DP), intent(out)           :: Eko_target( neg, kv3_ek )
    real(kind=DP), intent(out), optional :: Occup_target( neg, kv3_ek )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer ik, ie, i
! -------------------------- start -----------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! -------------------------- main -----------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    Do ik=1, kv3
       Do i=1, neg
          Eko_target( i, ik + nk_in_the_process -1 ) = e2_mpi( i,ik )
       End do
    End do
! -
    if ( nrd_efermi == ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
       Do ik=1, kv3
          Do i=1, neg
             Occup_target( i, ik + nk_in_the_process -1 ) = occup_tmp( i,ik )
          End do
       End do
    endif
! ------------------------- end ---------------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_EigenVals_To2
  
  subroutine Copy_Occups_To( occup_tmp )
    real(kind=DP), intent(out), optional :: occup_tmp( neg, kv3 )
!
    real(kind=DP), allocatable :: e_mpi(:,:), e2_mpi(:,:)
    integer ik, ie, i
! -------------------------- start ----------
    allocate( e_mpi(neg,kv3));   e_mpi = 0.0d0
    allocate(e2_mpi(neg,kv3));  e2_mpi = 0.0d0
! --------------------------- main ----------
    Do ik = 1, kv3
       if ( map_k(ik) /= myrank_k ) cycle
       Do ie = 1, neg
          if ( map_e(ie) /= myrank_e ) cycle
          e_mpi( ie,ik ) = eko_l( map_z(ie),ik )
       End do
    End do
    if( npes >= 2 ) then
       call mpi_allreduce(e_mpi,e2_mpi,neg*kv3,mpi_double_precision &
            &               ,mpi_sum,mpi_comm_group,ierr)
    else
       e2_mpi = e_mpi
    end if
!
    if ( nrd_efermi == ON ) then
       Call Estimate_Ocuup_Simply( e2_mpi, occup_tmp )
    endif
! ------------------------- end --------------
    deallocate( e_mpi, e2_mpi )
  end subroutine Copy_Occups_To
  
  subroutine Estimate_Ocuup_Simply( eko_in, occup_out )
    real(kind=DP), intent(in)  :: eko_in( neg, kv3 )
    real(kind=DP), intent(out) :: occup_out( neg, kv3 )

    integer ik, j

    Do ik=1, kv3
       Do j=1, neg
          if ( eko_in( j,ik) < efermi ) then
             occup_out( j,ik ) = 1.0d0
          else
            occup_out( j,ik ) = 0.0d0
          endif
       End do
    End do
  end subroutine Estimate_Ocuup_Simply

end module m_LinearResponse_tools

       subroutine tred1(n, a, nma0,
     &                  d_out, e_out, nme0, m_orig)
       implicit NONE

       include 'mpif.h'

       integer                :: n, nma0, nme0, m_orig
       integer                :: nm, ne, m
       real(8)                :: a(*)
       real(8)                :: d_out(*), e_out(*)

       include 'trd.h'
       include 'CSTAB.h'

       integer                :: nm0, nx0
       integer                :: i_1,j_1, i, j, k, j_2, j_3
       integer                :: nx, ierr

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*4*2


       real(8)                :: d1, d2
       real(8)                :: c1, c2

       integer :: lda, ldz, nz

!Kro   nm = nma0
       ne = nme0
       m  = m_orig

       call datacast_init(2)

       lda = nma0
!Kro   ldz = (n-1)/x_nnod+1
!Kro   call CSTAB_get_optdim(ldz,9,nm_max_L1,nm_max_L2,nx)
!Kro   ldz = nx
!Kro   nz = (n-1)/y_nnod+1

       call tred1_(a, lda, d_out, e_out, ne, n, m)

       call datacast_free(1)

       return
       end subroutine ! tred1

       subroutine tred1_(a, nm, d_out, e_out, ne, n, m_orig)
       implicit NONE

       include 'mpif.h'

       integer                :: n, nm, ne, nmx, nv, nvx, m_orig
       real(8)                :: a(1:nm,*)
       real(8)                :: d_out(1:n)
       real(8)                :: e_out(1:ne,*)

       real(8), pointer       :: u_t(:), v_t(:), d_t(:)
       real(8), pointer       :: w(:)
       real(8), pointer       :: ux_vx(:)
       real(8), pointer       :: uy_vy(:)

       include 'trd.h'
       include 'CSTAB.h'
       include 'param.h'

       real(8)                :: d1,d2
       real(8)                :: d3,d4
       integer                :: nm_orig, nx, n1, n2, n3
       integer                :: i,j,k

       integer                :: ierr, kx

       integer                :: offset1, offset2, offset3
       integer                :: offset4, offset5, offset6
       integer                :: offset7, offset8

       integer, parameter     :: nm_max_L1 = 16*4
       integer, parameter     :: nm_max_L2 = 16*6


!Kro
       integer                :: ny, nv1, nv2
           nx = (n-1)/x_nnod+1 +2
!          call CSTAB_get_optdim(nx, 6, nm_max_L1, nm_max_L2, nv)
           call CSTAB_get_optdim(nx, 6, nm_max_L1, nm_max_L2, nv1)
!Kro
           ny = (n-1)/y_nnod+1 +2
           call CSTAB_get_optdim(ny, 6, nm_max_L1, nm_max_L2, nv2)
           nv=max(nv1,nv2)
           if(TRD_inod==1)then
             PRINT*,"NV=",nv
           endif

       allocate(
     &           w(1:nm*m_orig+n_columns),
     &           v_t(1:MAX(2*nv,2*(n+3),2*8*m_orig)+n_columns),
     &           u_t(1:MAX(2*nv,2*(n+3),2*8*m_orig)+n_columns),
     &           d_t(1:nv+n_columns),
     &           ux_vx(1:nv*2*m_orig+2*n_columns),
     &           uy_vy(1:nv*2*m_orig+2*n_columns),
     &           stat=ierr)
       if ( ierr /= 0 ) then
          if ( TRD_inod == 1 ) print*,"Memory allocation error."
          call MPI_Abort(TRD_COMM_WORLD, 1, ierr)
       end if

       w = ZERO
       v_t = ZERO
       u_t = ZERO
       d_t = ZERO
       ux_vx = ZERO
       uy_vy = ZERO

       kx = nv*m_orig+n_columns
       call CSTAB_adjust_base(ux_vx(1), a(1,1),offset1)
       call CSTAB_adjust_base(ux_vx(1+kx), a(1,1),offset3)
       call CSTAB_adjust_base(uy_vy(1), a(1,1),offset2)
       call CSTAB_adjust_base(uy_vy(1+kx), a(1,1),offset4)
       call CSTAB_adjust_base(u_t(1),a(1,1),offset5)
       call CSTAB_adjust_base(v_t(1),a(1,1),offset6)
       call CSTAB_adjust_base(w(1),a(1,1),offset7)
       kx = (L1_WINDOW/8)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
       offset1 = offset1+kx*1
       offset2 = offset2+kx*2
       offset3 = offset3+kx*3
       offset4 = offset4+kx*4
       offset5 = offset5+kx*5
       offset6 = offset6+kx*6
       offset7 = offset7+kx*7
       call CSTAB_round_offset(offset1)
       call CSTAB_round_offset(offset2)
       call CSTAB_round_offset(offset3)
       call CSTAB_round_offset(offset4)
       call CSTAB_round_offset(offset5)
       call CSTAB_round_offset(offset6)
       call CSTAB_round_offset(offset7)

!!!
       kx = nv*m_orig+n_columns

!$OMP PARALLEL
       call trd_body(a, nm, d_out, e_out, ne,
     &               n, m_orig,
     &               w(1+offset7),
     &               ux_vx(1   +offset1),    ! u_x(1:nv,m)
     &               uy_vy(1   +offset2),    ! u_y(1:nv,m)
     &               ux_vx(1+kx+offset3),    ! v_x(1:nv,m)
     &               uy_vy(1+kx+offset4),    ! v_y(1:nv,m)
     &               u_t(1+offset5),
     &               v_t(1+offset6),
     &               d_t(1),
     &               nv)
!$OMP END PARALLEL

       deallocate(w)
       deallocate(v_t)
       deallocate(u_t)
       deallocate(d_t)
       deallocate(ux_vx)
       deallocate(uy_vy)

       return
       end subroutine ! tred1_

       subroutine trd_body(a, nm, d_out, e_out, ne,
     &               n, m_orig,
     &               w, u_x, u_y, v_x, v_y, u_t, v_t, d_t, nv)
       implicit NONE

       integer, intent(in)    :: n, nm, ne, nv, m_orig
       real(8)                :: a(1:nm,*)
       real(8)                :: d_out(1:n), e_out(1:ne,*)
       real(8)                :: w(1:nm,*)
       real(8)                :: u_x(1:nv,*), u_y(1:nv,*)
       real(8)                :: v_x(1:nv,*), v_y(1:nv,*)
       real(8)                :: u_t(1:2*nv), v_t(1:2*nv)
       real(8)                :: d_t(1:nv)

       include 'trd.h'

       real(8)                :: c(MBAND,MBAND), t1, t2, t3
       integer                :: i, j, k, l, m

       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: k_1, k_2, k_3, k_4
       integer                :: l_1, l_2, l_3, l_4

       integer                :: m0, mm
       integer                :: i_block, i_base

       integer                :: ii

       include 'mpif.h'
!$     include 'omp_lib.h'

       real(8)                :: d1,d2,dd(100)

!
! initialization
!
       dd = 0.0D+00
       m  = m_orig

!$OMP MASTER

       if ( TRD_inod == 1 ) then
          print*,"NUM.OF.PROCESS=",TRD_nnod,"(",x_nnod,y_nnod,")"
!$        print*,"NUM.OF.THREADS=",omp_get_num_threads()
       endif
       call flush(6)

       call tred1_init(a(1,1), nm, n,
     &         d_out(1), e_out(1,1), ne,
     &         u_t(1), v_t(1), nv)

!$OMP END MASTER

       if ( m > n ) then
          m = n
       end if
!
! main iteration to reduce the input matrix into a penta-diagonal
!
       mm = ((n-(MBAND+MOD(n,MBAND)))-1)/m+1+1

!$OMP BARRIER

       do i_block=mm,2,-1

!$OMP BARRIER

          i_base = (i_block-2)*m+(MBAND+MOD(n,MBAND))
          m0     = MIN(m,n-i_base)

!$OMP MASTER

!          print*, i_block, i_base, m0

          call tred1_load(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &            m0, i_base, i_block)

!$OMP END MASTER

          k_2 = m0
          k_3 = MAX(1,3*(2-i_block))

!$OMP BARRIER

          do k_1=k_2,k_3,-MBAND; k_4=k_1-MBAND+1

!$OMP BARRIER

             i = i_base+k_1
!
! u=...
!
!$OMP MASTER

             d1=MPI_Wtime()
             call tred1_u(
     &               w(1,k_4), nm,
     &               u_x(1,k_4), u_y(1,k_4), nv,
     &               u_t(1), v_t(1), i,
     &               c(1,1), e_out(1,1), ne)
             d2=MPI_Wtime()
             dd(1)=dd(1)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

!$OMP MASTER
             d1=MPI_Wtime()
!$OMP END MASTER
!
! v:=Au
!
             call tred1_au(
     &               a(1,1), nm,
     &               u_x(1,k_4), u_y(1,k_4), v_x(1,k_4), nv,
     &               u_t(1), v_t(1), d_t(1),
     &               i, i_base, m0)

!$OMP BARRIER

!$OMP MASTER
             d2=MPI_Wtime()
             dd(2)=dd(2)+(d2-d1)
!
! v=v-(UV+VU)u
!
             d1=MPI_Wtime()
             call tred1_vorhto(
     &               u_x(1,1), v_x(1,1), nv,
     &               u_t(1), v_t(1),
     &               i, i_base, m0)
             d2=MPI_Wtime()
             dd(5)=dd(5)+(d2-d1)

!
! v':= v-((u,v)/2|u|^2)u
!
             d1=MPI_Wtime()
             call tred1_v(
     &               u_x(1,k_4), v_x(1,k_4), v_y(1,k_4), nv,
     &               u_t(1), v_t(1), c(1,1), i)
             d2=MPI_Wtime()
             dd(4)=dd(4)+(d2-d1)
!
! w':= w-uv-vu
!
             d1=MPI_Wtime()
             call tred1_local_2update(
     &               w(1,1), nm,
     &               u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &               i_base, i)
             d2=MPI_Wtime()
             dd(6)=dd(6)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

          end do! k_1

!$OMP BARRIER

!!$OMP MASTER
!             print*,"A="
!             print*,a(1:3,1)
!             print*,a(1:3,2)
!             print*,a(1:3,3)
!!$OMP END MASTER

!$OMP MASTER

          call tred1_store(a(1,1), w(1,1), nm,
     &            d_t(1),
     &            m0, i_base)
!$OMP END MASTER

!!$OMP MASTER
!             print*,"A'="
!             print*,a(1:3,1)
!             print*,a(1:3,2)
!             print*,a(1:3,3)
!!$OMP END MASTER


!$OMP BARRIER

!$OMP MASTER
          d1=MPI_Wtime()
!$OMP END MASTER
!
! A:=A-v^Tu-uT^v
!
!          if ( i_block >= 1 ) then
!!$OMP MASTER
!             print*,"A''="
!             print*,a(1:3,1)
!             print*,a(1:3,2)
!             print*,a(1:3,3)
!!$OMP END MASTER
             call tred1_2update(
     &               a(1,1), nm,
     &               u_x(1,1), u_y(1,1), v_x(1,1), v_y(1,1), nv,
     &               m0, i_base)
!!$OMP MASTER
!             print*,"A'''="
!             print*,a(1:3,1)
!             print*,a(1:3,2)
!             print*,a(1:3,3)
!!$OMP END MASTER
!          end if

!$OMP BARRIER

!$OMP MASTER
          d2=MPI_Wtime()
          dd(3)=dd(3)+(d2-d1)

!$OMP END MASTER

!$OMP BARRIER

       end do! i_block

!$OMP BARRIER

!$OMP MASTER

!       print*,"D=",d_out(1:n)
!       print*,"E=",e_out(1:n,1)
!       print*,"F=",e_out(1:n,2)


       call tred1_final(a(1,1), nm, n,
     &         d_out(1), e_out(1,1), ne, u_t(1))

!       print*,"D=",d_out(1:n)
!       print*,"E=",e_out(1:n,1)
!       print*,"F=",e_out(1:n,2)

       if(TRD_inod==1)then
            print*,"calc (u,beta)    ",dd(1)
            print*,"mat-vec (Au)     ",dd(2),dble(n)**3*2d-9/3/dd(2)
            print*,"2update (A-uv-vu)",dd(3),dble(n)**3*2d-9/3/dd(3)
            print*,"calc v           ",dd(4)
            print*,"v=v-(UV+VU)u     ",dd(5)
            print*,"UV post reduction",dd(6)
       endif
       call flush(6)

!$OMP END MASTER

       return
       end subroutine ! trd_body

module m_timer
  implicit none
  integer, parameter :: dp = kind(0d0)
  integer, parameter :: n_tim = 1750
  integer :: iunit1 = 91
  integer :: iunit2 = 92
#ifdef USE_MEM
  integer :: unitmw = 93
  integer :: unitmr = 94
#endif
!--
!--
  integer, parameter :: n_ite = 10
!--
#ifdef USE_WTIME
  real(dp) :: t_now
  real(dp) :: timers(n_tim,0:n_ite), tsta(n_tim), ttot(3)
  real(dp) :: timers_all(n_tim)
#ifdef USE_MEM
  real(dp) :: t_sta
#endif
#else
  integer(8) :: t_now
  integer(8) :: timers(n_tim,0:n_ite), tsta(n_tim), ttot(3)
  integer(8) :: timers_all(n_tim)
#ifdef USE_MEM
  integer(8) :: t_sta
#endif
#endif
  integer  :: ncount(n_tim,0:n_ite), ncnt_e(n_tim,0:n_ite)
  integer  :: ncount_all(n_tim)
  character(50) :: name(n_tim)
  logical  :: tflag = .false.
  character(len=3) :: ite_num
  character(len=5) :: rnk_num
  character(len=80) :: fname
  character(len=80) :: dname
  character(len=5)  :: crank
  integer :: myrank  
  integer :: orank = 0

end module m_timer

!-----------------------------------------------------------------------
subroutine timer_init
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: ierr
  real(4) :: rdum, rarray(2)
!  real(4), external :: etime
  real(4) :: etime

  call MPI_COMM_RANK(MPI_COMM_WORLD, myrank, ierr)

#ifdef USE_MEM
  if (myrank .eq. 0) then
    open(unitmw,file='mem.txt',status='replace')
    write(unitmw,*) "Kukan Times[s] Virtual_Memory[B] Resident_Set_Size[Page]"
#ifdef USE_WTIME
    t_sta=MPI_WTIME()
#else
    call getclkreg(t_sta)
#endif
  endif
#endif

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

      ! init
      ktrace_target(1:n_tim) = 0
      ! set ktarce target
      ktrace_target(1:n_tim) = 1
!$omp parallel
      call ktrace_enter
!$omp end parallel

#endif

  ! real, user, sys of total
  rdum = etime(rarray)
#ifdef USE_WTIME
  ttot(1) = MPI_WTIME()  ! real
#else
  call getclkreg(ttot(1))! real
#endif
  ttot(2) = rarray(1)    ! user
  ttot(3) = rarray(2)    ! sys

  timers = 0.0d0
  tsta   = 0.0d0
  ncount = 0
  ncnt_e = 0

  name = '-'
  ! set timer name
! name(000) = '---------1---------2---------3---------4---------5---------6----'
  name( 1) =  'Kukan_1                                 '
  name( 2) =  'Kukan_2                                 '
  name( 3) =  'Kukan_3                                 '
  name( 4) =  'Kukan_4                                 '
  name( 5) =  'Kukan_5                                 '
  name( 6) =  'Kukan_6                                 '
  name( 7) =  'Kukan_7                                 '
!fj mod 20110819
! name( 8) =  'Kukan_8_latter_half_&_kukan_9           '
  name( 8) =  'Kukan_8_latter_half                     '
  name( 9) =  'kukan_9                                 '
!fj mod 20110819
  name(10) =  'Kukan_10                                '
  name(11) =  'Kukan_11                                '
  name(12) =  '  Solver_SD_or_MSD_(_or_CG_)            '
  name(13) =  '  Solver_lmSD_or_lmMSD_(_or_CG_)        '
  name(14) =  '  Solver_Submat                         '
  name(15) =  '  Solver_MATRIXDIAGON                   '
  name(16) =  'SCF_Loop                                '
  name(17) =  'Initialization                          '
  name(18) =  '  Solver_RMM                            '
  name(19) =  'Forces                                  '
  name(20) =  'Move_Ions                                '
!fj mod 20110906
  name(1498) = 'Parallel_Region_Overhead                 '
  name(1499) = 'Parallel_Region_Overhead                 '
  name(1500) = 'kukan_9_not_scalapack                    '
!fj mod 20110906
!----- FJ sokutei
  name(21) = 'Initialization'
  name(22) = 'InputData_Analysis'
  name(23) = 'Preparation'
  name(24) = 'Preparation_for_mpi'
  name(25) = 'PseudoPotential_Construction'
  name(26) = 'Ewald_and_Structure_Factor'
  name(27) = 'Initial_Electronic_Structure'
  name(28) = 'INI_1_Gvec'
  name(29) = 'INI_2_PP'
  name(30) = 'INI_3_WF'
  name(31) = 'INI_4_CS'
  name(32) = 'm_ES_modified_gram_schmidt' ! kukan 4,5
  name(33) = 'm_ES_energy_eigen_values'  ! kukan 6
  name(34) = 'm_XC_cal_potential'  !kukan 7
  name(35) = 'm_ESlhxc_potential'  !kukan 11
  name(36) = 'm_ESiVQ_integrate_VlhxcQlm'  !kukan 11
!-----
  name(37) = 'PARA_2Dto3D'  !interface
  name(38) = 'PARA_3Dto2D'  !interface
  name(39) = 'WriteDownData_onto_Files'
!-----
  name(40) = 'm_ESIW_by_randomnumbers' 
  name(41) = 'm_pwBS_generate_G_vectors'
  name(42) = 'count_Gvectors_in_spheres'
  name(43) = 'get_Gvectors_in_a_gmaxp_sphere'
  name(44) = 'm_pwBS_generate_G_vectors_3D:allgather'
!---
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- MATDIAGON / SUBROUTINE
  name(1201) = 'm_ESmat_solve_Hx_eq_eSx_3D'
  name(1202) = 'wd_hsmat'
  name(1203) = 'solve_Hx_eq_ex_LAPACK'
  name(1204) = 'calphase'
  name(1205) = 'nlmtrx'
  name(1206) = 'ovmtrx'
  name(1207) = 'cholde'
  name(1208) = 'amtrxkinetic'
  name(1209) = 'prjvlhxc_l2vlhxc_t'
  name(1210) = 'amtrxlocalpt'
  name(1211) = 'lhl'
  name(1212) = 'lx'
  name(1213) = 'phase_mult'
  name(1214) = 'cp_zaj_mat_to_zaj_l'
  name(1470) = 'make_index_band_for_scalapack'
!---- MATDIAGON add scalapack
  name(1471) = 'solve_Hx_eq_ex_ScaLAPACK'
  name(1472) = 'scalapack_setup_3D'
  name(1473) = 'make_index_band_for_scalapack_md'
  name(1474) = 'trans_scalapack                         '
  name(1475) = 'trans_scalapack_r                       '
  name(1476) = 'm_ESmat_solve_Hx_eq_eSx_3D:1            '
  name(1477) = 'm_ESmat_solve_Hx_eq_eSx_3D:2            '
  name(1478) = 'm_ESmat_solve_Hx_eq_eSx_3D:3            '
  name(1479) = 'solve_Hx_eq_ex_ScaLAPACK:PDSYGVX        '
  name(1480) = 'solve_Hx_eq_ex_ScaLAPACK:PDSYEVX        '
  name(1481) = 'solve_Hx_eq_ex_ScaLAPACK:DO_1           '
  name(1482) = 'solve_Hx_eq_ex_ScaLAPACK:PZHEGVX        '
  name(1483) = 'solve_Hx_eq_ex_ScaLAPACK:PZHEEVX        '
  name(1484) = 'solve_Hx_eq_ex_ScaLAPACK:DO_2           '
  name(1485) = 'trans_scalapack:DO_1                    '
  name(1486) = 'trans_scalapack:DO_2                    '
  name(1487) = 'trans_scalapack:DO_3                    '
  name(1488) = 'trans_scalapack:DO_4                    '
  name(1489) = 'trans_scalapack:isend/irecv_1           '
  name(1490) = 'trans_scalapack_r:DO_1                  '
  name(1491) = 'trans_scalapack_r:DO_2                  '
  name(1492) = 'trans_scalapack_r:DO_3                  '
  name(1493) = 'trans_scalapack_r:DO_4                  '
  name(1494) = 'trans_scalapack_r:isend/irecv_1         '
! -- Initialization / SUBROUTINE
  name(1215) = 'm_ES_betar_dot_WFs_3D'
  name(1216) = 'cpzaj_l_to_psi_ri'
  name(1217) = 'set_msize'
  name(1218) = 'pre_lmta_k_blk'
  name(1219) = 'post_lmta_k_blk'
  name(1220) = 'm_pwBS_calc_length_of_G_3D'
  name(1221) = 'm_pwBS_for_each_WF'
  name(1222) = 'm_PP_vanderbilt_type_3D'
  name(1223) = 'm_PP_local_part_3D'
  name(1224) = 'm_NLP_betar_dot_PWs_3D'
  name(1225) = 'm_CD_cp_chgq_to_chgqo_3D'
  name(1226) = 'm_CD_initial_CD_by_Gauss_func_3D'
  name(1227) = 'm_CS_gnrt_symmetry_operations'
  name(1228) = 'm_IS_symm_check_of_pos'
  name(1229) = 'm_Parallel_init_mpi_elec_3D'
  name(1230) = 'make_index_band_3D'
  name(1231) = 'make_index_band_for_Gdiv_3D'
  name(1232) = 'm_Parallel_mpi_fft_box'
  name(1233) = 'm_Parallel_mpi_fft_box_cd'
  name(1234) = 'm_Parallel_init_mpi_kngp_B_3D'
  name(1235) = 'm_Parallel_init_mpi_nbmx'
  name(1236) = 'im_Parallel_init_mpi_gga'
  name(1237) = 'm_Parallel_init_mpi_snl_3D'
  name(1238) = 'm_Parallel_init_mpi_atm_3D'
  name(1239) = 'm_Parallel_init_mpi_atm2_3D'
  name(1240) = 'm_Parallel_init_mpi_atm_B_3D'
  name(1241) = 'm_Parallel_init_mpi_mix_3D'
  name(1242) = 'm_Parallel_init_mpi_iba_3D'
  name(1243) = 'm_Parallel_wf_onto_fft_3D'
  name(1244) = 'm_Parallel_fft_onto_wf_3D'
  name(1245) = 'm_Parallel_fft_onto_chgq_3D'
  name(1246) = 'm_Parallel_chgq_onto_fftcd_3D'
  name(1247) = 'm_Parallel_fftcd_onto_chgq_3D'
  name(1248) = 'm_IS_structure_factor_3D'
  name(1249) = 'structure_factor1'
  name(1250) = 'structure_factor2'
  name(1251) = 'm_IS_ewald_3D'
  name(1252) = 'decide_rxyz_size'
  name(1253) = 'substitute_rxyz'
  name(1254) = 'decide_alf'
  name(1255) = 'decide_newldg'
  name(1256) = 'cpspac'
  name(1257) = 'set_ewald_parameters'
  name(1258) = 'ewald_Rspace_summation'
  name(1259) = 'ewald_Gspace_summation'
  name(1260) = 'get_zsum'
  name(1261) = 'add_exp_G2_zsum'
  name(1262) = 'ewald_force_Gspace_summation'

! -- MATDIAGON / COMMUNICATION
  name(1263) = 'solve_Hx_eq_ex_LAPACK:allreduce1'
  name(1264) = 'solve_Hx_eq_ex_LAPACK:allreduce2'
  name(1265) = 'nlmtrx:allreduce'
  name(1266) = 'ovmtrx:allreduce_1'
  name(1267) = 'ovmtrx:allreduce_2'
  name(1268) = 'cholde:allreduce_1'
  name(1269) = 'cholde:allreduce_2'
  name(1270) = 'cholde:allreduce_3'
  name(1271) = 'cholde:allreduce_4'
  name(1272) = 'cholde:allreduce_5'
  name(1273) = 'cholde:allreduce_6'
  name(1274) = 'cholde:allreduce_7'
  name(1275) = 'cholde:allreduce_8'
  name(1276) = 'prjvlhxc_l2vlhxc_t:allreduce'
  name(1277) = 'amtrxlocalpt:allreduce'
  name(1278) = 'lhl:allreduce_1'
  name(1279) = 'lhl:allreduce_2'
  name(1280) = 'lhl:allreduce_3'
  name(1281) = 'lhl:allreduce_4'
  name(1282) = 'lhl:allreduce_5'
  name(1283) = 'lhl:allreduce_6'
  name(1284) = 'lx:allreduce_1'
  name(1285) = 'lx:allreduce_2'
! -- MATDIAGON / DO
  name(1286) = 'solve_Hx_eq_ex_LAPACK:DO_1'
  name(1287) = 'solve_Hx_eq_ex_LAPACK:DO_2'
  name(1288) = 'solve_Hx_eq_ex_LAPACK:DO_3'
  name(1289) = 'solve_Hx_eq_ex_LAPACK:DO_4'
  name(1290) = 'solve_Hx_eq_ex_LAPACK:DO_5'
  name(1291) = 'calphase:DO_1'
  name(1292) = 'nlmtrx:DO_1'
  name(1293) = 'nlmtrx:DO_2'
  name(1294) = 'nlmtrx:DO_3'
  name(1295) = 'nlmtrx:DO_4'
  name(1296) = 'nlmtrx:DO_5'
  name(1297) = 'nlmtrx:DO_6'
  name(1298) = 'ovmtrx:DO_1'
  name(1299) = 'ovmtrx:DO_2'
  name(1300) = 'ovmtrx:DO_3'
  name(1301) = 'ovmtrx:DO_4'
  name(1302) = 'ovmtrx:DO_5'
  name(1303) = 'ovmtrx:DO_6'
  name(1304) = 'ovmtrx:DO_7'
  name(1305) = 'cholde:DO_1'
  name(1306) = 'cholde:DO_2'
  name(1307) = 'cholde:DO_3'
  name(1308) = 'cholde:DO_4'
  name(1309) = 'cholde:DO_5'
  name(1310) = 'cholde:DO_6'
  name(1311) = 'cholde:DO_7'
  name(1312) = 'cholde:DO_8'
  name(1313) = 'cholde:DO_9'
  name(1314) = 'cholde:DO_10'
  name(1315) = 'cholde:DO_11'
  name(1316) = 'cholde:DO_12'
  name(1317) = 'cholde:DO_13'
  name(1318) = 'cholde:DO_14'
  name(1319) = 'amtrxkinetic:DO_1'
  name(1320) = 'prjvlhxc_l2vlhxc_t:DO_1'
  name(1321) = 'amtrxlocalpt:DO_1'
  name(1322) = 'amtrxlocalpt:DO_2'
  name(1323) = 'amtrxlocalpt:DO_3'
  name(1324) = 'amtrxlocalpt:DO_4'
  name(1325) = 'lhl:DO_1'
  name(1326) = 'lhl:DO_2'
  name(1327) = 'lhl:DO_3'
  name(1328) = 'lhl:DO_3'
  name(1329) = 'lhl:DO_5'
  name(1330) = 'lhl:DO_6'
  name(1331) = 'lhl:DO_7'
  name(1332) = 'lx:DO_1'
  name(1333) = 'lx:DO_2'
  name(1334) = 'lx:DO_3'
  name(1335) = 'lx:DO_4'
  name(1336) = 'lx:DO_5'
  name(1337) = 'phase_mult:DO_1'
  name(1338) = 'phase_mult:DO_2'
  name(1339) = 'phase_mult:DO_3'
  name(1340) = 'cp_zaj_mat_to_zaj_l:DO_1'
  name(1341) = 'cp_zaj_mat_to_zaj_l:DO_2'
  name(1342) = 'cp_zaj_mat_to_zaj_l:DO_3'
  name(1343) = 'cp_zaj_mat_to_zaj_l:DO_4'
  name(1344) = 'cp_zaj_mat_to_zaj_l:DO_5'
! -- Initialization / DO    # TIMER_INIDO
  name(1345) = 'm_ESIW_by_randomnumbers_3D:DO_1'
  name(1346) = 'm_ESIW_by_randomnumbers_3D:DO_2'
  name(1347) = 'get_Gvectors_in_a_gmaxp_sphere:DO_1'
  name(1348) = 'get_Gvectors_in_a_gmaxp_sphere:DO_2'
  name(1349) = 'get_Gvectors_in_a_gmaxp_sphere:DO_3'
  name(1350) = 'get_Gvectors_in_a_gmaxp_sphere:DO_4'
  name(1351) = 'count_Gvectors_in_spheres:DO_1'
! -- Initialization / COMMUNICATION    # TIMER_INICOMM
  name(1352) = 'm_Parallel_wf_onto_fft_3D:isend/irecv_1'
  name(1353) = 'm_Parallel_wf_onto_fft_3D:allgater_1'
  name(1354) = 'm_Parallel_wf_onto_fft_3D:isend/irecv_2'
  name(1355) = 'm_Parallel_wf_onto_fft_3D:alltoall_1'
  name(1356) = 'm_Parallel_fft_onto_wf_3D:isend/irecv_1'
  name(1357) = 'm_Parallel_fft_onto_wf_3D:alltoall_1'
  name(1358) = 'm_Parallel_fft_onto_chgq_3D:isend/irecv_1'
  name(1359) = 'm_Parallel_fft_onto_chgq_3D:alltoall_1'
  name(1360) = 'm_Parallel_chgq_onto_fftcd_3D:isend/irecv_1'
  name(1701) = 'm_Parallel_chgq_onto_fftcd_3D:allgather_1'
  name(1702) = 'm_Parallel_chgq_onto_fftcd_3D:isend/irecv_1'
  name(1703) = 'm_Parallel_chgq_onto_fftcd_3D:alltoall_1'
  name(1704) = 'm_Parallel_fftcd_onto_chgq_3D:isend/irecv_1'
  name(1705) = 'm_Parallel_fftcd_onto_chgq_3D:alltoall_1'

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- Finalization / SUBROUTINE
  name(1361) = 'm_PP_rd_PP_parameters_3D'
  name(1362) = 'rd_kgp_array'
  name(1363) = 'rd_kgp_array_p'
  name(1364) = 'bcast_nfcntn_bin'
  name(1365) = 'm_PP_wd_PP_parameters_3D'
  name(1366) = 'wd_kgp_array'
  name(1367) = 'wd_kgp_array_p'
  name(1368) = 'm_NLP_rd_snl_3D'
  name(1369) = 'm_NLP_wd_snl_3D'
  name(1370) = 'm_ESIO_rd_EigenValues_etc'
  name(1371) = 'm_ESIO_wd_EigenValues_etc_3D'
  name(1372) = 'm_ESIO_rd_WFs'
  name(1373) = 'm_ESIO_wd_WFs_3D'
  name(1374) = 'm_CD_rd_chgq_3D'
  name(1375) = 'm_CD_wd_chgq_3D'
  name(1376) = 'm_ESIO_rd_Efermi'
  name(1377) = 'm_ESIO_wd_efermi'
  name(1378) = 'm_ESIO_wd_EigenValues'
  name(1379) = 'm_ESIO_wd_WFs_standardout_3D'
! -- Finalization / COMMUNICATION & DO     #TIMER_IODO TIMER_IOCOMM
  name(1380) = 'rd_kgp_array:READ_1'
  name(1381) = 'rd_kgp_array:bcast_1'
  name(1382) = 'rd_kgp_array:READ_2'
  name(1383) = 'rd_kgp_array:bcast_2'
  name(1384) = 'rd_kgp_array:DO_1'
  name(1385) = 'rd_kgp_array_p:READ_1'
  name(1386) = 'rd_kgp_array_p:DO_1'
  name(1387) = 'bcast_nfcntn_bin:bcast'
  name(1388) = 'wd_kgp_array:allreduce_1'
  name(1389) = 'wd_kgp_array:WRITE_1'
  name(1390) = 'wd_kgp_array:DO_1'
  name(1391) = 'wd_kgp_array:allreduce_2'
  name(1392) = 'wd_kgp_array:WRITE_2'
  name(1393) = 'wd_kgp_array_p:DO_1'
  name(1394) = 'wd_kgp_array_p:WRITE_1'
  name(1395) = 'm_NLP_rd_snl_3D:DO_1'
  name(1396) = 'm_NLP_rd_snl_3D:READ_1'
  name(1397) = 'm_NLP_rd_snl_3D:bcast_1'
  name(1398) = 'm_NLP_rd_snl_3D:DO_2'
  name(1399) = 'm_NLP_wd_snl_3D:WRITE_1'
  name(1400) = 'm_NLP_wd_snl_3D:DO_1'
  name(1401) = 'm_NLP_wd_snl_3D:allreduce_1'
  name(1402) = 'm_NLP_wd_snl_3D:DO_2'
  name(1403) = 'm_NLP_wd_snl_3D:allreduce_2'
  name(1404) = 'm_NLP_wd_snl_3D:WRITE_2'
  name(1405) = 'm_ESIO_rd_EigenValues_etc:READ_1'
  name(1406) = 'm_ESIO_rd_EigenValues_etc:DO_1'
  name(1407) = 'm_ESIO_rd_EigenValues_etc:READ_2'
  name(1408) = 'm_ESIO_rd_EigenValues_etc:DO_2'
  name(1409) = 'm_ESIO_rd_EigenValues_etc:READ_3'
  name(1410) = 'm_ESIO_rd_EigenValues_etc:bcast_1'
  name(1411) = 'm_ESIO_rd_EigenValues_etc:DO_3'
  name(1412) = 'm_ESIO_rd_EigenValues_etc:READ_4'
  name(1413) = 'm_ESIO_rd_EigenValues_etc:bcast_2'
  name(1414) = 'm_ESIO_rd_EigenValues_etc:DO_4'
  name(1415) = 'm_ESIO_wd_EigenValues_etc:DO_1'
  name(1416) = 'm_ESIO_wd_EigenValues_etc:WRITE_1'
  name(1417) = 'm_ESIO_wd_EigenValues_etc:DO_2'
  name(1418) = 'm_ESIO_wd_EigenValues_etc:WRITE_2'
  name(1419) = 'm_ESIO_wd_EigenValues_etc:DO_3'
  name(1420) = 'm_ESIO_wd_EigenValues_etc:WRITE_3'
  name(1421) = 'm_ESIO_wd_EigenValues_etc:DO_4'
  name(1422) = 'm_ESIO_wd_EigenValues_etc:WRITE_4'
  name(1423) = 'm_ESIO_wd_EigenValues_etc:DO_5'
  name(1424) = 'm_ESIO_wd_EigenValues_etc:allreduce_1'
  name(1425) = 'm_ESIO_wd_EigenValues_etc:WRITE_5'
  name(1426) = 'm_ESIO_wd_EigenValues_etc:DO_6'
  name(1427) = 'm_ESIO_wd_EigenValues_etc:allreduce_2'
  name(1428) = 'm_ESIO_wd_EigenValues_etc:WRITE_6'
  name(1429) = 'm_ESIO_wd_EigenValues_etc:DO_7'
  name(1430) = 'm_ESIO_wd_EigenValues_etc:allreduce_3'
  name(1431) = 'm_ESIO_wd_EigenValues_etc:WRITE_7'
  name(1432) = 'm_ESIO_wd_EigenValues_etc:DO_8'
  name(1433) = 'm_ESIO_wd_EigenValues_etc:allreduce_4'
  name(1434) = 'm_ESIO_wd_EigenValues_etc:WRITE_8'
  name(1435) = 'm_ESIO_rd_WFs:DO_1'
  name(1436) = 'm_ESIO_rd_WFs:READ_1'
  name(1437) = 'm_ESIO_rd_WFs:DO_2'
  name(1438) = 'm_ESIO_rd_WFs:READ_2'
  name(1439) = 'm_ESIO_rd_WFs:bcast'
  name(1440) = 'm_ESIO_wd_WFs:DO_1'
  name(1441) = 'm_ESIO_wd_WFs:WRITE_1'
  name(1442) = 'm_ESIO_wd_WFs:DO_2'
  name(1443) = 'm_ESIO_wd_WFs:allreduce'
  name(1444) = 'm_ESIO_wd_WFs:WRITE_2'
  name(1445) = 'm_CD_rd_chgq_3D:READ_1'
  name(1446) = 'm_CD_rd_chgq_3D:DO_1'
  name(1447) = 'm_CD_rd_chgq_3D:READ_2'
  name(1448) = 'm_CD_rd_chgq_3D:READ_3'
  name(1449) = 'm_CD_rd_chgq_3D:bcast'
  name(1450) = 'm_CD_rd_chgq_3D:DO_2'
  name(1451) = 'm_CD_rd_chgq_3D:READ_4'
  name(1452) = 'm_CD_wd_chgq_3D:DO_1'
  name(1453) = 'm_CD_wd_chgq_3D:WRITE_1'
  name(1454) = 'm_CD_wd_chgq_3D:WRITE_2'
  name(1455) = 'm_CD_wd_chgq_3D:allreduce'
  name(1456) = 'm_CD_wd_chgq_3D:WRITE_3'
  name(1457) = 'm_CD_wd_chgq_3D:WRITE_4'
  name(1458) = 'm_ESIO_rd_Efermi:READ_1'
  name(1459) = 'm_ESIO_rd_Efermi:bcast_1'
  name(1460) = 'm_ESIO_wd_Efermi:WRITE_1'
  name(1461) = 'm_ESIO_wd_EigenValues_put_kpart:DO'
  name(1462) = 'm_ESIO_wd_EigenValues_put_kpart:allreduce'
  name(1463) = 'm_ESIO_wd_EigenValues:WRITE_1'
!!$  name(1464) = 'm_ESIO_wd_EigenValues_3D:DO_2'
!!$  name(1465) = 'm_ESIO_wd_EigenValues_3D:allreduce_2'
!!$  name(1466) = 'm_ESIO_wd_EigenValues_3D:WRITE_2'
  name(1467) = 'm_ESIO_wd_WFs_standardout_3D:DO_1'
  name(1468) = 'm_ESIO_wd_WFs_standardout_3D:allreduce_1'
  name(1469) = 'm_ESIO_wd_WFs_standardout_3D:WRITE_1'

  name(1490) = 'FORCE                                   '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_1 / SUBROUTINE / ID= 101 -> 110
  name(101) =  'm_ES_Vlocal_in_Rspace_3D                '
  name(102) =  'cnt_vlhxc_to_fft_box_3D                 '
  name(103) =  'mp_vlhxc_l_onto_afft_3D                 '
  name(104) =  'm_FFT_WF_3D                             '
  name(105) =  'm_FFT_Direct_3D                         '
  name(106) =  'm_FFT_Inverse_3D                        '
  name(107) =  'm_FFT_Vlocal_W_3D                       '
  name(108) =  'm_FFT_W_Vlocal_W_3D                     '
  name(109) =  'm_FFT_CD_Direct_3D                      '
  name(110) =  'm_FFT_CD_Inverse_3D                     '

! -- KUKAN_1 / COMMUNICATION & DGEMM & DO / ID= 111 -> 189
  name(111) =  'cnt_vlhxc_to_fft_box_3D:isend/irecv_1   '
  name(112) =  'cnt_vlhxc_to_fft_box_3D:DO_1            '
  name(113) =  'cnt_vlhxc_to_fft_box_3D:isend/irecv_2   '
  name(114) =  'cnt_vlhxc_to_fft_box_3D:DO_2            '
  name(115) =  'mp_vlhxc_l_onto_afft_3D:DO_1            '
  name(116) =  'mp_vlhxc_l_onto_afft_3D:isend/irecv_1   '
  name(117) =  'mp_vlhxc_l_onto_afft_3D:DO_2            '
  name(118) =  'm_FFT_Direct_3D:Initial                 '
  name(119) =  'm_FFT_Direct_3D:Initial_FFTW            '
  name(120) =  'm_FFT_Direct_3D:Allocate                '
  name(121) =  'm_FFT_Direct_3D:DO_4                    '
  name(122) =  'm_FFT_Direct_3D:DO_5                    '
  name(123) =  'm_FFT_Direct_3D:alltoall                '
  name(124) =  'm_FFT_Direct_3D:DO_6                    '
  name(125) =  'm_FFT_Direct_3D:DO_7                    '
  name(126) =  'm_FFT_Direct_3D:DO_8                    '
  name(127) =  'm_FFT_Direct_3D:alltoall                '
  name(128) =  'm_FFT_Direct_3D:DO_9                    '
  name(129) =  'm_FFT_Direct_3D:DO_10                   '
  name(130) =  'm_FFT_Direct_3D:DO_11                   '
  name(131) =  'm_FFT_Direct_3D:DO_12                   '
  name(132) =  'm_FFT_Direct_3D:allgatherv              '
  name(133) =  'm_FFT_Direct_3D:DO_13                   '
  name(134) =  'm_FFT_Inverse_3D:Initial                '
  name(135) =  'm_FFT_Inverse_3D:Initial_FFTW           '
  name(136) =  'm_FFT_Inverse_3D:DO_3                   '
  name(137) =  'm_FFT_Inverse_3D:alltoall               '
  name(138) =  'm_FFT_Inverse_3D:DO_4                   '
  name(139) =  'm_FFT_Inverse_3D:DO_5                   '
  name(140) =  'm_FFT_Inverse_3D:DO_6                   '
  name(141) =  'm_FFT_Inverse_3D:DO_7                   '
  name(142) =  'm_FFT_Inverse_3D:alltoall               '
  name(143) =  'm_FFT_Inverse_3D:DO_7                   '
  name(144) =  'm_FFT_Inverse_3D:DO_8                   '
  name(145) =  'm_FFT_Inverse_3D:DO_9                   '
  name(146) =  'm_FFT_Inverse_3D:DO_10                  '
  name(147) =  'm_FFT_Inverse_3D:DO_11                  '
  name(148) =  'm_FFT_Inverse_3D:DO_12                  '
  name(149) =  'm_FFT_Inverse_3D:allgatherv             '
  name(150) =  'm_FFT_Inverse_3D:DO_13                  '
  name(151) =  'm_FFT_Vlocal_W_3D:DO_1                  '
  name(152) =  'm_FFT_W_Vlocal_W_3D:DO_1                '
  name(153) =  'm_FFT_W_Vlocal_W_3D:DO_2                '
  name(154) =  'm_FFT_W_Vlocal_W_3D:DO_3                '
  name(155) =  'm_FFT_W_Vlocal_W_3D:DO_4                '
  name(156) =  'm_FFT_W_Vlocal_W_3D:DO_5                '
  name(157) =  'm_FFT_CD_Direct_3D:Initial              '
  name(158) =  'm_FFT_CD_Direct_3D:Allocate             '
  name(159) =  'm_FFT_CD_Direct_3D:DO_3                 '
  name(160) =  'm_FFT_CD_Direct_3D:DO_4                 '
  name(161) =  'm_FFT_CD_Direct_3D:DO_5                 '
  name(162) =  'm_FFT_CD_Direct_3D:alltoall             '
  name(163) =  'm_FFT_CD_Direct_3D:DO_6                 '
  name(164) =  'm_FFT_CD_Direct_3D:DO_7                 '
  name(165) =  'm_FFT_CD_Direct_3D:DO_8                 '
  name(166) =  'm_FFT_CD_Direct_3D:alltoall             '
  name(167) =  'm_FFT_CD_Direct_3D:DO_9                 '
  name(168) =  'm_FFT_CD_Direct_3D:DO_10                '
  name(169) =  'm_FFT_CD_Direct_3D:DO_11                '
  name(170) =  'm_FFT_CD_Direct_3D:DO_12                '
  name(171) =  'm_FFT_CD_Direct_3D:allgatherv           '
  name(172) =  'm_FFT_CD_Direct_3D:DO_13                '
  name(173) =  'm_FFT_CD_Inverse_3D:Initial             '
  name(174) =  'm_FFT_CD_Inverse_3D:Allocate            '
  name(175) =  'm_FFT_CD_Inverse_3D:DO_3                '
  name(176) =  'm_FFT_CD_Inverse_3D:alltoall            '
  name(177) =  'm_FFT_CD_Inverse_3D:DO_4                '
  name(178) =  'm_FFT_CD_Inverse_3D:DO_5                '
  name(179) =  'm_FFT_CD_Inverse_3D:DO_6                '
  name(180) =  'm_FFT_CD_Inverse_3D:DO_7                '
  name(181) =  'm_FFT_CD_Inverse_3D:alltoall            '
  name(182) =  'm_FFT_CD_Inverse_3D:DO_8                '
  name(183) =  'm_FFT_CD_Inverse_3D:DO_9                '
  name(184) =  'm_FFT_CD_Inverse_3D:DO_10               '
  name(185) =  'm_FFT_CD_Inverse_3D:DO_11               '
  name(186) =  'm_FFT_CD_Inverse_3D:DO_12               '
  name(187) =  'm_FFT_CD_Inverse_3D:DO_13               '
  name(188) =  'm_FFT_CD_Inverse_3D:allgatherv          '
  name(189) =  'm_FFT_CD_Inverse_3D:DO_14               '
  name(266) =  'cnt_vlhxc_to_fft_box_3D:allgather_1     '
  name(267) =  'cnt_vlhxc_to_fft_box_3D:alltoall_1      '
  name(268) =  'mp_vlhxc_l_onto_afft_3D:alltoallv_1     '
! -- KUKAN_1 / FFT / ID= 190         
  name(190)=   'kukan_1:FFT_INVERSE                     '
! -- KUKAN_1 / DO / ID= 251 -> 189
  name(251) =  'm_FFT_Direct_3D:DO_14                   '
  name(252) =  'm_FFT_Direct_3D:DO_15                   '
  name(253) =  'm_FFT_Direct_3D:DO_16                   '
  name(254) =  'm_FFT_Inverse_3D:DO_14                  '
  name(255) =  'm_FFT_Inverse_3D:DO_15                  '
  name(256) =  'm_FFT_Inverse_3D:DO_16                  '
  name(257) =  'm_FFT_CD_Direct_3D:DO_15                '
  name(258) =  'm_FFT_CD_Direct_3D:DO_16                '
  name(259) =  'm_FFT_CD_Direct_3D:DO_17                '
  name(260) =  'm_FFT_CD_Inverse_3D:DO_15               '
  name(261) =  'm_FFT_CD_Inverse_3D:DO_16               '
  name(262) =  'm_FFT_CD_Inverse_3D:DO_17               '
  name(263) =  'm_FFT_Inverse_3D:FFTW                   '
  name(264) =  'm_FFT_Inverse_3D:Allocate               '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_2 / SUBROUTINE / ID= 201 -> 208
  name(201) =  'm_ES_Vnonlocal_W_3D                     '
  name(202) =  'pre_m_ES_Vnonlocal_W                    '
  name(203) =  'm_ES_gather_f_3d_to_2d                  '
  name(204) =  'calc_phase_blk                          '
  name(205) =  'Vnonlocal_W_part_with_blk_3D            '
  name(206) =  'add_vnlph_l_with_eko_blk_3D             '
  name(207) =  'Vnonlocal_W_part_without_blk_3D         '
  name(208) =  'add_vnlph_l_without_eko_blk_3D          '
! -- KUKAN_2 / COMMUNICATION & DGEMM & DO / ID= 209 -> 231
  name(209) =  'pre_m_ES_Vnonlocal_W:DO_1               '
  name(210) =  'm_ES_gather_f_3d_to_2d:DO_1             '
  name(211) =  'm_ES_gather_f_3d_to_2d:DO_2             '
  name(212) =  'm_ES_gather_f_3d_to_2d:allgatherv_1     '
  name(213) =  'calc_phase_blk:DO_1                     '
  name(214) =  'Vnonlocal_W_part_with_blk_3D:DO_1       '
  name(215) =  'Vnonlocal_W_part_with_blk_3D:DO_2       '
  name(216) =  'Vnonlocal_W_part_with_blk_3D:DO_3       '
  name(217) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_1     '
  name(218) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_2     '
  name(219) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_3     '
  name(220) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_4     '
  name(221) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_5     '
  name(222) =  'add_vnlph_l_with_eko_blk_3D:DGEMM_6     '
  name(223) =  'add_vnlph_l_with_eko_blk_3D:DO_1        '
  name(224) =  'add_vnlph_l_with_eko_blk_3D:DO_2        '
  name(225) =  'add_vnlph_l_with_eko_blk_3D:DO_3        '
  name(226) =  'Vnonlocal_W_part_without_blk_3D:DO_1    '
  name(227) =  'Vnonlocal_W_part_without_blk_3D:DO_2    '
  name(228) =  'Vnonlocal_W_part_without_blk_3D:DO_3    '
  name(229) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_1  '
  name(230) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_2  '
  name(231) =  'add_vnlph_l_without_eko_blk_3D:DGEMM_3  '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_3 / SUBROUTINE / ID= 301 -> 309
  name(301) =  'evolve_WFs_in_MSD_direction_3D          '
  name(302) =  'm_ES_decide_precon_factor_3D            '
  name(303) =  'kinetic_energy_3D                       '
  name(304) =  'm_ES_WF_in_Rspace_3D                    '
  name(305) =  'Vnonlocal_Diagonal_part_3D              '
  name(306) =  'Vnonlocal_D_norm_conserve_case          '
  name(307) =  'Vnonlocal_D_vanderbilt_case             '
  name(308) =  'map_fft_to_WF_3D                        '
  name(309) =  'modified_steepest_descent_3D            '
! -- KUKAN_3 / COMMUNICATION & DGEMM & DO / ID= 310 -> 326
  name(310) =  'm_ES_decide_precon_factor_3D:DO_1       '
  name(311) =  'kinetic_energy_3D:DO_1                  '
  name(312) =  'kinetic_energy_3D:allreduce_1           '
  name(313) =  'm_ES_WF_in_Rspace_3D:DO_1               '
  name(314) =  'm_ES_WF_in_Rspace_3D:isend/irecv_1      '
  name(315) =  'm_ES_WF_in_Rspace_3D:DO_2               '
  name(316) =  'Vnonlocal_Diagonal_part_3D:DO_1         '
  name(317) =  'Vnonlocal_D_norm_conserve_case:DO_1     '
  name(318) =  'Vnonlocal_D_norm_conserve_case:DO_2     '
  name(319) =  'Vnonlocal_D_vanderbilt_case:DO_1        '
  name(320) =  'Vnonlocal_D_vanderbilt_case:allreduce_1 '
  name(321) =  'Vnonlocal_D_vanderbilt_case:DO_2        '
  name(322) =  'Vnonlocal_D_vanderbilt_case:DO_3        '
  name(323) =  'map_fft_to_WF_3D:isend/irecv_1          '
  name(324) =  'map_fft_to_WF_3D:DO_1                   '
  name(325) =  'map_fft_to_WF_3D:DO_2                   '
  name(326) =  'modified_steepest_descent_3D:DO_1       '
  name(329) =  'm_ES_WF_in_Rspace_3D:alltoallv_1        '
  name(330) =  'map_fft_to_WF_3D:alltoallv_1            '
! -- KUKAN_8 / FFT / ID= 327 -> 328
  name(327)=  'kukan_3:FFT_INVERSE                     '
  name(328)=  'kukan_3:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_4 / SUBROUTINE / ID= 401 -> 410
  name(401) = 'm_ES_betar_dot_WFs_4_each_k_3D'
  name(402) = 'cpzaj_l_to_psi_ri'
  name(403) = 'set_msize'
  name(404) = 'pre_lmta_k_blk'
  name(405) = 'post_lmta_k_blk'
  name(406) = 'm_ES_betar_dot_WFs_4_lmta_k_blk_3D'
  name(407) = 'G_dot_R_mult_snl_blk'
  name(408) = 'betar_dot_WFs_core_blk'
  name(409) = 'betar_dot_WFs_core2_blk'
  name(410) = 'G_dot_R_map_blk_3D'
! -- KUKAN_4 / DGEMM / ID= 411 -> 418 
  name(411) = 'betar_dot_WFs_core_blk:DGEMM_1'
  name(412) = 'betar_dot_WFs_core_blk:DGEMM_2'
  name(413) = 'betar_dot_WFs_core_blk:DGEMM_3'
  name(414) = 'betar_dot_WFs_core_blk:DGEMM_4'
  name(415) = 'betar_dot_WFs_core2_blk:DGEMM_1'
  name(416) = 'betar_dot_WFs_core2_blk:DGEMM_2'
  name(417) = 'betar_dot_WFs_core2_blk:DGEMM_3'
  name(418) = 'betar_dot_WFs_core2_blk:DGEMM_4'
! -- KUKAN_4 / COMMUNICATION / ID= 419 -> 422
  name(419) = 'm_ES_betar_dot_WFs_4_each_k_3D:reduce_scatter'
  name(420) = 'm_ES_betar_dot_WFs_4_each_k_3D:DO_p'
  name(421) = 'm_ES_betar_dot_WFs_4_each_k_3D:allgatherv'
  name(422) = 'm_ES_betar_dot_WFs_4_each_k_3D:DO_unp'
! -- KUKAN_4 / DO / ID= 423 -> 426
  name(423) = 'cpzaj_l_to_psi_ri:DO_1'
  name(424) = 'post_lmta_k_blk:DO_1'
  name(425) = 'G_dot_R_mult_snl_blk:DO_1'
  name(426) = 'G_dot_R_mult_snl_blk:DO_2'

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_5 / SUBROUTINE / ID= 501 -> 514
  name(501) = 'm_ES_MGS_4_each_k'
  name(502) = 'm_ES_MGS_4_each_k_3D'
  name(503) = 'mgs_4_each_k_G_3D'
  name(504) = 'WSW_t'
  name(505) = 'cp_bpr2bprtw'
  name(506) = 'normalize_bp_and_psi_t'
  name(507) = 'W1SW2_t_r'
  name(508) = 'modify_bp_and_psi_t_r'
  name(509) = 'W1SW2_t_r_block'
  name(510) = 'modify_bp_and_psi_t_r_block'
  name(511) = 'm_ES_F_transpose_r_3D'
  name(512) = 'm_ES_F_transpose_back_r_3D'
  name(513) = 'm_ES_W_transpose_r_3D'
  name(514) = 'm_ES_W_transpose_back_r_3D'
! -- KUKAN_5 / DGEMM / ID= 515 -> 526
  name(515) = 'W1SW2_t_r_block:DGEMM_1'
  name(516) = 'W1SW2_t_r_block:DGEMM_2'
  name(517) = 'W1SW2_t_r_block:DGEMM_3'
  name(518) = 'W1SW2_t_r_block:DGEMM_4'
  name(519) = 'W1SW2_t_r_block:DGEMM_5'
  name(520) = 'W1SW2_t_r_block:DGEMM_6'
  name(521) = 'modify_bp_and_psi_t_r_block:DGEMM_1'
  name(522) = 'modify_bp_and_psi_t_r_block:DGEMM_2'
  name(523) = 'modify_bp_and_psi_t_r_block:DGEMM_3'
  name(524) = 'modify_bp_and_psi_t_r_block:DGEMM_4'
  name(525) = 'modify_bp_and_psi_t_r_block:DGEMM_5'
  name(526) = 'modify_bp_and_psi_t_r_block:DGEMM_6'
! -- KUKAN_5 / COMMUNICATION / ID= 527 -> 539,582 -> 590
  name(527) = 'mgs_4_each_k_G_3D:DO_p'
  name(528) = 'mgs_4_each_k_G_3D:DO_p'
  name(529) = 'mgs_4_each_k_G_3D:bcast_1'
  name(530) = 'mgs_4_each_k_G_3D:DO_unp'
  name(531) = 'mgs_4_each_k_G_3D:bcast_2'
  name(532) = 'mgs_4_each_k_G_3D:DO_unp_1'
  name(533) = 'mgs_4_each_k_G_3D:DO_unp_2'
  name(534) = 'mgs_4_each_k_G_3D:DO_p'
  name(535) = 'mgs_4_each_k_G_3D:allreduce'
  name(536) = 'WSW_t:allreduce'
  name(537) = 'W1SW2_t_r:DO_p'
  name(538) = 'W1SW2_t_r:allreduce'
  name(539) = 'W1SW2_t_r:DO_unp'
  name(582) = 'm_ES_F_transpose_r_3D:isend/irecv_1'
  name(583) = 'm_ES_F_transpose_r_3D:alltoall_1'
! -- KUKAN_5 / DO / ID= 540 -> 581
  name(540) = 'mgs_4_each_k_G_3D:DO_1'
  name(541) = 'mgs_4_each_k_G_3D:DO_2'
  name(542) = 'mgs_4_each_k_G_3D:DO_3'
  name(543) = 'mgs_4_each_k_G_3D:DO_4'
  name(544) = 'mgs_4_each_k_G_3D:DO_5'
  name(545) = 'mgs_4_each_k_G_3D:DO_6'
  name(546) = 'mgs_4_each_k_G_3D:DO_7'
  name(547) = 'mgs_4_each_k_G_3D:DO_8'
  name(548) = 'WSW_t:DO_1'
  name(549) = 'WSW_t:DO_2'
  name(550) = 'WSW_t:DO_3'
  name(551) = 'WSW_t:DO_4'
  name(552) = 'cp_bpr2bprtw:DO_1'
  name(553) = 'cp_bpr2bprtw:DO_2'
  name(554) = 'normalize_bp_and_psi_t:DO_1'
  name(555) = 'normalize_bp_and_psi_t:DO_2'
  name(556) = 'W1SW2_t_r:DO_1'
  name(557) = 'W1SW2_t_r:DO_2'
  name(558) = 'W1SW2_t_r:DO_3'
  name(559) = 'W1SW2_t_r:DO_4'
  name(560) = 'W1SW2_t_r:DO_5'
  name(561) = 'W1SW2_t_r:DO_6'
  name(562) = 'W1SW2_t_r:DO_7'
  name(563) = 'W1SW2_t_r:DO_8'
  name(564) = 'modify_bp_and_psi_t_r:DO_1'
  name(565) = 'modify_bp_and_psi_t_r:DO_2'
  name(566) = 'modify_bp_and_psi_t_r:DO_3'
  name(567) = 'modify_bp_and_psi_t_r:DO_4'
  name(568) = 'modify_bp_and_psi_t_r:DO_5'
  name(569) = 'modify_bp_and_psi_t_r:DO_6'
  name(570) = 'W1SW2_t_r_block:DO_1'
  name(571) = 'W1SW2_t_r_block:DO_2'
  name(572) = 'W1SW2_t_r_block:DO_3'
  name(573) = 'm_ES_F_transpose_r_3D:DO_1'
  name(574) = 'm_ES_F_transpose_r_3D:DO_2'
  name(575) = 'm_ES_F_transpose_back_r_3D:DO_1'
  name(576) = 'm_ES_F_transpose_back_r_3D:DO_2'
  name(577) = 'm_ES_W_transpose_r_3D:DO_1'
  name(578) = 'm_ES_W_transpose_r_3D:DO_2'
  name(579) = 'm_ES_W_transpose_r_3D:DO_3'
  name(580) = 'm_ES_W_transpose_back_r_3D:DO_1'
  name(581) = 'm_ES_W_transpose_back_r_3D:DO_2'
  name(585) = 'gram_schmidt_recursive'
  name(586) = 'gram_schmidt_angle'
  name(587) = 'gram_schmidt_block'
  name(588) = 'gram_schmidt_block:DO_1'
  name(589) = 'gram_schmidt_block:DO_2'
  name(590) = 'gram_schmidt_block:DO_3'
  name(591) = 'gram_schmidt_block:allreduce'
  name(592) = 'gram_schmidt_block:DO_4'
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_6 / SUBROUTINE / ID= 601 -> 607
  name(601) =  'm_ES_eigen_values_for_each_k_3D         '
  name(602) =  'W_T_W                                   '
  name(603) =  'W_Vnonlocal_W                           '
  name(604) =  'm_ES_sort_eigen_values_3D               '
  name(605) =  'heap_sorting                            '
  name(606) =  'cp_eigen_values_for_af                  '
  name(607) =  'expand_neordr_and_nrvf_ordr             '
! -- KUKAN_6 / COMMUNICATION & DGEMM & DO / ID= 608 -> 635
  name(608) =  'm_ES_eigen_values_for_each_k_3D:alreduce'
  name(609) =  'W_T_W:DO_1                              '
  name(610) =  'W_Vnonlocal_W:DO_1                      '
  name(611) =  'W_Vnonlocal_W:DO_2                      '
  name(612) =  'm_ES_sort_eigen_values_3D:DO_1          '
  name(613) =  'm_ES_sort_eigen_values_3D:DO_2          '
  name(614) =  'm_ES_sort_eigen_values_3D:allgather_1   '
  name(615) =  'm_ES_sort_eigen_values_3D:DO_3          '
  name(616) =  'm_ES_sort_eigen_values_3D:DO_4          '
  name(617) =  'm_ES_sort_eigen_values_3D:DO_5          '
  name(618) =  'm_ES_sort_eigen_values_3D:DO_6          '
  name(619) =  'm_ES_sort_eigen_values_3D:DO_7          '
  name(620) =  'm_ES_sort_eigen_values_3D:DO_8          '
  name(621) =  'm_ES_sort_eigen_values_3D:DO_9          '
  name(622) =  'm_ES_sort_eigen_values_3D:DO_10         '
  name(623) =  'm_ES_sort_eigen_values_3D:DO_11         '
  name(624) =  'm_ES_sort_eigen_values_3D:DO_12         '
  name(625) =  'm_ES_sort_eigen_values_3D:DO_13         '
  name(626) =  'm_ES_sort_eigen_values_3D:DO_14         '
  name(627) =  'm_ES_sort_eigen_values_3D:DO_15         '
  name(628) =  'm_ES_sort_eigen_values_3D:DO_16         '
  name(629) =  'm_ES_sort_eigen_values_3D:DO_17         '
  name(630) =  'm_ES_sort_eigen_values_3D:DO_18         '
  name(631) =  'm_ES_sort_eigen_values_3D:DO_19         '
  name(632) =  'heap_sorting:DO_1                       '
  name(633) =  'heap_sorting:DO_2                       '
  name(634) =  'cp_eigen_values_for_af:DO_1             '
  name(635) =  'expand_neordr_and_nrvf_ordr:DO_1        '
! -- KUKAN_6 / FFT / ID= 608 -> 635
  name(636) =  'kukan_6:FFT_INVERSE                     '
  name(637) =  'kukan_6:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_7 / SUBROUTINE / ID= 701 -> 799
  name(701) =  'ChargeDensity_Construction_3D           '
  name(702) =  'FermiEnergyLevel_3D                     '
  name(703) =  'm_ESoc_fermi_parabolic_3D               '
  name(704) =  'get_occup_l_and_tot                     '
  name(705) =  'width2                                  '
  name(706) =  'get_entropic_term                       '
  name(707) =  'get_entropy                             '
  name(708) =  'get_total_spin0                         '
  name(709) =  'm_ESoc_fermi_tetrahedron_3D             '
  name(710) =  'fermi1                                  '
  name(711) =  'nsdos2                                  '
  name(712) =  'fermi2                                  '
  name(713) =  'nstt3i                                  '
  name(714) =  'nstt2i                                  '
  name(715) =  'm_ESoc_fermi_ColdSmearing_3D            '
  name(716) =  'm_CD_softpart_3D                        '
  name(717) =  'add_occupied_densities                  '
  name(718) =  'map_fft_to_chgq_3D                      '
  name(719) =  'substitute_CD_for_chgq                  '
  name(720) =  'm_CD_hardpart_3D                        '
  name(721) =  'summation_of_ff_3D                      '
  name(722) =  'add_hardpart_to_chgq_l_3D               '
  name(723) =  'm_PP_set_index_arrays1                  '
  name(724) =  'm_PP_set_index_arrays2                  '
  name(725) =  'substitute_qitgred                      '
  name(726) =  'substitute_ylmred                       '
  name(727) =  'calc_phase_div                          '
  name(728) =  'sum_hsr_dot_gauntc0                     '
  name(729) =  'add_hardpart_to_chgq_l_div0             '
  name(730) =  'add_hardpart_to_chgq_l_div1             '
  name(731) =  'charge_average_3D                       '
  name(732) =  'cp_chgq_by_ngpt                         '
  name(733) =  'm_CD_conversion_check_3D                '
  name(734) =  'm_CD_hardpart_hsr_3D                    '
  name(735) =  'Renewal_of_OccMat_3D                    '
  name(736) =  'm_CD_den_mat_3D                         '
  name(737) =  'm_OP_occ_mat_ylm                        '
  name(738) =  'm_OP_occ_mat_ao_kt                      '
  name(739) =  'm_TE_total_energy_3D                    '
  name(740) =  'get_band_energy_3D                      '
  name(741) =  'get_xc_and_HE_of_old_CD_3D              '
  name(742) =  'get_local_potential_energy_3D           '
  name(743) =  'get_hubbard_energy_3D                   '
  name(744) =  'get_nonlocal_potential_energy_3D        '
  name(745) =  'get_hartree_energy_3D                   '
  name(746) =  'get_dipole_energy_3D                    '
  name(747) =  'get_kinetic_energy                      '
  name(748) =  'get_entropic_term                       '
  name(749) =  'sumup_all_energies                      '
  name(750) =  'm_XC_cal_potential_3D                   '
  name(751) =  'xc_allocate_3D                          '
  name(752) =  'set_f2or1_3D                            '
  name(753) =  'map_charge_onto_a_fftcd_box             '
  name(754) =  'check_of_negative_CD_3D                 '
  name(755) =  'cp_afft_to_chgrhr_3D                    '
  name(756) =  'check_lmn_even_3D                       '
  name(757) =  'ggaxcp_diff_3D                          '
  name(758) =  'ggaxcp0_3D                              '
  name(759) =  'abs_grad_rho_up_down_total_3D           '
  name(760) =  'g_xyz_chden_l_3D                        '
  name(761) =  'boundary_zero_into_afft_3D              '
  name(762) =  'cp_afft_to_cgrad_rho_3D                 '
  name(763) =  'add_sq_afft_to_grad_rho_3D              '
  name(764) =  'ex_ggapw91_3D                           '
  name(765) =  'cr_ggapw91_3D                           '
  name(766) =  'ex_ggapbe_3D                            '
  name(767) =  'cr_ggapbe_3D                            '
  name(768) =  'xclda_3D                                '
  name(769) =  'ggabek_3D                               '
  name(770) =  'ggaprd_3D                               '
  name(771) =  'ggaxcp_3D                               '
  name(772) =  'dFxc_over_ddgradrho_3D                  '
  name(773) =  'dFxc_dgradrho_dot_gradrho2_3D           '
  name(774) =  'G_xyz_afft_3D                           '
  name(775) =  'add_negative_afft_to_grad_rho_3D        '
  name(776) =  'finally_gga_xc_pot_3D                   '
  name(777) =  'xcpotf_3D                               '
  name(778) =  'xcpotf_wigner_3D                        '
  name(779) =  'xcpotf_pzold_3D                         '
  name(780) =  'xcpotf_xalfa_3D                         '
  name(781) =  'xcpotf_pz_3D                            '
  name(782) =  'xcpotf_vwn_3D                          '
  name(783) =  'xcpotf_mjw_bh_gl_3D                     '
  name(784) =  'cpafft_3D                               '
  name(785) =  'map_fftcd_onto_charge                   '
  name(786) =  'rhos_diff                               '
  name(787) =  'rhopc_diff_3D                           '
  name(788) =  'rhoh_diff_3D                            '
  name(789) =  'even_case_3D                            '
  name(790) =  'odd_case_3D                             '
  name(791) =  'real_case_3D                            '
  name(792) =  'complex_case_3D                         '
  name(793) =  'dgrhodh1_3D                             '
  name(794) =  'stress_correlation_part_3D              '
  name(795) =  'sum_s_gga12                             '
  name(796) =  'dgrhodh2_3D                             '
  name(797) =  'stress_exchange_part_3D                 '
  name(798) =  'map_drhodh1_3D                          '
  name(799) =  'map_drhodh2_3D                          '
! -- KUKAN_7 / COMMUNICATION & DGEMM & DO / ID= 800 -> 900, 1001 -> 1049
  name(800) =  'm_ESoc_fermi_parabolic_3D:DO_1          '
  name(801) =  'm_ESoc_fermi_parabolic_3D:allreduce_1   '
  name(802) =  'm_ESoc_fermi_parabolic_3D:allgather_1   '
  name(803) =  'm_ESoc_fermi_parabolic_3D:DO_2          '
  name(804) =  'get_occup_l_and_tot:DO_1                '
  name(805) =  'get_entropic_term:DO_1                  '
  name(806) =  'm_ESoc_fermi_tetrahedron_3D:DO_1        '
  name(807) =  'm_ESoc_fermi_tetrahedron_3D:allreduce_1 '
  name(808) =  'm_ESoc_fermi_tetrahedron_3D:DO_2        '
  name(809) =  'm_ESoc_fermi_tetrahedron_3D:DO_3        '
  name(810) =  'm_ESoc_fermi_tetrahedron_3D:DO_4        '
  name(811) =  'fermi1:DO_1                             '
  name(812) =  'fermi1:DO_2                             '
  name(813) =  'fermi1:DO_3                             '
  name(814) =  'nsdos2:DO_1                             '
  name(815) =  'fermi2:DO_1                             '
  name(816) =  'nstt3i:DO_1                             '
  name(817) =  'nstt3i:DO_2                             '
  name(818) =  'nstt3i:DO_3                             '
  name(819) =  'nstt2i:DO_1                             '
  name(820) =  'nstt2i:DO_20                            '
  name(821) =  'm_ESoc_fermi_ColdSmearing_3D:DO_1       '
  name(822) =  'm_ESoc_fermi_ColdSmearing_3D:allreduce_1'
  name(823) =  'm_ESoc_fermi_ColdSmearing_3D:DO_2       '
  name(824) =  'm_ESoc_fermi_ColdSmearing_3D:DO_3       '
  name(825) =  'm_CD_softpart_3D:allreduce_1            '
  name(826) =  'add_occupied_densities:DO_1             '
  name(827) =  'map_fft_to_chgq_3D:isend/irecv_1        '
  name(828) =  'map_fft_to_chgq_3D:DO_1                 '
  name(829) =  'map_fft_to_chgq_3D:DO_2                 '
  name(830) =  'substitute_CD_for_chgq:DO_1             '
  name(831) =  'summation_of_ff_3D:DO_1                 '
  name(832) =  'summation_of_ff_3D:allreduce_1          '
  name(833) =  'summation_of_ff_3D:allreduce_2          '
  name(834) =  'add_hardpart_to_chgq_l_3D:DO_1          '
  name(835) =  'add_hardpart_to_chgq_l_3D:allgather_1   '
  name(836) =  'add_hardpart_to_chgq_l_3D:DO_2          '
  name(837) =  'add_hardpart_to_chgq_l_3D:allreduce_1   '
  name(838) =  'm_PP_set_index_arrays1:DO_1             '
  name(839) =  'm_PP_set_index_arrays2:DO_1             '
  name(840) =  'substitute_qitgred:DO_1                 '
  name(841) =  'substitute_ylmred:DO_1                  '
  name(842) =  'substitute_ylmred:DO_2                  '
  name(843) =  'calc_phase_div:DO_1                     '
  name(844) =  'sum_hsr_dot_gauntc0:DO_1                '
  name(845) =  'sum_hsr_dot_gauntc0:DO_2                '
  name(846) =  'add_hardpart_to_chgq_l_div0:DO_1        '
  name(847) =  'add_hardpart_to_chgq_l_div1:DO_1        '
  name(848) =  'charge_average_3D:DO_1                  '
  name(849) =  'charge_average_3D:allgather_1           '
  name(850) =  'charge_average_3D:DO_2                  '
  name(851) =  'charge_average_3D:DO_3                  '
  name(852) =  'charge_average_3D:DO_4                  '
  name(853) =  'cp_chgq_by_ngpt:isend/irecv_1           '
  name(854) =  'cp_chgq_by_ngpt:DO_1                    '
  name(855) =  'cp_chgq_by_ngpt:DO_2                    '
  name(856) =  'cp_chgq_by_ngpt:DO_3                    '
  name(857) =  'm_CD_conversion_check_3D:DO_1           '
  name(858) =  'm_CD_conversion_check_3D:allreduce_1    '
  name(859) =  'm_CD_conversion_check_3D:DO_2           '
  name(860) =  'm_CD_conversion_check_3D:bcast_1        '
  name(861) =  'm_OP_occ_mat_ylm:DO_1                   '
  name(862) =  'm_OP_occ_mat_ao_kt:DO_1                 '
  name(863) =  'get_band_energy_3D:DO_1                 '
  name(864) =  'get_band_energy_3D:allreduce_1          '
  name(865) =  'get_xc_and_HE_of_old_CD_3D:DO_1         '
  name(866) =  'get_xc_and_HE_of_old_CD_3D:DO_2         '
  name(867) =  'get_xc_and_HE_of_old_CD_3D:allreduce_1  '
  name(868) =  'get_local_potential_energy_3D:DO_1      '
  name(869) =  'get_local_potential_energy_3D:allreduce '
  name(870) =  'get_nonlocal_potential_energy_3D:DO_1   '
  name(871) =  'get_nonlocal_potential_energy_3D:allredu'
  name(872) =  'get_hartree_energy_3D:DO_1              '
  name(873) =  'get_hartree_energy_3D:allreduce_1       '
  name(874) =  'get_dipole_energy_3D:DO_1               '
  name(875) =  'get_dipole_energy_3D:allreduce_1        '
  name(876) =  'xc_allocate_3D:DO_1                     '
  name(877) =  'set_f2or1_3D:DO_1                       '
  name(878) =  'set_f2or1_3D:DO_2                       '
  name(879) =  'map_charge_onto_a_fftcd_box:DO_1        '
  name(880) =  'map_charge_onto_a_fftcd_box:DO_2        '
  name(881) =  'map_charge_onto_a_fftcd_box:DO_3        '
  name(882) =  'map_charge_onto_a_fftcd_box:isend/irecv1'
  name(883) =  'map_charge_onto_a_fftcd_box:DO_4        '
  name(884) =  'check_of_negative_CD_3D:DO_1            '
  name(885) =  'check_of_negative_CD_3D:DO_2            '
  name(886) =  'check_of_negative_CD_3D:DO_3            '
  name(887) =  'check_of_negative_CD_3D:allreduce_1     '
  name(888) =  'cp_afft_to_chgrhr_3D:DO_1               '
  name(889) =  'check_lmn_even_3D:DO_1                  '
  name(890) =  'ggaxcp_diff_3D:allreduce_1              '
  name(891) =  'ggaxcp_diff_3D:allreduce_2              '
  name(892) =  'abs_grad_rho_up_down_total_3D:DO_1      '
  name(893) =  'abs_grad_rho_up_down_total_3D:DO_2      '
  name(894) =  'g_xyz_chden_l_3D:DO_1                   '
  name(895) =  'boundary_zero_into_afft_3D:DO_1         '
  name(896) =  'cp_afft_to_cgrad_rho_3D:DO_1            '
  name(897) =  'add_sq_afft_to_grad_rho_3D:DO_1         '
  name(898) =  'ex_ggapw91_3D:DO_1                      '
  name(899) =  'cr_ggapw91_3D:DO_1                      '
  name(900) =  'ex_ggapbe_3D:DO_1                       '
  name(1001)=  'cr_ggapbe_3D:DO_1                       '
  name(1002)=  'xclda_3D:DO_1                           '
  name(1003)=  'ggabek_3D:DO_1                          '
  name(1004)=  'ggaprd_3D:DO_1                          '
  name(1005)=  'ggaxcp_3D:allreduce_1                   '
  name(1006)=  'ggaxcp_3D:allreduce_2                   '
  name(1007)=  'dFxc_dgradrho_dot_gradrho2_3D:DO_1      '
  name(1008)=  'G_xyz_afft_3D:DO_1                      '
  name(1009)=  'add_negative_afft_to_grad_rho_3D:DO_1   '
  name(1010)=  'finally_gga_xc_pot_3D:DO_1              '
  name(1011)=  'xcpotf_3D:allreduce_1                   '
  name(1012)=  'xcpotf_3D:allreduce_2                   '
  name(1013)=  'xcpotf_wigner_3D:DO_1                   '
  name(1014)=  'xcpotf_wigner_3D:DO_2                   '
  name(1015)=  'xcpotf_pzold_3D:DO_1                    '
  name(1016)=  'xcpotf_xalfa_3D:DO_1                    '
  name(1017)=  'xcpotf_pz_3D:DO_1                       '
  name(1018)=  'xcpotf_vwn_3D:DO_1                     '
  name(1019)=  'xcpotf_mjw_bh_gl_3D:DO_1                '
  name(1020)=  'cpafft_3D:DO_1                          '
  name(1021)=  'map_fftcd_onto_charge:isend/irecv_1     '
  name(1022)=  'map_fftcd_onto_charge:DO_1              '
  name(1023)=  'map_fftcd_onto_charge:DO_2              '
  name(1024)=  'map_fftcd_onto_charge:DO_3              '
  name(1025)=  'rhos_diff:DO_1                          '
  name(1026)=  'rhopc_diff_3D:DO_1                      '
  name(1027)=  'even_case_3D:DO_1                       '
  name(1028)=  'odd_case_3D:DO_1                        '
  name(1029)=  'real_case_3D:DO_1                       '
  name(1030)=  'real_case_3D:DO_2                       '
  name(1031)=  'complex_case_3D:DO_1                    '
  name(1032)=  'dgrhodh1_3D:DO_1                        '
  name(1033)=  'stress_correlation_part_3D:DO_1         '
  name(1034)=  'sum_s_gga12:allreduce_1                 '
  name(1035)=  'sum_s_gga12:allreduce_2                 '
  name(1036)=  'sum_s_gga12:allreduce_3                 '
  name(1037)=  'sum_s_gga12:allreduce_4                 '
  name(1038)=  'sum_s_gga12:send/recv_1                 '
  name(1039)=  'sum_s_gga12:send/recv_2                 '
  name(1040)=  'dgrhodh2_3D:DO_1                        '
  name(1041)=  'dgrhodh2_3D:DO_2                        '
  name(1042)=  'stress_exchange_part_3D:DO_1            '
  name(1043)=  'stress_exchange_part_3D:DO_2            '
  name(1044)=  'map_drhodh1_3D:DO_1                     '
  name(1045)=  'map_drhodh1_3D:allreduce_1              '
  name(1046)=  'map_drhodh1_3D:allreduce_2              '
  name(1047)=  'map_drhodh2_3D:DO_1                     '
  name(1048)=  'map_drhodh2_3D:allreduce_1              '
  name(1049)=  'map_drhodh2_3D:allreduce_2              '
  name(693)=  'map_fft_to_chgq_3D:alltoallv_1           '
  name(694)=  'cp_chgq_by_ngpt:alltoall_1(List)         '
  name(695)=  'map_fftcd_onto_charge:alltoallv_1        '
  name(696)=  'map_charge_onto_a_fftcd_box:alltoallv_1  '
! -- KUKAN_7 / FFT / ID= 1050 -> 1051
  name(691)=  'kukan_7:FFT_INVERSE                     '
  name(692)=  'kukan_7:FFT_DIRECT                      '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_8&9 / SUBROUTINE / ID= 901 -> 913
  name(901) =  'evolve_WFs_in_subspace_3D               '
  name(902) =  'set_col_partition_3D                    '
  name(903) =  'scalapack_setup_3D                      '
  name(904) =  'set_hmat_3D                             '
  name(905) =  'gather_zmat_all                         '
  name(906) =  'pdsyev_driver_3D                        '
  name(907) =  'pzheev_driver_3D                        '
  name(908) =  'dsyev_driver                            '
  name(909) =  'zheev_driver                            '
  name(910) =  'hobsvw_driver                           '
  name(911) =  'chobsd_driver                           '
  name(912) =  'subspace_rotation_real_3D               '
  name(913) =  'subspace_rotation_imag_3D               '
!fj add 20110819
  name(963) =  'set_hmat_3D_scl                         '
  name(964) =  'trans_scalapack                         '
  name(965) =  'trans_scalapack_r                       '
!fj add 20110819
!fj add 20110901
  name(988) =  'eig_send                                '
!fj add 20110901
! -- KUKAN_8&9 / COMMUNICATION & DGEMM & DO / ID= 914 -> 959
  name(914) =  'evolve_WFs_in_subspace_3D:allreduce_1   '
  name(915) =  'evolve_WFs_in_subspace_3D:isend/irecv_1 '
  name(916) =  'evolve_WFs_in_subspace_3D:DO_1          '
  name(917) =  'evolve_WFs_in_subspace_3D:DO_2          '
  name(918) =  'evolve_WFs_in_subspace_3D:DO_3          '
  name(919) =  'evolve_WFs_in_subspace_3D:DO_4          '
  name(920) =  'evolve_WFs_in_subspace_3D:DO_5          '
  name(921) =  'evolve_WFs_in_subspace_3D:DGEMM_1       '
  name(922) =  'evolve_WFs_in_subspace_3D:DGEMM_2       '
  name(923) =  'evolve_WFs_in_subspace_3D:DO_6          '
  name(924) =  'evolve_WFs_in_subspace_3D:DGEMM_3       '
  name(925) =  'evolve_WFs_in_subspace_3D:DO_7          '
  name(926) =  'evolve_WFs_in_subspace_3D:DO_8          '
  name(927) =  'evolve_WFs_in_subspace_3D:DO_9          '
  name(928) =  'evolve_WFs_in_subspace_3D:DO_10         '
  name(929) =  'evolve_WFs_in_subspace_3D:DO_11         '
  name(930) =  'evolve_WFs_in_subspace_3D:DO_12         '
  name(931) =  'evolve_WFs_in_subspace_3D:DO_13         '
  name(932) =  'evolve_WFs_in_subspace_3D:DO_14         '
  name(933) =  'evolve_WFs_in_subspace_3D:allreduce_2   '
  name(934) =  'evolve_WFs_in_subspace_3D:DO_15         '
  name(935) =  'evolve_WFs_in_subspace_3D:DO_16         '
  name(936) =  'evolve_WFs_in_subspace_3D:DO_17         '
  name(937) =  'evolve_WFs_in_subspace_3D:DO_18         '
  name(938) =  'evolve_WFs_in_subspace_3D:DO_19         '
  name(939) =  'evolve_WFs_in_subspace_3D:DO_20         '
  name(940) =  'set_col_partition_3D:DO_1               '
  name(941) =  'set_col_partition_3D:DO_2               '
  name(942) =  'make_usermap                            '
  name(943) =  'set_hmat_3D:DO_1                        '
  name(944) =  'set_hmat_3D:reduce_scatter_1            '
  name(945) =  'set_hmat_3D:DO_2                        '
  name(946) =  'set_hmat_3D:reduce_scatter_2            '
  name(947) =  'set_hmat_3D:DO_3                        '
  name(948) =  'gather_zmat_all:DO_1                    '
  name(949) =  'gather_zmat_all:allgather               '
  name(950) =  'gather_zmat_all:DO_2                    '
  name(951) =  'gather_zmat_all:DO_3                    '
  name(952) =  'gather_zmat_all:DO_4                    '
  name(953) =  'subspace_rotation_real_3D:DGEMM_1       '
  name(954) =  'subspace_rotation_real_3D:DO_1          '
  name(955) =  'subspace_rotation_imag_3D:DGEMM_1       '
  name(956) =  'subspace_rotation_imag_3D:DO_2          '
  name(957) =  'subspace_rotation_imag_3D:DO_3          '
  name(958) =  'subspace_rotation_imag_3D:DGEMM_2       '
  name(959) =  'subspace_rotation_imag_3D:DO_4          '
  name(960) =  'evolve_WFs_in_subspace_3D:DO_21         '
! -- KUKAN_8 / FFT / ID= 961 -> 962
  name(961)=  'kukan_8:FFT_INVERSE                     '
  name(962)=  'kukan_8:FFT_DIRECT                      '

!fj add 20110819
  name(966) =  'set_hmat_3D_scl:DO_1                    '
  name(967) =  'set_hmat_3D_scl:reduce_scatter_1        '
  name(968) =  'set_hmat_3D_scl:DO_2                    '
  name(969) =  'set_hmat_3D_scl:reduce_scatter_2        '
  name(970) =  'set_hmat_3D_scl:DO_3                    '
  name(971) =  'trans_scalapack:DO_1                    '
  name(972) =  'trans_scalapack:DO_2                    '
  name(973) =  'trans_scalapack:DO_3                    '
  name(974) =  'trans_scalapack:DO_4                    '
  name(975) =  'trans_scalapack:isend/irecv_1           '
  name(976) =  'trans_scalapack_r:DO_1                  '
  name(977) =  'trans_scalapack_r:DO_2                  '
  name(978) =  'trans_scalapack_r:DO_3                  '
  name(979) =  'trans_scalapack_r:DO_4                  '
  name(980) =  'trans_scalapack_r:isend/irecv_1         '
  name(981) =  'evolve_WFs_in_subspace_3D:DO_21         '
  name(982) =  'evolve_WFs_in_subspace_3D:allgather     '
  name(983) =  'evolve_WFs_in_subspace_3D:DO_22         '
  name(984) =  'evolve_WFs_in_subspace_3D:DO_23         '
  name(985) =  'evolve_WFs_in_subspace_3D:DO_24         '
  name(986) =  'evolve_WFs_in_subspace_3D:DO_25         '
  name(987) =  'evolve_WFs_in_subspace_3D:allgather     '
  name(992) =  'trans_scalapack:alltoall_1(List)        '
  name(993) =  'trans_scalapack_r:alltoall_1(List)      '
  name(994) =  'evolve_WFs_in_subspace_3D:alltoallv_1   '
!fj add 20110820
!fj add 20110901
  name(989) =  'eigsend:send                            '
  name(990) =  'eigsend:recv                            '
  name(991) =  'dsyev_driver  dsyev || dsyevd           '
!fj add 20110901

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_11 / SUBROUTINE / ID= 1101 -> 1145
  name(1101) = 'ChargeDensity_Mixing_3D                 '
  name(1102) = 'm_CD_prepare_precon_3D                  '
  name(1103) = 'm_CD_simple_mixing_3D                   '
  name(1104) = 'alloc_chgqstore_recompose_chgq_3D       '
  name(1105) = 'precon_4_charge_mix_3D                  '
  name(1106) = 'compose_chgq_dealloc_chgqstore_3D       '
  name(1107) = 'm_CD_mix_broyden1_3D                    '
  name(1108) = 'simple_mix1_3D                          '
  name(1109) = 'mix_broyden_alloc3_3D                   '
  name(1110) = 'dF_F_d0_u_v_and_dd_3D                   '
  name(1111) = 'set_ncrspd_mxiter_etc                   '
  name(1112) = 'rotate_cmix_arrays                      '
  name(1113) = 'renew_u_br_3D                           '
  name(1114) = 'mult1s_3D                               '
  name(1115) = 'mult1s5_3D                              '
  name(1116) = 'subtr_j_th_term_3D                      '
  name(1117) = 'renew_v_3D                              '
  name(1118) = 'renew_d_br_3D                           '
  name(1119) = 'store_to_urec2_3D                       '
  name(1120) = 'renew_d_last_br_3D                      '
  name(1121) = 'scatter_chg_onto_d_3D                   '
  name(1122) = 'concentrate_d_to_chg_3D                 '
  name(1123) = 'simple_mix_large_Gc_3D                  '
  name(1124) = 'm_CD_mix_broyden2_3D                    '
  name(1125) = 'dF_F_d0_u_and_v_3D                      '
  name(1126) = 'm_CD_mix_DFP_3D                         '
  name(1127) = 'dF_F_d0_u_and_w_3D                      '
  name(1128) = 'renew_w_3D                              '
  name(1129) = 'renew_d_3D                              '
  name(1130) = 'renew_d_last_3D                         '
  name(1131) = 'm_CD_mix_pulay_3D                       '
  name(1132) = 'Resid_and_dd_into_urec                  '
  name(1133) = 'Ri_dot_Rj_3D                            '
  name(1134) = 'get_finv_3D                             '
  name(1135) = 'rdecomp                                 '
  name(1136) = 'rsolve                                  '
  name(1137) = 'mult1s10_3D                             '
  name(1138) = 'Rj_dot_d_3D                             '
  name(1139) = 'get_gmatrix_3D                          '
  name(1140) = 'renew_d_using_g_3D                      '
  name(1141) = 'm_OP_simple_mixing                      '
  name(1142) = 'm_OP_mix_broyden1                       '
  name(1143) = 'm_OP_mix_broyden2                       '
  name(1144) = 'm_CD_simple_mixing_hsr_3D               '
  name(1145) = 'm_CD_check_3D                           '
  name(1050) = 'm_ESlhxc_potential_3D                   '
  name(1051) = 'm_Dipole_calc_3D                        '
  name(1052) = 'electron_part_3D                        '
  name(1053) = 'ion_part                                '
  name(1054) = 'm_Dipole_potential_3D                   '
  name(1055) = 'edip_ion_part                           '
  name(1056) = 'm_ESlhxc_wd_vlhxc_3D                    '
  name(1057) = 'm_ESiVQ_integrate_VlhxcQlm_3D           '
  name(1058) = 'm_PP_find_maximum_l                     '
  name(1059) = 'm_pwBS_sphrp2_3D                        '
  name(1060) = 'substitute_vlhxcred                     '
  name(1061) = 'dp_Vlhxcq_exp_Q_div                     '
  name(1062) = 'veQ_dot_ylm_div                         '
  name(1063) = 'symmetrize_vlhxcq                       '
! -- KUKAN_11 / COMMUNICATION & DGEMM & DO / ID= 1146 -> 1197
  name(1146) = 'm_CD_prepare_precon_3D:allreduce_1      '
  name(1147) = 'm_CD_prepare_precon_3D:allreduce_2      '
  name(1148) = 'm_CD_simple_mixing_3D:DO_1              '
  name(1149) = 'alloc_chgqstore_recompose_chgq_3D       '
  name(1150) = 'precon_4_charge_mix_3D:DO_1             '
  name(1151) = 'precon_4_charge_mix_3D:DO_2             '
  name(1152) = 'precon_4_charge_mix_3D:DO_3             '
  name(1153) = 'compose_chgq_dealloc_chgqstore_3D:DO_1  '
  name(1154) = 'simple_mix1_3D:DO_1                     '
  name(1155) = 'simple_mix1_3D:DO_2                     '
  name(1156) = 'dF_F_d0_u_v_and_dd_3D:DO_1              '
  name(1157) = 'dF_F_d0_u_v_and_dd_3D:DO_2              '
  name(1158) = 'rotate_cmix_arrays:DO_1                 '
  name(1159) = 'rotate_cmix_arrays:DO_2                 '
  name(1160) = 'mult1s_3D:DO_1                          '
  name(1161) = 'mult1s_3D:allreduce_1                   '
  name(1162) = 'mult1s5_3D:DO_1                         '
  name(1163) = 'mult1s5_3D:allreduce_1                  '
  name(1164) = 'subtr_j_th_term_3D:DO_1                 '
  name(1165) = 'store_to_urec2_3D:DO_1                  '
  name(1166) = 'renew_d_last_br_3D:DO_1                 '
  name(1167) = 'renew_d_last_br_3D:DO_2                 '
  name(1168) = 'scatter_chg_onto_d_3D:DO_1              '
  name(1169) = 'scatter_chg_onto_d_3D:bcast_1           '
  name(1170) = 'scatter_chg_onto_d_3D:DO_2              '
  name(1171) = 'concentrate_d_to_chg_3D:DO_1            '
  name(1172) = 'concentrate_d_to_chg_3D:send/recv_1     '
  name(1173) = 'concentrate_d_to_chg_3D:DO_2            '
  name(1174) = 'simple_mix_large_Gc_3D:DO_1             '
  name(1175) = 'dF_F_d0_u_and_v_3D:DO_1                 '
  name(1176) = 'dF_F_d0_u_and_v_3D:DO_2                 '
  name(1177) = 'dF_F_d0_u_and_w_3D:DO_1                 '
  name(1178) = 'renew_d_last_3D:DO_1                    '
  name(1179) = 'Ri_dot_Rj_3D:DO_1                       '
  name(1180) = 'get_finv_3D:DO_1                        '
  name(1181) = 'get_finv_3D:DO_2                        '
  name(1182) = 'rdecomp:DO_1                            '
  name(1183) = 'rdecomp:DO_2                            '
  name(1184) = 'rsolve:DO_1                             '
  name(1185) = 'rsolve:DO_2                             '
  name(1186) = 'mult1s10_3D:DO_1                        '
  name(1187) = 'mult1s10_3D:allreduce_1                 '
  name(1188) = 'get_gmatrix_3D:DO_1                     '
  name(1189) = 'renew_d_using_g_3D:DO_1                 '
  name(1190) = 'renew_d_using_g_3D:DO_2                 '
  name(1191) = 'm_OP_mix_broyden1:DO_1                  '
  name(1192) = 'm_CD_simple_mixing_hsr_3D:DO_1          '
  name(1193) = 'm_CD_check_3D:DO_1                      '
  name(1194) = 'm_CD_check_3D:DO_2                      '
  name(1195) = 'm_CD_check_3D:DO_3                      '
  name(1196) = 'm_CD_check_3D:bcast_1                   '
  name(1197) = 'm_CD_check_3D:bcast_2                   '
  name(1064) = 'm_ESlhxc_potential_3D:DO_1              '
  name(1065) = 'm_ESlhxc_potential_3D:DO_2              '
  name(1066) = 'm_ESlhxc_potential_3D:DO_3              '
  name(1067) = 'electron_part_3D:DO_1                   '
  name(1068) = 'electron_part_3D:bcast_1                '
  name(1069) = 'electron_part_3D:allreduce_1            '
  name(1070) = 'ion_part:DO_1                           '
  name(1071) = 'ion_part:DO_2                           '
  name(1072) = 'm_Dipole_potential_3D:DO_1              '
  name(1073) = 'm_Dipole_potential_3D:DO_2              '
  name(1074) = 'edip_ion_part:DO_1                      '
  name(1075) = 'edip_ion_part:DO_2                      '
  name(1076) = 'm_ESiVQ_integrate_VlhxcQlm_3D:DO_1      '
  name(1077) = 'm_ESiVQ_integrate_VlhxcQlm_3D:allreduce1'
  name(1078) = 'm_ESiVQ_integrate_VlhxcQlm_3D:DO_2      '
  name(1079) = 'm_ESiVQ_integrate_VlhxcQlm_3D:allreduce2'
  name(1080) = 'm_PP_find_maximum_l:DO_1                '
  name(1081) = 'm_pwBS_sphrp2_3D:DO_1                   '
  name(1082) = 'm_pwBS_sphrp2_3D:DO_2                   '
  name(1083) = 'substitute_vlhxcred:DO_1                '
  name(1084) = 'dp_Vlhxcq_exp_Q_div:DO_1                '
  name(1085) = 'veQ_dot_ylm_div:DO_1                    '
  name(1086) = 'symmetrize_vlhxcq:DO_1                  '
  name(1087) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP0      '
  name(1088) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP1      '
  name(1089) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP2      '
  name(1090) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP3      '
  name(1091) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP4      '
  name(1092) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP5      '
  name(1093) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP6      '
  name(1094) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP7      '
  name(1095) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP8      '
  name(1096) = 'm_ESiVQ_integrate_VlhxcQlm_3D:OMP9      '
! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- KUKAN_FORCE
  name(1501) =  'm_Force_initialize                      '
  name(1502) =  'm_Force_term_drv_of_flmt_3D             '
  name(1503) =  'm_Force_term_drv_of_VlhxcQ_3D           '
  name(1504) =  'm_Force_term_Elocal_and_Epc_3D          '
  name(1505) =  'm_Force_term_dipole                     '
  name(1506) =  'm_Force_sumup_and_symmetrize            '
  name(1507) =  'm_Force_cal_forcmx                      '
  name(1508) =  'm_Force:comm1                           '
  name(1509) =  'm_Force:comm2                           '
  name(1510) =  'm_Force:comm3                           '
  name(1511) =  'm_Force:comm4                           '
  name(1512) =  'm_Force:comm5                           '
  name(1513) =  'm_Force:comm6                           '
  name(1514) =  'm_Force:comm7                           '
  name(1515) =  'm_Force:comm8                           '
  name(1516) =  'm_Force:comm9                           '
  name(1517) =  'gather_f_3d_to_2d                       '
  name(1518) =  'term_related_to_drv_of_flmt_NC          '
  name(1519) =  'term_related_to_drv_of_flmt_VDB         '
  name(1520) =  'substitute_ngabcred                     '
  name(1521) =  'calc_phase_div                          '
  name(1522) =  'pre_drv_of_betar_dot_WFs_div            '
  name(1523) =  'drv_of_betar_dot_WFs_div                '
  name(1524) =  'calc_phase_div                          '
  name(1525) =  'sum_hsr_dot_gauntc                      '
  name(1526) =  'hsr_dot_gaunt                           '
  name(1527) =  'add_hardpart_to_flhxcq_l_core           '
  name(1528) =  'add_hardpart_to_flhxcq_l_div            '
  name(1529) =  'force_from_Epc_for_each_atom            '
  name(1530) =  'force_from_Elocal_4_each_atom           '
  name(1531) =  'm_Force_term_Elocal_and_Epc_3D:DO_1     '
  name(1532) =  'm_Force_term_Elocal_and_Epc_3D:DO_2     '
  name(1533) =  'force_from_Epc_for_each_atom:DO_1       '
  name(1534) =  'force_from_Epc_for_each_atom:DO_2       '
  name(1535) =  'force_from_Elocal_4_each_atom:DO_1      '
  name(1536) =  'm_Force_term_drv_of_vlhxcQ_3D:DO_1      '
  name(1537) =  'm_Force_term_drv_of_vlhxcQ_3D:DO_2      '
  name(1538) =  'calc_phase_div:DO_1                     '
  name(1539) =  'sum_hsr_dot_gauntc:DO_1                 '
  name(1540) =  'add_hardpart_to_flhxcq_l_core:DO_1      '
  name(1541) =  'add_hardpart_to_flhxcq_l_core:DO_2      '
  name(1542) =  'add_hardpart_to_flhxcq_l_div:DO_1       '
  name(1543) =  'add_hardpart_to_flhxcq_l_div:DO_2       '
  name(1544) =  'm_Force_term_drv_of_flmt_3D:DO_1        '
  name(1545) =  'gather_f_3d_to_2d:DO_1                  '
  name(1546) =  'term_related_to_drv_of_flmt_NC:DO_1     '
  name(1547) =  'term_related_to_drv_of_flmt_VDB:DO_1    '
  name(1548) =  'substitute_ngabcred:DO_1                '
  name(1549) =  'calc_phase_div:DO_1                     '
  name(1550) =  'pre_drv_of_betar_dot_WFs_div:DO_1       '
  name(1551) =  'pre_drv_of_betar_dot_WFs_div:DO_2       '
  name(1552) =  'drv_of_betar_dot_WFs_div:DO_1           '
  name(1553) =  'drv_of_betar_dot_WFs_div:DO_2           '

! name(000) = '---------1---------2---------3---------4---------5---------6----'
! -- RMM SOLVERE
  name(1601) =  'RMM_Initialize                          '
  name(1602) =  'RMM_zajold2zaj_phi2zaj_old_3D           '
  name(1603) =  'RMM_Vnonlocal_W_RMM_3D                  '
  name(1604) =  'RMM_temporary_FFT                       '
  name(1605) =  'RMM_rmm1_3D                             '
  name(1606) =  'RMM_rmm_n_uda_3D                        '
  name(1607) =  'RMM_zajold2zaj_phi2zaj_old_all_3D       '
  name(1608) =  'RMM_Vnonlocal_W_RMMn_3D                 '
  name(1609) =  'RMM_temporary_FFT                       '
  name(1610) =  'RMM_rmm1_3D                             '
  name(1611) =  'RMM_rmm_n_uda_3D                        '
  name(1612) =  'RMM_Finalize                            '
  name(1613) =  'RMM2_calc_phasek_b_3D                   '
  name(1614) =  'RMM2_sumset_rmm_all4                    '
  name(1615) =  'RMM2_Vnonlocal_W_part_sum_ovr_lmt4      '
  name(1616) =  'RMM2_add_vnlph_l_part4                  '
  name(1617) =  'RMM2_sumset_rmm_all3                    '
  name(1618) =  'RMM2_Vnonlocal_W_part_sum_over_lmt1b    '
  name(1619) =  'RMM2_add_vnlph_l_without_eko_part3      '
  name(1620) =  'RMM2_add_vnlph_l_with_eko_part3         '
  name(1621) =  'RMM2_rr_avr_final_3D:allreduce          '
  name(1622) =  'RMM2_rmm1_3D:allreduce                  '
  name(1623) =  'RMM2_sumset_rmm:allreduce               '
  name(1624) =  'RMM2_sumset_rmm_all4:allreduce          '
  name(1625) =  'RMM2_sumset_rmm_all3:allreduce          '


  return
end subroutine timer_init

!-----------------------------------------------------------------------
subroutine timer_fin
  use m_IterationNumbers,   only  : iteration
  use m_Parallelization ,   only  : nrank_e,nrank_g,nrank_k
  use m_timer
  implicit none

#ifdef USE_WTIME
  include 'mpif.h'
#endif

  integer :: ierr
  integer :: i, it, m, n_err, n_err_g
  real(4) :: rdum, rarray(2)
!  real(4), external :: etime
  real(4) :: etime
  logical  :: infoflg

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

!$omp parallel
      call ktrace_exit
!$omp end parallel
#endif

  ! user and system cpu time
  rdum = etime(rarray)
#ifdef USE_WTIME
  ttot(1) = MPI_WTIME() - ttot(1)  ! real
#else
  call getclkreg(t_now)
  ttot(1) = t_now       - ttot(1)  ! real
#endif
  ttot(2) = rarray(1)   - ttot(2)  ! user
  ttot(3) = rarray(2)   - ttot(3)  ! sys

  call getenv('FJ_TIMER_DIR', dname)
  if (len_trim(dname) .eq. 0) then
    dname = '.'
  else
    call system( &
 &    'if [ ! -d '//dname//' ]; then mkdir -p '//dname//'; fi')
  endif
  call getenv('FJ_TIMER_RNK', crank)
  if (crank .ne. "ALL") then
     if (len_trim(crank) .eq. 0) then
        orank = 0
     else
        read(crank,*) orank
     endif
  endif
  if ((myrank .eq. orank) .or. (crank .eq. "ALL")) then

    ncount_all = 0
    timers_all = 0.0d0

    do it = 0, iteration
!
      if (it > n_ite) cycle
!
      if (crank .eq. "ALL") then
        write(fname,'(A,"/timer_ite_",I3.3,"_",I6.6,".out")') &
     &        dname(:len_trim(dname)), it, myrank
      else
        write(fname,'(A,"/timer_ite_",I3.3,".out")') &
     &        dname(:len_trim(dname)), it
      endif
      if (iunit1 .ne. 6) open(iunit1, file=fname)


      write(IUNIT1,'("cfj_info # nodes = ",i5,2x,"ne,ng,ng = ",i5,x,i5,x,i5)') &
     &                nrank_e*nrank_g*nrank_k,nrank_e,nrank_g,nrank_k
#ifdef USE_WTIME
      write(IUNIT1,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
     &                myrank, ttot
#else
      write(IUNIT1,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
     &                myrank, ttot*5e-10
#endif
      write(IUNIT1,'("cfj # rank = ", i6,2x," Iteration = ", i6)') &
     &                myrank, it
      do i = 1, N_TIM
        if ((name(i) .ne. '-').or.(ncount(i,it).ne.0)) then
#ifdef USE_WTIME
          write(IUNIT1,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
         &  i, name(i), timers(i,it),       ncount(i,it)
#else
          write(IUNIT1,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
         &  i, name(i), timers(i,it)*5e-10, ncount(i,it)
#endif
        endif
        timers_all(i) = timers_all(i) + timers(i,it)
        ncount_all(i) = ncount_all(i) + ncount(i,it)
      enddo
      write(IUNIT1,'()')
    enddo

    if (crank .eq. "ALL") then
      write(fname,'(A,"/timer_tot_",I6.6,".out")') &
   &        dname(:len_trim(dname)), myrank
    else
      write(fname,'(A,"/timer_tot.out")') &
   &        dname(:len_trim(dname))
    endif
    if (iunit2 .ne. 6) open(iunit2, file=fname)
    write(IUNIT2,'("cfj_info # nodes = ",i5,2x,"ne,ng,ng = ",i5,x,i5,x,i5)') &
   &                  nrank_e*nrank_g*nrank_k,nrank_e,nrank_g,nrank_k 
#ifdef USE_WTIME
    write(IUNIT2,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
   &                  myrank, ttot
#else
    write(IUNIT2,'("cfj # rank = ",i6,2x,"real,user,sys = ",3f13.3)') &
   &                  myrank, ttot*5e-10
#endif
    write(IUNIT2,'("cfj # rank = ", i6,2x," Total Iteration = ", i3)') &
   &                  myrank, iteration
    do i = 1, N_TIM
      if ((name(i) .ne. '-').or.(ncount_all(i).ne.0)) then
!      if (ncount_all(i).ne.0) then
#ifdef USE_WTIME
         write(IUNIT2,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
        &  i, name(i), timers_all(i),       ncount_all(i)
#else
         write(IUNIT2,'("cfj ",i4,1x,a,f13.3,1x,i8)') &
        &  i, name(i), timers_all(i)*5e-10, ncount_all(i)
#endif
      endif
    enddo
    write(IUNIT2,'()')

#ifdef USE_MEM
    call flush(unitmw)
    close(unitmw)
#endif
    call flush(IUNIT1)
    call flush(IUNIT2)
    if (IUNIT1 .ne. 6) close(IUNIT1)
    if (IUNIT2 .ne. 6) close(IUNIT2)

  endif

  return
end subroutine timer_fin
!-----------------------------------------------------------------------

subroutine timer_sta(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
#ifdef USE_WTIME
  include 'mpif.h'
#endif
  integer :: id,idx
  character*5 cid
  character*3 citer
  character*11 ccc

! if (.not.tflag) return
!$omp master
  if(id < 0) then
!   idx = id * (-1) + 90000
    idx = id * (-1)
  else
    idx = id
  endif

  write(cid,'(I5.5)') idx
  write(citer,'(I3.3)') iteration
  ccc = "r_"//citer//"_"//cid

#ifdef USE_MEM
  if (myrank .eq. 0) then
    integer :: j
    character(1000) :: line
    character(15),dimension(24) :: str

    open(unitmr,file='/proc/self/stat', form="formatted", access="stream", status='old')
    read(unitmr,'(a)') line
    close(unitmr)
    read(line,*) (str(j),j=1,24)
#ifdef USE_WTIME
    write(unitmw,*) ccc, " sta", MPI_WTIME()-t_sta, str(23), str(24)
#else
    call getclkreg(t_now)
    write(unitmw,*) ccc, " sta", (t_now-t_sta)*5d-10, str(23), str(24)
#endif
  endif
#endif

#ifdef USE_TOFUPA
  call fj_tofupa_start(ccc,id,1)
#endif

#ifdef USE_KTRACE
  integer ktrace_target(n_tim)
  common /c_ktrace_target/ ktrace_target

  if (ktrace_target(id) .eq. 1) then
    call ktrace_start(id)
  endif
#endif

#ifdef USE_PROF
  call start_collection(ccc)
#endif

#ifdef USE_FAPP
  call FAPP_START(ccc,1,1)
#endif
!
  if(iteration <= n_ite) then
!
#ifdef USE_WTIME
  tsta(idx) = MPI_WTIME()
#else
  call getclkreg(tsta(idx))
#endif
  ncount(idx,iteration) = ncount(idx,iteration) + 1
!
  end if
!
!$omp end master
  return
end subroutine timer_sta

!-----------------------------------------------------------------------
subroutine timer_end(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
#ifdef USE_WTIME
  include 'mpif.h'
#endif
  integer :: id,idx
  character*5 cid
  character*3 citer
  character*11 ccc

! if (.not.tflag) return
!$omp master
  if(id < 0) then
!   idx = id * (-1) + 90000
    idx = id * (-1)
  else
    idx = id
  endif

  write(cid,'(I5.5)') idx
  write(citer,'(I3.3)') iteration
  ccc = "r_"//citer//"_"//cid

#ifdef USE_MEM
  if (myrank .eq. 0) then
    integer :: j
    character(1000) :: line
    character(15),dimension(24) :: str

    open(unitmr,file='/proc/self/stat', form="formatted", access="stream", status='old')
    read(unitmr,'(a)') line
    close(unitmr)
    read(line,*) (str(j),j=1,24)
#ifdef USE_WTIME
    write(unitmw,*) ccc, " end", MPI_WTIME()-t_sta, str(23), str(24)
#else
    call getclkreg(t_now)
    write(unitmw,*) ccc, " end", (t_now-t_sta)*5d-10, str(23),str(24)
#endif
  endif
#endif

#ifdef USE_KTRACE
      integer ktrace_target(n_tim)
      common /c_ktrace_target/ ktrace_target

      if (ktrace_target(id) .eq. 1) then
        call ktrace_stop(id)
      endif
#endif

#ifdef USE_PROF
  call stop_collection(ccc)
#endif

#ifdef USE_FAPP
  call FAPP_STOP(ccc,1,1)
#endif

#ifdef USE_TOFUPA
  call fj_tofupa_stop(ccc,id,1)
#endif
!
  if(iteration <= n_ite) then
!
#ifdef USE_WTIME
  timers(idx,iteration) = timers(idx,iteration) + (MPI_WTIME() - tsta(idx))
#else
  call getclkreg(t_now)
  timers(idx,iteration) = timers(idx,iteration) + (t_now       - tsta(idx))
#endif
  ncnt_e(idx,iteration) = ncnt_e(idx,iteration) + 1
!
  end if
!
!$omp end master
  return
end subroutine timer_end

!-----------------------------------------------------------------------
subroutine timer_bar(id)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: id
  integer :: ierr

!
  if(iteration > n_ite) return
!
!$omp master
#ifdef USE_WTIME
  tsta(id) = MPI_WTIME()
#else
  call getclkreg(tsta(id))
#endif
  ncount(id,iteration) = ncount(id,iteration) + 1
  call MPI_BARRIER(MPI_COMM_WORLD, ierr)
#ifdef USE_WTIME
  timers(id,iteration) = timers(id,iteration) + (MPI_WTIME() - tsta(id))
#else
  call getclkreg(t_now)
  timers(id,iteration) = timers(id,iteration) + (t_now       - tsta(id))
#endif
  ncnt_e(id,iteration) = ncnt_e(id,iteration) + 1
!$omp end master

  return
end subroutine timer_bar

!-----------------------------------------------------------------------
subroutine timer_barrier(mpi_comm)
  use m_IterationNumbers,   only  : iteration
  use m_timer
  implicit none
  include 'mpif.h'
  integer :: mpi_comm
  integer :: ierr

!$omp master
  call MPI_BARRIER(MPI_COMM, ierr)
!$omp end master

  return
end subroutine timer_barrier

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  SUBROUINE: WriteDownData_onto_Files_ek, FermiEnergyLevel_ek()
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, December/01/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!$$#ifndef PARA3D
subroutine WriteDownData_onto_Files_ek
! $Id: WriteDownData_onto_Files_ek.f90 409 2014-10-27 09:24:52Z jkoga $
  use m_Files,               only : m_Files_open_nfcntn,m_Files_close_all &
       &                     ,nfcntn,nfchgt,nfzaj,m_Files_open_nfcntn_bin &
       &                     ,nfcntn_bin,nfout,nfeng, nfstatus &
       &                     ,F_CNTN_BIN_partitioned &
       &                     , m_Files_open_nfstatus, m_Files_skiptoend &
       &                     , m_Files_open_nfzaj_with_check
  use m_Const_Parameters,    only: EK,SCF,YES,EK_CONVERGED,PARABOLIC,TETRAHEDRON,ON,FINISH
  use m_Timing,              only: m_Timing_wd_status
  use m_Control_parameters,  only: ipri,ipriekzaj, neg, num_extra_bands, nspin &
       &                         , iconvergence_previous_job, iprijobstatus &
       &                         , jobstatus_series, jobstatus_format &
       &                         , continuation_using_ppdata, ekmode, neg_is_enlarged&
       &                         , m_CtrlP_wd_cpu_total, m_CtrlP_wd_iconvergence &
       &                         , m_CtrlP_wd_iconv_ek &
       &                         , m_CtrlP_way_of_smearing &
       &                         , m_CtrlP_wd_numk_zajsaved &
       &                         , sw_berry_phase
  use m_IterationNumbers,    only: iteration, iteration_ionic, iteration_electronic &
       &                         , nk_in_the_process &
       &                         , m_Iter_wd_iters_and_nk, m_Iter_electronic_reset
  use m_Parallelization,     only: mype
  use m_Kpoints,             only: kv3, kv3_ek
  use m_PseudoPotential,     only: m_PP_wd_PP_parameters_3D, m_PP_wd_betar
  use m_PlaneWaveBasisSet,   only: kgp
  use m_NonLocal_Potential,  only: m_NLP_wd_snl_3D
  use m_ES_LHXC,             only: m_ESlhxc_potential_3D
  use m_ES_IO,               only: m_ESIO_wd_EigenValues_ek &
       &                         , m_ESIO_wd_WFs_and_EVS_ek
  use m_ES_occup,            only: m_ESoc_fermi_parabolic_ek, m_ESoc_fermi_tetra_ek &
       &                         , m_ESoc_check_num_bands
  use m_Electronic_Structure,only: efermi, vbm, metalic_system, iconv_ek &
       &                         , m_ES_wd_zaj_small_portion0
  use m_ES_nonlocal,         only: m_ES_wd_fsr_fsi

! ============================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,  only : noncol, ndim_spinor
! ================================================================== 11.0

! ============================== KT_Add ===================== 13.0E
  use m_Const_Parameters,     only : Fermi_Dirac
  use m_ES_occup,            only: m_ESoc_fermi_dirac_ek
! =========================================================== 13.0E

  use m_BerryPhase,          only : m_BP_wd_cntn_data
  implicit none
  integer :: status_wdmode, numk_zajsaved
  logical :: Allkpoints_are_Calculated, enough_bands

  if(iconvergence_previous_job < EK_CONVERGED) then
     call m_Files_open_nfcntn                        ! -(m_Files)
     if(mype==0) rewind nfcntn
     if(ipriekzaj<=0) call m_Iter_electronic_reset()
     call m_Iter_wd_iters_and_nk(nfcntn)
     call m_CtrlP_wd_iconvergence(nfcntn)
     numk_zajsaved = min(kv3_ek,nk_in_the_process+kv3-1)
     call m_CtrlP_wd_numk_zajsaved(nfcntn,numk_zajsaved)
     call m_CtrlP_wd_iconv_ek(kv3_ek,iconv_ek,nfcntn)

     call m_ESIO_wd_EigenValues_ek(nfout,mode=SCF)

     if(continuation_using_ppdata == YES) then
        call m_Files_open_nfcntn_bin
        if(mype==0) rewind nfcntn_bin
        call m_PP_wd_PP_parameters_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kgp)
        call m_PP_wd_betar(nfcntn_bin)
        call m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
     end if

     if(Allkpoints_are_Calculated()) then
        enough_bands = m_ESoc_check_num_bands()
        if(enough_bands) then
           call FermiEnergylevel_ek()   ! -> metalic_system?, vbm, efermi
!!$           stop ' WriteDownData_onto_Files_ek (1)'
           if(ipri >= 1) write(nfout,'(" --- efermi = ",f8.4)') efermi
        else
           if(ipri >= 1) write(nfout,'(" --- efermi can not be estimated --")')
        end if
        rewind nfeng

       if(ipri >= 1) then
! -------------------------------------
!
! --- The following modification is intended to work band.pl correctly.
! 
! =============== modified by K. Tagami ======================= 11.0
!           write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!           write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
!           write(nfeng,'(" nspin       = ",i6)') nspin

!!$           if ( noncol ) then
          write(nfeng,'(" num_kpoints = ",i6)') kv3_ek /ndim_spinor
          if(neg_is_enlarged) then
             write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
          else
             write(nfeng,'(" num_bands   = ",i6)') neg
          end if
          write(nfeng,'(" nspin       = ",i6)') nspin / ndim_spinor
!!$           else
!!$              write(nfeng,'(" num_kpoints = ",i6)') kv3_ek
!!$              write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
!!$              write(nfeng,'(" nspin       = ",i6)') nspin
!!$           endif
! =============================================================== 11.0
        end if

        if(enough_bands) then
           if(metalic_system) then
              if(ipri>=1) write(nfeng,'(" Fermi energy level = ",f10.6/)') efermi
           else
!!$           write(nfeng,'(" The Highest occupied band energy = ",f10.6/)') vbm
              if(ipri>=1) write(nfeng,'(" Valence band max   = ",f10.6/)') vbm
           end if
        else
           if(ipri>=1) write(nfeng,'(" Fermi energy level = unknown")')
        end if
!!$        call m_ES_wd_eko(nfeng,mode=EK)
        call m_ESIO_wd_EigenValues_ek(nfeng,mode=EK)
     else
!!$     if(.not.Allkpoints_are_Calculated() .and. ipriekzaj >= 1) &
        if(ipriekzaj >= 1) then
           if(ipri >= 1) write(nfout,'(" ipriekzaj = ",i8," <<WriteDownData_onto_Files_ek>>")') ipriekzaj
           call m_Files_open_nfzaj_with_check()
           call m_ESIO_wd_WFs_and_EVs_ek(nfout,nfzaj)
        end if
     end if
  else
     if(ipri>=1) write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
  end if
  if(sw_berry_phase==ON)then
     call m_BP_wd_cntn_data()
  endif

  call m_ES_wd_fsr_fsi()                    ! if(ipri >= 2) 
  call m_ES_wd_zaj_small_portion0(" -- WDonFiles_ek --",18)
!!$  stop ' WriteDownData_onto_Files_ek (2)'

  call m_CtrlP_wd_cpu_total()
  if(iprijobstatus >= 1) then
     call m_Files_open_nfstatus()
     if(jobstatus_series == ON) then
        call m_Files_skiptoend(nfstatus)
     else
     end if
     status_wdmode = FINISH
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          &                , iteration,iteration_ionic,iteration_electronic)
  end if 

  call m_Files_close_all                    ! -(m_Files)
!!$  stop ' WriteDownData_onto_Files_ek (3)'
contains

  subroutine FermiEnergyLevel_ek()
    integer :: way_of_smearing
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic_ek(nfout)  ! -> efermi, metalic_system
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
     else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetra_ek(nfout)     ! -> efermi, metalic_system

! ========================= KT_add ================= 13.0E
     else if(way_of_smearing == Fermi_Dirac) then
        call m_ESoc_fermi_dirac_ek(nfout)     ! -> efermi, metalic_system
! ================================================== 13.0E
    end if
  end subroutine FermiEnergyLevel_ek

end subroutine WriteDownData_onto_Files_ek
!$$#endif

subroutine WriteDown_totalcpu()
  use m_Control_parameters,  only: m_CtrlP_wd_cpu_total

  call m_CtrlP_wd_cpu_total()
end subroutine WriteDown_totalcpu

subroutine write_energies(mnk,nk,kxyz,ek,mnt,nt,tk,ie)
  use m_Const_Parameters, only : DP
  use m_Files, only :            nfegrid, m_Files_open_nfegrid
  implicit none

  integer, intent(in) :: mnk,nk,mnt,nt,ie
  real(kind=DP), intent(in), dimension(3,mnk) :: kxyz
  real(kind=DP), intent(in), dimension(mnk) ::   ek
  integer, intent(in), dimension(4,mnt) ::       tk

  integer :: it, ik

  call m_Files_open_nfegrid()  ! open nfegrid

  write (nfegrid,*) '$ DATA=CURVE3D NAME = ', nt

  do it = 1, nt
     if( kxyz(3,tk(1,it)) == 0.d0 .and. kxyz(3,tk(2,it)) == 0.d0 .and. &
          &       kxyz(3,tk(3,it)) == 0d0) then
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
     endif

     if (kxyz(3,tk(1,it)) == 0d0 .and. kxyz(3,tk(2,it)) == 0d0 .and. &
          &       kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif

     if (kxyz(3,tk(1,it)) == 0d0 .and. kxyz(3,tk(3,it)) == 0d0 .and. &
          &      kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(1,it))),sngl(kxyz(2,tk(1,it))),sngl(ek(tk(1,it))),tk(1,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif

     if (kxyz(3,tk(2,it)) == 0d0 .and. kxyz(3,tk(3,it)) == 0d0 .and. &
          &     kxyz(3,tk(4,it)) == 0d0) then
        write (nfegrid,*)
        write (nfegrid,*) sngl(kxyz(1,tk(2,it))),sngl(kxyz(2,tk(2,it))),sngl(ek(tk(2,it))),tk(2,it)
        write (nfegrid,*) sngl(kxyz(1,tk(3,it))),sngl(kxyz(2,tk(3,it))),sngl(ek(tk(3,it))),tk(3,it)
        write (nfegrid,*) sngl(kxyz(1,tk(4,it))),sngl(kxyz(2,tk(4,it))),sngl(ek(tk(4,it))),tk(4,it)
     endif
     write (nfegrid,*)
  enddo

  write (nfegrid,*) '$ end  ', ie, nk

!_____write output
  write (nfegrid,*) nk
  do ik = 1, nk
     write (nfegrid,*) kxyz(1,ik), kxyz(2,ik), kxyz(3,ik), ek(ik)
  enddo

  write (nfegrid,*) nt
  do it = 1, nt
     write (nfegrid,*) tk(1,it), tk(2,it), tk(3,it), tk(4,it)
  enddo
end subroutine write_energies

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 412 $)
!
!  MODULE: m_Kpoint
!
!  AUTHORS: T. Yamasaki, T. Yamamoto,  August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!  patch 10.1 by K. Tagami @adv    2011/06/18
!
!  patch 10.1 :  k_sample_mesh is changed from private to public
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developOPed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Kpoints
!     (m_Kp)
!  $Id: m_Kpoints.F90 412 2014-11-30 12:02:22Z yamasaki $
! 
  use m_Crystal_Structure,   only : il,imag,inv,ngen,igen,jgen, a,b,c,ca,cb,cc &
       &                          , altv, rltv, nbztyp , nbztyp_spg, n1_sc, n2_sc, n3_sc
  use m_Files,               only : nfout,nfkpoint, nfmatbp
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin, ipri, tag_accuracy, icond &
       &                          , ipriinputfile, ipri_kp, sw_berry_phase, ekmode, printable, kimg &
       &                          , fixed_charge_k_parallel &
       &                          , m_CtrlP_way_of_smearing, m_CtrlP_set_way_ksample
  use m_Const_Parameters,    only : CARTS, BUCS, CRDTYP, NONAME &
       &                          , MESH, MONKHORST_PACK &
       &                          , SKPS_DIRECT_IN, GAMMA, FILE, DP, PAI2 &
       &                          , SURFACE, WHOLE_BZ, SIMPLE_CUBIC &
       &                          , BCC, FCC, DIAMOND, HEXAGONAL, ORTHORHOMBIC &
       &                          , RUTILE, C2v_SURFACE, Csy_SURFACE &
       &                          , GENERAL, GENERAL_LARGER &
       &                          , HEX1fold, HEX2fold, HEX3fold &
       &                          , LOWER, NODATA, FMAXVALLEN &
       &                          , TETRAHEDRON, ON, OFF, GRID, DELTA &
       &                          , GAMMA_base_symmetrization, PARA, ONE_BY_ONE
  use m_Parallelization,     only : mpi_comm_group,npes,ierr,nrank_k,mype

! ================================= added by. Tagami =========== 11.0
  use m_Control_Parameters,    only : ndim_spinor, noncol, SpinOrbit_mode
  use m_Const_Parameters,      only : Neglected
! ============================================================= 11.0

! ================================= added by. Tagami =========== 12.0A
  use m_Crystal_Structure,   only : gen_name_in_carts, use_altv_rltv
! ============================================================== 12.0A

! === KT_add ==== 2014/08/14
  use m_CS_NonCollinear,  only : magmom_dir_inversion_opr_flag
! =============== 2014/08/14

! === KT_add ==== 2014/09/30
  use m_Const_Parameters,  only : DELTA07
  use m_Crystal_Structure, only : nopr, op
! =============== 2014/09/30

  implicit none
  include 'mpif.h'

  integer                                      :: kv3=0 ! #sampling k-points
  real(kind=DP), allocatable, dimension(:,:,:) :: vkxyz ! d(kv3,3,CRDTYP), sampling k-points
  real(kind=DP), allocatable, dimension(:)     :: qwgt  ! d(kv3), weight factors
  integer, allocatable, dimension(:)           :: k_symmetry ! d(kv3), symmetries of k-points, Gamma or not
  integer                                      :: kv3_ek ! k-points with charge-fixed
  integer                                      :: ek_group = 1 ! #k-point groups with charge-fixed
  real(kind=DP), allocatable, dimension(:,:,:) :: vkxyz_ek ! k-points
  real(kind=DP), allocatable, dimension(:)     :: qwgt_ek ! weight factors

! ========================= modified by K. Tagami ==================== 10.1
!  integer,          private,  dimension(3,2)   :: k_sample_mesh = 1
  integer,                     dimension(3,2)   :: k_sample_mesh = 1
! =================================================================== 10.1

  integer                                      :: kv3_previous = 0
  integer                                      :: way_ksample = MONKHORST_PACK
  integer, private                             :: ipri_kp_count = 0, ipri_kp_t = 0
  integer                                      :: nkek  ! #kpoints for ek curve
  integer, private                             :: base_reduction_for_GAMMA = ON ! default=ON if possible
  integer, private                             :: base_symmetrization_for_GAMMA = ON ! default=ON if possible
  integer, parameter, private :: len_str = 132
  character(len=len_str),private :: str
  real(kind=DP),private,pointer,dimension(:,:) :: work

  integer                                      :: np0,np1,np2,nx1,ny1,nz1,nd
  integer,allocatable, dimension(:)            :: ip20,ip10,ip02,ip12
  integer,allocatable, dimension(:)            :: ip01,ip21,iu21,iv21,iwt,ip2cub
  integer,allocatable, dimension(:)            :: nxyz_tetra
  real(kind=DP), dimension(3,3)                :: trmat

  ! --- Ksampling ---
  character(len("ksampling")),private,parameter :: tag_ksampling = "ksampling"
  character(len("method")),private,parameter ::    tag_method    = "method"
  character(len("mesh")),private,parameter ::      tag_mesh      = "mesh"
  character(len("nx")),private,parameter ::        tag_nx        = "nx"
  character(len("ny")),private,parameter ::        tag_ny        = "ny"
  character(len("nz")),private,parameter ::        tag_nz        = "nz"
  character(len("monk")),private,parameter ::      tag_monkhorst_pack = "monk"
  character(len("mp_index")),private,parameter ::  tag_mp_index  = "mp_index"
  character(len("n1")),private,parameter ::        tag_n1        = "n1"
  character(len("n2")),private,parameter ::        tag_n2        = "n2"
  character(len("n3")),private,parameter ::        tag_n3        = "n3"
  character(len("kshift")),private,parameter ::    tag_kshift    = "kshift"
  character(len("k1")),private,parameter ::        tag_k1        = "k1"
  character(len("k2")),private,parameter ::        tag_k2        = "k2"
  character(len("k3")),private,parameter ::        tag_k3        = "k3"
  character(len("file")),private,parameter ::      tag_file      = "file"
  character(len("gamma")),private,parameter ::     tag_gamma     = "gamma"
  character(len("directin")),private,parameter ::  tag_directin  = "directin"
  character(len("num_kpoints")),private,parameter ::tag_num_kpoints = "num_kpoints"
  character(len("sum_weight")),private,parameter:: tag_sum_weight = "sum_weight"
  character(len("kpoints")),private,parameter ::   tag_kpoints   = "kpoints"
  character(len("kx")),private,parameter ::        tag_kx        = "kx"
  character(len("ky")),private,parameter ::        tag_ky        = "ky"
  character(len("kz")),private,parameter ::        tag_kz        = "kz"
  character(len("denom")),private,parameter ::     tag_denom     = "denom"
  character(len("weight")),private,parameter ::    tag_weight    = "weight"
  character(len("base_reduction_for_GAMMA")),private,parameter :: &
       &                       tag_base_reduction_for_GAMMA = "base_reduction_for_GAMMA"
  character(len("base_symmetrization_for_GAMMA")),private,parameter :: &
       &                       tag_base_symmetrization_for_G = "base_symmetrization_for_GAMMA"
  character(len("kv3")),private,parameter ::       tag_kv3       = "kv3"
  character(len("use_trs")),private,parameter ::  tag_use_trs  = "use_trs"
  ! --- temporary ---
  real(kind=DP), allocatable, dimension(:) :: kx_t,ky_t,kz_t
  real(kind=DP), allocatable, dimension(:) :: weight_t
  integer ::                                  kv3_t = -1

  ! --- Monknorst-Pack method---
  !!integer, parameter, private :: ng=45,ngrid=(2*ng+1)**3,nshell=10000
  integer, private :: ng,ngrid,nshell
  integer, parameter, private :: nface_max = 125
  type shell 
    integer :: ndim
    real(kind=DP) :: length
    real(kind=DP), pointer :: rindex(:,:) !(3,ndim)
  end type
  integer :: mp_index(3)
  real(kind=DP) :: kshift(3)

  integer :: itrs = ON

! ==================================== added by K. Tagami ==================== 12.0A
  character(len("gen_tetramesh_mode")), private,parameter :: &
       &                 tag_gen_tetramesh_mode    = "gen_tetramesh_mode"
  integer :: gen_tetramesh_mode = 0
!
!!  character(len("use_altv_rltv")), private,parameter :: &
 !!      &                 tag_use_altv_rltv    = "use_altv_rltv"
!!!  integer :: sw_use_altv_rltv = ON
!!!  logical :: use_altv_rltv = .true.
! ============================================================================ 12.0A

! ==================================== added by K. Tagami ==================== 11.0P
  character(len("use_op_before_sym_reduction")),private,parameter ::  &
       &         tag_use_op_before_sym_reduction = "use_op_before_sym_reduction"
  logical :: use_op_before_sym_reduction = .false.
  integer :: sw_use_op_before_sym_reduction = OFF
! ============================================================================ 11.0P

! === KT_add ==== 2014/09/30
  integer :: kv3_fbz
  integer, allocatable :: to_ibz_from_fbz_for_kpoint(:)
  real(kind=DP), allocatable :: vkxyz_fbz(:,:,:) ! d(kv3_fbz,3,CRDTYP)
!
  integer :: max_num_star_of_k
  integer, allocatable :: iopr_k_fbz_to_ibz(:)
  integer, allocatable :: trev_k_fbz_to_ibz(:)
  integer, allocatable :: num_star_of_k(:)
  integer, allocatable :: star_of_k(:,:)
! =============== 2014/09/30

contains
  subroutine alloc_kxyzweight(na)
    integer, intent(in) :: na
    allocate(kx_t(na)); allocate(ky_t(na));allocate(kz_t(na));allocate(weight_t(na))
  end subroutine alloc_kxyzweight

  subroutine dealloc_kxyzweight()
    if(allocated(kx_t)) deallocate(kx_t)
    if(allocated(ky_t)) deallocate(ky_t)
    if(allocated(kz_t)) deallocate(kz_t)
    if(allocated(weight_t)) deallocate(weight_t)
  end subroutine dealloc_kxyzweight

  subroutine m_Kp_sample_mesh(kmesh)
    integer, intent(out), dimension(3) :: kmesh
    kmesh(1:3) = k_sample_mesh(1:3,1)
  end subroutine m_Kp_sample_mesh

  subroutine m_Kp_wd_kv3(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,'(a11)') tag_kv3
       write(nfcntn,'(i10)') kv3
    end if
  end subroutine m_Kp_wd_kv3

  subroutine m_Kp_rd_kv3(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    logical :: EOF_reach, tag_is_found
    if(mype==0) then
       call rewind_to_tag0(nfcntn,len(tag_kv3),tag_kv3 &
            & , EOF_reach, tag_is_found, str,len_str)
       if(.not.tag_is_found) then
          write(nfout,'(" tag_kv3 is not found")')
       else
          read(nfcntn,*) kv3_previous
       end if
    end if
    if(npes > 1) call mpi_bcast(kv3_previous,1,mpi_integer,0,mpi_comm_group,ierr)
    if(printable) write(nfout,'(i5, " : kv3_previous_job")') kv3_previous
  end subroutine m_Kp_rd_kv3

  subroutine m_Kp_rd_n(nfout)
    integer, intent(in) :: nfout
    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue &
            & ,f_getRealValue, f_selectFirstTableLine
    integer :: f_selectParentBlock, f_selectTop
    integer :: sum_weight
    integer :: i
    real(kind=DP) :: dret
    logical :: prealloc = .false.

    if(ipriinputfile >= 2) write(nfout,'(" !**  << m_Kp_rd_n >>")')
    ! --- accuracy ---
    iret = f_selectTop()
    if( f_selectBlock( tag_accuracy) == 0) then
       if(ipriinputfile >= 2) write(nfout,'(" !** -- tag_accuracy --")')
       if( f_selectBlock( tag_ksampling) == 0) then

          if(icond > 1) base_reduction_for_GAMMA = 0
          if( f_getIntValue(tag_base_reduction_for_GAMMA, iret)==0) then
             base_reduction_for_GAMMA = iret
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," in tag_ksampling <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
             if(base_reduction_for_GAMMA < 0 .or. base_reduction_for_GAMMA >1) then
                base_reduction_for_GAMMA = 1
                if(ipri_kp >= 1) write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," (reset) in tag_ksampling <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_reduction_for_GAMMA = ",i3 &
                     & ," (=default value) <<m_Kp_rd_n>>")') base_reduction_for_GAMMA
             end if
          end if

          if(icond > 1) base_symmetrization_for_GAMMA = 0
          if( f_getIntValue(tag_base_symmetrization_for_G, iret)==0) then
             base_symmetrization_for_GAMMA = iret
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," in tag_ksampling <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
             if(base_symmetrization_for_GAMMA < 0 .or. base_symmetrization_for_GAMMA >1) then
                base_symmetrization_for_GAMMA = 1
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," (reset) in tag_ksampling <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** base_symmetrization_for_GAMMA = ",i3 &
                     & ," (=default value) <<m_Kp_rd_n>>")') base_symmetrization_for_GAMMA
             end if
          end if
             
          if( f_getStringValue( tag_method, rstr, LOWER) == 0) then
             call set_ksamplingmethod(rstr)
          else
             if(ipri_kp >= 1) then
                write(nfout,'(" !** a method of sampling is not defined in the accuracy block <<m_Kp_rd_n>>")')
             end if
          end if
          if( way_ksample == MESH ) then
             if( f_selectBlock( tag_mesh) == 0) then
                if( f_getIntValue( tag_nx, iret) == 0) k_sample_mesh(1,1) = iret
                if( f_getIntValue( tag_ny, iret) == 0) k_sample_mesh(2,1) = iret
                if( f_getIntValue( tag_nz, iret) == 0) k_sample_mesh(3,1) = iret
                k_sample_mesh(:,2) = k_sample_mesh(:,1)
                iret = f_selectParentBlock()
             else
                k_sample_mesh(1:3,1) = 4   ! default value
             end if

! ================================ added by K. Tagami ======================== 12.0A
!             if( f_getIntValue( tag_use_altv_rltv, iret) == 0 ) then
!                sw_use_altv_rltv = iret
!             endif
!             if ( sw_use_altv_rltv == ON ) then
!                use_altv_rltv = .true.
!             else
!                use_altv_rltv = .false.
!             endif             ! ---- judgement is moved to m_Crystal_Structre.F90

             if( f_getIntValue( tag_gen_tetramesh_mode, iret) == 0 ) then
                if ( iret == 0 .or. iret == 1  ) then
                   gen_tetramesh_mode = iret
                endif
             endif
             write(nfout,*) '!************************************ '
             write(nfout,*) '!** gen_tetramesh_mode is set to ', gen_tetramesh_mode
!!             write(nfout,*) '!** use_altv_rltv is set to ', use_altv_rltv
             write(nfout,*) '!************************************ '

!
             if ( noncol ) then
                write(*,*) '***** Caution *****'
                write(*,*) 'In noncollinear systems "method = mesh" is experimental '
             endif
!
             if( f_getIntValue( tag_use_trs, iret) == 0) then
                itrs = iret
             else
                if ( noncol ) then
                   if ( SpinOrbit_mode /= Neglected ) then
                      itrs = OFF
                   else
!                      itrs = ON
                      itrs = OFF
                   endif
                endif
             endif
! ================================================================== 12.0A

           else if( way_ksample == MONKHORST_PACK ) then
              if( f_selectBlock( tag_mp_index) == 0) then
                 if( f_getIntValue( tag_n1, iret) == 0) mp_index(1) = iret
                 if( f_getIntValue( tag_n2, iret) == 0) mp_index(2) = iret
                 if( f_getIntValue( tag_n3, iret) == 0) mp_index(3) = iret
                 iret = f_selectParentBlock()
              else if( f_selectBlock( tag_mesh) == 0) then
                 if( f_getIntValue( tag_nx, iret) == 0) mp_index(1) = iret
                 if( f_getIntValue( tag_ny, iret) == 0) mp_index(2) = iret
                 if( f_getIntValue( tag_nz, iret) == 0) mp_index(3) = iret
                 iret = f_selectParentBlock()
              else
                 mp_index(1:3) = 4   ! default value
              end if
              if( f_selectBlock( tag_kshift) == 0) then
                 if( f_getRealValue( tag_k1, dret, '' ) == 0) kshift(1) = dret
                 if( f_getRealValue( tag_k2, dret, '' ) == 0) kshift(2) = dret
                 if( f_getRealValue( tag_k3, dret, '' ) == 0) kshift(3) = dret
                 iret = f_selectParentBlock()
              else
                 kshift(1:3) = 0.5d0   ! default value for cubic system
                 if(il == 0) then   ! default value for hexagonal system
                    kshift(1:2) = 0.0d0
                    kshift(3) = 0.5d0
                 end if
              end if

              if( f_getIntValue( tag_use_trs, iret) == 0) then
                 itrs = iret
! ================================= added by K. Tagami ============== 12.0A
              else
                 if ( noncol .and. SpinOrbit_mode /= Neglected ) then
                    itrs = OFF
!                    itrs = ON                    ! uncertain
                 else
                    itrs = ON
                 endif
              endif
! ================================================================== 12.0A

              if( f_getIntValue( tag_use_op_before_sym_reduction, iret) == 0 ) then
                 sw_use_op_before_sym_reduction = iret
              endif
              if ( sw_use_op_before_sym_reduction == ON ) then
                 use_op_before_sym_reduction = .true.
              else
                 use_op_before_sym_reduction = .false.
              endif

              if(ipri_kp >= 1) then
                 write(nfout,'("<< Monkhorst-Pack scheme")')
                 write(nfout,'(" MP index:",3(1x,i3))') mp_index(1:3)
                 write(nfout,'(" kp shift:",3(1x,f10.5))') kshift(1:3)
                 write(nfout,'(" il = ",i3)') il
                 write(nfout,'(" use_trs = ",i3)') itrs

                 if ( noncol ) then
                    write(nfout,*) "use_op_before_sym_reduction = ", &
                         &            use_op_before_sym_reduction
                 endif

                 write(nfout,'("   Monkhorst-Pack scheme >>")')
              end if

              do i=1,3
                if(mp_index(i) > 100) then
                   if(printable) then
                      write(nfout,*)  &
                           & 'Monkhorst-Pack: found a bad parameter'
                      write(nfout,*)  &
                           & '#### Use Monknorst-Pack indeces less than 101. ###'
                   end if
                   stop 'Monkhorst-Pack: found a bad parameter'
                end if
              end do
          else if( way_ksample == SKPS_DIRECT_IN ) then
             sum_weight = 0
             if( f_getIntValue( tag_sum_weight,  iret) == 0) sum_weight = iret
             if( f_getIntValue( tag_num_kpoints, iret) == 0) then
                kv3_t = iret
                if(kv3_t <= 0) stop ' kv3 is not positive value << m_Kp_rd_n >>'
             else
                prealloc = .true.
                call set_kxyz(prealloc,iret)
                kv3_t = iret
                if(ipriinputfile >= 3) write(nfout,'(" !* kv3_t = ",i6," <<m_Kp_rd_n>>")') kv3_t
             end if
             prealloc = .false.
             call alloc_kxyzweight(kv3_t)
             call set_kxyz(prealloc,iret)
          end if
          iret = f_selectParentBlock()
       end if
       iret = f_selectParentBlock()
    end if
    if(way_ksample == MESH) then
!!$       if(ipriinputfile >= 1) write(nfout,'(" !** k-point sampling method = ",i6)') way_ksample
       if(ipriinputfile >= 1) write(nfout,'(" !** k_sample_mesh = ",3i6)') k_sample_mesh(1:3,1)
    end if
  contains
    subroutine set_kxyz(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out)::  iret
      integer :: i, f_readKPoints, f_selectFirstTableLine, f_selectNextTableLine
      real(kind=DP),dimension(3) :: kvec
      integer ::              weight, sum
      if( f_selectBlock(tag_kpoints) == 0) then
         sum = 0
         i = 1
         do while(.true.)
            if( i == 1 ) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            iret = f_readKPoints( tag_kx,tag_ky,tag_kz,tag_denom,tag_weight &
                 & ,kvec, weight )
!!$            print '(f8.4, f8.4, f8.4, I3)', kvec(1),  kvec(2), kvec(3), weight
            if(.not.prealloc) then
               if(i > kv3_t) exit
               if(weight < 1.d-13) weight = 1
               sum = sum + weight
               kx_t(i) = kvec(1); ky_t(i) = kvec(2); kz_t(i) = kvec(3)
               weight_t(i) = weight
            end if
            i = i+1
         end do
         if(ipriinputfile >= 3) write(nfout,'(" !*  weight-sum = ", i6)') sum
         if(.not.prealloc .and. sum_weight /= 0) then
            if(sum_weight /= sum) then
               if(printable) write(nfout,'(" !* Given sum_weight is not equal to summed weight")')
            end if
         end if
         if(.not.prealloc) weight_t = weight_t/dble(sum)
         iret = f_selectParentBlock()
      else
         stop ' ! No kpoints is given in the inputfile <<m_Kp_rd_n>>'
      end if
      if(prealloc) iret = i-1
      if(.not.prealloc) then
         if(ipriinputfile >= 2) then
            do i = 1, kv3_t
               write(nfout,'(" !* i = ",i6," kvxyz,weight = ",4f8.4)') i,kx_t(i),ky_t(i),kz_t(i),weight_t(i)
            end do
         end if
      end if
    end subroutine set_kxyz

    subroutine set_ksamplingmethod(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      way_ksample = MONKHORST_PACK
      call strncmp0(tag_monkhorst_pack, trim(rstr), tf)
      if(tf) then
         way_ksample = MONKHORST_PACK
         goto 1001
      end if
      call strncmp0(tag_mesh, trim(rstr), tf)
      if(tf) then
         way_ksample = MESH
         goto 1001
      end if
      call strncmp0(tag_file, trim(rstr), tf)
      if(tf) then
         way_ksample = FILE
         goto 1001
      end if
      call strncmp0(tag_gamma,trim(rstr),tf)
      if(tf) then
         way_ksample = GAMMA
         goto 1001
      end if
      call strncmp0(tag_directin, trim(rstr),tf)
      if(tf) then
         way_ksample = SKPS_DIRECT_IN
         goto 1001
      end if
      stop ' ! tag for ksampling is invalid <<m_Kp_rd_n.set_ksamplingmethod>>'
1001  continue
      if(ipri_kp>= 2) write(nfout,'(" !** ksampling method = ",a14)') trim(rstr)
      call m_CtrlP_set_way_ksample(way_ksample)
    end subroutine set_ksamplingmethod
  end subroutine m_Kp_rd_n

  subroutine m_Kp_alloc_kpoints()
    if(.not.allocated(vkxyz)) then
       allocate(vkxyz(kv3,3,CRDTYP)); vkxyz = 0.d0
       if(ipri_kp >= 2) then
          write(nfout,'(" !kp vkxyz is allocated now <<m_Kp_alloc_kpoints>>")')
          write(nfout,'(" !kp kv3 = ", i5," CRDTYP = ",i3)') kv3,CRDTYP
       end if
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp vkxyz is already allocated <<m_Kp_alloc_kpoints>>")')
    end if
    if(.not.allocated(qwgt)) then
       allocate(qwgt(kv3))
       if(ipri_kp >= 2) write(nfout,'(" !kp qwgt is allocated now <<m_Kp_alloc_kpoints>>")')
       qwgt = 1.d0
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp qwgt is already allocated <<m_Kp_alloc_kpoints>>")')
    end if
    if(.not.allocated(k_symmetry)) then
       allocate(k_symmetry(kv3)); k_symmetry = 0
       if(ipri_kp >= 2) then
          write(nfout,'(" !kp k_symmetry is allocated now <<m_Kp_alloc_symmetry>>")')
       end if
    else
       if(ipri_kp >= 2) write(nfout,'(" !kp k_symmetry is already allocated <<m_Kp_alloc_kpoints>>")')
    end if

! === KT_add === 2014/09/30
!    write(*,*) "kv3_fbz = ", kv3_fbz, kv3
    if ( .not. allocated(vkxyz_fbz) ) allocate(vkxyz_fbz(kv3_fbz,3,CRDTYP))
    if ( .not. allocated(to_ibz_from_fbz_for_kpoint) ) then
       allocate( to_ibz_from_fbz_for_kpoint(kv3_fbz) )
    endif
! ============== 2014/09/30

  end subroutine m_Kp_alloc_kpoints

  subroutine m_Kp_alloc_kpoints_ek()
    kv3_ek = kv3
    if(.not.allocated(vkxyz_ek)) allocate(vkxyz_ek(kv3_ek,3,CRDTYP))
    if(.not.allocated(qwgt_ek))  allocate(qwgt_ek(kv3_ek))
  end subroutine m_Kp_alloc_kpoints_ek

  subroutine m_Kp_cp_vkxyz_to_vkxyz_ek()
    vkxyz_ek = vkxyz
    qwgt_ek  = qwgt
  end subroutine m_Kp_cp_vkxyz_to_vkxyz_ek

  subroutine m_Kp_cp_vkxyz_ek_to_vkxyz(nk)
    integer, intent(in) :: nk
    integer :: i, kvt
    if(ipri_kp >= 1) write(nfout,'(" !kp nk, kv3, kv3_ek = ",3i6)') nk, kv3, kv3_ek
    if(nk+kv3-1 > kv3_ek) then
       if(fixed_charge_k_parallel /= ONE_BY_ONE) &
            & stop ' nk is illegal (m_Kp_cp_vkxyz_ek_to_vkxyz)'
    end if

    if(fixed_charge_k_parallel == ONE_BY_ONE .and. nk+kv3-1 > kv3_ek) then
       kvt = kv3_ek - nk + 1
       vkxyz(1:kvt,1:3,1:CRDTYP) = vkxyz_ek(nk:kv3_ek,1:3,1:CRDTYP)
       qwgt(1:kvt) = qwgt_ek(nk:kv3_ek-1)
       do i = kvt+1, kv3
          vkxyz(i,1:3,1:CRDTYP) = vkxyz_ek(kv3_ek,1:3,1:CRDTYP)
          qwgt(i) = qwgt_ek(kv3_ek)
       end do
    else
       vkxyz(1:kv3,1:3,1:CRDTYP) = vkxyz_ek(nk:nk+kv3-1,1:3,1:CRDTYP)
       qwgt(1:kv3) = qwgt_ek(nk:nk+kv3-1)
    end if
    if(kimg == 2) then
       if(base_reduction_for_GAMMA == ON) then
          do i = 1, kv3
             if(vkxyz(i,1,1)**2 + vkxyz(i,2,1)**2 + vkxyz(i,3,1)**2 < DELTA) then
                k_symmetry(i) = GAMMA
             else
                k_symmetry(i) = 0
             end if
          end do
       else if(base_reduction_for_GAMMA == OFF .and. base_symmetrization_for_GAMMA == ON) then
          do i = 1, kv3
             if(vkxyz(i,1,1)**2 + vkxyz(i,2,1)**2 + vkxyz(i,3,1)**2 < DELTA) then
                k_symmetry(i) = GAMMA_base_symmetrization
             else
                k_symmetry(i) = 0
             end if
          end do
       end if
    else
       do i = 1, kv3
          k_symmetry(i) = 0
       end do
    end if

! ================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
       write(nfout,*) '!----- '
       write(nfout,*) '! k_symmetry is forced to 0 in the non-collinear system'
       write(nfout,*) '!----- '
       k_symmetry(:) = 0
    endif
! ===================================================================== 11.0

    if(ipri_kp >= 1) then
       do i = 1, kv3
          if(k_symmetry(i) == GAMMA) then
             write(nfout,'(" !kp ",i6, 6f8.4, " GAMMA")') &
                  & i, vkxyz(i,1:3,CARTS), vkxyz(i,1:3,BUCS)
          else
             write(nfout,'(" !kp ",i6, 6f8.4)') &
                  & i, vkxyz(i,1:3,CARTS), vkxyz(i,1:3,BUCS)
          end if
       end do
    end if
  end subroutine m_Kp_cp_vkxyz_ek_to_vkxyz

  subroutine m_Kp_set_ek_group()
! ============================== modified by K. Tagami =========== 11.0
!    if(nspin == 1) then
!       ek_group = ceiling(dble(kv3_ek)/nrank_k)
!    else
!       ek_group = ceiling(dble(kv3_ek/nspin)/nrank_k)*nspin
!    end if
!    kv3 = nrank_k*nspin
!
    if ( noncol ) then
      ek_group = ceiling(dble(kv3_ek/ndim_spinor)/nrank_k)*ndim_spinor
      kv3 = nrank_k *ndim_spinor
    else
      if(nspin == 1) then
         ek_group = ceiling(dble(kv3_ek)/nrank_k)
      else
         ek_group = ceiling(dble(kv3_ek/nspin)/nrank_k)*nspin
      end if
      kv3 = nrank_k *nspin
    endif 
! ================================================================ 11.0

    if(ipri_kp >=1 ) then
       write(nfout,'(" !kp ek_group = ",i5)') ek_group
       write(nfout,'(" !kp kv3_ek   = ",i5)') kv3_ek
       write(nfout,'(" !kp kv3      = ",i5)') kv3
    end if
  end subroutine m_Kp_set_ek_group

  subroutine m_Kp_realloc_kpoints2()
    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt))  deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)
    call m_Kp_alloc_kpoints()
  end subroutine m_Kp_realloc_kpoints2

  subroutine m_Kp_realloc_kpoints()
! ================================ modified by K. Tagami ========== 11.0
!    kv3 = nspin
!
    if ( noncol ) then
       kv3 = ndim_spinor
    else
       kv3 = nspin
    endif
! ================================================================= 11.0

    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt))  deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)

! === KT_add === 2014/09/30
    if ( allocated(vkxyz_fbz) ) deallocate(vkxyz_fbz)
    if ( allocated(to_ibz_from_fbz_for_kpoint) ) deallocate(to_ibz_from_fbz_for_kpoint)
! ============== 2014/09/30

    call m_Kp_alloc_kpoints()

  end subroutine m_Kp_realloc_kpoints

  subroutine m_Kp_rd_way_ksample_etc(nfinp,nlines)
    integer, intent(in) :: nfinp,nlines
    integer, parameter  :: NWK = 6
    integer             :: natm0, ntyp0
    allocate(work(NWK,1))

    if(npes >= 2) call mpi_barrier(mpi_comm_group,ierr)
    rewind nfinp
    if(ipri_kp >= 2) write(nfout,'(" <<< m_Kp_rd_way_ksample_etc >>>")')
!       ==========================
    call read_natm_ntyp          ! -> natm0, ntyp0
    if(ipri_kp >= 2) then
       write(nfout,'(" !kp nlines+14+natm0+ntyp0 = ",i8)') nlines+14+natm0+ntyp0
       write(nfout,'(" !kp ntyp0, natm0 = ",2i8)') ntyp0, natm0
    end if
    call skip_lines(nfinp,nlines+14+natm0+ntyp0)
    call read_way_ksample_etc    ! -> way_ksample, k_sample_mesh
!       ==========================
    deallocate(work)
  contains
    subroutine read_natm_ntyp
      integer nsize
      read(nfinp,'(a132)') str
      call chnnm(str,len_str,4,work,nsize)
      ntyp0 = nint(work(3,1))
      natm0 = nint(work(4,1))
    end subroutine read_natm_ntyp

    subroutine read_way_ksample_etc
      integer :: i, ikpnt, sw_k_coord_system
      read(nfinp,'(a132)') str
      if(ipri_kp >= 2) write(nfout,'(a132)') str
      call ch4ksample(str,len_str,way_ksample)
      if(way_ksample == NONAME .or. way_ksample == MESH) then
         if(way_ksample == NONAME) then
            read(str,*) (k_sample_mesh(i,1), i=1,3)
            way_ksample = MESH
         else
            read(nfinp,*) (k_sample_mesh(i,1),i=1,3)
         endif
         if(ipri_kp>=1) write(nfout,680) (k_sample_mesh(i,1),i=1,3)
         read(nfinp,*) (k_sample_mesh(i,2),i=1,3)
         if(ipri_kp>=1) write(nfout,690) (k_sample_mesh(i,2),i=1,3)
         if(k_sample_mesh(1,1) == 0  &
              & .or.(     k_sample_mesh(1,2) == 0 &
              &     .and. k_sample_mesh(2,2) == 0 &
              &     .and. k_sample_mesh(3,2) == 0)) &
              &  way_ksample = GAMMA
      else if(way_ksample.eq.SKPS_DIRECT_IN) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = SKPS_DIRECT_IN")')
         read(nfinp,'(a132)') str
         if(ipri_kp>=2) write(nfout,'(" ! str : ",a50)') str(1:50)
         call read_nkpnt(str,len_str,ikpnt) !-(b_Kpoints)
         if(ipri_kp>=2) write(nfout,'(" ! ikpnt(#skipped lines) = ",i5)') ikpnt
         read(nfinp,'(a132)') str
         call read_coordsystem(str,len_str,sw_k_coord_system) !-(b_Kpoints)
         if(sw_k_coord_system == NODATA) ikpnt = ikpnt - 1
         call skip_lines(nfinp,ikpnt)      !-(bottom_Subroutines)
!         call read_konly
!     >        (nfinp,nfout,knv3,altv,rltv,nspin
!     <        ,kv3,vkxyz,qwgt,wka)
      else if(way_ksample == FILE) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = FILE")')
         call skip_lines(nfinp,2)
      else if(way_ksample == MONKHORST_PACK) then
         if(ipri_kp>=1) write(nfout,'(" ! way_ksample = MONKHORST_PACK")')
         call read_mpindex(nfinp) !-(b_SpeicalKpints)
      endif

      call m_CtrlP_set_way_ksample(way_ksample)
680   format(' ',3i6,'   : nkx, nky, nkz ')
690   format(' ',3i6,'   : nkx2,nky2,nkz2')
    end subroutine read_way_ksample_etc
  end subroutine m_Kp_rd_way_ksample_etc

  subroutine m_Kp_gnrt_or_rd_k_points(nfinp,preallocation)
    ! -> kv3(when preallocation == .true.), kv3,vkxyz,qwgt(when preallocation == .flase.)
    external kpmsf0, kpmwbz0, sccm0, bccm0, fccm0, hexm0
    integer, intent(in)      :: nfinp
    logical, intent(in)      :: preallocation
    integer                  :: knv3_t, id_sname = -1, i, kv3_adj, j
    integer :: knv3_t_fbz
    call tstatc0_begin('m_Kp_gnrt_or_rd_k_points ', id_sname)

    if(ipri_kp >= 2) then
       write(nfout,'(" !kpgnrt way_ksample = ",i6)') way_ksample
       write(nfout,'(" !kpgnrt nbztyp      = ",i6)') nbztyp
       write(nfout,'(" !kpgnrt nbztyp_spg  = ",i6)') nbztyp_spg
    end if

    if(preallocation) then
       allocate(vkxyz(1,1,1))
       allocate(qwgt(1))
       allocate(vkxyz_fbz(1,1,1))
       allocate(to_ibz_from_fbz_for_kpoint(1))
    end if

    knv3_t = kv3;  knv3_t_fbz = kv3_fbz
    if(sw_berry_phase == 1) then
       continue
    else if(way_ksample == GAMMA) then
       call gen_gamma_p0(preallocation,knv3_t,kv3,vkxyz,qwgt)  !-(b_Kpoints)
    else if(way_ksample == FILE) then
       call readk0(preallocation,nfout,ipri_kp,knv3_t,rltv,nfkpoint,nfmatbp&
            &,kv3,vkxyz,qwgt) !-(b_Kpoints)
       if(ipriinputfile >= 2 .and. .not.preallocation) then
          do i=1, kv3
             write(nfout,'(" !** id, vkxyz, qwgt = ",i6,4f8.4," << m_Kp_gnrt_or_rd_k_points>>")') &
                  & i,vkxyz(i,1,CARTS),vkxyz(i,2,CARTS),vkxyz(i,3,CARTS),qwgt(i)
          end do
       end if
    else if(way_ksample == SKPS_DIRECT_IN) then
       if(ipri_kp>=2) write(nfout,'(" !kp kv3_t = ", i6)') kv3_t
       if(kv3_t > 0) then  ! directin from inputfile in new format style
          kv3 = kv3_t
          if(preallocation) then
             if(ipriinputfile >= 2) then
                do i=1, kv3_t
                   write(nfout,'(" !** id,kx_t,ky_t,kz_t,weight_t = " &
                        &    ,i6,4f8.4," <<m_Kp_gnrt_or_rd_k_points>>")') &
                        & i,kx_t(i),ky_t(i),kz_t(i),weight_t(i)
                end do
             end if
          else
             kv3_adj = ubound(vkxyz,1)-lbound(vkxyz,1) + 1
             call set_kfromtemporaryarray(nfout,ipri,nfmatbp,kv3_adj,kv3_t,kx_t,ky_t,kz_t,weight_t &
                  &   ,rltv,vkxyz,qwgt)
             call dealloc_kxyzweight()
             if(ipriinputfile >= 2) then
                do i=1, kv3
                   write(nfout,'(" !** id, vkxyz, qwgt = ",i6,4f8.4," << m_Kp_gnrt_or_rd_k_points>>")') &
                        & i,vkxyz(i,1,CARTS),vkxyz(i,2,CARTS),vkxyz(i,3,CARTS),qwgt(i)
                end do
             end if
          end if
       else
          call read_konly(preallocation,nfinp,nfout,knv3_t &
               & ,altv,rltv,kv3,vkxyz,qwgt,str,len_str)
       end if

    else if(way_ksample == MONKHORST_PACK) then

       call gen_special_kpoints( preallocation, nfout, ipri, knv3_t, &
            &                    nfmatbp, kv3, vkxyz, qwgt, imag, itrs, &
            &                    kv3_fbz, vkxyz_fbz, to_ibz_from_fbz_for_kpoint )

    else if( nbztyp == GENERAL .or. nbztyp == GENERAL_LARGER) then
       ipri_kp_t = ipri_kp*(1-ipri_kp_count)
       if(ipri_kp_count == 0) ipri_kp_count = 1

! ======================================= modified by K. Tagami =========== 12.0A
!       call gnrt_k0_n( il, ngen, inv, igen, jgen, a, b, c, ca, cb, cc, &
!            &          nbztyp_spg, &
!            &          k_sample_mesh(1,1),k_sample_mesh(2,1),k_sample_mesh(3,1), &
!            &          preallocation, nfout, ipri, knv3_t, rltv, &
!            &          kv3, vkxyz, qwgt, ipri_kp_t, trmat )
!                                                               !-(b_Kpoints)
!
       call gnrt_k0_n( il, ngen, inv, igen, jgen, a, b, c, ca, cb, cc, &
            &          nbztyp_spg, &
            &          k_sample_mesh(1,1),k_sample_mesh(2,1),k_sample_mesh(3,1), &
            &          preallocation, nfout, ipri, knv3_t, rltv, &
            &          kv3, vkxyz, qwgt, ipri_kp_t, trmat, &
            &          gen_tetramesh_mode, use_altv_rltv, altv, itrs, &
            &          gen_name_in_carts, &
            &          knv3_t_fbz, kv3_fbz, vkxyz_fbz, to_ibz_from_fbz_for_kpoint )
                                                         !-(b_Kpoints)
       if(ipri_kp_t >= 1) then
          write(nfout,'(" << trmat >>")')
          write(nfout,'(3f8.4)') ((trmat(i,j),j=1,3),i=1,3)
       end if
!        === modified by T. Y. 2015/01/16 ===
!!$       call gen_kpoint_in_full_BZ( preallocation, kv3_fbz, vkxyz_fbz )
       call gen_kpoint_in_full_BZ( preallocation)
!        ====================================
! ========================================================================= 12.0A

    else if(way_ksample == MESH) then
       if(ipri_kp>=1) call wd_k_sample_mesh          !-(contained here) k_sample_mesh->
       BZtype: select case(nbztyp)
       case (SURFACE, C2v_SURFACE, Csy_SURFACE)
          call call_k_generator(kpmsf0)
       case (WHOLE_BZ, ORTHORHOMBIC, RUTILE)
          call call_k_generator(kpmwbz0)
       case (SIMPLE_CUBIC)
          call call_k_generator(sccm0)
       case (BCC)
          call call_k_generator(bccm0)
       case (FCC, DIAMOND)
          call call_k_generator(fccm0)
       case (HEXAGONAL, 9)
          call call_k_generator(hexm0)
!!$          case (HEX1fold,HEX2fold,HEX3fold)
!!$          call kccrdf0(paramset,kv3,nfout,nbztyp,nfkpoint,nfmatbp &
!!$               &,vkxyz,qwgt,kv3)
       end select BZtype

    endif

! ==================================== modified by K. Tagami ======= 11.0
!!!    kv3 = kv3*nspin
!
    if ( noncol ) then             ! non-collinear case
       kv3 = kv3 *ndim_spinor;   kv3_fbz = kv3_fbz *ndim_spinor
    else
       kv3 = kv3 *nspin;         kv3_fbz = kv3_fbz *nspin
    endif
! =================================================================== 11.0

    if(.not.preallocation) then
       if(ipri_kp >= 2 ) write(nfout,*) ' << generate_or_read_k_sampling_points >>'

       if(way_ksample == MESH .and.  m_CtrlP_way_of_smearing() == TETRAHEDRON &
            & .and. nbztyp == WHOLE_BZ )   call change_kpoints_order

! ======================= modified by K. Tagami ================ 11.0
!!!       if(nspin == 2)  call double_k_points
!
       if ( noncol ) then
	  call gen_k_points_noncol
       else
          if ( nspin == 2 )  call double_k_points
       endif
! ========================================================= 11.0

       call k_points_in_BUCS_from_CARTS

       call set_k_symmetry()
       if(ipri_kp>=1) call wd_kpoints()
! ==== KT_add === 2014/09/30
       if(ipri_kp>=2) call wd_kpoints_fbz()
! =============== 2014/09/30

    else
       if(ipri_kp>=1) write(nfout,'(" !kp kv3 = ",i5, " nspin = ", i5)') kv3,nspin

! ======================= added by K. Tagami ================== 11.0
       if(ipri_kp>=1) write(nfout,*) 'ndim_spinor = ', ndim_spinor
! ============================================================= 11.0
    end if

    if(preallocation) then
       deallocate(vkxyz)
       deallocate(qwgt)
       deallocate(vkxyz_fbz)
       deallocate(to_ibz_from_fbz_for_kpoint)
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine set_k_symmetry()
      integer :: ik
      if(kimg == 2) then
         if(base_reduction_for_GAMMA == ON) then
            do ik = 1, kv3
               if(vkxyz(ik,1,CARTS)**2 + vkxyz(ik,2,CARTS)**2 &
                    & + vkxyz(ik,3,CARTS)**2 < DELTA) then
                  k_symmetry(ik) = GAMMA
               else
                  k_symmetry(ik) = 0
               end if
            end do
         else if(base_reduction_for_GAMMA == OFF .and. base_symmetrization_for_GAMMA == ON) then
            do ik = 1, kv3
               if(vkxyz(ik,1,CARTS)**2 + vkxyz(ik,2,CARTS)**2 &
                    & + vkxyz(ik,3,CARTS)**2 < DELTA) then
                  k_symmetry(ik) = GAMMA_base_symmetrization
               else
                  k_symmetry(ik) = 0
               end if
            end do
         else
            do ik = 1, kv3
               k_symmetry(ik) = 0
            end do
         end if
      else
         do ik = 1, kv3
            k_symmetry(ik) = 0
         end do
      end if
      
! ================================== added by K. Tagami =============== 11.0
      if ( noncol ) then
         write(nfout,*) '!----- '
         write(nfout,*) '! k_symmetry is forced to 0 in the non-collinear system'
         write(nfout,*) '!----- '
         k_symmetry(:) = 0
      endif
! ===================================================================== 11.0
    end subroutine set_k_symmetry

    subroutine wd_kpoints
      integer ik,i
      write(nfout,*)
      write(nfout,*) ' === k-points generated or read ==='
      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"QITG")')
      do ik = 1, kv3
         if(k_symmetry(ik) == GAMMA) then
            write(nfout,9002) ik,(vkxyz(ik,i,CARTS),i=1,3) &
                 &        ,           (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
         else
            write(nfout,9001) ik,(vkxyz(ik,i,CARTS),i=1,3) &
                 &        ,           (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
         end if
9001     format(i6,3f8.4,3x,3f8.4,3x,f8.4)
9002     format(i6,3f8.4,3x,3f8.4,3x,f8.4," GAMMA")
      enddo
    end subroutine wd_kpoints

! === KT_add === 2014/09/30
    subroutine wd_kpoints_fbz
      integer ik,i
      write(nfout,*)
      write(nfout,*) ' === k-points in full BZ ==='
      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"in IBZ")')
      do ik = 1, kv3_fbz
         write(nfout,9001) ik, (vkxyz_fbz(ik,i,CARTS),i=1,3), &
              &                (vkxyz_fbz(ik,i,BUCS) ,i=1,3), &
              &                to_ibz_from_fbz_for_kpoint(ik)
9001     format(i6,3f8.4,3x,3f8.4,3x,i6)
      enddo
    end subroutine wd_kpoints_fbz
! ============= 2014/09/30

!!$    subroutine wd_kpoints(kv3,vkxyz)
!!$      integer, intent(in) :: kv3
!!$      real(kind=DP),intent(inout),dimension(kv3,3,CRDTYP) :: vkxyz
!!$
!!$      integer :: ik,i
!!$
!!$      write(nfout,*)
!!$      write(nfout,*) ' === k-points generated ==='
!!$      write(nfout,'(" ik",8x,"CARTS",22x,"BUCS",19x,"QITG")')
!!$      do ik = 1, kv3
!!$         write(nfout,9001) ik,(vkxyz(ik,i,CARTS),i=1,3) &
!!$              &     ,         (vkxyz(ik,i,BUCS) ,i=1,3),qwgt(ik)
!!$9001     format(i3,3f8.4,3x,3f8.4,3x,f8.4)
!!$      enddo
!!$    end subroutine wd_kpoints

    subroutine call_k_generator(external_k_gen)
      external   external_k_gen
      call external_k_gen(preallocation,nfout,altv,rltv,k_sample_mesh &
           &,knv3_t,kv3,vkxyz,qwgt)
    end subroutine call_k_generator

    subroutine double_k_points
      integer :: ik, is, k1
      integer, allocatable :: ilist(:)
      real(kind=DP), allocatable :: vkxyz_fbz_org(:,:,:)
      
      do ik = kv3/nspin, 1, -1
         vkxyz(ik*2,  1:3,CARTS) = vkxyz(ik,1:3,CARTS)
         vkxyz(ik*2-1,1:3,CARTS) = vkxyz(ik,1:3,CARTS)
         qwgt(ik*2)            = qwgt(ik)*0.5d0
         qwgt(ik*2-1)          = qwgt(ik)*0.5d0
      enddo
      
      allocate( vkxyz_fbz_org(kv3_fbz,3,2 ) ); 
      vkxyz_fbz_org(1:kv3_fbz/nspin,:,:) = vkxyz_fbz(1:kv3_fbz/nspin,:,:)

      allocate( ilist(kv3_fbz) )
      ilist(1:kv3_fbz/nspin) = to_ibz_from_fbz_for_kpoint(1:kv3_fbz)

      do ik=1, kv3_fbz/nspin
         Do is=1, nspin
            k1 = ( ik -1 )*nspin + is
            if ( is == 1 ) then
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            else
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik)
            endif
         End do
      End do

      deallocate( vkxyz_fbz_org ); deallocate( ilist )
      
    end subroutine double_k_points

! =========================== added by K. Tagami =========== 11.0
    subroutine gen_k_points_noncol
      integer :: ik, is, k1
      integer, allocatable :: ilist(:)
      real(kind=DP), allocatable :: vkxyz_org(:,:,:), qwgt_org(:)
      real(kind=DP), allocatable :: vkxyz_fbz_org(:,:,:)
!
      allocate( vkxyz_org(kv3/ndim_spinor,3,2 ) ); 
      vkxyz_org(1:kv3/ndim_spinor,:,:) = vkxyz(1:kv3/ndim_spinor,:,:)

      allocate( qwgt_org(kv3/ndim_spinor) );       
      qwgt_org(1:kv3/ndim_spinor) =  qwgt(1:kv3/ndim_spinor)
!
      do ik=1, kv3/ndim_spinor
         Do is=1, ndim_spinor
            k1 = ( ik -1 )*ndim_spinor + is
            
	    if ( is == 1 ) then
              vkxyz( k1,:,CARTS) = vkxyz_org(ik,:,CARTS)
              qwgt( k1 ) = qwgt_org(ik)
            else
              vkxyz( k1,:,CARTS) = vkxyz_org(ik,:,CARTS)
              qwgt( k1 ) = 0.0d0
           endif
         End do
      enddo
! 
      deallocate( vkxyz_org, qwgt_org )

      allocate( vkxyz_fbz_org(kv3_fbz/ndim_spinor,3,2 ) ); 
      vkxyz_fbz_org(1:kv3_fbz/ndim_spinor,:,:) = vkxyz_fbz(1:kv3_fbz/ndim_spinor,:,:)

      allocate( ilist(kv3_fbz/ndim_spinor) )
      ilist(1:kv3_fbz/ndim_spinor) = to_ibz_from_fbz_for_kpoint(1:kv3_fbz)

      do ik=1, kv3_fbz/ndim_spinor
         Do is=1, ndim_spinor
            k1 = ( ik -1 )*ndim_spinor + is
	    if ( is == 1 ) then
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            else
               vkxyz_fbz( k1,:,CARTS) = vkxyz_fbz_org(ik,:,CARTS)
               to_ibz_from_fbz_for_kpoint(k1) = 2*ilist(ik) -1
            endif
         End do
      End do
      deallocate( vkxyz_fbz_org ); deallocate( ilist )

    end subroutine gen_k_points_noncol
! ========================================================== 11.0

    subroutine k_points_in_BUCS_from_CARTS
      integer       :: i, ik
      real(kind=DP) :: fact
      do i = 1, 3
         do ik = 1, kv3
            vkxyz(ik,i,BUCS) = (altv(1,i)*vkxyz(ik,1,CARTS)&
                 &           +  altv(2,i)*vkxyz(ik,2,CARTS)&
                 &           +  altv(3,i)*vkxyz(ik,3,CARTS))/PAI2
         enddo
      enddo

      ! -- >      check of BUCS system
      do i = 1, 3
         do ik = 1, kv3
            fact =   rltv(i,1)*vkxyz(ik,1,BUCS)&
                 & + rltv(i,2)*vkxyz(ik,2,BUCS)&
                 & + rltv(i,3)*vkxyz(ik,3,BUCS)
            if(dabs(fact - vkxyz(ik,i,CARTS)) > 1.d-5) then
               if(ipri_kp>=1) then
                  write(nfout,*) ' !D (i = ',i,',ik = ',ik,')'
                  write(nfout,*) vkxyz(ik,i,BUCS),fact, vkxyz(ik,i,CARTS)
               end if
               stop ' Coordinate transformation is invalid'
            endif
         enddo
      enddo

! === KT_add === 2014/09/30
      do i = 1, 3
         do ik = 1, kv3_fbz
            vkxyz_fbz(ik,i,BUCS) = ( altv(1,i) *vkxyz_fbz(ik,1,CARTS) &
                 &                    +  altv(2,i) *vkxyz_fbz(ik,2,CARTS) &
                 &                    +  altv(3,i) *vkxyz_fbz(ik,3,CARTS) )/PAI2
         enddo
      enddo
! ============= 2014/09/30

    end subroutine k_points_in_BUCS_from_CARTS

    subroutine wd_k_sample_mesh
      integer :: i
      write(nfout,680) (k_sample_mesh(i,1),i=1,3)
      write(nfout,690) (k_sample_mesh(i,2),i=1,3)
680   format(' ',3i6,'   : nkx, nky, nkz ')
690   format(' ',3i6,'   : nkx2, nky2, nkz2 ')
    end subroutine wd_k_sample_mesh
  end subroutine m_Kp_gnrt_or_rd_k_points



!!$  subroutine m_Kp_rd_kpoints_table
!!$!    for tetrahedron method
!!$!     read k-table from the file 'f.kp0 '
!!$!           Tsuyoshi Miyazaki  '94.8.10
!!$#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1
!!$    integer,       pointer, dimension(:,:) :: ip2cub_wk
!!$    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0
!!$
!!$    write(nfout,*) '-- read k-table from <f.kp0> --'
!!$    call m_Files_open_nfkindex
!!$    read(nfkindex,*) np0
!!$    read(nfkindex,*) np0,np1,np2
!!$    write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
!!$    if(np2 /= kv3/nspin) then
!!$       write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!!$       write(nfout,*) ' kv3/nspin ',kv3/nspin
!!$       write(nfout,*) ' np2  /=  (kv3/nspin)'
!!$       stop
!!$    endif
!!$    allocate(ip20(np0)) ; ip20 = 0
!!$    allocate(ip10(np0)) ; ip10 = 0
!!$    allocate(ip01(np1)) ; ip01 = 0
!!$    allocate(ip21(np1)) ; ip21 = 0
!!$    allocate(iu21(np1)) ; iu21 = 0
!!$    allocate(iv21(np1)) ; iv21 = 0
!!$    allocate(ip02(np2)) ; ip02 = 0
!!$    allocate(ip12(np2)) ; ip12 = 0
!!$    allocate(iwt(np2)) ; iwt = 0
!!$    allocate(ip2cub(np1)) ; ip2cub = 0
!!$    allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
!!$    allocate(pa0(3,np0)) ; pa0 = 0.d0
!!$    allocate(pb0(3,np0)) ; pb0 = 0.d0
!!$    rewind nfkindex
!!$    write(nfout,'(" nfkindex = ",i9)') nfkindex
!!$    call nskpr0(nfkindex,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
!!$           &    ,nx1,ny1,nz1,np0,np1,np2 &
!!$           &    ,pa0,pb0 &
!!$           &    ,ip10,ip20,ip01,ip21,ip02,ip12,iu21,iv21)
!!$    deallocate(pa0)
!!$    deallocate(pb0)
!!$    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3))) 
!!$    ip2cub_wk = 0.d0
!!$    call wtetra &
!!$      &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
!!$      &  ,iwt,ip2cub &
!!$      &  ,ip2cub_wk)
!!$    deallocate(ip2cub_wk)
!!$#endif
!!$  end subroutine m_Kp_rd_kpoints_table

!! added by mizouchi@adv !!
!!!!!!!! modified by mizouchi@adv 2003.2.25 !!!!!
  subroutine m_Kp_cr_kpoints_table
!    for tetrahedron method
#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1,nd
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: ill,ii,lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb 
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2

    if(ipri_kp >= 2) write(nfout,*) '-- create k-table for tetrahedron method --'

    if(way_ksample == SKPS_DIRECT_IN) then
        stop 'way_ksample = SKPS_DIRECT_IN case is not&
             & supportted in tetrahedron method.'
    end if

    if(nbztyp.eq.WHOLE_BZ) then

        np0 = (k_sample_mesh(1,2)+1)*(k_sample_mesh(2,2)+1)*(k_sample_mesh(3,2)+1)
        np2 = k_sample_mesh(1,2)*k_sample_mesh(2,2)*k_sample_mesh(3,2)
        np1=np2

        if(ipri_kp>=1) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2

! ============================== modified by K. Tagami ============== 11.0
!        if(np2 /= kv3/nspin) then
!           if(ipri_kp>=1) then
!              write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!              write(nfout,*) ' kv3/nspin ',kv3/nspin
!              write(nfout,*) ' np2  /=  (kv3/nspin)'
!           end if
!           stop
!        endif
!
        if ( noncol ) then
          if(np2 /= kv3/ndim_spinor) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/ndim_spinor ',kv3/ndim_spinor
                write(nfout,*) ' np2  /=  (kv3/ndim_spinor)'
             end if
             stop
          endif
        else
          if(np2 /= kv3/nspin) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/nspin ',kv3/nspin
                write(nfout,*) ' np2  /=  (kv3/nspin)'
             end if
             stop
          endif
        endif
! ==================================================================== 11.0

        allocate(ip20(np0)) ; ip20 = 0
	if(ipri_kp>=2) write(nfout,'(" !kp ip20 is allocated")')
        allocate(iwt(np2)) ; iwt = 0
        allocate(ip2cub(np1)) ; ip2cub = 0
        allocate(nxyz_tetra(3)) ; nxyz_tetra = 0

        nx = k_sample_mesh(1,2)
        ny = k_sample_mesh(2,2)
        nz = k_sample_mesh(3,2)
        ill = 1

        lmnp0=np0
        lmnp1=np1

        allocate(ip01(np1)) ; ip01 = 0
        allocate(pa0(3,np0)) ; pa0 = 0.d0

        call nskma0(ill,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2) &
                    &,nxyz_tetra(3),nx1,ny1,nz1,nd)

        call nskp00(nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
                    &,nx1,ny1,nz1,nd,lmnp0,np0,pa0)

!! When nbztyp=1, ip10 in FLAPW program should be ip20 in this program !!

        call nskpbm(np0,lmnp0,lmnp1,pa0,np1,ip20,ip01) 

        deallocate(pa0)
        deallocate(ip01)
 
    else

      if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) then

         nx=k_sample_mesh(1,1); ny=k_sample_mesh(2,1); nz=k_sample_mesh(3,1)

         call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)         
         lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
         lmnp1=lmnp0
         lmnp2=lmnp0

         allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
         allocate(ip10(lmnp0))  ; ip10 = 0        
         allocate(ip20(lmnp0))  ; ip20 = 0        
         allocate(ip01(lmnp1))    ; ip01 = 0
         allocate(ip02(lmnp2))    ; ip02 = 0
         allocate(ip21(lmnp1))    ; ip21 = 0
         allocate(ip12(lmnp2))    ; ip12 = 0
         allocate(iu21(lmnp1))    ; iu21 = 0
         allocate(iv21(lmnp1))    ; iv21 = 0
         allocate(nstar2(lmnp2))  ; nstar2 = 0
         allocate(pa0(3,lmnp0))  ; pa0 = 0
         allocate(pb0(3,lmnp0))  ; pb0 = 0
         allocate(pb(3,lmnp2))  ; pb = 0
         allocate(ka0(4,lmnp0))  ; ka0 = 0
         allocate(ka2(4,lmnp2))  ; ka2 = 0

         ipri_kp_t = ipri_kp*(1-ipri_kp_count)
         if(ipri_kp_count == 0) ipri_kp_count = 1
         call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
              & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
              & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
              & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
              & ,nstar2,pa0,pb0,pb,ka0,ka2 &
              & ,ipri_kp_t)

      else
           nx = k_sample_mesh(1,1)
           ny = k_sample_mesh(2,1)
           nz = k_sample_mesh(3,1)

           if(ipri_kp>=2) write(nfout,'(" !kp nx,ny,nz = ",3i6)') nx,ny,nz
!!$           if(nbztyp_spg.eq.SIMPLE_CUBIC) il = 1
!!$           if(nbztyp_spg.eq.BCC) il = 3
!!$           if(nbztyp_spg.eq.FCC) il = 2
!!$           if(nbztyp_spg.eq.DIAMOND) il = 2
!!$           if(nbztyp_spg.eq.HEXAGONAL) il = 0

           call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)         
           if(ipri_kp >=2) write(nfout,'(" !kp nxx,nyy,nzz = ",3i6)') nxx,nyy,nzz

           lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
           lmnp1=lmnp0
           lmnp2=lmnp0

           allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
           allocate(ip10(lmnp0))  ; ip10 = 0        
           allocate(ip20(lmnp0))  ; ip20 = 0        
           allocate(ip01(lmnp1))    ; ip01 = 0
           allocate(ip02(lmnp2))    ; ip02 = 0
           allocate(ip21(lmnp1))    ; ip21 = 0
           allocate(ip12(lmnp2))    ; ip12 = 0
           allocate(iu21(lmnp1))    ; iu21 = 0
           allocate(iv21(lmnp1))    ; iv21 = 0
           allocate(nstar2(lmnp2))  ; nstar2 = 0
           allocate(pa0(3,lmnp0))  ; pa0 = 0
           allocate(pb0(3,lmnp0))  ; pb0 = 0
           allocate(pb(3,lmnp2))  ; pb = 0
           allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$           allocate(ka2(4,lmnp2))  ; ka2 = 0

!!$           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!!$                &               ,nbztyp_spg,altv,nx,ny,nz &
!!$                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!!$                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!!$                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!!$                &               ,nstar2,pa0,pb0,pb,ka0,ka2 &
!!$                &               ,ipri_kp)
           ipri_kp_t = ipri_kp*(1-ipri_kp_count)
           if(ipri_kp_count == 0) ipri_kp_count = 1

! ===================================== modified by K. Tagami ============== 12.0A
!           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!                &               ,nx,ny,nz &
!                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!                &               ,nstar2,pa0,pb0,pb,ka0 &
!                &               ,ipri_kp_t)
           if ( gen_tetramesh_mode == 0 ) then
              call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                   &               ,nx,ny,nz &
                   &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                   &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
                   &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                   &               ,nstar2,pa0,pb0,pb,ka0 &
                   &               ,ipri_kp_t)
           else if ( gen_tetramesh_mode == 1 ) then
              call setkp0_default_n_kt(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
                   &               ,nx,ny,nz &
                   &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
                   &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
                   &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
                   &               ,nstar2,pa0,pb0,pb,ka0 &
                   &               ,ipri_kp_t, &
                   &               use_altv_rltv, altv, rltv, itrs, &
                   &               gen_name_in_carts )
           endif
! ========================================================================== 12.0A
        end if

        if(ipri_kp>=2) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
        if(ipri_kp>=1) then
           write(nfout,'("!Kp nxyz_tetra(1:3) = ",3i8)') nxyz_tetra(1:3)
        end if

! ==================================== modified by K. Tagami =========== 11.0
!        if(np2 /= kv3/nspin) then
!           if(ipri_kp>=1) then
!              write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
!              write(nfout,*) ' kv3/nspin ',kv3/nspin
!              write(nfout,*) ' np2  /=  (kv3/nspin)'
!           end if
!           stop
!        endif
!
        if ( noncol ) then
          if(np2 /= kv3/ndim_spinor) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/ndim_spinor ',kv3/ndim_spinor
                write(nfout,*) ' np2  /=  (kv3/ndim_spinor)'
             end if
             stop
          endif
        else
          if(np2 /= kv3/nspin) then
             if(ipri_kp>=1) then
                write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
                write(nfout,*) ' kv3/nspin ',kv3/nspin
                write(nfout,*) ' np2  /=  (kv3/nspin)'
             end if
             stop
          endif
        endif
! =================================================================== 11.0

        allocate(iwt(np2)) ; iwt = 0
        allocate(ip2cub(np1)) ; ip2cub = 0

         deallocate(ip10)
         deallocate(ip01)
         deallocate(ip02)
         deallocate(ip21)
         deallocate(ip12)
         deallocate(iu21)
         deallocate(iv21)
         deallocate(nstar2)
         deallocate(pa0)
         deallocate(pb0)
         deallocate(pb)
         deallocate(ka0)
         if(nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER) &
              & deallocate(ka2)
    end if

    if(ipri_kp >= 2) then
       write(nfout,*) 'ip20'
       write(nfout,'(" np0 = ",i8)') np0
       write(nfout,*) (ip20(ii),ii=1,np0)
       write(nfout,'(" nx1,ny1,nz1,nd = ",4i6)') nx1,ny1,nz1,nd
    end if

    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3))) 
    ip2cub_wk = 0.d0
    call wtetra &
      &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
      &  ,iwt,ip2cub &
      &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
#endif
  end subroutine m_Kp_cr_kpoints_table

  subroutine change_kpoints_order
    integer :: nx,ny,nz,ik,ix,iy,iz &
          & , k0(k_sample_mesh(1,2),k_sample_mesh(2,2),k_sample_mesh(3,2)) &
          & , k1(kv3)
    real(kind=DP) :: wk(1:kv3,3)

    nx = k_sample_mesh(1,2)
    ny = k_sample_mesh(2,2)
    nz = k_sample_mesh(3,2)

! ======================================= modified by K. Tagami ======== 11.0
!    do ik = 1, kv3/nspin
!       wk(ik,1) = vkxyz(ik,1,CARTS)
!       wk(ik,2) = vkxyz(ik,2,CARTS)
!       wk(ik,3) = vkxyz(ik,3,CARTS)
!    end do

    if ( noncol ) then
      do ik = 1, kv3/ndim_spinor
         wk(ik,1) = vkxyz(ik,1,CARTS)
         wk(ik,2) = vkxyz(ik,2,CARTS)
         wk(ik,3) = vkxyz(ik,3,CARTS)
      end do
    else
      do ik = 1, kv3/nspin
         wk(ik,1) = vkxyz(ik,1,CARTS)
         wk(ik,2) = vkxyz(ik,2,CARTS)
         wk(ik,3) = vkxyz(ik,3,CARTS)
      end do
    endif
! ====================================================================== 11.0

    ik = 0
    do ix = 1,nx
    do iy = 1,ny
    do iz = 1,nz
        ik = ik+1
        k0(ix,iy,iz) = ik
        k1(ik) = 0
    end do
    end do
    end do

    ik = 0
    do iz = 1,nz
    do iy = 1,ny
    do ix = 1,nx
        ik = ik+1
        k1(ik) = k0(ix,iy,iz)
    end do
    end do
    end do

! ===================================== modified by K. Tagami ============= 11.0
!    do ik = 1, kv3/nspin
!      vkxyz(ik,1,CARTS) = wk(k1(ik),1) 
!      vkxyz(ik,2,CARTS) = wk(k1(ik),2) 
!      vkxyz(ik,3,CARTS) = wk(k1(ik),3) 
!    end do

    if ( noncol ) then
      do ik = 1, kv3/ndim_spinor
        vkxyz(ik,1,CARTS) = wk(k1(ik),1) 
        vkxyz(ik,2,CARTS) = wk(k1(ik),2) 
        vkxyz(ik,3,CARTS) = wk(k1(ik),3) 
      end do
    else
      do ik = 1, kv3/nspin
        vkxyz(ik,1,CARTS) = wk(k1(ik),1) 
        vkxyz(ik,2,CARTS) = wk(k1(ik),2) 
        vkxyz(ik,3,CARTS) = wk(k1(ik),3) 
      end do
    endif
! ======================================================================== 11.0

  end subroutine change_kpoints_order


  !  <<< Monkhorst-Pack special kpoints generator >>>
  !  coded by Takenori YAMAMOTO (Univ. Tokyo)
  !  last update : Aug. 12, 2003
! ========================================== modified by K. Tagami ======== 11.0P
!  subroutine special_kpoints(printlevel,output,nsym,rot,b1,b2,b3,a1,a2,a3 &
!    & ,nkpoint,nkpmax,kpoint,weight,magnetic,use_trs )

  subroutine special_kpoints( printlevel, output, nsym, rot, b1, b2, b3, a1, a2, a3, &
       &                      nkpoint, nkpmax, kpoint, weight, magnetic, use_trs, &
       &                      nkpoint_full, kpoint_full, to_ibz_from_fbz_for_kpoint, &
       &                      nsym_before_sym_reduction, rot_before_sym_reduction )
! ========================================================================== 11.0P
    implicit none

    integer, intent(in) :: printlevel
    integer, intent(in) :: output
    integer, intent(in) :: nsym
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(inout) :: nkpoint
    integer, intent(in) :: nkpmax
    real(kind=DP), intent(inout) :: kpoint(3,*),weight(*)
    logical, intent(in) :: magnetic
    logical, intent(in) :: use_trs

! === KT_add === 2014/09/30
    integer, optional, intent(inout) :: nkpoint_full
    real(kind=DP), optional, intent(inout) :: kpoint_full(3,*)
    integer, optional, intent(inout) :: to_ibz_from_fbz_for_kpoint(*)
! ============== 2014/09/30

! ============================ aded by K. Tagami ======================== 11.0P
    integer, optional, intent(in) :: nsym_before_sym_reduction
    real(kind=DP), optional, intent(in) :: rot_before_sym_reduction(3,3,*)
! ======================================================================= 11.0P

    ! local variables
    integer :: i,nkmesh,nmp_kmesh,nfbz_kmesh
    real(kind=DP), allocatable :: kmesh(:,:)
    real(kind=DP), allocatable :: mp_kmesh(:,:),fbz_kmesh(:,:)
    integer :: nsym_trs
    real(kind=DP), allocatable :: rot_trs(:,:,:),grot(:,:,:)
    real(kind=DP) :: kshf(3)
    integer :: face(3,nface_max),nface

! ============================= added by K. Tagami =============== 11.0P
    integer :: nsym_trs_before_sym_reduction
    real(kind=DP), allocatable :: rot_trs_before_sym_reduction(:,:,:)
    real(kind=DP), allocatable :: grot_before_sym_reduction(:,:,:)

    logical :: use_rot_before_sym_reduction
! ================================================================= 11.0P

    if(printable .and. printlevel .ge. 0) then
      write(output,*) 'Special k-points generation starts.'
    end if

    ! debug
    !if(printable .and. printlevel .ge. 3) then
    !  write(output,'("Symmetry operation matirx")')
    !  do i=1,nsym
    !    write(output,*) 'n=',i
    !    write(output,'(3(1x,f10.5))') rot(1,1:3,i)
    !    write(output,'(3(1x,f10.5))') rot(2,1:3,i)
    !    write(output,'(3(1x,f10.5))') rot(3,1:3,i)
    !  end do
    !end if
    ! end debug

    call set_number_nsym_trs( nsym, rot, magnetic, use_trs, nsym_trs )
    allocate( rot_trs(3,3,nsym_trs), grot(3,3,nsym_trs) )
    call gen_rot_trs( nsym, rot, nsym_trs, rot_trs )
    call get_grot(a1,a2,a3,b1,b2,b3,nsym_trs,rot_trs,grot)

! ============================= added by K. Tagami =============== 11.0P
    if ( noncol .and. present( nsym_before_sym_reduction ) ) then
       use_rot_before_sym_reduction = .true.
    else
       use_rot_before_sym_reduction = .false.
    endif

    if ( use_rot_before_sym_reduction ) then
       call set_number_nsym_trs( nsym_before_sym_reduction, rot_before_sym_reduction, &
            &                    magnetic, use_trs, nsym_trs_before_sym_reduction )
       allocate( rot_trs_before_sym_reduction(3,3,nsym_trs_before_sym_reduction) )
       allocate( grot_before_sym_reduction(3,3,nsym_trs_before_sym_reduction) )
       call gen_rot_trs( nsym_before_sym_reduction, rot_before_sym_reduction, &
            &            nsym_trs_before_sym_reduction, rot_trs_before_sym_reduction )
       call get_grot( a1, a2, a3, b1, b2, b3, nsym_trs_before_sym_reduction, &
            &         rot_trs_before_sym_reduction, grot_before_sym_reduction )
    endif
! =================================================================== 11.0P

    ! debug
    !if(printable .and. printlevel .ge. 3) then
    !  write(output,'("Symmetry operation matirx for reciprocal lattice indeces")')
    !  do n=1,nsym
    !    write(output,*) 'n=',n
    !    write(output,'(3(1x,f10.5))') grot(1,1:3,n)
    !    write(output,'(3(1x,f10.5))') grot(2,1:3,n)
    !    write(output,'(3(1x,f10.5))') grot(3,1:3,n)
    !  end do
    !end if
    ! end debug
  
    if(nkpoint == 0) then

      nkmesh = (2*mp_index(1)+1)*(2*mp_index(2)+1)*(2*mp_index(3)+1)
      allocate(kmesh(3,nkmesh*nsym_trs))
      call gen_gmesh(mp_index,nkmesh,kmesh)

      kshf(1:3) = kshift(1:3)/mp_index(1:3)
      do i=1,nkmesh
        kmesh(1:3,i) = kmesh(1:3,i) + kshf(1:3)
      end do

      ! debug
      !do i=1,nkmesh
      !  write(output,'(3(1x,f10.5))') kmesh(1:3,i)
      !end do
      !stop 'debug kmesh'
      ! end debug

      call fbz_face(b1,b2,b3,nface,face)

      allocate(mp_kmesh(3,nkmesh))
      allocate(fbz_kmesh(3,nkmesh))

      call first_bz(b1,b2,b3,nkmesh,kmesh,nmp_kmesh,mp_kmesh,nface,face)

      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in MP mesh        = ",i5)') nmp_kmesh

      ! debug
      !do i=1,nmp_kmesh
      !  write(output,'(3(1x,f10.5))') mp_kmesh(1:3,i)
      !end do
      !stop 'debug mp_kmesh'
      ! end debug

! == KT_add == 2014/09/30
#ifndef EXPERIMENTAL_REGEN_KMESH
      if ( present( kpoint_full ) ) then
         call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, 1, grot(1:3,1:3,1) )
         call first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)

         nkpoint_full = nfbz_kmesh
         kpoint_full(1:3,1:nkpoint_full) = fbz_kmesh(1:3,1:nkpoint_full)
      endif
#endif
! ============ 2014/09/30

      if ( use_rot_before_sym_reduction ) then
         call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, &
              &                       nsym_trs_before_sym_reduction, &
              &                       grot_before_sym_reduction )
      else
         call regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, nsym_trs, grot )
      endif

      call first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh,nface,face)

      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in full BZ        = ",i5)') nfbz_kmesh

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5))') fbz_kmesh(1:3,i)
      !end do
      !stop 'debug fbz_kmesh'
      ! end debug

#ifndef EXPERIMENTAL_REGEN_KMESH
      if ( present( kpoint_full ) ) then
         call gen_spk2( nsym_trs, grot, nkpoint_full, kpoint_full, nkpoint, nkpmax, &
              &        kpoint, weight, to_ibz_from_fbz_for_kpoint )
      else
         call gen_spk( nsym_trs, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax, &
              &        kpoint, weight )
      endif
#else
! == KT_add == 2014/09/30
      if ( present( kpoint_full ) ) then
         nkpoint_full = nfbz_kmesh
         kpoint_full(1:3,1:nkpoint_full) = fbz_kmesh(1:3,1:nkpoint_full)
      endif
      call gen_spk2( nsym_trs, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax, &
           &         kpoint, weight, to_ibz_from_fbz_for_kpoint )
! ============ 2014/09/30
#endif

      call positive(nsym_trs,grot,nkpoint,kpoint)

      deallocate(rot_trs,mp_kmesh,kmesh,fbz_kmesh)

    end if

    !!call accuracy(a1,a2,a3,nsym_trs,grot,nkpoint,kpoint,weight)

    deallocate(grot)

! ============================= added by K. Tagami ======================== 11.0P
    if ( allocated(grot_before_sym_reduction) ) deallocate( grot_before_sym_reduction )
    if ( allocated(rot_trs_before_sym_reduction) ) deallocate( rot_trs_before_sym_reduction )
! ========================================================================= 11.0P

    if(printable .and. printlevel .ge. 0) then
      write(output,*) 'Special k-points generation ends.'
    end if

  contains

! ================================ added by K. Tagami ================= 11.0P   
    subroutine regen_kmesh_using_grot( nkmesh, kmesh, mp_kmesh, nsym_trs, grot )
      integer, intent(in) :: nsym_trs
      integer, intent(inout) :: nkmesh
      real(kind=DP), intent(inout) :: kmesh(3,nkmesh*nsym_trs)
      real(kind=DP), intent(in) :: mp_kmesh(3,nkmesh)
      real(kind=DP), intent(in) :: grot(3,3,nsym_trs)

      real(kind=DP), allocatable :: kt_mesh(:,:)      

      integer :: i, j, n
      logical :: new_kp
      real(kind=DP) :: v(3)
      
      allocate( kt_mesh(3,nmp_kmesh) ); kt_mesh = 0

#ifndef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i)
         kt_mesh(2,i) = mp_kmesh(2,i)
         kt_mesh(3,i) = mp_kmesh(3,i)
      End Do      
#else
      Do i=1, nmp_kmesh
         kt_mesh(1,i) = mp_kmesh(1,i) -kshf(1)
         kt_mesh(2,i) = mp_kmesh(2,i) -kshf(2)
         kt_mesh(3,i) = mp_kmesh(3,i) -kshf(3)
      End Do      
#endif

      nkmesh=1
      kmesh(1:3,nkmesh) = kt_mesh(1:3,1)

      do i=1,nmp_kmesh
         
         do n=1,nsym_trs
            v(1:3) = grot(1:3,1,n)*kt_mesh(1,i) +grot(1:3,2,n)*kt_mesh(2,i) &
                 & + grot(1:3,3,n)*kt_mesh(3,i)

            new_kp = .true.
            do j=1,nkmesh
               if (abs(v(1)-kmesh(1,j)) < 1.d-10 .and. &
                    &abs(v(2)-kmesh(2,j)) < 1.d-10 .and. &
                    &abs(v(3)-kmesh(3,j)) < 1.d-10 ) then
                  new_kp = .false.    
                  exit
               end if
            end do
            
            if(new_kp) then
               nkmesh = nkmesh + 1
               kmesh(1:3,nkmesh) = v(1:3)
            end if

         end do
      end do

#ifdef EXPERIMENTAL_REGEN_KMESH
      Do i=1, nkmesh
         kmesh(1,i) = kmesh(1,i) +kshf(1)
         kmesh(2,i) = kmesh(2,i) +kshf(2)
         kmesh(3,i) = kmesh(3,i) +kshf(3)
      End Do
#endif
      deallocate( kt_mesh )
      
    end subroutine regen_kmesh_using_grot

    subroutine set_number_nsym_trs( nsym, rot, magnetic, use_trs, nsym_trs )
      integer, intent(in) :: nsym
      logical, intent(in) :: magnetic, use_trs
      real(kind=DP), intent(in) :: rot(3,3,nsym)

      integer, intent(out) :: nsym_trs

      integer :: i
      logical :: with_inverse
    
      real(kind=DP), parameter :: eps = 1.d-8

! check if the inverse operation is in rot
      with_inverse = .false.

      do i=1,nsym
         if ( abs(rot(1,1,i)+1.d0) < eps .and. &
              & abs(rot(2,2,i)+1.d0) < eps .and. &
              & abs(rot(3,3,i)+1.d0) < eps .and. &
              & abs(rot(1,2,i)) < eps .and. &
              & abs(rot(2,1,i)) < eps .and. &
              & abs(rot(2,3,i)) < eps .and. &
              & abs(rot(3,2,i)) < eps .and. &
              & abs(rot(3,1,i)) < eps .and. &
              & abs(rot(1,3,i)) < eps ) then
            with_inverse = .true.
         end if
      end do

! ----------------------------------------------
!    if(magnetic) with_inverse = .true.
! ---------------------------------------------

      if ( magnetic ) then
         if ( .not. noncol ) with_inverse = .true.
      endif

! ----------------------------------------------
!    if(with_inverse) then
!      nsym_trs = nsym
!    else
!      if(use_trs) then
!         nsym_trs = nsym*2
!      else
!         nsym_trs = nsym
!      end if
!    end if 
!    allocate(rot_trs(3,3,nsym_trs),grot(3,3,nsym_trs))
!    do i=1,nsym
!      rot_trs(1:3,1:3,i) = rot(1:3,1:3,i)
!    end do
!    if(use_trs .and. .not.with_inverse) then
!      do i=nsym+1,nsym_trs
!        rot_trs(1:3,1:3,i) = -rot(1:3,1:3,i-nsym) 
!      end do
!    end if
! ------------------------------------------------------

      if ( noncol ) then
         if(with_inverse) then
            nsym_trs = nsym
         else
            if(use_trs) then
               nsym_trs = nsym*2
            else
               nsym_trs = nsym
            end if
         end if
      else
         if(with_inverse) then
            nsym_trs = nsym
         else
            if(use_trs) then
               nsym_trs = nsym*2
            else
               nsym_trs = nsym
            end if
         end if
      endif

    end subroutine set_number_nsym_trs

    subroutine gen_rot_trs( nsym, rot, nsym_trs, rot_trs )
      integer, intent(in) :: nsym, nsym_trs
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: rot_trs(3,3,nsym_trs)

      integer :: i

      do i=1,nsym
         rot_trs(1:3,1:3,i) = rot(1:3,1:3,i)
      end do
      if ( nsym_trs > nsym ) then
         do i=nsym+1,nsym_trs
            rot_trs(1:3,1:3,i) = -rot(1:3,1:3,i-nsym) 
         end do
      end if

    end subroutine gen_rot_trs
! ====================================================================== 11.0P

    subroutine gen_gmesh(mp_index,nmesh,gmesh)
      implicit none

      integer, intent(in) :: mp_index(3)
      integer, intent(in) :: nmesh
      real(kind=DP), intent(out) :: gmesh(3,nmesh)

      ! local variables
      integer :: i,j,k,n

      n=0
      do i=-mp_index(1),mp_index(1)
        do j=-mp_index(2),mp_index(2)
          do k=-mp_index(3),mp_index(3)
            n=n+1
            gmesh(1,n)=dble(i)/mp_index(1)
            gmesh(2,n)=dble(j)/mp_index(2)
            gmesh(3,n)=dble(k)/mp_index(3)
          end do
        end do
      end do

    end subroutine gen_gmesh

    subroutine first_bz(b1,b2,b3,nkmesh,kmesh,nfbz_kmesh,fbz_kmesh &
    & ,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(in) :: nkmesh
      real(kind=DP), intent(in) :: kmesh(3,nkmesh)
      integer, intent(out) :: nfbz_kmesh
      real(kind=DP), intent(out) :: fbz_kmesh(3,nkmesh)
      integer, intent(in) :: nface,face(3,nface_max)

      ! local variables
      integer :: i,j,k
      real(kind=DP) :: g(3),q(3),gg,qg,g1(3),g2(3),g3(3),diff
      logical :: exists_in_fbz(nkmesh),trans_sym
      real(kind=DP), parameter :: eps = 1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      ! restrict k-points within FBZ
      exists_in_fbz(1:nkmesh) = .true.
      do i=1,nface
        g(1:3) = face(1,i)*g1(1:3) + face(2,i)*g2(1:3) + face(3,i)*g3(1:3)
        gg = sum(g(1:3)*g(1:3))
        do j=1,nkmesh
          q(1:3) = kmesh(1,j)*b1(1:3) + kmesh(2,j)*b2(1:3) + kmesh(3,j)*b3(1:3)
          qg = sum(q(1:3)*g(1:3))
          if(qg > gg + eps) exists_in_fbz(j) = .false.
        end do
      end do

      ! traslational symmetry
      loop_1: do i=1,nkmesh
        if(.not.exists_in_fbz(i)) cycle loop_1
        loop_2: do j=i+1,nkmesh
          if(.not.exists_in_fbz(j)) cycle loop_2
          trans_sym = .true.
          do k=1,3
            diff =  kmesh(k,i) - kmesh(k,j)
            if(abs(dble(nint(diff))-diff) .gt. eps) trans_sym = .false.
          end do
          if(trans_sym) exists_in_fbz(j) = .false.
        end do loop_2
      end do loop_1

      nfbz_kmesh=0
      do i=1,nkmesh
        if(exists_in_fbz(i)) then
          nfbz_kmesh=nfbz_kmesh+1
          fbz_kmesh(1:3,nfbz_kmesh)=kmesh(1:3,i)
        end if
      end do

    end subroutine first_bz

    subroutine fbz_face(b1,b2,b3,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(out) :: nface
      integer, intent(out) :: face(3,nface_max)

      ! local variables
      integer :: i,j,k,n
      real(kind=DP) :: gg_ref,gg
      real(kind=DP) :: g1(3),g2(3),g3(3)
      real(kind=DP) :: gface(3,nface_max)
      integer :: iface(3,nface_max)
      logical :: exists_in_fbz(nface_max)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      n=0
      do i=-2,2
        do j=-2,2
          do k=-2,2
            if(i == 0 .and. j == 0 .and. k == 0) cycle
            n=n+1
            gface(1:3,n) = i*g1(1:3) + j*g2(1:3) + k*g3(1:3)
            iface(1,n)=i
            iface(2,n)=j
            iface(3,n)=k
          end do
        end do
      end do

      exists_in_fbz(1:nface_max) = .true.
      do i=1,n
        if(exists_in_fbz(i)) then
          gg_ref = gface(1,i)**2 + gface(2,i)**2 + gface(3,i)**2
          do j=1,n
            if(i /= j) then
              gg = gface(1,i)*gface(1,j) + gface(2,i)*gface(2,j) + gface(3,i)*gface(3,j)
              if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
            end if
          end do
        end if
      end do

      nface=0
      do i=1,n
        if(exists_in_fbz(i)) then
          nface=nface+1
          face(1:3,nface)=iface(1:3,i)
        end if
      end do

      ! debug
      !if(printable .and. printlevel .ge. 3) then
      !  write(output,*) 'nface=',nface
      !  write(output,'(4(1x,a3))') ' no',' n1',' n2',' n3'
      !  do i=1,nface
      !    write(output,'(4(1x,i3))') i,face(1:3,i)
      !  end do
      !end if
      !stop 'debug fbz_face'
      ! end debug

    end subroutine fbz_face

    subroutine get_grot(a1,a2,a3,b1,b2,b3,nsym,rot,grot)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: grot(3,3,nsym)

      ! local variables
      integer :: n,i,j
      real(kind=DP) :: amat(3,3),bmat(3,3)

      amat(1:3,1) = a1(1:3)
      amat(1:3,2) = a2(1:3)
      amat(1:3,3) = a3(1:3)
      bmat(1:3,1) = b1(1:3)
      bmat(1:3,2) = b2(1:3)
      bmat(1:3,3) = b3(1:3)

      do n=1,nsym
        do j=1,3
          do i=1,3
            grot(i,j,n) = element(amat(1,i),bmat(1,j),rot(1,1,n))
          end do
        end do
      end do


! === KT_add === 2014/08/14
      do n=1, nsym
         if ( noncol ) then 
            if(magmom_dir_inversion_opr_flag(n) == -1 ) then
            grot(:,:,n) = -grot(:,:,n)
            endif
         endif
      end do
! ============== 2014/08/14

    end subroutine get_grot

    function element(a,b,rot) result(value)
      implicit none

      real(kind=DP) :: value

      real(kind=DP), intent(in) :: a(3),b(3),rot(3,3)

      ! local variables
      integer :: i,j

      value = 0.d0

      do j=1,3
        do i=1,3
          value = value + a(i)*rot(i,j)*b(j)
        end do
      end do

    end function element

    subroutine gen_spk( nsym, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax,  &
         &              kpoint, weight )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nfbz_kmesh
      real(kind=DP), intent(in) :: fbz_kmesh(3,nfbz_kmesh)
      integer, intent(inout) :: nkpoint
      integer, intent(in) :: nkpmax
      real(kind=DP), intent(inout) :: kpoint(3,nkpmax), weight(nkpmax)
      
      ! local variables
      integer :: i,j,n
      integer :: nequiv(nkpmax)
      real(kind=DP) :: g(3),q(3)
      real(kind=DP), parameter :: eps = 1.d-3
      logical :: not_included(nfbz_kmesh)

      not_included(1:nfbz_kmesh) = .true.

      nkpoint = 0
      do i=1,nfbz_kmesh
        if(not_included(i)) then
          nkpoint = nkpoint+1
          if(nkpoint > nkpmax) stop 'gen_spk: nkpoint > nkpmax'
          g(1:3) = fbz_kmesh(1:3,i)
          kpoint(1:3,nkpoint) = g(1:3)
          nequiv(nkpoint) = 1

          do j=i+1,nfbz_kmesh
            do n=1,nsym
              q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,j) + grot(1:3,2,n)*fbz_kmesh(2,j) + grot(1:3,3,n)*fbz_kmesh(3,j)

              if(sum((g(1:3)-q(1:3))**2) < eps .and. not_included(j)) then
                nequiv(nkpoint) = nequiv(nkpoint)+1
                not_included(j) = .false.
              end if

              ! debug
              !write(output,'(i2,3(1x,f10.5),2x,3(1x,f10.5),2x,l1)') n,g(1:3),q(1:3),not_included(j)
              ! end debug
            end do
          end do
        end if
      end do

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5),1x,l1)') fbz_kmesh(1:3,i), not_included(i)
      !end do
      ! end debug

      n=sum(nequiv(1:nkpoint))
      do i=1,nkpoint
        weight(i) = dble(nequiv(i))/dble(n)
      end do

    end subroutine gen_spk

! === KT_add ==== 2014/09/30
    subroutine gen_spk2( nsym, grot, nfbz_kmesh, fbz_kmesh, nkpoint, nkpmax,  &
         &               kpoint, weight, kpoint_index_in_ibz )
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nfbz_kmesh
      real(kind=DP), intent(in) :: fbz_kmesh(3,nfbz_kmesh)
      integer, intent(inout) :: nkpoint
      integer, intent(in) :: nkpmax
      real(kind=DP), intent(inout) :: kpoint(3,nkpmax), weight(nkpmax)
      integer, optional, intent(inout) :: kpoint_index_in_ibz(nfbz_kmesh)

      ! local variables
      integer :: i,j,n
      integer :: nequiv(nkpmax)
      real(kind=DP) :: g(3), q(3), vec_tmp(3)
      real(kind=DP), parameter :: eps = 1.d-3
      logical :: not_included(nfbz_kmesh)

      not_included(1:nfbz_kmesh) = .true.

      nkpoint = 0
      do i=1,nfbz_kmesh
        if(not_included(i)) then
          nkpoint = nkpoint+1
          if(nkpoint > nkpmax) stop 'gen_spk: nkpoint > nkpmax'
          g(1:3) = fbz_kmesh(1:3,i)
          kpoint(1:3,nkpoint) = g(1:3)
          nequiv(nkpoint) = 1
! ============ KT_add === 2014/09/30
          if ( present(kpoint_index_in_ibz) ) kpoint_index_in_ibz(i) = nkpoint
! ======================= 2014/09/30

          do j=i+1,nfbz_kmesh
            do n=1,nsym
              q(1:3) = grot(1:3,1,n)*fbz_kmesh(1,j) + grot(1:3,2,n)*fbz_kmesh(2,j) + grot(1:3,3,n)*fbz_kmesh(3,j)

              vec_tmp(1:3) = g(1:3) -q(1:3)
              vec_tmp(1:3) = vec_tmp(1:3) -nint( vec_tmp(1:3) )

              if ( sum( vec_tmp(1:3)**2 ) < eps .and. not_included(j) ) then
                nequiv(nkpoint) = nequiv(nkpoint)+1
                not_included(j) = .false.
! ============ KT_add === 2014/09/30
                if ( present(kpoint_index_in_ibz) ) kpoint_index_in_ibz( j ) = nkpoint
! ======================= 2014/09/30
              end if

              ! debug
              !write(output,'(i2,3(1x,f10.5),2x,3(1x,f10.5),2x,l1)') n,g(1:3),q(1:3),not_included(j)
              ! end debug
            end do
          end do
        end if
      end do

      ! debug
      !do i=1,nfbz_kmesh
      !  write(output,'(3(1x,f10.5),1x,l1)') fbz_kmesh(1:3,i), not_included(i)
      !end do
      ! end debug

      n=sum(nequiv(1:nkpoint))
      do i=1,nkpoint
        weight(i) = dble(nequiv(i))/dble(n)
      end do

    end subroutine gen_spk2
! =============== 2014/09/30

    subroutine positive(nsym,grot,nkpoint,kpoint)
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nkpoint
      real(kind=DP), intent(inout) :: kpoint(3,nkpoint)

      ! local variables
      integer :: i,n
      real(kind=DP) :: g(3)

      do i=1,nkpoint
        if(kpoint(1,i) /= 0.d0 .or. kpoint(2,i) /= 0.d0 .or. kpoint(3,i) /= 0.d0) then
          do n=1,nsym
            g(1:3) = grot(1:3,1,n)*kpoint(1,i) + grot(1:3,2,n)*kpoint(2,i) + grot(1:3,3,n)*kpoint(3,i)
            if(g(1) >= 0.d0 .and. g(2) >= 0.d0 .and. g(3) >= 0.d0) then
              kpoint(1:3,i)=g(1:3)
              exit
            end if
          end do
        end if
      end do

    end subroutine positive

    subroutine accuracy(a1,a2,a3,nsym,grot,nkpoint,kpoint,weight)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      integer, intent(in) :: nkpoint
      real(kind=DP), intent(in) :: kpoint(3,nkpoint),weight(nkpoint)

      ! local variables
      real(kind=DP) :: rgrid(0:3,ngrid)
      type(shell), allocatable :: rshell(:)
      type(shell) :: rshtmp
      integer, allocatable :: id_sub(:)
      integer :: i,j,k,nsub
      real(kind=DP) :: sm
      integer :: n,istart
      integer :: none_zero
      real(kind=DP) :: sm_nz,length_nz


      if(printable .and. printlevel .ge. 0) &
      &  write(output,'(1x,"number of k-points in irreducible BZ = ",i5)') nkpoint


      call gen_rgrid(a1,a2,a3,rgrid)

      ! debug
      !do i=1,ngrid
      !  write(output,'(3(1x,i4),1x,f10.5)') nint(rgrid(1:3,i)), rgrid(0,i)
      !end do
      !stop 'debug rgrid'
      ! end debug

      istart=2
      n=0
      shell_loop : do 
        if( n+1 > nshell ) exit shell_loop
        call get_shell(rgrid,rshtmp,istart)
        allocate(id_sub(rshtmp%ndim))
        call get_subshell(nsym,grot,rshtmp,id_sub,nsub)

        ! debug
        !write(output,*) 'n=',n+1
        !do i=1,rshtmp%ndim
        !  write(output,'(3(1x,i5),1x,i2)') nint(rshtmp%rindex(1:3,i)),id_sub(i)
        !end do
        !stop 'debug rshtmp'
        ! end debug
        allocate(rshell(nsub))
        do i=1,nsub
          allocate(rshell(i)%rindex(3,48))
          rshell(i)%ndim = 0
          do j=1,rshtmp%ndim
            if(id_sub(j) == i) then
              rshell(i)%ndim = rshell(i)%ndim+1
              rshell(i)%rindex(1:3,rshell(i)%ndim) = rshtmp%rindex(1:3,j)
            end if
          end do
          rshell(i)%length=rshtmp%length
        end do
        do i=1,nsub
          if( n+1 > nshell ) exit shell_loop
          n=n+1
          ! debug
          !write(output,'(i5,1x,f10.5,4(1x,i5))') n,rshell(i)%length,nint(rshell(i)%rindex(1:3,1)),rshell(i)%ndim
          ! end debug
          do j=1,rshell(i)%ndim
            if(nint(rshell(i)%rindex(1,j)) == ng ) stop 'accuracy: rindex >= ng'
            if(nint(rshell(i)%rindex(2,j)) == ng ) stop 'accuracy: rindex >= ng'
            if(nint(rshell(i)%rindex(3,j)) == ng ) stop 'accuracy: rindex >= ng'
          end do
          sm=0.d0
          do k=1,nkpoint
             sm = sm + weight(k)*amk(rshell(i)%rindex,rshell(i)%ndim,kpoint(1,k))
          end do

          ! debug
          !write(output,'(i5,2(1x,f10.5))') n, rshell(i)%length, sm
          ! end debug

          if(abs(sm) > 1.d-8) then
            none_zero = n
            sm_nz = sm/dble(2*nkpoint)
            length_nz = rshell(i)%length 
            do j=1,nsub
              deallocate(rshell(j)%rindex)
            end do
            deallocate(rshtmp%rindex,rshell,id_sub)
            exit shell_loop
          end if
        end do
        do i=1,nsub
          deallocate(rshell(i)%rindex)
        end do
        deallocate(rshtmp%rindex,rshell,id_sub)
      end do shell_loop

      if( n == nshell ) stop 'accuracy: n == nshell, accuracy check failure'

      if(printable .and. printlevel .ge. 0 ) then
        write(output,'(1x,"Index of the first none zero shell = ",i5)') none_zero
        write(output,'(1x,"|R| of the first none zero shell   = ",f10.5)') length_nz
        write(output,'(1x,"phase sum = ",f10.5)') sm_nz
        write(output,'(1x,"efficiency = ",f8.2)') dble(none_zero)/dble(nkpoint)
      end if

      if(printable .and. printlevel .ge. 1) then
        write(output,'(5x,4(1x,a10))') 'k1','k2','k3','weight'
        do i=1,nkpoint
          write(output,'(i5,4(1x,f10.5))') i,kpoint(1:3,i),weight(i)
        end do
      end if

    end subroutine accuracy

    subroutine gen_rgrid(a1,a2,a3,rgrid)
      implicit none

      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(out) :: rgrid(0:3,ngrid)

      ! local variables
      integer :: n,i1,i2,i3
      real(kind=DP) :: x(3)

      n=0
      loop_1: do i1=-ng,ng
        loop_2: do i2=-ng,ng
          loop_3: do i3=-ng,ng
            n=n+1
            x(1:3) = i1*a1(1:3) + i2*a2(1:3) + i3*a3(1:3)
            rgrid(0,n) = sqrt(sum(x(1:3)**2))
            rgrid(1,n) = dble(i1)
            rgrid(2,n) = dble(i2)
            rgrid(3,n) = dble(i3)
          end do loop_3
        end do loop_2
      end do loop_1

      call heap_sort(4,ngrid,rgrid,1)

    end subroutine gen_rgrid

    subroutine get_shell(rgrid,rshell,istart)
      implicit none

      real(kind=DP), intent(in) :: rgrid(0:3,ngrid)
      type(shell), intent(out) :: rshell
      integer, intent(inout) :: istart

      ! local variables
      real(kind=DP) :: eps = 1.d-10
      integer :: i,ndim

      ndim=0
      do 
        ndim=ndim+1
        if(istart+ndim>ngrid) exit
        if(abs(rgrid(0,istart+ndim)-rgrid(0,istart+ndim-1)) > eps) exit
      end do

      allocate(rshell%rindex(3,ndim))
      do i=1,ndim
        rshell%rindex(1:3,i) = rgrid(1:3,istart+i-1)
      end do
      rshell%length = rgrid(0,istart)
      rshell%ndim = ndim

      istart=istart+ndim

    end subroutine get_shell

    subroutine get_subshell(nsym,grot,rshell,id_sub,nsub)
      implicit none

      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: grot(3,3,nsym)
      type(shell), intent(in) :: rshell
      integer, intent(out) :: id_sub(rshell%ndim)
      integer, intent(out) :: nsub

      ! local variables
      integer :: i,j,n
      real(kind=DP) :: eps=1.d-8
      real(kind=DP) :: v(3)

      id_sub(1:rshell%ndim)=0
      nsub=0
      do i=1,rshell%ndim
        if(id_sub(i) /= 0) cycle
        nsub=nsub+1
        id_sub(i)=nsub
        do n=1,nsym 
          v(1:3) =   rshell%rindex(1,i)*grot(1,1:3,n) &
                 & + rshell%rindex(2,i)*grot(2,1:3,n) &
                 & + rshell%rindex(3,i)*grot(3,1:3,n)
          do j=1,rshell%ndim
            if(abs(v(1)-rshell%rindex(1,j)) < eps .and. &
               abs(v(2)-rshell%rindex(2,j)) < eps .and. &
               abs(v(3)-rshell%rindex(3,j)) < eps ) then
              id_sub(j)=id_sub(i)
            end if
          end do
        end do
      end do

    end subroutine get_subshell

    function amk(ri,ndim,kp) result(value)
      implicit none

      real(kind=DP) :: value

      integer, intent(in) :: ndim
      real(kind=DP), intent(in) :: ri(3,ndim),kp(3)

      ! local variables
      integer :: i
      real(kind=DP), parameter :: pi = 3.141592653589793d0, pi2=2*pi

      value=0.d0
      do i=1,ndim
        value = value + cos(pi2*sum(kp(1:3)*ri(1:3,i)))
      end do
      value = value/dble(ndim)

    end function amk

  end subroutine special_kpoints

  subroutine gen_special_kpoints( paramset, nfout, printlevel, nkpmax, &
       &                          nfmatbp, nkpoint, vkxyz, qwgt, imag, itrs, &
       &                          nkpoint_full, vkxyz_full, to_ibz_from_fbz_for_kpoint )

    use m_Const_Parameters, only : CARTS, CRDTYP, DP
    use m_Crystal_Structure, only : altv, rltv, nopr, op

! ========================= added by K. Tagami =========================== 11.0P
    use m_CS_NonCollinear,   only : nopr_before_sym_reduction, op_before_sym_reduction
! ======================================================================== 11.0P

    implicit none

    logical, intent(in)        :: paramset
    integer, intent(in)        :: nfout, printlevel, nkpmax
    integer, intent(in)        :: nfmatbp
    integer, intent(inout)     :: nkpoint
    ! if nkpoint == 0 then generating special k-points
    ! else ckecking accuracy of special k-points 
    real(kind=DP), intent(out) :: vkxyz(nkpmax,3,CRDTYP),qwgt(nkpmax)
    integer, intent(in)        :: imag
    integer, intent(in)        :: itrs

! === KT_add === 2014/09/30
    integer, intent(inout)     :: nkpoint_full
    real(kind=DP), intent(out) :: vkxyz_full(nkpoint_full,3,CRDTYP)
    integer, intent(out) :: to_ibz_from_fbz_for_kpoint(nkpoint_full)
! ============== 2014/09/30

    ! local variables
    real(kind=DP), parameter :: pi = 3.141592653589793d0, pi2=2*pi
    integer       :: i,nk,pl
    real(kind=DP), allocatable, dimension(:,:) :: trmat,trbp,trpb,mat1,mat2 
    real(kind=DP) :: v(3)
    real(kind=DP) :: b1(3),b2(3),b3(3)
    real(kind=DP), allocatable :: kpoint(:,:), weight(:)

! === KT_add ==== 2014/09/30
    real(kind=DP), allocatable :: kpoint_full(:,:)
    integer,       allocatable :: kpoint_num_in_ibz(:)
! =============== 2014/09/30
    
    !!integer, parameter :: nkpmax0 = 10000
    integer :: nkpmax0
    logical :: magnetic
    logical :: use_trs

    if(imag/=PARA) then
       magnetic = .true.
    else
       magnetic = .false.
    end if
    if(itrs == 1) then
       use_trs = .true.
    else
       use_trs = .false.
    end if

    b1(1:3) = rltv(1:3,1)/pi2
    b2(1:3) = rltv(1:3,2)/pi2
    b3(1:3) = rltv(1:3,3)/pi2

    if(paramset) then
      pl = -1
    else
      pl = printlevel
    end if
    !write(nfout,*) 'paramset=',paramset

    if(.not.(allocated(kpoint).or.allocated(weight))) then
      nkpoint = 0 ! for generating special k-points
      nkpmax0 = 2*mp_index(1)*mp_index(2)*mp_index(3)
      ng= 2 * maxval(mp_index)
      ngrid=(2*ng+1)**3
      nshell = nkpmax0
      allocate(kpoint(3,nkpmax0));   allocate(weight(nkpmax0))
! === KT_add === 2014/09/30
      allocate(kpoint_full(3,nkpmax0))
      allocate(kpoint_num_in_ibz(nkpmax0))
! ============== 2014/09/30
    end if

! ==================================== modified by K. Tagami ============== 11.0P
!    call special_kpoints( pl, nfout, nopr, op, &
!    &                     b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
!    &                     nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs )
!
    if ( noncol .and. use_op_before_sym_reduction ) then
       call special_kpoints( pl, nfout, nopr, op, &
            &                b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
            &                nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs, &
            &                nkpoint_full, kpoint_full, kpoint_num_in_ibz, &
            &                nopr_before_sym_reduction, op_before_sym_reduction )
    else
       call special_kpoints( pl, nfout, nopr, op, &
            &                b1, b2, b3, altv(1,1), altv(1,2), altv(1,3), &
            &                nkpoint, nkpmax0, kpoint, weight, magnetic, use_trs, &
            &                nkpoint_full, kpoint_full, kpoint_num_in_ibz )
    endif
! ========================================================================== 11.0P

    ! exists in m_SpecicalKpoints

    ! debug
    ! stop 'debug b_SpecailKpoints when first calling'
    ! end debug


    if(paramset) then
      deallocate(kpoint,weight);  
      deallocate(kpoint_full); deallocate(kpoint_num_in_ibz)
      return
    end if

    allocate(trmat(3,3))
    allocate(trbp(3,3))
    allocate(trpb(3,3))
    allocate(mat1(3,3))
    allocate(mat2(3,3))

    call get_trmat  !-(contained here) ->(trmat)

    do nk = 1, nkpoint
      v(1:3) = kpoint(1:3,nk) 
      vkxyz(nk,1:3,CARTS) = matmul(trmat,v)
      qwgt(nk) = weight(nk)
    enddo

! ==== KT_add === 2014/09/30
    do nk = 1, nkpoint_full
      v(1:3) = kpoint_full(1:3,nk) 
      vkxyz_full(nk,1:3,CARTS) = matmul(trmat,v)
      to_ibz_from_fbz_for_kpoint(nk) = kpoint_num_in_ibz(nk)
    end do
    deallocate( kpoint_full ); deallocate( kpoint_num_in_ibz )
! =============== 2014/09/30

    deallocate(kpoint,weight)

    deallocate(trmat); deallocate(trbp ); deallocate(trpb )
    deallocate(mat1 ); deallocate(mat2 )

    if(printable .and. printlevel >= 2) then
       write(nfout,'(/,"  << gen_special_kpoints >>")')
       write(nfout,*) ' !Total Generated Kpoints = ',nkpoint
       do nk = 1, nkpoint
         write(nfout,'(i6," ",3f12.6," : ",f12.6)') & 
         & nk,(vkxyz(nk,i,CARTS),i=1,3),qwgt(nk)
       end do
    end if

  contains
    subroutine get_trmat
    !    make translation matrix  trpb (P -> B)
      integer  :: i
      logical :: open

      trbp = 0.d0
      do i = 1,3
        trbp(i,i) = 1.d0
      end do

      inquire(unit=nfmatbp, opened = open)
      if(open) then
        rewind nfmatbp
        do i = 1, 3
          read(nfmatbp,*,end=1,err=1) trbp(i,1),trbp(i,2),trbp(i,3)
        enddo
        goto 2
1       trbp = 0.d0
        do i = 1,3
          trbp(i,i) = 1.d0
        end do
2       continue
      end if

      call inver3n(3,trbp,trpb)

      mat1 = transpose(trpb)
      call inver3n(3,mat1,mat2)
      call matpr3(rltv,mat2,trmat)

    end subroutine get_trmat
  end subroutine gen_special_kpoints

  subroutine read_mpindex(input)
    implicit none

    integer, intent(in) :: input

    read(input,*) mp_index(1:3)
    read(input,*) kshift(1:3)

  end subroutine read_mpindex

  subroutine m_Kp_cp_kxyz_to_vkxyz(nk,kxyz)
    integer, intent(in) :: nk
    real(kind=DP),intent(in) :: kxyz(3,nk)
    integer :: i,ik

    if(.not.allocated(vkxyz)) then
       if(ipri_kp >= 1) write(nfout,'(" vkxyz is not allocated")')
       stop
    end if

    if(ipri_kp>=1) write(nfout,'(" nk = ",i6," <<m_Kp_cp_kxyz_to_vkxyz>>")') nk
    do ik = 1, nk
       vkxyz(ik,1:3,BUCS) = kxyz(1:3,ik)
       if(ipri_kp>=1) write(nfout,'(" kxyz = ",3f10.6)') kxyz(1:3,ik)
    end do

    do ik = 1,nk
       do i = 1, 3
          vkxyz(ik,i,CARTS) = rltv(i,1)*vkxyz(ik,1,BUCS) &
               &            + rltv(i,2)*vkxyz(ik,2,BUCS) &
               &            + rltv(i,3)*vkxyz(ik,3,BUCS)
       end do
    end do

  end subroutine m_Kp_cp_kxyz_to_vkxyz

  subroutine m_Kp_set_kv3(nk)
    integer, intent(in) ::nk
    kv3 = nk
    if(ipri_kp>=1) write(nfout,'(" !kp kv3 = ",i5," <<m_kp_set_kv3>>")') kv3
  end subroutine m_Kp_set_kv3

  subroutine m_Kp_set_mesh_super
    integer :: n
    if( way_ksample == MESH ) then
       n = k_sample_mesh(1,1)
       k_sample_mesh(1,1) = max(nint(dble(n)/n1_sc),1)
       n = k_sample_mesh(1,1)
       k_sample_mesh(2,1) = max(nint(dble(n)/n2_sc),1)
       n = k_sample_mesh(1,1)
       k_sample_mesh(3,1) = max(nint(dble(n)/n3_sc),1)
       k_sample_mesh(:,2) = k_sample_mesh(:,1)
       if(printable) then
          write(nfout,*) 'k-point mesh will be changed.'
          write(nfout,'("mesh=",6i3)') k_sample_mesh
       end if
    else if( way_ksample == MONKHORST_PACK ) then
       n = mp_index(1)
       mp_index(1) = max(nint(dble(n)/n1_sc),1)
       n = mp_index(2)
       mp_index(2) = max(nint(dble(n)/n2_sc),1)
       n = mp_index(3)
       mp_index(3) = max(nint(dble(n)/n3_sc),1)
       if(printable) then
          write(nfout,*) 'k-point mesh will be changed.'
          write(nfout,'("mesh=",3i3)') mp_index
       end if
    end if
  end subroutine m_Kp_set_mesh_super

  subroutine m_Kp_dealloc
    if(allocated(vkxyz)) deallocate(vkxyz)
    if(allocated(qwgt)) deallocate(qwgt)
    if(allocated(k_symmetry)) deallocate(k_symmetry)
    if(allocated(nxyz_tetra)) deallocate(nxyz_tetra)
    if(allocated(ip20)) deallocate(ip20)
    if(allocated(iwt)) deallocate(iwt)
    if(allocated(ip2cub)) deallocate(ip2cub)

! === KT_add ==== 2014/09/30
    if ( allocated( vkxyz_fbz ) ) deallocate( vkxyz_fbz )
    if ( allocated( to_ibz_from_fbz_for_kpoint ) ) then
       deallocate( to_ibz_from_fbz_for_kpoint )
    endif
    if ( allocated( iopr_k_fbz_to_ibz ) ) deallocate( iopr_k_fbz_to_ibz ) 
    if ( allocated( num_star_of_k ) ) deallocate( num_star_of_k )
    if ( allocated( star_of_k ) ) deallocate( star_of_k )
! ================ 2014/09/30

  end subroutine m_Kp_dealloc
  
! === KT_add ==== 2014/09/30
!        === modified by T. Y. 2015/01/16 ===
!!$  subroutine gen_kpoint_in_full_BZ( paramset, kv3_fbz, vkxyz_fbz )
  subroutine gen_kpoint_in_full_BZ( paramset)
    logical, intent(in) :: paramset
!!$    integer, intent(in) :: kv3_fbz
!!$    real(kind=DP), intent(inout) :: vkxyz_fbz(kv3_fbz,3,CARTS)
!        ====================================

    integer :: i, ik
    real(kind=DP) :: b1(3), b2(3), b3(3)

    integer :: nface, face(3,nface_max)

    if ( paramset ) return

    b1(1:3) = rltv(1:3,1) /PAI2
    b2(1:3) = rltv(1:3,2) /PAI2
    b3(1:3) = rltv(1:3,3) /PAI2

    do i = 1, 3
       do ik = 1, kv3_fbz
          vkxyz_fbz(ik,i,BUCS) = (altv(1,i) *vkxyz_fbz(ik,1,CARTS) &
               &                + altv(2,i) *vkxyz_fbz(ik,2,CARTS) &
               &                + altv(3,i) *vkxyz_fbz(ik,3,CARTS) ) /PAI2
       enddo
    enddo

    call fbz_face(b1,b2,b3,nface,face)
    call move_kpt_to_inside_fbz( nface, face )

    do i = 1, 3
       do ik = 1, kv3_fbz
          vkxyz_fbz(ik,i,CARTS) = (rltv(1,i) *vkxyz_fbz(ik,1,BUCS) &
               &                + rltv(2,i) *vkxyz_fbz(ik,2,BUCS) &
               &                + rltv(3,i) *vkxyz_fbz(ik,3,BUCS) )
       enddo
    enddo

  contains

    subroutine move_kpt_to_inside_fbz( nface, iface_bz )
      integer, intent(in) :: nface
      integer, intent(in) :: iface_bz(3,nface_max)

      integer :: i, j, ik
      real(kind=DP) :: mtr(3,3)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8
      real(kind=DP) :: gg, gg_ref, ko(3)
!        === modified by T. Y. 2015/01/16 ===
      integer,parameter :: max_icount = 10000
      integer :: icount
!        ====================================
      
      do i=1,3
         do j=1,3
            mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
         end do
      end do
      
      Do ik=1, kv3_fbz
         ko(1:3) = vkxyz_fbz(ik,1:3,BUCS)
         do i=1,nface
            gg_ref = dot_product(iface_bz(:,i),matmul(mtr,iface_bz(:,i))) * 0.5d0
            icount = 0
            do
               gg = dot_product(iface_bz(:,i),matmul(mtr,ko))
               if(gg > gg_ref*lambda) then
                  ko(1:3) = ko(1:3) - dble(iface_bz(1:3,i))
               else
                  exit
               end if
!        === modified by T. Y. 2015/01/16 ===
               icount = icount+1
               if(icount > max_icount) then
                  write(nfout,'(" icount > max_icount in <<move_kpt_to_inside_fbz>>")')
                  write(nfout,'(" icount = ",i8)') icount
                  stop ' stop at <<move_kpt_to_inside_fbz>>. Icount is too large'
               end if
!        ====================================
            end do
         end do
         vkxyz_fbz(ik,1:3,BUCS) = ko(1:3)
      End do
    end subroutine move_kpt_to_inside_fbz

    subroutine fbz_face(b1,b2,b3,nface,face)
      implicit none

      real(kind=DP), intent(in) :: b1(3),b2(3),b3(3)
      integer, intent(out) :: nface
      integer, intent(out) :: face(3,nface_max)

      ! local variables
      integer :: i,j,k,n
      real(kind=DP) :: gg_ref,gg
      real(kind=DP) :: g1(3),g2(3),g3(3)
      real(kind=DP) :: gface(3,nface_max)
      integer :: iface(3,nface_max)
      logical :: exists_in_fbz(nface_max)
      real(kind=DP), parameter :: lambda = 1.d0+1.d-8

      g1(1:3)=b1(1:3)*0.5d0
      g2(1:3)=b2(1:3)*0.5d0
      g3(1:3)=b3(1:3)*0.5d0

      n=0
      do i=-2,2
        do j=-2,2
          do k=-2,2
            if(i == 0 .and. j == 0 .and. k == 0) cycle
            n=n+1
            gface(1:3,n) = i*g1(1:3) + j*g2(1:3) + k*g3(1:3)
            iface(1,n)=i
            iface(2,n)=j
            iface(3,n)=k
          end do
        end do
      end do

      exists_in_fbz(1:nface_max) = .true.
      do i=1,n
        if(exists_in_fbz(i)) then
          gg_ref = gface(1,i)**2 + gface(2,i)**2 + gface(3,i)**2
          do j=1,n
            if(i /= j) then
              gg = gface(1,i)*gface(1,j) + gface(2,i)*gface(2,j) + gface(3,i)*gface(3,j)
              if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
            end if
          end do
        end if
      end do

      nface=0
      do i=1,n
        if(exists_in_fbz(i)) then
          nface=nface+1
          face(1:3,nface)=iface(1:3,i)
        end if
      end do

    end subroutine fbz_face

  end subroutine gen_kpoint_in_full_BZ

  subroutine m_Kp_set_star_of_k
    integer :: iopr, i, j
    integer :: ikbz, jtrs, ik, jk
    real(kind=DP) :: x(3), y(3), rkxyz(3), dk(3)
    real(kind=DP), allocatable :: oprec(:,:,:)
    real(kind=DP), allocatable :: wk_star_of_k(:,:)

    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    allocate( num_star_of_k( kv3 ) );         num_star_of_k = 0;
    allocate( wk_star_of_k( kv3, kv3_fbz ) );  wk_star_of_k = 0
    allocate( iopr_k_fbz_to_ibz( kv3_fbz ) );  iopr_k_fbz_to_ibz = 0
    allocate( trev_k_fbz_to_ibz( kv3_fbz ) );  trev_k_fbz_to_ibz = 0

    do ikbz=1,kv3_fbz
       LOOP_S: do jtrs=0,1
          do iopr=1,nopr
             rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkxyz_fbz(ikbz,1:3,BUCS))

             do jk=1, kv3, nspin
                dk(1:3) = vkxyz(jk,1:3,BUCS) -rkxyz(1:3)

                if( abs(dk(1)-nint(dk(1)))<DELTA07  &
                     &      .and. abs(dk(2)-nint(dk(2)))<DELTA07  &
                     &      .and. abs(dk(3)-nint(dk(3)))<DELTA07 ) then

                   iopr_k_fbz_to_ibz(ikbz) = iopr
                   trev_k_fbz_to_ibz(ikbz) = jtrs
                   num_star_of_k(jk) = num_star_of_k(jk) +1
                   wk_star_of_k( jk, num_star_of_k(jk) ) = ikbz
                   exit LOOP_S
                end if
             end do
          end do
       end do LOOP_S
    End do

    max_num_star_of_k = maxval( num_star_of_k )

    allocate( star_of_k( kv3, max_num_star_of_k ) );  star_of_k = 0

    if ( nspin == 1 ) then
       Do ik=1, kv3
          Do i=1, num_star_of_k(ik)
             star_of_k(ik,i) = wk_star_of_k(ik,i)
          End do
       End do
    else
       Do ik=1, kv3, nspin
          num_star_of_k(ik+1) = num_star_of_k(ik)
          Do i=1, num_star_of_k(ik)
             star_of_k(ik,  i) = wk_star_of_k(ik,i)
             star_of_k(ik+1,i) = wk_star_of_k(ik,i)
          End do
       End do
    endif

    deallocate( wk_star_of_k )

  end subroutine m_Kp_set_star_of_k
! ============ 2014/09/30

  subroutine m_Kp_wd_BandSymInput(ipri,nfout,nf)
    integer, intent(in) ::ipri, nfout, nf
    character(len=4),dimension(3) :: spinstate
    data spinstate/"    ","  UP","DOWN"/
    integer :: ip, ik
    integer :: id_sname = -1
    call tstatc0_begin('m_Kp_wd_BandSymInput ',id_sname)
    if(mype == 0) then
       write(nf,'("##KPOINTS")')
       ip = 1
       if(allocated(vkxyz_ek) .and. kv3_ek >= kv3) then
          do ik = 1, kv3_ek
             if(nspin==2) ip = 3 - mod(ik,2)
             write(nf,'(i6,3f14.6,2x,a4)') ik,vkxyz_ek(ik,1:3,BUCS),spinstate(ip)
          end do
       else
          do ik = 1, kv3
             if(nspin==2) ip = 3 - mod(ik,2)
             write(nf,'(i6,3f14.6,2x,a4)') ik,vkxyz(ik,1:3,BUCS),spinstate(ip)
          end do
       end if
       write(nf,'("##"/)')
    end if
    call tstatc0_end(id_sname)
  end subroutine m_Kp_wd_BandSymInput
end module m_Kpoints

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 409 $)
!
!  MODULE: m_Electronic_Structure
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
!!$#ifdef VPP
!!$#define _VECTOR_TUNING_
!!$#endif
!!$#ifdef SX
!!$#define _VECTOR_TUNING_
!!$#endif
!!$#ifdef NEC_TUNE_MXCP
!!$#define _VECTOR_TUNING_
!!$#endif
module m_Electronic_Structure
! $Id: m_Electronic_Structure.F90 409 2014-10-27 09:24:52Z jkoga $
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, nkgroup, iteration
! === DEBUG for icond=2,3 & one_by_one by tkato 2014/01/24 =====================
  use m_IterationNumbers,   only : first_kpoint_in_this_job
! ==============================================================================
  use m_NonLocal_Potential, only : snl,norm_phig
  use m_PlaneWaveBasisSet,  only : igf,kg1,kg,kgp,nbase,nbmx,iba &
       &                         , nbase_gamma
  use m_PlaneWaveBasisSet,   only : m_pwBS_kinetic_energies
  use m_PseudoPotential,    only : ival,ilmt,nlmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,q,dion &
       &                         , ilmt_phi,nlmt_phi,nlmtt_phi,nlmta_phi &
       &                         , lmta_phi,lmtt_phi,ltp_phi,mtp_phi,taup_phi &
       &                         , iproj_phi, nlmta_add, nac_p &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , porb, qorb, m_PP_tell_iorb_lmt &
       &                         , nrorb, irorb, crorb &
       &                         , ipaw, dion_paw
  use m_Crystal_Structure,  only : op, nopr, nlpnt, additional_charge
  use m_Kpoints,            only : kv3,vkxyz, kv3_ek,vkxyz_ek,k_symmetry
  use m_Ionic_System,       only : ntyp,iatom, natm, iwei, ityp, pos, cps, qex &
       &                         , if_pdos, speciesname, iproj_group
  use m_FFT,                only : nfft &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , fft_box_size_WF
  use m_FFT,                only : m_FFT_WF, m_FFT_W_Vlocal_W
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : nspin,ipri, iprievdff, iprieigenvalue, ipribetar &
       &                         , kimg, neg, meg, neg_previous, num_extra_bands, printable &
       &                         , af, ekmode, delta_eigenvalue, evaluation_eko_diff &
       &                         , delta_eigenvalue_conduction, delta_eigenvalue_cond_is_given &
       &                         , m_CtrlP_ntcnvg_incre &
       &                         , m_CtrlP_ntcnvg_clear &
       &                         , m_CtrlP_ntcnvg_reset &
       &                         , m_CtrlP_cachesize &
       &                         , m_CntrlP_set_neg, m_CntrlP_set_meg &
       &                         , sw_orb_popu, sw_use_add_proj, sw_rsb &
#ifdef SAVE_FFT_TIMES
       &                         , sw_save_fft &
#endif
       &                         , sw_hybrid_functional &
#ifndef ENABLE_ESM_PACK
       &                         , nblocksize_mgs, nblocksize_mgs_is_given
#else
       &                         , nblocksize_mgs, nblocksize_mgs_is_given, esm_qbac
#endif
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, INVERSE, DELTA, PAI2 &
       &                         , DELTAevdff, BUCS, SCF, EK &
       &                         , ELECTRON, GAMMA, EK_CONVERGED, STORED_AND_NEW, OLD
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , np_kngp, mp_kngp, nel_kngp, myrank_g & 
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_atm, iend_atm &
       &                         , ierr,mp_e,nel_e &
       &                         , ista_g1k,iend_g1k,np_g1k,mp_g1k &
       &                         , np_fs, mp_fs,  nel_fs
! ============================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                              SpinOrbit_mode, sw_hubbard
  use m_Const_Parameters,     only : BuiltIn, Neglected

  use m_PseudoPotential,      only : dion_scr_noncl, fqwei_noncl
  use m_FFT,  only : m_FFT_W_Vlocal_W_noncl
  use m_ES_NonCollinear,      only : m_ES_MagMom_to_DensMat_Gspace, &
       &                            m_ES_MagMom_to_DensMat_vlhxcl, &
       &                             m_ES_DensMat_To_MagMom_dm, &
       &                             m_ES_DensMat_To_MagMom_porb
! ============================================================ 11.0

! ============================== added by K. Tagami ========== 12.0Exp
  use m_Control_Parameters,    only :   fixed_charge_k_parallel
  use m_Const_Parameters,      only :   ONE_BY_ONE
! ============================== added by K. Tagami ========== 12.0Exp

! ========== KT_add ======= 13.0U2
  use m_Control_Parameters, only : sw_potential_mixing, sw_mix_charge_hardpart, &
       &                           sw_modified_TFW_functional
  use m_PseudoPotential,    only : flg_paw
! ========================= 13.0U2

  implicit none

  real(kind=DP),allocatable, dimension(:,:,:,:):: zaj_l   ! d(kg1,np_e,ista_k:iend_k,kimg) wave functions
  real(kind=DP),allocatable, dimension(:,:,:,:):: zaj_l_buf   ! d(kg1,np_e,ista_k:iend_k,kimg) wave functions
#ifdef SAVE_FFT_TIMES
  real(kind=DP),allocatable, dimension(:,:,:)  :: Phifftr_l 
  !                                      d(nfft,np_e,ista_k:iend_k) or d(lsize,np_e,ista_k:iend_k)
  integer, allocatable, dimension(:,:) :: status_saved_phifftr ! d(np_e,ista_k:iend_k) 0: nothing or old, 1: stored and new
#endif
!!$  integer,      allocatable, dimension(:)     :: symmetric_or_antisymmetric
!!$                               !d(np_e), this is allocated when kimg == 1 and the system is symmetric
!!$  real(kind=DP),allocatable, dimension(:,:)   :: zaj_gamma_neg
!!$                               !d(kg1,np_e), zaj -G part for Gamma points when kimg = 1 and the system is symmetric
  integer,      allocatable, dimension(:,:)   :: neordr, nrvf_ordr !d(neg,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:)   :: eko_l             !d(np_e,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:)   :: eko_ek            !d(neg,kv3_ek)
  integer,  allocatable, dimension(:)         :: iconv_ek          !d(kv3_ek)
  real(kind=DP),allocatable, dimension(:,:)   :: occup_l           !d(np_e,ista_k:iend_k)
  real(kind=DP)                               :: efermi, efermi_spin(2), vbm = -9.99d10
  logical ::                                     metalic_system = .false.
  logical ::                                     check_if_metalic_flag = .false.
  real(kind=DP)                               :: totch
  real(kind=DP)                               :: band_entropy = 0.d0

  real(kind=DP),allocatable, dimension(:,:,:) :: fsr_l,fsi_l!d(np_e,nlmta,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:,:) :: fsr_add_l,fsi_add_l!d(np_e,nlmta_add,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:,:,:) :: compr_l,compi_l!d(np_e,nlmta_phi,nopr,ista_k:iend_k)

! ====== KT_mod ======== 13.0U2
!  real(kind=DP), allocatable, dimension(:,:,:) :: vlhxc_l !d(ista_kngp:iend_kngp,kimg,nspin)
  real(kind=DP), target, allocatable, dimension(:,:,:) :: vlhxc_l
                                               !d(ista_kngp:iend_kngp,kimg,nspin)
! ====================== 13.0U2
! ===== KT_add ========= 13.0U2
  real(kind=DP), target, allocatable, dimension(:,:,:) :: vlhxc_l_old
! ====================== 13.0U2

! =========================================== added by K. Tagami ============ 11.0
  real(kind=DP), allocatable, dimension(:,:,:) :: vlhxc_ssrep 
                                     !d(ista_kngp:iend_kngp,kimg,ndim_chgpot)
  real(kind=DP), allocatable, dimension(:,:,:,:):: dhub_aimag
! =========================================================================== 11.0

  real(kind=DP), allocatable, dimension(:,:,:,:):: vlhxcQ  !d(nlmt,nlmt,natm,nspin) 
! ===== KT_add ========= 13.0U2
  real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_old
! ====================== 13.0U2

  real(kind=DP), allocatable, dimension(:,:,:,:):: dhub  !d(nlmt,nlmt,natm,nspin) 
  real(kind=DP), allocatable, dimension(:,:,:) :: vnlph_l  !d(kg1,np_e,kimg) work array

  real(kind=DP),private,allocatable,dimension(:,:) :: eko1_l  !d(np_e,ista_k:iend_k)
  real(kind=DP),private,allocatable,dimension(:)   :: evdff   !d(3)
  real(kind=DP),private,allocatable,dimension(:)   :: evdffr  !d(3)
  ! evdff(1) : dsqrt((sum((e_old - e_new)**2))/(sum))
  ! evdff(2) : (1/sum)sum(dabs(e_old - e_new))
  ! evdff(3) : (1/sum)sum(dsqrt(dabs(e_old**2 - e_new**2)))

  integer,private                                     :: NB
#ifdef SX
  integer,        parameter                           :: nblocksize_mgs_default = 200
#else
!f  integer,        parameter                           :: nblocksize_mgs_default = 8
  integer,        parameter                           :: nblocksize_mgs_default = 8
#endif

  real(kind=DP),private,allocatable,dimension(:)      :: ar, ai

  real(kind=DP),        allocatable, dimension(:)     :: afft, bfft
  integer, private, parameter                         :: sw_timing_2ndlevel = ON

#ifndef NO_NONLOCAL_DGEMM
  logical :: DGEMM_DEBUG = .false.
#endif

  complex(kind=CMPLDP), allocatable, dimension(:) :: vloc_esm

!  1-1.  m_ES_alloc_zaj_etc
!  1-2.  m_ES_alloc_eko1
!  1-3.  m_ES_alloc_eko_ek
!  1-4.  m_ES_alloc_vlhxc
!  1-5.  m_ES_dealloc_vlhxc
!  1-6.  m_ES_alloc_vlhxcQ
!  1-7.  m_ES_dealloc_vlhxcQ
!  1-8.  m_ES_alloc_Dhub
!  1-9.  m_ES_dealloc_Dhub
!  1-10. m_ES_alloc_scss_etc
!  1-11. m_ES_dealloc_scss_etc
!  1-12. m_ES_alloc_fft_related
!  1-13. m_ES_dealloc_fft_related
!  1-14. m_ES_alloc_afft_scss_etc
!  1-15. m_ES_dealloc_afft_scss_etc
!  1-16. alloc_zfsincos_mpi
!  1-17. dealloc_zfsincos_mpi
!  1-18. m_ES_mgs_alloc
!        - mgs_vdb_alloc, - mgs_nrc_alloc
!  1-19. m_ES_mgs_dealloc
!        - mgs_vdb_dealloc, - mgs_nrc_dealloc
!  1-20. m_ES_alloc_zfsincos
!  1-21. m_ES_dealloc_zfsincos
!  1-22. m_ES_alloc_arai
!  1-23. m_ES_dealloc_arai
!  2-1.  m_ES_gtotch
!  2-2.  m_ES_wd_zaj_small_portion
!  2-3.  m_ES_decide_precon_factor
!  2-4.  kinetic_energy               <- (2-3)
!  2-5.  m_ES_Vnonlocal_W
!        - calc_phase_mpi, - Vnonlocal_W_part_sum_over_lmt1
!        - add_vnlph_l_with_eko_part, - add_vnlph_l_without_eko_part
!  2-6.  m_ES_sort_eigen_values
!        - cp_eigen_values_for_af, - expand_neordr_and_nrvf_ordr
!        - heap_sorting
!  2-7.  m_ES_energy_eigen_values
!        - get_ipri0
!  2-8.  m_ES_energy_eigen_values_ext
!        - get_ipri0
!  2-9.  m_ES_eigen_values_for_each_k
!        - W_T_W, - W_Vnonlocal_W
!  2-10. m_ES_eigen_values_for_each_kex
!        - W_T_W, - W_Vnonlocal_W
!  2-11. m_ES_Vlocal_in_Rspace
!        - map_vlhxc_l_onto_afft
!  2-12. m_ES_WF_in_Rspace
!  2-13. G_dot_R_mpi                  <- (2-14), (2-20), (2-23), (2-26)
!  2-14. m_ES_betar_dot_WFs           -> (2-15), (2-16)
!  2-15. wd_fsr_fsi                   <- (2-14), (2-17)
!  2-16. G_dot_R_map                  <- (2-14), (2-17), (2-18), (2-20), (2-23), (2-26)
!  2-17. m_ES_betar_dot_WFs_4_each_k  -> (2-15), (2-16)
!  2-18. m_ES_betar_dot_Psi_4_each_k  -> (2-16)
!  2-19. m_ES_betar_dot_WFs_4_lmta_k
!       - G_dot_R_mult_snl, - betar_dot_WFs_core, - multiple_i_l
!       - betar_dot_WFs_core2
!  2-20. m_ES_phir_dot_WFs            -> (2-13), (2-16)
!  2-21. wd_compr_compi
!  2-22. m_ES_phir_dot_WFs_4_lmta_k
!       - G_dot_R_mult_phig, - phir_dot_WFs_core, - multiple_i_l, - phir_dot_WFs_core2
!  2-23. m_ES_add_betar_dot_WFs       -> (2-13), (2-16), (2-24)
!  2-24. wd_fsr_fsi_add               <- (2-23)
!  2-25. m_ES_add_betar_dot_WFs_4_lmta_k
!        - G_dot_R_mult_snl, - betar_dot_WFs_core, - multiple_i_l, - betar_dot_WFs_core2
!  2-26. m_ES_PAO_WFs                 -> (2-13), (2-16)
!  2-27. m_ES_PAO_WFs_4_lmta_k
!        - G_dot_R_mult_paog
!  2-28. m_ES_modified_gram_schmidt
!  2-29. m_ES_orthogonalize_SD_to_WFs -> (2-30)
!  2-30. mgs_sd2wf_each_k_G           <- (2-29)  -> (2-34), (2-44)
!        - broadcast_fs, - Psi1SPhi2_t, - modify_bsd_and_phi_t, - alloc_phi_w_and_brd_w
!        - dealloc_phi_w_and_brd_w, - WSW, - normalize_bsd_and_phi, - Psi1SPhi2
!        - modify_bsd_and_phi
!  2-31. orthogonalize_SD             -> (2-33)
!  2-32. m_ES_MGS_4_each_k            -> (2-17), (2-33)
!        - wd_title_of_the_operation
!  2-33. mgs_4_each_k_G               <- (2-31), (2-32)  -> (2-34), (2-44)
!        - WSW_t, - normalize_bp_and_psi_t, - W1SW2_t_r
!        - modify_bp_and_psi_t_r, - substitute_jto_ib2back, - W1SW2_t
!        - modify_bp_and_psi_t, - alloc_and_brd_w, - dealloc_and_brd_w
!        - WSW, - normalize_bp_and_psi, - W1SW2, - modify_bp_and_psi
!  2-34. set_npzri                    <- (2-30), (2-33)
!  2-35. m_ES_W_transpose
!  2-36. m_ES_W_transpose_back
!  2-37. m_ES_W_transpose_back2
!  2-38. m_ES_W_transpose_r
!  2-39. m_ES_W_transpose_back_r
!  2-40. m_ES_F_transpose
!  2-41. m_ES_F_transpose_back
!  2-42. m_ES_F_transpose_r
!  2-43. m_ES_F_transpose_back_r
!  2-44. cp_bp_and_psi_2_brd_w2      <- (2-30), (2-33)
!  2-45. m_ES_wd_eko
!  2-46. m_ES_wd_eko_cond
!  2-47. m_ES_wd_eko2
!  2-48. m_ES_sum_of_LocalPart
!  2-48. m_ES_sum_of_LocalPart2
!  2-49. m_ES_cpeko
!  2-50. logical fnct. m_ES_eekdif
!        - get_ipri0
!  2-51. logical fnct. m_ES_eekdif_cond
!  2-52. m_ES_cp_eko_l_to_eko_ek
!  2-53. real(DP) fnct. m_ES_what_is_evdff_now
!  2-54. real(kind=DP) fnct. m_ES_get_energy
!  2-55. m_ES_orbital_population
!  2-56. m_ES_sym_comp
!  2-57. m_ES_orbital_den_mat
!  2-58. m_ES_set_num_bands_super
!

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  interface m_ES_WF_in_Rspace
    module procedure m_ES_WF_in_Rspace0
    module procedure m_ES_WF_in_Rspace1
  end interface m_ES_WF_in_Rspace

contains


  subroutine m_ES_alloc_zaj_etc()
    integer :: ik,ib
#ifdef SAVE_FFT_TIMES
    integer :: lsize
#endif
    if(iend_k - ista_k < 0) stop ' iend_k - ista_k < 0 (in m_ES_alloc_zaj_etc)'
    if(nlmta <= 0) stop ' nlmta <= 0 (in m_ES_alloc_zaj_etc)'
     allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
     if(sw_rsb==ON) allocate(zaj_l_buf(kg1,np_e,ista_k:iend_k,kimg))
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       allocate(Phifftr_l(nfft,np_e,ista_k:iend_k)); Phifftr_l = 0.d0
       allocate(status_saved_phifftr(np_e,ista_k:iend_k)); status_saved_phifftr = 0
    end if
#endif
    allocate(neordr(neg,ista_k:iend_k))
    allocate(nrvf_ordr(neg,ista_k:iend_k))
    do ik = ista_k, iend_k
       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)
       nrvf_ordr(1:neg,ik) = (/(ib,ib=1,neg)/)
    end do
    allocate(eko_l(np_e,ista_k:iend_k)); eko_l = 0.d0
    allocate(occup_l(np_e,ista_k:iend_k)); occup_l = 0.d0
    allocate(fsr_l(np_e,nlmta,ista_k:iend_k))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi_l(np_e,nlmta,ista_k:iend_k)); fsi_l = 0.d0
!!$ASASASAS
!!$    end if
    else
       allocate(fsi_l(1,1,1))
    end if
    fsi_l = 0.d0
!!$ASASASAS
    allocate(vnlph_l(kg1,np_e,kimg))
    ! -- for PDOS
    if(sw_orb_popu == ON) then
       allocate(compr_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(compi_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
!!$ASASASAS
!!%       end if
       else
          allocate(compi_l(1,1,1,1))
       end if
       compi_l = 0.d0
!!$ASASASAS
    end if
    if(sw_use_add_proj == ON) then
       allocate(fsr_add_l(np_e,nlmta_add,ista_k:iend_k))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi_add_l(np_e,nlmta_add,ista_k:iend_k))
       end if
    end if

  end subroutine m_ES_alloc_zaj_etc

! ======================================= added by K. Tagami =============== 11.0
  subroutine m_ES_alloc_zaj_etc_noncl()
    integer :: ik,ib
    if(iend_k - ista_k < 0) stop ' iend_k - ista_k < 0 (in m_ES_alloc_zaj_etc_noncl)'
    if(nlmta <= 0) stop ' nlmta <= 0 (in m_ES_alloc_zaj_etc_noncl)'
    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
    if(sw_rsb==ON) allocate(zaj_l_buf(kg1,np_e,ista_k:iend_k,kimg))
    allocate(neordr(neg,ista_k:iend_k))
    allocate(nrvf_ordr(neg,ista_k:iend_k))
    do ik = ista_k, iend_k
       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)
       nrvf_ordr(1:neg,ik) = (/(ib,ib=1,neg)/)
    end do
    allocate(eko_l(np_e,ista_k:iend_k)); eko_l = 0.d0
    allocate(occup_l(np_e,ista_k:iend_k)); occup_l = 0.d0
    allocate(fsr_l(np_e,nlmta,ista_k:iend_k)); fsr_l = 0.0d0
    allocate(fsi_l(np_e,nlmta,ista_k:iend_k));  fsi_l = 0.d0

    allocate(vnlph_l(kg1,np_e,kimg)); vnlph_l = 0.0d0
    ! -- for PDOS
    if(sw_orb_popu == ON) then
       allocate(compr_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       allocate(compi_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       compr_l = 0.d0; compi_l = 0.0d0
    end if
!
    if(sw_use_add_proj == ON) then
       allocate(fsr_add_l(np_e,nlmta_add,ista_k:iend_k))
       allocate(fsi_add_l(np_e,nlmta_add,ista_k:iend_k))
       fsr_add_l = 0.0d0; fsi_add_l = 0.0d0
    end if

  end subroutine m_ES_alloc_zaj_etc_noncl
! =======================================================================-11.0

  subroutine m_ES_alloc_eko1()
    allocate(eko1_l(np_e,ista_k:iend_k)); eko1_l = 0.d0
    allocate(evdff(3))
    allocate(evdffr(3))
  end subroutine m_ES_alloc_eko1

  subroutine m_ES_alloc_eko_ek()
    if ( allocated( eko_ek ) ) deallocate( eko_ek )
    allocate(eko_ek(neg,kv3_ek)); eko_ek = 0.0d0

    if(.not.allocated(iconv_ek)) then
       allocate(iconv_ek(kv3_ek)); iconv_ek = 0
    end if
  end subroutine m_ES_alloc_eko_ek


  subroutine m_ES_cp_iconv(numk,iconv_ek_tmp)
    integer, intent(in) :: numk
    integer, intent(in), dimension(numk) :: iconv_ek_tmp
    integer :: i
    if(numk>=1) then
       if(.not.allocated(iconv_ek)) then
          allocate(iconv_ek(kv3_ek))
          iconv_ek = 0
       end if
       do i = 1, numk
          iconv_ek(i) = iconv_ek_tmp(i)
       end do
       if(ipri >= 1) then
          write(nfout,'(" ! -- iconv_ek -- <<m_ES_cp_iconv>>")')
          write(nfout,'(" ! ",8i6)') (iconv_ek(i),i=1,numk)
          write(nfout,'(" ! ",8i6)') (iconv_ek(i),i=numk+1,kv3_ek)
       end if
    end if
  end subroutine m_ES_cp_iconv

  subroutine m_ES_alloc_vlhxc()
! =================================== modified by K. Tagami ================ 11.0
!!    allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin)); vlhxc_l = 0.d0
!
    if ( noncol ) then
      allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom))
    else 
      if(.not.allocated(vlhxc_l)) allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin))
    endif
    vlhxc_l = 0.d0
! ========================================================================== 11.0

! ====== KT_add ====== 13.0U2
    if ( sw_potential_mixing == ON .or. sw_modified_tfw_functional == ON ) then
      allocate(vlhxc_l_old(ista_kngp:iend_kngp,kimg,ndim_magmom))
      vlhxc_l_old = 0.0d0
   endif
! ==================== 13.0U2

  end subroutine m_ES_alloc_vlhxc

  subroutine m_ES_dealloc_vlhxc()
    if(allocated(vlhxc_l)) deallocate(vlhxc_l)

! ========== KT_add ========= 13.0U2
    if(allocated(vlhxc_l_old)) deallocate(vlhxc_l_old)
! =========================== 13.0U2

  end subroutine m_ES_dealloc_vlhxc

  subroutine m_ES_alloc_vlhxcQ()
    if(nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_vlhxcQ)'
! =================================== modified by K. Tagami ================ 11.0
!    allocate(vlhxcQ(nlmt,nlmt,natm,nspin)); vlhxcQ = 0.d0
!
    if ( noncol ) then
       allocate(vlhxcQ(nlmt,nlmt,natm,ndim_magmom))
    else 
       if(.not.allocated(vlhxcQ)) allocate(vlhxcQ(nlmt,nlmt,natm,nspin))
    endif
    vlhxcQ = 0.d0
! ========================================================================== 11.0

#if 0
! ====== KT_add ====== 13.0U2
    if ( sw_potential_mixing == ON ) then
       if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
          allocate(vlhxcQ_old(nlmt,nlmt,natm,nspin))
          vlhxcQ_old = 0.d0
       endif
   endif
! ==================== 13.0U2
#endif

  end subroutine m_ES_alloc_vlhxcQ

  subroutine m_ES_dealloc_vlhxcQ()
    if(allocated(vlhxcQ))  deallocate(vlhxcQ)
#if 0
! ======== KT_add ==== 13.0U2
    if(allocated(vlhxcQ_old))  deallocate(vlhxcQ_old)
! ==================== 13.0U2
#endif
  end subroutine m_ES_dealloc_vlhxcQ

! ====== KT_add =================== 13.0U2
  subroutine m_ES_cp_vlhxc_to_old
    vlhxc_l_old = vlhxc_l
    if ( flg_paw .or. sw_mix_charge_hardpart == ON) then
       vlhxcQ_old = vlhxcQ
#if 0
       if ( noncol ) vlhxcQ_i_old = vlhxcQ_i
#endif
    endif
  end subroutine m_ES_cp_vlhxc_to_old

  subroutine m_ES_cp_vlhxcQ_to_old
    if ( flg_paw .or. sw_mix_charge_hardpart == ON) then
       vlhxcQ_old = vlhxcQ
#if 0
       if ( noncol ) vlhxcQ_i_old = vlhxcQ_i
#endif
    endif
  end subroutine m_ES_cp_vlhxcQ_to_old
! ==================================== 13.0U2

  subroutine m_ES_wd_vlhxcQ()
    integer :: i, j, na
    write(nfout,'(" --- m_ES_wd_vlhxcQ ---")')
    do na = 1, natm
       write(nfout,'("  na = ", i8)') na
       do j = 1, nlmt
          write(nfout,'(" j = ", i8)') j
          write(nfout,'(8f10.4)') (vlhxcQ(i,j,na,1),i=1,nlmt)
       end do
    end do
  end subroutine m_ES_wd_vlhxcQ

  subroutine m_ES_alloc_Dhub()
    if(nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_Dhub)'
! ======================================== modified by K. Tagami ========= 11.0
!!    allocate(dhub(nlmt,nlmt,natm,nspin)); dhub = 0.d0
!
    if ( noncol ) then
       allocate(dhub(nlmt,nlmt,natm,ndim_magmom))
       allocate(dhub_aimag(nlmt,nlmt,natm,ndim_magmom))
       dhub = 0.d0; dhub_aimag = 0.0d0
    else
       allocate(dhub(nlmt,nlmt,natm,nspin))
       dhub = 0.d0
    endif
! =========================================================================11.0

  end subroutine m_ES_alloc_Dhub

  subroutine m_ES_dealloc_Dhub()
    if(allocated(dhub)) deallocate(dhub)
! ======================================== added by K. Tagami ========= 11.0
    if(allocated(dhub_aimag)) deallocate(dhub_aimag)
! ===================================================================== 11.0
  end subroutine m_ES_dealloc_Dhub

  subroutine m_ES_alloc_fft_related()
    allocate(afft(nfft))
    allocate(bfft(nfft))
    call m_FFT_alloc_WF_work() ! allocate(ftw)
  end subroutine m_ES_alloc_fft_related

  subroutine m_ES_dealloc_fft_related()
    call m_FFT_dealloc_WF_work()
    deallocate(bfft)
    deallocate(afft)
  end subroutine m_ES_dealloc_fft_related

  subroutine m_ES_gtotch(nfout)
    integer, intent(in) :: nfout
    integer :: it
    totch = 0.d0
    do it = 1, ntyp
       totch = totch + ival(it)*iatom(it) + qex(it)
    end do
#ifdef ENABLE_ESM_PACK
    totch = totch - esm_qbac
#endif
! ===== KT_add === 2014/06/08
    totch = totch - additional_charge      ! totch is num. of electrons
! ================ 2014/06/08

    if(printable) write(nfout,'(" TOTCH (total charge) = ",d25.12)') totch
    if(totch <= 1.d-20) stop ' ! illegal TOTCH value (m_ES_gtotch)'
    if(totch > natm*500.0) then
       if(printable) then
          do it=1,ntyp
             write(nfout,'(" !! it, ival, iatom, qex = ",i4,f8.4,i4,f8.4)') it,ival(it),iatom(it),qex(it)
          end do
          write(nfout,'(" ! illegal TOTCH value (m_ES_gtotch)")')
       end if
       stop ' ! illegal TOTCH value (m_ES_gtotch)'
    end if
  end subroutine m_ES_gtotch

  subroutine m_ES_wd_zaj_small_portion(nfout,ik,comment,nc)
    integer,        intent(in) :: nfout, ik, nc
    character(len=nc), intent(in) :: comment

    character(len=5) :: a
    integer :: i, ib, ri, j
    real(kind=DP), allocatable, dimension(:,:) :: zaj_tmp
    integer, parameter :: NZAJSIZE = 20
    integer :: nelm

    write(nfout,*) comment
    a = "     "
    do ib = ista_e, iend_e, istep_e               ! MPI
       if(k_symmetry(ik) == GAMMA) then
          allocate(zaj_tmp(5,2)); zaj_tmp = 0.d0
          do i = 1, 5
             find_j: do j = 1, 10
                if(nbase_gamma(j,1) == i) then
                   zaj_tmp(i,1) = zaj_l(j,map_z(ib),ik,1)
                   if(kimg == 2) zaj_tmp(i,2) = zaj_l(j,map_z(ib),ik,2)
                   goto 1001
                end if
             end do find_j
             find_j2: do j = 2, 10
                if(nbase_gamma(j,2) == i) then
                   zaj_tmp(i,1) = zaj_l(j,map_z(ib),ik,1)
                   if(kimg == 2) zaj_tmp(i,2) = -zaj_l(j,map_z(ib),ik,2)
                   exit find_j2
                end if
             end do find_j2
1001         continue
          end do
          
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "
             
             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_tmp(i,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_tmp(i,ri),i=1,5)
          end do
          deallocate(zaj_tmp)
       else
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
          end do
       end if
       if(ipri >= 3) then
          nelm = min(iba(ik),NZAJSIZE)
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             write(nfout,'(35x,5e14.6)') (zaj_l(i,map_z(ib),ik,ri),i=6,nelm)
!!$             write(nfout,'(35x,5e14.6)') (zaj_l(i,map_z(ib),ik,ri),i=6,kg1)
          end do
       end if
    end do
!!$       if(kimg==2) a = "(Im) "
!!$       write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
!!$            &  ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,1),i=1,5)
!!$       write(nfout,455) ik,ib,eko_l(map_z(ib),ik) ! MPI
!!$       do ri = 1, kimg
!!$          if(ri == 1 .and. kimg == 2) write(nfout,*) ' (zaj real part)'
!!$          if(ri == 2)                 write(nfout,*) ' (zaj imag part)'
!!$          if(ri == 1 .and. kimg == 2) a = "(Re)"
!!$          if(ri == 2)                 a = "(Im)"
!!$          write(nfout,'(a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5) ! MPI
!!$       end do
!!$    end do
!!$455 format(' ',' ik, ib = ',2i5,' e = ',d20.12)
  end subroutine m_ES_wd_zaj_small_portion

  subroutine m_ES_decide_precon_factor(precon,ik,ib,ekin,p)
    integer, intent(in)                         :: precon,ik,ib
    real(kind=DP), intent(in),  dimension(kg1) :: ekin
    real(kind=DP), intent(out), dimension(kg1) :: p

    integer       :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

! ======================== added by K. Tagami ============== 11.0
    real(kind=DP) :: ctmp1
    integer :: is
! =========================================================== 11.0

    if(precon == ON) then
! ======================== modiifed by K. Tagami ============ 11.0
!       call kinetic_energy(ik,ib,ekin,ektot)   ! -(m_E.S.)

       if ( noncol ) then
          ektot = 0.0d0
          Do is=1, ndim_spinor
             call kinetic_energy( ik+is-1, ib, ekin, ctmp1 )  
             ektot = ektot + ctmp1
          End do
       else
          call kinetic_energy(ik,ib,ekin,ektot)   ! -(m_E.S.)
       endif

! =========================================================== 11.0

       d_ektot = 1.d0/ektot
       do i = 1, iba(ik)
          x = ekin(i)*d_ektot
          x1 = 27 + ( 18 + (12 + 8*x) *x) *x
          x2 = 16*(x*x)*(x*x)
          p(i)  = x1/(x1 + x2 )
       end do
    else
       p = 1.d0
    end if
  end subroutine m_ES_decide_precon_factor

  subroutine kinetic_energy(ik,ib,dekin,ektot)
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i
    ektot = 0.d0
    if(kimg == 1) then
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*zaj_l(i,map_z(ib),ik,1)**2
       end do
    else
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*( zaj_l(i,map_z(ib),ik,1)**2 &
               &                   + zaj_l(i,map_z(ib),ik,2)**2)
       end do
    end if
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy

  subroutine m_ES_sort_eigen_values()
    integer             :: ik, ib, jb
#ifdef _NO_HEAP_SORT_EIGENVALUES_
    integer             :: ibo, jbo
#endif
    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable,dimension(:) :: eko_t, eko_t2
#ifdef _ESORT_ALLGATHER_
    integer :: n_little_elements, n_big_elements, ns, in, ip, ip0
    real(kind=DP), allocatable,dimension(:) :: work_subst
#endif

    integer                  :: i, id_sname = -1, id_sname2 = -1, id_sname3 = -1
    call tstatc0_begin('m_ES_sort_eigen_values ',id_sname,1)


#ifdef _ESORT_ALLGATHER_
    allocate(eko_t(mp_e*nrank_e))
    allocate(eko_t2(mp_e)); eko_t2 = 0.d0
#else
    allocate(eko_t(neg))
    allocate(eko_t2(np_e))   ! MPI
#endif    

    do ik = 1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle    ! MPI

       do ib = 1, np_e
          eko_t2(ib) = eko_l(ib,ik)
       end do
       if(nrank_e > 1) then
          call tstatc0_begin('mpi_barrier ',id_sname2)
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          call tstatc0_end(id_sname2)
#ifdef _ESORT_ALLGATHER_
          call tstatc0_begin('mpi_allgather ',id_sname3)
          call mpi_allgather(eko_t2,mp_e, mpi_double_precision &
               &           , eko_t, mp_e, mpi_double_precision,mpi_k_world(myrank_k),ierr)

          n_little_elements = mp_e*nrank_e - neg
          if(ipri >= 2) write(nfout,'("!esort n_little_elements = ",i6)') n_little_elements
          if(ipri >= 2) write(nfout,'("!esort eko_t  = ",10(/,10f8.4))') (eko_t(i),i=1,mp_e*nrank_e)
          if(n_little_elements > 1) then
             n_big_elements = nrank_e - n_little_elements
             ns = mp_e*(n_big_elements + 1) - 1
             allocate(work_subst(neg-ns))
             do in = n_big_elements+2, nrank_e
                ip0 = mp_e*(in-1)
                ip  = (mp_e-1)*(in - n_big_elements - 2)
                do i = 1, nel_e(in-1)
                   work_subst(ip+i) = eko_t(ip0+i)
                end do
             end do
             do i = 1, neg-ns
                eko_t(ns+i-1) = work_subst(i)
             end do
             deallocate(work_subst)
          end if
#else
          call tstatc0_begin('mpi_allgatherv ',id_sname3)
          call mpi_allgatherv(eko_t2,nel_e(myrank_e),mpi_double_precision, eko_t, nel_e &
               & , idisp_e,mpi_double_precision,mpi_k_world(myrank_k),ierr)
#endif
          call tstatc0_end(id_sname3)
       else
          eko_t = eko_t2
       end if
!!$#else
!!$       eko_t = 0.d0                       ! MPI
!!$       do ib = 1, neg                     ! MPI
!!$          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik)   ! MPI
!!$       end do                             ! MPI
!!$
!!$       if(nrank_e > 1) then
!!$          call tstatc0_begin('mpi_allreduce ',id_sname3)
!!$          call mpi_allreduce(eko_t,eko_t2,neg,mpi_double_precision &
!!$               & ,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
!!$          eko_t = eko_t2
!!$          call tstatc0_end(id_sname3)
!!$       end if
!!$#endif

       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t before sorting ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

#ifdef _NO_HEAP_SORT_EIGENVALUES_
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr(ib,ik)
             jbo = neordr(jb,ik)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr(jb,ik) = ibo
                neordr(ib,ik) = jbo
             endif
          enddo
       enddo
#else
       call heap_sorting(neg,eko_t,neordr(1,ik))
#endif

       do ib = 1, neg
          do jb = 1, neg
             if(ib == neordr(jb,ik)) then
                nrvf_ordr(ib,ik) = jb
                exit
             endif
          enddo
       enddo

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t in order ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if
    end do ! do-loop of ik

    if(af /= 0) then
       call cp_eigen_values_for_af()
       call expand_neordr_and_nrvf_ordr()
    end if
    deallocate(eko_t)
!!$#ifdef TRANSPOSE
    deallocate(eko_t2)
!!$#else
!!$    if(nrank_e > 1) deallocate(eko_t2)  ! MPI
!!$#endif
!!$    call mpi_barrier(mpi_comm_group,ierr)
    call tstatc0_end(id_sname)
  contains
    subroutine cp_eigen_values_for_af()
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle                              ! MPI
         do ib = 1, np_e                                              ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr()
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle                             ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

#ifndef _NO_HEAP_SORT_EIGENVALUES_
    subroutine heap_sorting(n,eig,iord)
      integer, intent(in) :: n
      real(kind=DP), intent(inout) :: eig(n)
      integer, intent(inout) :: iord(n)

      integer :: i,j,k,itmp,it
      real(kind=DP) :: rt

      !*** initialization: heapfy eig and iord ***
      do i=2,n
         rt = eig(i)
         it = iord(i)
         j=i
10       itmp=j/2
         if(eig(itmp).ge.rt) go to 20
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         if(j.gt.1) go to 10
20       eig(j) = rt
         iord(j) = it
      end do
      !*** to be fully sort ***
      do k=n-1,1,-1
         rt = eig(1)
         eig(1) = eig(k+1)
         eig(k+1) = rt
         rt = eig(1)
         it = iord(1)
         iord(1) = iord(k+1)
         iord(k+1) = it
         it = iord(1)
         j=1
         itmp=2
30       if(itmp.gt.k) go to 40
         if(itmp.lt.k) then
            if(eig(itmp+1).gt.eig(itmp)) itmp=itmp+1
         end if
         if(rt.ge.eig(itmp)) go to 40
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         itmp=j*2
         go to 30
40       eig(j) = rt
         iord(j) = it
      end do
    end subroutine heap_sorting
#endif
  end subroutine m_ES_sort_eigen_values

! ===================================== added by K. Tagami ============== 11.0
  subroutine m_ES_sort_eigen_vals_noncl()
    integer             :: ik, ib, jb
#ifdef _NO_HEAP_SORT_EIGENVALUES_
    integer             :: ibo, jbo
#endif
    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable,dimension(:) :: eko_t, eko_t2
#ifdef _ESORT_ALLGATHER_
    integer :: n_little_elements, n_big_elements, ns, in, ip, ip0
    real(kind=DP), allocatable,dimension(:) :: work_subst
#endif

! ===================================== added by K. Tagami ================ 11.0
    integer :: ikskip, is
! ========================================================================= 11.0

    integer                  :: i, id_sname = -1, id_sname2 = -1, id_sname3 = -1
    call tstatc0_begin('m_ES_sort_eigen_vals_noncl ',id_sname,1)


!!$#ifdef TRANSPOSE
#ifdef _ESORT_ALLGATHER_
    allocate(eko_t(mp_e*nrank_e))
    allocate(eko_t2(mp_e)); eko_t2 = 0.d0
#else
    allocate(eko_t(neg))
    allocate(eko_t2(np_e))   ! MPI
#endif    
!!$#else
!!$    allocate(eko_t(neg))
!!$    if(nrank_e > 1) allocate(eko_t2(neg))    ! MPI
!!$#endif

    ikskip = ndim_spinor

    do ik = 1, kv3, ikskip
       if(map_k(ik) /= myrank_k) cycle    ! MPI
!!$#ifdef TRANSPOSE
       do ib = 1, np_e
          eko_t2(ib) = eko_l(ib,ik)
       end do
       if(nrank_e > 1) then
          call tstatc0_begin('mpi_barrier ',id_sname2)
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          call tstatc0_end(id_sname2)
#ifdef _ESORT_ALLGATHER_
          call tstatc0_begin('mpi_allgather ',id_sname3)
          call mpi_allgather(eko_t2,mp_e, mpi_double_precision &
               &           , eko_t, mp_e, mpi_double_precision,mpi_k_world(myrank_k),ierr)

          n_little_elements = mp_e*nrank_e - neg
          if(ipri >= 2) write(nfout,'("!esort n_little_elements = ",i6)') n_little_elements
          if(ipri >= 2) write(nfout,'("!esort eko_t  = ",10(/,10f8.4))') (eko_t(i),i=1,mp_e*nrank_e)
          if(n_little_elements > 1) then
             n_big_elements = nrank_e - n_little_elements
             ns = mp_e*(n_big_elements + 1) - 1
             allocate(work_subst(neg-ns))
             do in = n_big_elements+2, nrank_e
                ip0 = mp_e*(in-1)
                ip  = (mp_e-1)*(in - n_big_elements - 2)
                do i = 1, nel_e(in-1)
                   work_subst(ip+i) = eko_t(ip0+i)
                end do
             end do
             do i = 1, neg-ns
                eko_t(ns+i-1) = work_subst(i)
             end do
             deallocate(work_subst)
          end if
#else
          call tstatc0_begin('mpi_allgatherv ',id_sname3)
          call mpi_allgatherv(eko_t2,nel_e(myrank_e),mpi_double_precision, eko_t, nel_e &
               & , idisp_e,mpi_double_precision,mpi_k_world(myrank_k),ierr)
#endif
          call tstatc0_end(id_sname3)
       else
          eko_t = eko_t2
       end if
!!$#else
!!$       eko_t = 0.d0                       ! MPI
!!$       do ib = 1, neg                     ! MPI
!!$          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik)   ! MPI
!!$       end do                             ! MPI
!!$
!!$       if(nrank_e > 1) then
!!$          call tstatc0_begin('mpi_allreduce ',id_sname3)
!!$          call mpi_allreduce(eko_t,eko_t2,neg,mpi_double_precision &
!!$               & ,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
!!$          eko_t = eko_t2
!!$          call tstatc0_end(id_sname3)
!!$       end if
!!$#endif

       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)

! ----------------- debug --
!       write(*,'(" !Esort  eko_t before sorting ")')
!       write(*,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
! ------------------------

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t before sorting ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

#ifdef _NO_HEAP_SORT_EIGENVALUES_
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr(ib,ik)
             jbo = neordr(jb,ik)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr(jb,ik) = ibo
                neordr(ib,ik) = jbo
             endif
          enddo
       enddo
#else
       call heap_sorting(neg,eko_t,neordr(1,ik))
#endif

       do ib = 1, neg
          do jb = 1, neg
             if(ib == neordr(jb,ik)) then
                nrvf_ordr(ib,ik) = jb
                exit
             endif
          enddo
       enddo

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t in order ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

! ------- debug --
!       write(*,'(" !Esort  eko_t in order ")')
!       write(*,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
! ---------------

    end do ! do-loop of ik

! ------------------- important- ---------------
!
    Do ik=1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle

       Do is=1, ndim_spinor
          Do ib=1, neg
             neordr( ib,ik+is-1 ) = neordr( ib,ik )
!!!             write(*,*) 'ik, ib ordr : ', ik, ib, neordr( ib,ik )
          End do
       End do
    End do
! --------------------------- unknown
    Do ik=1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle

       Do is=1, ndim_spinor
          Do ib=1, neg
              nrvf_ordr( ib,ik+is-1 ) =  nrvf_ordr( ib,ik )
          End do
       End do
    End do
! ---------------------    

    deallocate(eko_t)
!!$#ifdef TRANSPOSE
    deallocate(eko_t2)
!!$#else
!!$    if(nrank_e > 1) deallocate(eko_t2)  ! MPI
!!$#endif
!!$    call mpi_barrier(mpi_comm_group,ierr)
    call tstatc0_end(id_sname)

  contains

    subroutine dummy
    end subroutine dummy

#ifndef _NO_HEAP_SORT_EIGENVALUES_
    subroutine heap_sorting(n,eig,iord)
      integer, intent(in) :: n
      real(kind=DP), intent(inout) :: eig(n)
      integer, intent(inout) :: iord(n)

      integer :: i,j,k,itmp,it
      real(kind=DP) :: rt

      !*** initialization: heapfy eig and iord ***
      do i=2,n
         rt = eig(i)
         it = iord(i)
         j=i
10       itmp=j/2
         if(eig(itmp).ge.rt) go to 20
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         if(j.gt.1) go to 10
20       eig(j) = rt
         iord(j) = it
      end do
      !*** to be fully sort ***
      do k=n-1,1,-1
         rt = eig(1)
         eig(1) = eig(k+1)
         eig(k+1) = rt
         rt = eig(1)
         it = iord(1)
         iord(1) = iord(k+1)
         iord(k+1) = it
         it = iord(1)
         j=1
         itmp=2
30       if(itmp.gt.k) go to 40
         if(itmp.lt.k) then
            if(eig(itmp+1).gt.eig(itmp)) itmp=itmp+1
         end if
         if(rt.ge.eig(itmp)) go to 40
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         itmp=j*2
         go to 30
40       eig(j) = rt
         iord(j) = it
      end do
    end subroutine heap_sorting
#endif
  end subroutine m_ES_sort_eigen_vals_noncl
! ========================================================================= 11.0

  subroutine m_ES_energy_eigen_values(nfout,sort)
    integer, intent(in) :: nfout
    logical, intent(in), optional :: sort

    integer             :: is, ik, ipri0
!!$    real(kind=DP), pointer, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: ekin
    logical :: sor

    sor = .true.
    if(present(sort)) sor=sort
    allocate(afft(nfft)); allocate(bfft(nfft))
!!$    allocate(sc(kg1))
!!$    ekin => sc(1:kg1)
    allocate(ekin(kg1))
    call m_FFT_alloc_WF_work()

    do is = 1, nspin, af+1
       call m_ES_Vlocal_in_Rspace(is,afft)                  ! (ptfft1)
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle                   ! MPI
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
          call m_ES_eigen_values_for_each_k(is,ik,ekin,afft)
       end do
    end do
    if(sor) call m_ES_sort_eigen_values()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate(afft); deallocate(bfft)
!!$    deallocate(sc)
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_values

! =============================== added by K. Tagami ================ 11.0
  subroutine m_ES_energy_eigen_vals_noncl(nfout)
    integer, intent(in) :: nfout
    integer             :: ipri0
    integer :: ik

    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    allocate(ekin(kg1))
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn
    call m_FFT_alloc_WF_work()

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )   ! vlhxc_ss -> afft_kt

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle                   ! MPI
       call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
       call m_ES_eigen_vals_each_k_noncl( ik,ekin,afft_kt, bfft_kt )
    End do

    call m_ES_sort_eigen_vals_noncl()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate( afft_kt, bfft_kt )
    deallocate( ekin)

    call m_FFT_dealloc_WF_work()

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_vals_noncl
! ========================================================================= 11.0

  subroutine m_ES_energy_eigen_values_ext(nfout)
    integer, intent(in) :: nfout

    integer             :: is, ik, ipri0
!!$    real(kind=DP), pointer, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: ekin

    allocate(afft(nfft)); allocate(bfft(nfft))
!!$    allocate(sc(kg1))
!!$    ekin => sc(1:kg1)
    allocate(ekin(kg1))
    call m_FFT_alloc_WF_work()

    do is = 1, nspin, af+1
       call m_ES_Vlocal_in_Rspace(is,afft)                  ! (ptfft1)
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle                   ! MPI
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin)

          if(ipri >= 3) then
             write(nfout,'(" -- ekin <<m_ES_eigen_values_ext>> -- ik = ",i8)') ik
             write(nfout,'(8f8.4)') (ekin(ipri0),ipri0=1,iba(ik))
          end if

          call m_ES_eigen_values_for_each_kex(nfout,is,ik,ekin,afft)
       end do
    end do
    call m_ES_sort_eigen_values()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko2(nfout,mode=SCF)

    deallocate(afft); deallocate(bfft)
!!$    deallocate(sc)
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_values_ext

! ==================================== added by K. Tagami ============== 11.0
  subroutine m_ES_energy_eigenvals_ext_noncl(nfout)
    integer, intent(in) :: nfout
    integer             :: ipri0
    integer :: ik

    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    allocate(ekin(kg1))
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn
    call m_FFT_alloc_WF_work()

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle                   ! MPI
       call m_pwBS_kinetic_energies(ik,vkxyz,ekin)

       if(ipri >= 3) then
          write(nfout,'(" -- ekin <<m_ES_eigen_values_ext>> -- ik = ",i8)') ik
          write(nfout,'(8f8.4)') (ekin(ipri0),ipri0=1,iba(ik))
       end if

       call m_ES_eigen_vals_each_kex_noncl( nfout, ik, ekin, afft_kt, bfft_kt )
    End do

    call m_ES_sort_eigen_vals_noncl()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko2(nfout,mode=SCF)

    deallocate( afft_kt, bfft_kt )
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigenvals_ext_noncl
! ========================================================================== 11.0

  subroutine m_ES_eigen_values_for_each_k(is,ik,ekin,afft)
    integer,       intent(in)                  :: is,ik    ! is: spin
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: afft
#ifdef NEC_TUNE_SMP
    real(kind=DP), dimension(nfft) :: bfft
#endif

    integer       :: ib
    real(kind=DP) :: eg
    integer       :: id_sname = -1
!!$    write(nfout,'(" --- energy_eigen_vlues ---")')
    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_T_W()                     ! (eigen1) --> eko_l , kinetic part

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,eg)
#endif
    do ib = ista_e, iend_e, istep_e  ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft) ! -(m_E.S.); (swffft)
       call m_FFT_W_Vlocal_W(ELECTRON,nfft,afft,bfft,eg) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before W_Vnonlocal_W <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_Vnonlocal_W(ik)

    call tstatc0_end(id_sname)
  contains
    subroutine W_T_W()
      integer :: ib, i
      real(kind=DP) :: eko

      if(sw_hybrid_functional == OFF) eko_l(1:np_e,ik) = 0.d0                   ! MPI
      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            eko = 0.d0
            do i = 1, iba(ik)
               !eko_l(ib,ik) = eko_l(ib,ik) + ekin(i)*zaj_l(i,ib,ik,1)**2
               eko = eko + ekin(i)*zaj_l(i,ib,ik,1)**2
            end do
            if(k_symmetry(ik) == GAMMA) eko = 2.d0*eko
            eko_l(ib,ik) = eko_l(ib,ik) + eko
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            eko = 0.d0
            do i = 1, iba(ik)
               !eko_l(ib,ik) = eko_l(ib,ik) + ekin(i)*(zaj_l(i,ib,ik,1)**2+zaj_l(i,ib,ik,2)**2)
               eko = eko + ekin(i)*(zaj_l(i,ib,ik,1)**2+zaj_l(i,ib,ik,2)**2)
            end do
            if(k_symmetry(ik) == GAMMA) eko = 2.d0*eko
            eko_l(ib,ik) = eko_l(ib,ik) + eko
         end do
      end if

      if(ipri >= 2) then
         write(6,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W

    subroutine W_Vnonlocal_W(ik)
      integer, intent(in) :: ik

      integer       :: ia, lmt1, lmt2, it, p, q, ib
      real(kind=DP) :: fac

      integer :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W ',id_sname)

      do ia = 1, natm
         it = ityp(ia)
         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)
            if(k_symmetry(ik) == GAMMA) then
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac = iwei(ia)
!!$                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  if(ipaw(it).eq.0) then
                     fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  else
                     fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
                  end if
                  do ib = 1, np_e                                  ! MPI
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik))
                  end do
               end do
            else
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac = iwei(ia)
!!$                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  if(ipaw(it).eq.0) then
                     fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  else
                     fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
                  end if
                  do ib = 1, np_e                                  ! MPI
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik)&
                          &      + fsi_l(ib,p,ik)*fsi_l(ib,q,ik))
                  end do
               end do
            end if
         end do
      end do
      if(ipri >= 2) then
         write(6,'(" -- eko_l <<W_Vnonlocal_W>> --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W
  end subroutine m_ES_eigen_values_for_each_k

! ============================= added by K. Tagami ======================= 11.0
  subroutine m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )
    integer,       intent(in)                  :: ik
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in)  :: afft_kt( nfft,ndim_chgpot )
!
    real(kind=DP), intent(inout)  :: bfft_kt( nfft,ndim_spinor )

    integer       :: ib, is
    real(kind=DP) :: eg
    integer       :: id_sname = -1
!!$    write(nfout,'(" --- energy_eigen_vlues ---")')

    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before <<m_ES_eigen_vals_each_k_noncl>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_T_W_noncl()                     ! (eigen1) --> eko_l , kinetic part

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,eg)
#endif
    do ib = ista_e, iend_e, istep_e  ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik +is -1  , ib, bfft_kt(1:nfft,is) ) 
       End do

       call m_FFT_W_Vlocal_W_noncl( ELECTRON, nfft, afft_kt, bfft_kt, eg, &
	&                           ndim_spinor, ndim_chgpot ) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI

    end do

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before W_Vnonlocal_W <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif


!    write(938,*) iwei
!    write(940,*) fsr_l
!    write(942,*) dion_Scr_noncl
!    stop

    call W_Vnonlocal_W_noncl_A(ik)

!    stop

    call tstatc0_end(id_sname)

  contains

    subroutine W_T_W_noncl()
      integer :: ib, i, is
      real(kind=DP) :: ctmp, meko

      if(sw_hybrid_functional == OFF) eko_l(1:np_e,ik) = 0.d0           ! MPI
      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            meko = 0.0d0
            do i = 1, iba(ik)
	       ctmp = 0.0d0
               Do is=1, ndim_spinor
                  ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2
               End do
               meko = meko + ekin(i) *ctmp
!!!!!               eko_l(ib,ik) = eko_l(ib,ik) + ekin(i) *ctmp
            end do
!!!!            if(k_symmetry(ik) == GAMMA) eko_l(ib,ik) = 2.d0*eko_l(ib,ik)

            if ( k_symmetry(ik) == GAMMA ) meko = 2.0d0 *meko
            eko_l(ib,ik) = eko_l(ib,ik) + meko

         end do

      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            meko = 0.0d0
            do i = 1, iba(ik)
	       ctmp = 0.0d0
               Do is=1, ndim_spinor
                  ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2 &
	&                     + zaj_l( i, ib, ik +is-1, 2 )**2
	       End do
!!               eko_l(ib,ik) = eko_l(ib,ik) + ekin(i) *ctmp
               meko = meko + ekin(i) *ctmp
            end do
!!            if(k_symmetry(ik) == GAMMA) eko_l(ib,ik) = 2.d0*eko_l(ib,ik)

            if ( k_symmetry(ik) == GAMMA ) meko = 2.0d0 *meko
            eko_l(ib,ik) = eko_l(ib,ik) + meko

         end do
      end if

      if(ipri >= 2) then
         write(6,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W_noncl

    subroutine W_Vnonlocal_W_noncl_A(ik)
      integer, intent(in) :: ik

      integer :: ia, lmt1, lmt2, it, p, q, ib
      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: k1, k2
      integer :: mdvdb

      real(kind=DP) :: c1, c2, fac0
      complex(kind=CMPLDP) :: fac

      real*8 csum_1, csum_2

      integer :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W_noncl ',id_sname)

!      write(960,*) 'FF'
!      write(960,*) dion_scr_noncl

      csum_1 = 0.0d0;       csum_2 = 0.0d0

      do ia = 1, natm
         it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
         mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)

            il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

            if(k_symmetry(ik) == GAMMA) then
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac0   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac0 = iwei(ia)

                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        is_tmp = ndim_spinor*( is1 -1 ) +is2
                        fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

                        k1 = ik + is1 - 1
                        k2 = ik + is2 - 1

                        Do ib = 1, np_e                                  ! MPI
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + fac*(fsr_l(ib,p,k1)*fsr_l(ib,q,k2) )
                        End do
                     End do
                  End do
               End do
            else
! ----------------------------------- Which is better ? --------
!!!!!               Do lmt2 = lmt1, ilmt(it)
               Do lmt2 = 1, ilmt(it)
                  q = lmta(lmt2,ia)

                  il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)


! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                  if ( mdvdb == SKIP ) then
                     if ( il1 /= il2 ) cycle
                     if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                        if ( im1 /= im2 ) cycle
                     endif
                  endif
#endif
! ---------------------------------------------------- 11.0S

!                  fac   = 2.d0 * iwei(ia)
!                  if(lmt1 == lmt2) fac = iwei(ia)

                  fac0 = iwei(ia)

                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        is_tmp = ndim_spinor *( is1 -1 ) +is2
                        fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

!                        write(950,*) lmt1, lmt2, is_tmp, ia, fac, dion( lmt1, lmt2, it )

                        k1 = ik + is1 - 1
                        k2 = ik + is2 - 1

                        Do ib = 1, np_e                                  ! MPI
                           c1 =  real(fac) *( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) &
                                &            +fsi_l(ib,p,k1)*fsi_l(ib,q,k2) )
#if 1
! -- orig -
                           c2 = -aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
	&                                     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
#else
! -- kt : debug --
!                           c2 = aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
!                                &            -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
!--
#endif
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + c1 + c2
                        End do
                     End Do
                  End Do
               end do
            end if

         end do
      end do

      if(ipri >= 2) then
         write(6,'(" -- eko_l <<W_Vnonlocal_W_noncl A *>> --, ik = ",i3)') ik
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W_noncl_A

  end subroutine m_ES_eigen_vals_each_k_noncl
! ==================================================================== 11.0

  subroutine m_ES_eigen_values_for_each_kex(nfout,is,ik,ekin,afft)
    integer,       intent(in)                  :: nfout,is,ik    ! is: spin
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: afft

    integer       :: ib
    real(kind=DP) :: eg
    integer,save  :: id_sname = -1
    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    call W_T_W()                     ! (eigen1) --> eko_l , kinetic part
    do ib = ista_e, iend_e, istep_e  ! MPI
       if(nrvf_ordr(ib,ik) <= neg_previous) cycle
       call m_ES_WF_in_Rspace(ik,ib,bfft) ! -(m_E.S.); (swffft)
       call m_FFT_W_Vlocal_W(ELECTRON,nfft,afft,bfft,eg) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    call W_Vnonlocal_W(ik)

    call tstatc0_end(id_sname)
  contains
    subroutine W_T_W()
      integer :: ib, i, ip, ibt

!!$      eko_l(1:np_e,ik) = 0.d0                   ! MPI
      do ib = neg_previous+1, neg
         ip = neordr(ib,ik)
         if(map_e(ip) == myrank_e) eko_l(map_z(ip),ik) = 0.d0
      end do

      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = neg_previous+1, neg                   ! MPI
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i)*zaj_l(i,ibt,ik,1)**2
               end do
               if(k_symmetry(ik) == GAMMA) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
!!$         do ib = 1, np_e                        ! MPI
         do ib = neg_previous+1, neg
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i)*(zaj_l(i,ibt,ik,1)**2+zaj_l(i,ibt,ik,2)**2)
               end do
               if(k_symmetry(ik) == GAMMA) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      end if

      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W

    subroutine W_Vnonlocal_W(ik)
      integer, intent(in) :: ik

      integer       :: ia, lmt1, lmt2, it, p, q, ib, ibo
      real(kind=DP) :: fac

      integer,save :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W ',id_sname)

      do ia = 1, natm
         it = ityp(ia)
         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)
            do lmt2 = lmt1, ilmt(it)
               q = lmta(lmt2,ia)
               fac   = 2.d0 * iwei(ia)
               if(lmt1 == lmt2) fac = iwei(ia)
!!$               fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
               if(ipaw(it).eq.0) then
                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
               else
                  fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
               end if
               if(k_symmetry(ik) == GAMMA) then
                  do ib = 1, np_e                                  ! MPI
                     ibo = ista_e + ista_e*(ib-1)
                     if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                     eko_l(ib,ik) = eko_l(ib,ik) &
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik))
                  end do
               else
                  do ib = 1, np_e                                  ! MPI
                     ibo = ista_e + ista_e*(ib-1)
                     if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik)&
                          &      + fsi_l(ib,p,ik)*fsi_l(ib,q,ik))
                  end do
               end if
            end do
         end do
      end do
      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_Vnonlocal_W) --, ik = ",i3)') ik 
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W
  end subroutine m_ES_eigen_values_for_each_kex

!================================ added by K. Tagami ==================== 11.0
  subroutine m_ES_eigen_vals_each_kex_noncl( nfout,ik,ekin,afft_kt, bfft_kt )
    integer,       intent(in)                  :: nfout, ik
    real(kind=DP), intent(in), dimension(kg1) :: ekin

    real(kind=DP), intent(in)  :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(inout)  :: bfft_kt( nfft,ndim_spinor )

    integer       :: ib, is
    real(kind=DP) :: eg
    integer,save  :: id_sname = -1

    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    call W_T_W_noncl()                     ! (eigen1) --> eko_l , kinetic part

    do ib = ista_e, iend_e, istep_e  ! MPI
       if(nrvf_ordr(ib,ik) <= neg_previous) cycle

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik +is-1, ib, bfft_kt(:,is) )    
       End do

       call m_FFT_W_Vlocal_W_noncl( ELECTRON,nfft,afft_kt,bfft_kt,eg, &
            &                       ndim_spinor, ndim_chgpot )  ! (eigens) --> eg

       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    call W_Vnonlocal_W_noncl_A(ik)

    call tstatc0_end(id_sname)
  contains

    subroutine W_T_W_noncl()
      integer :: ib, i, ip, ibt, is
      real(kind=DP) :: ctmp

!!$      eko_l(1:np_e,ik) = 0.d0                   ! MPI
      do ib = neg_previous+1, neg
         ip = neordr(ib,ik)
         if(map_e(ip) == myrank_e) eko_l(map_z(ip),ik) = 0.d0
      end do

      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = neg_previous+1, neg                   ! MPI
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
	          ctmp = 0.0d0
         	  Do is=1, ndim_spinor
	            ctmp = ctmp + zaj_l( i, ibt, ik +is-1, 1 )**2
	          End do
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i) *ctmp
               end do
               if ( k_symmetry(ik)==GAMMA ) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
!!$         do ib = 1, np_e                        ! MPI
         do ib = neg_previous+1, neg
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
	          ctmp = 0.0d0
	          Do is=1, ndim_spinor
                    ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2 &
	&                       + zaj_l( i, ib, ik +is-1, 2 )**2
	          End do
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i) *ctmp
               end do
               if ( k_symmetry(ik)==GAMMA ) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      end if

      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_T_W_noncl) --, ik = ",i3)') ik
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W_noncl

    subroutine W_Vnonlocal_W_noncl_A(ik)
      integer, intent(in) :: ik

      integer :: ia, lmt1, lmt2, it, p, q, ib, ibo
      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: k1, k2
      integer :: mdvdb

      real(kind=DP) :: c1, c2, fac0
      complex(kind=CMPLDP) :: fac

      integer,save :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W_noncl ',id_sname)

!      write(960,*) 'FF'
!      write(960,*) dion_scr_noncl

      do ia = 1, natm
         it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
         mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)

            il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)

!!!!!!            do lmt2 = lmt1, ilmt(it)
            do lmt2 = 1, ilmt(it)
               q = lmta(lmt2,ia)

               il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
               if ( mdvdb == SKIP ) then
                  if ( il1 /= il2 ) cycle
                  if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                     if ( im1 /= im2 ) cycle
                  endif
               endif
#endif
! ---------------------------------------------------- 11.0S

!               fac0   = 2.d0 * iwei(ia)
!               if(lmt1 == lmt2) fac0 = iwei(ia)

               fac0   = iwei(ia)

               Do is1=1, ndim_spinor
                  Do is2=1, ndim_spinor
                     is_tmp = ndim_spinor*( is1 -1 ) +is2
                     fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

                     k1 = ik + is1 - 1
                     k2 = ik + is2 - 1

                     if ( k_symmetry(ik) == GAMMA ) then
                        do ib = 1, np_e                                  ! MPI
                           ibo = ista_e + ista_e*(ib-1)
                           if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + fac*( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) )
                        end do
                     else
                        do ib = 1, np_e                                  ! MPI
                           ibo = ista_e + ista_e*(ib-1)
                           if(nrvf_ordr(ibo,ik) <= neg_previous) cycle

                           c1 =  real(fac) *( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) &
                                &            +fsi_l(ib,p,k1)*fsi_l(ib,q,k2) )
#if 1
! ----------- orig --
                           c2 = -aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
                                &	     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
#else
! --- kt :debug --
!                           c2 = aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
!                                &	     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
! ---
#endif
                           eko_l(ib,ik) = eko_l(ib,ik) + c1 +c2

                        end do
                     end if
                  End Do      ! is2
               End do       !is1

            end do
         end do
      end do
      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_Vnonlocal_W_noncl :) --, ik = ",i3)') ik
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W_noncl_A

  end subroutine m_ES_eigen_vals_each_kex_noncl
! ========================================================= 11.0

  subroutine m_ES_Vlocal_in_Rspace(is,afft)
    integer, intent(in) :: is
    real(kind=DP), dimension(nfft) :: afft
    integer,save                   :: id_sname = -1
!!$    call tstatc0_begin('m_ES_Vlocal_in_Rspace ', id_sname,1)
    call tstatc0_begin('m_ES_Vlocal_in_Rspace ', id_sname)

    call map_vlhxc_l_onto_afft(is)      !-(contained here) vlhxc_l  --> afft ;using (igf)
    call m_FFT_WF(ELECTRON,nfout,afft,INVERSE,OFF) ! afft -> afft

    call tstatc0_end(id_sname)
  contains
    subroutine map_vlhxc_l_onto_afft(is)
      integer, intent(in) :: is
      integer :: i,i1,ri
      integer :: iend
      real(kind=DP), pointer, dimension(:) :: afft_mpi
      if(npes > 1) allocate(afft_mpi(nfft))

      afft = 0.d0
      iend = iend_kngp
      if( iend > kg ) iend = kg
      do ri = 1, kimg
         do i = ista_kngp, iend  !for mpi
            i1 = kimg*igf(i) + (ri - kimg)
            afft(i1) = vlhxc_l(i,ri,is)
         end do
      end do

      if(npes > 1) then
         call mpi_allreduce(afft,afft_mpi,nfft &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         afft = afft_mpi
         deallocate(afft_mpi)
      end if

    end subroutine map_vlhxc_l_onto_afft
  end subroutine m_ES_Vlocal_in_Rspace

! ==================================== added by K. Tagami ================== 11.0
  subroutine m_ES_Vlocal_in_Rspace_noncl( afft_kt )
    real(kind=DP), intent(out) :: afft_kt( nfft, ndim_chgpot )

    integer :: is
    integer,save                   :: id_sname = -1
!!$    call tstatc0_begin('m_ES_Vlocal_in_Rspace_noncl ', id_sname,1)
    call tstatc0_begin('m_ES_Vlocal_in_Rspace_noncl ', id_sname)

    allocate( vlhxc_ssrep( ista_kngp:iend_kngp,kimg,ndim_chgpot) )
    vlhxc_ssrep = 0.0d0

    call m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )

    afft_kt = 0.d0
    Do is=1, ndim_chgpot
      call map_vlhxc_ss_onto_afft(is)  
                    !-(contained here) vlhxc_l  --> afft ;using (igf)
      call m_FFT_WF( ELECTRON, nfout, afft_kt(:,is), INVERSE, OFF ) ! afft -> afft
    End do

    deallocate( vlhxc_ssrep )
    call tstatc0_end(id_sname)

  contains

    subroutine map_vlhxc_ss_onto_afft(is)
      integer, intent(in) :: is
      integer :: i,i1,ri
      integer :: iend
      real(kind=DP), allocatable, dimension(:) :: afft_mpi

      if(npes > 1) allocate(afft_mpi(nfft))

      iend = iend_kngp
      if( iend > kg ) iend = kg
      do ri = 1, kimg
         do i = ista_kngp, iend  !for mpi
            i1 = kimg*igf(i) + (ri - kimg)
            afft_kt(i1,is) = vlhxc_ssrep(i,ri,is)
         end do
      end do

      if(npes > 1) then
         call mpi_allreduce( afft_kt(:,is), afft_mpi,nfft &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         afft_kt(:,is) = afft_mpi(:)
         deallocate(afft_mpi)
      end if

    end subroutine map_vlhxc_ss_onto_afft

  end subroutine m_ES_Vlocal_in_Rspace_noncl
! ========================================================================= 11.0


  subroutine m_ES_WF_in_Rspace_kt(k1,k2,ik,psi_l,bfft)
    integer, intent(in) :: k1,k2,ik
    real(kind=DP), intent(in),dimension(kg1,1,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = psi_l(1,1,ik,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = psi_l(ii,1,ik,1)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) =   psi_l(ii,1,ik,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf(1) - 1
          bfft(i1)   = psi_l(1,1,ik,1)
          bfft(i1+1) = psi_l(1,1,ik,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = psi_l(ii,1,ik,1)
             bfft(i1+1) = psi_l(ii,1,ik,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = psi_l(ii,1,ik,1)
             bfft(i2+1) = -psi_l(ii,1,ik,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,1,ik,ri)   ! MPI
          end do
       end do
    end if

    call m_FFT_WF(ELECTRON,nfout,bfft,INVERSE,ON)

  end subroutine m_ES_WF_in_Rspace_kt

  subroutine m_ES_WF_in_Rspace1(k1,k2,ik,ib,psi_l,bfft)
    integer, intent(in) :: k1,k2,ik,ib
    real(kind=DP), intent(in),dimension(kg1,np_e,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii
#ifndef NEC_TUNE_SMP
    integer,save  :: id_sname = -1
#ifdef SAVE_FFT_TIMES
    integer,save :: id_sname2 = -1
#endif
#endif

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON .and. status_saved_phifftr(map_z(ib),ik) == STORED_AND_NEW) then
#ifndef NEC_TUNE_SMP
       call tstatc0_begin('m_ES_WF_in_Rspace(2) ',id_sname2,1)
#endif
       if(ipri>=2 .and. ik==1 .and. ib==1) write(nfout,'(" !### zaj_fftr(stored) --> bfft")')
       bfft(:) = Phifftr_l(:,map_z(ib),ik)
#ifndef NEC_TUNE_SMP
       call tstatc0_end(id_sname2)
#endif
    else
#endif

#ifndef NEC_TUNE_SMP
       call tstatc0_begin('m_ES_WF_in_Rspace(1) ',id_sname,1)
#endif

    if(ipri>=2 .and. ik==1 .and. ib==1) write(nfout,'(" !### zaj_l --(FFT)--> bfft")')

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = psi_l(1,map_z(ib),ik,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = psi_l(ii,map_z(ib),ik,1)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) =   psi_l(ii,map_z(ib),ik,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf(1) - 1
          bfft(i1)   = psi_l(1,map_z(ib),ik,1)
          bfft(i1+1) = psi_l(1,map_z(ib),ik,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = psi_l(ii,map_z(ib),ik,1)
             bfft(i1+1) = psi_l(ii,map_z(ib),ik,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = psi_l(ii,map_z(ib),ik,1)
             bfft(i2+1) = -psi_l(ii,map_z(ib),ik,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,map_z(ib),ik,ri)   ! MPI
          end do
       end do
    end if
    if(ipri >= 2) then
       if(ik <= 2 .and. ib <= 3) then
          write(6,'(" ! bfft G-space ik = ",i3," ib = ",i3," <<m_ES_WF_in_Rspace>>")') ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if
    call m_FFT_WF(ELECTRON,nfout,bfft,INVERSE,ON)
    if(ipri >= 2) then
       if(ik <=  2 .and. ib <= 3) then
          write(6,'(" ! bfft R-space ik = ",i3," ib = ",i3," <<m_ES_WF_in_Rspace>>")') ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       Phifftr_l(:,map_z(ib),ik) = bfft(:)
       status_saved_phifftr(map_z(ib),ik) = STORED_AND_NEW
    end if
#endif
#ifndef NEC_TUNE_SMP
    call tstatc0_end(id_sname)
#endif
#ifdef SAVE_FFT_TIMES
    end if
#endif

  end subroutine m_ES_WF_in_Rspace1

  subroutine m_ES_WF_in_Rspace0(ik,ib,bfft)
    integer, intent(in)                           :: ik, ib
    real(kind=DP), intent(inout), dimension(nfft) :: bfft
    call m_ES_WF_in_Rspace1(ista_k,iend_k,ik,ib,zaj_l,bfft)
  end subroutine m_ES_WF_in_Rspace0

!!$  integer function cachesize(level)
!!$    integer, intent(in) :: level
!!$    if(level == 1) then
!!$       cachesize = 64
!!$    else if(level == 2) then
!!$       cachesize = 512
!!$    else if(level == 3) then
!!$       cachesize = 1024
!!$    else
!!$       cachesize = 100000
!!$    end if
!!$  end function cachesize

  subroutine m_ES_wd_zaj_small_portion0(str,nc)
    integer, intent(in) :: nc
    character(len=nc), intent(in) :: str

    integer :: ik
    do ik = ista_k, iend_k, af+1                            ! MPI
       if(ipri>=1) call m_ES_wd_zaj_small_portion(nfout,ik,str,nc)
    end do
  end subroutine m_ES_wd_zaj_small_portion0

  subroutine m_ES_wd_eko(nfout,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    if(printable) write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0
! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ===================================================================== 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          if(printable) write(nfout,'(" ik = ",i7," ( ",3f10.6," )",/99(4f18.10,/))')&
               &ik+ikp,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg-num_extra_bands)
!!$          write(nfout,'(" ik = ",i4,99(4f18.10,/))')&
!!$               &ik,(eko(neordr(ib,ik)),ib=1,neg)
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          if(printable) write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(10f8.4,/))')&
               & ik,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg)
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko

  subroutine m_ES_wd_eko_cond(nfout,ibcm,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode, ibcm
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(ibcm > neg) return

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0
! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ======================================================================= 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          if(iprieigenvalue >= 1) then
             write(nfout,'(" ik = ",i7," ( ",3f10.6," ) [conduction bands]" &
                  & ,/99(4f18.10,/))') ik+ikp,vkxyz(ik,1:3,BUCS) &
                  & , (eko(neordr(ib,ik)),ib=ibcm,neg-num_extra_bands)
          end if
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          if(iprieigenvalue >= 2) then
             write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(10f8.4,/))')&
                  &ik,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=ibcm,neg)
          end if
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko_cond

  subroutine m_ES_wd_eko2(nfout,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0

! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ======================================================================= 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          write(nfout,'(" ik = ",i7," ( ",3f10.6," )",/99(4f18.10,/))')&
               &ik+ikp,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg-num_extra_bands)
!!$          write(nfout,'(" ik = ",i4,99(4f18.10,/))')&
!!$               &ik,(eko(neordr(ib,ik)),ib=1,neg)
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4d20.8,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(5f20.8,/))')&
               &ik,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg)
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko2

  subroutine m_ES_sum_of_LocalPart(ik,ibo,bpr_l,bpi_l,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi_l(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart

!!$  subroutine m_ES_sum_of_LocalPart(ik,ibo,bpr_l,bpi_l,dz)
!!$    integer, intent(in)                                 :: ik,ibo
!!$    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
!!$    real(kind=DP),intent(out)                           :: dz
!!$
!!$    integer  :: ib, ia, p, q
!!$
!!$    ib = map_z(ibo)
!!$    dz = 0.d0
!!$    do ia = 1, nac
!!$       p = nlmta1(ia); q = nlmta2(ia)
!!$       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi_l(ib,q,ik))
!!$    end do
!!$  end subroutine m_ES_sum_of_LocalPart

! =============================== added by K. Tagami ================= 11.0
  subroutine m_ES_sum_of_LocalPart_noncl( ik,ibo,kst, ken, bpr_l,bpi_l,dz)
    integer, intent(in)  :: ik,ibo
    integer, intent(in)  :: kst, ken
    real(kind=DP), intent(in) :: bpr_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_l(np_e,nlmta,kst:ken)
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q
    integer :: is1, is2, is_tmp, k1, k2
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr_l(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi_l(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi_l(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr_l(ib,q,k2))

             dz = dz + c1 + c2

          End do
       End Do
    end do
  end subroutine m_ES_sum_of_LocalPart_noncl
! ================================================================ 11.0


  subroutine m_ES_sum_of_LocalPart2(ik,ibo,bpr_l,bpi_l,bpr_np,bpi_np,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l,bpr_np,bpi_np !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_np(ib,q,ik) + bpi_l(ib,p,ik)*bpi_np(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart2

! ============================== added by K. Tagami ======================== 11.0
  subroutine m_ES_sum_of_LocalPart2_noncl( ik, ibo, kst, ken, &
       &                                   bpr_l, bpi_l, &
       &                                   bpr_np, bpi_np, dz )
    integer, intent(in)       :: ik,ibo
    integer, intent(in)       :: kst, ken
    real(kind=DP), intent(in) :: bpr_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpr_np(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_np(np_e,nlmta,kst:ken)

    real(kind=DP),intent(out)      :: dz

    integer  :: ib, ia, p, q
    integer :: k1, k2
    integer :: is1, is2, is_tmp
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr_np(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi_np(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi_np(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr_np(ib,q,k2))

             dz = dz + c1 + c2
          Enddo
       End do
    end do
  end subroutine m_ES_sum_of_LocalPart2_noncl
! ==================================================================== 11.0

  subroutine m_ES_sum_of_LocalPart3(ik,ibo,bpr_l,bpi_l,bpr1_l,bpi1_l,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(in),dimension(np_e,nlmta,ista_k:iend_k):: bpr1_l,bpi1_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr1_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi1_l(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart3

! ============================== added by K. Tagami ======================== 11.0
  subroutine m_ES_sum_of_LocalPart3_noncl( ik, ibo, kst, ken, &
       &                                   bpr_l, bpi_l, &
       &                                   bpr1_l, bpi1_l, dz )
    integer, intent(in) :: ik,ibo
    integer, intent(in) :: kst, ken
    real(kind=DP),intent(in),dimension(np_e,nlmta,kst:ken):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(in),dimension(np_e,nlmta,ista_k:iend_k):: bpr1_l,bpi1_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q
    integer :: k1, k2
    integer :: is1, is2, is_tmp
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr1_l(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi1_l(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi1_l(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr1_l(ib,q,k2))

             dz = dz + c1 + c2
          Enddo
       End do
    end do    
  end subroutine m_ES_sum_of_LocalPart3_noncl
! =========================================================================== 11.0

  subroutine m_ES_cpeko()
    eko1_l = eko_l
  end subroutine m_ES_cpeko

  logical function m_ES_eekdif()
    integer       :: ik, ib
    real(kind=DP) :: fac, tmp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(ekmode == ON .and. evaluation_eko_diff == OFF) then
       m_ES_eekdif = .false.
       return
    end if

    evdff = 0.d0; evdffr = 0.d0

! =================================== modified by K. Tagami ============ 11.0
!!    fac = 1.d0/dble(kv3*neg)
!
    if ( noncol ) then
      fac = 1.0d0 / dble( kv3/ndim_spinor *neg )
    else
      fac = 1.d0/dble(kv3*neg)
    endif
! ====================================================================== 11.0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff(1) = evdff(1) + tmp*tmp
          evdff(2) = evdff(2) + dabs(tmp)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff(3) = evdff(3) + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff,evdffr,3 &
         & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       evdff = evdffr
    end if

!!$    if(iprievdff >= 2) write(6,'(" ! evdff = ",3d16.8)') evdff(1:3)
    evdff(1) = dsqrt(fac*evdff(1))*(af+1)
    evdff(2) = fac*evdff(2)*(af+1)
    evdff(3) = fac*evdff(3)*(af+1)

    eko1_l = eko_l

    if(iprievdff >= 1) &
         & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
         &    iteration_electronic, evdff(1), evdff(2), evdff(3)

    if(max(evdff(1),evdff(2)) < delta_eigenvalue) then
       ib = m_CtrlP_ntcnvg_incre()
       if(printable) then
          write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_electronic, ib
          if(iprievdff < 1) &
               & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
               &    iteration_electronic, evdff(1), evdff(2), evdff(3)
       end if
    else
       call m_CtrlP_ntcnvg_reset()    ! K.Mae 030808 
    end if
    m_ES_eekdif = m_CtrlP_ntcnvg_clear()

  end function m_ES_eekdif

  logical function m_ES_eekdif2()
    integer       :: ik, ib, it, kv3_e
    real(kind=DP), allocatable, dimension(:,:) :: evdff2, evdffr2 ! d(3,kv3)
    integer, allocatable, dimension(:)         :: iconv           ! d(kv3)
    real(kind=DP) :: fac, tmp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(evaluation_eko_diff == OFF) then
       m_ES_eekdif2 = .false.
       return
    end if

    allocate(evdff2(3,kv3));  evdff2  = 0.d0
    allocate(evdffr2(3,kv3)); evdffr2 = 0.d0
    allocate(iconv(kv3)); iconv = 0

    fac = 1.d0/dble(neg)

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff2(1,ik) = evdff2(1,ik) + tmp*tmp
          evdff2(2,ik) = evdff2(2,ik) + dabs(tmp)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff2(3,ik) = evdff2(3,ik)  &
                  & + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff2,evdffr2,3*kv3 &
            & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       evdff2 = evdffr2
    end if

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       evdff2(1,ik) = dsqrt(fac*evdff2(1,ik))*(af+1)
       evdff2(2,ik) = fac*evdff2(2,ik)*(af+1)
       evdff2(3,ik) = fac*evdff2(3,ik)*(af+1)
    end do

    eko1_l = eko_l

    if(iprievdff >= 1) then
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
          write(nfout,'(" >> (",i6,") <eko_old-eko_new>(ik=",i6,") :(",3d13.5 &
               & ,")")') iteration_electronic,ik &
               & ,evdff2(1,ik),evdff2(2,ik),evdff2(3,ik)
       end do
    end if

    it = 0
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(max(evdff2(1,ik),evdff2(2,ik)) < delta_eigenvalue) then
          iconv(ik) = EK_CONVERGED
       else
          it = it + 1
       end if
    end do
! === DEBUG for icond=2,3 & one_by_one by tkato 2014/01/24 =====================
    if(first_kpoint_in_this_job == 0) then
       kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    else
       kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1)-first_kpoint_in_this_job+1)
    end if
! ==============================================================================
    if(iprievdff >= 2) then
       write(nfout,'(" ! -- iconv_ek(before) -- <<m_ES_eekdif2>>")')
       write(nfout,'(" ! ",10i8)') iconv_ek(1:kv3_ek)
    end if
    do ik = 1, kv3_e
       if(iconv_ek(nk_in_the_process+ik-1) /= EK_CONVERGED) then
          iconv_ek(nk_in_the_process+ik-1) = iconv(ik)
       end if
    end do
!!$    iconv_ek(nk_in_the_process:nk_in_the_process+kv3_e-1) = iconv(1:kv3_e)
    if(iprievdff >= 2) then
       write(nfout,'(" ! -- iconv_ek(after) -- <<m_ES_eekdif2>>")')
       write(nfout,'(" ! ",10i8)') iconv_ek(1:kv3_ek)
    end if

    if(it == 0) then
       ib = m_CtrlP_ntcnvg_incre()
       if(printable) then
          write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_electronic, ib
          if(iprievdff < 1) then
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
             do ik = 1, kv3, ikskip
! ====================================================================== 11.0

                write(nfout,'(" >> (",i5,") <eko_(old-new)>(ik=",i4,")=("&
                     & ,3d12.4 ,", iconv = ",i2,")")') iteration_electronic,ik&
                     & ,evdff2(1,ik),evdff2(2,ik),evdff2(3,ik),iconv(ik)
             end do
          end if
       end if
    else
       call m_CtrlP_ntcnvg_reset()    ! K.Mae 030808 
    end if
    m_ES_eekdif2 = m_CtrlP_ntcnvg_clear()
    deallocate(evdff2,evdffr2)
    deallocate(iconv)
  end function m_ES_eekdif2

  logical function m_ES_eekdif_cond()
    integer       :: ik, ib, ibcm, ipri0
    real(kind=DP) :: fac, tmp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

!!$    if(evaluation_eko_diff == OFF) then
    if(.not.delta_eigenvalue_cond_is_given) then
       m_ES_eekdif_cond = .true.
       return
    end if

    ibcm = totch/2 + 1.1
    if(printable) write(nfout,'("!m_ES_eekdif_cond: ibcm = ",i8)') ibcm

    evdff = 0.d0; evdffr = 0.d0
    if(neg-ibcm > 0) then
       fac = 1.d0/dble(kv3*(neg-ibcm))
    else
       fac = 1.d0/dble(kv3*neg)
    end if

! ======================= added by K. Tagami ========================= 11.0
    if ( noncol ) fac = fac * dble(ndim_spinor)
! =================================================================== 11.0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) < ibcm .or. nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff(1) = evdff(1) + tmp*tmp
          evdff(2) = evdff(2) + dabs(tmp)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff(3) = evdff(3) + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff,evdffr,3 &
         & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       evdff = evdffr
    end if

    evdff(1) = dsqrt(fac*evdff(1))*(af+1)
    evdff(2) = fac*evdff(2)*(af+1)
    evdff(3) = fac*evdff(3)*(af+1)

    eko1_l = eko_l


    if(iprievdff >= 1) &
         & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
         &    iteration_electronic, evdff(1), evdff(2), evdff(3)

    if(max(evdff(1),evdff(2)) < delta_eigenvalue_conduction) then
       m_ES_eekdif_cond = .true.
       if(printable) then
          if(iprievdff < 1) &
               & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,") : m_ES_eekdif_cond")') &
               &    iteration_electronic, evdff(1), evdff(2), evdff(3)
       end if
    else
       m_ES_eekdif_cond = .false.
    end if

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 1 ) call m_ES_wd_eko_cond(nfout,ibcm,mode=SCF)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end function m_ES_eekdif_cond

  subroutine m_ES_cp_eko_l_to_eko_ek()
    real(kind=DP),pointer,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))
    eko_t = 0.d0 ; eko_t2 = 0.d0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) == myrank_e) eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
         & ,mpi_sum,mpi_k_world(myrank_k),ierr)
    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    if(nk_in_the_process+kv3_e-1>kv3_ek) kv3_e = kv3_ek+1-nk_in_the_process
    eko_ek(:,nk_in_the_process:nk_in_the_process+kv3_e-1) = eko_t2(:,1:kv3_e)
    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_ES_cp_eko_l_to_eko_ek

  subroutine m_ES_cp_eko_l_to_eko_ek2()
    real(kind=DP),allocatable,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))

    eko_t = 0.d0
! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = 1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) /= myrank_e) cycle
          eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    if(npes >= 2) then
       call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
            &              ,mpi_sum, mpi_comm_group,ierr)
    else
       eko_t2 = eko_t
    end if

    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    if(nk_in_the_process+kv3_e-1 > kv3_ek) kv3_e = kv3_ek - nk_in_the_process + 1
    if(kv3_e <=0) kv3_e = 1
    eko_ek(:,nk_in_the_process:nk_in_the_process+kv3_e-1) = eko_t2(:,1:kv3_e)

    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_ES_cp_eko_l_to_eko_ek2

  real(DP) function m_ES_what_is_evdff_now()
    m_ES_what_is_evdff_now = max(evdff(1),evdff(2))
  end function m_ES_what_is_evdff_now

  real(kind=DP) function m_ES_get_energy(ilevel)
    integer, intent(in) :: ilevel
    real(kind=DP), pointer, dimension(:) :: eko, eko_t

    integer :: ib
    allocate(eko(neg)); allocate(eko_t(neg))

    do ib = 1, neg
       if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),1)
    end do
    call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI

    m_ES_get_energy = eko(neordr(ilevel,1))
  end function m_ES_get_energy

  subroutine m_ES_orbital_population(nfout)
    integer, intent(in) :: nfout

    integer :: is,ik,ib,iopr,i,it,ia,il,im,tau,lmt,ilmta,iksnl
    real(kind=DP) :: temp, pup, pdn, fac
    real(kind=DP), dimension(nlmta_phi,2) :: porb_mpi

    if(.not.allocated(porb)) allocate(porb(nlmta_phi,2))

    porb_mpi = 0.d0
    porb   = 0.d0

    is = 1
    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle
       if(nspin==2) is = mod(ik-1,2)+1
       iksnl = (ik-1)/nspin + 1
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do i=1,nlmta_phi
                call m_PP_tell_iorb_lmt(i,lmt)
                temp = 0.d0
                if(k_symmetry(ik) == GAMMA) then
                   do iopr = 1,nopr
! =============================== Modified by K. Tagami =====  0.2b
!                      temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2) &
!                           &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                      temp = temp + compr_l(map_z(ib),i,iopr,ik)**2 /2.0 &
                           &      *(1.d0+qorb(i)/(norm_phig(lmt,iksnl)*2.))
! ==========================================================
                   end do
                else
                   do iopr = 1,nopr
                      temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2 &
                           &         + compi_l(map_z(ib),i,iopr,ik)**2) &
                           &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                   end do
                end if
                porb_mpi(i,is) = porb_mpi(i,is) + occup_l(map_z(ib),ik)*temp/dble(nopr)
             end do
          end if
       end do
    end do
    call mpi_allreduce(porb_mpi,porb,nlmta_phi*2,mpi_double_precision &
                    & ,mpi_sum,mpi_comm_group,ierr)

    fac = 2.d0/kv3
    do is=1,nspin
       do i=1,nlmta_phi
          porb(i,is) = fac*porb(i,is)
       end do
    end do
    if(nspin == 1) then
       do i=1,nlmta_phi
          porb(i,1)=0.5d0*porb(i,1)
          porb(i,2)=porb(i,1)
       end do
    end if

    pup=0.d0; pdn=0.d0
    do i=1,nlmta_phi
       pup=pup+porb(i,1)
       pdn=pdn+porb(i,2)
    end do

    ! Write down Porb
    if(ipri >= 1) then  ! -->

    write(nfout,'(" --------- Orbital population ---------")')
    write(nfout,'("  ia   l   m   t    Porb(UP)   Porb(DN) element")')
    do ia=1,natm
       if(if_pdos(ia) == OFF) cycle
! ======================================== Added by K. Tagami == 0.2a =
       if(iproj_group(ia) == 0) cycle
! ================================================================
       it = ityp(ia)
       do lmt=1,ilmt_phi(it)
          ilmta = lmta_phi(lmt,ia)
          il  = ltp_phi(lmt,it)
          im  = mtp_phi(lmt,it)
          tau = taup_phi(lmt,it)
          write(nfout,'(4(1x,i3),2(1x,f10.5),1x,4a)') &
                      & ia,il,im,tau,porb(ilmta,1:2),speciesname(it)
       end do
    end do
    write(nfout,'(8x,"Total : ",3(1x,f10.5))') pup,pdn,pup+pdn

    end if      ! <--

  end subroutine m_ES_orbital_population

! ============================== added by K. Tagami =================== 11.0
  subroutine m_ES_orbital_population_noncl(nfout)
    integer, intent(in) :: nfout

    integer :: ik,ib,iopr,i,it,ia,il,im,tau,lmt,ilmta,iksnl
    real(kind=DP) :: fac
    integer :: is1, is2, istmp

    real(kind=DP), allocatable :: porb_mpi( :,: )
    real(kind=DP) :: porb_sum( ndim_magmom )
    complex(kind=CMPLDP) :: porb_ssrep( nlmta_phi, ndim_magmom )
    complex(kind=CMPLDP) :: z1, z2, ztemp

    if(.not.allocated(porb)) allocate(porb(nlmta_phi,ndim_magmom))

    porb_ssrep = 0.d0;      porb   = 0.d0

    do ik = 1, kv3, ndim_spinor

       if (map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do i=1,nlmta_phi
                call m_PP_tell_iorb_lmt(i,lmt)

                if(k_symmetry(ik) == GAMMA) then
                   stop 'Not supported : Gamma symmetry in noncollinear system.'
                else
                   Do is1=1, ndim_spinor
                      Do is2=1, ndim_spinor
                         istmp = ( is1 -1 )*ndim_spinor + is2
                         
                         ztemp = 0.0d0
                         do iopr = 1,nopr
                            z1 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is1-1 ), &
                                 &       compi_l(map_z(ib),i,iopr,ik+is1-1 ) )
                            z2 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is2-1 ), &
                                 &       compi_l(map_z(ib),i,iopr,ik+is2-1 ) )
                            ztemp = ztemp + z1 *conjg(z2) &
                                 &      *( 1.d0+qorb(i)/norm_phig(lmt,iksnl) )
                         End do
                         
                         porb_ssrep(i,istmp) = porb_ssrep(i,istmp) &
                              &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                              
                      End do
                   End do

                end if

             end do
          end if
       end do
    end do
! --

    fac = 1.d0 / ( kv3 /ndim_spinor )
    porb_ssrep = porb_ssrep *fac

!------------
    if ( SpinOrbit_mode == BuiltIn ) then
       stop 'kt : Under construction porb '
    endif
! -----

    call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )

    if ( npes >=2 ) then
       allocate( porb_mpi(nlmta_phi,ndim_magmom ) )
       porb_mpi = 0.0d0
       call mpi_allreduce( porb, porb_mpi, nlmta_phi*ndim_magmom, &
            &              mpi_double_precision, mpi_sum,mpi_comm_group, ierr )
       porb = porb_mpi
       deallocate( porb_mpi )
    endif

    porb_sum = 0.0d0
    do i=1,nlmta_phi
       porb_sum(:) = porb_sum(:) + porb(i,:)
    end do

! Write down Porb
    if (ipri >= 1) then

       write(nfout,'(" --------- Orbital population ---------")')
       write(nfout,'("  ia   l   m   t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element")')
       do ia=1,natm
          if(if_pdos(ia) == OFF) cycle

          if(iproj_group(ia) == 0) cycle

          it = ityp(ia)
          do lmt=1,ilmt_phi(it)
             ilmta = lmta_phi(lmt,ia)
             il  = ltp_phi(lmt,it)
             im  = mtp_phi(lmt,it)
             tau = taup_phi(lmt,it)
             write(nfout,'(4(1x,i3),4(1x,f10.5),4x,4a)') &
                  & ia,il,im,tau,porb(ilmta,1:ndim_magmom),speciesname(it)
          end do
       end do

       write(nfout,'(" -------- summation ---------")')
       write(nfout,'("             total       mx         my         mz")')
       write(nfout,'(8x,4(1x,f10.5))') porb_sum(1:ndim_magmom)

    end if

  end subroutine m_ES_orbital_population_noncl
! ===================================================================== 11.0

  subroutine m_ES_sym_comp(nfout)
    integer, intent(in) :: nfout

    integer :: ik,iopr,mm,jorb,iorb,ib

    do ik=1,kv3
       if(map_k(ik) /= myrank_k) cycle
       if(k_symmetry(ik) == GAMMA) then
          compr_l(:,:,2:nopr,ik) = 0.d0
          do iopr=2,nopr
             do iorb=1,nlmta_phi
                do mm=1,nrorb(iorb,iopr)
                   jorb=irorb(mm,iorb,iopr)
                   do ib=1,np_e
                      compr_l(ib,iorb,iopr,ik) = compr_l(ib,iorb,iopr,ik) &
                           & + compr_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                   end do
                end do
             end do
          end do
       else
          compr_l(:,:,2:nopr,ik) = 0.d0
          compi_l(:,:,2:nopr,ik) = 0.d0
          do iopr=2,nopr
             do iorb=1,nlmta_phi
                do mm=1,nrorb(iorb,iopr)
                   jorb=irorb(mm,iorb,iopr)
                   do ib=1,np_e
                      compr_l(ib,iorb,iopr,ik) = compr_l(ib,iorb,iopr,ik) &
                           & + compr_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                      compi_l(ib,iorb,iopr,ik) = compi_l(ib,iorb,iopr,ik) &
                           & + compi_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                   end do
                end do
             end do
          end do
       end if
    end do

    if(ipri>=2) write(nfout,*) '** compr and compi were symmetrized. **'

  end subroutine m_ES_sym_comp

  subroutine m_ES_orbital_den_mat(nfout,dm,max2lp,max_projs)
    integer, intent(in) :: nfout,max2lp,max_projs
    real(kind=DP), intent(out) :: dm(max2lp,max2lp,max_projs,natm,nspin)

    integer :: is,ik,ib,iopr,i,it,ia,im,lmt,iksnl
    integer :: im1,im2,i1,i2,lmt1,lmt2,ip
    real(kind=DP) :: temp, fac
    real(kind=DP), dimension(max2lp,max2lp,max_projs,natm,nspin) :: dm_mpi

    dm_mpi = 0.d0
    dm     = 0.d0

    is = 1
    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle
       if(nspin==2) is = mod(ik-1,2)+1
       iksnl = (ik-1)/nspin + 1
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do ia=1,natm
                it = ityp(ia)
                !!if(if_pdos(ia) == OFF) cycle
                if(iproj_group(ia) == 0) cycle
                ! diagonal part
                do lmt=1,ilmt_phi(it)
                   im  = mtp_phi(lmt,it)
                   ip  = iproj_phi(lmt,it)
                   i = lmta_phi(lmt,ia)
                   temp = 0.d0
                   if(k_symmetry(ik) == GAMMA) then
                      do iopr = 1,nopr
! ============================ Modified by K. Tagami ==== 0.2b
!                         temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2) &
!                             &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                         temp = temp + compr_l(map_z(ib),i,iopr,ik)**2 /2.0 &
                             &      *(1.d0+qorb(i)/(norm_phig(lmt,iksnl)*2.0))
! ======================================================
                      end do
                   else
                      do iopr = 1,nopr
                         temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2 &
                              &         + compi_l(map_z(ib),i,iopr,ik)**2) &
                              &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                      end do
                   end if
                   dm_mpi(im,im,ip,ia,is) = dm_mpi(im,im,ip,ia,is) + occup_l(map_z(ib),ik)*temp/dble(nopr)
                end do
                ! non-diagonal part
                do lmt2=1,ilmt_phi(it)
                   do lmt1=1,lmt2-1
                      if(ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
                      ip  = iproj_phi(lmt1,it)
                      im1  = mtp_phi(lmt1,it)
                      i1 = lmta_phi(lmt1,ia)
                      im2  = mtp_phi(lmt2,it)
                      i2 = lmta_phi(lmt2,ia)
                      temp = 0.d0
                      if(k_symmetry(ik) == GAMMA) then
                         do iopr = 1,nopr
! ===================== Modified by K. Tagami ==== ???? === 0.2b
!                            temp = temp + ( &
!                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik)) &
!                                 & /sqrt(norm_phig(lmt1,iksnl)*norm_phig(lmt2,iksnl))
                            temp = temp + ( &
                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik)) &
                                 & /sqrt(norm_phig(lmt1,iksnl)*norm_phig(lmt2,iksnl)) / 4.0
! ========================================================
                         end do
                      else
                         do iopr = 1,nopr
                            temp = temp + ( &
                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik) &
                                 & + compi_l(map_z(ib),i1,iopr,ik)*compi_l(map_z(ib),i2,iopr,ik)) &
                                 & /sqrt(norm_phig(lmt1,iksnl)*norm_phig(lmt2,iksnl))
                         end do
                      end if
                      dm_mpi(im1,im2,ip,ia,is) = dm_mpi(im1,im2,ip,ia,is) + occup_l(map_z(ib),ik)*temp/dble(nopr)
                      dm_mpi(im2,im1,ip,ia,is) = dm_mpi(im1,im2,ip,ia,is)
                   end do
                end do
             end do
          end if
       end do
    end do
    call mpi_allreduce(dm_mpi,dm,max2lp**2*max_projs*natm*nspin,mpi_double_precision &
                    & ,mpi_sum,mpi_comm_group,ierr)

    fac = 2.d0/kv3
    dm = fac*dm
    if(nspin == 1) dm = 0.5d0*dm

  end subroutine m_ES_orbital_den_mat

! ================================= added by K. Tagami ================= 11.0
  subroutine m_ES_orbital_den_mat_noncl( nfout, dm, max2lp, max_projs )
!
    integer, intent(in) :: nfout,max2lp,max_projs
    real(kind=DP), intent(out) :: dm(max2lp,max2lp,max_projs,natm,ndim_magmom)

    integer :: ik,ib,iopr,i,it,ia,im,lmt,iksnl
    integer :: im1,im2,i1,i2,lmt1,lmt2,ip

    integer :: is1, is2, istmp
    real(kind=DP) :: fac
    complex(kind=CMPLDP) :: z1, z2, ztemp
    complex(kind=CMPLDP), allocatable :: dm_ssrep( :, :, :, :, : )

    real(kind=DP), allocatable :: dm_mpi( :, :, :, :, : )

    allocate( dm_ssrep( max2lp, max2lp, max_projs, natm, ndim_chgpot ) )
    dm_ssrep = 0.d0; dm  = 0.d0

    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle
       
       iksnl = (ik-1)/ndim_spinor + 1
       
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do ia=1,natm
                it = ityp(ia)
                !!if(if_pdos(ia) == OFF) cycle
                if(iproj_group(ia) == 0) cycle
                
! ------------------------------- diagonal part ----------
                do lmt=1,ilmt_phi(it)
                   im  = mtp_phi(lmt,it)
                   ip  = iproj_phi(lmt,it)
                   i = lmta_phi(lmt,ia)
                   
                   if (k_symmetry(ik) == GAMMA) then
                      stop 'Not supported : Gamma symmetry in noncollinear system.'
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr = 1,nopr
                               z1 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is1-1 ), &
                                    &       compi_l(map_z(ib),i,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is2-1 ), &
                                    &       compi_l(map_z(ib),i,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(i)/norm_phig(lmt,iksnl) )
                            End do

                            dm_ssrep( im, im, ip, ia, istmp ) &
                                 & = dm_ssrep( im, im, ip, ia, istmp ) &
                                 &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                         End do
                      End do
                   end if

                end do

! --------------------  non-diagonal part --------------
                do lmt2 = 1,ilmt_phi(it)
!!!!                   do lmt1=1,lmt2-1

                   do lmt1 = 1, ilmt_phi(it)

                      if ( lmt1 == lmt2 ) cycle
                      if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle

                      ip  = iproj_phi(lmt1,it)
                      im1  = mtp_phi(lmt1,it)
                      i1 = lmta_phi(lmt1,ia)
                      im2  = mtp_phi(lmt2,it)
                      i2 = lmta_phi(lmt2,ia)

                      if (k_symmetry(ik) == GAMMA) then
                         stop 'Not supported : Gamma symmetry in noncollinear system.'
                      else
                         Do is1=1, ndim_spinor
                            Do is2=1, ndim_spinor
                               istmp = ( is1 -1 )*ndim_spinor + is2

                               ztemp = 0.0d0
                               do iopr = 1,nopr
                                  z1 = dcmplx( compr_l(map_z(ib),i1,iopr,ik+is1-1 ), &
                                       &       compi_l(map_z(ib),i1,iopr,ik+is1-1 ) )
                                  z2 = dcmplx( compr_l(map_z(ib),i2,iopr,ik+is2-1 ), &
                                       &       compi_l(map_z(ib),i2,iopr,ik+is2-1 ) )
                                  ztemp = ztemp + z1 *conjg(z2) &
                                       & / sqrt( norm_phig(lmt1,iksnl) &
                                       &         *norm_phig(lmt2,iksnl) )
                               End do

                               dm_ssrep( im1, im2, ip, ia, istmp ) &
                                    & = dm_ssrep( im1, im2, ip, ia, istmp ) &
                                    &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                            End do
                         End do
                      end if
                   end do
                end do
! ------------------------------------------------------
             end do
          end if
       end do
    end do
! ----------
    fac = 1.d0 / ( kv3 /ndim_spinor )
    dm_ssrep = dm_ssrep *fac

!------------
    if ( SpinOrbit_mode == BuiltIn ) then
       stop 'kt : Under construction porb '
    endif
! -----

    call m_ES_DensMat_To_MagMom_dm( dm_ssrep, dm, max2lp, max_projs )

    if ( npes > 1 ) then
       allocate( dm_mpi( max2lp, max2lp, max_projs, natm, ndim_magmom ) )
       dm_mpi = 0.0d0

       call mpi_allreduce( dm, dm_mpi, max2lp**2*max_projs*natm*ndim_magmom, &
         &                 mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       dm = dm_mpi
       deallocate( dm_mpi )
    endif
! --

  end subroutine m_ES_orbital_den_mat_noncl
! ================================================================ 11.0

  subroutine m_ES_set_num_bands_super()
    integer :: i
    i = neg*nlpnt
    call m_CntrlP_set_neg(i)
    call m_CntrlP_set_meg(i)
    if(printable) then
       write(nfout,*) 'num_bands will be changed.'
       write(nfout,'("neg,meg=",2i7)') neg,meg
    end if
  end subroutine m_ES_set_num_bands_super

  subroutine m_ES_add_neg(ne)
     integer, intent(in) :: ne
     integer :: newneg
     if(ne==0) return
     newneg = neg+ne
     if(printable) write(nfout,'(a,i6,a,i6)') ' !** the number of bands will change from ',neg,' to ',newneg
     call m_CntrlP_set_neg(newneg)
     call m_CntrlP_set_meg(newneg)
     neg_previous = newneg
     !call m_Parallel_dealloc_mpi_elec()
     !call m_Parallel_init_mpi_elec(nfout,0,printable,neg,kv3,nspin,kg1)
  end subroutine m_ES_add_neg

  subroutine m_ES_dealloc

    if(allocated(vlhxcQ)) deallocate(vlhxcQ)
    if(allocated(vlhxc_l)) deallocate(vlhxc_l)
    if(allocated(vnlph_l)) deallocate(vnlph_l)   

    if(allocated(zaj_l)) deallocate(zaj_l)
    if(allocated(zaj_l_buf)) deallocate(zaj_l_buf)
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       if(allocated(Phifftr_l)) deallocate(Phifftr_l)
       if(allocated(status_saved_phifftr)) deallocate(status_saved_phifftr)
    end if
#endif
    if(allocated(fsr_l)) deallocate(fsr_l)   
    if(allocated(fsi_l)) deallocate(fsi_l)   
    if(allocated(eko_l)) deallocate(eko_l)
    if(allocated(occup_l)) deallocate(occup_l)   
    if(allocated(neordr)) deallocate(neordr)   
    if(allocated(nrvf_ordr)) deallocate(nrvf_ordr)   
    if(allocated(eko_ek)) deallocate(eko_ek)   
    if(allocated(eko1_l)) deallocate(eko1_l) 
    if(allocated(evdff)) deallocate(evdff) 
    if(allocated(evdffr)) deallocate(evdffr)
    if(allocated(compr_l)) deallocate(compr_l)
    if(allocated(compi_l)) deallocate(compi_l)
    if(allocated(fsr_add_l)) deallocate(fsr_add_l)
    if(allocated(fsi_add_l)) deallocate(fsi_add_l)

  end subroutine m_ES_dealloc


  subroutine m_ES_add_it_to_vnlph(ik,ib,v)
    integer, intent(in) :: ik,ib
    real(kind=DP), intent(in) :: v(kg1,kimg)

    integer :: ig

    if(kimg==1) then
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + v(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + v(ig,1)
          vnlph_l(ig,ib,2) = vnlph_l(ig,ib,2) + v(ig,2)
       end do
    end if
  end subroutine m_ES_add_it_to_vnlph

end module m_Electronic_Structure

#ifdef HIUX
*option MP(P(0))
#endif
!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 6.01)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BP_Properties
! $ID: $
!
! Properties:
! 1. Berry-phase polarization
!
!    P_a = -qe/V sum_j Z_ion(j) * r(j)_a - qe/V * f/(2*pi) sum_i A_ia * phi_i
!
! 2. Effective charge tensor
!
!    Z_ab = Z_ion + f/(2*pi) sum_i A_ia * d(phi_i)/d(u_b)
!
! 3. piezoelectirc stress tensor
!
!    C_ab = f/(2*pi*V) sum_i A_ia * d(phi_i)/d(e_b)
!

use m_Files, only : nfout
use m_Control_Parameters, only : polar_prop,nspin,printable
use m_Const_Parameters,   only : DP, PAI, PAI2, ON, OFF &
                        &      , POLARIZATION, EFFECTIVE_CHARGE &
                        &      , PIEZOELECTRIC_CONST, UNIT_PIEZO_CONST
use m_Parallelization,    only : mpi_comm_group,mype,npes,ierr

implicit none
include 'mpif.h'

integer, private :: num_berry_phase,max_num_kpoints
integer, private, allocatable :: num_kpoints(:) ! dim(num_berry_phase)
integer, private, allocatable :: g_index(:) ! dim(num_berry_phase)
integer, private, allocatable :: direction(:) ! dim(num_berry_phase) 
integer, private, allocatable :: displaced_atom(:) ! dim(num_berry_phase)
  ! 1 -> x, 2 -> y, 3 -> z
real(kind=DP), private, allocatable :: u(:) ! dim(num_berry_phase)
  ! atomic displacement
real(kind=DP), private, allocatable :: displacement(:,:) ! dim(3,num_berry_phase)
complex(kind=DP), private, allocatable :: cphi(:,:,:) ! dim(nkprep_max,nspin,num_berry_phase)
real(kind=DP), private, allocatable :: wgh(:,:) ! dim(nkprep_max,num_berry_phase)
real(kind=DP), private, allocatable :: epsstr(:) ! dim(num_berry_phase)
real(kind=DP), private, allocatable :: posstr(:,:,:) ! dim(natm,3,num_berry_phase)
integer, private, allocatable :: istrain(:) ! dim(num_berry_phase)

! Properties
real(kind=DP), allocatable :: zeff(:,:,:) ! dim(3,3,natm)
real(kind=DP), allocatable :: piezo(:,:) ! dim(3,6)

contains

subroutine m_BP_read_Berry_phase(paramset)
use m_Files, only : m_Files_open_nfberry, nfberry
use m_Ionic_System, only : natm
implicit none

logical, intent(in) :: paramset

! local variables
integer :: i,k,ia,is
integer :: idummy
real(kind=DP) :: dummy,cphi_re,cphi_im,phi
real(kind=DP) :: d(3),tmp,epstmp(3,3)

! debug
!write(nfout,*) 'DEBUG: reading berry.data (1)'
! end debug

if(.not.paramset) then
   allocate(num_kpoints(1),g_index(1),displaced_atom(1),displacement(3,1))
   allocate(wgh(1,1))
else
! debug
!   write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase
!   write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints
! end debug
   allocate(num_kpoints(num_berry_phase))
   allocate(g_index(num_berry_phase))
   allocate(displaced_atom(num_berry_phase))
   allocate(displacement(3,num_berry_phase))
   allocate(cphi(max_num_kpoints,nspin,num_berry_phase))
   allocate(wgh(max_num_kpoints,num_berry_phase))
   allocate(direction(num_berry_phase))
   allocate(u(num_berry_phase))
   if( polar_prop == PIEZOELECTRIC_CONST ) then
      allocate(istrain(num_berry_phase))
      allocate(epsstr(num_berry_phase))
      allocate(posstr(natm,3,num_berry_phase))
   end if
end if

! debug
!write(nfout,*) 'DEBUG: reading berry.data (2)'
! end debug

if(mype == 0) then

   if(.not.paramset) max_num_kpoints = 0

   call m_Files_open_nfberry()
   rewind nfberry
   read(nfberry,*) num_berry_phase
! debug
   write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase
   call flush(nfout)
! end debug
   if(.not.paramset) then
   do i=1,num_berry_phase
! debug
      write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i
      call flush(nfout)
! end debug
      read(nfberry,*) num_kpoints(1),g_index(1),displaced_atom(1),displacement(1:3,1)
      do is=1,nspin
      do k=1,num_kpoints(1)
         read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(1,1)
      end do
      end do
      if(num_kpoints(1) .gt. max_num_kpoints) then
         max_num_kpoints = num_kpoints(1)
      end if
      if( polar_prop == PIEZOELECTRIC_CONST ) then
	 do k=1,3
	    read(nfberry,*)
	 end do    
         read(nfberry,*) idummy
	 do k=1,idummy
	    read(nfberry,*)
         end do
      end if
   end do
! debug
    write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints
    call flush(nfout)
! end debug
   else
   do i=1,num_berry_phase
! debug
      write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i
      call flush(nfout)
! end debug
      read(nfberry,*) num_kpoints(i),g_index(i),displaced_atom(i),displacement(1:3,i)
! debug
      write(nfout,'("DEBUG: the header was read.")')
      call flush(nfout)
! end debug
      if(polar_prop == EFFECTIVE_CHARGE) then
        direction(i) = 1
        u(i) = 0.d0
        do k=1,3
          if(abs(displacement(k,i)) > 1.d-10) then
           ! debug
           !write(nfout,'("m_BP_read_Berry_phase: displacement = ",e25.14)') displacement(k,i)
              direction(i) = k
              u(i) = displacement(k,i)
           !write(nfout,'("m_BP_read_Berry_phase: "i7,"-th data. u=",e25.14)') i,u(i)
           ! end debug
          end if
        end do
        d(1:3) = displacement(1:3,i)
        d(direction(i)) = d(direction(i)) - u(i)
        if(abs(sum(d(1:3)**2)) > 1.d-10) then
          if(printable) then
            write(nfout,'("Displacement vector of ",i4,"-th atom =",3(1x,f10.5))') &
                    & displaced_atom(i),displacement(1:3,i)
          end if
          return
          !stop 'Error of displacement in <<<m_BP_read_Berry_phase>>>'
        end if
        if(displaced_atom(i) <= 0) direction(i) = -1
      end if
! debug
      write(nfout,'("DEBUG: berry phase is reading.")')
      call flush(nfout)
! end debug
      do is=1,nspin
      do k=1,num_kpoints(i)
         read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(k,i)
         cphi(k,is,i) = dcmplx(cphi_re,cphi_im)
      end do
      end do
      if( polar_prop == PIEZOELECTRIC_CONST ) then
! debug
      write(nfout,'("DEBUG: strain tensor is reading.")')
      call flush(nfout)
! end debug
         read(nfberry,*) epstmp(1,1:3)
         read(nfberry,*) epstmp(2,1:3)
         read(nfberry,*) epstmp(3,1:3)
         call set_istrain(epstmp,istrain(i),epsstr(i))
         read(nfberry,*) idummy
         if(idummy /= natm) then
            stop 'natm in berry.data differs from natm in PHASE.'
         end if
         do ia=1,natm
            read(nfberry,*) idummy,posstr(ia,1:3,i)
         end do
      end if
      if(printable) write(nfout,'(i7,"-th berry data was read.")') i
      call flush(nfout)
   end do
   end if

end if

if(.not.paramset) then
   deallocate(num_kpoints,g_index,displaced_atom,displacement)
   deallocate(wgh)
end if

if(npes > 1) then
if(.not.paramset) then
  call mpi_bcast(num_berry_phase,1,mpi_integer,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(max_num_kpoints,1,mpi_integer,0,mpi_comm_group,ierr) ! MPI
else
  call mpi_bcast(num_kpoints,num_berry_phase,mpi_integer,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(g_index,num_berry_phase,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(displaced_atom,num_berry_phase,mpi_integer,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(displacement,num_berry_phase*3,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(cphi,max_num_kpoints*nspin*num_berry_phase*2,mpi_double_complex,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(wgh,max_num_kpoints*num_berry_phase,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(direction,num_berry_phase,mpi_integer,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(u,num_berry_phase,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
end if
end if

contains

subroutine set_istrain(eps,istrain,str)
  real(kind=DP), intent(in) :: eps(3,3)
  integer, intent(out) :: istrain
  real(kind=DP), intent(out) :: str

  integer :: i
  real(kind=DP) :: dst(6)

  dst(1) = eps(1,1)
  dst(2) = eps(2,2)
  dst(3) = eps(3,3)
  dst(4) = eps(2,3)+eps(3,2)
  dst(5) = eps(3,1)+eps(1,3)
  dst(6) = eps(1,2)+eps(1,2)
  ! debug
  if(printable) then
  write(nfout,*) 'debug: set_istrain'
  do i=1,6
     write(nfout,*) i,dst(i)
  end do
  write(nfout,*) 'end debug: set_istrain'
  end if
  ! end debug
  istrain = 0
  do i=1,6 
     if(abs(dst(i)) > 0.d0) then
        istrain = i
        str = dst(i)
        return
     end if
  end do

end subroutine set_istrain

end subroutine m_BP_read_Berry_phase



subroutine m_BP_get_Berry_phase(atom_id,g_id,dir_id,cphi_out,wgh_out,nkp,u_out,exists)
implicit none
integer, intent(in) :: atom_id, g_id, dir_id
complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin)
real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
integer, intent(out) :: nkp
real(kind=DP), intent(out) :: u_out
logical, intent(out) :: exists

! lcoal variables
integer :: i,k,is

exists = .false.
do i=1,num_berry_phase
   ! debug
   !write(6,*) 'atom_id,g_id,dir_id=',atom_id,g_id,dir_id,': i=',i
   ! end debug
   if(displaced_atom(i).eq.atom_id .and. &
    & g_index(i).eq.g_id .and. &
    & direction(i).eq.dir_id) then
     nkp = num_kpoints(i)
     do is=1,nspin
     do k=1,nkp
       cphi_out(k,is) = cphi(k,is,i)
       wgh_out(k) = wgh(k,i)
     end do 
     end do
     u_out = u(i)
     exists = .true.
     return
   end if
end do

return
end subroutine m_BP_get_Berry_phase



subroutine m_BP_calc_diff_Berry_phase(dphi,present_atom)
use m_Ionic_System, only : natm
implicit none
real(kind=DP), intent(out) :: dphi(3,3,natm)
logical, intent(out) :: present_atom(natm)

! local variables
integer :: ia,ig,id,k,ia0,is
integer :: nkp0,nkp1
complex(kind=DP) :: cphi0(max_num_kpoints,nspin)
complex(kind=DP) :: cphi1(max_num_kpoints,nspin)
real(kind=DP) :: wgh0(max_num_kpoints)
real(kind=DP) :: wgh1(max_num_kpoints)
real(kind=DP) :: phi(max_num_kpoints)
real(kind=DP) :: u0,u1
!!$logical :: exists
logical :: exists1, exists2

present_atom(1:natm) = .false.

ATOM: do ia=1,natm
  do ig=1,3
    ia0 = 0
    id = -1
    !!$call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists)
    !!$if(.not.exists) cycle ATOM
    call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists1)
    do id=1,3
      !!$call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists)
      !!$if(.not.exists) cycle ATOM
      call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists2)
      if(.not.(exists1.and.exists2)) cycle
      present_atom(ia) = .true.
      if(nkp0.ne.nkp1) then
         if(printable) then
            write(nfout,*) 'nkp0=',nkp0
            write(nfout,*) 'nkp1=',nkp1
         end if
         stop 'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_phase>>'
      end if

   ! debug
   !   write(nfout,*) 'ia,ig,id =',ia,ig,id
   ! end debug
      dphi(id,ig,ia) = 0.d0
      do is=1,nspin
      do k=1,nkp0
        if(wgh0(k).ne.wgh1(k)) then
           if(printable) then
              write(nfout,*) 'wgh0=',wgh0(k)
              write(nfout,*) 'wgh1=',wgh1(k)
           end if
           stop 'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_phase>>'
        end if
        phi(k) = dimag(log(cphi1(k,is)/cphi0(k,is)))
   ! debug
   !     write(nfout,*) 'k=',k,' phi=',phi(k)
   ! end debug
        dphi(id,ig,ia) = dphi(id,ig,ia) + phi(k)*wgh0(k)
      end do
      end do
   ! debug
   !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi=',dphi(id,ig,ia)
   ! end debug
      dphi(id,ig,ia) = 2.d0*dphi(id,ig,ia)/u1
   ! debug
   !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi/u=',dphi(id,ig,ia)
   ! end debug
    end do
  end do
  !!$present_atom(ia) = .true.
end do ATOM

return
end subroutine m_BP_calc_diff_Berry_phase


subroutine m_BP_calc_Polarization()
use m_Crystal_Structure, only : altv
use m_Ionic_System, only : natm,ntyp,ityp,cps
use m_Crystal_Structure, only : univol
use m_PseudoPotential, only : ival
implicit none

! local variables
integer :: i,ia,nkp,is
real(kind=DP) :: polar_ion(3), polar_ele(3), polar_tot(3)
real(kind=DP) :: phi(3)
real(kind=DP) :: fac


do ia=1,natm
   polar_ion(1:3) = polar_ion + ival(ityp(ia))*cps(ia,1:3)
end do
fac = 2.d0/(PAI2*univol)
polar_ele(1:3) = 0.d0
do i=1,3
   nkp = num_kpoints(i)
   phi(i) = 0.d0
   do is=1,nspin
      phi(i) = phi(i) +  sum(dimag(log(cphi(1:nkp,is,i)))*wgh(1:nkp,i))
   end do
   polar_ele(1:3) = polar_ele(1:3) + fac*altv(1:3,i)*phi(i)
end do
polar_tot(1:3) = polar_ion(1:3) + polar_ele(1:3)

! print polarization
if(printable) then
   write(nfout,*) ' --- Berry phase ---'
   write(nfout,'("phi =",3(1x,f20.10))') phi(1:3)
   write(nfout,*) ' --- Polarization ---'
   write(nfout,'("P_ion =",3(1x,f20.10))') polar_ion(1:3)
   write(nfout,'("P_ele =",3(1x,f20.10))') polar_ele(1:3)
   write(nfout,'("P_tot =",3(1x,f20.10))') polar_tot(1:3)
end if

return
end subroutine m_BP_calc_Polarization


subroutine m_BP_calc_Effective_charge()
use m_Crystal_Structure, only : altv,nopr,op
use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
use m_Crystal_Structure, only : univol
use m_PseudoPotential, only : ival
use m_Files, only : nfeffchg, m_Files_open_nfeffchg
use m_Control_Parameters,  only : sw_check_sumrule_born_charge

implicit none

! local variables
integer :: i,j,k,ia,ja,iopr
real(kind=DP) :: dphi(3,3,natm)
logical :: present_atom(natm)
real(kind=DP) :: zeff_el(3,3,natm)
!real(kind=DP) :: zeff(3,3,natm)
real(kind=DP) :: fac
real(kind=DP) :: ztmp(3,3)

! == ASMS DEBUG ==
!!!real(kind=DP) :: nsym
integer :: nsym
! ===============

real(kind=DP) :: nonzero(3,3)

if(.not.allocated(zeff)) allocate(zeff(3,3,natm))

if( polar_prop == EFFECTIVE_CHARGE ) then

call m_BP_calc_diff_Berry_phase(dphi,present_atom)
fac = 1.d0/PAI2
do ia=1,natm
  if(.not.present_atom(ia)) cycle
  do j=1,3
     do i=1,3
        zeff_el(i,j,ia) = fac*sum(altv(i,1:3)*dphi(j,1:3,ia))
        zeff(i,j,ia) = zeff_el(i,j,ia)
     end do
  end do
  do i=1,3
     zeff(i,i,ia) = zeff(i,i,ia) + ival(ityp(ia))
  end do
end do

! print electronic effective charges
if(printable) then
   write(nfout,*) ' --- Calculated electronic effective charges ---'
   do ia=1,natm
      if(.not.present_atom(ia)) cycle
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(1,1:3,ia)
      write(nfout,'("Zel (",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff_el(2,1:3,ia)
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(3,1:3,ia)
      write(nfout,*)
   end do

   ! print effective charges
   write(nfout,*) ' --- Calculated effective charges ---'
   do ia=1,natm
      if(.not.present_atom(ia)) cycle
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
      write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
      write(nfout,*)
   end do
end if

else

call m_BP_read_Effective_charge(zeff,present_atom)

end if

! Symmetrization
ATOM: do ia=1,natm
  if(.not.present_atom(ia)) cycle ATOM
  ztmp(1:3,1:3) = 0.d0
  nsym=0
  OPERATION: do iopr=1,nopr
    if(napt(ia,iopr).ne.ia) cycle OPERATION
    nsym=nsym+1
    do j=1,3
      do i=1,3
        do k=1,3
          ztmp(i,j) = ztmp(i,j) + sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr) 
        end do
      end do
    end do
  end do OPERATION
  zeff(1:3,1:3,ia) = ztmp(1:3,1:3)/nsym
end do ATOM
      
! print effective charges
if(printable) then
   write(nfout,*) ' --- Symmetrized effective charges ---'
   do ia=1,natm
      if(.not.present_atom(ia)) cycle
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
      write(nfout,'("Zsym(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
      write(nfout,*)
   end do
end if

! calculate effective chareges of equivalent atoms
ATOM2: do ia=1,natm
  ! debug
  !  print *,'DEGUG: ia=',ia
  if(.not.present_atom(ia)) cycle ATOM2
  OPERATION2: do iopr=1,nopr
    ja = napt(ia,iopr)
  ! debug
  !  print *,'DEGUG: operation iopr=',iopr
  !  print *,'DEGUG: equivalent atom ja=',ja
    if(ja.eq.ia) cycle OPERATION2
    if(present_atom(ja)) cycle OPERATION2
    zeff(1:3,1:3,ja) = 0.d0
    do j=1,3
      do i=1,3
        do k=1,3
          zeff(i,j,ja) = zeff(i,j,ja) + sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr) 
        end do
      end do
    end do
    present_atom(ja) = .true.
  end do OPERATION2
end do ATOM2

! print effective charges of all atoms
if(printable) then
   write(nfout,*) ' --- Effective charges of all atoms ---'
   do ia=1,natm
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
      write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
      write(nfout,*)
   end do
end if

! === KT_add === 2014/06/30
if ( sw_check_sumrule_born_charge == OFF ) goto 100
! ============== 2014/06/30

! check zero sum rule
ztmp(1:3,1:3) = 0.d0
nonzero(1:3,1:3) = 0
do ia=1,natm
  do j=1,3
    do i=1,3
      if(dabs(zeff(i,j,ia)).gt.1.d-10) nonzero(i,j)=nonzero(i,j)+1
      ztmp(i,j) = ztmp(i,j) + zeff(i,j,ia)
    end do
  end do
end do
do j=1,3
  do i=1,3
     if(nonzero(i,j)==0) nonzero(i,j)=1
  end do
end do
ztmp(1:3,1:3) = ztmp(1:3,1:3)/nonzero(1:3,1:3)
! print averaged effective charge
if(printable) then
   write(nfout,*) ' --- Averaged effective charges ---'
   write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(1,1:3)
   write(nfout,'("Zave = [",3(1x,f10.5),1x,"]")') ztmp(2,1:3)
   write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(3,1:3)
   write(nfout,*)
end if

! correct effective charges
do ia=1,natm
  do j=1,3
    do i=1,3
      if(dabs(zeff(i,j,ia)).lt.1.d-10) cycle
      zeff(i,j,ia) = zeff(i,j,ia) - ztmp(i,j)
    end do
  end do
end do

! print corrected effective charges
if(printable) then
   write(nfout,*) ' --- Corrected effective charges ---'
   do ia=1,natm
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
      write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
      write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
      write(nfout,*)
   end do
end if

100 continue

! ==== KT_add === 13.1R
if ( mype == 0 ) then
   call m_Files_open_nfeffchg()

   write(nfeffchg,*) natm
   do ia=1,natm
      write(nfeffchg,'(I6)') ia
      write(nfeffchg,'(3F18.12)') zeff(1,1:3,ia)
      write(nfeffchg,'(3F18.12)') zeff(2,1:3,ia)
      write(nfeffchg,'(3F18.12)') zeff(3,1:3,ia)
   end do
   close( nfeffchg )
endif
! =============== 13.1R

return
end subroutine m_BP_calc_Effective_charge

subroutine m_BP_read_Effective_charge(zeff,present_atom)
use m_Ionic_System, only : natm
use m_Files, only : nfeffchg, m_Files_open_nfeffchg
implicit none
real(kind=DP), intent(out) :: zeff(3,3,natm)
logical, intent(out) :: present_atom(natm)

integer :: num_zeff
integer :: i,ia

if( polar_prop == EFFECTIVE_CHARGE ) return

present_atom(1:natm) = .false.

call m_Files_open_nfeffchg()
if(mype == 0) then
rewind nfeffchg
read(nfeffchg,*) num_zeff
do i=1,num_zeff
  read(nfeffchg,*) ia 
  read(nfeffchg,*) zeff(1,1:3,ia)
  read(nfeffchg,*) zeff(2,1:3,ia)
  read(nfeffchg,*) zeff(3,1:3,ia)
  present_atom(ia) = .true.
end do
close( nfeffchg )  !ASMS
end if

if(npes>1) then
  call mpi_bcast(zeff,3*3*natm,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
  call mpi_bcast(present_atom,natm,mpi_logical,0,mpi_comm_group,ierr) ! MPI
end if

return
end subroutine m_BP_read_Effective_charge

subroutine m_BP_get_Berry_phase_strain(g_id,eps_id,cphi_out,wgh_out,nkp,eps_out,posstr_out,exists)
use m_Ionic_System, only : natm
implicit none
integer, intent(in) :: g_id, eps_id
complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin)
real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
integer, intent(out) :: nkp
real(kind=DP), intent(out) :: eps_out
real(kind=DP), intent(out) :: posstr_out(natm,3)
logical, intent(out) :: exists

integer :: i,k,is

exists = .false.
do i=1,num_berry_phase
   if(g_index(i).eq.g_id .and. &
    & istrain(i).eq.eps_id) then
      nkp = num_kpoints(i)
      do is=1,nspin
      do k=1,nkp
         cphi_out(k,is) = cphi(k,is,i)
         wgh_out(k) = wgh(k,i)
      end do
      end do
      eps_out = epsstr(i) 
      posstr_out(1:natm,1:3) = posstr(1:natm,1:3,i)
      exists = .true.
      return
   end if
end do

end subroutine m_BP_get_Berry_phase_strain

subroutine m_BP_calc_diff_Berry_strain(dphi,present_strain)
use m_Ionic_System, only : natm
implicit none
real(kind=DP), intent(out) :: dphi(3,6)
logical, intent(out) :: present_strain(6)

! local variables
integer :: ia,ig,id,k,ist,is
integer :: nkp0,nkp1
complex(kind=DP) :: cphi0(max_num_kpoints,nspin)
complex(kind=DP) :: cphi1(max_num_kpoints,nspin)
real(kind=DP) :: wgh0(max_num_kpoints)
real(kind=DP) :: wgh1(max_num_kpoints)
real(kind=DP) :: phi(max_num_kpoints,nspin)
real(kind=DP) :: eps0,eps1
real(kind=DP) :: pos0(natm,3),pos1(natm,3)
logical :: exists
real(kind=DP) :: dphi_ion

present_strain(1:6) = .false.

do ig=1,3
   ist = 0
   call m_BP_get_Berry_phase_strain(ig,ist,cphi0,wgh0,nkp0,eps0,pos0,exists)
   if(.not.exists) cycle
   STRAIN: do ist=1,6
      call m_BP_get_Berry_phase_strain(ig,ist,cphi1,wgh1,nkp1,eps1,pos1,exists)
      if(.not.exists) cycle STRAIN
      present_strain(ist) = .true.
      if(nkp0.ne.nkp1) then
         if(printable) then
            write(nfout,*) 'nkp0=',nkp0
            write(nfout,*) 'nkp1=',nkp1
         end if
         stop 'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_strain>>'
      end if
   ! debug
   !   write(nfout,*) 'ig,ist =',ig,ist
   ! end debug
      dphi(ig,ist) = 0.d0
      do is=1,nspin
      do k=1,nkp0
         if(wgh0(k).ne.wgh1(k)) then
            if(printable) then
               write(nfout,*) 'wgh0=',wgh0(k)
               write(nfout,*) 'wgh1=',wgh1(k)
            end if
            stop 'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_strain>>'
         end if
         phi(k,is) = dimag(log(cphi1(k,is)/cphi0(k,is)))
   ! debug
        if(printable) write(nfout,*) 'k=',k,' is=',is,' phi=',phi(k,is)
   ! end debug
         dphi(ig,ist) = dphi(ig,ist) + phi(k,is)*wgh0(k)
      end do
      end do
      dphi(ig,ist) = 2.d0*dphi(ig,ist)
   ! debug
      if(printable) write(nfout,*) 'ig,ist=',ig,ist,' dphi=',dphi(ig,ist)
   ! end debug
      call ionic_part(pos0,pos1,ig,dphi_ion)
   ! debug
      if(printable) then
      write(nfout,*) 'ig,ist=',ig,ist,' dphi_ion=',dphi_ion
      write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot=',dphi_ion+dphi(ig,ist)
      write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot(mod.)=',4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))
      end if
   ! end debug
      dphi(ig,ist) = 4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))/eps1
   ! debug
      if(printable) then
      write(nfout,*) 'ig,ist=',ig,ist,' eps=',eps1
      write(nfout,*) 'ig,ist=',ig,ist,' dphi/eps=',dphi(ig,ist)
      end if
   ! end debug
   end do STRAIN
end do

contains

subroutine ionic_part(pos0,pos1,ig,dphi)
use m_Crystal_Structure, only : rltv
use m_PseudoPotential, only : ival
use m_Ionic_System, only : ityp
real(kind=DP), intent(in) :: pos0(natm,3) ! internal coordinates
real(kind=DP), intent(in) :: pos1(natm,3)
integer, intent(in) :: ig
real(kind=DP), intent(out) :: dphi

! local variables
integer :: ia

dphi = 0.d0
do ia=1,natm
   dphi = dphi + ival(ityp(ia))*(pos1(ia,ig) - pos0(ia,ig))*PAI2
end do

end subroutine ionic_part

end subroutine m_BP_calc_diff_Berry_strain

subroutine m_BP_calc_piezoelectric_const
use m_Crystal_Structure, only : altv
use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
use m_Crystal_Structure, only : univol
implicit none

! local variables
integer :: i,ia,ist
real(kind=DP) :: dphi(3,6)
real(kind=DP) :: fac
logical :: present_strain(natm)

if(.not.allocated(piezo)) allocate(piezo(3,6))
piezo = 0.d0

if( polar_prop == PIEZOELECTRIC_CONST ) then
   dphi = 0.d0
   call m_BP_calc_diff_Berry_strain(dphi,present_strain)
   fac = 1.d0/(PAI2*univol)
   ! debug
     if(printable) then
     write(nfout,*) 'fac=',fac
     write(nfout,*) 'present_strain=',present_strain(1:6)
     end if
   ! end debug
   do ist=1,6
      if(.not.present_strain(ist)) cycle
   ! debug
      if(printable) then
      write(nfout,*) 'ist=',ist
      write(nfout,'(" dphi=",3(1x,f10.5))') dphi(1:3,ist)
      end if
   ! end debug
    do i=1,3
   ! debug
      if(printable) then
      write(nfout,'(" a1i,a2i,a3i=",3(1x,f10.5))') altv(i,1:3)
      end if
   ! end debug
         piezo(i,ist) = fac*sum(altv(i,1:3)*dphi(1:3,ist))
      end do
   end do
end if

if(printable) then
   write(nfout,*) '=== Piezoelectric constant (a.u.) ==='
   do ist=1,6
      write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)
   end do
   write(nfout,*) '=== Piezoelectric constant (C/m^2) ==='
   do ist=1,6
      write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)*UNIT_PIEZO_CONST
   end do
end if

end subroutine m_BP_calc_piezoelectric_const

end module m_BP_Properties

program wan_iterp
  implicit none
  integer, parameter :: DP = 8
  real(kind=DP), parameter :: PAI  = 3.141592653589793238462D0
  real(kind=DP), parameter :: PAI2 = PAI*2.d0, PAI4 = PAI*4.d0
  real(kind=DP), parameter :: Hartree = 27.21139615d0

  integer, parameter :: nfwannier = 10
  integer :: i, j, ir, id, jd
  integer :: ikx,iky,ikz,idk
  integer :: nkpt, num_wan, nrpts, num_band_kpt
  integer :: nspin
  integer, allocatable :: ndegen(:), ipos(:,:)
  real(kind=DP) :: altv(3,3), rltv(3,3)
  real(kind=DP) :: v1(3), v2(3)
  real(kind=DP) :: hr, hi
  real(kind=DP) :: efermi
  complex(kind=DP), allocatable :: hmat(:,:,:)
  real(kind=DP), allocatable :: kvec(:,:)
  real(kind=DP), allocatable :: eig(:,:)
  complex(kind=DP), allocatable :: umat(:,:,:)
  real(kind=DP), allocatable :: kpt_band(:,:), klen(:)
  character(len=128) :: seedname
  if(iargc()<1) then
     stop 'wan_interp.x seedname'
  end if
  call getarg(1,seedname)
  
  open(nfwannier,file=trim(seedname)//".nnkp")
  do i=1,5
     read(nfwannier,*)
  end do
  read(nfwannier,*) altv(1:3,1)
  read(nfwannier,*) altv(1:3,2)
  read(nfwannier,*) altv(1:3,3)
     read(nfwannier,*)
     read(nfwannier,*)
     read(nfwannier,*)
  read(nfwannier,*) rltv(1:3,1)
  read(nfwannier,*) rltv(1:3,2)
  read(nfwannier,*) rltv(1:3,3)
     read(nfwannier,*)
     read(nfwannier,*)
     read(nfwannier,*)
  read(nfwannier,*) nkpt
  allocate(kvec(3,nkpt))
  do i=1,nkpt
     read(nfwannier,*) kvec(1:3,i)
  end do
  close(nfwannier)

  write(*,'("Lattice vectors:")')
  do i=1,3
     write(*,'(3(1x,f10.5))') altv(1:3,i)
  end do
  write(*,'("Reciprocal lattice vectors:")')
  do i=1,3
     write(*,'(3(1x,f10.5))') rltv(1:3,i)
  end do
  write(*,'("k-points: nkpt=",i5)') nkpt
  do i=1,nkpt
     write(*,'(3(1x,f10.5))') kvec(1:3,i)
  end do

  open(nfwannier,file=trim(seedname)//"_hr.dat")
     read(nfwannier,*)
  read(nfwannier,*) num_wan
  read(nfwannier,*) nrpts
  allocate(ndegen(nrpts))
  allocate(hmat(num_wan,num_wan,nrpts))
  allocate(ipos(3,nrpts))
  read(nfwannier,*) ndegen(1:nrpts)
  do ir=1,nrpts 
     do j=1,num_wan
        do i=1,num_wan
           read(nfwannier,*) ipos(1:3,ir),id,jd, hr, hi 
           hmat(i,j,ir) = cmplx(hr,hi)
        end do
     end do
  end do
  close(nfwannier)

  write(*,'("Hamiltonian matrix in the WF basis:")')
  do ir=1,nrpts 
     do j=1,num_wan
        do i=1,num_wan
           write(*,'(5i5,2f10.6)') ipos(1:3,ir),i,j,hmat(i,j,ir)
        end do
     end do
  end do

  open(nfwannier,file="kpoint.data")
  read(nfwannier,*) num_band_kpt
  allocate(kpt_band(3,num_band_kpt))
  do i=1,num_band_kpt
     read(nfwannier,*) ikx,iky,ikz,idk
     kpt_band(1,i) = real(ikx)/real(idk)
     kpt_band(2,i) = real(iky)/real(idk)
     kpt_band(3,i) = real(ikz)/real(idk)
  end do
  close(nfwannier)

  allocate(eig(num_wan,num_band_kpt))
  allocate(umat(num_wan,num_wan,num_band_kpt))
  do i=1,num_band_kpt
     call solve_hmat_k(kpt_band(1,i),eig(1,i),umat(1,1,i))
  end do

  efermi = 0.d0
  open(nfwannier,file="nfefermi.data")
  read(nfwannier,*) efermi
  close(nfwannier)
  nspin = 1

  open(nfwannier,file="nfenergy.data")
  write(nfwannier,'(" num_kpoints = ",i6)') num_band_kpt
  write(nfwannier,'(" num_bands   = ",i6)') num_wan
  write(nfwannier,'(" nspin       = ",i6)') nspin
  write(nfwannier,'(" Fermi energy level = ",f10.5)') efermi
  write(nfwannier,*)
  do i=1,num_band_kpt
     write(nfwannier,'("=== energy_eigen_values ===")')
     write(nfwannier,'(" ik = ",i4," (",3f10.6," )")') i,kpt_band(1:3,i)
     write(nfwannier,'(4f18.10)') eig(1:num_wan,i)/Hartree
  end do
  close(nfwannier)
  
contains
 
  subroutine solve_hmat_k(kpt,eig,umat)
    implicit none
    real(kind=DP), intent(in) :: kpt(3)
    real(kind=DP), intent(out) :: eig(num_wan)
    complex(kind=DP), intent(out) :: umat(num_wan,num_wan)
 
    integer :: i,j,ir
    real(kind=DP) :: ph
    complex(kind=DP) :: zf
    complex(kind=DP), allocatable :: hmat_k(:,:)

    character(len=1) :: JOBZ,UPLO
    integer :: lwork, lrwork, info
    complex(kind=DP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork

    allocate(hmat_k(num_wan,num_wan))

    hmat_k = cmplx(0.d0,0.d0)
    do j=1,num_wan
       do i=1,num_wan
          do ir=1,nrpts
             ph = PAI2 * dot_product(kpt,real(ipos(1:3,ir),DP))
             zf = cmplx(cos(ph),sin(ph))/real(ndegen(ir),DP)
             hmat_k(i,j) = hmat_k(i,j) + zf * hmat(i,j,ir)
          end do
       end do
    end do

    JOBZ = 'V'
    UPLO = 'U'
    lwork = max(1,2*num_wan-1)
    lrwork = max(3*num_wan-2,1)

    allocate(work(lwork))
    allocate(rwork(lrwork))
    umat = hmat_k
    call zheev(JOBZ,UPLO,num_wan,umat,num_wan,eig,work,lwork,rwork,info)
    deallocate(work)
    deallocate(rwork)

    deallocate(hmat_k)
  end subroutine solve_hmat_k
  
end program wan_iterp

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 412 $)
!
!  MODULE:  m_ES_WF_by_submat
!
!  AUTHOR(S): Tsuyoshi Miyazaki, T. Yamasaki   August/20/2003
!             Takenori Yamamoto June/22/2005
!  FURTHER MODIFICATION: T. Yamasaki, September 2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

module m_ES_WF_by_submat
! $Id: m_ES_WF_by_submat.F90 412 2014-11-30 12:02:22Z yamasaki $
#define SINGLE_CONTEXT

!!$#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif

#ifndef NO_SUBMAT_DGEMM
#define SUBMAT_DGEMM
#endif

  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF, SmallestPositiveNumber,GAMMA &
       &                          , HOUSEHOLDER, DIVIDEandCONQUER, ELECTRON, CMPLDP, OLD, INVERSE
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,mpi_k_world,ierr,map_z &
       &                          , np_e,npes, nrank_k, nrank_e,mype
  use m_Control_Parameters,  only : nspin,iprisubmat,ldiag,kimg,neg,af &
       &                          , submat_critical_ratio,printable &
       &                          , m_CtrlP_set_submat, sw_scalapack &
       &                          , method_scalapack, block_size, nprow, npcol &
       &                          , msize_submat, sw_hybrid_functional, sw_fef &
       &                          , nblocksize_submat_is_given, nblocksize_submat, nb_submat_default &
       &                          , submat_uncalled &
       &                          , nb_mgs_default &
       &                          , nblocksize_submat_latter_is_given, nblocksize_submat_latter &
       &                          , nblocksize_mgs_is_given                    &
#ifdef SAVE_FFT_TIMES
       &                          , nblocksize_mgs, divide_square, sw_save_fft
#else
       &                          , nblocksize_mgs, divide_square
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, zaj_l_buf,neordr,           nrvf_ordr &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , eko_l,vnlph_l 
  use m_ES_nonlocal,         only : sc ,ss ,qc                                        &
 &                                , m_ES_dealloc_scss_etc
  use m_ES_ortho,            only : np_g1k_x                                          
  use m_Electronic_Structure,only : zaj_ball         &
       &                          , fsr_l_2d,fsi_l_2d,fsr_l,fsi_l  &
       &                          , vlhxc_l                                &
       &                          , m_ES_Vlocal_in_Rspace_3D                          &
       &                          , m_ES_WF_in_Rspace_3D                              &
       &                          , m_ES_wd_zaj_small_portion_3D                      &
       &                          , m_ES_wd_eko_3D                                    &
       &                          , nblocksize_mgs_default
  use m_ES_nonlocal,         only : sc_l                                              &
 &                                , m_ES_Vnonlocal_W_3D                               &
 &                                , m_ES_betar_dot_WFs_4_each_k_3D                    &
 &                                , m_ES_alloc_scss_etc_3D                            
  use m_PseudoPotential,     only : nlmtt
  use m_FFT,                 only : m_FFT_Direct_3D, m_FFT_Direct_XYZ_3D              &
#ifdef FFT_3D_DIVISION
                                  , m_FFT_Direct_3DIV_3D, m_FFT_Vlocal_W_3DIV_3D      &
#endif
       &                          , m_FFT_Vlocal_W_3D
  use m_Parallelization,   only : nel_fft_z, nel_fft_y, nel_fft_x &
       &                        , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel   &
       &                        , mp_fft_x, xyz_fft_x &
       &                        , myrank_g, nrank_g   & 
       &                        , nis_e, nie_e, nel_e &
       &                        , ista_g1k, iend_g1k, mp_g1k, nel_g1k  &
       &                        , mpi_ke_world,  mpi_kg_world, ista_g1k, iend_g1k &
       &                        , nis_g1k, nie_g1k, neg_g, neg_g_all &
       &                        , nel_eg, nis_eg, nie_eg, neg_gg, neg_gg_all, mp_e
!#ifdef _USE_SCALAPACK_
#ifdef EIGEN_TRANS
  use m_Parallelization,     only : make_index_band_for_scalapack                &
       &                          , neg_col, nel_col, nis_col, nie_col, scl_col  &
       &                          , neg_row, nel_row, nis_row, nie_row, scl_row  &
       &                          , scl_comm_max, scl_comm_max_r                 &
       &                          , scl_comm_rank, scl_comm_rank_r               &
       &                          , scl_comm_rno,  scl_comm_rno_r
#endif
!#endif
  use m_Control_Parameters,  only : nblocksize_fftw, nblocksize_fftw_is_given &
       &                          , nblocksize_submat, nblocksize_subspace, sw_fft_xzy
  use m_IterationNumbers,     only : iteration, iteration_electronic, iteration_ionic &
       &                           , m_Iter_set_rmm_start, nk_in_the_process
  use m_ES_ExactExchange,    only : m_ES_Vexx_W
  use m_FiniteElectricField, only : m_FEF_add_grad_to_vnlph


! ================================= added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : ndim_spinor, ndim_chgpot
!  use m_FFT,                   only : m_FFT_Vlocal_W_noncl
!  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
! =================================================================== 11.0

  use m_Control_Parameters, only : sw_rsb

  implicit none
  logical, allocatable, dimension(:) :: non_diagonal_part_is_small

  integer, save :: npart,npart2
  integer, allocatable, save :: isp(:),iep(:)
  integer, allocatable, save :: isp2(:),iep2(:)

  real(kind=DP), allocatable, target, dimension(:,:) :: unimat,unimat_h

  integer, private, save :: lda,occ
#ifdef SINGLE_CONTEXT
   integer, private, allocatable, save :: usermap(:,:)
#else
   integer, private, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif

   logical :: disable_utransform = .false.

  include 'mpif.h'
contains
  subroutine m_ESsubmat_alloc()
    if(.not.allocated(non_diagonal_part_is_small)) then
       allocate(non_diagonal_part_is_small(kv3))
!!$       non_diagonal_part_is_small = .false.
    end if
    non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_alloc

  subroutine m_ESsubmat_dealloc()
    if(allocated(non_diagonal_part_is_small)) deallocate(non_diagonal_part_is_small)
  end subroutine m_ESsubmat_dealloc

  subroutine m_ESsubmat_reset_non_diagon()
    if(allocated(non_diagonal_part_is_small)) non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_reset_non_diagon

  subroutine m_ESsubmat_Renew_WF(nfout,meg,damp)
    integer, intent(in) :: nfout,meg
    real(kind=DP)       :: damp

    integer             :: ispin, iksnl, ik
    real(kind=DP), allocatable, dimension(:,:) ::  afft_l
    real(kind=DP), pointer, dimension(:) :: ekin_l
    integer             :: lsize, ierr

    integer :: n_all_kpoints, n_submat, n_mpi, ipri0
    logical :: submat_is_done

    submat_is_done = .false.
    call m_ES_alloc_scss_etc_3D()
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2,1), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg,1), stat=ierr)
#endif
     if(ierr /= 0) then
        write(nfout,*)' m_ESsubmat_Renew_WF : Not allocated afft_l array'
        call flush(nfout)
        call mpi_abort(mpi_comm_world, 101, ierr)
     endif
    ekin_l => sc_l

    n_all_kpoints = 0
    n_submat = 0
!!$    if(m_CtrlP_ntcnvg_clear()) non_diagonal_part_is_small = .false.
    if(iprisubmat >= 2) write(nfout,'(" !! <<m_ESsubmat_Renew_WF>>")')
    call get_ipri0(iprisubmat,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)


    do ispin = 1, nspin, (af+1)
       !                     timer sta 1 + barrier
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)   ! (ptfft1) vlhxc_l->afft
       !                     timer end 1
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          n_all_kpoints = n_all_kpoints + 1
          if(non_diagonal_part_is_small(ik)) then
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is not done for ik=",i4)') ik
             cycle
          else
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is done for ik=",i4)') ik
             n_submat = n_submat + 1
             submat_is_done = .true.
          end if
          iksnl = (ik-1)/nspin + 1
          !                  timer sta 2 + barrier(myrank_k)
          call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=OFF)  ! (nonloc) ->(vnlph_l)
          !                  timer end 2 + barrier(myrank_k)
! === Support Hybrid on 3D_Parallel by tkato 2013/02/10 ========================
          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
! ==============================================================================
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          call evolve_WFs_in_subspace_3D&     !-(m_ES_WF_by_submat)
                  &(ik,iksnl,ispin,meg,damp,ekin_l,afft_l(1,1),lsize)
          if(ik==1.and.iprisubmat>= 2) &
               & call m_ES_wd_zaj_small_portion_3D(nfout,1," -- after subspace-rotation --",30)
          !                  timer sta 10 + barrier(myrank_k)
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
          !                  timer end 10
       enddo      ! k-point loop
    enddo      ! spin loop


!!$    if(npes > 1) then
!!$       call mpi_allreduce(n_submat,n_submat_mpi,1,mpi_integer,mpi_sum,mpi_k_world(myrank_k),ierr)
!!$       n_submat = n_submat_mpi
!!$    end if

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)
    deallocate(afft_l)
    call m_ES_dealloc_scss_etc()
    if(iprisubmat >= 2) then
       if(submat_is_done) write(nfout,'(" !solver -- subspace_rotation is done for ",i4," of ",i4," kpoints")') &
            & n_submat, n_all_kpoints
       if(.not.submat_is_done) write(nfout,'(" !solver --  no subspace_rotation")')
    end if

    if(nrank_k > 1) then
       call mpi_allreduce(n_submat,n_mpi,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       n_submat = n_mpi
       call mpi_allreduce(n_all_kpoints,n_mpi,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       n_all_kpoints = n_mpi
    end if
    if(submat_is_done .and. n_submat < n_all_kpoints) submat_is_done = .false.
    call m_CtrlP_set_submat(submat_is_done)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESsubmat_Renew_WF




!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
  subroutine evolve_WFs_in_subspace_3D&
       &(ik,iksnl,ispin,meg,damp,ekin_l,afft_l,lsize)
!
! Revised by FUJITSU , March 2010 : MULTI DIMENSION
!
    use m_Parallelization,     only : fft_wf_scnt, fft_wf_rcnt &
   &                                , fft_wf_recv &
   &                                , fft_wf_index, fft_wf_dist &
   &                                , fft_wf_maxrecv, fft_wf_maxsend

    integer, intent(in) :: ik,iksnl,ispin,meg,lsize
    real(kind=DP), intent(in)  :: damp,ekin_l(np_g1k(ik))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(inout) :: afft_l(lsize*2)
#else
    real(kind=DP), intent(inout) :: afft_l(lsize*kimg)
#endif
! (allocatable variables)
! === Debug by Intel "-check all" option! by T.Kato 2011/01/24 =================
!   real(kind=DP), allocatable,dimension(:,:) ::   bfft
! ==============================================================================
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
    real(kind=DP), allocatable,dimension(:,:) ::   w1hw2
!   real(kind=DP), allocatable,dimension(:,:,:) :: zat_wk
    real(kind=DP), allocatable,dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable,dimension(:,:) :: bfft_l

!fj --------------------
!fj real(kind=DP), allocatable :: amat_l_3D(:,:), zmat_l_3D(:,:)
!fj real(kind=DP), allocatable :: wk_amat(:,:)
!fj --------------------
    real(kind=DP), allocatable :: amat_l(:,:)
    real(kind=DP), allocatable :: zmat(:,:), zmat_l(:,:), zmat_l_2D(:,:)
    real(kind=DP), allocatable :: wk_mpi(:,:), wk_gather(:,:,:), wk_ball(:,:,:), wk_meg(:,:,:)
!fj integer, save :: lwork,lrwork,liwork
    integer, save :: lda,occ,lrwork
!#ifdef _USE_SCALAPACK_
    integer, save :: lwork1,lrwork1,liwork1
    integer, save :: lwork2,lrwork2,liwork2
    integer, save :: nb_mgs
    logical, save :: nsame
    integer, save :: nsclrow, nsclcol
    integer, save :: icolor
!#endif
#ifdef SINGLE_CONTEXT
    integer, save :: ictxt, myrow, mycol
#else
    integer, save :: myrow, mycol, tmpctxt
    integer, allocatable, save :: ictxt(:) ! d(0:nrank_k-1)
#endif
    integer, dimension(9), save :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, allocatable, save :: usermap(:,:)
#else
    integer, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif
    integer, allocatable, save :: icol(:)
#ifdef EIGEN_TRANS
    integer, allocatable, save :: irank_c(:)
    integer, allocatable, save :: irank_r(:)
#endif
!!$    integer, save :: npart,npart2
!!$    integer, allocatable, save :: isp(:),iep(:)
!!$    integer, allocatable, save :: isp2(:),iep2(:)
!    logical, save :: first = .true.
    integer :: is,ie,m,jp,ig1
    integer :: maxe, maxeg

!fj integer, allocatable, save, dimension(:) :: G_nel_e,G_nis_e,G_nie_e
!fj integer, dimension(meg) :: G_map_e

    integer       :: ib1,ib2,ib1to,i1,ii, i, kimg_t, iadd, j, k, l, ib1ad, ib2ad
    integer       :: ibsize, iesize, jj 
    real(kind=DP) :: denom, eko1, ekod
    real(kind=DP) :: dr1,dr2,di1,di2, dd
    real(kind=DP) :: sum_sq_diagonal, sum_sq_non_diagonal &
         & , sum_abs_diagonal, sum_abs_non_diagonal
    integer :: id_sname = -1, id_sname2 = -1, ipri0
#ifdef SUBMAT_DGEMM
    real(kind=DP),allocatable,dimension(:,:) :: w1hw2r,w1hw2i
!fj real(kind=DP) :: alpha, beta
    integer :: imax
#endif

    integer :: isrsize, num
    integer, dimension(0:nrank_g-1) ::req_r,req_s
    integer, dimension(MPI_STATUS_SIZE,0:nrank_g-1)::sta_r, sta_s
     real(kind=DP), allocatable, dimension(:,:) :: sendbuf, recvbuf
     integer :: icnt_send, icnt_recv, ierr, lrank
     integer :: itag = 10
! === DEBUG by tkato 2011/10/24 ================================================
     ! Revised by T. Yamasaki 2013/05/14 
     !  real(kind=DP) :: wk1(maxval(np_g1k),neg,kimg)
     real(kind=DP),allocatable,dimension(:,:,:) :: wk1 ! wk1(maxval(np_g1k),neg,kimg)
! ==============================================================================
! === DEBUG by tkato 2012/06/05 ================================================
#ifdef USE_ALLTOALLV
     integer, allocatable, dimension(:) :: sdsp, rdsp
#endif
! ==============================================================================
#ifdef EIGEN_TRANS
#else
! === DEBUG by tkato 2013/09/18 ================================================
     integer, save, dimension(9) :: desc0, desc1
     integer, save               :: ictxt0 ! , ictxt1
! ==============================================================================
#endif
     !                    timer sta 8
     !                    timer_sub sta 901

    call tstatc0_begin('evolve_WFs_in_subspace_3D ', id_sname,1)
    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    allocate(eko_d(neg))
    allocate(eko_d_mpi(neg))
    allocate(eig(meg)); eig=0.d0
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif

!! Not use !!
!   do ib1 = 1, neg
!      if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
!   end do
!   call mpi_allreduce(eko_d,eko_d_mpi,neg,mpi_double_precision,mpi_sum &
!        & ,mpi_k_world(myrank_k),ierr)       ! MPI
!   eko_d = eko_d_mpi                         ! MPI
    eko_d_mpi = 0.0d0
    do ib1 = 1, np_e
       eko_d_mpi(neordr(neg_g(ib1),ik)) = eko_l(ib1,ik)  ! MPI
    end do
    !                   timer_comm sta 914 + barrker(mpi_kg_world)
    call mpi_allreduce(eko_d_mpi,eko_d,neg,mpi_double_precision,mpi_sum &
         & ,mpi_kg_world,ierr)       ! MPI
    !                   timer_comm end 914
    eko1 = sum(eko_d(1:neg))
    allocate(wk1(maxval(np_g1k),neg,kimg))
! === DEBUG by tkato 2011/10/24 ================================================
    wk1 = 0.0d0
    do i = ista_e, iend_e
       wk1(:,i,:) = zaj_l(:,i-ista_e+1,ik,:)
    enddo
    call mpi_allreduce(MPI_IN_PLACE,wk1,maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    do i = 1, neg
       zaj_ball(:,i,ik,:) = wk1(:,i,:)
    enddo
! ==============================================================================
    deallocate(wk1)

    ibsize = 1
    if (nblocksize_fftw_is_given) then
       ibsize = nblocksize_fftw
       if (ibsize < 1) ibsize = 1
    endif
    isrsize = min(lsize,mp_g1k(ik))
! === DEBUG by tkato 2011/07/12 ================================================
!   bfft = 0.0d0
! ==============================================================================

    maxe = mp_g1k(ik)
#ifdef FFT_3D_DIVISION
    allocate(wk_bfft_l(lsize*2,ibsize) ,stat=ierr)
    allocate(bfft_l(lsize*2,ibsize) ,stat=ierr)
#else
    allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
    allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
!   allocate(bfft(nfft,ibsize), stat=ierr)
     if (ierr /= 0) then
        write(nfout,*)' m_ES_WF_in_Rspace_3D :  Not allocate '
        call flush(nfout)
        call mpi_abort(mpi_comm_world, 109, ierr)
     endif

! (zaj_l <- H |phi> )
     !              timer_do sta 960
    do ib1 = 1, np_e, ibsize
       ib2 = min(ib1+ibsize-1,np_e)
       iesize = ib2 - ib1 + 1

#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l, 8)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,iesize,nel_fft_x(myrank_g))
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,iesize,nel_fft_y(myrank_g))
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,iesize,nel_fft_z(myrank_g))
       end if
#endif
       !         timer_comm sta 962
#ifdef FFT_3D_DIVISION
       call m_FFT_Direct_3DIV_3D (nfout, wk_bfft_l, lsize, iesize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Direct_3D (nfout, wk_bfft_l, lsize, iesize)
       else
          call m_FFT_Direct_XYZ_3D (nfout, wk_bfft_l, lsize, iesize)
       endif
#endif
       !         timer_comm end 962

       if (fft_wf_maxsend(ik) /= 0) then
          allocate(sendbuf(fft_wf_maxsend(ik)*kimg*ibsize,0:nrank_g-1), stat=ierr)
          sendbuf = 0.0d0
! === DEBUG by tkato 2012/06/05 ================================================
       else
          allocate(sendbuf(1,1), stat=ierr)
! ==============================================================================
       endif
       if (fft_wf_maxrecv(ik) /= 0) then
          allocate(recvbuf(fft_wf_maxrecv(ik)*kimg*ibsize,0:nrank_g-1), stat=ierr)
          recvbuf = 0.0d0
! === DEBUG by tkato 2012/06/05 ================================================
       else
          allocate(recvbuf(1,1), stat=ierr)
! ==============================================================================
       endif
        if (ierr /= 0) then
           write(nfout,*)' evolve_WFs_in_subspace_3D :  Not allocate '
           call flush(nfout)
           call mpi_abort(mpi_comm_world, 110, ierr)
        endif

    req_r = 0
    req_s = 0
    sta_r = 0
    sta_s = 0
       if (fft_wf_maxrecv(ik) /= 0) then
          icnt_recv = 0
          lrank = mod(myrank_g,nrank_g)
#ifndef USE_ALLTOALLV
          !    timer_comm sta 915 + barrier(mpi_ke_world)
#endif
          do i = 0, nrank_g - 1
             lrank = lrank + 1
             if (lrank > nrank_g -1) lrank = 0
             if (fft_wf_rcnt(lrank,ik) /= 0) then
#ifndef USE_ALLTOALLV
                call mpi_irecv(recvbuf(1,lrank), fft_wf_rcnt(lrank,ik)*kimg*iesize, &
               &     mpi_double_precision, lrank, itag, mpi_ke_world, req_r(icnt_recv), ierr)
                 if (ierr /= 0) then
                    write(nfout,*)' evolve_WFs_in_subspace_3D :  mpi_irecv error'
                    call flush(nfout)
                    call mpi_abort(mpi_comm_world, 111, ierr)
                 endif
#endif
                icnt_recv = icnt_recv + 1
             endif
          enddo
       endif
       !     timer_do sta 916
       if (fft_wf_maxsend(ik) /= 0) then 
          if (kimg == 1) then
#ifdef FFT_3D_DIVISION
          integer :: i1, lx, ly, lz, mx, my, mz, mm, kx1p, kx2p, kx3p, jadd
             lx = fft_box_size_WF(1,0)
             ly = fft_box_size_WF(2,0)
             lz = fft_box_size_WF(3,0)
             kx1p = fft_X_x_nel
             kx2p = fft_X_y_nel
             kx3p = fft_X_z_nel
!OCL NORECURRENCE
             do k = 1, nel_fft_x(myrank_g)
                if(fft_wf_index(k,ik) == 0) cycle
                i1 = mp_fft_x(k)
                mz = (i1-1)/(lx*ly)+1
                mm = mod(i1,(lx*ly))
                if (mm==0) mm=lx*ly
                my = (mm-1)/lx+1
                mx = mod(mm,lx)
                if (mx==0) mx = lx
                jadd = mx-xyz_fft_x(1,1)+1+kx1p*(my-xyz_fft_x(1,2))+kx1p*kx2p*(mz-xyz_fft_x(1,3))
                do i = 1, iesize
                   sendbuf(iesize*(fft_wf_index(k,ik)-1)+i,fft_wf_dist(k,ik)) = wk_bfft_l(jadd*2-1,i)
                enddo
             end do

#else
!OCL NORECURRENCE
             do k = 1, nel_fft_x(myrank_g)
                if(fft_wf_index(k,ik) == 0) cycle
                do i = 1, iesize
                   sendbuf(iesize*(fft_wf_index(k,ik)-1)+i,fft_wf_dist(k,ik)) = wk_bfft_l(k,i)
                enddo
             end do
#endif
          else
#ifdef FFT_3D_DIVISION
             lx = fft_box_size_WF(1,0)
             ly = fft_box_size_WF(2,0)
             lz = fft_box_size_WF(3,0)
             kx1p = fft_X_x_nel
             kx2p = fft_X_y_nel
             kx3p = fft_X_z_nel
!OCL NORECURRENCE
             do k = 1, nel_fft_x(myrank_g)
                if(fft_wf_index(k,ik) == 0) cycle
                i1 = mp_fft_x(k)
                mz = (i1-1)/(lx*ly)+1
                mm = mod(i1,(lx*ly))
                if (mm==0) mm=lx*ly
                my = (mm-1)/lx+1
                mx = mod(mm,lx)
                if (mx==0) mx = lx
                jadd = mx-xyz_fft_x(1,1)+1+kx1p*(my-xyz_fft_x(1,2))+kx1p*kx2p*(mz-xyz_fft_x(1,3))
                do i = 1, iesize
                   iadd = iesize*2*(fft_wf_index(k,ik)-1)+i*2
                   sendbuf(iadd-1,fft_wf_dist(k,ik)) = wk_bfft_l(jadd*2-1,i)
                   sendbuf(iadd,  fft_wf_dist(k,ik)) = wk_bfft_l(jadd*2  ,i)
                enddo
             end do
#else
!OCL NORECURRENCE
             do k = 1, nel_fft_x(myrank_g)
                if(fft_wf_index(k,ik) == 0) cycle
                do i = 1, iesize
                   iadd = iesize*2*(fft_wf_index(k,ik)-1)+i*2
                   sendbuf(iadd-1,fft_wf_dist(k,ik)) = wk_bfft_l(k*2-1,i)
                   sendbuf(iadd,  fft_wf_dist(k,ik)) = wk_bfft_l(k*2  ,i)
                enddo
             end do
#endif
          end if
       end if
       !     timer_do end 916

       if (fft_wf_maxsend(ik) /= 0) then
          icnt_send = 0
          lrank = mod((myrank_g+1),nrank_g)
          do i = 0, nrank_g - 1
             lrank = lrank + 1
             if (lrank > (nrank_g - 1)) lrank = 0
             if (fft_wf_scnt(lrank,ik) /= 0) then
#ifndef USE_ALLTOALLV
                call mpi_isend(sendbuf(1,lrank), fft_wf_scnt(lrank,ik)*kimg*iesize, &
               &     mpi_double_precision, lrank, itag, mpi_ke_world, req_s(icnt_send), ierr)
                 if (ierr /= 0) then
                    write(nfout,*)' evolve_WFs_in_subspace_3D :  mpi_isend error'
                    call flush(nfout)
                    call mpi_abort(mpi_comm_world, 112, ierr)
                 endif
#endif
                icnt_send = icnt_send + 1
             endif
          enddo
       endif

#ifndef USE_ALLTOALLV
       if (fft_wf_maxrecv(ik) /= 0) then
          call mpi_waitall(icnt_recv, req_r, sta_r, ierr)
           if (ierr /= 0) then
              write(nfout,*)' evolve_WFs_in_subspace_3D :  mpi_waitall error'
              call flush(nfout)
              call mpi_abort(mpi_comm_world, 113, ierr)
           endif
       endif

       if (fft_wf_maxsend(ik) /= 0) then
          call mpi_waitall(icnt_send, req_s, sta_s, ierr)
           if (ierr /= 0) then
              write(nfout,*)' evolve_WFs_in_subspace_3D :  mpi_waitall error'
              call flush(nfout)
              call mpi_abort(mpi_comm_world, 114, ierr)
           endif
       endif
       !     timer_comm end 915
#else
       !     timer_comm sta 994 + barrier(mpi_ke_world)
! === DEBUG by tkato 2012/06/05 ================================================
!      integer, allocatable, dimension(:) :: sdsp, rdsp
! ==============================================================================
       allocate(sdsp(0:nrank_g-1), stat=ierr)
       allocate(rdsp(0:nrank_g-1), stat=ierr)
       do i = 0, nrank_g - 1
          sdsp(i)=fft_wf_maxsend(ik)*kimg*ibsize*i
          rdsp(i)=fft_wf_maxrecv(ik)*kimg*ibsize*i
       enddo
       call MPI_ALLTOALLV(      sendbuf, fft_wf_scnt(:,ik)*kimg*iesize, sdsp, &
      &   mpi_double_precision, recvbuf, fft_wf_rcnt(:,ik)*kimg*iesize, rdsp, &
      &   mpi_double_precision, mpi_ke_world, ierr )
       if (ierr /= 0) then
          write(nfout,*)' evolve_WFs_in_subspace_3D :  mpi_alltoallv error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 115, ierr)
       endif
       deallocate(sdsp)
       deallocate(rdsp)
       !     timer_comm end 994
#endif

       bfft_l = 0.0d0
       !    timer_do sta 917
       if (kimg == 1) then
!x!OCL NORECURRENCE
          do i = 0, nrank_g - 1
             if (fft_wf_rcnt(i,ik) /= 0) then
                do k = 1, fft_wf_rcnt(i,ik)
                   do j = 1, iesize
                      bfft_l(fft_wf_recv(k,ik,i),j) = recvbuf(iesize*(k-1)+j,i)
                   enddo
                end do
             end if
          end do
       else
!x!OCL NORECURRENCE
          do i = 0, nrank_g - 1
             if (fft_wf_rcnt(i,ik) /= 0) then
                do k = 1, fft_wf_rcnt(i,ik)
                   do j = 1, iesize
                      iadd = iesize*2*(k-1)+j*2
                      bfft_l(fft_wf_recv(k,ik,i)*2-1,j) = recvbuf(iadd-1,i)
                      bfft_l(fft_wf_recv(k,ik,i)*2  ,j) = recvbuf(iadd,  i)
                   enddo
                end do
             end if
          end do
       end if
       !     timer_do end 917

       if (allocated(sendbuf)) deallocate(sendbuf)
       if (allocated(recvbuf)) deallocate(recvbuf)

       !     timer_do sta 918
       if(kimg == 1) then
!x!OCL NORECURRENCE
          do ii=ista_g1k(ik), iend_g1k(ik)
             i1  = igf(nbase(ii,ik))
             iadd = ii-ista_g1k(ik)+1
             do jj = ib1, ib2
!fj --------------------
                if(neg_g(jj)>meg) cycle
!fj --------------------
                dr1 = zaj_l(iadd,jj,ik,1)
                dr2 = bfft_l(iadd,jj-ib1+1)*denom
                zaj_l(iadd,jj,ik,1)= ekin_l(iadd)*dr1+vnlph_l(iadd,jj,1)+dr2
             enddo
          enddo
       else
!x!OCL NORECURRENCE
           do ii=ista_g1k(ik), iend_g1k(ik)
              i1  = igf(nbase(ii,ik))
              iadd = ii-ista_g1k(ik)+1
              do jj = ib1, ib2
!!fj --------------------
                 if(neg_g(jj)>meg) cycle
!!fj --------------------
                 dr1  = zaj_l(iadd,jj,ik,1)
                 di1  = zaj_l(iadd,jj,ik,2)
                 zaj_l(iadd,jj,ik,1)= ekin_l(iadd)*dr1+bfft_l(2*iadd-1,jj-ib1+1)*denom+vnlph_l(iadd,jj,1)
                 zaj_l(iadd,jj,ik,2)= ekin_l(iadd)*di1+bfft_l(2*iadd  ,jj-ib1+1)*denom+vnlph_l(iadd,jj,2)
              enddo
           enddo
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib1:ib2,ik) = OLD
#endif

       !    timer_do end 918

    end do
    !       timer_do end 960

    deallocate(wk_bfft_l)

    if(submat_uncalled) then
       call set_col_partition_3D(neg) ! -> npart,isp,iep, npart2, isp2, iep2
!      call set_block_range(meg,nrank_g,G_nel_e,G_nis_e,G_nie_e,G_map_e)
    end if
    maxe = maxval(nel_e(:))
    maxeg = maxval(nel_eg(:))

! (make matrix elements )
#ifdef _USE_SCALAPACK_
    if(sw_scalapack == ON) then
       if(submat_uncalled) then
          if(iprisubmat >= 2) write(nfout,'("first nprow,npcol=",2i5)') nprow,npcol
!fj --------------------
          if(nblocksize_mgs_is_given) then
             nb_mgs = nblocksize_mgs
          else
             nb_mgs = nblocksize_mgs_default
          end if
!fj    -----------------
          if (nprow==0 .or. npcol==0 .or. nprow*npcol > nrank_g*nrank_e) then

             nprow = int(sqrt(real(nrank_e*nrank_g)))

             if (divide_square > 0) then
                npcol = nprow
             else
                do
                   if ( nprow <= 1 ) exit
                   if ( mod(nrank_g*nrank_e,nprow) == 0 ) exit
                   nprow = nprow-1
                end do
                npcol = nrank_g*nrank_e/nprow
             endif
          endif
!xx       if(nprow*npcol /= nrank_g*nrank_e) then
!xx          method_scalapack=HOUSEHOLDER
!xx          write(nfout,'("ScaLAPACK METHOD ---> HOUSEHOLDER")')
!xx       end if
!fj    -----------------
          call set_nprow_npcol(nprow,npcol)
#ifdef SINGLE_CONTEXT
          if(allocated(usermap)) deallocate(usermap)
          allocate(usermap(nprow,npcol))
#else
          if(allocated(ictxt)) deallocate(ictxt)
          if(allocated(usermap)) deallocate(usermap)
          allocate(ictxt(0:nrank_k-1))
          allocate(usermap(nprow,npcol,0:nrank_k-1))
#endif
          allocate(icol(0:nrank_e*nrank_g*nrank_k-1))
#ifdef EIGEN_TRANS
          allocate(irank_c(0:nrank_e*nrank_g*nrank_k-1))
          allocate(irank_r(0:nrank_e*nrank_g*nrank_k-1))
#endif
          nsclrow = nprow
          nsclcol = npcol
#ifdef USE_EIGENLIB
          nsame = .false.
          block_size = 1

#ifdef EIGEN_TRANS
          call eigen_setup(meg,block_size,nprow,npcol,lda,occ,icolor,ictxt,usermap,icol,irank_c,irank_r)
#else
          call eigen_setup(meg,block_size,nprow,npcol,lda,occ,icolor,ictxt,usermap,icol)
#endif
          if(iprisubmat > 0) then
             write(nfout,'("eigenlib_setup")')
             write(nfout,'("nprow=",i4,", npcol=",i4,", neg=",i6,", meg=",i6)') nprow,npcol,neg,meg
             write(nfout,'("lda=",i4,", occ=",i4,", block_size=",i4)') lda,occ,block_size
             write(nfout,'("maxeg=",i4,", mp_e=",i4,", nsame=",l4)')   maxeg, mp_e ,nsame
             write(nfout,'("nsclrow=",i4,", nsclcol=",i4)') nsclrow, nsclcol
             call flush(nfout)
          endif
#else
          if(block_size == 0) then
             block_size = nb_mgs
          end if
#if defined(ASSIGN_G_PREVIOUS) || defined(_ASSIGN_ROW_)
          nsame = .false.
#else
          if(nprow==nrank_g .and. npcol==nrank_e .and. block_size==nb_mgs) then
             nsame = .true.
          else
             nsame = .false.
          endif
#endif

!s        call scalapack_setup_3D(meg,lwork,lrwork,liwork,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#ifdef EIGEN_TRANS
          call scalapack_setup_3D(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,&
         & ictxt,myrow,mycol,desca,descz,usermap,icolor,icol,irank_c,irank_r)
#else
          call scalapack_setup_3D(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,&
         & ictxt,myrow,mycol,desca,descz,usermap,icolor,icol)
#endif
          if(iprisubmat > 0) then
             write(nfout,'("scalapack_setup")')
             write(nfout,'("nprow=",i4,", npcol=",i4,", neg=",i6,", meg=",i6)') nprow,npcol,neg,meg
             write(nfout,'("lda=",i4,", occ=",i4,", block_size=",i4)') lda,occ,block_size
             write(nfout,'("maxeg=",i4,", mp_e=",i4,", nsame=",l4)')   maxeg, mp_e ,nsame
             write(nfout,'("nsclrow=",i4,", nsclcol=",i4)') nsclrow, nsclcol
             write(nfout,'("lwork1=",i9,", lrwork1=",i9,", liwork1=",i9)') lwork1,lrwork1,liwork1
             write(nfout,'("lwork2=",i9,", lrwork2=",i9,", liwork2=",i9)') lwork2,lrwork2,liwork2
             write(nfout,'("scalapack nprow=",i4,", npcol=",i4,", block_size=",i4)') nprow,npcol,block_size
             call flush(nfout)
          endif
#endif
!endif ifdef USE_EIGENLIB
!fj --------------------
          if (.not. nsame) then
             !      timer_sub sta 1470

#ifdef EIGEN_TRANS
#ifdef EIGEN_6D
          call make_index_band_for_scalapack(neg, meg, nb_mgs, block_size, nsclrow, nsclcol, usermap, irank_c, irank_r)
#else
          call make_index_band_for_scalapack(neg, meg, nb_mgs, block_size, nsclrow, nsclcol)
#endif
#else
! === DEBUG by tkato 2013/09/18 ================================================
!            integer, save, dimension(9) :: desc0, desc1
!            integer, save               :: ictxt0 ! , ictxt1
! ==============================================================================

             call blacs_get(-1, 0, ictxt0)
             call blacs_gridinit(ictxt0, "R", nrank_g, nrank_e)

             ierr=0
             call descinit(desc0, neg, neg, nb_mgs,     nb_mgs,     0, 0, ictxt0, maxeg, ierr)
             desc1(1) = 1
             desc1(2) = ictxt
             desc1(3) = meg
             desc1(4) = meg
             desc1(5) = block_size
             desc1(6) = block_size
             desc1(7) = 0
             desc1(8) = 0
             desc1(9) = lda
             if(iprisubmat > 0) then
               write(nfout,*) 'usermap=',usermap(:,:)
               write(nfout,'("neg=",i6,", meg=",i6)') neg,meg
               write(nfout,'("nprow  =",i6,", npcol  =",i6)') nprow,npcol
               write(nfout,'("nsclrow=",i6,", nsclcol=",i6)') nsclrow,nsclcol
               write(nfout,'("nb_mgs    =",i6,", maxeg=",i6,", maxe=",i6)') nb_mgs,maxeg,maxe
               write(nfout,'("block_size=",i6,", lda  =",i6,", occ =",i6)') block_size,lda,occ
               write(nfout,'("desc0=",9(1x,i6))') desc0
               write(nfout,'("desc1=",9(1x,i6))') desc1
             end if
#endif

             !  timer_sub end 1470
          end if
       end if
!fj --------------------
!fj    allocate(zmat_l(lda*kimg_t,occ))
       allocate(zmat_l(maxeg*kimg_t,maxe))
!fj --------------------
       zmat_l = 0.0d0
!fj --------------------
!s     allocate(amat_l(maxeg*kimg_t,maxe))
       allocate(amat_l(lda*kimg_t,occ))
!fj --------------------
       amat_l = 0.0d0
    else
       allocate(zmat(meg*kimg_t,meg))
       zmat = 0.0d0
       allocate(zmat_l(maxeg*kimg_t,maxe))
! === DEBUG by Tkato 2011/06/28 ================================================
       lda = maxeg
       occ = maxe
! ==============================================================================
       zmat_l = 0.0d0
    end if
#else
    sw_scalapack = OFF
    allocate(zmat(meg*kimg_t,meg))
    zmat = 0.0d0
    allocate(zmat_l(nel_eg(myrank_g)*kimg_t,np_e))
    zmat_l = 0.0d0
#endif
    if(submat_uncalled) then
       submat_uncalled = .false.
    end if
    call tstatc0_begin('evolve_WFs_in_subspace_3D(PART1) ', id_sname2)

    allocate(wk_ball(maxval(np_g1k),neg,kimg), stat=ierr)
!!
!!  order of eigenvalue B-block cyclic  ->  order of eigenvalue
!!
    !       timer_do sta 919
    do j = 1, neg
      do i = 1, np_g1k(ik)
         wk_ball(i,neg_g_all(j),1) = zaj_ball(i,j,ik,1)
      enddo
    enddo
    if (kimg == 2) then
      do j = 1, neg
        do i = 1, np_g1k(ik)
          wk_ball(i,neg_g_all(j),2) = zaj_ball(i,j,ik,2)
        enddo
      enddo
    end if
    !      timer_do end 919
!!
!!  order of eigenvalue  ->  order of eigenvalue G-block cyclic
!!
    !      timer_do sta 920
    do j = 1, neg
      do i = 1, np_g1k(ik)
        zaj_ball(i,j,ik,1) = wk_ball(i,neg_gg_all(j),1)
      enddo
    enddo
    if (kimg == 2) then
      do j = 1, neg
        do i = 1, np_g1k(ik)
          zaj_ball(i,j,ik,2) = wk_ball(i,neg_gg_all(j),2)
        enddo
      enddo
    end if

    !    timer_do end 920
    deallocate(wk_ball)

    ekod = 0.d0
    sum_abs_diagonal = 0.d0
    sum_sq_diagonal = 0.d0
    sum_sq_non_diagonal = 0.d0
    sum_abs_non_diagonal = 0.d0
    PART1: do jp = 1, npart
       is = isp(jp)
       ie = iep(jp)
       allocate(w1hw2((ie-is+1)*kimg_t,np_e))
       w1hw2 = 0.d0
#ifdef SUBMAT_DGEMM
       ibsize = min(ie,neg)-is+1
       imax = maxval(np_g1k(:))
       if(kimg==1) then
          !                       timer_dgemm sta 921
          call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,1),imax &
               &            ,zaj_l(1,1,ik,1),imax,1.d0,w1hw2(1,1),ibsize)
          !                       timer_dgemm end 921
       else
          if(k_symmetry(ik) == GAMMA) then
             !                    timer_dgemm sta 922
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,1),imax &
                  &         ,zaj_l(1,1,ik,1),imax,1.d0,w1hw2(1,1),ibsize)
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,2),imax &
                  &         ,zaj_l(1,1,ik,2),imax,1.d0,w1hw2(1,1),ibsize)
             !                    timer_dgemm end 922
             w1hw2 = w1hw2*2.d0
             if(myrank_g == 0) then
                !                 timer_do sta 923
                do ib1 = is, ie
                   do ib2 = 1, np_e
                      w1hw2(ib1-is+1,ib2) = w1hw2(ib1-is+1,ib2) & 
                     &                     - 2.d0*zaj_l(1,ib2,ik,2)*zaj_ball(1,ib1,ik,2) &
                     &                          - zaj_l(1,ib2,ik,1)*zaj_ball(1,ib1,ik,1)
                   end do
                end do
                !                 timer_do end 923
             end if
          else
             allocate(w1hw2r((ie-is+1),np_e))
              if (ierr /= 0) then
                 call mpi_abort(mpi_comm_world, 115, ierr)
              end if
             w1hw2r = 0.d0
             allocate(w1hw2i((ie-is+1),np_e))
              if (ierr /= 0) then
                 call mpi_abort(mpi_comm_world, 116, ierr)
              end if
             w1hw2i = 0.d0
                !                 timer_do sta 924
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,1),imax &
                  &                 , zaj_l(1,1,ik,1),imax,1.d0,w1hw2r(1,1),ibsize)
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,2),imax &
                  &                 , zaj_l(1,1,ik,2),imax,1.d0,w1hw2r(1,1),ibsize)
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),1.d0,zaj_ball(1,is,ik,2),imax &
                  &                 , zaj_l(1,1,ik,1),imax,1.d0,w1hw2i(1,1),ibsize)
             call dgemm('T','N',ibsize,np_e,np_g1k(ik),-1.d0,zaj_ball(1,is,ik,1),imax &
                  &                 , zaj_l(1,1,ik,2),imax,1.d0,w1hw2i(1,1),ibsize)
                !                 timer_do end 924
                !                 timer_do sta 925
             do ib1 = is, min(ie,neg)
                do ib2 = 1, np_e
                   w1hw2((ib1-is+1)*2-1,ib2) = w1hw2r(ib1-is+1,ib2)
                   w1hw2((ib1-is+1)*2  ,ib2) = w1hw2i(ib1-is+1,ib2)
                end do
             end do
                !                 timer_do end 925
             deallocate(w1hw2i)
             deallocate(w1hw2r)
          end if
       end if
#else
                !                 timer_do sta 926
       do ib1 = is, ie
!fj --------------------
          if (neg_g_all(ib1)>meg) cycle
!fj --------------------
          ib1ad = ib1-is+1
          do ib2 = 1, np_e
!fj --------------------
             if (neg_g(ib2)>meg) cycle
!fj --------------------
             if(kimg == 1) then
                do ii = 1, np_g1k(ik)              ! MPI
                   dr1 = zaj_l(ii,ib2,ik,1)
                   dr2 = zaj_ball(ii,ib1,ik,1)
                   w1hw2(ib1ad,ib2) = w1hw2(ib1ad,ib2) + dr1*dr2
                end do
             else
                if(k_symmetry(ik) == GAMMA) then
                   dd = 0.d0
                   ig1 = 1
                   if(myrank_g == 0) ig1 = 2
                   do ii = ig1, np_g1k(ik)            ! MPI
                      dr1 = zaj_l(ii,ib2,ik,1)
                      di1 = zaj_l(ii,ib2,ik,2)
                      dr2 = zaj_ball(ii,ib1,ik,1)
                      di2 = zaj_ball(ii,ib1,ik,2)
                      dd = dd + (dr1*dr2+di1*di2)*2.d0
                   end do
                   if(myrank_g == 0) dd = dd + zaj_l(1,ib2,ik,1)*zaj_ball(1,ib1,ik,1)
                   w1hw2(ib1ad,ib2)=dd
                else
                   do ii = 1, np_g1k(ik)             ! MPI
                      dr1 = zaj_l(ii,ib2,ik,1)
                      di1 = zaj_l(ii,ib2,ik,2)
                      dr2 = zaj_ball(ii,ib1,ik,1)
                      di2 = zaj_ball(ii,ib1,ik,2)
                      w1hw2(ib1ad*2-1,ib2)=w1hw2(ib1ad*2-1,ib2)+dr1*dr2+di1*di2
                      w1hw2(ib1ad*2  ,ib2)=w1hw2(ib1ad*2  ,ib2)+dr1*di2-di1*dr2
                   end do
                end if
             end if
          end do
       end do
                !                 timer_do end 926
#endif

!! (off-diagonal matrix elements will be damped.)
                !                 timer_do sta 927
       if(kimg_t == 1) then
!OCL PARALLEL
          do ib1=is,ie
             ib1ad = ib1-is+1
             do ib2=ista_e,iend_e
                ib2ad = ib2-ista_e+1
                if (neg_g(ib2ad) /= neg_gg_all(ib1)) then
                   sum_sq_non_diagonal = sum_sq_non_diagonal + w1hw2(ib1ad,ib2ad)*w1hw2(ib1ad,ib2ad)
                   sum_abs_non_diagonal = sum_abs_non_diagonal + abs(w1hw2(ib1ad,ib2ad))
                   w1hw2(ib1ad,ib2ad) = damp*w1hw2(ib1ad,ib2ad)
                else
                   sum_sq_diagonal = sum_sq_diagonal + w1hw2(ib1ad,ib2ad)**2
                   sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(ib1ad,ib2ad))
                   ekod = ekod + w1hw2(ib1ad,ib2ad)
                endif
             enddo
          enddo
       else
!OCL PARALLEL
          do ib1=is,ie
             ib1ad = ib1-is+1
             do ib2=ista_e,iend_e
                ib2ad = ib2-ista_e+1
                if (neg_g(ib2ad) /= neg_gg_all(ib1)) then
                   dd = w1hw2(2*ib1ad-1,ib2ad)*w1hw2(2*ib1ad-1,ib2ad) &
                  &   + w1hw2(2*ib1ad,  ib2ad)*w1hw2(2*ib1ad,  ib2ad)
                   sum_sq_non_diagonal = sum_sq_non_diagonal + dd
                   if(dd >= SmallestPositiveNumber) then
                      sum_abs_non_diagonal = sum_abs_non_diagonal + sqrt(dd)
                   endif
                   w1hw2(2*ib1ad-1,ib2ad) = damp*w1hw2(2*ib1ad-1,ib2ad)
                   w1hw2(2*ib1ad  ,ib2ad) = damp*w1hw2(2*ib1ad  ,ib2ad)
                else
                   sum_sq_diagonal = sum_sq_diagonal + w1hw2(2*ib1ad-1,ib2ad)**2
                   sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(2*ib1ad-1,ib2ad))
                   ekod = ekod + w1hw2(2*ib1ad-1,ib2ad)
                endif
             enddo
          enddo
       endif
                !                 timer_do end 927

#ifdef _USE_SCALAPACK_
       if(sw_scalapack==ON) then
          call set_hmat_3D_scl(neg,w1hw2,zmat_l)
       else
          call set_hmat_3D(neg,w1hw2,zmat_l)
       end if
#else
       call set_hmat_3D(neg,w1hw2,zmat_l)
#endif
       deallocate(w1hw2)
    end do PART1

    call tstatc0_end(id_sname2)
    !                             timer end 8 + barrier(myrank_k)
    !                             timer sta 9
    !                             timer sta 1500

    if(sw_scalapack == ON) then
       if(nsame) then
          !                       timer_do sta 981
          if (kimg_t == 1) then
             do j = 1, np_e
                if (neg_g(j) > meg) cycle
                do i = 1, nel_eg(myrank_g)
                   if (neg_gg(i) > meg) cycle
                   amat_l(i,j) = zmat_l(i,j)
                enddo
             enddo
          else
             do j = 1, np_e
                if (neg_g(j) > meg) cycle
                do i = 1, nel_eg(myrank_g)
                   if (neg_gg(i) > meg) cycle
                   amat_l(i*2-1,j) = zmat_l(i*2-1,j)
                   amat_l(i*2  ,j) = zmat_l(i*2  ,j)
                enddo
             enddo
          end if
          !                       timer_do end 981
       else
!fj --------------------s
          !                       timer_sub sta 964
#ifdef EIGEN_TRANS
#ifdef EIGEN_6D
          call trans_scalapack(neg, meg, nb_mgs, block_size, zmat_l, amat_l, &
         &                     maxeg, maxe, lda, occ, kimg_t, usermap, irank_c, irank_r)
#else
          call trans_scalapack(neg, meg, nb_mgs, block_size, zmat_l, amat_l, &
         &                     maxeg, maxe, lda, occ, kimg_t)
#endif
#else
          if(kimg_t == 1) then
            call pdgemr2d(meg, meg, zmat_l, 1, 1, desc0, amat_l, 1, 1, desc1, ictxt0)
          else
            call pzgemr2d(meg, meg, zmat_l, 1, 1, desc0, amat_l, 1, 1, desc1, ictxt0)
          endif
#endif
          !                       timer_sub end 964
!!$#if 0
!!$          allocate(zmat(neg*kimg_t,neg),stat=j)
!!$          zmat = 0.0d0
!!$          call gather_zmat_all(zmat_l,zmat)
!!$          call get_zmat(lda,occ,amat_l,neg,nsclrow,nsclcol,block_size,usermap,1,neg,zmat)
!!$          deallocate(zmat)
!!$#else
!!$          call trans_scalapack(neg, meg, nb_mgs, block_size, zmat_l, amat_l, &
!!$         &                     maxeg, maxe, lda, occ, kimg_t)
!!$#endif
!fj --------------------t
       end if
       deallocate(zmat_l)
       allocate(zmat_l(lda*kimg_t,occ))
       zmat_l = 0.0d0
    else
       call gather_zmat_all(zmat_l,zmat)
    endif

    sum_abs_diagonal = sum_abs_diagonal/meg
    sum_abs_non_diagonal = sum_abs_non_diagonal/(meg*(meg-1)/2)

!! (Diagonalization )  !!

#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
        !      timer end 1500 + barrier(myrank_k)
#ifdef USE_EIGENLIB
     if (icolor == 1) then
        if(kimg_t == 1) then
           call eigen_solver(lda,occ)
        else
           call eigen_solver_h(lda,occ)
        endif
     endif
#else
     if (myrow /= -1) then
        if(kimg_t == 1) then
           call pdsyev_driver_3D(meg,eig,desca,descz,lda,occ,amat_l,zmat_l,lwork1,liwork1)
        else
           call pzheev_driver_3D(meg,eig,desca,descz,lda,occ,amat_l,zmat_l,lwork2,lrwork2,liwork2)
        end if
     end if
#endif
     !          timer sta 1500 + barrier(myrank_k)
        if (nrank_e*nrank_g /= nsclcol*nsclrow) then
           call eigsend()
        end if
! ** dummy ** !
        !       timer_sub sta 988
        !       timer_sub end 988
        !       timer_comm sta 989
        !       timer_comm sta 990
        !       timer_comm end 989
        !       timer_comm end 990

     else
        if(kimg_t == 1) then
           call dsyev_driver(meg,eig,zmat)
        else
           call zheev_driver(meg,eig,zmat)
        endif
     endif
#else
     if(kimg_t == 1) then
       call dsyev_driver(meg,eig,zmat)
     else
       call zheev_driver(meg,eig,zmat)
     endif
#endif

     if (sw_scalapack == ON) then
        if (.not.nsame) then
!fj --------------------s
#if 0
           allocate(zmat(neg*kimg_t,neg),stat=j)
           zmat = 0.0d0
           call put_zmat(kimg_t,lda,maxe,zmat_l,neg,nsclrow,nsclcol,block_size,usermap,1,neg,zmat) ! zmat_l->zmat
           allocate(zmat_l_2D(neg*kimg_t,np_e), stat=ierr)
           zmat_l_2D = 0.0d0
           if(kimg_t == 1) then
              do i = 1, np_e
                 if (neg_g(i) > meg) cycle
                 do j = 1, neg
                    if (neg_g_all(j) > meg) cycle
                    zmat_l_2D(j,i) = zmat(neg_g_all(j),neg_g(i))
                 enddo
              end do
           else
              do i = 1, np_e
                 if (neg_g(i) > meg) cycle
                 do j = 1, neg
                    if (neg_g_all(j) > meg) cycle
                    zmat_l_2D(j*2-1,i) = zmat(neg_g_all(j)*2-1,neg_g(i))
                    zmat_l_2D(j*2  ,i) = zmat(neg_g_all(j)*2  ,neg_g(i))
                 enddo
              end do
           endif
           deallocate(zmat)
#else
           deallocate(amat_l)
           allocate(amat_l(maxeg*kimg_t,maxe))
           amat_l = 0.0d0
           !           timer_sub sta 965
#ifdef EIGEN_TRANS
#ifdef EIGEN_6D
           call trans_scalapack_r(neg, meg, nb_mgs, block_size, zmat_l, amat_l, maxeg, maxe, lda, occ, kimg_t, usermap, irank_c, irank_r)
#else
           call trans_scalapack_r(neg, meg, nb_mgs, block_size, zmat_l, amat_l, maxeg, maxe, lda, occ, kimg_t)
#endif
#else
           if(kimg_t == 1) then
              call pdgemr2d(meg, meg, zmat_l, 1, 1, desc1, amat_l, 1, 1, desc0, ictxt0)
           else
              call pzgemr2d(meg, meg, zmat_l, 1, 1, desc1, amat_l, 1, 1, desc0, ictxt0)
           endif
#endif
           !           timer_sub end 965
           allocate(wk_gather(maxeg*kimg_t, maxe, 0:nrank_g-1), stat=ierr)
           allocate(wk_mpi(neg*kimg_t,maxe), stat=ierr)
           !           timer_comm sta 982 + barrier(mpi_ke_world)
           call mpi_allgather(amat_l,    maxeg*kimg_t*maxe, mpi_double_precision,&
          &                   wk_gather, maxeg*kimg_t*maxe, mpi_double_precision,&
          &                   mpi_ke_world, ierr)
           !           timer_comm end 982
           !           timer_do sta 983
           if (kimg_t == 1) then
              do k = 0, nrank_g-1
                 do j = 1, np_e
                    do i = nis_eg(k), nie_eg(k)
                       wk_mpi(neg_gg_all(i),j) = wk_gather(i-nis_eg(k)+1,j,k)
                    enddo
                 enddo
              enddo
           else
              do k = 0, nrank_g-1
                 do j = 1, np_e
                    do i = nis_eg(k), nie_eg(k)
                       wk_mpi(neg_gg_all(i)*2-1,j) = wk_gather((i-nis_eg(k)+1)*2-1,j,k)
                       wk_mpi(neg_gg_all(i)*2  ,j) = wk_gather((i-nis_eg(k)+1)*2  ,j,k)
                    enddo
                 enddo
              enddo
           endif
           !           timer_do end 983
           deallocate(wk_gather)
           allocate(zmat_l_2D(neg*kimg_t,np_e), stat=ierr)
           !           timer_do sta 984
           if (kimg_t == 1) then
              do j = 1, np_e
                 do i = 1, neg
                    zmat_l_2D(i,j) = wk_mpi(neg_g_all(i),j)
                 enddo
              enddo
           else
              do j = 1, np_e
                 do i = 1, neg
                    zmat_l_2D(i*2-1,j) = wk_mpi(neg_g_all(i)*2-1,j)
                    zmat_l_2D(i*2  ,j) = wk_mpi(neg_g_all(i)*2  ,j)
                 enddo
              enddo
           endif
           !          timer_do end 984
           deallocate(wk_mpi)
#endif
!fj --------------------e
        else
! ( zmat_l  G b-cyclic -> B b-cyclic )
           allocate(wk_gather(maxeg*kimg_t, maxe, 0:nrank_g-1), stat=ierr)
           allocate(wk_mpi(maxeg*kimg_t, maxe), stat=ierr)
           !          timer_do sta 984
           wk_mpi = 0.0d0
           if (kimg_t == 1) then
              do j = 1,np_e
                 if (neg_g(j) > meg) cycle
                 do i = 1,nel_eg(myrank_g)
                   if (neg_gg(i) > meg) cycle
                    wk_mpi(i,j) = zmat_l(i,j)
                 enddo
              enddo
           else
              do j = 1,np_e
                 if (neg_g(j) > meg) cycle
                 do i = 1,nel_eg(myrank_g)
                    if (neg_gg(i) > meg) cycle
                    wk_mpi(i*2-1,j) = zmat_l(i*2-1,j)
                    wk_mpi(i*2  ,j) = zmat_l(i*2  ,j)
                 enddo
              enddo
           endif
           !       timer_do end 984
           !       timer_comm sta 987 + barrier(mpi_ke_world)  
           call mpi_allgather(wk_mpi,   maxeg*kimg_t*maxe, mpi_double_precision,&
          &                   wk_gather, maxeg*kimg_t*maxe, mpi_double_precision,&
          &                   mpi_ke_world, ierr)
           !       timer_comm end 987
  
           deallocate(wk_mpi)
           allocate(wk_mpi(neg*kimg_t,maxe), stat=ierr)
           !       timer_do sta 985
           wk_mpi = 0.0d0
           if (kimg_t == 1) then
              do k = 0, nrank_g-1
                 do j = 1, np_e
                    do i = nis_eg(k), nie_eg(k)
                       wk_mpi(neg_gg_all(i),j) = wk_gather(i-nis_eg(k)+1,j,k)
                    enddo
                 enddo
              enddo
           else
              do k = 0, nrank_g-1
                 do j = 1, np_e
                    do i = nis_eg(k), nie_eg(k)
                       wk_mpi(neg_gg_all(i)*2-1,j) = wk_gather((i-nis_eg(k)+1)*2-1,j,k)
                       wk_mpi(neg_gg_all(i)*2  ,j) = wk_gather((i-nis_eg(k)+1)*2  ,j,k)
                    enddo
                 enddo
              enddo
           endif
           !    timer_do end 985
           deallocate(wk_gather)
           allocate(zmat_l_2D(neg*kimg_t,np_e), stat=ierr)
           !    timer_do sta 986
           if (kimg_t == 1) then
              do j = 1, np_e
                 do i = 1, neg
                    zmat_l_2D(i,j) = wk_mpi(neg_g_all(i),j)
                 enddo
              enddo
           else
              do j = 1, np_e
                 do i = 1, neg
                    zmat_l_2D(i*2-1,j) = wk_mpi(neg_g_all(i)*2-1,j)
                    zmat_l_2D(i*2  ,j) = wk_mpi(neg_g_all(i)*2  ,j)
                 enddo
              enddo
           endif
           !   timer_do end 986
           deallocate(wk_mpi)
        end if
     else
       allocate(zmat_l_2D(neg*kimg_t,np_e), stat=ierr)
       zmat_l_2D = 0.0d0
       !       timer_do sta 928
       if(kimg_t == 1) then
          do i = 1, np_e
             if (neg_g(i) > meg) cycle
             do j = 1, neg
                if (neg_g_all(j) > meg) cycle
                zmat_l_2D(j,i) = zmat(neg_g_all(j),neg_g(i))
             enddo
          end do
       else
          do i = 1, np_e
             if (neg_g(i) > meg) cycle
             do j = 1, neg
                if (neg_g_all(j) > meg) cycle
                zmat_l_2D(j*2-1,i) = zmat(neg_g_all(j)*2-1,neg_g(i))
                zmat_l_2D(j*2  ,i) = zmat(neg_g_all(j)*2  ,neg_g(i))
             enddo
          end do
       endif
       !    timer_do end 928
    end if

! ( zaj_ball  Gb-cyclic -> Bb-cyclic )
    allocate(wk_ball(np_g1k(ik),neg,kimg), stat=ierr)
    wk_ball = 0.0d0
    !       timer_do sta 929
!OCL SERIAL
    do k = 1, kimg
!OCL PARALLEL
       do j = 1, neg
          do i = 1, np_g1k(ik)
             wk_ball(i,neg_gg_all(j),k) = zaj_ball(i,j,ik,k)
          enddo
       enddo
    enddo
    !       timer_do end 929, sta 930
!OCL SERIAL
    do k = 1, kimg
!OCL PARALLEL
       do j = 1, neg
          do i = 1, np_g1k(ik)
             zaj_ball(i,j,ik,k) = wk_ball(i,neg_g_all(j),k)
          enddo
       enddo
    enddo
    !       timer_do end 930

    zaj_l(:,:,ik,:) = 0.0d0
    PART2: do jp = 1, npart2
       is = isp2(jp)
       ie = iep2(jp)
       if(kimg == 1) then
          call subspace_rotation_real_3D(is,ie,neg)
       else
          call subspace_rotation_imag_3D(is,ie,neg)
       endif
    end do PART2

    deallocate(zmat_l_2D)

    if (meg < neg) then
       allocate(wk_meg(1:np_g1k(ik),meg+1:neg,kimg), stat=ierr)
       !    timer_do sta 931
!OCL SERIAL
       do k = 1, kimg
          do j = meg+1, neg
!OCL PARALLEL
             do i = 1, np_g1k(ik)
                wk_meg(i,j,k) = wk_ball(i,j,k)
             end do
          end do
       end do
       !    timer_do end 931
       wk_ball = 0.0d0
       !    timer_do sta 932
!OCL SERIAL
       do k = 1, kimg
!OCL PARALLEL
          do j = 1, np_e
             do i = 1, np_g1k(ik)
                wk_ball(i,neg_g(j),k) = zaj_l(i,j,ik,k)
             end do
          end do
       end do
       !  timer_do end 932

       allocate(wk_gather(np_g1k(ik),neg,kimg), stat=ierr)
       !    timer_comm sta 933 + barrier(mpi_kg_world)
       call mpi_allreduce(wk_ball, wk_gather, np_g1k(ik)*neg*kimg, &
      &                   mpi_double_precision, mpi_sum, mpi_kg_world, ierr) ! MPI
       !    timer_comm end 933
       !    timer_do sta 934
!OCL SERIAL
       do k = 1, kimg
!OCL PARALLEL
          do j = meg+1, neg
             do i = 1, np_g1k(ik)
                wk_gather(i,j,k) = wk_meg(i,j,k)
             end do
          end do
       end do
       !    timer_do end 934, sta 935
!OCL SERIAL
       do k = 1, kimg
!OCL PARALLEL
          do j = 1, np_e
             if (neg_g(j) > meg) then
                do i = 1, np_g1k(ik)
                   zaj_l(i,j,ik,k) = wk_gather(i,neordr(neg_g(j),ik),k)
                end do
             end if
          end do
       end do
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) then
          do j = 1, np_e
             status_saved_phifftr(j,ik) = OLD
          end do
       end if
#endif

       !  timer_do end 935
       deallocate(wk_meg)
       deallocate(wk_gather)
    end if

    deallocate(wk_ball)

!!  maxe = maxval(nel_e(:))
!!  maxeg = maxval(nel_g1k(:,ik))
!!  allocate(wk_mpi(maxeg*kimg,maxe), stat=ierr)
!!  allocate(wk_gather(maxeg*kimg,maxe,0:nrank_e-1), stat=ierr)
!!  wk_mpi = 0.0d0
!!  if (kimg == 1) then
!!     do j = 1, np_e
!!        do i = 1, np_g1k(ik)
!!           wk_mpi(i,j) = zaj_l(i,j,ik,1)
!!        enddo
!!     enddo
!!  else
!!     do j = 1, np_e
!!        do i = 1, np_g1k(ik)
!!           wk_mpi(i*2-1,j) = zaj_l(i,j,ik,1)
!!           wk_mpi(i*2  ,j) = zaj_l(i,j,ik,2)
!!        enddo
!!     enddo
!!  endif
!!
!!  call mpi_allgather(wk_mpi,   maxeg*kimg_t*maxe, mpi_double_precision,&
!! &                   wk_gather, maxeg*kimg_t*maxe, mpi_double_precision,&
!! &                   mpi_kg_world, ierr)
!!
!!  if (kimg_t == 1) then
!!     do k = 0, nrank_e-1
!!        do j = nis_e(k), nie_e(k)
!!           do i = 1, np_g1k(ik)
!!              zaj_ball(i,j,ik,1) = wk_gather(i,j-nis_e(k)+1,k)
!!           enddo
!!        enddo
!!     enddo
!!  else
!!     do k = 0, nrank_e-1
!!        do j = nis_e(k), nie_e(k)
!!           do i = 1, np_g1k(ik)
!!              zaj_ball(i,j,ik,1) = wk_gather(i*2-1,j-nis_e(k)+1,k)
!!              zaj_ball(i,j,ik,2) = wk_gather(i*2  ,j-nis_e(k)+1,k)
!!           enddo
!!        enddo
!!     enddo
!!  endif
!!  deallocate(wk_mpi)
!!  deallocate(wk_gather)

!! (eko_l)
    !      timer_do sta 936
     if(meg < neg) then
        do ib1=meg+1,neg
           if(map_e(ib1) == myrank_e) then        ! MPI
!             eko_l(map_z(ib1),ik)=eko_d_mpi(neordr(ib1,ik))
              eko_l(map_z(ib1),ik)=eko_d(neordr(ib1,ik))
           end if
        enddo
     endif
     !    timer_do end 936, sta 937
     do ib1 = 1, meg
        if(map_e(ib1) == myrank_e) then         ! MPI
           eko_l(map_z(ib1),ik)=eig(ib1)
        end if
     end do
     !   timer_do end 937

#ifdef _USE_SCALAPACK_
!!   if(sw_scalapack==ON) then
!!   else
!!   end if
#else
     !   timer_do sta 938
     if(meg < neg) then
        do ib1 = 1, np_e
           if(neg_g(ib1) > meg) then
!             eko_l(ib1,ik)=eko_d_mpi(neordr(neg_g(ib1),ik))
              eko_l(ib1,ik)=eko_d(neordr(neg_g(ib1),ik))
           end if
        enddo
     endif
     !   timer_do end 938, sta 939
     do ib1 = 1, np_e
        if(neg_g(ib1) > meg) cycle
        eko_l(ib1,ik) = eig(neg_g(ib1))
     end do
     !   timer_do end 939
#endif

!! (neordr & nrvf_ordr)
     neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
     nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)
    deallocate(eko_d)
    deallocate(eko_d_mpi)
    deallocate(eig)
    if(sw_scalapack==ON) deallocate(amat_l)
!fj --------------------
!s  deallocate(zmat)
    if (allocated(zmat)) deallocate(zmat)
!fj --------------------
    deallocate(zmat_l)

! === DEBUG by tkato 2012/12/11 ================================================
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_non_diagonal,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_diagonal,    1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
! ==============================================================================
    if(.not.non_diagonal_part_is_small(ik)  &
         & .and. sum_abs_non_diagonal/sum_abs_diagonal <= submat_critical_ratio) &
         & non_diagonal_part_is_small(ik) = .true.

    call tstatc0_end(id_sname)
    !     timer_sub end 901
    !     timer end 1500
    !     timer end 9

  contains

#ifdef USE_EIGENLIB

#ifdef EIGEN_TRANS
  subroutine eigen_setup(ndim,nb,nprow,npcol,lda,occ,icolor,ictxt,usermap,icol,irank_c,irank_r)
#else
  subroutine eigen_setup(ndim,nb,nprow,npcol,lda,occ,icolor,ictxt,usermap,icol)
#endif

#ifdef EIGEN_EXA
    use eigen_libs,  only: eigen_init
    use eigen_blacs, only: eigen_set_blacs_context
#endif
    implicit none
    integer, intent(in)  :: ndim, nb, nprow, npcol
    integer, intent(out) :: lda, occ, icolor
    integer, intent(out) :: ictxt, usermap(nprow,npcol)
    integer, intent(out) :: icol(0:nrank_e*nrank_g*nrank_k-1)
    integer              :: ikey(0:nrank_e*nrank_g*nrank_k-1)
#ifdef EIGEN_TRANS
    integer, intent(out) :: irank_c(0:nrank_e*nrank_g*nrank_k-1)
    integer, intent(out) :: irank_r(0:nrank_e*nrank_g*nrank_k-1)
#endif
    integer :: myrow, mycol
    integer :: i, k
    integer :: id_sname = -1
    integer :: iam, nprocs, info

    include 'commtxt.h'

    !     timer_sub sta 903
    call tstatc0_begin('eigen_setup ', id_sname)

    if(mod(ndim,nb)>0) then
       lda = ndim/nb +1
    else
       lda = ndim/nb
    end if
    occ = lda
    if(mod(lda,nprow)>0) then
       lda = lda/nprow+1
    else
       lda = lda/nprow
    end if
    if(mod(occ,npcol)>0) then
       occ = occ/npcol+1
    else
       occ = occ/npcol
    end if
    lda = lda*nb
    occ = occ*nb
    if(iprisubmat>=2) write(nfout,'("lda,occ=",2i5)') lda,occ

#ifdef EIGEN_TRANS
    call make_usermap(usermap,icol,ikey,irank_c,irank_r)
#else
    call make_usermap(usermap,icol,ikey)
#endif

    call MPI_COMM_RANK(MPI_COMM_WORLD, iam, ierr)
    call blacs_setup(iam,nprocs)

#ifdef EIGEN_6D
    icolor=icol(iam)
    call MPI_comm_split(MPI_COMM_WORLD,icolor,ikey(iam),MPI_COMM_EIGEN,ierr)
#else
    if ( iam < nprow*npcol ) then
      icolor=1
    else
      icolor=0
    endif
    call MPI_comm_split(MPI_COMM_WORLD,icolor,iam,MPI_COMM_EIGEN,ierr)
#endif

#ifdef EIGEN_EXA
    call eigen_init( mpi_comm_eigen, order='C' )
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow,nprow,npcol)
    call eigen_set_blacs_context(ictxt)
#else
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow,nprow,npcol)
    call blacs_gridinfo(ictxt,nprow,npcol,myrow,mycol)

    ICTXTtoDC=ictxt
    MYROWtoDC=myrow
    MYCOLtoDC=mycol
! === Specify NPROWtoDC and NPCOLtoDC in commtxt.h! ============================
    NPROWtoDC = nprow
    NPCOLtoDC = npcol
! ==============================================================================
#endif

    if(iprisubmat>=1) then
      write(nfout,'("nb=",i6,", lda=",i6,", occ=",i6,", ndim=",i6,", nprow=",i6,", npcol=",i6)') nb, lda, occ, ndim, nprow, npcol
      if(iprisubmat>=2) write(nfout,'("myrow,mycol=",2i8)') myrow,mycol
      call flush(nfout)
    end if

    call tstatc0_end(id_sname)
    !     timer_sub end 903
  end subroutine eigen_setup

  subroutine eigen_solver(nn1,nn2)
#ifdef EIGEN_EXA
       use eigen_libs, only: eigen_sx
#endif
    implicit none
    integer :: nx, ierr, larray
    integer,intent(in) :: nn1, nn2
    integer :: nm_cache1,nm_cache2, nm_block
    real(kind=DP), allocatable :: utmp2xx(:), vtmp2xx(:)
    integer :: NB, nmz, nmw
    integer :: LLD_RX,LLD_CX,MXLLDX,LLD_R,LLD_C,MXLLD
    integer :: iam, lddz, lddw

    include 'commtxt.h'

    !    timer_sub sta 906
    if(iprisubmat>=2) write(nfout,*) "Submat: eigen_solver"

    nb = 64+32
    nmz = ((meg-1)/nprow+1)
    call CSTAB_get_optdim(nmz, 6, 16*4, 16*4*2 ,nm_cache1 )
    nmz = ((nmz-1)/nb+1)*nb+1

    nmw = ((meg-1)/npcol+1)
    call CSTAB_get_optdim(nmw, 6, 16*4, 16*4*2 ,nm_cache2 )
    nmw = ((nmw-1)/nb+1)*nb+1

    larray = MAX(nn1,nmz,nm_cache1,nm_cache2)*nmw
    allocate (utmp2xx(larray), vtmp2xx(larray) )
    utmp2xx = 0.d0
    vtmp2xx = 0.d0

    call mset(amat_l,utmp2xx,nn1,nn2,larray)
#ifdef EIGEN_EXA
    call eigen_sx(meg, meg, utmp2xx, nn1, eig, vtmp2xx, nn1, m_forward=32, m_backward=128)
#else
    call eigen_sx(meg, utmp2xx(1), nn1, eig(1), vtmp2xx(1), nn1, 32)
#endif
    call mset2(zmat_l,vtmp2xx,nn1,nn2,larray)

    deallocate (utmp2xx, vtmp2xx )

    !   timer_sub end 906
    return
  end subroutine eigen_solver

  subroutine mset(a,b,n1,n2,n3)
    implicit none
    real(8),intent(in)    :: a(n1,n2)
    real(8),intent(inout) :: b(n3)
    integer n1,n2,n3
    integer i,j,l

    l=0
    do j=1,n2
       do i=1,n1
          l=l+1
          b(l)=a(i,j)
       enddo
    enddo
    if (l>n3) write(nfout,*) "***** error in mset"

    return
  end subroutine mset

  subroutine mset2(a,b,n1,n2,n3)
    implicit none
    real(8),intent(inout) :: a(n1,n2)
    real(8),intent(in)    :: b(n3)
    integer n1,n2,n3
    integer i,j,l

    l=0
    do j=1,n2
       do i=1,n1
          l=l+1
          a(i,j)=b(l)
       enddo
    enddo

    if (l>n3) write(nfout,*) "***** error in mset"

    return
  end subroutine mset2

  subroutine eigen_solver_h(nn1,nn2)

!.M  use communication_h, only : eigen_init, eigen_free
    implicit none

    integer :: nx, ierr, lda, ldz, larray
    integer,intent(in) :: nn1, nn2
    integer :: nm_cache, nm_block
    real(8), allocatable :: utmp_r(:), utmp_i(:)
    real(8), allocatable :: vtmp_r(:), vtmp_i(:)
    integer :: npos, nb, nmz, nmw, nm, m0, nmz1, nmw1
    integer :: trilwmin, np, nq, lddz, lddw, numroc
    integer :: iam

    include 'commtxt.h'
    !      timer_sub sta 907

    if(iprisubmat>=2) write(nfout,*) "Submat: eigen_h_solver"

    npos = npcol*nprow

    nb  = 48
    nmz = ((meg-1)/nprow+1)
    nmz = ((nmz-1)/nb+1)*nb+1
    nmw = ((meg-1)/npcol+1)
    nmw = ((nmw-1)/nb+1)*nb+1

    nm = (meg/2)*2+1
    nmz1 = nm

    nmw1 = (meg-1)/npos+1
    m0 = 32

    lda = (meg-1)/npcol+1
    larray = MAX(nmz*nmw+nm+1,nmz1*nmw1)

    np = numroc( meg, nb, myrow, 0, nprow )
    nq = numroc( meg, nb, mycol, 0, npcol )
    lddz = (meg-1)/nprow+1
    lddz = ((lddz-1)/nb+1)*nb+1
    lddw = (meg-1)/npcol+1
    lddw = ((lddw-1)/nb+1)*nb+1

    trilwmin = 3*meg + max( nb*( np+1 ), 3*nb )
    ldz = max( max( 1+6*meg+2*np*nq, trilwmin ) + 2*meg, lddz*lddw)

    allocate(utmp_r(ldz), utmp_i(ldz))
    allocate(vtmp_r(ldz), vtmp_i(ldz))

    utmp_r = 0.d0
    utmp_i = 0.d0

    call mset_h(amat_l,utmp_r,utmp_i,nn1,nn2,larray)
    call eigen_h(meg,utmp_r(1),utmp_i(1),lda,vtmp_r(1),vtmp_i(1),larray,eig(1),m0,0)
    call mset2_h(zmat_l,utmp_r,utmp_i,nn1,nn2,larray)

    deallocate(utmp_r, utmp_i)
!   call MPI_comm_free(MPI_COMM_EIGEN,ierr)

    !      timer_sub end 907
    return
  end subroutine eigen_solver_h

  subroutine mset_h(a,b,c,n1,n2,n3)
    implicit none
    real(8),intent(in)    :: a(n1*kimg_t,n2)
    real(8),intent(inout) :: b(n3), c(n3)
    integer n1,n2,n3
    integer i,j,l

    l=0
    do j=1,n2
       do i=1,n1
          l=l+1
          b(l)=a(i*2-1,j)
          c(l)=a(i*2  ,j)
       enddo
    enddo

    if (l>n3) write(*,*) "***** error in mset"

    return
  end subroutine mset_h

  subroutine mset2_h(a,b,c,n1,n2,n3)
    implicit none
    integer,intent(in) :: n1,n2,n3
    real(8),intent(inout) :: a(n1*kimg_t,n2)
    real(8),intent(in)    :: b(n3),c(n3)
    integer i,j,l

    l=0
    do j=1,n2
       do i=1,n1
          l=l+1
          a(i*2-1,j)=b(l)
          a(i*2  ,j)=c(l)
       enddo
    enddo

    if (l>n3) write(*,*) "***** error in mset"

    return
  end subroutine mset2_h
#endif
!endif if USE_EIGENLIB

  subroutine eigsend()
    integer :: i, ierr, itag=100
    integer, dimension(MPI_STATUS_SIZE) :: stat

    !    timer_sub sta 988
    !    timer_comm sta 989

    if ((myrank_e==0) .and. (myrank_g==0)) then
#ifdef EIGEN_6D
       do i=0,nrank_e*nrank_g*nrank_k-1
       if ( icol(i) == 1 ) cycle
#else
       do i = nrank_e*nrank_g-1, nsclcol*nsclrow, -1
#endif
          call mpi_send(eig, meg, mpi_double_precision, i, &
         &              itag, mpi_k_world(myrank_k), ierr)
           if (ierr /= 0) then
              write(nfout,*)' eigsend :  mpi_send error'
              call flush(nfout)
              call mpi_abort(mpi_comm_world, 10010, ierr)
           end if
       end do
    end if
    !     timer_comm end 989
    !     timer_comm sta 990
#ifdef EIGEN_6D
    if (icolor==0) then
#else
#ifdef ASSIGN_G_PREVIOUS
    if ((nsclcol*nsclrow-1) < (nrank_g*myrank_e+myrank_g)) then
#else
    if ((nsclcol*nsclrow-1) < (nrank_e*myrank_g+myrank_e)) then
#endif
#endif
       call mpi_recv(eig, meg, mpi_double_precision, 0, &
      &              itag, mpi_k_world(myrank_k), stat, ierr)
        if (ierr /= 0) then
           write(nfout,*)' eigsend :  mpi_irecv error'
           call flush(nfout)
           call mpi_abort(mpi_comm_world, 10012, ierr)
        end if
    end if
    !     timer_comm end 990
    !     timer_sub end 988

    end subroutine eigsend

    subroutine gather_zmat_all(zmat_l, zmat)
    integer(kind=4) :: i, j
    real(kind=DP), allocatable :: zmat_l(:,:), zmat(:,:)
    real(kind=DP), allocatable :: zmat_wk(:,:),zmat_all(:,:)
    !     timer_sub sta 905

    allocate(wk_mpi(maxeg*kimg_t,maxe), stat=ierr)
     if (ierr /= 0) then
        call mpi_abort(mpi_comm_world, 117, ierr)
     end if
    allocate(wk_gather(maxeg*kimg_t,maxe,0:nrank_e*nrank_g-1), stat=ierr)
     if (ierr /= 0) then
        call mpi_abort(mpi_comm_world, 118, ierr)
     end if
!   wk_mpi = 0.0d0
!   wk_gather = 0.0d0

     !     timer_do sta 948
    if(kimg_t==1) then
       do j = 1, np_e
          do i = 1, nel_eg(myrank_g)
             wk_mpi(i,j) = zmat_l(i,j)
          enddo
       enddo
    else
       do j = 1, np_e
          do i = 1, nel_eg(myrank_g)
             wk_mpi(i*2-1,j) = zmat_l(i*2-1,j)
             wk_mpi(i*2  ,j) = zmat_l(i*2  ,j)
          enddo
       enddo
    endif
    !     timer_do end 948
    !     timer_comm sta 949 + barrier(mpi_k_world(myrank_k))
    call mpi_allgather(wk_mpi,    maxeg*kimg_t*maxe, mpi_double_precision,&
   &                   wk_gather, maxeg*kimg_t*maxe, mpi_double_precision,&
   &                   mpi_k_world(myrank_k), ierr)
    !     timer_comm end 949
     if (ierr /= 0) then
        call mpi_abort(mpi_comm_world, 119, ierr)
     end if

    allocate(zmat_all(neg*kimg_t,neg), stat=ierr)
     if (ierr /= 0) then
        call mpi_abort(mpi_comm_world, 120, ierr)
     end if

     !    timer_do sta 950
    if(kimg_t==1) then
       do l = 0, nrank_g-1
          do k = 0, nrank_e-1
             do j = 1, nel_e(k)
                do i = 1, nel_eg(l)
! === DEBUG by tkato 2013/08/28 ================================================
!                  zmat_all(i+nis_eg(l)-1,j+nis_e(k)-1) = wk_gather(i,j,l*nrank_e+k)
#ifndef ASSIGN_G_PREVIOUS
                   zmat_all(i+nis_eg(l)-1,j+nis_e(k)-1) = wk_gather(i,j,l*nrank_e+k)
#else
                   zmat_all(i+nis_eg(l)-1,j+nis_e(k)-1) = wk_gather(i,j,k*nrank_g+l)
#endif
! ==============================================================================
                enddo
             enddo
          enddo
       enddo
    else
       do l = 0, nrank_g-1
          do k = 0, nrank_e-1
             do j = 1, nel_e(k)
                do i = 1, nel_eg(l)
! === DEBUG by tkato 2013/08/28 ================================================
!                  zmat_all((i+nis_eg(l)-1)*2-1,j+nis_e(k)-1) = wk_gather(i*2-1,j,l*nrank_e+k)
!                  zmat_all((i+nis_eg(l)-1)*2  ,j+nis_e(k)-1) = wk_gather(i*2  ,j,l*nrank_e+k)
#ifndef ASSIGN_G_PREVIOUS
                   zmat_all((i+nis_eg(l)-1)*2-1,j+nis_e(k)-1) = wk_gather(i*2-1,j,l*nrank_e+k)
                   zmat_all((i+nis_eg(l)-1)*2  ,j+nis_e(k)-1) = wk_gather(i*2  ,j,l*nrank_e+k)
#else
                   zmat_all((i+nis_eg(l)-1)*2-1,j+nis_e(k)-1) = wk_gather(i*2-1,j,k*nrank_g+l)
                   zmat_all((i+nis_eg(l)-1)*2  ,j+nis_e(k)-1) = wk_gather(i*2  ,j,k*nrank_g+l)
#endif
! ==============================================================================
                enddo
             enddo
          enddo
       enddo
    endif
    !      timer_do end 950
    deallocate(wk_gather)
    deallocate(wk_mpi)

    allocate(zmat_wk(neg*kimg_t,neg))
     if (ierr /= 0) then
        call mpi_abort(mpi_comm_world, 121, ierr)
     end if
    zmat_wk = 0.0d0
    !     timer_do sta 951
    if(kimg_t==1) then
!OCL NOFLTLD
       do j = 1,neg
          if (neg_g_all(j) > meg) cycle
          do i = 1,neg
             if (neg_gg_all(i) > meg) cycle
             zmat_wk(neg_gg_all(i),neg_g_all(j)) = zmat_all(i,j)
          enddo
       enddo
    else
!OCL NOFLTLD
       do j = 1,neg
          if (neg_g_all(j) > meg) cycle
          do i = 1,neg
             if (neg_gg_all(i) > meg) cycle
             zmat_wk(neg_gg_all(i)*2-1,neg_g_all(j)) = zmat_all(i*2-1,j)
             zmat_wk(neg_gg_all(i)*2  ,neg_g_all(j)) = zmat_all(i*2  ,j)
          enddo
       enddo
    endif
    !    timer_do end 951
    deallocate(zmat_all)

    !    timer_do sta 952
    if(kimg_t==1) then
       do j= 1, meg
          do i = 1, j
             zmat(i,j) = zmat_wk(i,j)
          enddo
       enddo
    else
       do j= 1, meg
          do i = 1, j
             zmat(i*2-1,j) = zmat_wk(i*2-1,j)
             zmat(i*2  ,j) = zmat_wk(i*2  ,j)
          enddo
       enddo
    endif
    !   timer_do end 952

    deallocate(zmat_wk)

    !   timer_sub end 905
    end subroutine gather_zmat_all

#ifdef EIGEN_TRANS
  subroutine make_usermap(usermap,icol,ikey,irank_c,irank_r)
#else
  subroutine make_usermap(usermap,icol,ikey)
#endif

    implicit none
    integer, intent(out) :: usermap(nprow,npcol)
    integer, intent(out) :: icol(0:nrank_e*nrank_g*nrank_k-1)
    integer, intent(out) :: ikey(0:nrank_e*nrank_g*nrank_k-1)
#ifdef EIGEN_TRANS
    integer, intent(out) :: irank_c(0:nrank_e*nrank_g*nrank_k-1)
    integer, intent(out) :: irank_r(0:nrank_e*nrank_g*nrank_k-1)
#endif

    integer :: ix, iy, iz, ia, ib, ic, irank, imode, icont
    integer :: nx, ny, nz, mx, my, mz, nb
    logical :: EIGEN_6D_

    !     timer_sub sta 942
    call tstatc0_begin('make_usermap', id_sname)

    imode = 2
    icont = 0
    icol(:) = 0
    do i=0,nrank_e*nrank_g*nrank_k-1
      ikey(i)= nrank_e*nrank_g*nrank_k+i
    enddo
#ifdef EIGEN_TRANS
    irank_c(:) = -1
    irank_r(:) = -1
#endif

#ifdef EIGEN_6D
    EIGEN_6D_=.true.
! === DEBUG by tkato 2013/09/18 ================================================
!#else
!    EIGEN_6D_=.false.
!#endif
! ==============================================================================
    if ( EIGEN_6D_ ) then
      imode=0
      if ( nprow == 32 .and. npcol == 32 ) then
        nb=1; nx=7; ny=3; nz=3
        mx=7; my=7; mz=15
      endif
      if ( nprow == 16 .and. npcol == 16 ) then
        nb=1; nx=3; ny=1; nz=3
        mx=7; my=3; mz=7
      endif
      if ( nprow == 8 .and. npcol == 8 ) then
        nb=1; nx=1; ny=1; nz=1
        mx=3; my=3; mz=3
      endif
      if ( nprow == 4 .and. npcol == 4 ) then
        nb=0; nx=1; ny=0; nz=1
        mx=3; my=1; mz=1
      endif
      if ( nprow == 2 .and. npcol == 2 ) then
        nb=0; nx=0; ny=0; nz=0
        mx=1; my=0; mz=1
      endif

      do ib=0,nb
        do iy=0,ny
          do iz=0,nz
            do ic=0,1
              do ix=0,nx
                do ia=0,1
                  j=icont/npcol
                  i=mod(icont,npcol)
                  call get6d2rank(ix,iy,iz,ia,ib,ic,irank)
                  if (irank < 0) imode=1
                  usermap(i+1,j+1)=myrank_k*nrank_e*nrank_g+irank
#ifdef EIGEN_TRANS
                  irank_c(irank)=j
                  irank_r(irank)=i
#endif
                  icol(irank)=1
                  ikey(irank)=icont
                  icont=icont+1
                end do
              end do
            end do
          end do
        end do
      end do
      if ( imode == 1 ) then
        icont = 0
        do iz=0,mz
          do iy=0,my
            do ix=0,mx
              j=icont/npcol
              i=mod(icont,npcol)
              call get3d2rank(ix,iy,iz,irank)
              if (irank < 0) imode=2
              usermap(i+1,j+1)=myrank_k*nrank_e*nrank_g+irank
#ifdef EIGEN_TRANS
              irank_c(irank)=j
              irank_r(irank)=i
#endif
              icol(irank)=1
              ikey(irank)=icont
              icont=icont+1
            end do
          end do
        end do
      endif
    endif
! === DEBUG by tkato 2013/09/18 ================================================
#else
    EIGEN_6D_=.false.
#endif
! ==============================================================================

    if ( imode == 2 ) then
    do j=1,npcol
       do i=1,nprow
!fj --------------------
!fj       usermap(i,j) = myrank_k*nrank_e + (j-1)*nprow + i - 1
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
          usermap(i,j) = myrank_k*nrank_e*nrank_g + (j-1)*nprow + i - 1
#else
          usermap(i,j) = myrank_k*nrank_e*nrank_g + (i-1)*npcol + j - 1
#endif
!fj --------------------
       end do
    end do
    endif

    if(iprisubmat>=1) then
       write(nfout,'("USERMAP mode=",i1)') imode
!      do i=1,nprow
!         write(nfout,'(16(1x,i5))') (usermap(i,j),j=1,npcol)
!      end do
       do j=1,npcol
          write(nfout,'(16(1x,i5))') (usermap(i,j),i=1,nprow)
       end do
       call flush(nfout)
    end if

    call tstatc0_end(id_sname)
    !     timer_sub end 942
  end subroutine make_usermap

!!#ifdef _USE_SCALAPACK_
#ifdef EIGEN_TRANS
#ifdef EIGEN_6D
    subroutine trans_scalapack(neg, meg, mgs_nb,scl_nb,zmat_l,amat_l,maxeg,maxe,lda,occ,kimg_t, usermap, irank_c, irank_r)
#else
    subroutine trans_scalapack(neg, meg, mgs_nb,scl_nb,zmat_l,amat_l,maxeg,maxe,lda,occ,kimg_t)
#endif

     integer, intent(in) :: neg, meg, mgs_nb, scl_nb, maxeg, maxe, lda, occ, kimg_t
     real(kind=DP), intent(in) :: zmat_l(maxeg*kimg_t,maxe)
     real(kind=DP), intent(inout) :: amat_l(lda*kimg_t,occ)

     integer, allocatable, dimension(:) :: wk_rk
     integer :: i, k, j,  nn, mm
     integer :: lrk, lad
     integer :: lno_r, ng_r, lrk_r, rank_r
     integer :: lno_c, ng_c, lrk_c, rank_c

     real(kind=DP), allocatable, dimension(:,:) :: send_buf, recv_buf

     integer, allocatable, dimension(:)   :: req_r, req_s
     integer, allocatable, dimension(:,:) :: sta_r, sta_s
     integer :: lrank, itag, icnt_send, icnt_recv, mpi_comm, ierr
#ifdef EIGEN_6D
     integer, intent(in) :: irank_c(0:nrank_e*nrank_g*nrank_k-1)
     integer, intent(in) :: irank_r(0:nrank_e*nrank_g*nrank_k-1)
     integer, intent(in) :: usermap(scl_row,scl_col)
#endif
! === DEBUG by tkato 2012/06/04 ================================================
#ifndef USE_NONBLK_COMM
#ifndef USE_ALLTOALLV
       real(kind=DP), allocatable, dimension(:,:) :: sendb, recvb
#else
       real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
       integer, allocatable, dimension(:) :: scnt, rcnt
       integer, allocatable, dimension(:) :: sdsp, rdsp
#endif
#endif
! ==============================================================================

     if (iprisubmat>=2) then
        write(nfout,'("lda,occ=",2i5)') lda,occ
        write(nfout,'("==== trans_scalapack ====")')
        write(nfout,'(" neg=",i4,", meg=",i4,", mgs_nb=",i4,", scl_nb=",i4,", maxeg=",i4,", maxe=",i4,", &
           & lda=",i4,", occ=",i4,", kimg_t=",i4)') neg, meg, mgs_nb, scl_nb, maxeg, maxe, lda, occ, kimg_t
        call flush(nfout)
      end if

      mpi_comm = mpi_k_world(myrank_k)
      itag = 10001
      allocate(req_r(scl_comm_rank_r), stat=ierr)
      allocate(req_s(scl_comm_rank  ), stat=ierr)
      allocate(sta_r(MPI_STATUS_SIZE,scl_comm_rank_r), stat=ierr)
      allocate(sta_s(MPI_STATUS_SIZE,scl_comm_rank  ), stat=ierr)
      allocate(recv_buf(scl_comm_max_r*kimg_t,scl_comm_rank_r), stat=ierr)
      allocate(send_buf(scl_comm_max  *kimg_t,scl_comm_rank  ), stat=ierr)
      icnt_recv = 0
      icnt_send = 0

#ifdef USE_NONBLK_COMM
      !     timer_do sta 971
#endif
      do i = 1, scl_comm_rank_r
         lrank = scl_comm_rno_r(i)
         if (lrank /= mype) then
            icnt_recv = icnt_recv + 1
#ifdef USE_NONBLK_COMM
            call mpi_irecv(recv_buf(1,i), scl_comm_max_r*kimg_t, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_r(icnt_recv), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack :  mpi_irecv error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10001, ierr)
             endif
#endif
         endif
      enddo
#ifdef USE_NONBLK_COMM
      !    timer_do end 971
#endif

      allocate(wk_rk(max(scl_comm_rank,scl_comm_rank_r)))
      wk_rk = 0
      rank_c = myrank_e
      rank_r = myrank_g

      !    timer_do sta 972
      do k = nis_e(rank_c), nie_e(rank_c)
         ng_c = neg_g_all(k)
         if (ng_c > meg) cycle
         if (mod(ng_c,scl_nb) > 0) then
            nn = ng_c / scl_nb + 1
         else
            nn = ng_c / scl_nb
         end if
         lrk_c = mod((nn-1),scl_col)
         do j = nis_eg(rank_r), nie_eg(rank_r)
            ng_r = neg_gg_all(j)
            if (ng_r > meg) cycle
            if (mod(ng_r,scl_nb) > 0) then
               nn = ng_r / scl_nb + 1
            else
               nn = ng_r / scl_nb
            end if
            lrk_r = mod((nn-1),scl_row)
#ifdef EIGEN_6D
            lrk = usermap(lrk_r+1,lrk_c+1)
#else
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
            lrk = scl_row*lrk_c+lrk_r
#else
            lrk = scl_col*lrk_r+lrk_c
#endif
#endif
!!          if (lrk /= mype) then
               do lrank = 1, scl_comm_rank
                  if (scl_comm_rno(lrank) == lrk) then
                     wk_rk(lrank) = wk_rk(lrank) + 1
                     if (kimg_t == 1) then
                        send_buf(wk_rk(lrank),lrank) = zmat_l(j-nis_eg(rank_r)+1,k-nis_e(rank_c)+1)
                     else
                        send_buf(wk_rk(lrank)*2-1,lrank) = zmat_l((j-nis_eg(rank_r)+1)*2-1,k-nis_e(rank_c)+1)
                        send_buf(wk_rk(lrank)*2  ,lrank) = zmat_l((j-nis_eg(rank_r)+1)*2  ,k-nis_e(rank_c)+1)
                     end if
                     exit
                  end if
               end do
!!          end if
         end do
      end do
      !      timer_do end 972
      !      timer_comm sta 975 + barrier(mpi_comm)
#ifdef USE_NONBLK_COMM
      !      timer_do sta 971
#endif
      do i = 1, scl_comm_rank
         lrank = scl_comm_rno(i)
         if (lrank /= mype) then
            icnt_send = icnt_send + 1
#ifdef USE_NONBLK_COMM
            call mpi_isend(send_buf(1,i), scl_comm_max*kimg_t, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_s(icnt_send), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack :  mpi_isend error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10002, ierr)
             endif
#endif
         endif
      enddo
#ifdef USE_NONBLK_COMM
      !     timer_do end 971
#endif

#ifdef EIGEN_6D
      rank_c = irank_c(mype-nrank_e*nrank_g*myrank_k)
      rank_r = irank_r(mype-nrank_e*nrank_g*myrank_k)
   if (rank_c > -1 .and. rank_r > -1 ) then
#else
   if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col*scl_row)) then
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
      rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row
      rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row)
#else
      rank_c = mod((mype-nrank_e*nrank_g*myrank_k),scl_col)
      rank_r = (mype-nrank_e*nrank_g*myrank_k)/scl_col
#endif
#endif
      !     timer_do sta 973
      do k = nis_col(rank_c), nie_col(rank_c)
         ng_c = neg_col(k)
         if( ng_c > meg ) cycle
         if (mod(ng_c,mgs_nb) > 0) then
            nn = ng_c / mgs_nb + 1
         else
            nn = ng_c / mgs_nb
         end if
         lrk_c = mod((nn-1),nrank_e)
         lad = mod(ng_c,mgs_nb)
         if (lad == 0) lad = mgs_nb
         mm  = ((ng_c-1)/mgs_nb)/nrank_e
         lno_c = mm * mgs_nb + lad

         do j = nis_row(rank_r), nie_row(rank_r)
            ng_r = neg_row(j)
            if( ng_r > meg ) cycle
            if (mod(ng_r,mgs_nb) > 0) then
               nn = ng_r / mgs_nb + 1
            else
               nn = ng_r / mgs_nb
            end if
            lrk_r = mod((nn-1),nrank_g)
            lad = mod(ng_r,mgs_nb)
            if (lad == 0) lad = mgs_nb
            mm  = ((ng_r-1)/mgs_nb)/nrank_g
            lno_r = mm * mgs_nb + lad
#ifdef ASSIGN_G_PREVIOUS
            lrk = nrank_g*lrk_c+lrk_r
#else
            lrk = nrank_e*lrk_r+lrk_c
#endif
            if (lrk == mype) then

               if(ng_r> ng_c) cycle

               if (kimg_t == 1) then
                  amat_l(j-nis_row(rank_r)+1,k-nis_col(rank_c)+1) = zmat_l(lno_r,lno_c)
               else
                  amat_l((j-nis_row(rank_r)+1)*2-1,k-nis_col(rank_c)+1) = zmat_l(lno_r*2-1,lno_c)
                  amat_l((j-nis_row(rank_r)+1)*2  ,k-nis_col(rank_c)+1) = zmat_l(lno_r*2  ,lno_c)
               end if
            end if
         end do
      end do
      !     timer_do end 973
   end if

#ifdef USE_NONBLK_COMM
      call mpi_waitall(icnt_recv, req_r, sta_r, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10003, ierr)
       endif

      call mpi_waitall(icnt_send, req_s, sta_s, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10004, ierr)
       endif
       !     timer_comm end 975
#else
       !     timer_comm sta 992 + barrier(mpi_k_world)
#ifndef USE_ALLTOALLV
! === DEBUG by tkato 2012/06/04 ================================================
!      real(kind=DP), allocatable, dimension(:,:) :: sendb, recvb
! ==============================================================================
       allocate(sendb(scl_comm_max  *kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(recvb(scl_comm_max_r*kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       sendb=0
       recvb=0
       do i = 1, scl_comm_rank
          sendb(:,scl_comm_rno(i))=send_buf(:,i)
       enddo
       call mpi_alltoall(sendb, scl_comm_max  *kimg_t, mpi_double_precision, &
      &                  recvb, scl_comm_max_r*kimg_t, mpi_double_precision, &
      &                                                MPI_COMM_WORLD, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_alltoall(List) error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10005, ierr)
       endif
       do i = 1, scl_comm_rank_r
          recv_buf(:,i)=recvb(:,scl_comm_rno_r(i))
       enddo
       deallocate(sendb)
       deallocate(recvb)
#else
! === DEBUG by tkato 2012/06/05 ================================================
!      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
!      integer, allocatable, dimension(:) :: scnt, rcnt
!      integer, allocatable, dimension(:) :: sdsp, rdsp
! ==============================================================================
       allocate(sbuf(scl_comm_max  *kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rbuf(scl_comm_max_r*kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(scnt(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rcnt(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(sdsp(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rdsp(0:nrank_e*nrank_g-1), stat=ierr)
       sbuf=0
       rbuf=0
       scnt=0
       rcnt=0
       do i = 1, scl_comm_rank
          lrank = scl_comm_rno(i)
          sbuf(:,lrank)=send_buf(:,i)
          scnt(lrank)=scl_comm_max  *kimg_t
       enddo
       do i = 1, scl_comm_rank_r
          rcnt(scl_comm_rno_r(i))=scl_comm_max_r*kimg_t
       enddo
       do i = 0, nrank_e*nrank_g - 1
          sdsp(i)=scl_comm_max  *kimg_t*i
          rdsp(i)=scl_comm_max_r*kimg_t*i
       enddo
       call mpi_alltoallv(sbuf, scnt, sdsp, mpi_double_precision, &
      &                   rbuf, rcnt, rdsp, mpi_double_precision, &
      &                                            MPI_COMM_WORLD, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_alltoallv error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10005, ierr)
       endif
       do i = 1, scl_comm_rank_r
          recv_buf(:,i)=rbuf(:,scl_comm_rno_r(i))
       enddo
       deallocate(sbuf)
       deallocate(rbuf)
       deallocate(scnt)
       deallocate(rcnt)
       deallocate(sdsp)
       deallocate(rdsp)
#endif
       !      timer_comm end 992
#endif

#ifdef EIGEN_6D
      rank_c = irank_c(mype-nrank_e*nrank_g*myrank_k)
      rank_r = irank_r(mype-nrank_e*nrank_g*myrank_k)
      if (rank_c > -1 .and. rank_r > -1 ) then
         wk_rk = 0
#else
      if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col*scl_row)) then

         wk_rk = 0
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
         rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row
         rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row)
#else
         rank_c = mod((mype-nrank_e*nrank_g*myrank_k),scl_col)
         rank_r = (mype-nrank_e*nrank_g*myrank_k)/scl_col
#endif
#endif
         !   timer_do sta 974
         do k = nis_col(rank_c), nie_col(rank_c)
            ng_c = neg_col(k)
            if( ng_c > meg ) cycle
            if (mod(ng_c,mgs_nb) > 0) then
               nn = ng_c / mgs_nb + 1
            else
               nn = ng_c / mgs_nb
            end if
            lrk_c = mod((nn-1),nrank_e)
            do j = nis_row(rank_r), nie_row(rank_r)
               ng_r = neg_row(j)
               if( ng_r > meg ) cycle
               if (mod(ng_r,mgs_nb) > 0) then
                  nn = ng_r / mgs_nb + 1
               else
                  nn = ng_r / mgs_nb
               end if
               lrk_r = mod((nn-1),nrank_g)
#ifdef ASSIGN_G_PREVIOUS
               lrk = nrank_g*lrk_c+lrk_r
#else
               lrk = nrank_e*lrk_r+lrk_c
#endif
!!             if (lrk /= mype) then
                  do lrank = 1, scl_comm_rank_r
                     if (scl_comm_rno_r(lrank) == lrk) then
                        wk_rk(lrank) = wk_rk(lrank) + 1

                        if(ng_r> ng_c) cycle

                        if (kimg_t == 1) then
                           amat_l(j-nis_row(rank_r)+1,k-nis_col(rank_c)+1) = recv_buf(wk_rk(lrank),lrank)
                        else
                           amat_l((j-nis_row(rank_r)+1)*2-1,k-nis_col(rank_c)+1) = recv_buf(wk_rk(lrank)*2-1,lrank)
                           amat_l((j-nis_row(rank_r)+1)*2  ,k-nis_col(rank_c)+1) = recv_buf(wk_rk(lrank)*2  ,lrank)
                        end if
                        exit
                     end if
                  end do
!!             end if
            end do
         end do
         !     timer_do end 974
      end if

      deallocate(req_r, stat=ierr)
      deallocate(req_s, stat=ierr)
      deallocate(sta_r, stat=ierr)
      deallocate(sta_s, stat=ierr)
      deallocate(send_buf, stat=ierr)
      deallocate(recv_buf, stat=ierr)
      deallocate(wk_rk, stat=ierr)

    end subroutine trans_scalapack

#ifdef EIGEN_6D
    subroutine trans_scalapack_r(neg, meg, mgs_nb,scl_nb,zmat_l,amat_l,maxeg,maxe,lda,occ,kimg_t, usermap, irank_c, irank_r)
#else
    subroutine trans_scalapack_r(neg, meg, mgs_nb,scl_nb,zmat_l,amat_l,maxeg,maxe,lda,occ,kimg_t)
#endif

     integer, intent(in) :: neg, meg, mgs_nb, scl_nb, maxeg, maxe, lda, occ, kimg_t
     real(kind=DP), intent(in) :: zmat_l(lda*kimg_t,occ)
     real(kind=DP), intent(inout) :: amat_l(maxeg*kimg_t,maxe)

     integer , allocatable, dimension(:) :: wk_rk
     integer :: i, k, j, nn, mm
     integer :: lrk, lad
     integer :: lno_r, ng_r, lrk_r, rank_r
     integer :: lno_c, ng_c, lrk_c, rank_c

     real(kind=DP), allocatable, dimension(:,:) :: send_buf, recv_buf

     integer, allocatable, dimension(:)   :: req_r, req_s
     integer, allocatable, dimension(:,:) :: sta_r, sta_s
     integer :: lrank, itag, icnt_send, icnt_recv, mpi_comm, ierr
#ifdef EIGEN_6D
     integer, intent(in) :: usermap(scl_row,scl_col)
     integer, intent(in) :: irank_c(0:nrank_e*nrank_g*nrank_k-1)
     integer, intent(in) :: irank_r(0:nrank_e*nrank_g*nrank_k-1)
#endif

! === DEBUG by tkato 2012/06/04 ================================================
#ifndef USE_NONBLK_COMM
#ifndef USE_ALLTOALLV
     real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
#else
     real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
     integer, allocatable, dimension(:) :: scnt, rcnt
     integer, allocatable, dimension(:) :: sdsp, rdsp
#endif
#endif
! ==============================================================================

      mpi_comm = mpi_k_world(myrank_k)
      itag = 10002
      if (iprisubmat>=2) then
         write(nfout,'("==== trans_scalapack_r ====")')
         write(nfout,'(" neg=",i4,", meg=",i4,", mgs_nb=",i4,", scl_nb=",i4,", maxeg=",i4,", maxe=",i4,", &
           & lda=",i4,", occ=",i4,", kimg_t=",i4)') neg, meg, mgs_nb, scl_nb, maxeg, maxe, lda, occ, kimg_t
         write(nfout,'(" scl_comm_rank=",i4,", scl_comm_rank_r=",i4)') scl_comm_rank, scl_comm_rank_r
         call flush(nfout)
      end if

      allocate(req_r(scl_comm_rank  ), stat=ierr)
      allocate(req_s(scl_comm_rank_r), stat=ierr)
      allocate(sta_r(MPI_STATUS_SIZE,scl_comm_rank  ), stat=ierr)
      allocate(sta_s(MPI_STATUS_SIZE,scl_comm_rank_r), stat=ierr)
      allocate(recv_buf(scl_comm_max  *kimg_t,scl_comm_rank  ), stat=ierr)
      allocate(send_buf(scl_comm_max_r*kimg_t,scl_comm_rank_r), stat=ierr)
      icnt_recv = 0
      icnt_send = 0
!     send_buf=0.0d0
!     recv_buf=0.0d0

#ifdef USE_NONBLK_COMM
      !     timer_do sta 976
#endif
      do i = 1, scl_comm_rank
         lrank = scl_comm_rno(i)
         if (lrank /= mype) then
            icnt_recv = icnt_recv + 1
#ifdef USE_NONBLK_COMM
            call mpi_irecv(recv_buf(1,i), scl_comm_max*kimg_t, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_r(icnt_recv), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack_r :  mpi_irecv error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10001, ierr)
             endif
#endif
         endif
      enddo
#ifdef USE_NONBLK_COMM
      !     timer_do end 976
#endif

      allocate(wk_rk(max(scl_comm_rank,scl_comm_rank_r)))

#ifdef EIGEN_6D
      rank_c = irank_c(mype-nrank_e*nrank_g*myrank_k)
      rank_r = irank_r(mype-nrank_e*nrank_g*myrank_k)
      if (rank_c > -1 .and. rank_r > -1 ) then
         wk_rk = 0
#else
      if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col*scl_row)) then

         wk_rk = 0

#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
         rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row
         rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row)
#else
         rank_c = mod((mype-nrank_e*nrank_g*myrank_k),scl_col)
         rank_r = (mype-nrank_e*nrank_g*myrank_k)/scl_col
#endif
#endif
         !   timer_do sta 977
         do k = nis_col(rank_c), nie_col(rank_c)
            ng_c = neg_col(k)
            if (ng_c > meg) cycle
            if (mod(ng_c,mgs_nb) > 0) then
               nn = ng_c / mgs_nb + 1
            else
               nn = ng_c / mgs_nb
            end if
            lrk_c = mod((nn-1),nrank_e)
            do j = nis_row(rank_r), nie_row(rank_r)
               ng_r = neg_row(j)
               if (ng_r > meg) cycle
               if (mod(ng_r,mgs_nb) > 0) then
                  nn = ng_r / mgs_nb + 1
               else
                  nn = ng_r / mgs_nb
               end if
               lrk_r = mod((nn-1),nrank_g)
#ifdef ASSIGN_G_PREVIOUS
               lrk = nrank_g*lrk_c+lrk_r
#else
               lrk = nrank_e*lrk_r+lrk_c
#endif
!!             if (lrk /= mype) then
                  do lrank = 1, scl_comm_rank_r
                     if(scl_comm_rno_r(lrank) == lrk) then
                        wk_rk(lrank) = wk_rk(lrank) + 1
                        if (kimg_t == 1) then
                           send_buf(wk_rk(lrank),lrank) = zmat_l(j-nis_row(rank_r)+1,k-nis_col(rank_c)+1)
                        else
                           send_buf(wk_rk(lrank)*2-1,lrank) = zmat_l((j-nis_row(rank_r)+1)*2-1,k-nis_col(rank_c)+1)
                           send_buf(wk_rk(lrank)*2  ,lrank) = zmat_l((j-nis_row(rank_r)+1)*2  ,k-nis_col(rank_c)+1)
                        end if
                        exit
                     end if
                  end do
!!             end if
            end do
         end do
         !     timer_do end 977
      end if

#ifdef USE_NONBLK_COMM
      !        timer_comm sta 980 + barrier(mpi_comm)
      !        timer_do   sta 976
#endif
      do i = 1, scl_comm_rank_r
         lrank = scl_comm_rno_r(i)
         if (lrank /= mype) then
            icnt_send = icnt_send + 1
#ifdef USE_NONBLK_COMM
            call mpi_isend(send_buf(1,i), scl_comm_max*kimg_t, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_s(icnt_send), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack_r :  mpi_isend error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10002, ierr)
             endif
#endif
         endif
      enddo
#ifdef USE_NONBLK_COMM
      !      timer_do end 976
#endif

      rank_c = myrank_e
      rank_r = myrank_g
      !      timer_do sta 978
      do k = nis_e(rank_c), nie_e(rank_c)
         ng_c = neg_g_all(k)
         if( ng_c > meg ) cycle
         if (mod(ng_c,scl_nb) > 0) then
            nn = ng_c / scl_nb + 1
         else
            nn = ng_c / scl_nb
         end if
         lrk_c = mod((nn-1),scl_col)
         lad = mod(ng_c,scl_nb)
         if (lad == 0) lad = scl_nb
         mm  = ((ng_c-1)/scl_nb)/scl_col
         lno_c = mm * scl_nb + lad

         do j = nis_eg(rank_r), nie_eg(rank_r)
            ng_r = neg_gg_all(j)
            if( ng_r > meg ) cycle
            if (mod(ng_r,scl_nb) > 0) then
               nn = ng_r / scl_nb + 1
            else
               nn = ng_r / scl_nb
            end if
            lrk_r = mod((nn-1),scl_row)
            lad = mod(ng_r,scl_nb)
            if (lad == 0) lad = scl_nb
            mm  = ((ng_r-1)/scl_nb)/scl_row
            lno_r = mm * scl_nb + lad

#ifdef EIGEN_6D
            lrk = usermap(lrk_r+1,lrk_c+1)
#else
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
            lrk = scl_row*lrk_c+lrk_r
#else
            lrk = scl_col*lrk_r+lrk_c
#endif
#endif
            if (lrk == mype) then
!fj --------------------
!fj            if(ng_r> ng_c) cycle
!fj --------------------
               if (kimg_t == 1) then
                  amat_l(j-nis_eg(rank_r)+1,k-nis_e(rank_c)+1) = zmat_l(lno_r,lno_c)
               else
                  amat_l((j-nis_eg(rank_r)+1)*2-1,k-nis_e(rank_c)+1) = zmat_l(lno_r*2-1,lno_c)
                  amat_l((j-nis_eg(rank_r)+1)*2  ,k-nis_e(rank_c)+1) = zmat_l(lno_r*2  ,lno_c)
               end if
            end if
         end do
      end do
      !       timer_do end 978

#ifdef USE_NONBLK_COMM
      call mpi_waitall(icnt_recv, req_r, sta_r, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack_r :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10003, ierr)
       endif

      call mpi_waitall(icnt_send, req_s, sta_s, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack_r :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10004, ierr)
       endif
       !     timer_comm end 980
#else
       !     timer_comm sta 993 + barrier(mpi_k_world)
#ifndef USE_ALLTOALLV
! === DEBUG by tkato 2012/06/04 ================================================
!      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
! ==============================================================================
       allocate(sbuf(scl_comm_max_r*kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rbuf(scl_comm_max  *kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       sbuf=0
       rbuf=0
       do i = 1, scl_comm_rank_r
          sbuf(:,scl_comm_rno_r(i))=send_buf(:,i)
       enddo
       call mpi_alltoall(sbuf, scl_comm_max_r*kimg_t, mpi_double_precision, &
      &                  rbuf, scl_comm_max  *kimg_t, mpi_double_precision, &
      &                                                MPI_COMM_WORLD, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_alltoall(List) error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10005, ierr)
       endif
       do i = 1, scl_comm_rank
          recv_buf(:,i)=rbuf(:,scl_comm_rno(i))
       enddo
       deallocate(sbuf)
       deallocate(rbuf)
#else
! === DEBUG by tkato 2012/06/05 ================================================
!      real(kind=DP), allocatable, dimension(:,:) :: sbuf, rbuf
!      integer, allocatable, dimension(:) :: scnt, rcnt
!      integer, allocatable, dimension(:) :: sdsp, rdsp
! ==============================================================================
       allocate(sbuf(scl_comm_max_r*kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rbuf(scl_comm_max  *kimg_t,0:nrank_e*nrank_g-1), stat=ierr)
       allocate(scnt(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rcnt(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(sdsp(0:nrank_e*nrank_g-1), stat=ierr)
       allocate(rdsp(0:nrank_e*nrank_g-1), stat=ierr)
       sbuf=0
       rbuf=0
       scnt=0
       rcnt=0
       do i = 1, scl_comm_rank_r
          lrank = scl_comm_rno_r(i)
          sbuf(:,lrank)=send_buf(:,i)
          scnt(lrank)=scl_comm_max_r*kimg_t
       enddo
       do i = 1, scl_comm_rank
          rcnt(scl_comm_rno(i))=scl_comm_max  *kimg_t
       enddo
       do i = 0, nrank_e*nrank_g - 1
          sdsp(i)=scl_comm_max_r*kimg_t*i
          rdsp(i)=scl_comm_max  *kimg_t*i
       enddo
       call mpi_alltoallv(sbuf, scnt, sdsp, mpi_double_precision, &
      &                   rbuf, rcnt, rdsp, mpi_double_precision, &
      &                                     MPI_COMM_WORLD, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_alltoallv error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10005, ierr)
       endif
       do i = 1, scl_comm_rank
          recv_buf(:,i)=rbuf(:,scl_comm_rno(i))
       enddo
       deallocate(sbuf)
       deallocate(rbuf)
       deallocate(scnt)
       deallocate(rcnt)
       deallocate(sdsp)
       deallocate(rdsp)
#endif
       !    timer_comm end 993
#endif

      wk_rk = 0
      rank_c = myrank_e
      rank_r = myrank_g
      !      timer_do sta 979
      do k = nis_e(rank_c), nie_e(rank_c)
         ng_c = neg_g_all(k)
         if( ng_c > meg ) cycle
         if (mod(ng_c,scl_nb) > 0) then
            nn = ng_c / scl_nb + 1
         else
            nn = ng_c / scl_nb
         end if
         lrk_c = mod((nn-1),scl_col)
         do j = nis_eg(rank_r), nie_eg(rank_r)
            ng_r = neg_gg_all(j)
            if( ng_r > meg ) cycle
            if (mod(ng_r,scl_nb) > 0) then
               nn = ng_r / scl_nb + 1
            else
               nn = ng_r / scl_nb
            end if
            lrk_r = mod((nn-1),scl_row)
#ifdef EIGEN_6D
            lrk = usermap(lrk_r+1,lrk_c+1)
#else
#if defined(_ASSIGN_ROW_) || defined(USE_EIGENLIB)
            lrk = scl_row*lrk_c+lrk_r
#else
            lrk = scl_col*lrk_r+lrk_c
#endif
#endif
!!          if (lrk /= mype) then
               do lrank = 1, scl_comm_rank
                  if (scl_comm_rno(lrank) == lrk) then
                     wk_rk(lrank) = wk_rk(lrank) + 1
!fj --------------------
!fj                  if(ng_r> ng_c) cycle
!fj --------------------
                     if (kimg_t == 1) then
                        amat_l(j-nis_eg(rank_r)+1,k-nis_e(rank_c)+1) = recv_buf(wk_rk(lrank),lrank)
                     else
                        amat_l((j-nis_eg(rank_r)+1)*2-1,k-nis_e(rank_c)+1) = recv_buf(wk_rk(lrank)*2-1,lrank)
                        amat_l((j-nis_eg(rank_r)+1)*2  ,k-nis_e(rank_c)+1) = recv_buf(wk_rk(lrank)*2  ,lrank)
                     end if
                     exit
                  end if
               end do
!!          end if
         end do
      end do
      !      timer_do end 979

      deallocate(req_r, stat=ierr)
      deallocate(req_s, stat=ierr)
      deallocate(sta_r, stat=ierr)
      deallocate(sta_s, stat=ierr)
      deallocate(send_buf, stat=ierr)
      deallocate(recv_buf, stat=ierr)
      deallocate(wk_rk, stat=ierr)

    end subroutine trans_scalapack_r
#endif
!#endif

!   subroutine set_block_range(ne,np,nel_p,nis_p,nie_p,map_p)
!     integer, intent(in)                     :: ne ! number of total elements
!     integer, intent(in)                     :: np ! number of ranks (or processors)
!     integer, allocatable, dimension(:) :: nel_p,nis_p,nie_p
!     integer, intent(out), dimension(ne)  :: map_p
!     integer :: j,i
! 
!     allocate(nel_p(0:np-1))
!     allocate(nis_p(0:np-1))
!     allocate(nie_p(0:np-1))

!     nel_p = ne/np
!     j = mod(ne,np)
!     do i = 0, j-1
!        nel_p(i) = nel_p(i) + 1
!     end do
 
!     nis_p(0) = 1
!     do i = 1, np-1
!        nis_p(i)   = nis_p(i-1) + nel_p(i-1)
!        nie_p(i-1) = nis_p(i) - 1
!     end do
!     nie_p(np-1) = ne

!     j = 0
!     do i = 1, ne
!        if(nie_p(j) < i) j = j + 1
!        map_p(i) = j
!     end do

!   end subroutine set_block_range

    subroutine subspace_rotation_real_3D(is,ie,meg)
      integer, intent(in) :: is,ie,meg
#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
#endif
      integer :: id_sname = -1
      !    timer_sub sta 912

      call tstatc0_begin('subspace_roation_real_3D ', id_sname)
#ifdef SUBMAT_DGEMM
      alpha=1.d0
      beta=1.d0
      !     timer_dgemm sta 953
!xx   call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,1),maxval(np_g1k(:)), &
!xx  &            zmat_l_2D(1,1),meg,beta,zaj_l(1,1,ik,1),maxval(np_g1k(:)))
      call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,1),maxval(np_g1k(:)), &
     &            zmat_l_2D(is,1),meg,beta,zaj_l(1,1,ik,1),maxval(np_g1k(:)))
      !     timer_dgemm end 953
#else
      !     timer_do sta 954
      do ib2=1, np_e
         do ib1=1,np_g1k(ik)
            do ii=is, ie
               zaj_l(ib1,ib2,ik,1) = zaj_l(ib1,ib2,ik,1) &
              &                       + zmat_l_2D(ii,ib2) * zaj_ball(ib1,ii,ik,1)
            enddo
         enddo
      enddo
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do ib2 = 1, np_e
            status_saved_phifftr(ib2,ik) = OLD
         end do
      end if
#endif

      !    timer_do end 954
#endif
      call tstatc0_end(id_sname)
      !    timer_sub end 912
    end subroutine subspace_rotation_real_3D

    subroutine subspace_rotation_imag_3D(is,ie,meg)
      integer, intent(in) :: is,ie,meg
      integer :: id_sname = -1
#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
      integer :: ibsize
      real(kind=DP), allocatable, dimension(:,:) :: zzr,zzi
#endif
      !    timer_sub sta 913

      call tstatc0_begin('subspace_roation_imag_3D ', id_sname)

      if(k_symmetry(ik) == GAMMA) then
#ifdef SUBMAT_DGEMM
         ibsize = maxval(np_g1k(:))
         alpha=1.d0
         beta=1.d0
         !                             timer_dgemm sta 955
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,1),ibsize, &
!x      &           zmat_l_2D(1,1),meg,beta,zaj_l(1,1,ik,1),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,1),ibsize, &
        &           zmat_l_2D(is,1),meg,beta,zaj_l(1,1,ik,1),ibsize)
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,2),ibsize, &
!x      &           zmat_l_2D(1,1),meg,beta,zaj_l(1,1,ik,2),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,2),ibsize, &
        &           zmat_l_2D(is,1),meg,beta,zaj_l(1,1,ik,2),ibsize)
         !                             timer_dgemm end 955
#else
         !                             timer_do sta 956
         do ib2=1, np_e
            do ib1=1,np_g1k(ik)
               do ii=is, ie
                  zaj_l(ib1,ib2,ik,1) = zaj_l(ib1,ib2,ik,1) &
                 &                       + zmat_l_2D(ii,ib2) * zaj_ball(ib1,ii,ik,1)
                  zaj_l(ib1,ib2,ik,2) = zaj_l(ib1,ib2,ik,2) &
                 &                       + zmat_l_2D(ii,ib2) * zaj_ball(ib1,ii,ik,2)
               enddo
            enddo
         enddo
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) then
            do ib2 = 1, np_e
               status_saved_phifftr(ib2,ik) = OLD
            end do
         end if
#endif
         !                             timer_do end 956
#endif
         if(iprisubmat >= 2) then
            do ib2 = is, ie
            end do
         end if
      else
#ifdef SUBMAT_DGEMM
         allocate(zzr(ie-is+1,np_e)); allocate(zzi(ie-is+1,np_e))
         !                             timer_do sta 957
         do ib2=1,np_e
            do ib1=is,ie
               zzr(ib1-is+1,ib2)=zmat_l_2D(2*ib1-1,ib2)
               zzi(ib1-is+1,ib2)=zmat_l_2D(2*ib1  ,ib2)
            end do
         end do
         !                             timer_do end 957
         ibsize = maxval(np_g1k(:))
         alpha=1.d0
         beta=1.d0
         !                             timer_dgemm sta 958
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,1),ibsize, &
!x      &           zzr(1,1),meg,beta,zaj_l(1,1,ik,1),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,1),ibsize, &
        &           zzr(1,1),ie-is+1,beta,zaj_l(1,1,ik,1),ibsize)
         alpha=-1.d0
         beta=1.d0
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,2),ibsize, &
!x      &           zzi(1,1),meg,beta,zaj_l(1,1,ik,1),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,2),ibsize, &
        &           zzi(1,1),ie-is+1,beta,zaj_l(1,1,ik,1),ibsize)
         alpha=1.d0
         beta=1.d0
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,2),ibsize, &
!x      &           zzr(1,1),meg,beta,zaj_l(1,1,ik,2),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,2),ibsize, &
        &           zzr(1,1),ie-is+1,beta,zaj_l(1,1,ik,2),ibsize)
         alpha=1.d0
         beta=1.d0
!x       call dgemm('N','N',np_g1k(ik),np_e,meg,alpha,zaj_ball(1,1,ik,1),ibsize, &
!x      &           zzi(1,1),meg,beta,zaj_l(1,1,ik,2),ibsize)
         call dgemm('N','N',np_g1k(ik),np_e,ie-is+1,alpha,zaj_ball(1,is,ik,1),ibsize, &
        &           zzi(1,1),ie-is+1,beta,zaj_l(1,1,ik,2),ibsize)
         !                             timer_dgemm end 958

         deallocate(zzi,zzr)
#else
         !                             timer_do sta 959
         do ib2=1, np_e
            do ib1=1,np_g1k(ik)
               do ii=is,ie
                  zaj_l(ib1,ib2,ik,1) = zaj_l(ib1,ib2,ik,1) &
                 &           + zmat_l_2D(ii*2-1,ib2) * zaj_ball(ib1,ii,ik,1) &
                 &           - zmat_l_2D(ii*2,  ib2) * zaj_ball(ib1,ii,ik,2)
                  zaj_l(ib1,ib2,ik,2) = zaj_l(ib1,ib2,ik,2) &
                 &           + zmat_l_2D(ii*2-1,ib2) * zaj_ball(ib1,ii,ik,2) &
                 &           + zmat_l_2D(ii*2,  ib2) * zaj_ball(ib1,ii,ik,1)
               enddo
            enddo
         enddo
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) then
            do ib2 = 1, np_e
               status_saved_phifftr(ib2,ik) = OLD
            end do
         end if
#endif
         !                             timer_do en 959
#endif
       end if
       call tstatc0_end(id_sname)
       !     timer_sub end 913
    end subroutine subspace_rotation_imag_3D

    subroutine set_col_partition_3D(meg)
      !!$integer,parameter :: maxmatsize = 67108864 ! 512MB
      integer, intent(in) :: meg
      integer :: maxmatsize
      integer :: trisize, size
      integer :: rowsize, block
      integer :: i,is,ie
      integer :: maxsize, nblocksize

      integer :: id_sname = -1
      !     timer_sub sta 902
      call tstatc0_begin('set_col_partition_3D ', id_sname)

      maxmatsize = msize_submat * 1024 * 1024 / 8 ! bytes

      trisize = meg*kimg_t*np_e

!fj --------------------
    if (nblocksize_submat > 0) then
      if  (mod(meg,nblocksize_submat) > 0) then
        npart = meg / nblocksize_submat + 1
      else
        npart = meg / nblocksize_submat
      end if
      allocate(isp(npart))
      allocate(iep(npart))
      isp(1) = 1
      iep(1) = isp(1) + nblocksize_submat - 1
      do i = 2, npart
        isp(i) = iep(i-1) + 1
        iep(i) = isp(i) + nblocksize_submat - 1
      end do
      iep(npart) = min(iep(npart),meg)
    else
!fj --------------------
      if(trisize <= maxmatsize.or.sw_scalapack==OFF) then
         npart = 1
         allocate(isp(npart))
         allocate(iep(npart))
         isp(npart) = 1
         iep(npart) = meg
         maxsize  = trisize
      else
         npart = (trisize - 1)/maxmatsize + 1
         allocate(isp(npart))
         allocate(iep(npart))
         maxsize  = trisize/npart
         ie = 0
         !      timer_do sta 940
         do i=1,npart
            is = ie+1
            ie = is
            size = 0
            do while(size*kimg_t <= maxsize)
               ie = ie+1
               size = (ie-is+1)*np_e
            end do
            isp(i) = is
            iep(i) = ie
            if(ie>meg) then
               npart = i
               exit
            end if
         end do
         !      timer_do end 940
         iep(npart) = meg
      end if
!fj --------------------
    end if
!fj --------------------

!fj --------------------
    if(nblocksize_submat_latter_is_given) then
       nblocksize = nblocksize_submat_latter
    else if(nblocksize_submat_is_given) then
       nblocksize = nblocksize_submat
    else
       nblocksize = 0
    end if

    if (nblocksize > 0) then
      if  (mod(meg,nblocksize) > 0) then
        npart2 = meg / nblocksize + 1
      else
        npart2 = meg / nblocksize
      end if
      if(allocated(isp2)) deallocate(isp2)
      if(allocated(iep2)) deallocate(iep2)
      allocate(isp2(npart2))
      allocate(iep2(npart2))
      isp2(1) = 1
      iep2(1) = isp2(1) + nblocksize_submat_latter - 1
      do i = 2, npart2
        isp2(i) = iep2(i-1) + 1
        iep2(i) = isp2(i) + nblocksize_submat_latter - 1
      end do
      iep2(npart2) = meg
    else
!fj --------------------
      rowsize = meg*kimg_t
      if(allocated(isp2)) deallocate(isp2)
      if(allocated(iep2)) deallocate(iep2)
      if(rowsize*meg<=maxmatsize.or.sw_scalapack==OFF) then
         npart2 = 1
         allocate(isp2(npart2))
         allocate(iep2(npart2))
         isp2(npart2) = 1
         iep2(npart2) = meg
         block = meg
      else
         npart2 = (rowsize*meg)/maxmatsize
         if(npart2 > meg) npart2 = meg
         block = meg/npart2
         allocate(isp2(npart2))
         allocate(iep2(npart2))
         is = 0
         ie = 0
         !        timer_do sta 941
         do i=1,npart2
            is = ie+1
            ie = is+block-1
            if(i<=mod(meg,npart2)) ie=ie+1
            isp2(i) = is
            iep2(i) = ie
         end do
         !        timer_do end 941
         iep2(npart2) = meg
      end if
!fj --------------------
    end if
!fj --------------------

      if (iprisubmat >= 2) then
         write(nfout,'("npart = ",i4,", nblocksize_submat= ",i4)') npart, nblocksize_submat
         write(nfout,'("isp   = ",10(i4,1x))') isp(:)
         write(nfout,'("iep   = ",10(i4,1x))') iep(:)
         write(nfout,'("npart2= ",i4,", nblocksize_submat_latter = ",i4)') npart2, nblocksize_submat_latter
         write(nfout,'("isp2  = ",10(i4,1x))') isp2(:)
         write(nfout,'("iep2  = ",10(i4,1x))') iep2(:)
      endif

      if(printable.and.(sw_scalapack==ON.or.iprisubmat>=2)) then
         write(nfout,*) '== col partition == '
         write(nfout,*) 'target memory(MB)=',msize_submat
         write(nfout,*) 'npart=',npart
         write(nfout,*) 'maxsize=',maxsize
         write(nfout,*) 'memory(MB)=',maxsize*8/1024/1024
         write(nfout,*) 'n, isp, iep, size'
         do i=1,npart
            is = isp(i)
            ie = iep(i)
            size = is*(ie-is+1)+(ie-is+2)*(ie-is+1)/2
            write(nfout,'(4i10)') i, is, ie, size
         end do
         write(nfout,*) 'npart2=',npart2
         write(nfout,*) 'block=',block
         write(nfout,*) 'memory(MB)=',block*rowsize*8/1024/1024
         write(nfout,*) 'n, isp2, iep2, block'
         do i=1,npart2
            write(nfout,'(4i7)') i, isp2(i), iep2(i), iep2(i)-isp2(i)+1
         end do
      else if(iprisubmat >=1) then
         write(nfout,'(" !target memory(MB) =",i10)') msize_submat
         write(nfout,'(" npart, npart2 = ",2i8)') npart, npart2
         write(nfout,'(" -- isp, iep --")')
         do i = 1, npart
            write(nfout,'(1x,i3," isp(",i3,"), iep(",i3,") = ",2i8)') i,i,i,isp(i),iep(i)
         end do
         write(nfout,'(" -- isp2, iep2 --")')
         do i = 1, npart
            write(nfout,'(1x,i3," isp2(",i3,"), iep2(",i3,") = ",2i8)') i,i,i,isp2(i),iep2(i)
         end do
      end if
      call tstatc0_end(id_sname)
      !    timer_sub end 902
    end subroutine set_col_partition_3D


  subroutine set_hmat_3D(meg,w1hw2,zmat_l)
    integer, intent(in) :: meg
    real(kind=DP), intent(inout) :: w1hw2((ie-is+1)*kimg_t,np_e)
#ifdef _USE_SCALAPACK_
! === DEBUG by Tkato 2011/06/28 ================================================
!   real(kind=DP), intent(out) :: zmat_l(maxeg*kimg_t,maxe)
    real(kind=DP), intent(out) :: zmat_l(lda*kimg_t,occ)
! ==============================================================================
#else
    real(kind=DP), intent(out) :: zmat_l(nel_eg(myrank_g)*kimg_t,np_e)
#endif

    real(kind=DP), allocatable :: w1hw2_mpi(:,:), zmat_mpi(:,:)
    integer(kind=4) :: irecv_num(0:nrank_g-1)
    integer(kind=4) :: i, j, G_ista_e, G_iend_e
    integer :: id_sname = -1
    !     timer_sub sta 904
    call tstatc0_begin('set_hmat_3D ', id_sname)

    if (npart == 1) then
       allocate(w1hw2_mpi(np_e,meg*kimg_t), stat=ierr)
        if (ierr /= 0) then
           call mpi_abort(mpi_comm_world, 122, ierr)
        end if
       allocate(zmat_mpi(np_e,meg*kimg_t), stat=ierr)
        if (ierr /= 0) then
           call mpi_abort(mpi_comm_world, 123, ierr)
        end if
        !    timer_do sta 943
       do i = 1, np_e
          do j = 1, meg*kimg_t
             w1hw2_mpi(i,j) = w1hw2(j,i)
          enddo
       enddo
       !     timer_do end 943
       irecv_num(:) = nel_eg(:)*kimg_t*np_e
       !     timer_comm sta 944 + barrier(mpi_ke_world)
       call mpi_reduce_scatter(w1hw2_mpi(1,1), zmat_mpi(1,1), irecv_num, mpi_double_precision, &
      &                        mpi_sum, mpi_ke_world, ierr)
       !     timer_comm end 944
       !     timer_do sta 945
       if(kimg_t==1) then
          do i = 1, np_e
             if (neg_g(i) > meg) cycle
             do j = 1, nel_eg(myrank_g)
                if (neg_gg(j) > meg) cycle
                zmat_l(j,i) = zmat_mpi(i,j)
             enddo
          enddo
       else
          do i = 1, np_e
             if (neg_g(i) > meg) cycle
             do j = 1, nel_eg(myrank_g)
                if (neg_gg(j) > meg) cycle
                zmat_l(j*2-1,i) = zmat_mpi(i,j*2-1)
                zmat_l(j*2  ,i) = -zmat_mpi(i,j*2  )
             enddo
          enddo
       endif
       !      timer_do end 945
       deallocate(w1hw2_mpi)
       deallocate(zmat_mpi)
    else
       allocate(w1hw2_mpi((ie-is+1)*kimg_t,np_e))
       !      timer_comm sta 946 + barrier(mpi_ke_world)
       call mpi_allreduce(w1hw2, w1hw2_mpi, np_e*(ie-is+1)*kimg_t, mpi_double_precision, &
      &                   mpi_sum, mpi_ke_world, ierr) ! MPI
       !      timer_comm end 946
       G_ista_e = nis_eg(myrank_g)
       G_iend_e = nie_eg(myrank_g)
       !      timer_do sta 947
       if(kimg_t==1) then
          do j = 1, np_e
             if (neg_g(j) > meg) cycle
             do i = is, ie
                if (neg_gg_all(i) > meg) cycle
                if ((G_ista_e <= i) .and. (i <= G_iend_e)) then
                   zmat_l(i-G_ista_e+1,j) = w1hw2_mpi(i-is+1,j)
                endif
             enddo
          enddo
       else
          do j = 1, np_e
             if (neg_g(j) > meg) cycle
             do i = is, ie
                if (neg_gg_all(i) > meg) cycle
                if ((G_ista_e <= i) .and. (i <= G_iend_e)) then
                   zmat_l((i-G_ista_e+1)*2-1,j) =  w1hw2_mpi((i-is+1)*2-1,j)
                   zmat_l((i-G_ista_e+1)*2  ,j) = -w1hw2_mpi((i-is+1)*2  ,j)
                endif
             enddo
          enddo
       end if
       !    timer_do end 947
       deallocate(w1hw2_mpi)
    endif
    call tstatc0_end(id_sname)
    !      timer_sub end 904
  end subroutine set_hmat_3D

#ifdef _USE_SCALAPACK_
! ScaLapack

  subroutine set_hmat_3D_scl(neg,w1hw2,zmat_l)
    integer, intent(in) :: neg
    real(kind=DP), intent(inout) :: w1hw2((ie-is+1)*kimg_t,np_e)
!fj real(kind=DP), intent(out) :: zmat_l(lda*kimg_t,occ)
    real(kind=DP), intent(inout) ::zmat_l(maxeg*kimg_t,maxe)

    real(kind=DP), allocatable :: w1hw2_mpi(:,:), zmat_mpi(:,:)
    integer(kind=4) :: irecv_num(0:nrank_g-1)
    integer(kind=4) :: i, j, G_ista_e, G_iend_e
    integer :: id_sname = -1
    !      timer_sub sta 963
    call tstatc0_begin('set_hmat_3D ', id_sname)

    if (npart == 1) then
       allocate(w1hw2_mpi(np_e,neg*kimg_t), stat=ierr)
        if (ierr /= 0) then
           call mpi_abort(mpi_comm_world, 122, ierr)
        end if
       allocate(zmat_mpi(np_e,neg*kimg_t), stat=ierr)
        if (ierr /= 0) then
           call mpi_abort(mpi_comm_world, 123, ierr)
        end if
        !       timer_do sta 966
       do i = 1, np_e
          do j = 1, neg*kimg_t
             w1hw2_mpi(i,j) = w1hw2(j,i)
          enddo
       enddo
       !        timer_do end 966
       irecv_num(:) = nel_eg(:)*kimg_t*np_e
       !        timer_comm sta 967, barrier(mpi_ke_world)
       call mpi_reduce_scatter(w1hw2_mpi(1,1), zmat_mpi(1,1), irecv_num, mpi_double_precision, &
      &                        mpi_sum, mpi_ke_world, ierr)
       !        timer_comm end 967
       !        timer_do sta 968
       if(kimg_t==1) then
          do i = 1, np_e
!            if (neg_g(i) > meg) cycle
             do j = 1, nel_eg(myrank_g)
!               if (neg_gg(j) > meg) cycle
                zmat_l(j,i) = zmat_mpi(i,j)
             enddo
          enddo
       else
          do i = 1, np_e
!            if (neg_g(i) > meg) cycle
             do j = 1, nel_eg(myrank_g)
!               if (neg_gg(j) > meg) cycle
                zmat_l(j*2-1,i) = zmat_mpi(i,j*2-1)
                zmat_l(j*2  ,i) = -zmat_mpi(i,j*2  )
             enddo
          enddo
       endif
       !        timer_do end 968
       deallocate(w1hw2_mpi)
       deallocate(zmat_mpi)
    else
       allocate(w1hw2_mpi((ie-is+1)*kimg_t,np_e))
       !        timer_comm sta 969, barrier(mpi_ke_world)
       call mpi_allreduce(w1hw2, w1hw2_mpi, np_e*(ie-is+1)*kimg_t, mpi_double_precision, &
      &                   mpi_sum, mpi_ke_world, ierr) ! MPI
       !        timer_comm end 969
       G_ista_e = nis_eg(myrank_g)
       G_iend_e = nie_eg(myrank_g)
       !        timer_do sta 970
       if(kimg_t==1) then
          do j = 1, np_e
!            if (neg_g(j) > meg) cycle
             do i = is, ie
!               if (neg_gg_all(i) > meg) cycle
                if ((G_ista_e <= i) .and. (i <= G_iend_e)) then
                   zmat_l(i-G_ista_e+1,j) = w1hw2_mpi(i-is+1,j)
                endif
             enddo
          enddo
       else
          do j = 1, np_e
!            if (neg_g(j) > meg) cycle
             do i = is, ie
!               if (neg_gg_all(i) > meg) cycle
                if ((G_ista_e <= i) .and. (i <= G_iend_e)) then
                   zmat_l((i-G_ista_e+1)*2-1,j) =  w1hw2_mpi((i-is+1)*2-1,j)
                   zmat_l((i-G_ista_e+1)*2  ,j) = -w1hw2_mpi((i-is+1)*2  ,j)
                endif
             enddo
          enddo
       end if
       !      timer_do end 970
       deallocate(w1hw2_mpi)
    endif
    call tstatc0_end(id_sname)
    !        timer_sub end 963
  end subroutine set_hmat_3D_scl

! ScaLapack

! === DEBUG by Tkato 2011/06/28 ================================================
  subroutine get_zmat(lda,occ,zmat,ndim,nprow,npcol,nb,usermap,is,ie,zz)
    integer, intent(in) :: lda,occ
    real(kind=DP), intent(out) :: zmat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol
    integer             ::                  nb
    integer, intent(in) :: usermap(nprow,npcol)
    integer, intent(in) :: is,ie
    real(kind=DP), intent(in) :: zz(ndim*kimg_t,is:ie)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: jsize
!   real(kind=DP), allocatable :: zz_mpi(:,:)
    integer :: id_sname = -1
    call tstatc0_begin('get_zmat ', id_sname)

    nb = block_size

    jsize = ie-is+1

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("GET_ZMAT")
#endif
!   zz = 0.d0
    zmat = 0.d0
    if(kimg_t==1) then
       do j=is,ie
!fj --------------------
          if (j > meg) cycle
!fj --------------------
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
!fj --------------------
             if (i > meg) cycle
!fj --------------------
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
!            zz(i,j) = zmat(ii,jj)
             zmat(ii,jj) = zz(i,j)
          end do
       end do
    else
       do j=is,ie
!fj --------------------
          if (j > meg) cycle
!fj --------------------
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
!fj --------------------
             if (i > meg) cycle
!fj --------------------
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
!            zz(2*i-1,j) = zmat(2*ii-1,jj)
!            zz(2*i  ,j) = zmat(2*ii  ,jj)
             zmat(2*ii-1,jj) = zz(2*i-1,j)
             zmat(2*ii  ,jj) = zz(2*i  ,j)
          end do
       end do
    end if
!   if(npes > 1) then
!      allocate(zz_mpi(ndim*kimg_t,is:ie))
!      call mpi_allreduce(zz,zz_mpi,ndim*kimg_t*jsize,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
!      zz = zz_mpi         ! MPI
!      deallocate(zz_mpi)
!   end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("GET_ZMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine get_zmat
! ==============================================================================

#ifdef EIGEN_TRANS
  subroutine scalapack_setup_3D(ndim,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,&
      & ictxt,myrow,mycol,desca,descz,usermap,icolor,icol,irank_c,irank_r)
#else
  subroutine scalapack_setup_3D(ndim,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,&
      & ictxt,myrow,mycol,desca,descz,usermap,icolor,icol)
#endif

    integer, intent(in) :: ndim
#ifdef SINGLE_CONTEXT
    integer, intent(out) :: lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol
#else
    integer, intent(out) :: lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt(0:nrank_k-1),myrow,mycol
#endif
    integer, dimension(9), intent(out) :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, intent(out) :: usermap(nprow,npcol)
#else
    integer, intent(out) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(out) :: icolor
    integer, intent(out) :: icol(0:nrank_e*nrank_g*nrank_k-1)
    integer              :: ikey(0:nrank_e*nrank_g*nrank_k-1)
#ifdef EIGEN_TRANS
    integer, intent(out) :: irank_c(0:nrank_e*nrank_g*nrank_k-1)
    integer, intent(out) :: irank_r(0:nrank_e*nrank_g*nrank_k-1)
#endif

    integer :: i,j
    integer :: nb
    integer :: np0,nq0,np,nq,iarow,iacol
    integer :: iroffa, icoffa, nrc, ldc
    integer :: sizemqrleft, qrmem, trilwmin
    integer :: iam,nprocs,info
    integer, external :: indxg2l, indxg2p, numroc
    integer, parameter :: BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1, &
     &                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6, &
     &                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9
    integer :: id_sname = -1
!fj+
    integer      :: lwork0,lrwork0,liwork0
    real(DP)    :: eig
    integer     :: itmp(1)
    real(DP)    :: rtmp(1)
    complex(DP) :: ctmp(1)
    real(DP)    :: utmp2(1),vtmp2(1)
!fj-
! === Change block_size if it's too large. by tkato 2014/=======================
    integer            :: max_block_size
! ==============================================================================
    !    timer_sub sta 903
    call tstatc0_begin('scalapack_setup ', id_sname)

    lwork1  = 0
    lrwork1 = 0
    liwork1 = 0
    lwork2  = 0
    lrwork2 = 0
    liwork2 = 0
    desca = 0
    descz = 0

! === Change block_size if it's too large. by tkato 2014/=======================
    if(max(nprow,npcol) /= 1) then
       max_block_size = int(real(ndim)/real(max(nprow,npcol) - 1))
       if(block_size > max_block_size) then
          if(mype == 0) then
             write(0,'(a)') '=== WARNING!!! =============================================='
             write(0,'(a)') 'Block size for block-cyclic division on ScaLAPACK is too large!'
             write(0,'(a,i5,a)') 'Block size should be not greater than ', max_block_size, '!'
             write(0,'(a,i5,a)') 'So, block_size is changed into ', max_block_size, '!'
             write(0,'(a)') 'FYI: '
             write(0,'(a,i8)') '   ndim: ', ndim
             write(0,'(a,i5)') '   Specified block Size: ', block_size
             write(0,'(a,2i5)') '   nprow, npcol: ', nprow, npcol
             write(0,'(a)') '=== WARNING!!! =============================================='
          end if
          block_size = max_block_size
       end if
    end if
! ==============================================================================
    nb = block_size

    if(mod(ndim,nb)>0) then
       lda = ndim/nb +1
    else
       lda = ndim/nb
    end if
    occ = lda
    if(mod(lda,nprow)>0) then
       lda = lda/nprow+1
    else
       lda = lda/nprow
    end if
    if(mod(occ,npcol)>0) then
       occ = occ/npcol+1
    else
       occ = occ/npcol
    end if
    lda = lda*nb
    occ = occ*nb
    if(iprisubmat>=2) write(nfout,'("lda,occ=",2i5)') lda,occ

#ifdef EIGEN_TRANS
    call make_usermap(usermap,icol,ikey,irank_c,irank_r)
#else
    call make_usermap(usermap,icol,ikey)
#endif
    call MPI_COMM_RANK(MPI_COMM_WORLD, iam, ierr)
    icolor=icol(iam)

    if(iprisubmat>=1) then
       write(nfout,'("nb=",i4,", lda=",i4,", occ=",i4,", nb=",i4,", ndim=",i4,", nprow=",i4,", npcol=",i4)') &
           & nb, lda, occ, nb, ndim, nprow, npcol
    end if
    call blacs_setup(iam,nprocs)
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow,nprow,npcol)
    call blacs_gridinfo(ictxt,nprow,npcol,myrow,mycol)
    if(iprisubmat>=2) write(nfout,'("nprow,npcol,myrow,mycol=",4i5)') nprow,npcol,myrow,mycol
    if(myrow == -1) then
!xx    if(printable) write(nfout,*) 'BLACS init failed.'
!xx    stop 'BLACS init failed.'
         return
    end if
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for amat: info=',info
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for zmat: info=',info

!   if(kimg_t==1) then
       ! setup for pdsyev
       if(method_scalapack==HOUSEHOLDER) then
          IROFFA = MOD( 0, nb )
          ICOFFA = MOD( 0, nb )
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( RSRC_ ), npcol )
          np = NUMROC( ndim+iroffa, nb, myrow, iarow, nprow )
          nq = NUMROC( ndim+icoffa, nb, mycol, iacol, npcol )
          sizemqrleft = max( (nb*(nb-1))/2, (np+nq)*nb ) + nb*nb
          if(printable) write(nfout,*) 'np,nq=',np,nq
          if(printable) write(nfout,*) 'sizemqrleft=',sizemqrleft
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          nrc = NUMROC( ndim, nb, myrow, 0, nprocs)
          ldc = max( 1, nrc )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          if(printable) write(nfout,*) 'nrc,ldc=',nrc,ldc
          qrmem = 2*ndim-2
          if(printable) write(nfout,'("qrmem,=",i9)') qrmem
          lwork1 = 5*ndim + ndim*ldc + max( sizemqrleft, qrmem ) + 1
! === DEBUG by tkato 2012/04/05 ================================================
          call pdsyev('V','U',ndim,utmp2,1,1,desca,eig,vtmp2,1,1 &
                   & ,descz,rtmp,-1,info)
          lwork1 = max(lwork1, nint(rtmp(1)))
! ==============================================================================
          if(printable) write(nfout,'("lwork1,=",i9)') lwork1
          lrwork1 = 0
          liwork1 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
! === DEBUG by tkato 2012/04/05 ================================================
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
! ==============================================================================
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0=',np0,nq0
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          trilwmin = 3*ndim + max( nb*( np0+1 ), 3*nb )
          lwork0  = max( 1+6*ndim+2*np0*nq0, trilwmin ) + 2*ndim
          liwork0 = 7*ndim + 8*npcol + 2
          call pdsyevd('V','U',ndim,utmp2,1,1,desca,eig,vtmp2,1,1 &
                    & ,descz,rtmp,-1,itmp,liwork1,info)
          lwork1  = max( lwork0*10, nint(rtmp(1))*10 )
          liwork1 = max( liwork0  , liwork1 )
          if(printable) write(nfout,'("lwork1,liwork1,=",2i16)') lwork1,liwork1
          lrwork1 = 0
       end if
!   else
       ! setup for pzheev
       if(method_scalapack==HOUSEHOLDER) then
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork2 = ndim*(ndim+3) + ( np0 + nq0 + nb ) * nb
          lrwork2 = 2*ndim + 2*ndim-2
          if(printable) write(nfout,'("lwork2,lrwork2,=",3i9)') lwork2,lrwork2
          liwork2 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
          nq  = NUMROC( MAX( ndim, nb, 2 ), nb, 0, 0, npcol )
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0,nq=',np0,nq0,nq
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          lwork0  = ndim + ( np0 + nq + nb ) * nb
!fj       lrwork0 = 1 + 9*ndim + 3*np0*nq0
          lrwork0 = (1 + 8*ndim + 2*np0*nq0)*2
          liwork0 = 7*ndim + 8*npcol + 2

          call pzheevd('V','U',ndim,utmp2,1,1,desca,eig,vtmp2,1,1 &
                    & ,descz,ctmp,-1,rtmp,-1,itmp,-1,info)
          lwork2  = max( lwork0 , nint(real(ctmp(1))) )
          lrwork2 = max( lrwork0, nint(rtmp(1)) )
          liwork2 = max( liwork0, itmp(1) )

          lrwork2 =lrwork2*10
          if(printable) write(nfout,'("lwork2,lrwork2,liwork2,=",3i9)') lwork2,lrwork2,liwork2
       end if
!   end if

    call tstatc0_end(id_sname)
    !     timer_sub end 903
  end subroutine scalapack_setup_3D

  subroutine pdsyev_driver_3D(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
!   real(kind=DP), intent(inout) ,dimension(maxeg,maxe) :: amat
!   real(kind=DP), intent(out) ,dimension(maxeg,maxe) :: zmat
! === DEBUG by Tkato 2011/06/28 ================================================
!   real(kind=DP), intent(inout) ,dimension(nel_eg(myrank_g),np_e) :: amat
!   real(kind=DP), intent(out) ,dimension(nel_eg(myrank_g),np_e) :: zmat
    real(kind=DP), intent(inout) ,dimension(lda,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda,occ) :: zmat
! ==============================================================================
    integer, intent(in):: lwork,liwork

    character(len=1) :: JOBZ,UPLO
    real(kind=DP),allocatable,dimension(:) :: work
    integer,allocatable,dimension(:) :: iwork
    integer :: info
    integer :: id_sname = -1
    call tstatc0_begin('pdsyev_driver ', id_sname)
    !     timer_sub sta 906

    if (iprisubmat >= 2) then
       write(nfout,'("-- pdsyev_driver_3D --")')
       write(nfout,'("ndim=",i4,", lda=",i4,", occ=",i4)') ndim,lda,occ
       write(nfout,'("desca : ",9(i4," ,"))') desca
       write(nfout,'("descz : ",9(i4," ,"))') descz
       call flush(nfout)
    end if

!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEV")
#endif
       call pdsyev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEVD")
#endif
       call pdsyevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyevd: info=',info
    end if


    deallocate(work)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
    !    timer_sub end 906
  end subroutine pdsyev_driver_3D

  subroutine pzheev_driver_3D(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
!   real(kind=DP), intent(inout) ,dimension(maxeg*2,maxe) :: amat
!   real(kind=DP), intent(out) ,dimension(maxeg*2,maxe) :: zmat
! === DEBUG by Tkato 2011/06/28 ================================================
!   real(kind=DP), intent(inout) ,dimension(nel_eg(myrank_g)*2,np_e) :: amat
!   real(kind=DP), intent(out) ,dimension(nel_eg(myrank_g)*2,np_e) :: zmat
    real(kind=DP), intent(inout) ,dimension(lda*2,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda*2,occ) :: zmat
! ==============================================================================
    integer, intent(in):: lwork,lrwork,liwork

    character(len=1) :: JOBZ,UPLO
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork
    integer,allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    !    timer_sub sta 907
    call tstatc0_begin('pzheev_driver ', id_sname)

    if(iprisubmat>=2) write(nfout,*) "Submat: pzheev_driver_3D"
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    allocate(rwork(lrwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEV")
#endif
       call pzheev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,rwork,lrwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEVD")
#endif
       call pzheevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheevd: info=',info
    end if

    deallocate(work)
    deallocate(rwork)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
    !     timer_sub end 907
  end subroutine pzheev_driver_3D

#endif
! _USE_SCALAPACK_

  end subroutine evolve_WFs_in_subspace_3D

!!$#endif

!! ++++++++++++++++++++ global(=not contained) subroutines in this module +++++++++++++++
#ifndef _USE_DSYEVD_
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    integer, parameter :: PRINTLEVEL = 2
    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
!!$    integer :: lwork,lwork_min
    integer, save :: lwork=0
    integer       :: lwork_min
    integer,parameter :: nb = 64
    integer, parameter :: lwork_huge=10**8
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)
!!$    lwork = 0
!!$    lwork_min=max(1,3*ndim-1)
    lwork_min=max(1,(nb+2)*ndim)
    if(lwork == 0) then
       lwork = -1
       allocate(work_lapack(1))
       call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
       lwork = int(work_lapack(1))+1
       if(iprisubmat >= PRINTLEVEL) then
          write(nfout,'(" lwork = ",i8)') lwork
       end if
       deallocate(work_lapack)
    end if
    if(lwork < lwork_min) lwork=lwork_min
    if(lwork > lwork_huge) lwork=lwork_min
    allocate(work_lapack(lwork))
    if(iprisubmat >= PRINTLEVEL .and. lwork == lwork_min) then
       write(nfout,'(" lwork = ",i8)') lwork
       write(nfout,'(" lda, ndim = ",2i8)') lda, ndim
    end if

    call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
!!$    write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
    if(iprisubmat >= 2) then
       write(nfout,'(" info = ",i8)') info
    end if
!!$    lwork= int(work_lapack(1))+1
    deallocate(work_lapack)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#else
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
    integer :: lwork,liwork
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)

    lwork  = 1 + ndim*(6+2*ndim)
    liwork = 3 + 5*ndim

    allocate(work(lwork)); work = 0.d0
    allocate(iwork(liwork)); iwork = 0.d0

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("DSYEVD")
#endif
    call dsyevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("DSYEVD")
#endif

    deallocate(work)
    deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#endif

#ifndef _USE_ZHEEVD_
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork_min=max(1,2*ndim-1)
      rwork_size=max(3*ndim-2,1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     call zheev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,rwork_lapack,info)
!!$     write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#else
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: lwork,lrwork,liwork
   complex(kind=CMPLDP),allocatable,dimension(:) :: work
   real(kind=DP),allocatable,dimension(:) :: rwork
   real(kind=DP),allocatable,dimension(:) :: iwork
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=3+5*ndim

     allocate(work(lwork))
     allocate(rwork(lrwork))
     allocate(iwork(liwork))

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("ZHEEVD")
#endif
     call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("ZHEEVD")
#endif

     deallocate(work)
     deallocate(rwork)
     deallocate(iwork)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#endif
! _NO_USE_ZHEEVD_


#ifdef _USE_SCALAPACK_
  subroutine set_nprow_npcol(nprow,npcol)
    integer, intent(inout) :: nprow,npcol
!
!   if(nprow /= nrank_e) then
!      nprow = 1
!      npcol = nrank_e
!      if(printable) write(nfout,'("set nprow,npcol=",2i5)') nprow,npcol
!   else
       if(iprisubmat >= 2) write(nfout,'("nprow,npcol=",2i5)') nprow,npcol
!   end if
  end subroutine set_nprow_npcol
#endif


#ifndef _USE_NUMPAC_
#ifdef _USE_SCALAPACK_
  subroutine put_zmat(kimg_t,lda,occ,zmat,ndim,nprow,npcol,nb,usermap,is,ie,zz)
    integer, intent(in) :: kimg_t,lda,occ
    real(kind=DP), intent(in) :: zmat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol,nb
#ifdef SINGLE_CONTEXT
    integer, intent(in) :: usermap(nprow,npcol)
#else
    integer, intent(in) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(in) :: is,ie
    real(kind=DP), intent(out) :: zz(ndim*kimg_t,is:ie)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: jsize
    real(kind=DP), allocatable :: zz_mpi(:,:)
    integer :: id_sname = -1
    call tstatc0_begin('put_zmat ', id_sname)

    jsize = ie-is+1

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("PUT_ZMAT")
#endif
    zz = 0.d0
    if(kimg_t==1) then
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(i,j) = zmat(ii,jj)
          end do
       end do
    else
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(2*i-1,j) = zmat(2*ii-1,jj)
             zz(2*i  ,j) = zmat(2*ii  ,jj)
          end do
       end do
    end if
    if(npes > 1) then
       allocate(zz_mpi(ndim*kimg_t,is:ie))
       call mpi_allreduce(zz,zz_mpi,ndim*kimg_t*jsize,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       zz = zz_mpi         ! MPI
       deallocate(zz_mpi)
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("PUT_ZMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine put_zmat
#endif
#endif

! ------------------------------


end module m_ES_WF_by_submat

!#define POST3D
!=======================================================================
!
!  PROGRAM  PHASE/0 2014.03 ($Rev: 412 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain.F90 412 2014-11-30 12:02:22Z yamasaki $
!
program PHASE

#ifdef PARA3D
!!$  use m_Parallelization,     only : myrank_k_3D  , map_k_3D, np_e   &
!!$ &                                , ista_k       , iend_k           &
!!$ &                                , ista_kngp    , iend_kngp        &
!!$ &                                , ista_k_3D    , iend_k_3D        &
!!$ &                                , ista_kngp_3D , iend_kngp_3D     &
!!$ &                                , ista_snl, iend_snl &
!!$ &                                , np_fs_3D     , np_e_3D , np_g1k_3D 
!!$  use m_Electronic_Structure,only : zaj_l, zaj_l_3D       &
!!$ &                                , eko_l, eko_l_3D       &
!!$ &                                , fsr_l, fsr_l_3D       &
!!$ &                                , fsi_l, fsi_l_3D       &
!!$ &                                , occup_l, occup_l_3D    &
!!$ &                                , vlhxc_l, vlhxc_l_3D   &
!!$ &                                , nrvf_ordr,neordr      &
!!$ &                                , vlhxcQ
!!$  use z_interface_3D, only        : decomp_eko_l_3D       &
!!$       &                          , decomp_eko_l_3D_2     &
!!$       &                          , decomp_eko_l_r_3D     &
!!$       &                          , decomp_eko_l_r_3D_2   &
!!$       &                          , decomp_fsr_l_3D       &
!!$       &                          , decomp_fsr_l_3D_ik    &
!!$       &                          , decomp_snl_l_3D       &
!!$       &                          , decomp_snl_l_r_3D     &
!!$       &                          , decomp_snl_l_3D_2     &
!!$       &                          , decomp_zaj_l_3D       &
!!$       &                          , decomp_zaj_l_3D_ik    &
!!$       &                          , decomp_fsr_l_r_3D     &
!!$       &                          , decomp_fsr_l_r_3D_ik  &
!!$       &                          , decomp_vnlph_l_r_3D   &
!!$       &                          , decomp_vnlph_l_3D     &
!!$       &                          , decomp_zaj_l_r_3D     &
!!$       &                          , decomp_zaj_l_r_3D_ik  &
!!$       &                          , decomp_vlhxc_l_3D     &
!!$       &                          , decomp_vlhxc_l_r_3D   &
!!$       &                          , decomp_wfsd_l_3D      &
!!$       &                          , decomp_wfsd_l_r_3D    &
!!$       &                          , decomp_zfm3_l_3D      &
!!$       &                          , decomp_zfm3_l_r_3D    &
!!$       &                          , decomp_psc_l_3D       &
!!$       &                          , decomp_psc_l_r_3D     &
!!$       &                          , decomp_qitg_l_3D      &
!!$       &                          , decomp_qitg_l_r_3D    &
!!$       &                          , decomp_gr_l_3D        &
!!$       &                          , decomp_gr_l_r_3D      &
!!$       &                          , decomp_occup_l_3D     &
!!$       &                          , decomp_occup_l_r_3D   &
!!$       &                          , decomp_ngpt_l_3D      &
!!$       &                          , decomp_ngpt_l_r_3D    &
!!$       &                          , decomp_igfp_l_3D      &
!!$       &                          , decomp_igfp_l_r_3D    &
!!$       &                          , replacement_zaj_ball_eigenvalue  &
!!$       &                          , replacement_zaj_ball_sequence
!!$  use m_Parallelization,    only  : mype
!!$  use m_IterationNumbers,   only  : iteration
!!$  use m_Control_Parameters,  only : nspin,kimg,neg,af,istress,sw_fine_STM_simulation, ON &
!!$       &                          , initial_chg, sw_positron
!!$  use m_Crystal_Structure,  only : nopr
!!$  use m_Const_Parameters,    only : GAMMA, from_PSEUDOPOTENTIAL_FILE, DEFECT, BULK
!!$  use m_PlaneWaveBasisSet,   only : kg1,kg,kgp           &
!!$  &                               , gr_l   , gr_l_3D     &
!!$  &                               , ngpt_l , ngpt_l_3D   &
!!$  &                               , igfp_l , igfp_l_3D
!!$  use m_Kpoints,             only : kv3, k_symmetry
!!$  use m_PseudoPotential,     only : nlmta   , nlmtt            &
!!$ &                                , qitg_l  , qitg_l_3D  , nqitg   &
!!$ &                                , psc_l   , psc_l_3D             &
!!$ &                                , rhpcg_l , rhpcg_l_3D , ntpcc   &
!!$ &                                , qitg_diff_l  , qitg_diff_l_3D  &
!!$ &                                , psc_diff_l   , psc_diff_l_3D   &
!!$ &                                , rhpcg_diff_l , rhpcg_diff_l_3D &
!!$ &                                , rhcg_l  , rhcg_l_3D   &
!!$ &                                , rhceg_l , rhceg_l_3D  &
!!$ &                                , rhchg_l , rhchg_l_3D  &
!!$ &                                , rhvg_l  , rhvg_l_3D
!!$  use m_NonLocal_Potential,  only : snl, snl_l_3D
!!$  use m_Charge_Density,      only : chgq_l , chgq_l_3D              &
!!$       &                          , chgqo_l, chgqo_l_3D             &
!!$       &                          , chgsoft, chgsoft_3D
!!$  use m_XC_Potential,        only : vxc_l  , vxc_l_3D               &
!!$       &                          , vxcpc_l, vxcpc_l_3D
!!$  use m_Ionic_System,        only : zfm3_l, zfm3_l_3D, ntyp
#endif
#ifdef PAW3D
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D
#endif

  use m_Const_Parameters,    only : DRIVER_NEB,DRIVER_CONSTRAINT,DRIVER_MTD
  use m_Parallelization,     only : mpi_comm_group

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
use mod_timer
use m_Parallelization, only  : mype
#endif
! === TIMERTIMERTIMER ==========================================================

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect, Structure_is_fixed
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable
  logical  :: from_Initialize
!!$  logical  :: ChargeDensity_is_Fixed
   interface
     subroutine Initialization(init_mpi)
       integer, intent(in), optional :: init_mpi
     end subroutine Initialization
   end interface
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: ispin, ik, iksnl, ierR

  integer :: initmpi
  logical :: confpara
  integer :: driver
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0

!  call Initialization(init_mpi=1)
  call Initialization(initmpi)
  !                   timer_fj end 21, sta 22
  call InputData_Analysis

  driver   = Resolve_Driver()
  if (driver==DRIVER_NEB)then
#ifndef DISABLE_CONSTRAINTS
      call do_neb()
  else if (driver==DRIVER_CONSTRAINT) then
      call constrained_dynamics()
  else if (driver==DRIVER_MTD) then
      call meta_dynamics()
#endif
  else
     !               timer_fj end 22, sta 23
  call Preparation                   ! Basis set, symmetry check etc.
  !                  timer_fj end 23, sta 24
  call Preparation_for_mpi(1)        ! mpi
  !                  timer_fj end 24, sta 25
  call PseudoPotential_Construction
  !                  timer_fj end 25
#ifdef PAW3D
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#endif
  !                  timer_fj sta 26

#ifdef ENABLE_ESM_PACK
  call Preparation_for_ESM
#endif

  call Ewald_and_Structure_Factor
  !                  timer_fj end 26, sta 27
  call Initial_Electronic_Structure
  !                  timer_fj end 27
  !                  timer end 17

!!  from_Initialize = .false.
!$$  from_Initialize = .true.
!$$  if(from_Initialize) call Para3d_Entry()
 
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif

     if(.not.Already_Converged()) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              ChargeDensity:    do

#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting
                 !                            timer sta 16
!!$                 call ReadCheckPointData_if_needed
                 call Renewal_of_WaveFunctions
                 !                            timer sta 11
                 call ChargeDensity_Construction(0)
                 call ChargeDensity_Mixing
                 !                            timer end 11
                 if(Ending_Time()) then
                    !                         timer end 16
                    exit StressLoop
                 end if
                 if(TotalEnergy_is_Divergent()) then
                    !                         timer end 16
                    exit StressLoop
                 end if
                 !                            timer sta 11
                 call Renewal_of_Potential
                 !                            timer end 11
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call WriteCheckPointData  ! if necessary
                 if(ChargeDensity_is_Converged()) then
                    !                       timer end 16
                    exit ChargeDensity
                 end if
                 !                          timer end 16
              enddo ChargeDensity

!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!

              if(Structure_is_fixed()) then
                  exit StressLoop
              end if
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
              call Forces
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
              if(Forces_are_Converged()) then
                exit AtomicConfiguration
              endif
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
                 call Ewald_and_Structure_Factor
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
                 call MDIterationNumber_Setting
              end if
           enddo AtomicConfiguration
           exit StressLoop
        end do StressLoop

!$$!        call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!


#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if


#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif

!$$!        call PARA_2Dto3D()
     !                  timer_fj sta 39
#ifdef POST3D
! === Add postprocessing to 3D Version by tkato ================================
     call Postprocessing(.false.)
! ==============================================================================
#endif
     call rttddft_main
     call WriteDownData_onto_Files(.true.)
     !                   timer_fj end 39

  endif

  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call print_timer(mype)
#endif
! === TIMERTIMERTIMER ==========================================================
contains

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k

#ifdef PARA3D
!!$  subroutine Para3d_Entry()
!!$    if (allocated(vlhxc_l))    deallocate(vlhxc_l)
!!$    if (allocated(chgq_l))     deallocate(chgq_l)
!!$    if (allocated(chgqo_l))    deallocate(chgqo_l)
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       if (allocated(chgsoft)) deallocate(chgsoft)
!!$    end if
!!$    if (allocated(vxc_l))      deallocate(vxc_l)
!!$    if (allocated(vxcpc_l))    deallocate(vxcpc_l)
!!$    if (allocated(snl))        deallocate(snl)
!!$    if (allocated(eko_l))      deallocate(eko_l)
!!$    if (allocated(zaj_l))      deallocate(zaj_l)
!!$    if (allocated(fsr_l))      deallocate(fsr_l)
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       if (allocated(fsi_l))   deallocate(fsi_l)
!!$    end if
!!$    if (allocated(occup_l))    deallocate(occup_l)
!!$    if (allocated(zfm3_l))     deallocate(zfm3_l)
!!$    if (allocated(gr_l))       deallocate(gr_l)
!!$    if (allocated(psc_l))      deallocate(psc_l)
!!$    if (allocated(qitg_l))     deallocate(qitg_l)
!!$    if (allocated(rhpcg_l))    deallocate(rhpcg_l)
!!$    if(istress==ON) then
!!$       if (allocated(psc_diff_l))      deallocate(psc_diff_l)
!!$       if (allocated(qitg_diff_l))     deallocate(qitg_diff_l)
!!$       if (allocated(rhpcg_diff_l))    deallocate(rhpcg_diff_l)
!!$    endif
!!$    if (allocated(ngpt_l))     deallocate(ngpt_l)
!!$    if (allocated(igfp_l))    deallocate(igfp_l)
!!$  end subroutine Para3d_Entry
!!$
!!$  subroutine PARA_2Dto3D()
!!$    !                timer_fj sta 37
!!$
!!$    allocate(vlhxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             vlhxc_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l)
!!$
!!$    allocate(chgq_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));              chgq_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l)
!!$
!!$    allocate(chgqo_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             chgqo_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));          chgsoft_3D = 0.0d0
!!$       do ispin = 1, nspin, (af+1)
!!$          call decomp_vlhxc_l_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft)
!!$    end if
!!$
!!$    allocate(vxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));               vxc_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l)
!!$
!!$    allocate(vxcpc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg));                   vxcpc_l_3D = 0.d0
!!$    deallocate(vxcpc_l)
!!$
!!$    allocate(snl_l_3D(maxval(np_g1k_3D),nlmtt,ista_snl:iend_snl));          snl_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_snl_l_3D_2(snl,snl_l_3D,ik)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(snl)
!!$
!!$    allocate(eko_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                        eko_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_eko_l_3D_2(eko_l,eko_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l)
!!$
!!$    allocate(zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)); zaj_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l)
!!$
!!$    allocate(fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));               fsr_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));            fsi_l_3D = 0.d0
!!$       do ispin = 1, nspin, (af+1)
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,'sort')
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l)
!!$    end if
!!$
!!$    allocate(occup_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                      occup_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_occup_l_3D(occup_l,occup_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l)
!!$
!!$    allocate(zfm3_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp,kimg));               zfm3_l_3D = 0.d0
!!$    call decomp_zfm3_l_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l)
!!$
!!$    allocate(gr_l_3D(ista_kngp_3D:iend_kngp_3D));                           gr_l_3D =0.0d0
!!$    call decomp_gr_l_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l)
!!$
!!$    allocate(psc_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     psc_l_3D =0.0d0
!!$    call decomp_psc_l_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l)
!!$
!!$    allocate(qitg_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));                   qitg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l)
!!$
!!$    allocate(rhpcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));                  rhpcg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));              psc_diff_l_3D =0.0d0
!!$       call decomp_psc_l_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l)
!!$
!!$       allocate(qitg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));            qitg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l)
!!$
!!$       allocate(rhpcg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));           rhpcg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l)
!!$    endif
!!$
!!$    allocate(ngpt_l_3D(ista_kngp_3D:iend_kngp_3D,nopr+af));         ngpt_l_3D =0.0d0
!!$    call decomp_ngpt_l_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l)
!!$
!!$    allocate(igfp_l_3D(ista_kngp_3D:iend_kngp_3D));                 igfp_l_3D =0.0d0
!!$    call decomp_igfp_l_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhvg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhcg_l_3D =0.0d0
!!$      allocate(rhceg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhceg_l_3D =0.0d0
!!$      allocate(rhchg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhchg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l)
!!$      deallocate(rhceg_l)
!!$      deallocate(rhchg_l)
!!$   endif
!!$
!!$   !                    timer_fj end 37
!!$  end subroutine PARA_2Dto3D
!!$
!!$  subroutine PARA_3Dto2D()
!!$    !                   timer_fj sta 38
!!$
!!$    allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin)); vlhxc_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l_3D)
!!$
!!$    allocate(chgq_l(ista_kngp:iend_kngp,kimg,nspin)); chgq_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l_3D)
!!$
!!$    allocate(chgqo_l(ista_kngp:iend_kngp,kimg,nspin)); chgqo_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l_3D)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft(ista_kngp:iend_kngp,kimg,nspin)) ; chgsoft = 0.0d0
!!$       do ispin = 1, nspin, af + 1
!!$          call decomp_vlhxc_l_r_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft_3D)
!!$    end if
!!$
!!$    allocate(vxc_l(ista_kngp:iend_kngp,kimg,nspin)); vxc_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l_3D)
!!$
!!$    allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0
!!$    deallocate(vxcpc_l_3D)
!!$
!!$    allocate(snl(kg1,nlmtt,ista_snl:iend_snl)); snl = 0.d0
!!$    call decomp_snl_l_r_3D(snl_l_3D,snl)
!!$    deallocate(snl_l_3D)
!!$
!!$    allocate(eko_l(np_e,ista_k:iend_k));                   eko_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_eko_l_r_3D_2(eko_l,eko_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l_3D)
!!$
!!$    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg));          zaj_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l_3D)
!!$
!!$    allocate(fsr_l(np_e,nlmta,ista_k:iend_k));             fsr_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"sort",0)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l_3D)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l(np_e,nlmta,ista_k:iend_k));          fsi_l = 0.d0
!!$       do ispin = 1, nspin, af + 1
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"sort",0)
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l_3D)
!!$    end if
!!$
!!$    allocate(occup_l(np_e,ista_k:iend_k));                 occup_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             iksnl = (ik-1)/nspin + 1
!!$             call decomp_occup_l_r_3D(occup_l,occup_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l_3D)
!!$
!!$    allocate(zfm3_l(ista_kngp:iend_kngp,ntyp,kimg));       zfm3_l = 0.d0
!!$    call decomp_zfm3_l_r_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l_3D)
!!$
!!$    allocate(gr_l(ista_kngp:iend_kngp));                   gr_l =0.0d0
!!$    call decomp_gr_l_r_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l_3D)
!!$
!!$    allocate(psc_l(ista_kngp:iend_kngp,ntyp));             psc_l =0.0d0
!!$    call decomp_psc_l_r_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l_3D)
!!$
!!$    allocate(qitg_l(ista_kngp:iend_kngp,nqitg));           qitg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l_3D)
!!$
!!$    allocate(rhpcg_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l_3D)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l(ista_kngp:iend_kngp,ntyp));             psc_diff_l =0.0d0
!!$       call decomp_psc_l_r_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l_3D)
!!$
!!$       allocate(qitg_diff_l(ista_kngp:iend_kngp,nqitg));           qitg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l_3D)
!!$
!!$       allocate(rhpcg_diff_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l_3D)
!!$    endif
!!$
!!$    allocate(ngpt_l(ista_kngp:iend_kngp,nopr+af));         ngpt_l =0.0d0
!!$    call decomp_ngpt_l_r_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l_3D)
!!$
!!$    allocate(igfp_l(ista_kngp:iend_kngp));                 igfp_l =0.0d0
!!$    call decomp_igfp_l_r_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l_3D)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l(ista_kngp:iend_kngp,ntyp));                     rhvg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l_3D)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l(ista_kngp:iend_kngp,ntyp));                     rhcg_l =0.0d0
!!$      allocate(rhceg_l(ista_kngp:iend_kngp,ntyp));                    rhceg_l =0.0d0
!!$      allocate(rhchg_l(ista_kngp:iend_kngp,ntyp));                    rhchg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_r_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_r_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l_3D)
!!$      deallocate(rhceg_l_3D)
!!$      deallocate(rhchg_l_3D)
!!$   endif
!!$
!!$   !                timer_fj end 38
!!$  end subroutine PARA_3Dto2D
!!$
!!$  subroutine output_zaj()
!!$   integer::ispin, ik
!!$
!!$    if (.not. allocated(zaj_l)) then
!!$       allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
!!$    end if
!!$    zaj_l = 0.0d0
!!$
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$
!!$    call dump_zaj(zaj_l)
!!$
!!$    deallocate(zaj_l)
!!$
!!$  endsubroutine output_zaj
#endif

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

end program PHASE

#!/bin/sh
NP=1

rm -f nfefn.data
for dir in 6.1 6.2 6.3 6.4 6.5 6.6 6.7 6.8 6.9 7.0 7.1 7.2 7.3 7.4 7.5 7.6 7.7 7.8 7.9 8.0;do
cd c$dir
mpiexec -n $NP ~/phase0_2014.03/bin/phase < /dev/null
echo -n $dir >> ../nfefn.data; echo -n; tail -1 nfefn.data >> ../nfefn.data
cd ../
done
